/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
import java.io.*;

public class BMP
{

  byte   bfType0;
  byte   bfType1;
  int    bfSize;
  short  bfReserved1;
  short  bfReserved2;
  int    bfOffBits;
  int    biSize;
  public int    biWidth;
  public int    biHeight;
  short  biPlanes;
  short  biBitCount;
  int    biCompression;
  int    biSizeImage;
  int    biXPelsPerMeter;
  int    biYPelsPerMeter;
  public int    biClrUsed;
  public int    biClrImportant;

  String filename;
  int N;
  byte[] head;
  byte[] info;
  int[] lut=new int[256];

//  static int sr=5, sg=5, sb=5, sbg=10;
//  static int Sr=8-sr, Sg=8-sg, Sb=8-sb;
  public static int nc=224;
  static int nr=32, ng=32, nb=32, nbg=nb*ng;
  static int Nr=0x100/nr, Ng=0x100/ng, Nb=0x100/nb;
  static int[] newlut=new int[256];
  static int[] cf=new int[nb*ng*nr];
  static byte[] Ix=new byte[nb*ng*nr];

  void actualizeHead()
  { head=new byte[54];
    setByte(head,0,bfType0);
    setByte(head,1,bfType1);
    setLongCard(head,2,bfSize);
    setCardinal(head,6,bfReserved1);
    setCardinal(head,8,bfReserved2);
    setLongCard(head,10,bfOffBits);
    setLongCard(head,14,biSize);
    setLongCard(head,18,biWidth);
    setLongCard(head,22,biHeight);
    setCardinal(head,26,biPlanes);
    setCardinal(head,28,biBitCount);
    setLongCard(head,30,biCompression);
    setLongCard(head,34,biSizeImage);
    setLongCard(head,38,biXPelsPerMeter);
    setLongCard(head,42,biYPelsPerMeter);
    setLongCard(head,46,biClrUsed);
    setLongCard(head,50,biClrImportant);
  }

  public BMP(String fn,int bc,int dx, int dy)
  { filename=new String(fn);
    bfType0=0x42;
    bfType1=0x4d; 
    bfSize=0;   
    bfReserved1=0; 
    bfReserved2=0; 
    bfOffBits=54;
    biSize=40;  
    biWidth=dx; 
    biHeight=dy;
    biPlanes=1;       
    biBitCount=(short)bc;     
    biCompression=0;  
    biSizeImage=0;    
    biXPelsPerMeter=0;
    biYPelsPerMeter=0;
    biClrUsed=0;      
    biClrImportant=0; 
    switch (biBitCount)
    { case 8  : N=biWidth; bfOffBits=bfOffBits+1024; break;
      case 24 : N=biWidth*3; break;
    }
    N=((N+3)/4)*4;
    info=new byte[N*dy];
    biSizeImage=info.length;    
    bfSize=54+info.length;   
    actualizeHead();
  } // BMP

  public void setLut(int[] l)
  { newlut=l;
  }// setLut;

  public BMP(String fn)
  { //bmph=new BMP_header();
    filename=new String(fn);
    RandomAccessFile f;
    try 
    { f=new RandomAccessFile(filename,"r");
      head=new byte[54];
      f.read(head);
      bfType0        = (byte) getByte(head,0);
      bfType1        = (byte) getByte(head,1);
      bfSize         = getLongCard(head,2);
      bfReserved1    = (short) getCardinal(head,6);
      bfReserved2    = (short) getCardinal(head,8);
      bfOffBits      = getLongCard(head,10);
      biSize         = getLongCard(head,14);
      biWidth        = getLongCard(head,18);
      biHeight       = getLongCard(head,22);
      biPlanes       = (short) getCardinal(head,26);
      biBitCount     = (short) getCardinal(head,28);
      biCompression  = getLongCard(head,30);
      biSizeImage    = getLongCard(head,34);
      biXPelsPerMeter= getLongCard(head,38);
      biYPelsPerMeter= getLongCard(head,42);
      biClrUsed      = getLongCard(head,46);
      biClrImportant = getLongCard(head,50);
      if (biBitCount==8)
      { byte[] colors=new byte[1024]; f.read(colors);
        for (int i=0;i<256;i++) lut[i]=getLongCard(colors,4*i); 
      }
      switch (biBitCount)
      { case 8  : N=biWidth; break;
        case 24 : N=biWidth*3; break;
      }
      N=((N+3)/4)*4;
      info=new byte[N*biHeight];
      f.seek(bfOffBits);
      f.read(info); 
      f.close(); 
    }
    catch (IOException e) { System.out.println(e); }
    finally 
    {  
    }
  } //BMP

  public int getPixel(int x, int y)
  { int c=0; int pos=0;
    if ((x>=0)&&(y>=0)&&(x<biWidth)&&(y<biHeight))
      if (biBitCount==8) 
      { pos=N*y+x; c=lut[uns(info[pos])];}
      else 
      { pos=N*y+x*3;
        c=uns(info[pos++])+uns(info[pos++])*0x100+uns(info[pos])*0x10000;
        c=c|0xff000000;
      }
    return c;
  } // getPixel;

  public int average(int x,int y,int dx,int dy)
  { int m,n,pos,c,b=0,g=0,r=0;
    for (n=0;n<dy;n++)
    { if (biBitCount==8) pos=N*y+x; else pos=N*y+x*3; 
      for (m=0;m<dx;m++)
      { if (biBitCount==8) c=lut[uns(info[pos])]; 
        else c=uns(info[pos++])+uns(info[pos++])*0x100+uns(info[pos++])*0x10000;
        pos++;
        b=b+(c%0x100); c=c>>8; 
        g=g+(c%0x100); c=c>>8; 
        r=r+(c%0x100);
      }
    }
    int d=dx*dy;
    return (b/d)+((g/d)<<8)+((r/d)<<16); 
  } // average;


  public void setPixel(int x, int y,byte i)
  { if ((x>=0)&&(y>=0)&&(x<biWidth)&&(y<biHeight))
    { int k=0;
      switch (biBitCount)
      { case 8  : k=N*y+x;
                  info[k]=i;
                  break;
        case 24 : k=N*y+x*3;
                  int c=newlut[uns(i)];
                  info[k++]=(byte)(c%256); c=c>>8;
                  info[k++]=(byte)(c%256); c=c>>8;
                  info[k]=(byte)(c%256); 
                  break;
      }
    }
  } // setPixel;

  public void setPixel(int x, int y,int c)
  { if ((x>=0)&&(y>=0)&&(x<biWidth)&&(y<biHeight))
    { int k=0;
      switch (biBitCount)
      { case 8  : k=N*y+x;
                  info[k]=index(c);
                  break;
        case 24 : k=N*y+x*3;
                  info[k++]=(byte)(c%256); c=c>>8;
                  info[k++]=(byte)(c%256); c=c>>8;
                  info[k]=(byte)(c%256); 
                  break;
      }
    }
  } // setPixel;

  byte index(int c)
  { int n=ncolor(c);
    if (Ix[n]!=(byte)255) return Ix[n];
    else 
    { int r=red(c), g=green(c), b=blue(c);
      int d0=100000;
      int i0=1, i=1;
      while (i<nc)
      { int tc=newlut[i];
        int dr=r-red(tc),dg=g-green(tc), db=b-blue(tc);
        int d=dr*dr+dg*dg+db*db;
        if (d<d0) { d0=d; i0=i; }
        i++;
      }
      return (byte)i0;
    }
  } // index;

  public void makeIx()
  { System.out.println("Start Frequencies");
    getColorFrequencies();
    System.out.println("End Frequencies");
    for (int k=0; k<Ix.length; k++) Ix[k]=(byte)255;
    Ix[0]=0;
    int N3=nr*ng*nb-1; 
    int i=255; int k=1;
    while (true)
    { int n=N3;
      while (true)
      { if (cf[n]==i)
        { Ix[n]=(byte)k;
          newlut[k]= (Nb*(n%nb))
                   +((Ng*((n/nb)%ng))<<8)
                   +((Nr*((n/nbg)%nr))<<16);
          k++;
          if (k==nc) break;
        }
        if (n==0) break;
        n--;
      }
      if ((k==nc)||(i==0)) break;
      i--;
    }
/* ciclic lut */
    k=nc;
    while (k<nc+(256-nc)/2)
    { newlut[k]=((k-nc)*255*2/(256-nc))<<16;
      k++;
    }
    while (k<256)
    { newlut[k]=newlut[nc+(255-k)];
      k++;
    }
  } // makeIx;

  void getColorFrequencies()
  { for (int k=0; k<cf.length; k++) cf[k]=0;
    for (int y=0;y<biHeight;y++)
      for (int x=0;x<biWidth;x++)
      { int c=getPixel(x,y);
        int n=ncolor(c);
        if (cf[n]<255) cf[n]++;
      }
  } // getColorFrequencies;

  static int ncolor(int c)
  { return ((c%0x100)/Nb)+(((c>>8)%0x100)/Ng)*nb+(((c>>16)%0x100)/Nr)*nbg;
  } //ncolor;

  public static int blue(int c)  {return ((c&0x00ffffff)%256); }
  public static int green(int c) {return (((c&0x00ffffff)>>8)%256); }
  public static int red(int c)   {return (((c&0x00ffffff)>>16)%256); }
  public static int color(int b,int g,int r) 
  { 
    return 0xff000000|b|(g<<8)|(r<<16); 
  }

  public void save()
  { 
  	try {
  		File f0=new File(filename);
  		f0.delete();
  	} catch (Exception e0) {
  	}
  	RandomAccessFile f;
    try 
    { f=new RandomAccessFile(filename,"rw");
      actualizeHead();
      f.write(head);
      if (biBitCount==8)
      { byte[] colors=new byte[1024];
        for (int i=0;i<256;i++) setLongCard(colors,4*i,newlut[i]);
        f.write(colors);
      }
      f.write(info);
      f.close(); 
    }
    catch (IOException e) { System.out.println(e); }
    finally
    {
    }
  } // save;

  static int uns(byte b)
  { int n=(int)b; return (b<0)?(256+n):n;
  }
  static int getByte(byte[] b,int pos)
  {return uns(b[pos]);
  } //getByte;

  static int getCardinal(byte[] b,int pos)
  {return uns(b[pos])+uns(b[pos+1])*0x100;
  } //getCardinal;

  static int getLongCard(byte[] b,int pos)
  {return uns(b[pos])+uns(b[pos+1])*0x100
          +uns(b[pos+2])*0x10000+uns(b[pos+3])*0x1000000;
  } //getLongCard;

  static void setByte(byte[] b,int pos,byte v)
  { b[pos]=v;
  } //setByte;

  static void setCardinal(byte[] b,int pos,short v)
  { b[pos]  =(byte)(v%256); v=(short)(v/256); 
    b[pos+1]=(byte)(v%256); 
  } //setCardinal;

  static void setLongCard(byte[] b,int pos,int v)
  { b[pos]  =(byte)(v%256); v=v>>8; 
    b[pos+1]=(byte)(v%256); v=v>>8;
    b[pos+2]=(byte)(v%256); v=v>>8;
    b[pos+3]=(byte)v;
  } //setLongCard;

  public void print()
  {
    System.out.println("         bfType0: "+bfType0);
    System.out.println("         bfType1: "+bfType1);
    System.out.println("         bfSize : "+bfSize);
    System.out.println("     bfReserved1: "+bfReserved1);
    System.out.println("     bfReserved2: "+bfReserved2);
    System.out.println("       bfOffBits: "+bfOffBits);
    System.out.println("          biSize: "+biSize);
    System.out.println("         biWidth: "+biWidth);
    System.out.println("        biHeight: "+biHeight);
    System.out.println("        biPlanes: "+biPlanes);
    System.out.println("      biBitCount: "+biBitCount);     
    System.out.println("   biCompression: "+biCompression);  
    System.out.println("     biSizeImage: "+biSizeImage);    
    System.out.println(" biXPelsPerMeter: "+biXPelsPerMeter);
    System.out.println(" bfYPelsPerMeter: "+biYPelsPerMeter);
    System.out.println("       biClrUsed: "+biClrUsed);      
    System.out.println("biClearImportant: "+biClrImportant); 
  } // print;

  static public void dummy() {}

} // mjaBMP