/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
import java.awt.*;
import java.applet.Applet;
import java.io.File;
import java.io.IOException;
import java.util.StringTokenizer;

import com.mja.file.mjaFile;
import com.mja.lang.*;
import com.mja.util.BasicStr;
import org.unam.matem.Attribute;
import org.unam.matem.Communicator;
import common.*;

public class Descartes extends Communicator implements DescartesInterface {

	DescartesInterface d;
	Applet A;
	
	static boolean firstD2=true;
	static boolean firstD5=true;
	static boolean firstInstD2=true;
	static boolean firstInstD5=true;
	private boolean ft=true;

	public void init() {
		setLayout(new GridLayout(1,1));
		d=null;
		
		try {
			Class cl=Class.forName("D5");
			d=getDescartes5();
			if (firstD5) {
				System.out.println("Usando Descartes5.jar");
				firstD5=false;
			}
		} catch (Exception ex1) {
			try {
				Class cl=Class.forName("D2");
				d=getDescartes2();
				if (firstD2) {
					System.out.println("Usando Descartes.jar");
				}
			} catch (Exception ex3) {
				String ver=getParameter("Versin");
				translator t=new translator(this);
				Attribute a=t.getParam(this,data.p_version);
				if (a!=null) {
					ver=a.value;
				}
				if (ver==null || ver.startsWith("2") || ver.startsWith("1")) {
					try {
						Class cl=Class.forName("descinst.D2");
						d=instGetDescartes2();
						if (firstInstD2) {
							System.out.println("Usando instalacin local de DescartesLib.jar");
							firstInstD2=false;
						}
					} catch (Exception ex4) {
					}
				} else {
					try {
						Class cl=Class.forName("descinst.D4");
						d=instGetDescartes5();
						if (firstInstD5) {
							System.out.println("Usando la instalacin local de DescartesLib.jar");
							firstInstD5=false;
						}
					} catch (Exception ex4) {
					}
				}
			}
		}
		A=d.getApplet();
		setLayout(new BorderLayout());
		add(A,BorderLayout.CENTER);
		A.init();
	}
	
	boolean fT=true;

	/**
	  * Function to be called when closing the warning message about a new version.
	  */

	public void updateLayout() {
		start();
	}

	public void start() {
		super.start();
		if (A!=null) {
			if (fT) {
				A.start();
//				try {
//					Thread.sleep(100);
//				} catch (InterruptedException ie) {
//				}
//				paintAll(getGraphics());
				fT=false;
			} else {
				if (A instanceof com.mja.descartes.Descartes) {
					((com.mja.descartes.Descartes) A).restart(true);
				} else if (A instanceof com.jla.desc2.descartes.Descartes) {
					((com.jla.desc2.descartes.Descartes) A).reset(false,true);
				} else {
					A.start();
				}
//				try {
//					Thread.sleep(100);
//				} catch (InterruptedException ie) {
//				}
//				paintAll(getGraphics());
			}
		}
	}

	public DescartesInterface getDescartes2() {
		return D2.getDescartes2(this);
	}

	public DescartesInterface getDescartes5() {
		return D5.getDescartes5(this);
	}

	public DescartesInterface instGetDescartes5() {
		return D5.getDescartes5(this);
	}

	public DescartesInterface instGetDescartes2() {
		return D2.getDescartes2(this);
	}

	public void stop() {
		if (A!=null) {
			A.stop();
		}
		super.stop();
	}

	public void destroy() {
		if (A!=null) {
			A.destroy();
		}
		super.destroy();
	}

	public String getParameter(String s) {
		if (s!=null && (s.startsWith("_info_") || s.startsWith("_action_"))) {
			return A.getParameter(s);
		}
		return super.getParameter(s);
	}
	
	public void resize(int w,int h) {
		super.resize(w,h);
		if (A!=null) {
			A.resize(w,h);
		}
	}
	
	public void resize(Dimension d) {
		super.resize(d);
		if (A!=null) {
			A.resize(d);
		}
	}

	public void update(Graphics g) {
		paint(g);
	}

	public void paint(Graphics g) {
		if (A!=null) {
			A.paint(g);
		}
	}
	/* -------- Interface D ---------- */

	public Applet getApplet() { return A; };
	public void about() { d.about(); }
	public void clear() { d.clear(); }
	public String getEvaluation() { return d.getEvaluation(); }
	public String dump() { return d.dump(); }
	public void undump(String s) { d.undump(s); }
	public void showSolution() { d.showSolution(); }
	public void showAnswer() { d.showAnswer(); }
	public String Evaluate(String expression) throws Exception  { return d.Evaluate(expression); }
	public void refresh() { d.refresh(); }
	public void original() { d.original(); }
	public void toggleAnimation() { d.toggleAnimation(); }
	public void initAnimation() { d.initAnimation(); }
	public void edit() { d.edit(); }
	public void setButtons(String s) { d.setButtons(s); }
	public void setSpace(String s) { d.setSpace(s); }
	public void removeSpaces() { d.removeSpaces(); }
	public void addSpace(String s) { d.addSpace(s); }
	public void replaceSpace(String num,String s) { d.replaceSpace(num,s); }
	public String getSpace(String num) { return d.getSpace(num); }
	public void deleteSpace(String num) { d.deleteSpace(num); }
	public void removeControls() { d.removeControls(); }
	public void addControl(String s) { d.addControl(s); }
	public void replaceControl(String num,String s) { d.replaceControl(num,s); }
	public String getControl(String num) { return d.getControl(num); }
	public void deleteControl(String num) { d.deleteControl(num); }
	public void removeAux() { d.removeAux(); }
	public void addAux(String s) { d.addAux(s); }
	public void replaceAux(String num,String s) { d.replaceAux(num,s); }
	public String getAux(String num) { return d.getAux(num); }
	public void deleteAux(String num) { d.deleteAux(num); }
	public void removeGraphs() { d.removeGraphs(); }
	public void addGraph(String s) { d.addGraph(s); }
	public void replaceGraph(String num,String s) { d.replaceGraph(num,s); }
	public String getGraph(String num) { return d.getGraph(num); }
	public void deleteGraph(String num) { d.deleteGraph(num); }
	public void remove3DGraphs() { d.remove3DGraphs(); }
	public void add3DGraph(String s) { d.add3DGraph(s); }
	public void replace3DGraph(String num,String s) { d.replace3DGraph(num,s); }
	public String get3DGraph(String num) { return d.get3DGraph(num); }
	public void delete3DGraph(String num) { d.delete3DGraph(num); }
	public void removeAnimation() { d.removeAnimation(); }
	public String getAnimation() { return d.getAnimation(); }
	public void setAnimation(String s) { d.setAnimation(s); }
	public String getCode() { return d.getCode(); }
	public String getHTMLEncodedCode() { return d.getHTMLEncodedCode(); }
	public void setDescartesWeb2_0(boolean b) { d.setDescartesWeb2_0(b); }
/* ---------------- Communicator Interface --------------- */
	public Attribute[] getState() {
		return d.getState();
	}
	public void changed(Communicator cc) {
		d.changed(cc);
	}
	public void addCommunicator(Communicator comm) {
		d.addCommunicator(comm);
	}
	public void sendChanges() {
		d.sendChanges();
	}
/* ------------------------------------------------------- */	
		
	public static String[] fileToUpdate = {
//		"Arquimedes.bat",
		"Descartes.bat",
		"clearcache.bat",
//		"DescartesJS.bat",
//		"Item.bat",
	};

	public static void main(String[] args) {
		Descartes d=new Descartes();
		for (int i=0;i<fileToUpdate.length;i++) {
			try {
				mjaFile.updateFromURL(d.getClass().getResource("/resources/batchfiles/"+fileToUpdate[i]),fileToUpdate[i],true);
			} catch (Exception e1) {
			}
		}
		com.jla.edit.NippeEditor.Start("Descartes 5 para Java y JS",true);
	}
	
}
