/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
/*
 * @(#)calcApplet.java	2.0 02/04/20
 *
 * Copyright 2002 Marta Oliver & Jos Luis Abreu.
 * Use is free. (Uso gratuito)
 */

/**
 * An Applet-Calculator.
 * (Una calculadora en un Applet.)
 * calcApplet.java, 1999.
 *
 * @author Jos Luis Abreu
 * @author Marta Oliver
 * @version 	2.0, 20 Apr 2002
 */

package com.jla.calc;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class calcApplet extends Applet implements ActionListener {

	private calculadora C;
	private Label pantalla;
	private char operador='=';
	private String nmero="0";
	private boolean entradaNueva=true;
	private Button[] b;
	
	private static final String[] etiquetaAlfanumerica= {
		"a", "b", "c", "d", "e", "f", "<-", "CA", "CE", "-x","1/x"  ,
		"g", "h", "i", "j", "k", "l", "<", "7" , "8" , "9" , "+"  ,
		"m", "n", "o", "p", "q", "r", ">", "4" , "5" , "6" , "-"  ,
		"s", "t", "u", "v", "w", "x", "|", "1" , "2" , "3" , "*"  ,
		"y", "z", "(", ")", "^", " ","[M]","." , "0" , "=" , "/"
	};

	private static final String[] etiquetaNumerica= {
		"CA" ,"CE" ,"-x"  ,"1/x"  ,
		"7"  ,"8"  ,"9"  ,"+"  ,
		"4"  ,"5"  ,"6"  ,"-"  ,
		"1"  ,"2"  ,"3"  ,"*"  ,
		"."  ,"0"  ,"="  ,"/"
	};
	
	private String[] etiqueta=etiquetaNumerica;
	
	void setAlphanumeric(boolean an) {
		if (an) {
			etiqueta=etiquetaAlfanumerica;
		} else {
			etiqueta=etiquetaNumerica;
		}
	}

    /**
     * Construye el despliegue y los botones y crea una calculadora.
     */
	public void init() { 
		setBackground(Color.gray);
		setFont(new Font("SansSerif",Font.BOLD,15)); 
		setLayout(new BorderLayout()); 

		pantalla=new Label("0");
		pantalla.setAlignment(Label.RIGHT);
		pantalla.setFont(new Font("SansSerif",Font.BOLD,22)); 
		pantalla.setBackground(Color.black);
		pantalla.setForeground(new Color(0xffff88));
		add("North",pantalla); 

		Panel teclado=new Panel(); 
		teclado.setLayout(new GridLayout(5,etiqueta.length/5));
		b=new Button[etiqueta.length];
		for (int i=0;i<etiqueta.length;i++) {
			b[i]=new Button(etiqueta[i]);
			b[i].addActionListener(this);
			teclado.add(b[i]);
		}
		add("Center",teclado);
		C=new calculadora();
	}
	
	public void performPendingOperation() {
		String nmero=pantalla.getText();
		if (nmero.equals("ERROR")) {
			nmero="0";
		}
		try {
			C.entrarValor(nmero);
			C.realizarOperacin();
			C.entrarValor(C.resultado());
			C.definirOperador("=");
			C.realizarOperacin();
			C.definirOperador("=");
			nmero=C.resultado();
			pantalla.setText(nmero);
			entradaNueva=true;
		} catch (Exception ex) {
//			nmero=nmero+"="; 
		}
	}

	public String getValue() {
		return pantalla.getText();
	}

    /**
     * Interpreta los clicks en los botones y hace
     * llamadas a los mtodos de la calculadora.
     * 
     * Un click en "CA" llama a limpiar();
     * Un click en "CE" pone en cero el despiegue;
     * Un click en un dgito o en "." agrega el caracter al despliegue.
     * Un click en un operador llama a entrarValor y realizarOperacin,
     * el resultado del la operacin se pone en el despliegue.
     */
	public void actionPerformed(ActionEvent e) {
		String nmero=pantalla.getText();
		if (nmero.equals("ERROR")) {
			nmero="0";
		}
		String comando=e.getActionCommand();
		if (comando.equals("CA")) { 
			C.limpiar(); 
			nmero="0";
			entradaNueva=true; 
		} else if (comando.equals("CE")) { 
			nmero="0";
			entradaNueva=true;
		} else if (comando.equals("[M]")) { 
			for (int i=0;i<etiqueta.length;i++) {
				if (etiqueta[i].length()==1) {
					b[i].setLabel(etiqueta[i].toUpperCase());
				} else if (etiqueta[i].equals("[M]")) {
					b[i].setLabel("[m]");
				}
			}
		} else if (comando.equals("[m]")) { 
			for (int i=0;i<etiqueta.length;i++) {
				if (etiqueta[i].length()==1) {
					b[i].setLabel(etiqueta[i].toLowerCase());
				} else if (etiqueta[i].equals("[M]")) {
					b[i].setLabel("[M]");
				}
			}
		} else if (comando.equals("<-")) { 
			if (nmero.length()>0) {
				nmero=nmero.substring(0,nmero.length()-1);
			}
		} else if (C.esOperador(comando)) {
			try {
				C.entrarValor(nmero);
				C.realizarOperacin();
				C.entrarValor(C.resultado());
				C.definirOperador(comando);
				if (!C.esOperadorBinario(comando)) {
					C.realizarOperacin();
					C.definirOperador("=");
				}
				nmero=C.resultado();
				entradaNueva=true;
			} catch (Exception ex) {
				nmero=nmero+comando.toString(); 
//				C.limpiar();
//				pantalla.setText("ERROR");
//				return;
			}
		} else { 
			if (nmero.equals("0") || entradaNueva) { 
				nmero=""; 
				entradaNueva=false;
			}
			nmero=nmero+comando.toString(); 
			if (nmero.startsWith(".")) { 
				nmero="0"+nmero; 
			}
		}
		pantalla.setText(nmero);
	}

}