/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.desc2.descartes;

/*------------------------------------------------------------*/
/*                           data                             */
/*                          (c) MJA                           */
/* Creacin:             Enero de 2001                        */
/* ltima actualizacin: Abril 29 de 2005                     */
/*------------------------------------------------------------*/

import java.util.*;
import java.awt.*;
import java.applet.*;
import com.jla.desc2.parser.*;
import com.jla.desc2.util.*;

public class data {

	static public final String Version="2."+com.jla.nippe.AbstractNippe.sub_ver;
	static public final String controlPrefix="C_", auxPrefix="A_", graphPrefix="G_";
	static public final int numLang=5;
	static public final int nolang=-1,eng=0,esp=1,cat=2,gal=3,eus=4;

	static public String[][] newName;
	static public String[][] colorName;

	static public final int
		langName   =  0,
		False      =  1,
		True       =  2,
		No         =  3,
		Yes        =  4,
		p_scale    =  5,
		textapplet =  6,
		name       =  7,
		editable   =  8,
		visible    =  9,
		trace      = 10,
		control    = 11,
		background = 12,
		color      = 13,
		parameter  = 14,
		sequence   = 15,
		size       = 16,
		decimals   = 17,
		black      = 18,
		magenta    = 19,
		blue       = 20,
		cyan       = 21,
		green      = 22,
		yellow     = 23,
		orange     = 24,
		red        = 25,
		pink       = 26,
		darkGray   = 27,
		gray       = 28,
		lightGray  = 29,
		white      = 30,
		BACKGROUND = 31,
		NET        = 32,
		NET10      = 33,
		AXES       = 34,
		TEXT       = 35,
		about      = 36,
		config     = 37,
		init       = 38,
		clear      = 39,
		incr       = 40,
		inf        = 41,
		sup        = 42,
		fill       = 43,
		fillplus   = 44,
		fillminus  = 45,
		arrow      = 46,
		widthness  = 47,
		spear      = 48,
		region     = 49,
		north      = 50,
		south      = 51,
		east       = 52,
		west       = 53,
		external   = 54,
		expr       = 55,
		type       = 56,
		position   = 57,
		constraint = 58,
		infinity   = 59,
		value      = 60,
		t_equation = 61,
		t_curve    = 62,
		t_text     = 63,
		t_point    = 64,
		t_segment  = 65,
		t_arc      = 66,
		t_polygon  = 67,
		p_version  = 68,
		p_language = 69,
		p_space    = 70,
		p_Ox       = 71,
		p_Oy       = 72,
		p_controls = 73,
		p_auxiliaries= 74,
		p_graphics = 75,
		p_buttons  = 76,
		p_anim     = 77,
		constant   = 78,
		original   = 79,
		newcfg     = 80,
		apply      = 81,
		close      = 82,
		cancel     = 83,
		accept     = 84,
		add        = 85,
		insert     = 86,
		delete     = 87,
		moveup     = 88,
		movedown   = 89,
		rename     = 90,
		auxiliary  = 91,
		font       = 92,
		undo       = 93,
		redo       = 94,
		c_numeric  = 95,
		c_graphic  = 96,
		initialPos = 97,
		ini        = 98,
		doWord     = 99,
		whileWord  =100,
		evaluate   =101,
		var        =102,
		func       =103,
		alg        =104,
		array      =105,
		zoom       =106,
		cond       =107,
		range      =108,
		delay      =109,
		stop       =110,
		x_axis     =111,
		y_axis     =112,
		numbers    =113,
		notexp     =114,
		family     =115,
		interval   =116,
		steps      =117,
		center     =118,
		radius     =119,
		end        =120,
		once       =121,
		always     =122,
		copy       =123,
		paste      =124,
		icolor     =125,
		loop       =126,
		controls   =127,
		appletc    =128,
		noedit     =129,
		anim       =130,
		pause      =131,
		auto       =132,
		NN         =133;

	static public final int numColors=1+white-black;
	static public final int[] bnameix={ about, config, init, clear };
	static public final int[] regix={south,north,west,east,external};
	static public final int[] auxix={ var, constant, array, func, alg };
	static public final int[] ctrlix={ c_numeric, c_graphic };
	static public final int[] gtix={ t_equation, t_curve, sequence, t_point, t_segment, arrow, t_polygon, t_arc, fill, t_text};

	private static final String allNames =
		"english|espaol|catal|galego|euskera|"+
		"false|falso|fals|1|gezurrezkoa|"+
		"true|verdadero|veritable|verdadeiro|egiazkoa|"+
		"no|0|1|non|bai|"+
		"yes|si|s|1|ez|"+
		"scale|escala|1|1|eskala|"+
		"You may copy this text and paste it on a Web page.|Puede copiar este texto y pegarlo en una pgina Web.|Podeu copiar aquest text i enganxar-lo en una pgina web.|Pode copiar este texto e pegalo nunha pxina Web.|Testu hau kopia dezkezu eta web orri batean itsasi.|"+
		"name|nombre|nom|nome|izena|"+
		"editable|0|0|0|editagarria|"+
		"visible|0|0|0|ikusgai|"+
		"trace|rastro|rastre|1|arrastoa|"+
		"control|0|1|1|kontrola|"+
		"background|fondo|fons|1|hondoa|"+
		"colour|color|1|cor|kolorea|"+
		"parameter|parmetro|parmetre|1|parametroa|"+
		"sequence|sucesin|successi|1|segida|"+
		"size|tamao|grandria|1|neurria|"+
		"decimals|decimales|0|decimais|hamarrenak|"+
		"black|negro|negre|1|beltza|"+
		"magenta|magenta|1|maxenta|1|"+
		"blue|azul|blau|1|urdina|"+
		"cyan|turquesa|1|1|turkesa|"+
		"green|verde|verd|1|berdea|"+
		"yellow|amarillo|groc|amarelo|horia|"+
		"orange|naranja|taronja|laranxa|laranja|"+
		"red|rojo|vermell|vermello|gorria|"+
		"pink|rosa|1|1|arrosa|"+
		"darkGray|grisObscuro|grisObscur|grisEscuro|gris iluna|"+
		"gray|gris|1|1|grisa|"+
		"lightGray|grisClaro|grisClar|1|gris argia|"+
		"white|blanco|blanc|branco|zuria|"+
		"background|fondo|fons|1|hondoa|"+
		"net|red|xarxa|rede|sarea|"+
		"net10|red10|xarxa10|rede10|sarea10|"+
		"axes|ejes|eixos|eixes|ardatzak|"+
		"text|texto|0|1|testua|"+
		"about|crditos|crdits|1|1|"+
		"config|0|0|0|konfig|"+
		"init|inicio|inici|1|hasiera|"+
		"clear|limpiar|netejar|1|ezabatu|"+
		"incr|0|0|0|gehi|"+
		"inf|min|1|inf|gutx|"+
		"sup|max|1|mx|1|"+
		"fill|relleno|ple|recheo|betea|"+
		"fill+|relleno+|ple+|recheo+|betea+|"+
		"fill-|relleno-|ple-|recheo-|betea-|"+
		"arrow|flecha|fletxa|frecha|gezia|"+
		"width|ancho|ample|1|1|"+
		"spear|punta|1|1|zabalera|"+
		"region|regin|regi|1|1|"+
		"north|norte|nord|1|1|"+
		"south|sur|sud|1|1|"+
		"east|este|est|1|1|"+
		"west|oeste|oest|1|1|"+
		"external|exterior|1|1|1|"+
		"expresion|expresin|expresi|1|1|"+
		"type|tipo|tipus|1|1|"+
		"position|posicin|posici|1|1|"+
		"constraint|constriccin|constricci|1|1|"+
		"infinity|infinito|infinit|1|amaigabea|"+
		"value|valor|1|1|1|"+
		"equation|ecuacin|equaci|ecuaci|ekuazio|"+
		"curve|curva|corba|1|kurba|"+
		"text|texto|0|1|testu|"+
		"point|punto|punt|1|puntu|"+
		"segment|segmento|0|1|segmentu|"+
		"arc|arco|0|1|arku|"+
		"polygon|polgono|polgon|1|1|"+
		"Version|Versin|Versi|1|1|"+
		"Language|Idioma|1|1|Hizkuntza|"+
		"Space|Espacio|Espai|1|Espazioa|"+
		"O.x|0|0|0|0|"+
		"O.y|0|0|0|0|"+
		"Controls|Controles|0|1|Kontrolak|"+
		"Auxiliaries|Auxiliares|Auxiliars|1|Aldagaiak|"+
		"Graphics|Grficos|Grfics|1|1|"+
		"Buttons|Botones|Botons|Botns|Botoiak|"+
		"Animation|Animacin|Animaci|1|1|"+
		"constant|constante|0|1|1|"+
		"original|0|1|orixinal|jatorrizkoa|"+
		"new|nueva|nou|novo|berria|"+
		"apply|aplicar|1|1|froga|"+
		"close|cerrar|1|1|1|"+
		"cancel|cancelar|anul.lar|1|0|"+
		"ok|aceptar|0|0|0|"+
		"add|agregar|afegir|engadir|erantsi|"+
		"insert|insertar|inserir|inserir|1|"+
		"delete|eliminar|1|1|txertatu|"+
		"up|arriba|amunt|1|1|"+
		"down|abajo|avall|1|1|"+
		"rename|renombrar|1|1|1|"+
		"auxiliary|auxiliar|1|1|aldagaia|"+
		"font|fuente|0|1|1|"+
		"undo|deshacer|desfer|1|1|"+
		"redo|rehacer|desfer|1|1|"+
		"numeric|numrico|numric|1|1|"+
		"graphic|grfico|grfic|1|1|"+
		"pos|0|0|0|0|"+
		"init|inicio|inici|1|1|"+
		"do|hacer|fer|0|0|"+
		"while|mientras|mentre|0|0|"+
		"evaluate|evaluar|avaluar|1|1|"+
		"variable|0|0|0|0|"+
		"function|funcin|funci|1|1|"+
		"algorithm|algoritmo|algorisme|1|1|"+
		"array|vector|1|1|1|"+
		"zoom|0|0|0|0|"+
		"draw-if|dibujar-si|dibuixar-si|1|1|"+
		"range|dominio|domini|1|1|"+
		"delay|pausa|1|1|1|"+
		"stop|0|0|0|0|"+
		"x-axis|eje-x|eix-x|1|1|"+
		"y-axis|eje-y|eix-y|1|1|"+
		"numbers|nmeros|nombres|1|1|"+
		"exponential-if|exponencial-si|1|1|1|"+
		"family|familia|1|1|1|"+
		"interval|intervalo|0|1|1|"+
		"steps|pasos|1|1|1|"+
		"center|centro|centre|1|1|"+
		"radius|radio|1|1|1|"+
		"end|fin|1|1|1|"+
		"only-once|una-sola-vez|una-sola-vegada|1|1|"+
		"always|siempre|sempre|1|1|"+
		"copy|copiar|1|1|1|"+
		"paste|pegar|1|1|1|"+
		"int-colour|color-int|1|1|1|"+
		"loop|repetir|1|1|1|"+
		"controls|controles|0|1|1|"+
		"<applet>|cdigo|0|0|0|"+
		"Runtime only.\nNo editing allowed.|Esta versin\nno permite editar.|Aquesta versi\nno permet l'edici|1|1|"+
		"animate|animar|1|1|1|"+
		"pause|pausa|1|1|1|"+
		"auto|0|1|1|1|"+
		"";

	static final synchronized void expandNames() {
		if (newName==null) {
			newName=new String[numLang][NN];
			StringTokenizer st=new StringTokenizer(allNames,"|");
			for (int n=0;n<NN;n++) {
				for (int L=0;L<numLang;L++)	{
					newName[L][n]=st.nextToken();
					if (newName[L][n].equals("0") && L>0) {
						newName[L][n]=newName[0][n];
					} else if (newName[L][n].equals("1") && L>1) {
						newName[L][n]=newName[1][n];
					}
				}
			}
		}
		if (colorName==null) {
			colorName=new String[numLang][numColors];
			for (int i=0;i<numLang;i++) {
				for (int j=0;j<numColors;j++) {
					colorName[i][j]=newName[i][black+j];
				}
			}
		}
	}

	static public Attribute getParam(Applet A,int L,int pix) {
		String s=A.getParameter(newName[L][pix]);
		if (!mjaStr.hasContent(s)) {
			s="";
			for (int l=0;l<numLang;l++) {
				String auxs=A.getParameter(newName[l][pix]);
				if (mjaStr.hasContent(auxs)) {
					s=auxs;
					break;
				}
			}
		}
		return new Attribute(newName[L][pix],s);
	}

	static public int getLanguage(String lang) {
		if (mjaStr.hasContent(lang)) {
			for (int j=0;j<numLang;j++) {
				if (mjaStr.equalsIgnoreAccents(newName[j][langName],lang)) {
					return j;
				}
			}
		}
		return esp;
	}


	static public String booleanName(int L,boolean b) {
		if (b) {
			return newName[L][Yes];
		} else {
			return newName[L][No];
		}
	}

/* ------------------------------------------------------------------- */

	static public boolean equals(String s,int n) {
		for (int L=0;L<numLang;L++) {
			boolean b=mjaStr.equalsIgnoreAccents(s,newName[L][n]);
			if (b) {
				return true;
			}
		}
		return false;
	}

	static public boolean isTrue(String p) {
		if (mjaStr.hasContent(p)) {
			return equals(p,True)||equals(p,Yes);
		} else {
			return false;
		}
	}

	static public boolean isNotFalse(String p) {
		if (mjaStr.hasContent(p)) {
			return !(equals(p,False)||equals(p,No));
		} else {
			return true;
		}
	}

/* ------------------- getValue methods -------------------- */

	static public String getValue(int L,Attribute[] aa,int attrix) {
		return getValue(L,aa,attrix,"");
	}

	static public String getValue(int L,Attribute[] aa,int attrix,String def) {
		if (aa!=null) {
			if (L>=0&&L<numLang) {
				for (int i=0;i<aa.length;i++) {
					if (mjaStr.equalsIgnoreAccents(aa[i].name,newName[L][attrix])) {
						return aa[i].value;
					}
				}
			}
			for (int i=0;i<aa.length;i++) {
				if (equals(aa[i].name,attrix)) {
					return aa[i].value;
				}
			}
		}
		return def;
	}

/* ---------------- parse local types -------------- */

	public static int getIndex(int[] ixa,int L,String s,int defval) {
		for (int i=0;i<ixa.length;i++) {
			if (mjaStr.equalsIgnoreAccents(s,newName[L][ixa[i]])) {
				return ixa[i];
			}
		}
		for (int i=0;i<ixa.length;i++) {
			if (equals(s,ixa[i])) {
				return ixa[i];
			}
		}
		return defval;
	}

	static Color parseColor(String s,Color defcol,Color nullcol) {
		if (isTrue(s)) {
			return defcol;
		} else if (mjaStr.hasContent(s)&&isNotFalse(s)) {
			for (int L=0;L<numLang;L++) {
				Color c=mjaStr.parseColor(colorName[L],s,null);
				if (c!=null) {
					return c;
				}
			}
			return defcol;
		} else {
			return nullcol;
		}
	}

/* --------------------- to String Methods ------------------------ */

	static String toString(String sep,int L,int ix,String s) {
		return toString(sep,newName[L][ix],s,"");
	}

	static String toString(String sep,int L,int ix,String s,String defvalue) {
		return toString(sep,newName[L][ix],s,defvalue);
	}

	static String toString(String sep,String attrname,String s,String defvalue) {
		if (mjaStr.hasContent(s) && !s.equals("''") && !s.equals(defvalue)) {
			return attrname+"="+s+sep;
		} else {
			return "";
		}
	}

/* -------------- Transition before Descartes 3 -------------- */

	static Color adaptColor	(Component C,Color c) {
		if (c!=null&&C!=null&&C.getColorModel().getPixelSize()==16) {
			int r=8*(c.getRed()/8);
			int g=8*(c.getGreen()/8);
			int b=8*(c.getBlue()/8);
			return new Color(r,g,b);
		} else {
			return c;
		}
	}

}