/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.desc2.descartes;
/*------------------------------------------------------------*/
/*                        graphConfig                         */
/*                         (c)  MJA                           */
/*                       Enero de 2001                        */
/*------------------------------------------------------------*/
import java.awt.*;
import java.util.*;
import com.jla.desc2.gui.*;
import com.jla.desc2.util.*;

public class graphConfig extends editObject {

	public int type;
	public String formula="",cond="",text="";
	public String seqRange="[1,100]";
	public String fparam="s", f_interval="[0,1]",f_steps="8";
	public String parameter="t", p_interval="[0,1]",p_steps="8";
	public String s_decimals="2", s_size="2", s_width="", s_spear="";
	public String s_center,s_radius,s_ini,s_end;
	public boolean isVisible=true, isEditable, isInBack, isFamily;
	public Color gcolor=Color.blue;
	public boolean hasTrace, hasFillplus, hasFillminus, hasFill;
	public Color traceColor=Color.gray,
		fillplusColor=Color.green, fillminusColor=Color.orange,
		arrowColor=Color.red,fillColor=Color.yellow;
	public Font font=mjaGui.Courier;
	private int L;

	public graphConfig(int L) {
		this(L,data.newName[L][data.t_equation],"");
	}

	public graphConfig(int L,int type,String svalue) {
		this.L=L;
		this.type=type;
		formula=svalue;
		if (type==data.t_arc) {
			getArcFromFormula(false);
		}
		initWidth();
		resetId(L);
	}

	private void initWidth() {
		if (type==data.arrow) {
			s_width="5";
		} else {
			s_width="1";
		}
	}

	public graphConfig(int L,String stype,String svalue) {
		this(L,data.getIndex(data.gtix,L,stype,data.t_equation),svalue);
	}

	public graphConfig(int L,String s) {
		this.L=L;
		Attribute[] aa=Attribute.parse(s);
		type=data.getIndex(data.gtix,L,data.getValue(L,aa,data.type),data.t_equation);
		initWidth();
		formula=data.getValue(L,aa,data.expr);
		if (type==data.t_arc) {
			s_center=data.getValue(L,aa,data.center);
			s_radius=data.getValue(L,aa,data.radius);
			s_ini=data.getValue(L,aa,data.ini);
			s_end=data.getValue(L,aa,data.end);
			if (!mjaStr.hasContent(s_center)&&mjaStr.hasContent(formula)) {
				getArcFromFormula(true);
			}
			makeArcFormula();
		}
		cond=data.getValue(L,aa,data.cond);
		text=data.getValue(L,aa,data.t_text);
		text=mjaStr.replace(text,"\\n","\n");
		font=mjaStr.parseFont(data.getValue(L,aa,data.font),font);
		gcolor=data.parseColor(data.getValue(L,aa,data.color),gcolor,gcolor);
		isVisible=data.isNotFalse(data.getValue(L,aa,data.visible));
		isEditable=isVisible&&data.isTrue(data.getValue(L,aa,data.editable));
		isInBack=data.isTrue(data.getValue(L,aa,data.background));
		Color auxc=data.parseColor(data.getValue(L,aa,data.trace),traceColor,null);
		hasTrace=(auxc!=null);
		if (hasTrace) {
			traceColor=auxc;
		}
		arrowColor=data.parseColor(data.getValue(L,aa,data.arrow),arrowColor,null);
		if (arrowColor!=null&&type==data.t_segment) { // correccin por si hay flechas en de segmentos
			type=data.arrow;
		}
		s_width=data.getValue(L,aa,data.widthness,s_width);
		s_spear=data.getValue(L,aa,data.spear);
		String s_fill=data.getValue(L,aa,data.fill);
		if (type==data.t_curve||type==data.t_arc||type==data.t_polygon) {
			auxc=data.parseColor(data.getValue(L,aa,data.fill,s_fill),fillColor,null);
			hasFill=(auxc!=null);
			if (hasFill) {
				fillColor=auxc;
			}
		} else {
			String s_fillplus=s_fill;
			String s_fillminus=s_fillplus;
			auxc=data.parseColor(data.getValue(L,aa,data.fillplus,s_fillplus),fillplusColor,null);
			hasFillplus=(auxc!=null);
			if (hasFillplus) {
				fillplusColor=auxc;
			}
			auxc=data.parseColor(data.getValue(L,aa,data.fillminus,s_fillminus),fillminusColor,null);
			hasFillminus=(auxc!=null);
			if (hasFillminus) {
				fillminusColor=auxc;
			}
		}
		s_decimals=data.getValue(L,aa,data.decimals,s_decimals);
		s_size=data.getValue(L,aa,data.size,s_size);
		String auxs1=data.getValue(L,aa,data.sequence,data.newName[L][data.No]);
		String auxs2=data.getValue(L,aa,data.family,data.newName[L][data.No]);
		isFamily=data.isNotFalse(auxs1)||data.isNotFalse(auxs2);
		if (isFamily) {
			if (data.isNotFalse(auxs2)) {
				fparam=auxs2;
			} else {
				fparam=auxs1;
			}
			f_interval=Attribute.getValue(aa,fparam+"."+data.newName[L][data.interval]);
			f_steps=Attribute.getValue(aa,fparam+"."+data.newName[L][data.steps]);
			if (mjaStr.hasContent(fparam)&&!mjaStr.hasContent(f_interval)) {
				try {
					String[] bst=mjaStr.getTokens(fparam);
					if (bst.length==4) {
						fparam=bst[0];
						f_interval="["+bst[1]+","+bst[2]+"]";
						f_steps=bst[3];
					}
				} catch(Exception exc) {
				}
			}
		}
		parameter=data.getValue(L,aa,data.parameter,"s");
		p_interval=Attribute.getValue(aa,parameter+"."+data.newName[L][data.interval]);
		p_steps=Attribute.getValue(aa,parameter+"."+data.newName[L][data.steps]);
		if (mjaStr.hasContent(parameter)&&!mjaStr.hasContent(p_interval)) {
			try {
				String[] bst=mjaStr.getTokens(parameter);
				if (bst.length==4) {
					parameter=bst[0];
					p_interval="["+bst[1]+","+bst[2]+"]";
					p_steps=bst[3];
				}
			} catch(Exception exc) {
			}
		}
		seqRange=data.getValue(L,aa,data.range,seqRange);
		resetId(L);
	}

	private void makeArcFormula() {
		if (s_ini.startsWith("[")||s_ini.startsWith("(")) {
			formula=s_center+s_radius+s_ini+s_end;
		} else {
			formula=s_center+s_radius+"["+s_ini+","+s_end+"]";
		}
	}

	private void getArcFromFormula(boolean old) {
		try {
			String[] st=mjaStr.getTokens(formula);
			if (st.length==5||st.length==7) {
				s_center="("+st[0]+","+st[1]+")";
				s_radius=st[2];
				if (st.length==5) {
					s_ini=st[3];
					s_end=st[4];
					if (old) {
						s_end="("+s_ini+")+("+s_end+")";
					}
				} else {
					s_ini="("+st[3]+","+st[4]+")";
					s_end="("+st[5]+","+st[6]+")";
				}
			}
		} catch (Exception exc) {
			System.out.println("bad expression "+formula);
		}
	}

	public void setName(String name) {
		formula=name;
		if (type==data.t_arc) {
			getArcFromFormula(false);
		}
	}

	public String getName() {
		return formula;
	}

	public void resetId(int L) {
		this.L=L;
		if (type==data.t_arc) {
			makeArcFormula();
		}
		setId(data.newName[L][type]+" "+formula);
	}

	public String toString(String sep,int L) {
		String s=data.newName[L][data.type]+"="+data.newName[L][type]+sep;
		if (type==data.t_arc) {
			s+=data.toString(sep,L,data.center,"'"+s_center+"'");
			s+=data.toString(sep,L,data.radius,"'"+s_radius+"'");
			s+=data.toString(sep,L,data.ini,"'"+s_ini+"'");
			s+=data.toString(sep,L,data.end,"'"+s_end+"'");
		} else {
			s+=data.toString(sep,L,data.expr,"'"+formula+"'");
		}
		s+=data.toString(sep,L,data.color,mjaStr.getColorName(data.colorName[L],gcolor),data.newName[L][data.blue]);
		s+=data.toString(sep,L,data.cond,"'"+cond+"'");

		s+=data.toString(sep,L,data.background,data.booleanName(L,isInBack),data.newName[L][data.No]);
		if (hasTrace) {
			s+=data.toString(sep,L,data.trace,mjaStr.getColorName(data.colorName[L],traceColor));
		}
		if (isFamily) {
			s+=data.toString(sep,L,data.family,fparam,"");
			s+=data.toString(sep,fparam+"."+data.newName[L][data.interval],f_interval,"");
			s+=data.toString(sep,fparam+"."+data.newName[L][data.steps],f_steps,"");
		}
		if (type==data.t_equation||type==data.t_curve||type==data.sequence) {
			s+=data.toString(sep,L,data.visible,data.booleanName(L,isVisible),data.newName[L][data.Yes]);
			s+=data.toString(sep,L,data.editable,data.booleanName(L,isEditable),data.newName[L][data.No]);
			if (type==data.t_equation) {
				if (hasFillplus) {
					s+=data.toString(sep,L,data.fillplus,mjaStr.getColorName(data.colorName[L],fillplusColor));
				}
				if (hasFillminus) {
					s+=data.toString(sep,L,data.fillminus,mjaStr.getColorName(data.colorName[L],fillminusColor));
				}
			}
			if (type==data.t_curve) {
				s+=data.toString(sep,L,data.parameter,parameter,"");
				s+=data.toString(sep,parameter+"."+data.newName[L][data.interval],p_interval,"");
				s+=data.toString(sep,parameter+"."+data.newName[L][data.steps],p_steps,"");
			}
			if (type==data.sequence) {
				s+=data.toString(sep,L,data.range,seqRange);
				s+=data.toString(sep,L,data.size,s_size,"2");
			}

		} else if (type!=data.fill) {
			s+=data.toString(sep,L,data.t_text,"'"+mjaStr.replace(text,"\n","\\n")+"'");
			s+=data.toString(sep,L,data.decimals,s_decimals,"2");
			if (type==data.t_point||type==data.t_segment) {
				s+=data.toString(sep,L,data.size,s_size,"2");
			}
			if (type==data.arrow) {
				s+=data.toString(sep,L,data.arrow,mjaStr.getColorName(data.colorName[L],arrowColor));
				s+=data.toString(sep,L,data.widthness,s_width,"-1");
				s+=data.toString(sep,L,data.spear,s_spear,"-1");
			}
			if (!font.equals(mjaGui.Courier)) {
				s+=data.toString(sep,L,data.font,mjaStr.FontToString(font));
			}
		}
		if (type==data.t_equation||type==data.t_curve||type==data.t_arc||type==data.t_polygon||type==data.t_segment) {
			s+=data.toString(sep,L,data.widthness,s_width,"1");
		}
		if (hasFill&& (type==data.t_curve||type==data.t_arc||type==data.t_polygon)) {
			s+=data.toString(sep,L,data.fill,mjaStr.getColorName(data.colorName[L],fillColor));
		}

		return s.trim();
	}

	public editObject create(int L, String values) {
		return new graphConfig(L,values);
	}
}