/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.desc2.editdesc;

/*------------------------------------------------------------*/
/*                           algEP                            */
/*                          (c) MJA                           */
/*                        Abril de 2001                       */
/*------------------------------------------------------------*/

import java.awt.*;
import com.jla.desc2.util.*;
import com.jla.desc2.gui.*;
import com.jla.desc2.descartes.*;

public class algEP extends Panel {

	mjaPair pr_id;
	private TextField tf_ini,tf_while;
	private TextArea ta_do;
	private Label lb_ini,lb_do,lb_while;
	private int L,type;
	private String name;

	algEP() {
		lb_ini=new Label();
		lb_ini.setAlignment(Label.CENTER);
		lb_do=new Label();
		lb_do.setAlignment(Label.CENTER);
		lb_while=new Label();
		lb_while.setAlignment(Label.CENTER);
		pr_id=new mjaPair(8);
		tf_ini=new TextField();
		tf_ini.setFont(mjaGui.Courier);
		ta_do=new TextArea(3,32);
		ta_do.setFont(mjaGui.Courier);
		tf_while=new TextField();
		tf_while.setFont(mjaGui.Courier);
		Panel W=new Panel();
		Panel C=new Panel();
		setLayout(new BorderLayout());
		add("West",W);
		W.setLayout(new BorderLayout());
		W.add("North",lb_ini);
		W.add("Center",lb_do);
		W.add("South",lb_while);
		add("Center",C);
		Panel NP=new Panel();
		C.setLayout(new BorderLayout());
		C.add("North",tf_ini);
		C.add("Center",ta_do);
		C.add("South",tf_while);
	}

	void setLabels(String s_ini,String s_do,String s_while) {
		lb_ini.setText(s_ini);
		lb_do.setText(s_do);
		lb_while.setText(s_while);
	}

	void setInfo(String name,String s_ini,String s_do,String s_while) {
		pr_id.setInfo("id",name);
		tf_ini.setText(s_ini);
		ta_do.setText(mjaStr.replace(s_do,";","\n"));
		tf_while.setText(s_while);
	}

	String getIni() {
		return tf_ini.getText();
	}
	String getDo() {
		return mjaStr.replace(ta_do.getText(),"\n",";");
	}
	String getWhile() {
		return tf_while.getText();
	}

	public void setEnabled(boolean en) {
		tf_ini.setEnabled(en);
		ta_do.setEnabled(en);
		tf_while.setEnabled(en);
	}

	public void setInfo(int L,editObject eO) {
		this.L=L;
		boolean isac=(eO!=null && eO instanceof auxConfig);
		auxConfig ac=null;
		if (isac) {
			ac=(auxConfig) eO;
		} else {
			ac=new auxConfig(L,"",data.var);
		}
		type=ac.type;
		name=ac.name;
		setInfo(ac.name,ac.s_ini,ac.s_do,ac.s_while);
	}

	public editObject getInfo() {
		auxConfig ac=new auxConfig(L,name,type);
		ac.name=pr_id.getInfo();
		ac.s_ini=getIni();
		ac.s_do=getDo();
		ac.s_while=getWhile();
		return ac;
	}

}