/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.desc2.editdesc;

/*------------------------------------------------------------*/
/*                          controlEP                         */
/*                          (c) MJA                           */
/*                       Enero de 2001                        */
/*------------------------------------------------------------*/

import java.awt.*;
import java.awt.event.*;
import com.jla.desc2.util.*;
import com.jla.desc2.gui.*;
import com.jla.desc2.descartes.*;

public class controlEP extends editPanel implements ActionListener {

	private mjaPair[] pr_numeric;
	private Label region_lb;
	private Choice region_ch;
	private Checkbox chb_visible;

	private Button b_text, b_ccolor,b_icolor,b_trace;
	private Checkbox chb_trace;
	private Font textFont=mjaGui.Courier;
	private TextField tf_text;
	private mjaPair pr_initialPos,pr_decimals,pr_size,pr_constraint,pr_cond;

	private TextField TF0;
	private Label lb_type;
	private editColorDialog ecd;
	private editFontDialog efd;
	private int L;
	private Frame parent;
	private Panel MP;
	private CardLayout CL;
	private static final String pempty="empty",pnumeric="numeric",pgraphic="graphic";

	public controlEP(Frame parent) {
		this.parent=parent;
		setLayout(new BorderLayout());
		lb_type=new Label();
		TF0=new TextField();

		add("Center",new Panel());
		add("North",MP=new Panel());
		MP.setLayout(CL=new CardLayout());
		MP.add(pempty,new Panel());
		Panel Pnumeric, Pgraphic;
		MP.add(pnumeric,Pnumeric=new Panel());
		MP.add(pgraphic,Pgraphic=new Panel());

		pr_numeric=new mjaPair[7];
		for (int i=0;i<pr_numeric.length;i++) {
			pr_numeric[i]=new mjaPair(6);
		}
		region_lb=new Label();
		region_lb.setAlignment(Label.CENTER);
		region_ch=new Choice();
		region_ch.setFont(mjaGui.Courier);
		chb_visible=new Checkbox();
		Pnumeric.setLayout(new GridLayout(4,1));
		Pnumeric.add(mjaGui.pair(0.8,0.2,pr_numeric[0],pr_numeric[5]));
		Pnumeric.add(mjaGui.pair(0.8,0.2,pr_numeric[4],mjaGui.pair(0.33,0.67,region_lb,region_ch)));
		Pnumeric.add(mjaGui.pair(0.33,0.67,pr_numeric[1],mjaGui.pair(pr_numeric[2],pr_numeric[3])));
		Pnumeric.add(mjaGui.pair(0.8,0.2,pr_numeric[6],chb_visible));

		pr_initialPos=new mjaPair(20);
		pr_decimals=new mjaPair(1);
		pr_size=new mjaPair(1);
		pr_constraint=new mjaPair(24);
		pr_cond=new mjaPair(24);
		b_trace=new Button(graphEP.blankColorLabel);
		chb_trace=new Checkbox();
		Pgraphic.setLayout(new GridLayout(4,1));
		Pgraphic.add(mjaGui.pair(0.8,0.2,mjaGui.pair(1,0,pr_initialPos,mjaGui.pair(b_ccolor=new Button(graphEP.blankColorLabel),b_icolor=new Button(graphEP.blankColorLabel))) ,pr_size ));
		Pgraphic.add(pr_constraint);
		Pgraphic.add(mjaGui.pair(0.8,0.2,mjaGui.pair(0.2,0.8,b_text=new Button(),tf_text=new TextField()),pr_decimals));
		Pgraphic.add(mjaGui.pair(0.2,0.8,mjaGui.pair(0,1,b_trace,chb_trace),pr_cond));
		tf_text.setFont(mjaGui.Courier);
		b_text.addActionListener(this);
		b_ccolor.addActionListener(this);
		b_icolor.addActionListener(this);
		b_trace.addActionListener(this);
	}

	public editObject newObject(String stype,String svalue) {
		return new controlConfig(L,stype,svalue);
	}

	public void setInfo(int L,editObject eO) {
		this.L=L;
		TF0.setText("");
		lb_type.setText("");
		region_ch.removeAll();
		region_ch.addItem(data.newName[L][data.north]);
		region_ch.addItem(data.newName[L][data.south]);
		region_ch.addItem(data.newName[L][data.external]);
		chb_visible.setLabel(data.newName[L][data.visible]);

		pr_numeric[0].setInfo(data.newName[L][data.value],"");
		pr_numeric[1].setInfo(data.newName[L][data.incr],"");
		pr_numeric[2].setInfo(data.newName[L][data.inf],"");
		pr_numeric[3].setInfo(data.newName[L][data.sup],"");
		pr_numeric[4].setInfo(data.newName[L][data.decimals],"");
		pr_numeric[5].setInfo(data.newName[L][data.name],"");
		pr_numeric[6].setInfo(data.newName[L][data.notexp],"");
		region_ch.select(data.newName[L][data.south]);

		b_text.setLabel(data.newName[L][data.TEXT]);
		b_ccolor.setBackground(Color.blue);
		b_icolor.setBackground(Color.red);
		pr_initialPos.setInfo(data.newName[L][data.initialPos],"");
		pr_decimals.setInfo(data.newName[L][data.decimals],"");
		pr_size.setInfo(data.newName[L][data.size],"");
		pr_constraint.setInfo(data.newName[L][data.constraint],"");
		pr_cond.setInfo(data.newName[L][data.cond],"");

		boolean iscc=(eO!=null && eO instanceof controlConfig);
		if (iscc) {
			controlConfig cc=(controlConfig) eO;
			switch (cc.type) {
			case data.c_numeric:
				TF0.setText(cc.param.id);
				lb_type.setText(data.newName[L][data.c_numeric]);
				pr_numeric[0].setInfo(data.newName[L][data.value],cc.param.s_v);
				pr_numeric[1].setInfo(data.newName[L][data.incr],cc.param.s_vincr);
				pr_numeric[2].setInfo(data.newName[L][data.inf],cc.param.s_vmin);
				pr_numeric[3].setInfo(data.newName[L][data.sup],cc.param.s_vmax);
				pr_numeric[4].setInfo(data.newName[L][data.decimals],cc.param.s_p);
				pr_numeric[5].setInfo(data.newName[L][data.name],cc.param.name);
				if (cc.param.name.trim().length()==0) {
					pr_numeric[5].setInfo(data.newName[L][data.name],cc.param.id);
					cc.param.name=cc.param.id;
				}
				pr_numeric[6].setInfo(data.newName[L][data.notexp],cc.param.s_notexp);
				region_lb.setText(data.newName[L][data.region]);
				region_ch.select(data.newName[L][cc.param.region]);
				chb_visible.setState(cc.param.visible);
				CL.show(MP,pnumeric);
				break;
			case data.c_graphic:
				pr_initialPos.setInfo(data.newName[L][data.initialPos],cc.ctrl.s_initialPos);
				pr_decimals.setInfo(data.newName[L][data.decimals],cc.ctrl.s_decimals);
				pr_size.setInfo(data.newName[L][data.size],cc.ctrl.s_size);
				pr_constraint.setInfo(data.newName[L][data.constraint],cc.ctrl.s_constraint);
				pr_cond.setInfo(data.newName[L][data.cond],cc.ctrl.s_cond);
				tf_text.setText(mjaStr.replace(cc.ctrl.text,"\n","\\n"));
				TF0.setText(cc.ctrl.controlName);
				lb_type.setText(data.newName[L][data.c_graphic]);
				b_ccolor.setBackground(cc.ctrl.ccolor);
				b_icolor.setBackground(cc.ctrl.icolor);
				b_trace.setBackground(cc.ctrl.tcolor);
				chb_trace.setLabel(data.newName[L][data.trace]);
				chb_trace.setState(cc.ctrl.hasTrace);
				textFont=cc.ctrl.font;
				CL.show(MP,pgraphic);
				break;
			default:
				CL.show(MP,pempty);
				break;
			}
		} else {
			CL.show(MP,pempty);
		}
		for (int i=0;i<pr_numeric.length;i++) {
			pr_numeric[i].setEnabled(iscc);
		}
		region_ch.setEnabled(iscc);
		chb_visible.setEnabled(iscc);
		paintAll(getGraphics());
	}

	public editObject getInfo() {
		controlConfig cc=new controlConfig(L,lb_type.getText().trim(),TF0.getText());
		switch (cc.type) {
		case data.c_numeric:
			cc.param.s_v=pr_numeric[0].getInfo();
			cc.param.s_vincr=pr_numeric[1].getInfo();
			cc.param.s_vmin=pr_numeric[2].getInfo();
			cc.param.s_vmax=pr_numeric[3].getInfo();
			cc.param.s_p=pr_numeric[4].getInfo();
			cc.param.name=pr_numeric[5].getInfo();
			cc.param.s_notexp=pr_numeric[6].getInfo();
			cc.param.region=data.getIndex(data.regix,L,region_ch.getSelectedItem(),data.south);
			cc.param.visible=chb_visible.getState();
			break;
		case data.c_graphic:
			cc.ctrl.ccolor=b_ccolor.getBackground();
			cc.ctrl.icolor=b_icolor.getBackground();
			cc.ctrl.font=textFont;
			cc.ctrl.text=mjaStr.replace(tf_text.getText(),"\\n","\n");
			cc.ctrl.s_initialPos=pr_initialPos.getInfo();
			cc.ctrl.s_decimals=pr_decimals.getInfo().trim();
			cc.ctrl.s_size=pr_size.getInfo().trim();
			cc.ctrl.s_constraint=pr_constraint.getInfo().trim();
			cc.ctrl.s_cond=pr_cond.getInfo().trim();
			cc.ctrl.hasTrace=chb_trace.getState();
			cc.ctrl.tcolor=b_trace.getBackground();
			break;
		default:
			break;
		}
		cc.resetId(L);
		return cc;
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==b_text) {
			if (efd==null) {
				efd=new editFontDialog(parent,"",true,"","");
			}
			efd.setTitle(b_text.getLabel());
			efd.setLabels(data.newName[L][data.accept],data.newName[L][data.cancel]);
			efd.setSelectedFont(textFont);
			efd.setText(mjaStr.replace(tf_text.getText(),"\\n","\n"));
			efd.display();
			if (efd.ok) {
				textFont=efd.getSelectedFont();
				tf_text.setText(mjaStr.replace(efd.getText(),"\n","\\n"));
			}
			return;
		} else if (e.getSource() instanceof Button) {
			Button src=(Button) e.getSource();
			if (ecd==null) {
				ecd=new editColorDialog(parent,"",true,"","");
			}
			ecd.setTitle(data.newName[L][data.color]);
			ecd.setLabels(data.newName[L][data.accept],data.newName[L][data.cancel]);
			ecd.setCopyLabels(data.newName[L][data.copy],data.newName[L][data.paste]);
			ecd.setColorNames(data.colorName[L]);
			ecd.setColor(src.getBackground());
			ecd.display();
			if (ecd.ok) {
				src.setBackground(ecd.getColor());
				src.setForeground(mjaGui.bestContrast(ecd.getColor()));
			}
			return;
		}
	}
}