/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.desc2.editdesc;

import java.awt.*;
import java.awt.event.*;
import com.jla.desc2.util.*;
import com.jla.desc2.gui.*;
import com.jla.desc2.descartes.*;

public class editColorDialog extends editDialog implements AdjustmentListener, ItemListener, KeyListener, ActionListener {

	public Color color;

	private Canvas c;
	private Scrollbar sb_r,sb_g,sb_b;
	private TextField tf_r,tf_g,tf_b;
	private Choice ch_c;
	private String[] colorName;
	private Button bc,bp;
	private static Color lastCopied;

	public editColorDialog(Frame parent,String title,boolean modal,String okLabel,String cancelLabel) {
		super(parent,title,modal,okLabel,cancelLabel);
		colorName=data.colorName[1];
		Panel NP=new Panel();
		NP.setBackground(Color.lightGray);
		add("North",NP);
		NP.add(ch_c=new Choice());
		addExtraButton(bc=new Button("copy"));
		addExtraButton(bp=new Button("paste"));
		bc.addActionListener(this);
		bp.addActionListener(this);
		ch_c.addItem("");
		for (int i=0;i<colorName.length;i++) {
			ch_c.addItem(colorName[i]);
		}
		ch_c.addItemListener(this);
		Panel cp=new Panel();
		cp.setBackground(Color.black);
		cp.setLayout(new GridLayout(3,0));
		add("Center",cp);
		sb_r = new Scrollbar(Scrollbar.HORIZONTAL,255,1,0,256);
		sb_g = new Scrollbar(Scrollbar.HORIZONTAL,255,1,0,256);
		sb_b = new Scrollbar(Scrollbar.HORIZONTAL,255,1,0,256);
		sb_r.setForeground(Color.red);
		sb_g.setForeground(Color.green);
		sb_b.setForeground(Color.blue);
		cp.add(sb_r);
		cp.add(sb_g);
		cp.add(sb_b);
		Panel wp=new Panel();
		add("West",wp);
		wp.setFont(mjaGui.Courier);
		wp.setLayout(new GridLayout(3,2));
		Label l=new Label(" "); l.setBackground(Color.red);	wp.add(l);
		wp.add(tf_r=new TextField(2));
		l=new Label(" "); l.setBackground(Color.green);	wp.add(l);
		wp.add(tf_g=new TextField(2));
		l=new Label(" "); l.setBackground(Color.blue); wp.add(l);
		wp.add(tf_b=new TextField(2));
		add("East",c=new Canvas());
		c.setSize(80,64);
		sb_r.addAdjustmentListener(this);
		sb_g.addAdjustmentListener(this);
		sb_b.addAdjustmentListener(this);
		tf_r.addKeyListener(this);
		tf_g.addKeyListener(this);
		tf_b.addKeyListener(this);
		setColor(Color.black);
	}

	public void setColorNames(String[] cn) {
		colorName=cn;
		ch_c.removeAll();
		ch_c.addItem("");
		for (int i=0;i<colorName.length;i++) {
			ch_c.addItem(colorName[i]);
		}
	}

	public void setCopyLabels(String copy,String paste) {
		bc.setLabel(copy);
		bp.setLabel(paste);
	}

	static String rgbHex(int n) {
		String s=Integer.toString(n,16);
		while (s.length()<2) {
			s="0"+s;
		}
		return s;
	}

	public static String colorToHexString(Color c) {
		return rgbHex(c.getRed()+c.getGreen()+c.getBlue());
	}

	public String getColorHexString() {
		return colorToHexString(color);
	}

	public Color getColor() {
		return color;
	}

	public void setColor(Color col) {
		color=col;
		updateAll();
	}

	private void updateAll() {
		if (!isUpdating()) {
			updating=true;
//			enableListener(false);
			ch_c.select(0);
			ch_c.select(mjaStr.getColorName(colorName,color));
			sb_r.setValue(color.getRed());
			sb_g.setValue(color.getGreen());
			sb_b.setValue(color.getBlue());
			tf_r.setText(rgbHex(color.getRed()));
			tf_g.setText(rgbHex(color.getGreen()));
			tf_b.setText(rgbHex(color.getBlue()));
			c.setBackground(color);
			c.repaint();
//			enableListener(true);
			updating=false;
		}
	}

	private boolean updating=false;

	private boolean isUpdating() {
		return updating;
	}

	private long ta=0;
	public void adjustmentValueChanged(AdjustmentEvent e) {
		long TA=System.currentTimeMillis();
		if (TA-ta>100) {
			ta=TA;
			if (!isUpdating()) {
				if ((e.getSource()==sb_r)||(e.getSource()==sb_g)||
					(e.getSource()==sb_b)) {
					int r=sb_r.getValue(); if (r>0xff) r=0xff;
					int g=sb_g.getValue(); if (g>0xff) g=0xff;
					int b=sb_b.getValue(); if (b>0xff) b=0xff;
					color=new Color(r,g,b);
					updateAll();
				}
			}
		}
	}

	private long ti=0;
	public void itemStateChanged(ItemEvent e) {
		long TI=System.currentTimeMillis();
		if (TI-ti>100) {
			ti=TI;
			if (!isUpdating()) {
				if (e.getStateChange()==ItemEvent.SELECTED) {
					if (e.getSource()==ch_c) {
						color=mjaStr.parseColor(colorName,ch_c.getSelectedItem(),color);
						updateAll();
					}
				}
			}
		}
	}

	public void actionPerformed(ActionEvent e) {
		if (!isUpdating()) {
			if (e.getSource()==bc) {
				lastCopied=getColor();
			} else if (e.getSource()==bp) {
				if (lastCopied!=null) {
					setColor(lastCopied);
				}
			}
		}
	}

	public void keyPressed(KeyEvent e) {
		if (!isUpdating()) {
			if ((e.getSource() instanceof TextField) && (e.getKeyCode()==KeyEvent.VK_ENTER)) {
				try {
					int r=Integer.parseInt(tf_r.getText(),16);
					int g=Integer.parseInt(tf_g.getText(),16);
					int b=Integer.parseInt(tf_b.getText(),16);
					color=new Color(r,g,b);
				} catch (NumberFormatException nfe) {
					Toolkit.getDefaultToolkit().beep();
				}
				updateAll();
			}
		}
	}

/*
	public void adjustmentValueChanged(AdjustmentEvent e) {
		int r=sb_r.getValue(); if (r>0xff) r=0xff;
		int g=sb_g.getValue(); if (g>0xff) g=0xff;
		int b=sb_b.getValue(); if (b>0xff) b=0xff;
		color=new Color(r,g,b);
		updateAll();
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==bc) {
			lastCopied=getColor();
		} else if (e.getSource()==bp) {
			if (lastCopied!=null) {
				setColor(lastCopied);
			}
		}
	}

	public void itemStateChanged(ItemEvent e) {
		if (e.getSource()==ch_c) {
			color=mjaStr.parseColor(colorName,ch_c.getSelectedItem(),color);
			updateAll();
		}
	}

	public void keyPressed(KeyEvent e) {
		if ((e.getSource() instanceof TextField) && (e.getKeyCode()==KeyEvent.VK_ENTER)) {
			try {
				int r=Integer.parseInt(tf_r.getText(),16);
				int g=Integer.parseInt(tf_g.getText(),16);
				int b=Integer.parseInt(tf_b.getText(),16);
				color=new Color(r,g,b);
			} catch (NumberFormatException nfe) {
				Toolkit.getDefaultToolkit().beep();
			}
			updateAll();
		}
	}
*/

	public void keyReleased(KeyEvent e) {}
	public void keyTyped(KeyEvent e) {}

}