/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.desc2.editdesc;

/*------------------------------------------------------------*/
/*                           graphEP                          */
/*                          (c) MJA                           */
/*                       Enero de 2001                        */
/*------------------------------------------------------------*/

import java.awt.*;
import java.awt.event.*;
import com.jla.desc2.util.*;
import com.jla.desc2.gui.*;
import com.jla.desc2.descartes.*;

public class graphEP extends editPanel implements ActionListener, ItemListener {


	static final String blankColorLabel="  ";
	private static int color=0,trace=1,arrow=2,fillplus=3, fillminus=4, fill=5 ;
	private static final int[] cbix={ data.color, data.trace, data.arrow, data.fillplus, data.fillminus, data.fill };
	private Button b_text;
	private Font textFont=mjaGui.Courier;
	private String s_type;
	private Button[] cb=new Button[cbix.length];
	private mjaPair pr_decimals,pr_size,pr_width,pr_width2,pr_spear,pr_fsteps,pr_psteps,
		pr_finterval,pr_pinterval,pr_cond,pr_center,pr_radius,pr_ini,pr_end,
		pr_fparam,pr_parameter, pr_seqRange;
	private Label lb_arrowColor;
	private TextField tf_expr,tf_text;
	private Checkbox chb_background,chb_visible,chb_editable,chb_family;
	private Checkbox chb_trace,chb_fillplus,chb_fillminus,chb_fill;
	private editColorDialog ecd;
	private editFontDialog efd;
	private int L;
	private Frame parent;
	private Panel[] P;
	private Panel auxP0,fillP,fillAllP,fillPlusP,fillMinusP;
	private CardLayout[] CL;
	private static final String pempty="empty",
		pcurve="curve", pseq="seq", parrow="arrow", pfillwidth="fw",
		peqcurv="eqcurv",ptextdec="textdec",ptsegsz="size";

	public graphEP(Frame parent) {
		this.parent=parent;
		for (int i=0;i<cb.length;i++) {
			cb[i]=new Button(blankColorLabel);
		}

		setLayout(new BorderLayout());
		Panel MP=new Panel();
		add("North",MP);
		P=new Panel[6];
		MP.setLayout(new GridLayout(P.length,1));
		CL=new CardLayout[P.length];
		for (int i=0;i<P.length;i++) {
			P[i]=new Panel();
			CL[i]=new CardLayout();
		}

		tf_expr=new TextField(20);
		tf_expr.setFont(mjaGui.Courier);
		pr_center=new mjaPair(6);
		pr_radius=new mjaPair(3);
		pr_ini=new mjaPair(3);
		pr_end=new mjaPair(3);
		P[0]=mjaGui.pair(1,0,auxP0=new Panel(),cb[color]);
		auxP0.setLayout(CL[0]);
		auxP0.add("expr",tf_expr);
		auxP0.add("arc",mjaGui.pair(mjaGui.pair(pr_center,pr_radius),mjaGui.pair(pr_ini,pr_end)));

		lb_arrowColor=new Label();
		pr_size=new mjaPair(8);
		pr_width=new mjaPair(8);
		pr_spear=new mjaPair(8);
		Panel arrowP=new Panel();
		arrowP.setLayout(new FlowLayout(FlowLayout.LEFT,0,0));
		arrowP.add(mjaGui.pair(0,1,cb[arrow],lb_arrowColor));
		arrowP.add(pr_width);
		arrowP.add(pr_spear);
		pr_parameter=new mjaPair(1);
		pr_pinterval=new mjaPair(8);
		pr_psteps=new mjaPair(8);
		Panel curveP=mjaGui.pair(0,1,pr_parameter,mjaGui.pair(pr_pinterval,pr_psteps));
		P[1].setLayout(CL[1]);
		P[1].add(pempty,new Panel());
		P[1].add(parrow,arrowP);
		P[1].add(ptsegsz,mjaGui.flow(FlowLayout.LEFT,0,0,pr_size));
		P[1].add(pcurve,curveP);

		pr_width2=new mjaPair(8);
		chb_fill=new Checkbox();
		chb_fillplus=new Checkbox();
		chb_fillminus=new Checkbox();
		fillP=mjaGui.flow(FlowLayout.LEFT,0,0,fillAllP=mjaGui.pair(0,1,cb[fill],chb_fill));
		fillP.add(fillPlusP=mjaGui.pair(0,1,cb[fillplus],chb_fillplus));
		fillP.add(fillMinusP=mjaGui.pair(0,1,cb[fillminus],chb_fillminus));
		P[2].setLayout(CL[2]);
		P[2].add(pfillwidth,mjaGui.pair(mjaGui.flow(FlowLayout.LEFT,0,0,pr_width2),fillP));
		P[2].add(pempty,new Panel());

		b_text=new Button();
		tf_text=new TextField(16);
		pr_decimals=new mjaPair(6);
		tf_text.setFont(mjaGui.Courier);
		chb_visible=new Checkbox();
		chb_editable=new Checkbox();
		pr_seqRange=new mjaPair(8);
		P[3].setLayout(CL[3]);
		P[3].add(pempty,new Panel());
		P[3].add(ptextdec,mjaGui.pair(1,0,mjaGui.pair(0,1,b_text,tf_text),pr_decimals));
		P[3].add(peqcurv,mjaGui.flow(FlowLayout.LEFT,0,0,mjaGui.pair(chb_visible,chb_editable)));
		P[3].add(pseq,pr_seqRange);

		chb_background=new Checkbox();
		chb_trace=new Checkbox();
		pr_cond=new mjaPair(8);
		P[4]=mjaGui.pair(0,1,mjaGui.pair(0,1,chb_background,mjaGui.pair(0,1,cb[trace],chb_trace)),pr_cond);

		chb_family=new Checkbox();
		pr_fparam=new mjaPair(1);
		pr_finterval=new mjaPair(6);
		pr_fsteps=new mjaPair(6);
		P[5]=mjaGui.pair(0,1,chb_family,mjaGui.pair(0,1,pr_fparam,mjaGui.pair(pr_finterval,pr_fsteps)));


		for (int i=0;i<P.length;i++) {
			MP.add(P[i]);
		}

		b_text.addActionListener(this);
		for (int i=0;i<cb.length;i++) {
			cb[i].addActionListener(this);
		}

		chb_background.addItemListener(this);
		chb_visible.addItemListener(this);
		chb_editable.addItemListener(this);
		chb_family.addItemListener(this);
		chb_trace.addItemListener(this);
		chb_fillplus.addItemListener(this);
		chb_fillminus.addItemListener(this);
		chb_fill.addItemListener(this);
	}

	public editObject newObject(String stype,String svalue) {
		return new graphConfig(L,stype,svalue);
	}

	public void setInfo(int L,editObject eO) {
		this.L=L;
		b_text.setLabel(data.newName[L][data.TEXT]);
		lb_arrowColor.setText(data.newName[L][data.arrow]);
		chb_background.setLabel(data.newName[L][data.background]);
		chb_visible.setLabel(data.newName[L][data.visible]);
		chb_editable.setLabel(data.newName[L][data.editable]);
		cb[color].setBackground(Color.blue);
		cb[trace].setBackground(Color.blue);
		cb[arrow].setBackground(Color.red);
		cb[fillplus].setBackground(Color.green);
		cb[fillminus].setBackground(Color.red);
		cb[fill].setBackground(Color.orange);
		chb_trace.setLabel(data.newName[L][data.trace]);
		chb_fillplus.setLabel(data.newName[L][data.fillplus]);
		chb_fillminus.setLabel(data.newName[L][data.fillminus]);
		chb_fill.setLabel(data.newName[L][data.fill]);
		chb_family.setLabel(data.newName[L][data.family]);
		boolean isgc=(eO!=null && eO instanceof graphConfig);
		graphConfig gc=null;
		if (isgc) {
			gc=(graphConfig) eO;
		} else {
			gc=new graphConfig(L);
		}
		if (gc.type==data.t_arc) {
			CL[0].show(auxP0,"arc");
		} else {
			CL[0].show(auxP0,"expr");
		}

		if (gc.type==data.fill) {
			P[1].setVisible(false);
			P[2].setVisible(false);
		} else {
			P[1].setVisible(true);
			P[2].setVisible(true);
		}

		switch (gc.type) {
		case data.t_point:
		case data.sequence:
		case data.t_segment:
			CL[1].show(P[1],ptsegsz);
			break;
		case data.arrow:
			CL[1].show(P[1],parrow);
			break;
		case data.t_curve:
			CL[1].show(P[1],pcurve);
			break;
		default:
			CL[1].show(P[1],pempty);
			break;
		}

		fillP.setVisible(false);
		switch (gc.type) {
		case data.t_polygon:
		case data.t_curve:
		case data.t_arc:
			fillPlusP.setVisible(false);
			fillMinusP.setVisible(false);
			fillAllP.setVisible(true);
			fillP.setVisible(true);
			CL[2].show(P[2],pfillwidth);
			break;
		case data.t_equation:
			fillPlusP.setVisible(true);
			fillMinusP.setVisible(true);
			fillAllP.setVisible(false);
			fillP.setVisible(true);
			CL[2].show(P[2],pfillwidth);
			break;
		case data.t_segment:
			CL[2].show(P[2],pfillwidth);
			break;
		default:
			CL[2].show(P[2],pempty);
		}

		switch (gc.type) {
		case data.t_equation:
		case data.t_curve:
			CL[3].show(P[3],peqcurv);
			break;
		case data.sequence:
			CL[3].show(P[3],pseq);
			break;
		case data.fill:
		case data.t_polygon:	// Added 03-05-2005
			CL[3].show(P[3],pempty);
			break;
		default:
			CL[3].show(P[3],ptextdec);
			break;
		}

		s_type=data.newName[L][gc.type];
		tf_expr.setText(gc.formula);
		pr_center.setInfo(data.newName[L][data.center],gc.s_center);
		pr_radius.setInfo(data.newName[L][data.radius],gc.s_radius);
		pr_ini.setInfo(data.newName[L][data.ini],gc.s_ini);
		pr_end.setInfo(data.newName[L][data.end],gc.s_end);
		cb[color].setBackground(gc.gcolor);
		pr_cond.setInfo(data.newName[L][data.cond],gc.cond);
		textFont=gc.font;
		tf_text.setText(mjaStr.replace(gc.text,"\n","\\n"));
		pr_decimals.setInfo(data.newName[L][data.decimals],gc.s_decimals);
		chb_background.setState(gc.isInBack);
		chb_visible.setState(gc.isVisible);
		chb_editable.setState(gc.isEditable);
		chb_trace.setState(gc.hasTrace);
		cb[trace].setBackground(gc.traceColor);
		cb[arrow].setBackground(gc.arrowColor);
		chb_fillplus.setState(gc.hasFillplus);
		cb[fillplus].setBackground(gc.fillplusColor);
		chb_fillminus.setState(gc.hasFillminus);
		cb[fillminus].setBackground(gc.fillminusColor);
		chb_fill.setState(gc.hasFill);
		cb[fill].setBackground(gc.fillColor);
		pr_size.setInfo(data.newName[L][data.size],gc.s_size);
		pr_width.setInfo(data.newName[L][data.widthness],gc.s_width);
		pr_width2.setInfo(data.newName[L][data.widthness],gc.s_width);
		pr_spear.setInfo(data.newName[L][data.spear],gc.s_spear);
		chb_family.setState(gc.isFamily);
		pr_fparam.setInfo(data.newName[L][data.parameter],gc.fparam);
		pr_finterval.setInfo(data.newName[L][data.interval],gc.f_interval);
		pr_fsteps.setInfo(data.newName[L][data.steps],gc.f_steps);
		pr_seqRange.setInfo(data.newName[L][data.range],gc.seqRange);
		pr_parameter.setInfo(data.newName[L][data.parameter],gc.parameter);
		pr_pinterval.setInfo(data.newName[L][data.interval],gc.p_interval);
		pr_psteps.setInfo(data.newName[L][data.steps],gc.p_steps);

		tf_expr.setEnabled(isgc);
		cb[color].setEnabled(isgc);
		tf_expr.setEnabled(isgc);
		pr_cond.setEnabled(isgc);
		chb_background.setEnabled(isgc);
		chb_visible.setEnabled(isgc);
		chb_editable.setEnabled(isgc);
		chb_trace.setEnabled(isgc);
		cb[trace].setEnabled(isgc);
		cb[arrow].setEnabled(isgc);
		chb_fillplus.setEnabled(isgc);
		cb[fillplus].setEnabled(isgc);
		chb_fillminus.setEnabled(isgc);
		cb[fillminus].setEnabled(isgc);
		pr_size.setEnabled(isgc);
		pr_width.setEnabled(isgc);
		pr_width2.setEnabled(isgc);
		pr_spear.setEnabled(isgc);
		chb_family.setEnabled(isgc);
		pr_fparam.setEnabled(isgc);
		pr_finterval.setEnabled(isgc);
		pr_fsteps.setEnabled(isgc);
		pr_seqRange.setEnabled(isgc);
		pr_parameter.setEnabled(isgc);
		pr_pinterval.setEnabled(isgc);
		pr_psteps.setEnabled(isgc);
		if (isgc) {
			resetEnabling();
		}
		paintAll(getGraphics());
	}

	public editObject getInfo() {
		graphConfig gc=new graphConfig(L,s_type,tf_expr.getText().trim());
		gc.s_center=pr_center.getInfo();
		gc.s_radius=pr_radius.getInfo();
		gc.s_ini=pr_ini.getInfo();
		gc.s_end=pr_end.getInfo();
		gc.gcolor=cb[color].getBackground();
		gc.font=textFont;
		gc.text=mjaStr.replace(tf_text.getText(),"\\n","\n");
		gc.cond=pr_cond.getInfo().trim();
		gc.s_decimals=pr_decimals.getInfo().trim();
		gc.isInBack=chb_background.getState();
		gc.isVisible=chb_visible.getState();
		gc.isEditable=chb_editable.getState();
		gc.hasTrace=chb_trace.getState();
		gc.traceColor=cb[trace].getBackground();
		gc.arrowColor=cb[arrow].getBackground();
		gc.hasFillplus=chb_fillplus.getState();
		gc.fillplusColor=cb[fillplus].getBackground();
		gc.hasFillminus=chb_fillminus.getState();
		gc.fillminusColor=cb[fillminus].getBackground();
		gc.hasFill=chb_fill.getState();
		gc.fillColor=cb[fill].getBackground();
		gc.s_size=pr_size.getInfo().trim();
		if (gc.type==data.arrow) {
			gc.s_width=pr_width.getInfo().trim();
		} else {
			gc.s_width=pr_width2.getInfo().trim();
		}
		gc.s_spear=pr_spear.getInfo().trim();
		gc.isFamily=chb_family.getState();
		gc.fparam=pr_fparam.getInfo().trim();
		gc.f_interval=pr_finterval.getInfo().trim();
		gc.f_steps=pr_fsteps.getInfo().trim();
		gc.seqRange=pr_seqRange.getInfo().trim();
		gc.parameter=pr_parameter.getInfo().trim();
		gc.p_interval=pr_pinterval.getInfo().trim();
		gc.p_steps=pr_psteps.getInfo().trim();
		gc.resetId(L);
		return gc;
	}

	private void resetEnabling() {
		if (!chb_visible.getState()) {
			chb_editable.setState(false);
		}
		chb_editable.setEnabled(chb_visible.getState());
		pr_fparam.setEnabled(chb_family.getState());
		pr_finterval.setEnabled(chb_family.getState());
		pr_fsteps.setEnabled(chb_family.getState());
		if (chb_background.getState()) {
			chb_trace.setState(false);
		}
		chb_trace.setEnabled(!chb_background.getState());
		cb[trace].setEnabled(chb_trace.getState());
		cb[fillplus].setEnabled(chb_fillplus.getState());
		cb[fillminus].setEnabled(chb_fillminus.getState());
		cb[fill].setEnabled(chb_fill.getState());
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==b_text) {
			if (efd==null) {
				efd=new editFontDialog(parent,"",true,"","");
			}
			efd.setTitle(b_text.getLabel());
			efd.setLabels(data.newName[L][data.accept],data.newName[L][data.cancel]);
			efd.setSelectedFont(textFont);
			efd.setText(mjaStr.replace(tf_text.getText(),"\\n","\n"));
			efd.display();
			if (efd.ok) {
				textFont=efd.getSelectedFont();
				tf_text.setText(mjaStr.replace(efd.getText(),"\n","\\n"));
			}
			return;
		}
		for (int i=0;i<cbix.length;i++) {
			if (e.getSource()==cb[i]) {
				if (ecd==null) {
					ecd=new editColorDialog(parent,"",true,"","");
				}
				ecd.setTitle(data.newName[L][cbix[i]]);
				ecd.setLabels(data.newName[L][data.accept],data.newName[L][data.cancel]);
				ecd.setCopyLabels(data.newName[L][data.copy],data.newName[L][data.paste]);
				ecd.setColorNames(data.colorName[L]);
				ecd.setColor(cb[i].getBackground());
				ecd.display();
				if (ecd.ok) {
					cb[i].setBackground(ecd.getColor());
					cb[i].setForeground(mjaGui.bestContrast(ecd.getColor()));
				}
				return;
			}
		}
	}

	public void itemStateChanged(ItemEvent e) {
		resetEnabling();
	}

}