/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.desc2.gui;

import java.awt.*;
import java.awt.event.*;
import com.jla.desc2.util.*;

public class editWindowButtons extends Panel implements ActionListener {

	private mjaButton b_ok,b_cancel,b_apply;
	private mjaWindow win;
	private Panel P;

	public editWindowButtons(mjaWindow win,String okLabel,String cancelLabel,String applyLabel) {
		this.win=win;
		setBackground(Color.lightGray);
		setLayout(new GridLayout(1,1));
		int N=3;
		if (okLabel!=null) {
			N++;N++;
		}
		if (cancelLabel!=null) {
			N++;N++;
		}
		if (applyLabel!=null) {
			N++;N++;
		}
		P=new Panel();
		add(mjaGui.flow(8,4,P));
		if (okLabel!=null) {
			P.add(b_ok=new mjaButton(okLabel));
			b_ok.addActionListener(this);
		}
		if (cancelLabel!=null) {
			P.add(b_cancel=new mjaButton(cancelLabel));
			b_cancel.addActionListener(this);
		}
		if (applyLabel!=null) {
			P.add(b_apply=new mjaButton(applyLabel));
			b_apply.addActionListener(this);
		}
/*
		add(mjaGui.flow(4,4,P));
		P.setLayout(new GridLayout(1,N));
		P.add(new Label());
		P.add(new Label());
		if (okLabel!=null) {
			P.add(b_ok=new mjaButton(okLabel));
			b_ok.addActionListener(this);
			P.add(new Label());
		}
		if (cancelLabel!=null) {
			P.add(b_cancel=new mjaButton(cancelLabel));
			b_cancel.addActionListener(this);
			P.add(new Label());
		}
		if (applyLabel!=null) {
			P.add(b_apply=new mjaButton(applyLabel));
			b_apply.addActionListener(this);
			P.add(new Label());
		}
		P.add(new Label());
*/
	}

	public void addExtraButton(Button b) {
		P.add(b);
	}

	public void setLabels(String okLabel, String cancelLabel,String applyLabel) {
		if (b_ok!=null) {
			b_ok.setLabel(okLabel);
		}
		if (b_cancel!=null) {
			b_cancel.setLabel(cancelLabel);
		}
		if (b_apply!=null) {
			b_apply.setLabel(applyLabel);
		}
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==b_ok) {
			win.setVisible(false);
			win.closingAction(true,true);
		} else if (e.getSource()==b_cancel) {
			win.setVisible(false);
			win.closingAction(true,false);
		} else if (e.getSource()==b_apply) {
			win.closingAction(false,true);
		}
	}

}