/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.desc2.gui;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class mjaButton extends Canvas implements MouseListener {

	public static final int pause=-1,play=0,stop=1,rewind=2,back=3,next=4,toend=5,other=6;
	public static final String[] args={"play/pause","stop","rewind","back","next","toend","" };
	public int type;

	private int w=-1,h=-1,w1,h1,w2,h2,dw,dh,ddw;
	private Polygon Pplay,Pback1,Pback2,Pnext1,Pnext2;
	private Vector listeners;
	private String arg;
	private Font font;
	private boolean down;

	public mjaButton(int type) {
		super();
		this.type=type;
		listeners=new Vector();
		addMouseListener(this);
		if (type>=0&&this.type<args.length) {
			arg=args[type];
		} else {
			arg=args[other];
		}
		setFont(font=mjaGui.Arial);
	}

	public mjaButton(String label) {
		this(other);
		setLabel(label);
	}

	public mjaButton() {
		this("");
	}

	public void setLabel(String label) {
		arg=label;
		Graphics g=getGraphics();
		if (g!=null) {
			FontMetrics fm=g.getFontMetrics();
			setSize(fm.stringWidth(arg)+12,fm.getHeight()+8);
			paint(g);
		} else {
			setSize(8*arg.length()+12,23);
			repaint();
		}
	}

	public String getLabel() {
		return arg;
	}

	public void setEnabled(boolean en) {
		super.setEnabled(en);
		repaint();
	}

	public void addActionListener(Component c) {
		listeners.addElement(c);
	}

	private void callListeners(String arg) {
		for (int i=0;i<listeners.size();i++) {
			ActionListener al=(ActionListener)listeners.elementAt(i);
			al.actionPerformed(new ActionEvent(this,ActionEvent.ACTION_PERFORMED,arg));
		}
	}

	private static final Color c1=new Color(228,228,220),
		c2=new Color(140,140,116),
		c3=new Color(4,4,4);

	public void paint (Graphics g) {
		if (w!=getSize().width || h!=getSize().height) {
			w=getSize().width; h=getSize().height;
			makePolygons(w,h);
		}
		if (w>0 && h>0) {
			Color c=g.getColor();
			g.setColor(Color.lightGray);
			g.fillRect(0,0,getSize().width,getSize().height);
			if (down) {
				g.setColor(c3); g.drawLine(0,0,w-1,0);  g.drawLine(0,0,0,h-1);
				g.setColor(c2); g.drawLine(1,1,w-2,1); g.drawLine(1,1,1,h-2);
				g.setColor(c1); g.drawLine(1,h-1,w-1,h-1); g.drawLine(w-1,1,w-1,h-1);
			} else {
				g.setColor(c1); g.drawLine(0,0,w-2,0);  g.drawLine(0,0,0,h-2);
				g.setColor(c2); g.drawLine(0,h-2,w-2,h-2); g.drawLine(w-2,0,w-2,h-2);
				g.setColor(c3); g.drawLine(0,h-1,w-1,h-1); g.drawLine(w-1,0,w-1,h-1);
			}
			if (isEnabled()) {
				g.setColor(Color.black);
			} else {
				g.setColor(Color.gray);
			}
			switch (type) {
			case pause:
				g.fillRect(w1,h1,ddw+1,dh);
				g.fillRect(w2-ddw-1,h1,ddw+1,dh);
				break;
			case play :
				g.fillPolygon(Pplay);
				break;
			case rewind :
				g.fillRect((w/4)-2,h1,2,dh);
			case back :
				g.fillPolygon(Pback1);
				g.fillPolygon(Pback2);
				break;
			case toend :
				g.fillRect(w-(w/4)-1,h1,2,dh);
			case next :
				g.fillPolygon(Pnext1);
				g.fillPolygon(Pnext2);
				break;
			case stop :
				g.fillRect(w1,h1,dw,dh);
				break;
			case other :
				FontMetrics fm=g.getFontMetrics();
				int x0=(w-fm.stringWidth(arg))/2;
				int y0=(h-fm.getHeight())/2+fm.getAscent();
				g.drawString(arg,x0,y0);
				break;
			}
			g.setColor(c);
		}
	}

	private void makePolygons(int w,int h) {
		if (type!=other) {
			int wc=w/2,hc=h/2;
			w1=w/3;h1=h/3;dw=w-2*w1;dh=h-2*h1;w2=w1+dw;h2=h1+dh;
			ddw=w/8;
			switch(type) {
			case pause:
			case play:
				Pplay=new Polygon();
				Pplay.addPoint(w1,h1-1);
				Pplay.addPoint(w2,hc);
				Pplay.addPoint(w1,h2+1);
				break;
			case next:
			case toend:
				Pnext1=new Polygon();
				Pnext1.addPoint(wc-ddw,h1);
				Pnext1.addPoint(wc+ddw,hc);
				Pnext1.addPoint(wc-ddw,h2);
				Pnext1.translate(-ddw-1,0);
				Pnext2=new Polygon();
				Pnext2.addPoint(wc-ddw,h1);
				Pnext2.addPoint(wc+ddw,hc);
				Pnext2.addPoint(wc-ddw,h2);
				Pnext2.translate(ddw,0);
				break;
			case back:
			case rewind:
				Pback1=new Polygon();
				Pback1.addPoint(wc+ddw,h1);
				Pback1.addPoint(wc-ddw,hc);
				Pback1.addPoint(wc+ddw,h2);
				Pback1.translate(-ddw-1,0);
				Pback2=new Polygon();
				Pback2.addPoint(wc+ddw,h1);
				Pback2.addPoint(wc-ddw,hc);
				Pback2.addPoint(wc+ddw,h2);
				Pback2.translate(ddw,0);
				break;
			}
		}
	}

	public void mousePressed(MouseEvent e) {
		down=true;
		paint(getGraphics());
		callListeners(arg);
	}
	public void mouseReleased(MouseEvent e) {
		down=false;
		paint(getGraphics());
	}
	public void mouseEntered (MouseEvent e) {
		down=false;
		paint(getGraphics());
	}
	public void mouseExited (MouseEvent e) {
		down=false;
		paint(getGraphics());
	}
	public void mouseClicked (MouseEvent e) {
		down=false;
		paint(getGraphics());
	}
}