/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.desc2.parser;
/*------------------------------------------------------------*/
/*                         Algorithm                          */
/*                         (c)  MJA                           */
/*                       Marzo de 2001                        */
/*------------------------------------------------------------*/
import com.jla.desc2.util.*;
import java.util.*;

public class Algorithm {

	boolean evOnce;

	private Node[] inivar,ininode,iniixnode,iniarrN;
	private Node[] var,node,ixnode,arrN;
	private Node whileNode;
	private int N;
	private int maxRepeat=100000;

	private Parser p;


	public Algorithm (Parser p,boolean evOnce,String s_do,String s_ini,String s_while) {
		this.p=p;
		this.evOnce=evOnce;
		String[] sa=mjaStr.getElements(s_ini);
		String[] inivarname=new String[sa.length];
		ininode=new Node[sa.length];
		inivar=new Node[sa.length];
		iniixnode=new Node[sa.length];
		iniarrN=new Node[sa.length];
		fillInfo(p,sa,inivarname,inivar,ininode,iniixnode,iniarrN);
		sa=mjaStr.getElements(s_do);
		String[] varname=new String[sa.length];
		node=new Node[sa.length];
		ixnode=new Node[sa.length];
		arrN=new Node[sa.length];
		var=new Node[sa.length];
		fillInfo(p,sa,varname,var,node,ixnode,arrN);
		whileNode=p.Analyse(s_while.trim(),"0");
	}

	private void fillInfo(Parser p,String[] sa,String[] varname,Node[] var,Node[] node,Node[] ixnode,Node[] arrN) {
		for (int i=0;i<sa.length;i++) {
			int pos=sa[i].indexOf("=");
			if (pos>0) {
				varname[i]=sa[i].substring(0,pos).trim();
				int ixlb=varname[i].indexOf("[");
				if (ixlb>0) {

					String arrname=varname[i].substring(0,ixlb).trim();
					if (p.isArray(arrname)) {
						int ixrb=varname[i].lastIndexOf("]");
						if (ixrb>ixlb) {
							ixnode[i]=p.Analyse(varname[i].substring(ixlb+1,ixrb).trim());
							arrN[i]=p.Array(arrname);
						}
					}

//					StringTokenizer st=new StringTokenizer(varname[i],"[]");
//					if (st.countTokens()==2) {
//						String arrname=st.nextToken();
//						if (p.isArray(arrname)) {
//							ixnode[i]=p.Analyse(st.nextToken());
//							arrN[i]=p.Array(arrname);
//						}
//					}
				} else {
					var[i]=p.Var(varname[i]);
				}
			} else {
				varname[i]="";
				arrN[i]=null;
				var[i]=null;
			}
			node[i]=p.Analyse(sa[i].substring(pos+1).trim());
		}
	}

	public void initialize() {
		for (int i=0;i<inivar.length;i++) {
			try {
				if (iniarrN[i]!=null) {
					int n=(int) Math.round(iniixnode[i].Evaluate());
					if (n>=0 && n<iniarrN[i].array.length) {
						iniarrN[i].array[n]=ininode[i].Evaluate();
					}
				} else if (inivar[i]!=null) {
					inivar[i].r=ininode[i].Evaluate();
				} else {
					ininode[i].Evaluate(0);
				}
			} catch (Exception e) {
			}
		}
		N=0;
	}

	public void backstep() throws Exception {
		int pn=N-1;
		initialize();
		while(N<pn) {
			step();
			if (N>maxRepeat) {
				throw new Exception("Loop limit exceeded.");
			}
		}
	}

	public void toEnd() throws Exception {
		do {
			step();
			if (N>maxRepeat) {
				throw new Exception("Loop limit exceeded.");
			}
		} while (repeat());
	}

	public void step() {
		for (int i=0;i<var.length;i++) {
			try {
				if (arrN[i]!=null) {
					int n=(int) Math.round(ixnode[i].Evaluate());
					if (n>=0 && n<arrN[i].array.length) {
						arrN[i].array[n]=node[i].Evaluate();
/*
						if (arrN[i].getSymbol().equals("r")) {
							System.out.println("r["+n+"]="+arrN[i].array[n]);
						}
						if (arrN[i].getSymbol().equals("E_P")) {
							System.out.println("E_P["+n+"]="+arrN[i].array[n]);
						}
*/
					}
				} else if (var[i]!=null) {
					var[i].r=node[i].Evaluate();
/*
					if (var[i].getSymbol().equals("EP")) {
						System.out.println("EP="+var[i].r);
					}
*/
				} else {
					node[i].Evaluate(0);
				}
			} catch (Exception e) {
			}
		}
		N++;
	}

	public boolean repeat() {
		return (whileNode.Evaluate(0)>0);
	}

	public void perform() throws Exception {
		initialize();
		toEnd();
	}

}