/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.desc2.util;
/*------------------------------------------------------------*/
/*                          Attribute                         */
/*                          (c)  MJA                          */
/*                       Febrero de 2001                      */
/*------------------------------------------------------------*/
import java.util.*;
import java.awt.*;

public class Attribute {

	public String name, value;

	public Attribute() {
	}

	public Attribute(String n,String v) {
		name=n; value=v;
	}

	public static String getValue(Attribute[] aa,String attrName) {
		if (aa!=null) {
			for (int i=0;i<aa.length;i++) {
				if (aa[i].name.equals(attrName)) {
					return aa[i].value;
				}
			}
		}
		return "";
	}

	public static Attribute[] parse(String s) {
		if (s==null) { return new Attribute[0]; }
		Vector aV = new Vector();
		int pos0=0;
		do {
			int poseq=s.indexOf("=",pos0);
			if (poseq<0) {
				break;
			}
			String name=s.substring(pos0,poseq).trim();
			int pos=poseq+1;
			int posesp=-1;
			boolean escape=false;
			boolean encomilla=false;
			while (pos<s.length()) {
				char ch=s.charAt(pos);
				if (ch=='\''&&!escape) {
					if (encomilla) {
						pos++;
						break;
					} else {
						encomilla=true;
					}
				} else if (!encomilla) {
					if (ch==' '||ch=='\n') {
						posesp=pos;
					} else if (ch=='=') {
						pos=posesp+1;
						break;
					}
				}
				if (ch=='\\'&&!escape) {
					escape=true;
				} else {
					escape=false;
				}
				pos++;
			}
			aV.addElement(new Attribute(name,mjaStr.trim(s.substring(poseq+1,pos).trim(),'\'')));
			pos0=pos;
		} while (pos0<s.length());
		Attribute[] aa = new Attribute[aV.size()];
		for (int i=0; i<aa.length;i++) {
			aa[i] = (Attribute) aV.elementAt(i);
		}
		return aa;
	}

	public static String[] get100Values(String prefix, Attribute[] aa) {
		Vector v=new Vector();
		for (int i=0;i<aa.length;i++) {
			if (aa[i].name.startsWith(prefix)) {
				v.addElement(aa[i].value);
			}
		}
		String[] sa=new String[v.size()];
		for (int i=0;i<sa.length;i++) {
			sa[i]=(String) v.elementAt(i);
		}
		return sa;
	}
}