/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.desc2.util;

import java.util.*;
import java.awt.*;
import java.math.*;
import com.jla.desc2.gui.*;

public final class mjaStr {

	public static boolean hasContent(String s) {
		return (s!=null && s.trim().length()>0);
	}

	public static String replace(String s,String s1,String s2) {
		if (s!=null&&s.length()>0) {
			String auxs=s;
			int pos=0,l1=s1.length();
			while ((pos=auxs.indexOf(s1,pos))>=0) {
				auxs=auxs.substring(0,pos)+s2+auxs.substring(pos+l1);
				pos+=s2.length();
			}
			return auxs;
		} else {
			return "";
		}
	}

//	public static String replace(String s,String s1,String s2) {
//		if (hasContent(s)) {
//			String auxs=s;
//			int pos,l1=s1.length();
//			while ((pos=auxs.indexOf(s1))>=0) {
//				auxs=auxs.substring(0,pos)+s2+auxs.substring(pos+l1);
//			}
//			return auxs;
//		} else {
//			return "";
//		}
//	}

	public static String[] toStringArray(String s) {
		StringTokenizer st=new StringTokenizer(s,"\n");
		String[] sa=new String[st.countTokens()];
		for (int i=0; i<sa.length; i++) {
			sa[i]=st.nextToken();
		}
		return sa;
	}

	public static String[] getElements(String s) {
		return toStringArray(replace(s.trim(),";","\n"));
	}

	public static String justify(String s,int j,char ch) {
		StringBuffer sb=new StringBuffer(s);
		if (j>0) {
			while (sb.length()<j) {
				sb.append(ch);
			}
		} else {
			while (sb.length()<-j) {
				sb.insert(0,ch);
			}
		}
		String auxs=new String(sb);
		if (j>0) {
			if (auxs.length()>j) {
				auxs=auxs.substring(0,j);
			}
		} else {
			if (auxs.length()>-j) {
				auxs=auxs.substring(auxs.length()+j);
			}
		}
		return auxs;
	}

	public static String trim(String s,char ch) {
		if (s==null||s.length()==0) {
			return s;
		}
		int i1=0;
		while (s.charAt(i1)==ch) {
			i1++;
			if (i1>=s.length()) {
				return "";
			}
		}
		int i2=s.length()-1;
		while (s.charAt(i2)==ch) {
			i2--;
		}
		return s.substring(i1,i2+1);
	}

	public static boolean equalsIgnoreAccents(String s1,String s2) {
		return normalize(s1).equals(normalize(s2));
	}

	public static String normalize(String s) {
		return toLowerCase(eliminateAccents(s));
	}

	private static String toLowerCase(String s) {
		StringBuffer t=new StringBuffer(s.toLowerCase());
		for (int i=0;i<t.length();i++) {
			switch (t.charAt(i)) {
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			}
		}
		return new String(t);
	}

	private static String eliminateAccents(String s) {
		StringBuffer t=new StringBuffer(s);
		for (int i=0;i<t.length();i++) {
			switch (t.charAt(i)) {
			case '' : case '' : case '' : case '' : t.setCharAt(i,'a'); break;
			case '' : case '' : case '' : case '' : t.setCharAt(i,'e'); break;
			case '' : case '' : case '' : case '' : t.setCharAt(i,'i'); break;
			case '' : case '' : case '' : case '' : t.setCharAt(i,'o'); break;
			case '' : case '' : case '' : case '' : t.setCharAt(i,'u'); break;
			case '' : case '' : case '' : case '' : t.setCharAt(i,'A'); break;
			case '' : case '' : case '' : case '' : t.setCharAt(i,'E'); break;
			case '' : case '' : case '' : case '' : t.setCharAt(i,'I'); break;
			case '' : case '' : case '' : case '' : t.setCharAt(i,'O'); break;
			case '' : case '' : case '' : case '' : t.setCharAt(i,'U'); break;
			}
		}
		return new String(t);
	}

/* ------------------- String Parsing ----------------- */
/* ----------------------- Color ---------------------- */

	public static final Color[] namedColor={
		Color.black,
		Color.magenta,  Color.blue,  Color.cyan,  Color.green,
		Color.yellow, Color.orange,  Color.red,   Color.pink,
		Color.darkGray, Color.gray,  Color.lightGray, Color.white
	};
/*
	public static String[] nomColor={
		{ "negro",
		  "magenta"   , "azul"   , "turquesa" , "verde",
		  "amarillo"  , "naranja", "rojo"     , "rosa",
		  "grisOscuro", "gris"   , "grisClaro", "blanco"
		}
	};
*/
	public static String getColorName(String[] colName,Color c) {
		for (int i=0;i<namedColor.length;i++) {
			if (c.equals(namedColor[i])) {
				return colName[i];
			}
		}
		return Integer.toHexString(c.getRGB()).substring(2);
	}

	public static Color parseColor(String[] colName,String s,Color defcol)	{
		if (s!=null) {
			for (int i=0;i<colName.length;i++) {
				if (s.equalsIgnoreCase(colName[i])) {
					return namedColor[i];
				}
			}
			try {
				int c=Integer.parseInt(s,16); return new Color(c);
			}
			catch (NumberFormatException nfe) { }
		}
		return defcol;
	}

/* ----------------------- Fonts ---------------------- */

	public static String FontToString(Font f) {
		String s="";
		if (f!=null) {
			String style="PLAIN";
			if (f.isBold()&&f.isItalic()) {
				style="BOLD+ITALIC";
			} else if (f.isBold()) {
				style="BOLD";
			} else if (f.isItalic()) {
				style="ITALIC";
			}
			s="'"+f.getName()+","+style+","+String.valueOf(f.getSize())+"'";
		}
		return s;
	}

	public static Font parseFont(String str,Font deffont)	{
		if (str!=null) {
			StringTokenizer st=new StringTokenizer(str,",",true);
			if (st.countTokens()>=2) {
				String fn=st.nextToken();
				if (fn.equals(",")) {
					fn = "";
				} else {
					st.nextToken();
				}
				String ft=st.nextToken();
				if (ft.equals(",")) {
					ft = "";
				} else {
					st.nextToken();
				}
				String fs = "";
				if (st.hasMoreTokens()) {
					fs=st.nextToken();
					if (fs.equals(",")) {
						fs = "";
					}
				}
				return parseFont(fn, ft, fs,deffont);
			}
		}
		return deffont;
	}

	private static Font parseFont(String fName, String fStyle, String fSize, Font deffont) {
		String fname  = fName;
		if (fname==null || fname.length()==0) {
			fname = deffont.getName();
		}
		int fstyle = deffont.getStyle();
		if (mjaStr.hasContent(fStyle)) {
			fstyle = Font.PLAIN;
			if (fStyle.indexOf("BOLD")>=0) {
				fstyle += Font.BOLD;
			}
			if (fStyle.indexOf("ITALIC")>=0) {
				fstyle += Font.ITALIC;
			}
		}
		int fsize = deffont.getSize();
		if (mjaStr.hasContent(fSize)) {
			try {
				fsize = Integer.parseInt(fSize);
			} catch (NumberFormatException nfe) {
				fsize = deffont.getSize();
			}
		}
		return new Font(fname,fstyle,fsize);
	}

/* ------------------------------------------------------------ */

	public static int parseInteger(String s,int defval,int nullval) {
		if (mjaStr.hasContent(s)) {
			try {
				return Integer.parseInt(s);
			} catch (NumberFormatException nfe) {
				return defval;
			}
		} else {
			return nullval;
		}
	}
/*
	public static double parseDouble(String s,double defval, double nullval) {
		if (mjaStr.hasContent(s)) {
			try {
				double d = Double.valueOf(s).doubleValue();
				return d;
			} catch (NumberFormatException nfe) {
				return defval;
			}
		} else {
			return nullval;
		}
	}

	public static boolean parseBoolean(String s,boolean defbool,boolean nullbool)	{
		if (mjaStr.hasContent(s)) {
			if (s.equals("false")||s.equals("no")) {
				return false;
			} else if (s.equals("true")||s.equals("si")
				||s.equalsIgnoreCase("s")||s.equalsIgnoreCase("yes")) {
				return true;
			} else {
				return defbool;
			}
		} else {
			return nullbool;
		}
	}
*/


	public static double parseDouble(String s,double defval) {
		return parseDouble(s,defval,defval);
	}

	public static double parseDouble(String s,double defval, double nullval) {
		if (hasContent(s)) {
			try {
				double d = Double.valueOf(s).doubleValue();
				return d;
			} catch (NumberFormatException nfe) {
				return defval;
			}
		} else {
			return nullval;
		}
	}


	public static double minIncr(int precision) {
		if (precision>0) {
			String sdv="1";
			int n=precision;
			while (n>1) {
				sdv="0"+sdv;
				n--;
			}
			return Double.parseDouble("0."+sdv);
		} else {
			return 1;
		}
	}
	
	public static final int real_precision=13;
	public static String decimal_symbol=".";

	public static String DoubleToString(double x,int p,boolean fixed) {
		return DoubleToString(x,p,fixed,decimal_symbol);
	}

	public static String DoubleToString(double x,int p,boolean fixed,String decsymb) {
		p=Math.max(0,p);
		double a=Math.abs(x);
		String xS=Double.toString(a);
//System.out.println("A "+xS);
		int exp=0;
		if (xS.indexOf("E-")>=0) {
			int posE=xS.indexOf("E-");
			String expS=xS.substring(posE+2);
			exp=-Integer.parseInt(expS);
			xS=xS.substring(0,posE);
		} else if (xS.indexOf("E")>=0) {
			int posE=xS.indexOf("E");
			String expS=xS.substring(posE+1);
			exp=Integer.parseInt(expS);
			xS=xS.substring(0,posE);
		} else if (a<Math.pow(10,-real_precision)) {
			a=0;
		}
//System.out.println("B "+xS);
		int pos=xS.indexOf(".");
		if (pos<0) {
			pos=xS.length();
		} else {
			xS=xS.substring(0,pos)+xS.substring(pos+1);
		}
		while (xS.length()>0 && xS.charAt(0)=='0') {
			xS=xS.substring(1);
			pos--;
		}
//System.out.println("C "+xS);
		if (xS.length()>real_precision) {
			if (xS.charAt(real_precision)>='5') {
				String aux=xS.substring(0,real_precision);
				long L=Long.parseLong(aux);
				L=L+1;
				xS=Long.toString(L);
				if (xS.length()>real_precision) {
					xS+="0";
					exp++;
				}
			} else {
				xS=xS.substring(0,real_precision);
			}
		}
//System.out.println("D "+xS);
		pos=pos+exp;
		while (pos<0) {
			xS="0"+xS;
			pos++;
		}
		while (xS.length()<pos) {
			xS=xS+"0";
		}
//System.out.println("E "+xS+"       pos="+pos);
		if (pos>0) {
			xS=xS.substring(0,pos)+decsymb+xS.substring(pos);
		} else {
			xS="0"+decsymb+xS;
			pos=1;
		}
//System.out.println("F "+xS+"       pos="+pos);
		if (p==0) {
			xS=xS.substring(0,pos);
		} else if (pos+1+p < xS.length()) {
			xS=xS.substring(0,pos+1+p);
		} else if (fixed) {
			while (xS.length()<pos+1+p) {
				xS+=0;
			}
		}
//System.out.println("G "+xS+"       pos="+pos);
		if (!fixed) {
			while (xS.length()>pos &&
				(xS.charAt(xS.length()-1)=='0' || xS.charAt(xS.length()-1)==decsymb.charAt(0))) {
				xS=xS.substring(0,xS.length()-1);
			}
		}
//System.out.println("H "+xS+"       pos="+pos);
		if (xS.equals("")) {
			xS="0";
		}
		if (x<0) {
			xS="-"+xS;
		}
//System.out.println("R "+xS+"       pos="+pos);
		return xS;
	}

/* -------------------- Notacin Exponencial para Descartes ------------------- */

	public static String notExp(double d,int dec,boolean fixed) {
		return notExp(d,dec,fixed,decimal_symbol);
	}

	public static String notExp(double d,int dec,boolean fixed,String decsymb) {
		return notExp(d,1,0,dec,fixed,decsymb);
	}

	public static String notExp(double d,double inf, double sup,int dec,boolean fixed) {
		return notExp(d,inf,sup,dec,fixed,decimal_symbol);
	}

	public static String notExp(double d,double inf, double sup,int dec,boolean fixed,String decsymb) {
		if (d==0.0) {
			return "0";
		}
		double D=Math.abs(d);
		if (inf<=D && D<=sup) {
			String s=DoubleToString(d,dec,fixed,decsymb);
			return DoubleToString(d,dec,fixed,decsymb);
		}
		String s=DoubleToString(D,50,false,decsymb);
		String sign=""; if (d<0) { sign="-"; }
		int pot=0;
		int posp=s.indexOf(decsymb);
		if (posp<0) {
			posp=s.indexOf(".");
		}
		if (posp<0) {
			posp=s.indexOf(",");
		}
		if (posp>0) {
			pot-=s.length()-1-posp;
			s=s.substring(0,posp)+s.substring(posp+1);
		}
		while (s.startsWith("0")) { // Quitar ceros a la izquierda
			s=s.substring(1);
		}
		while (s.endsWith("0")) { // Quitar ceros a la derecha y aumentar exponente
			s=s.substring(0,s.length()-1);
			pot++;
		}
		if (s.length()==0) {
			s="0";
		}
		if (s.length()>1)  { // poner nuevo punto decimal
			pot+=s.length()-1;
			s=s.substring(0,1)+"."+s.substring(1);
		}
		double x=parseDouble(s,0,0);
		s=DoubleToString(x,dec,fixed,decsymb);
		s+="E"+Integer.toString(pot);
		return sign+s;
	}

/* -------------------- Big Decimal expressions ------------------

	private static String PositiveBigDecimalToString(BigDecimal X,int p) {
		String ps="";
		ps="0.";
		for (int i=0;i<p;i++) {
			ps+="0";
		}
		ps+="5";
		BigDecimal pd=new BigDecimal(ps);
		BigDecimal XX=X.add(pd);
		String s=XX.toString();
		int pos=0;
		while (pos<s.length()) {
			if (s.charAt(pos)=='.') { break; }
			pos++;
		}
		if (pos==s.length()) { s=s+"."; }
		if (p==0) {
			s=s.substring(0,pos);
		} else {
		pos++;
		while (s.length()<pos+p) {s=s+"0"; }
			if (s.length()>pos+p) {s=s.substring(0,pos+p);}
		}
		return s;
	}

	public static String BigDecimalToString(BigDecimal X,int p) {
		if (X.signum()>=0) {
			return PositiveBigDecimalToString(X,p);
		} else {
			return "-"+PositiveBigDecimalToString(X.negate(),p);
		}
	}

--------------------------------------------------------------- */

	public static String IntegerToString(int i,int sz) {
		String auxs=Integer.toString(i);
		while (auxs.length()<sz) {
			auxs="0"+auxs;
		}
		return auxs;
	}

	public static String DoubleToString(double x,int p) {
		return DoubleToString(x,p,true);
//		return BigDecimalToString(new BigDecimal(x),p);
	}

/* -------------------- Notacin Exponencial ------------------- */

	public static String notExp(double d,int dec) {
		return notExp(d,dec,false);
//		return notExp(d,1,0);
	}

	private static String clean(String s0) {
		String s=s0;
		if (s.indexOf(".")>=0) {
			while (s.endsWith("0")) {
				s=s.substring(0,s.length()-1);
			}
			if (s.endsWith(".")) {
				s=s.substring(0,s.length()-1);
			}
		}
		return s;
	}

/*
	public static String notExp(double d,double inf,double sup) {
		if (d==0.0) {
			return "0";
		}
		String sign=""; if (d<0) { sign="-"; }
		double D=Math.abs(d);
		int pot=0;
		String s="";
		if (D<1) {
			BigDecimal bd=new BigDecimal(Math.round(D/1E-15)*(1E-15));
			s=clean(BigDecimalToString(bd,15));
			if (inf-(1E-15)<D) {
				return sign+s;
			}
		} else {
			BigDecimal bd=new BigDecimal(Math.round(D/1E-4)*(1E-4));
			s=clean(BigDecimalToString(bd,4));
			int pose=s.indexOf("E");
			if ( (pose<0) && (D<sup+(1E-15)) ) {
				return sign+s;
			}
			if (pose>0) { // Interpretar la notacin exponencial.
				pot=Integer.valueOf(s.substring(pose+1)).intValue();
				s=s.substring(0,pose);
			}
		}
		int posp=s.indexOf(".");
		if (posp>0) {
			pot-=s.length()-1-posp;
			s=s.substring(0,posp)+s.substring(posp+1);
		}
		while (s.startsWith("0")) { // Quitar ceros a la izquierda
			s=s.substring(1);
		}
		while (s.endsWith("0")) { // Quitar ceros a la derecha y aumentar exponente
			s=s.substring(0,s.length()-1);
			pot++;
		}
		if (s.length()==0) {
			if (pot==0) {
				return "0";
			} else {
				s="1";
			}
		}
		if ( s.length()>1 ) { // poner nuevo punto decimal
			pot+=s.length()-1;
			s=s.substring(0,1)+"."+s.substring(1);
		}
		s=clean(s);
		if (pot!=0) {
			s+="E"+Integer.toString(pot);
		}
		return sign+s;
	}
*/

/* ------- Analisis de expresiones con "puntos"como polgonos, arcos, etc... -------- */

	static final String openP="[(", closeP="])", sep=",";

	public static String[] getTokens(String s) throws Exception {
// para separar por ejemplo [0,0]R[A[0],A[1]]
// primero en [0,0],R,[A[0],A[1]]
		Vector v=new Vector();
		StringBuffer sb=new StringBuffer("");
		Stack S=new Stack();
		for (int i=0;i<s.length();i++) {
			char ch=s.charAt(i);
			int ix=openP.indexOf(ch);
			if (ix>=0) {
				S.push(new Integer(ix));
				if (S.size()==1) {
					v.addElement(new String(sb));
					sb=new StringBuffer();
				}
				sb.append(ch);
			} else {
				sb.append(ch);
				ix=closeP.indexOf(ch);
				if (ix>=0) {
					if (ix==((Integer) S.peek()).intValue()) {
						S.pop();
						if (S.empty()) {
							v.addElement(new String(sb));
							sb=new StringBuffer();
						}
					} else {
						throw new Exception(""+ch+" not expected");
					}
				}
			}
		}
		if (sb.length()>0) {
			v.addElement(new String(sb));
		}
// y luego en 0,0,R,A[0],A[1]
		Vector v2=new Vector();
		String s0="";
		for (int i=0;i<v.size();i++) {
			String auxs=(String) v.elementAt(i);
			if ( auxs.length()>0 ) {
				if (openP.indexOf(auxs.charAt(0))>=0
					&& openP.indexOf(auxs.charAt(0))==closeP.indexOf(auxs.charAt(auxs.length()-1))) {
					auxs=auxs.substring(1,auxs.length()-1);
					int inpar=0;
					sb=new StringBuffer("");
					for (int j=0;j<auxs.length();j++) {
						char ch=auxs.charAt(j);
						if (sep.indexOf(ch)>=0 && inpar==0) {
							v2.addElement(new String(sb));
							sb=new StringBuffer("");
						} else {
							sb.append(ch);
							if (openP.indexOf(ch)>=0) {
								inpar++;
							} else if (closeP.indexOf(ch)>=0) {
								inpar--;
							}
						}
					}
					v2.addElement(new String(sb));
				} else {
					v2.addElement(auxs);
				}
			}
		}
		String[] sa=new String[v2.size()];
		for (int i=0;i<sa.length;i++) {
			sa[i]=(String) v2.elementAt(i);
		}
		return sa;
	}


	/**
	 *	@return true only if the os is Windows,
	 */
	public static boolean osIsWindows() {
		String osname=System.getProperty("os.name");
		if (osname!=null&&osname.toLowerCase().startsWith("windows")) {
			return true;
		}
		return false;
	}

        /**
         *
         *  * @return true only if the os is Linux
         */
        public static boolean osIsLinux(){
          String osname=System.getProperty("os.name");
          if(osname!=null&&osname.toLowerCase().startsWith("linux")) {
              return true;
          }
          return false;
        }

        /**
         *
         *  * @return true only if the os is solaris
         */
        public static boolean osIsSolaris(){
          String osname=System.getProperty("os.name");
          if(osname!=null&&osname.toLowerCase().startsWith("sunos")) {
              return true;
          }
          return false;
        }



}