/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.nippe;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.net.*;
import java.util.*;

import com.mja.file.*;
import com.mja.util.BasicStr;

import org.unam.matem.Communicator;

public abstract class AbstractNippe extends Communicator implements Runnable {
	public static final String fecha="2016-05-18", sub_ver="4";
	public static final String ver="5."+sub_ver;
	
	public Frame parentFrame=null;

	public static Color BGColor=Color.white; 
	
	protected String object_id="";

	abstract public void doAction(String type,String param);
	abstract public String getInfo(String type,String param);
	abstract public String getAppliedCode();
	abstract public Dimension getRealSize();
	abstract public void updateProposedDimension();
	abstract public String class_Id();
	abstract public String[] getFilePaths();
	
	public static final String _info_="_info_";
	public static final String _action_="_action_";
	public static final String _nippe_="_nippe_";
	
	private Hashtable appletParams;
	protected AppletContext externalAppletContext;
	protected URL externalDocBase, externalCodeBase;
	protected Dimension proposedDimension;

//	private boolean inWeb=true;
	private boolean toRun=false;
	private ActionListener al;
	private static boolean inNippeEditor=false;

	public Object Promete;
	public String applet_codebase;

	public void init() {
		setBackground(BGColor);
		if (".".equals(getParameter("decimal_symbol"))) {
			BasicStr.decimal_symbol=".";
		} else if (",".equals(getParameter("decimal_symbol"))) {
			BasicStr.decimal_symbol=",";
		}
		setStartTime();
		BasicStr.A=this;
	}
	
	public Hashtable appletParams() {
		return appletParams;
	}
	
	public Dimension proposedDimension() {
		if (proposedDimension==null) {
			updateProposedDimension();
		}
		return proposedDimension;
	}
	
	public void setSize(Dimension d) {
		proposedDimension=d;
		super.setSize(d);
	}

	public void configApplied() {
		updateProposedDimension();
		performAction(new ActionEvent(this,1,"config applied in "+class_Id()));
	}
	public void setInWeb(boolean inw) {
//		inWeb=inw;
		BasicStr.inWeb=inw;
	}
	
	public void setToRun(boolean b) {
		toRun=b;
	}

	public boolean inWeb() {
		return BasicStr.inWeb;
////		return inWeb;
	}

	public boolean toRun() {
		return toRun;
	}

	public void setAppletParams(Hashtable ap) {
		appletParams=ap;
	}

	public String getParameter(String s) {
		if (s==null || s.length()==0) {
			return "";
		}
		if (appletParams!=null) {
			String p=(String) appletParams.get(s);
			if (p!=null && p.length()>0) {
				return p;
			} else {
				return "";
			}
		} else {
			return super.getParameter(s);
		}
	}

	public void setAppletContext(AppletContext ac) {
		externalAppletContext=ac;
	}
	
	public AppletContext getAppletContext() {
		if (externalAppletContext!=null) {
			return externalAppletContext;
		} else {
			return super.getAppletContext();
		}
	}

	public Applet getAppletFromContext(String appletName) {
		AppletContext AC=getAppletContext();
		return AC.getApplet(appletName);
	}
	
	public void setCodeBase(String s_cb) {
		if (s_cb.toLowerCase().startsWith("http://") ) {
			try {
				externalCodeBase=new URL(s_cb);
			} catch (MalformedURLException mue) {
				mue.printStackTrace();
			}
		} else {
			try {
				if (inWeb()) {
					externalCodeBase=new URL(super.getCodeBase(),s_cb);
				} else {
					java.io.File f=new java.io.File("");
					String uri="file://"+f.getAbsolutePath()+java.io.File.separator+s_cb;
					uri=BasicStr.convertToFilePath(uri);
					uri=BasicStr.reducePath(uri);
					externalCodeBase=new URL(uri);
				}
			} catch (MalformedURLException mue) {
				mue.printStackTrace();
			}
		}
	}

	public void setCodeBase(URL codebase) {
		externalCodeBase=codebase;
	}

	public void setDocBase(URL docbase) {
		externalDocBase=docbase;
	}

	public URL getCodeBase() {
		try {
			if (super.getCodeBase().toExternalForm().toLowerCase().startsWith("http://")) {
				return super.getCodeBase();
			} 
		} catch (Exception e) {
		}
		if (externalCodeBase!=null) {
			return externalCodeBase;
		} else {
			try {
				return super.getCodeBase();
			} catch (Exception e) {	}
			try {
				return (new File(".")).toURI().toURL();
			} catch (Exception e) {	 e.printStackTrace();}
			return null;
		}
	}

	public URL getDocumentBase() {
		if (externalDocBase!=null) {
			return externalDocBase;
		} else {
			File file=new File(".");
			try {
				String str=getParameter("docBase");
				if (str==null) {
					return new URL(".");
				}
				int ix=str.lastIndexOf("/");
				if (ix+1<str.length()) {
					str=str.substring(0,ix+1);
				}
				URL url=new URL(str);
				return url;
			} catch (MalformedURLException e) {
				return null;
			}
//			return super.getDocumentBase();
		}
	}

	public void addActionListener(ActionListener al) {
		this.al=al;
	}

	public void performAction(ActionEvent e) {
		if (al!=null) {
			al.actionPerformed(e);
		}
	}

	public static boolean inNippeEditor() {
		return inNippeEditor;
	}

	public void setInNippeEditor(boolean in) {
		inNippeEditor=in;
	}

	public String filterParameter(String paramName) {
 		if(paramName != null) {
            String param = "";
            if (paramName.startsWith("_info_")) {
                String s = paramName.substring("_info_".length());
                StringTokenizer st = new StringTokenizer(s, " ");
                if(st.hasMoreTokens()) {
                    String type = st.nextToken();
                    param = s.substring(type.length());
                    return getInfo(type, param);
                } else {
                	return ("Error: Invalid paramName: "+paramName);
                }
            }
            if (paramName.startsWith("_action_")) {
                String s = paramName.substring("_action_".length());
                StringTokenizer st = new StringTokenizer(s, "_");
                if (st.hasMoreTokens()) {
                    String type = st.nextToken();
                    while(st.hasMoreTokens()) {
                        param += st.nextToken();
	                    if (st.hasMoreTokens()) {
	                    	param+="_";
	                    }
                    }
                    doAction(type, param);
                    return "";
                } else {
                    return ("Error in AbstractNippe.filterparameter: Invalid paramName: "+paramName);
                }
            }
        }
        return null;
	}
	
	public void replaceScene(String params) {
		if (Promete!=null) {
			Prometeo.replace(Promete,this,params);
		}
	}
	
	public void runScene(String filename,String target) throws Exception {
		if (target.equals("_self")) {
			replaceScene(filename);
		} else {
			Applet A=getAppletFromContext(target);
			if (A!=null){
				if (Promete!=null) {
					Prometeo.replace(Promete,A,filename);
				}
			} else {
				throw new Exception("target: \""+target+"\", not found");
			}
		}
	}

/* ------------------- clean and print Memory --------------- */

	protected Image backIm;
	
	protected static Image reloj;

	protected double progress=0;
	
	public void run() {
		while (backIm!=null) {
			try {
				Thread.sleep(50);
				setProgress(progress);
				progress=progress + ((100.0-progress)/16.0);
			} catch (InterruptedException e) {
			}
		}
		progress=0;
	}
	
	public void setProgress(double progress) {
		if (backIm!=null) {
				Graphics g=backIm.getGraphics();
				int W=getSize().width;
				int H=getSize().height;
				Color darkBrown=new Color(0x442207);
				g.setFont(mjaFont.makeFont("SansSerif",Font.PLAIN,22));
				g.setColor(new Color(0xf8d880));
				g.fillOval(W/8,H/3,(3*W)/4,H/3);
				g.setColor(darkBrown);
				FontMetrics fm=g.getFontMetrics(getFont());
				String s="Descartes v.4."+sub_ver;
				g.drawString(s,W/2-fm.stringWidth(s)+16,H/2-15-10);
				g.setColor(darkBrown);
				g.fillRect(W/4,H/2-15,W/2,30);
				g.setColor(darkBrown);
				g.drawOval(W/8,H/3,(3*W)/4,H/3);
				g.setColor(new Color(0xffffcc));
				g.fillRect(W/4,H/2-15,(int) Math.round((W*progress)/200.0),30);
				g.setColor(darkBrown);
				g.drawRect(W/4,H/2-15,W/2,30);
				s=Integer.toString((int) Math.round(progress))+"%";
				g.drawString(s,W/2-fm.stringWidth(s)+16,H/2+45);
				if (reloj!=null) {
					g.drawImage(reloj,W/4-46,H/2-45,this);
				}
				getGraphics().drawImage(backIm,0,0,this);
				
			}
	}

/* ------------------- clean and print Memory --------------- */

	private static long T_start=System.currentTimeMillis();

	private static void setStartTime() {
		T_start=System.currentTimeMillis();
	}
	
	public void destroy() {
		cleanMem(false);
		super.destroy();
	}
	
	private static boolean print_mem=false;

	public static void cleanMem(boolean print) {
		Runtime.getRuntime().runFinalization();
		Runtime.getRuntime().gc();
		long T=System.currentTimeMillis();
		if (print_mem || print) {
			long TM=Runtime.getRuntime().totalMemory();
			long UM=TM-Runtime.getRuntime().freeMemory();
//			System.out.println("Memoria usada: "+ UM/(1000*1024) +" de "+TM/(1000*1024)+" MB"+", "+Thread.activeCount()+" hilos"
//					+", Tiempo: "+BasicStr.DoubleToString((double)(T-T_start)/1000,2,true)+" seg" );
		}
		T_start=T;
	}
	
}