/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.nippe;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.net.*;

import com.mja.gui.*;
import com.mja.guiedit.*;
import com.mja.krypto.*;
import com.mja.parser.*;
import com.mja.lang.*;
import com.mja.text.*;
import com.mja.cmp.*;
import com.mja.util.*;
import com.mja.file.*;
import com.mja.algebra.*;

public abstract class LMSApplet extends NotSoAbstractNippe {

	public static boolean UseRAD=false;

	public static final String _EQUIPO_="_EQUIPO_";
	public static final String _SERVIDOR_RAD_="_SERVIDOR_RAD_";
	public static final String _CONECTADO_AL_RAD_="_CONECTADO_AL_RAD_";
	public String str_name,str_course,str_unit;

	private Object LMS_activity;
	private boolean LMS_checked,LMS_present,RAD_present;
	protected static String RAD_host,nombre_equipo;
	protected boolean connectedToRAD=false;
	protected int _nota_=100;
	protected int _aciertos_=0;
	protected int _errores_=0;
	protected abstract String getInfoInd();
	protected abstract String getInfoEst();
	public abstract String toAppletString();
	
	public LMSApplet() {
	}

	public void init() {
		str_name=getParameter("Nombre");
		str_course=getParameter("CURSO");
		str_unit=getParameter("UNIDAD");
		nombre_equipo=getParameter(_EQUIPO_);
		if (!BasicStr.hasContent(nombre_equipo)) {
			try {
				nombre_equipo=InetAddress.getLocalHost().toString();
			} catch (UnknownHostException e) {
				System.out.println("Unknown Host");
			}
		}
		p.defineVar(_EQUIPO_,nombre_equipo);
		RAD_host=getParameter(_SERVIDOR_RAD_);
		if (!BasicStr.hasContent(RAD_host)) {
			String codebase=getCodeBase().toExternalForm();
			if (codebase.startsWith("http://")) {
				RAD_host=getCodeBase().getHost();
			}
		}
		p.defineVar(_SERVIDOR_RAD_,RAD_host);
		super.init();
	}

	public boolean LMS_inUse() {
		if (LMS_present()) {
			boolean learnerClientExists=doLMS.getLearnerClient()!=null;
			return learnerClientExists;
		} else {
			return false;
		}
	}

	public void initLMS(String programName) {
		if (LMS_inUse()) {
			if (RAD_present) {
				String codebase=getCodeBase().toExternalForm();
				String document=getDocumentBase().toExternalForm();
				String filepath=getDocumentBase().getPath();
				if (document.startsWith(codebase)) {
					filepath=document.substring(codebase.length());
				}
				LMS_activity=doLMS.RADInitialize(codebase,filepath,str_name,toAppletString(),getInfoInd(),getInfoEst());
			} else if (LMS_present) {
				LMS_activity=doLMS.LMSInitialize(programName,str_course,str_unit,str_name,getDocumentBase().toExternalForm());
			}
		}
	}

	public void start() {
		super.start();
		informLMS("auto","start");
	}

	public void informLMS(String type,String name) {
		informLMS(type,name,"");
	}

	private void informLMS(String tipo,String name,String msg) {
		informLMS(tipo,name,msg,null);
	}

	public void informLMS(String tipo,String name,String msg,String[][] strdblarr) {
		if (LMS_inUse()) {
			if (RAD_present) {
				doLMS.RADAddAction(LMS_activity,tipo,name,strdblarr);
			} else if (LMS_present) {
				doLMS.LMSAddAction(LMS_activity,name,msg);
			}
		}
	}

	public void stopLMS() {
		if (LMS_inUse()) {
			if (RAD_present) {
				int n=0;
				doLMS.RADAddAction(LMS_activity,"auto","stop",null);
				doLMS.RADFinish(LMS_activity,p,_nota_,_aciertos_,_errores_);
			} else if (LMS_present) {
				doLMS.LMSFinish(LMS_activity);
			}
		}
	}

	/* ------------------ private methods ------------------ */

	private boolean LMS_present() {
		if (UseRAD) {
			if (!LMS_checked) {
				LMS_checked=true;
				LMS_present=false;
				RAD_present=true;
				RAD_host=getCodeBase().getHost();
				if (doLMS.initRAD(nombre_equipo,RAD_host)) {
					connectedToRAD=true;
					p.defineVar("_EQUIPO_",doLMS.clientName());
					p.Var("_CONECTADO_AL_RAD_").setDouble(1);
					int na=0;
					if (doLMS.Alumnos()!=null) {
						na=doLMS.Alumnos().length;
					}
					int n=0;
					while (n<10) {
						Node N=p.Var("_ALUMNO"+(n+1)+"_");
						if (n<na) {
							N.setOnlyStr(doLMS.Alumnos()[n]);
						} else {
							N.setOnlyStr("");
						}
						n++;
					}
				}
			}
			return RAD_present||LMS_present;
		} else {
			return false;
		}
	}
	
	public void destroy(boolean usingRAD) {
		if (usingRAD /*BasicStr.classExists("com.jla.nippe.doLMS")*/) {
			try {
				doLMS.RADProgramFinish();
			} catch (Exception e) {
			}
		}
		super.destroy();
	}

}