/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.prometeo;
/* ------------ Nippe ---------- */

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.*;

import com.jla.desc2.descartes.Descartes2;
import com.jla.nippe.*;
import com.mja.parser.Parser;
import com.mja.descartes.Descartes3;
import com.mja.descartes.Descartes5;
import com.mja.descartes.Arquimedes;
import com.mja.file.mjaHtml;
import com.mja.util.BasicStr;
import com.mja.algebra.DescartesA;


public class Prometeo_Nippe extends Nippe {

	public static String[] nippes= {
		"Descartes2",
		"Descartes5",
		"Arquimedes",
		"DescartesA",
		"Tablas",
		"Prometeo"
	};
	
	public static String archive(int type) {
		switch (type) {
			case DESCARTES2 : return "Descartes.jar";
			case DESCARTES5 : return "Descartes5.jar";
			case ARQUIMEDES	: return "Arquimedes.jar";
			case ITEM		: return "Descartes5.jar";
//			case DESCARTESA : return "DescartesA.jar";
//			case TABLAS     : return "tablas.jar";
//			case PROMETEO   : return "Prometeo.jar";
			default : return "Descartes5.jar";
		}
	}

	public static String code(int type) {
		switch (type) {
			case DESCARTES2 	: return "Descartes";
			case DESCARTES5 	: return "Descartes";
			case ARQUIMEDES 	: return "Arquimedes";
//			case DESCARTESA 	: return "DescartesA";
//			case TABLAS     	: return "com.mos.tablas.tabla";
//			case PROMETEO   	: return "com.jla.nippe.Prometeo";
			default : return "";
		}
	}


	public static int Type(String code,String archive) {
		if (code!=null) {
			if (code.equals("Arquimedes")) {
				return ARQUIMEDES;
			} else if (code.equals("Descartes")) {
				if (archive.indexOf("Descartes4.jar")>=0) {
					return DESCARTES5;
				} else if (archive.indexOf("Descartes4Runtime.jar")>=0) {
					return DESCARTES5;
				} else if (archive.indexOf("Descartes3.jar")>=0) {
					return DESCARTES5;
				} else if (archive.indexOf("Descartes.jar")>=0) {
					return DESCARTES2;
				} else {
					return DESCARTES5;
				}
			} else if (code.equals("DescartesA")) {
				return DESCARTESA;
			} else if (code.equals("com.mos.tablas.tabla")) {
				return TABLAS;
			} else if (code.equals("com.jla.nippe.Prometeo")) {
				return PROMETEO;
			}
		}
		return -1;
	}


	public int Type() {
		return Type(type,archive);
	}

	public static int Type(String stype) {
		for (int i=0;i<nippes.length;i++) {
			if (nippes[i].equalsIgnoreCase(stype)) {
				return i;
			}
		}
		return -1;
	}
	
	public Prometeo_Nippe(Frame pf,String appletType,String appletArchive,String appletCode,URL codebase, URL docbase) {
		super(pf,appletType,appletArchive,appletCode,codebase,docbase);
	}

	public Applet getApplet(AppletContext ac) {
		Applet A=getApplet(ac,false);
		A.init();
		return A;
	}
	public AbstractNippe getApplet(AppletContext ac,boolean inWeb) {
		AbstractNippe A=null;
		if (Type()==DESCARTES2) {
			A=new Descartes2();
		} else if (Type()==DESCARTES5) {
			A=new Descartes5();
		} else if (Type()==ARQUIMEDES) {
			A=new Arquimedes(parentFrame);
		} else if (Type()==ITEM) {
			A=new com.mja.descartes.Item(parentFrame);
		} else if (Type()==DESCARTESA) {
			A=new DescartesA();
		} else if (Type()==TABLAS) {
			A=new com.mos.tablas.tabla();
		} else if (Type()==PROMETEO) {
			A=new com.jla.nippe.Prometeo();
		}
		if (A!=null) {
			try {
				Hashtable ht=mjaHtml.getAppletParams(getAppletCode());
				A.setAppletContext(ac);
				A.setAppletParams(ht);
				A.setCodeBase(codebase);
				A.setDocBase(docbase);
				A.setInWeb(inWeb);
				A.setInNippeEditor(!inWeb);
				A.addActionListener(al);
				A.setSize(d);
				A.setBounds(0,0,d.width,d.height);
//				A.init();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		return A;
	}

}