/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.algebra;

import java.applet.Applet;
import com.mja.util.BasicStr;
import com.mja.lang.translator;

public class ANodeConfig {

	public static final int manual=0,auto=1;

	public int nextExercise=manual;
	public boolean usar_mcm=true;
	public boolean dividir_enteros=true;
	public boolean simplify_numerators=true;
	public boolean simplify_denominators=true;
	public boolean simplify_zero_one=true;
	public boolean simplify_minuses=false;
	boolean associateOnClick=true;
	boolean associateOnDoubleClick=true;
	boolean showResult=false;
	boolean showRule=true;
	private int decimales=2;

	public ANodeConfig(Applet A,int decimales) {
		this.decimales=decimales;
		paramContent=new String[paramName.length];
		for (int i=0;i<paramName.length;i++) {
			paramContent[i]=A.getParameter(paramName[i]);
			if (!BasicStr.hasContent(paramContent[i])) {
				paramContent[i]=paramDefault[i];
			}
		}
		applyANodeCfg();
	}
	
	void setDecimals(int d) {
		decimales=d;
	}
	
	int getDecimals() {
		return decimales;
	}

	public void applyANodeCfg() {
		nextExercise=("auto".equalsIgnoreCase(paramContent[ix_avance]))?auto:manual;
		usar_mcm=!"no".equalsIgnoreCase(paramContent[ix_usar_mcm]);
		simplify_zero_one=!"no".equalsIgnoreCase(paramContent[ix_simplificar_cerosyunos]);
		simplify_numerators=!"no".equalsIgnoreCase(paramContent[ix_simplificar_numeradores]);
		simplify_denominators=!"no".equalsIgnoreCase(paramContent[ix_simplificar_denominadores]);
		showResult=translator.isTrue(paramContent[ix_mostrar_resultado]);
		showRule=translator.isTrue(paramContent[ix_mostrar_regla]);
		associateOnClick=translator.isTrue(paramContent[ix_asociar_con_clic]);
		associateOnDoubleClick=translator.isTrue(paramContent[ix_asociar_con_doble_clic]);
	}

	static int ix_avance=0,
				ix_mostrar_resultado=1,
				ix_mostrar_regla=2,
				ix_asociar_con_clic=3,
				ix_asociar_con_doble_clic=4,
				ix_simplificar_cerosyunos=5,
//				ix_decimales=6,
				ix_usar_mcm=6,
				ix_simplificar_numeradores=7,
				ix_simplificar_denominadores=8;

	public static final String[] paramName = {
		"avance",					//(0) auto; manual,auto
		"mostrar_resultado",		//(1) no; no,s
		"mostrar_regla",			//(2) no; no,s
		"asociar_con_clic",			//(3) s; no,s
		"asociar_con_doble_clic",	//(4) s; no,s
		"simplificar_cerosyunos",	//(5) no; no,s
//		"decimales",				//(6) 2; 0,1,2,...
		"usar_mcm",					//(7) s; no,s
		"simplificar_numeradores",	//(8) no; no,s
		"simplificar_denominadores" //(9) no; no,s
	};

	public static final String[][] paramOptions = {
		{"manual","auto"},	//(0) avance
		{"no","s"},		//(1) mostrar_resultado
		{"no","si"},		//(2) mostrar_regla
		{"no","s"},		//(3) asociar_con_clic
		{"no","s"},		//(4) asociar_con_doble_clic
		{"no","s"},		//(5) simplificar_cerosyunos
//		{"0","1","2","3","4","5","6","7","8"},	//(6) decimales
		{"no","s"},		//(7) usar_mcm
		{"no","s"},		//(8) simplificar_numeradores
		{"no","s"} 		//(9) simplificar_denominadores
	};

	public static final String[] paramDefault = {
		"manual",//(0)
		"no",	//(1) mostrar_resultado
		"no",	//(2) mostrar_regla
		"s",	//(3) asociar_con_clic
		"no",	//(4) asociar_con_doble_clic
		"no",	//(5) simplificar_cerosyunos
//		"2",	//(6) decimales
		"s",	//(7) usar_mcm
		"no",	//(8) simplificar_numeradores
		"no"	//(9) simplificar_denominadores
	};

	public String[] paramContent;

	public String toAppletParams() {
		String s="";
		for (int i=0;i<paramName.length;i++) {
			if (!paramDefault[i].equals(paramContent[i])) {
				s+="   <param name=\""+paramName[i]+"\" value=\""+paramContent[i]+"\">\n";
			}
		}
		return s;
	}

}