/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.algebra;

import java.util.*;

import com.mja.algebra.*;
import com.mja.parser.Node_A;

public class ANode_AB extends ANode {

	public ANode_AB(ANode AN) {
		super(AN.N,AN.an_cfg);
	}

// 9  R binary, L arbitrary.		A op (B op C)
	Resultado perform_AB(Vector V) {
		ANode AN=null;
		String msg="A "+symbol+ "(A "+R.symbol+" C)";
		String cond="";
		if (R.isBinaryOperator()) {
			if (R.isSum()) {
				if (isSum()) {
					AN=Sum(Sum(L,R.L).performOperation(),R.R);
					//cond="AB";
					msg="A + (B + C) = (A + B) + C";
				} else if (isSub()) {
					AN=Sub(Sub(L,R.L).performOperation(),R.R);
					//cond="AB";
					msg="A - (B + C) = (A - B) - C";
				} else if (isMul()) {
					AN=Sum(Mul(L,R.L),Mul(L,R.R));
					//cond="AB";
					msg="A * (B + C) = (A * B) + (A * C)";
				} else if (isDiv()) {			// a / (A+B)
				} else if (isExp()) {
					AN=Mul(Exp(L,R.L),Exp(L,R.R));
					//cond="AB";
					msg="A ^ (B + C) = (A ^ B) + (A ^ C)";
				} else if (isRoot()) {			// a\ (A+B)
				} else if (isComp()) {			// a =? (A+B)
					if (isEqual()) {
						msg="(A = B + C) == (A - B = C)";
						AN=Equal(Sub(L,R.L),R.R);
						addResultado(V,AN,msg,cond);
						msg="(A = B + C) == (A - C = B)";
						AN=Equal(Sub(L,R.R),R.L);
						addResultado(V,AN,msg,cond);
						if (L.equals(R.L)) {
							msg="(A = A + B) == (0 = B)";
							AN=Equal(Num(0),R.R);
							addResultado(V,AN,msg,cond);
						} else if (L.equals(R.R)) {
							msg="(A = B + A) == (B = 0)";
							AN=Equal(Num(0),R.L);
							addResultado(V,AN,msg,cond);
						}
						AN=null;
					}
				}
			} else if (R.isSub()) {
				if (isSum()) {
					AN=Sub(Sum(L,R.L),R.R);
					//cond="AB";
					msg="A + (B - C) = (A + B) - C";
				} else if (isSub()) {
					AN=Sum(Sub(L,R.L),R.R);
					//cond="AB";
					msg="A - (B + C) = (A - B) - C";
				} else if (isMul()) {
					AN=Sub(Mul(L,R.L),Mul(L,R.R));
					//cond="AB";
					msg="A * (B - C) = (A * B) - (A * C)";
				} else if (isDiv()) {			// a / (A-B)
				} else if (isExp()) {
					AN=Div(Exp(L,R.L),Exp(L,R.R));
					//cond="AB";
					msg="A ^ (B - C) = (A ^ B) / (A ^ C)";
				} else if (isRoot()) {			// a \ (A-B)
				} else if (isComp()) {			// a =? (A-B)
					if (isEqual()) {
						msg="(A = B - C) == (A + C = B)";
						AN=Equal(Sum(L,R.R),R.L);
						addResultado(V,AN,msg,cond);
						msg="(A = B - C) == (A - B = -C)";
						AN=Equal(Sub(L,R.L),Minus(R.R));
						addResultado(V,AN,msg,cond);
						if (L.equals(R.L)) {
							msg="(A = A - B) == (0 = B)";
							AN=Equal(Num(0),Minus(R.R));
							addResultado(V,AN,msg,cond);
						}
						AN=null;
					}
				}
			} else if (R.isMul()) {
				if (isSum()) {		// a + (A*B)
					if (L.equals(R.L)) {
						AN=Mul(L,Sum(Num(1),R.R));
						//cond="AB";
						msg="A + (A * B) = A * (1 + B)";
					} else if (L.equals(R.R)) {
						if (R.L.isInteger()&&!L.isInteger()) {
							AN=Mul(Num(Sum(Num(1),R.L).N.Evaluate(0)),L);
							//cond="AB";
							msg="A + (m * A) = (1 + m) * A";
						} else {
							AN=Mul(L,Sum(R.L,Num(1)));
							//cond="AB";
							msg="A + (B * A) = (1 + B) * A";
						}
					}
				} else if (isSub()) {				// a - (A*B)
					if (L.equals(R.L)) {
						AN=Mul(L,Sub(Num(1),R.R));
						//cond="AB";
						msg="A - (A * B) = A * (1 - B)";
					} else if (L.equals(R.R)) {
						if (R.L.isInteger()&&!L.isInteger()) {
							AN=Mul(Num(Sub(Num(1),R.L).N.Evaluate(0)),L);
							//cond="AB";
							msg="A + (m * A) = (1 - m) * A";
						} else {
							AN=Mul(L,Sub(R.L,Num(1)));
							//cond="AB";
							msg="A - (B * A) = (1 - B) * A";
						}
					}
				} else if (isMul()) {
					AN=Mul(Mul(L,R.L).performOperation(),R.R);
					//cond="AB";
					msg="A * (B * C) = (A * B) * C";
				} else if (isDiv()) {
					if (L.equals(R.L)) {
						AN=(Div(Num(1),R.R));
						cond=" si A # 0";
						//cond="AB";
						msg="A / (A * B) = 1 / B";
					} else if (L.equals(R.R)) {
						AN=(Div(Num(1),R.L));
						cond=" si B # 0";
						//cond="AB";
						msg="B / (A * B) = 1 / A";
					} else {
						AN=Div(Div(L,R.L),R.R);
						//cond="AB";
						msg="A / (B * C) = (A / B) / C";
					}
				} else if (isExp()) {
					AN=Exp(Exp(L,R.L),R.R);
					//cond="AB";
					msg="A ^ (B * C) =  (A ^ B) ^ C";
				} else if (isRoot()) {
					AN=Mul(Root(L,R.L),Root(L,R.R));
					//cond="AB";
					msg="A \\ (B * C) = (A \\ B) * (A \\ C)";
				} else if (isComp()) {				// a =? (A*B)
					if (isEqual()) {
						AN=Equal(Div(L,R.L),R.R);
						msg="(A = B * C) == (A / B = C)";
						addResultado(V,AN,msg,cond);
						AN=Equal(Div(L,R.R),R.L);
						msg="(A = B * C) == (A / C = B)";
						addResultado(V,AN,msg,cond);
						AN=null;
					}
				}
			} else if (R.isDiv()) {
				if (isSum()) {
					ANode M=Mul(L,R.R);
					if (an_cfg.simplify_numerators) {
						M=new ANode(Node_A.Multiply(M.N,true,false),an_cfg);
					}
					AN=Sum(Div(M,R.R),Div(R.L,R.R));
//					AN=Div(Sum(M,R.L),R.R);
					//cond="AB";
					msg="A + (B / C) = (A * C) / C + (B / C)";
				} else if (isSub()) {
					ANode M=Mul(L,R.R);
					if (an_cfg.simplify_numerators) {
						M=new ANode(Node_A.Multiply(M.N,true,false),an_cfg);
					}
					AN=Sub(Div(M,R.R),Div(R.L,R.R));
//					AN=Div(Sub(M,R.L),R.R);
					//cond="AB";
					msg="A - (B / C) = (A * C) / C - (B / C)";
				} else if (isMul()) {
					AN=Div(Mul(L,R.L),R.R);
					//cond="AB";
					msg="A * (B / C) = (A * B) / C";
				} else if (isDiv()) {
					AN=Div(Mul(L,R.R),R.L);
					//cond="AB";
					msg="A / (B / C) = (A * C) / B";
				} else if (isExp()) {				// a ^ (A/B)
					if (R.L.equals(Num(1))) {
						AN=Root(R.R,L);				//
						//cond="AB";
						msg="A ^ (1 / B) = B \\ A";
					} else {
						AN=Root(R.R,Exp(L,R.L));			// este es el resultado feo??rootB(a^A)
						cond="ABfeo";
						msg="A ^ (B / C) = C \\ (A ^ B)";
					}
				} else if (isRoot()) {
					AN=Div(Root(L,R.L),Root(L,R.R));
					//cond="AB";
					msg="A \\ (B / C) = (A \\ B) / (A\\ C)";
				} else if (isComp()) {				// a =? (A/B)
					if (isEqual()) {
						msg="(A = B / C) == (A * C = B)";
						AN=Equal(Mul(L,R.R),R.L);
						addResultado(V,AN,msg,cond);
						msg="(A = B / C) == (C = B / A)";
						AN=Equal(R.R,Div(R.R,L));
						addResultado(V,AN,msg,cond);
						msg="(A = B / C) == (A / B = 1 / C)";
						AN=Equal(Div(L,R.L),Div(Num(1),R.R));
						addResultado(V,AN,msg,cond);
						AN=null;
					}
				}
			} else if (R.isExp()) {
				if (isSum()) {				// a + (A^B)
					if (L.equals(R.L)) {
						AN=Mul(L,Sum(Num(1),Exp(L,Sub(R.R,Num(1)))));
						//cond="AB";
						msg="A + (A ^ B) = A * (1 + A ^(B - 1))";
					}
				} else if (isSub()) {				// a - (A^B)
					if (L.equals(R.L)) {
						AN=Mul(L,Sub(Num(1),Exp(L,Sub(R.R,Num(1)))));
						//cond="AB";
						msg="A - (A ^ B) = A * (1 - A ^(B - 1))";
					}
				} else if (isMul()) {				// a * (A^B)
					if (L.equals(R.L)) {
						AN=Exp(L,Sum(Num(1),R.R));
						//cond="AB";
						msg="A * (A ^ B) = A ^(1 + B)";
					}
				} else if (isDiv()) {				// a / (A^B)
					if (L.equals(R.L)) {
						AN=Exp(L,Sub(Num(1),R.R));
						//cond="AB";
						msg="A / (A ^ B) = A ^ (1 - B))";	//otro posible resultado es 1/a^(B-1)
					}
				} else if (isExp()) {			// a ^ (A^B)
				} else if (isRoot()) {
					if (R.isExp()) {
						if (L.equals(Num(2))&& R.R.equals(Num(2))) {
							AN=Abs(R.L).performOperation();
							//cond="AB";
							msg="2 \\ (A ^ 2) = | A |";
						} else {
							AN=Exp(R.L,Div(R.R,L));
							//cond="AB";
							msg="A \\ (B ^ C) = B ^ (C / A)";
						}
// estas se repiten	} else {
//						AN=Exp(R.L,Div(R.R,L));		// resultado A^(B/a)
					}
				} else if (isComp()) {			// a =? (A^B)
				}
			} else if (R.isRoot()) {
				if (isSum()) {		// a + (A\B	)	// OJO:pendiente
				} else if (isSub()) {		// a - (A\B)		// OJO:pendiente
				} else if (isMul()) {		// a * (A\B)		//OJO: pendiente
				} else if (isDiv()) {		// a / (A\B)		//OJO: pendiente
				} else if (isExp()) {		// a ^ (A\B)
				} else if (isRoot()) {
					AN=Root(Mul(L,R.L),R.R);
					//cond="AB";
					msg="A \\ (B \\ C) = (A * B) \\ C";
				} else if (isComp()) {		// a =? (A\B)
				}
			} else if (R.isComp()) {				//OJO:return this sin meter casos (pendiente de codificar)
				if (isSum()) {
				} else if (isSub()) {
				} else if (isMul()) {
				} else if (isDiv()) {
				} else if (isExp()) {
				} else if (isRoot()) {
				} else if (isComp()) {
				}
			}
		}
		if (AN!=null) {
			return new Resultado(AN,msg,cond);
		}
		return null;
	}

}