/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.algebra;

import java.util.*;
import com.mja.parser.Node;
import com.mja.parser.Node_A;

public class ANode_BB extends ANode {


	public ANode_BB(ANode AN) {
		super(AN.N,AN.an_cfg);
	}


/* ----------------------- Operations with Fractions ------------------- */

	private void addFractions(Vector V,String os) {
		String msg="";
		String cond="";
		if (!L.isDiv()) {
			L=Div(L,Num(1));
		}
		if (!R.isDiv()) {
			R=Div(R,Num(1));
		}
		ANode AN=this;
		if (L.R.equals(R.R)) { // hay denominador comn
			if (os.equals("+")) {
				msg="(A / C) + (B / C) = (A + B) / C";
				AN=Div(Sum(L.L,R.L),L.R);
			} else if (os.equals("-")) {
				msg="(A / C) - (B / C) = (A - B) / C";
				AN=Div(Sub(L.L,R.L),L.R);
			}
			addResultado(V,AN,msg,cond);
		}
		ANode A=null,B=null,D=null;
		if (an_cfg.usar_mcm && L.R.isInteger() && R.R.isInteger()) {
			msg="(A / (m*C)) "+os+" (B / (n*C)) = (n*A)/C "+os+" (m*B)/C";
			int mcm=minCommonMultiple((int)Math.round(L.R.value), (int) Math.round(R.R.value));
			A=Mul(L.L,Num(mcm/L.R.value));
			B=Mul(Num(mcm/R.R.value),R.L);
			D=Num(mcm);
		} else {
			msg="(A / B) "+os+"(C / D) = ((A*D)/(B*D)) "+os+"((B*C)/(B*D))";
			A=Mul(L.L,R.R);
			B=Mul(L.R,R.L);
			D=Mul(L.R,R.R);
			if (an_cfg.simplify_denominators) {
				D=new ANode(Node_A.Multiply(D.N,true,false),an_cfg);
			}
		}
		if (an_cfg.simplify_numerators) {
			A=new ANode(Node_A.Multiply(A.N,true,false),an_cfg);
			B=new ANode(Node_A.Multiply(B.N,true,false),an_cfg);
		}
		if (os.equals("+")) {
			AN=Sum(Div(A,D),Div(B,D));
		} else {
			AN=Sub(Div(A,D),Div(B,D));
		}
		if (an_cfg.simplify_zero_one) {
			AN=new ANode(Node_A.eliminateUnnecessaryZerosAndOnes(AN.N,true),an_cfg);
		}
		addResultado(V,AN,msg,cond);
	}

	Resultado perform_BB(Vector V) {
		String msg="(A "+L.symbol+" B) "+symbol+ " (C "+R.symbol+" D)";
		String cond="";
		ANode AN=null;
		if (R.isSum()) {
			if (L.isSum()) { 				// (a + b) op (c + d)
				if (isSum()) {  			// (a + b) + (c + d)  	OJO 9 y 10 dan  ((a+b)+c)+d  y  a+(b+(c+d)) falta a+(b+c)+d y (c+d)+(a+b) alcanzables?
				} else if (isSub()) {		// (a + b) - (c + d)  	OJO 9 y 10 dan  ((a+b)-c)-d   y  a+(b-(c+d))		(a+b)+(-c-d) o (a+b)+(-c+(-d)) y caer en caso anterior?
				} else if (isMul()) {		// (a + b) * (c + d)  	OJO contemplados en 9 y 10
				} else if (isDiv()) {		// (a + b) / (c + d) 	OJO 10 da   a/(c+d) + b/(c+d)
				} else if (isExp()) {		// (a + b) ^ (c + d) 	OJO 9 da   (a+b)^c * (a+b)^d
				} else if (isRoot()) {		// (a + b) \ (c + d)  	OJO nada?
				} else if (isComp()) {		// (a + b) = (c + d)
					if (L.R.equals(R.R)) {
						msg="A + C = B + C == A = B";
						AN=Equal(L.L,R.L);
					} else if (L.R.equals(R.L)) {
						msg="A + B = B + C == A = C";
						AN=Equal(L.L,R.R);
					} else if (L.L.equals(R.L)) {
						msg="A + B = A + C == B = C";
						AN=Equal(L.R,R.R);
					} else if (L.L.equals(R.R)) {
						msg="A + B = C + A == B = C";
						AN=Equal(L.R,R.L);
					}
				}
			} else if (L.isSub()) { 		// (a - b) op (c + d)
				if (isSum()) {  			// (a - b) + (c + d)  	OJO 9 y 10 dan  ((a-b)+c)+d  y  a-(b-(c+d))
				} else if (isSub()) {		// (a - b) - (c + d)  	OJO: 9 y 10 dan  ((a-b)-c)-d  y  a-(b+(c+d))    (a-b)+(-c-d) o (a-b)+(-c+(-d)) y caer en el caso anterior?
				} else if (isMul()) {		// (a - b) * (c + d) 	OJO: contemplados en 9 y 10
				} else if (isDiv()) {		// (a - b) / (c + d) 	OJO 10 da   a/(c+d) - b/(c+d)
				} else if (isExp()) {		// (a - b) ^ (c + d) 	OJO:9 da   (a-b)^c * (a-b)^d
				} else if (isRoot()) {		// (a - b) \ (c + d) 	OJO: nada
				} else if (isComp()) {		// (a - b) =? (c + d)
					if (L.L.equals(R.L)) {
						msg="A - B = A + C == -B = C";
						AN=Equal(Minus(L.R),R.R);
					} else if (L.L.equals(R.R)) {
						msg="A - B = C + A == -B = C";
						AN=Equal(Minus(L.R),R.L);
					}
				}
			} else if (L.isMul()) { 		// (a * b) op (c + d)
				if (isSum()) {  		// (a * b) + (c + d)  	OJO: como no sean factores ...
				} else if (isSub()) {		// (a * b) - (c + d)  	 OJO: como no sean factores ...
				} else if (isMul()) {		// (a * b) * (c + d) 	 OJO  9 y 10 dan 	(a*b)*c+(a*b)*d    y  	a*(b*(c+d))
				} else if (isDiv()) {		// (a * b) / (c + d)  	OJO  ver propuesta en 10
				} else if (isExp()) {		// (a * b) ^ (c + d) 	OJO: 9 y 10 dan 	(a*b)^c * (a*b)^d   y	a^(c+d) * b^(c+d)
				} else if (isRoot()) {		// (a * b) \ (c + d)  	OJO nada?
				} else if (isComp()) {		// (a + b) =? (c + d)
				}
			} else if (L.isDiv()) { 		// (a / b) op (c + d)
				if (isSum()) {  		// (a / b) + (c + d)  	OJO: 9 y 10 dan	(a/b + c) +d          y  	a/b + (b*(c+d))/b
				} else if (isSub()) {		// (a / b) - (c + d)  	OJO: 9 y 10 dan 	(a/b - c) -d          y  	a/b - (b*(c+d))/b
				} else if (isMul()) {		// (a / b) * (c + d) 	OJO  9 y 10 dan 	(a/b)*c+(a/b)*d    y  	a*(c+d)/b
				} else if (isDiv()) {		// (a / b) / (c + d)  	OJO  10 da	a/(b*(c+d))
				} else if (isExp()) {		// (a / b) ^ (c + d) 	OJO 9 y 10 dan	(a/b)^c * (a/b)^d   y  	a^(c+d) / b^(c+d)
				} else if (isRoot()) {		// (a / b) \ (c + d)  	OJO: 10 da 	(c+d)^(b/a)
				} else if (isComp()) {		// (a /b) =? (c + d)
				}
			} else if (L.isExp()) { 		// (a ^ b) op (c + d)
				if (isSum()) {  		// (a ^ b) + (c + d)  		OJO: 9  da	(a^b + c) +d
				} else if (isSub()) {		// (a ^ b) - (c + d)  	OJO: 9  da 	(a^b + c) +d
				} else if (isMul()) {		// (a ^ b) * (c + d) 	OJO  9  da	(a^b)*c+(a^b)*d
				} else if (isDiv()) {		// (a ^ b) / (c + d)
				} else if (isExp()) {		// (a ^ b) ^ (c + d) 	OJO 9  da (a^b)^c * (a^b)^d   falta a^(b*(c+d))  ?????
				} else if (isRoot()) {		// (a ^ b) \ (c + d)
				} else if (isComp()) {		// (a ^ b) =? (c + d)
				}
			} else if (L.isRoot()) { 		// (a \ b) op (c + d)
				if (isSum()) {  		// (a \b) + (c + d)  		OJO: 9  da	(a\b + c) +d
				} else if (isSub()) {		// (a \ b) - (c + d)  	OJO: 9  da 	(a\b - c) -d
				} else if (isMul()) {		// (a \ b) * (c + d) 	OJO  9  da 	(a\b)*c+(a\b)*d
				} else if (isDiv()) {		// (a \ b) / (c + d)
				} else if (isExp()) {		// (a \ b) ^ (c + d) 	OJO 9 da		(a/b)^c * (a/b)^d   falta b^((c+d)/a)
				} else if (isRoot()) {		// (a \ b) \ (c + d)
				} else if (isComp()) {		// (a \ b) =? (c + d)
				}
			}
		} else if (R.isSub()) {
			if (L.isSum()) {				// (a + b) op (c - d)
				if (isSum()) {  		// (a + b) + (c - d)  		OJO: 9 y 10 dan 	((a+b)+c)-d          y 	a+(b+(c-d))
				} else if (isSub()) {		// (a + b) - (c - d)	OJO: 9 y 10 dan 	((a+b)-c)+d          y  	a+(b-(c-d))
				} else if (isMul()) {		// (a + b) * (c - d)	OJO: 9 y 10 dan 	(a+b)*c-(a+b)*d   y   	a*(c-d) + b*(c-d)
				} else if (isDiv()) {		// (a + b) / (c - d)	OJO: 10 da	 a/(c-d) +b/(c-d)
				} else if (isExp()) {		// (a + b) ^ (c - d)	OJO: 9 da 	(a+b)^c / (a+b)^d
				} else if (isRoot()) {		// (a + b) \ (c - d)
				} else if (isComp()) {		// (a + b) =? (c - d)
					if (L.L.equals(R.L)) {
						msg="A + B = A - C == B = -C";
						AN=Equal(L.R,Minus(R.R));
					} else if (L.R.equals(R.L)) {
						msg="A + B = B - C == A = -C";
						AN=Equal(L.L,Minus(R.R));
					}
				}
			} else if (L.isSub()) { 		// (a - b) op (c - d)
				if (isSum()) {  		// (a - b) + (c - d)  		OJO 9 y 10 dan  ((a-b)+c)-d  y  a-(b-(c-d))
				} else if (isSub()) {		// (a - b) - (c - d)  	OJO: 9 y 10 dan  ((a-b)-c)+d  y  a-(b+(c-d))    (a-b)+(-c+d) o (a-b)+(-c+d) y caer en el caso anterior?
				} else if (isMul()) {		// (a - b) * (c - d) 	OJO: contemplados en 9 y 10
				} else if (isDiv()) {		// (a - b) / (c - d) 	OJO 10 da   a/(c-d) - b/(c-d)
				} else if (isExp()) {		// (a - b) ^ (c - d) 	OJO:9 da   (a-b)^c / (a-b)^d
				} else if (isRoot()) {		// (a - b) \ (c - d) 	OJO nada
				} else if (isComp()) {		// (a - b) =? (c - d)
					if (L.R.equals(R.R)) {
						msg="A - C = B - C == A = B";
						AN=Equal(L.L,R.L);
					} else if (L.L.equals(R.L)) {
						msg="A - B = A - C == -B = -C";
						AN=Equal(Minus(L.R),Minus(R.R));
					}
				}
			} else if (L.isMul()) { 		// (a * b) op (c - d)
				if (isSum()) {  		// (a * b) + (c - d)  		OJO: como no sean factores ...
				} else if (isSub()) {		// (a * b) - (c - d)  	OJO: como no sean factores ...
				} else if (isMul()) {		// (a * b) * (c - d) 	OJO  9 y 10 dan 	(a*b)*c-(a*b)*d     y  	a*(b*(c-d))
				} else if (isDiv()) {		// (a * b) / (c - d)  	OJO  ver propuesta en 10
				} else if (isExp()) {		// (a * b) ^ (c - d) 	OJO: 9 y 10 dan  	(a*b)^c / (a*b)^d   y	a^(c-d) * b^(c-d)
				} else if (isRoot()) {		// (a * b) \ (c - d)  	OJO nada?
				} else if (isComp()) {		// (a + b) =? (c - d)
				}
			} else if (L.isDiv()) { 		// (a / b) op (c - d)
				if (isSum()) {  		// (a / b) + (c - d)  		OJO: 9 y 10 dan	(a/b + c) -d          y  	a/b + (b*(c-d))/b
				} else if (isSub()) {		// (a / b) - (c - d)  	OJO: 9 y 10 dan 	(a/b - c) +d          y  	a/b + (b*(c-d))/b
				} else if (isMul()) {		// (a / b) * (c - d) 	OJO  9 y 10 dan 	(a/b)*c-(a/b)*d    y  	a*(c-d)/b
				} else if (isDiv()) {		// (a / b) / (c - d)  	OJO  10 da	a/(b*(c-d))
				} else if (isExp()) {		// (a / b) ^ (c - d) 	OJO 9 y 10 dan	(a/b)^c / (a/b)^d   y  	a^(c-d) / b^(c-d)
				} else if (isRoot()) {		// (a / b) \ (c - d)  	OJO: 10 da 	(c-d)^(b/a)
				} else if (isComp()) {		// (a /b) =? (c - d)
				}
			} else if (L.isExp()) { 		// (a ^ b) op (c - d)
				if (isSum()) {  		// (a ^ b) + (c - d)  		OJO: 9  da	(a^b + c) -d
				} else if (isSub()) {		// (a ^ b) - (c - d)  	OJO: 9  da 	(a^b + c) -d
				} else if (isMul()) {		// (a ^ b) * (c - d) 	OJO  9  da	(a^b)*c-(a^b)*d
				} else if (isDiv()) {		// (a ^ b) / (c - d)
				} else if (isExp()) {		// (a ^ b) ^ (c - d) 	OJO 9  da		(a^b)^c / (a^b)^d   falta a^(b*(c-d))  ?????
				} else if (isRoot()) {		// (a ^ b) \ (c - d)
				} else if (isComp()) {		// (a ^ b) =? (c - d)
				}
			} else if (L.isRoot()) { 		// (a \ b) op (c - d)
				if (isSum()) {  		// (a \b) + (c - d)  		OJO: 9  da	(a\b + c) -d
				} else if (isSub()) {		// (a \ b) - (c - d)  	OJO: 9  da 	(a\b - c) +d
				} else if (isMul()) {		// (a \ b) * (c - d) 	OJO  9  da 	(a\b)*c-(a\b)*d
				} else if (isDiv()) {		// (a \ b) / (c - d)
				} else if (isExp()) {		// (a \ b) ^ (c - d) 	OJO 9 da		(a/b)^c / (a/b)^d   falta b^((c-d)/a)
				} else if (isRoot()) {		// (a \ b) \ (c - d)
				} else if (isComp()) {		// (a \ b) =? (c - d)
				}			}
		} else if (R.isMul()) {
			if (L.isSum()) { 				// (a + b) op (c * d)
				if (isSum()) {  		// (a + b) + (c * d)  		OJO: como no sean factores ...
				} else if (isSub()) {		// (a + b) - (c * d)  	OJO: como no sean factores ...
				} else if (isMul()) {		// (a + b) * (c * d) 	OJO  9 y 10 dan 	((a+b)*c)+d   y	a*(c*d)+b*(c*d)
				} else if (isDiv()) {		// (a + b) / (c * d)  	OJO  ver propuesta en 10
				} else if (isExp()) {		// (a + b) ^ (c * d) 	OJO: 9  da 	((a+b)^c)^d
				} else if (isRoot()) {		// (a + b) \ (c * d)  	OJO: 9 da 	(a+b)\c  * (a+b)\d
				} else if (isComp()) {		// (a + b) =? (c * d)
				}
			} else if (L.isSub()) { 		// (a - b) op (c * d)
				if (isSum()) {  		// (a - b) + (c * d)  		OJO: como no sean factores ...
				} else if (isSub()) {		// (a - b) - (c * d)  	OJO: como no sean factores ...
				} else if (isMul()) {		// (a - b) * (c * d) 	OJO  9 y 10 dan 	((a-b)*c)+d   y	a*(c*d)-b*(c*d)
				} else if (isDiv()) {		// (a - b) / (c * d)  	OJO  ver propuesta en 10
				} else if (isExp()) {		// (a - b) ^ (c * d) 	OJO: 9  da 	((a-b)^c)^d
				} else if (isRoot()) {		// (a - b) \ (c * d)  	OJO: 9 da 	(a-b)\c  * (a-b)\d
				} else if (isComp()) {		// (a - b) =? (c * d)
				}
			} else if (L.isMul()) { 		// (a * b) op (c * d)
				if (isSum()) {  			// (a * b) + (c * d)
					if (L.R.equals(R.R)) {
						if (L.L.isInteger()&&R.L.isInteger()&&!L.R.isInteger()) {
							AN=Mul(Num(Sum(L.L,R.L).N.Evaluate(0)),L.R);
							//cond="BB";
							msg=" m * A + n * A = k * A";
						} else {
							AN=Mul(Sum(L.L,R.L),L.R);
							//cond="BB";
							msg="(A * B) + (C * B) = (A + C) * B";
						}
						addResultado(V,AN,msg,cond);
					} 
					if (L.L.equals(R.L))  {	// (a * b) + (a * d)
						AN=Mul(L.L,Sum(L.R,R.R));	// a * (b + d)
						//cond="BB";
						msg="(A * B) + (A * C) = A * (B + C)";
						addResultado(V,AN,msg,cond);
					} 
					if (L.R.equals(R.L)) {
						AN=Mul(Sum(L.L,R.R),L.R);
						//cond="BB";
						msg="(A * B) + (B * C) = (A + C) * B";
						addResultado(V,AN,msg,cond);
					} 
					if (L.L.equals(R.R)) {
						AN=Mul(L.L,Sum(L.R,R.L));
						//cond="BB";
						msg="(A * B) + (C * A) = A * (B + C)";
						addResultado(V,AN,msg,cond);
					}
					AN=null;
				} else if (isSub()) {		// (a * b) - (c * d)
					if (L.R.equals(R.R)) {
						if (L.L.isInteger()&&R.L.isInteger()&&!L.R.isInteger()) {
							double r=Sub(L.L,R.L).N.Evaluate(0);
//							double r=L.L.N.Evaluate(0)-R.L.N.Evaluate(0);
							if (r==0) {
								AN=Num(0);
								//cond="BB";
								msg=" m * A - m * A = 0";
							} else if (r==1) {
								AN=L.R;
								//cond="BB";
								msg=" (m+1) * A - m * A = A";
							} else if (r==-1) {
								AN=Minus(L.R);
								//cond="BB";
								msg=" m * A - (m+1) * A = -A";
							} else {
								AN=Mul(Num(r),L.R);
								//cond="BB";
								msg=" m * A - n * A = k * A";
							}
						} else {
							AN=Mul(Sub(L.L,R.L),L.R);
							//cond="BB";
							msg="(A * B) - (C * B) = (A - C) * B";
						}
						addResultado(V,AN,msg,cond);
					} 
					if (L.L.equals(R.L))  {
						AN=Mul(L.L,Sub(L.R,R.R));
						//cond="BB";
						msg="(A * B) - (A * C) = A * (B - C)";
						addResultado(V,AN,msg,cond);
					} 
					if (L.R.equals(R.L)) {
						AN=Mul(Sub(L.L,R.R),L.R);
						//cond="BB";
						msg="(A * B) - (B * C) = (A - C) * B";						;
						addResultado(V,AN,msg,cond);
					} 
					if (L.L.equals(R.R)) {
						AN=Mul(L.L,Sub(L.R,R.L));
						//cond="BB";
						msg="(A * B) - (C * A) = A * (B - C)";
						addResultado(V,AN,msg,cond);
					}
					AN=null;
				} else if (isMul()) {		// (a * b) * (c * d)	OJO: 9 y 10 dan 	((a*b)*c)*d     y 	a*(b*(c*d))
					if (L.L.isNumber() && !L.R.isNumber()) {
						if (R.L.isNumber()  && !R.R.isNumber()) {
							if(L.R.equals(R.R))	{
								AN=Mul(Mul(L.L,R.L).performOperation().performOperation(),Exp(L.R,Num(2)));
								//cond="BB";
								msg="(n * A) + (m * A) = (n*m) * (A^2)";
							} else {
								AN=Mul(Mul(L.L,R.L).performOperation().performOperation(),Mul(L.R,R.R));
								//cond="BB";
								msg="(n * A) + (m * B) = (n*m) * A * B ";								;
							}

						} else if (R.R.isNumber() && !R.L.isNumber()) {
							if(L.R.equals(R.L))	{
								AN=Mul(Mul(L.L,R.R).performOperation().performOperation(),Exp(L.R,Num(2)));
								//cond="BB";
								msg="(n * A) + (A * m) = (n*m) * (A^2)";
							} else {
								AN=Mul(Mul(L.L,R.R).performOperation().performOperation(),Mul(L.R,R.L));
								//cond="BB";
								msg="(n * A) + (B * m) = (n*m) * A * B ";
							}
						}

					} else if (L.R.isNumber() && !L.L.isNumber()) {
						if (R.L.isNumber() && !R.R.isNumber()) {
							if(L.L.equals(R.R))	{
								AN=Mul(Mul(L.R,R.L).performOperation().performOperation(),Exp(L.L,Num(2)));
								//cond="BB";
								msg="(A * n) + (m * A) = (n*m) * (A^2)";
							} else {
								AN=Mul(Mul(L.R,R.L).performOperation().performOperation(),Mul(L.L,R.R));
								//cond="BB";
								msg="(A * n) + (m * B) = (n*m) * A * B ";
							}
						} else if (R.R.isNumber()) {
							if(L.L.equals(R.L))	{
								AN=Mul(Mul(L.R,R.R).performOperation().performOperation(),Exp(L.L,Num(2)));
								//cond="BB";
								msg="(A * n) + (A * m) = (n*m) * (A^2)";
							} else {
								AN=Mul(Mul(L.R,R.R).performOperation(),Mul(L.L,R.L));
								//cond="BB";
								msg="(A * n) + (B * m) = (n*m) * A * B ";
							}
						}
					}
				} else if (isDiv()) {		// (a * b) / (c * d)
					if (L.R.equals(R.R)) {
						AN=Div(L.L,R.L);
						cond= "si B # 0";
						//cond="BB";
						msg="(A * B) / (C * B) = A / C";
					} else if (L.R.equals(R.L)) {
						AN=Div(L.L,R.R);
						cond= "si B # 0";
						//cond="BB";
						msg="(A * B) / (B * C) = A / C";
					} else if (L.L.equals(R.L)) {
						AN=Div(L.R,R.R);
						cond= "si A # 0";
						//cond="BB";
						msg="(A * B) / (A * C) = B / C";
					} else if (L.L.equals(R.R)) {
						AN=Div(L.R,R.L);
						cond= "si A # 0";
						//cond="BB";
						msg="(A * B) / (C * A) = B / C";
					}
				} else if (isExp()) {		// (a * b) ^ (c * d)	OJO: 9 y 10 dan 	((a*b)^c)^d     y 	a^(c*d) * b^(c*d)

				} else if (isRoot()) {		// (a * b) \ (c * d) 	OJO: 9  da 	(a*b)\c * (a*b)\d   y	ver nota correspondiente de 10
				} else if (isComp()) {		// (a * b) =? (c * d)
					if (L.L.equals(R.L)) {
						msg="A * B = A * C == B = C";
						cond= "si A # 0";
						AN=Equal(L.R,R.R);
					} else if (L.L.equals(R.R)) {
						msg="A * B == C * A == B = C";
						cond= "si A # 0";
						AN=Equal(L.R,R.L);
					} else if (L.R.equals(R.R)) {
						msg="A * B == C * B == A = C";
						cond= "si B # 0";
						AN=Equal(L.L,R.L);
					} else if (L.R.equals(R.L)) {
						msg="A * B == B * C == A = C";
						cond= "si B # 0";
						AN=Equal(L.L,R.R);
					}
				}
			} else if (L.isDiv()) { 		// (a / b) op (c * d)
				if (isSum()) {  		// (a / b) + (c * d)	OJO: faltaran casos de factorizacin por ej a=c  d
				} else if (isSub()) {		// (a / b) - (c * d)	OJO: faltaran casos de factorizacin
				} else if (isMul()) {		// (a / b) * (c * d)	OJO: 9 y 10 dan 	((a/b)*c)*d     y 	(a*(c*d))/b
				} else if (isDiv()) {		// (a / b) / (c * d)	OJO: 9 y 10 dan	 ((a/b)/c) /d    y 	a/(b*(c*d)) y faltarian casos de cancelacin
				} else if (isExp()) {		// (a / b) ^ (c * d)	OJO: 9 y 10 dan 	((a/b)^c)^d     y 	a^(c*d) / b^(c*d)
				} else if (isRoot()) {		// (a / b) \ (c * d) 	OJO: 9  y 10 dan 	(a/b)\c * (a/b)\d   y	(c * d) ^(b / a)
				} else if (isComp()) {		// (a / b) =? (c * d)
				}
			} else if (L.isExp()) { 		// (a ^ b) op (c * d)
				if (isSum()) {  		// (a ^ b) + (c * d)	OJO: faltaran casos de factorizacin por ej a=c  d
				} else if (isSub()) {		// (a ^ b) - (c * d)	OJO: faltaran casos de factorizacin
				} else if (isMul()) {		// (a ^ b) * (c * d)	OJO: 9  da 	((a^b)*c)*d
				} else if (isDiv()) {		// (a ^ b) / (c * d)	OJO: 9  da	 ((a^b)/c) /d
				} else if (isExp()) {		// (a ^ b) ^ (c * d)	OJO: 9  da 	((a^b)^c)^d    	faltara a^(b*(c*d))
				} else if (isRoot()) {		// (a ^ b) \ (c * d) 	OJO: 9  da 	(a^b)\c * (a^b)\d
				} else if (isComp()) {		// (a ^ b) =? (c * d)
				}
			} else if (L.isRoot()) { 		// (a \ b) op (c * d)
				if (isSum()) {  		// (a \b) + (c * d)
				} else if (isSub()) {		// (a \ b) - (c * d)
				} else if (isMul()) {		// (a \ b) * (c * d) 	OJO  9  da 	((a\b)*c)*d
				} else if (isDiv()) {		// (a \ b) / (c * d)  	OJO  9 da 	((a\b)/c) /d
				} else if (isExp()) {		// (a \ b) ^ (c * d) 	OJO 9 da		(a/b)^c / (a/b)^d   falta b^((c-d)/a)
				} else if (isRoot()) {		// (a \ b) \ (c * d)  	OJO: 9  da 	(a\b)\c * (a\b)\d
				} else if (isComp()) {		// (a \ b) =? (c * d)
				}
			}
		} else if (R.isDiv()) {
			if (L.isSum()) {				// (a + b) op (c / d)
				if (isSum()) {  		// (a + b) + (c / d)  	OJO: 9 da 	((a+b)*d) +c)/d
				} else if (isSub()) {		// (a + b) - (c / d)  	OJO: 9 da 	((a+b)*d) -c)/d
				} else if (isMul()) {		// (a + b) * (c / d) 	OJO  9 y 10 dan 	((a+b)*c)/d   y	a*(c/d)+b*(c/d)
				} else if (isDiv()) {		// (a + b) / (c / d)  	OJO  9 y 10 dan 	(a+b)*d/c     y	a/(c/d) +b/(c/d)
				} else if (isExp()) {		// (a + b) ^ (c / d) 	OJO: 9  da 	rootd ((a+b)^c)
				} else if (isRoot()) {		// (a + b) \ (c / d)  	OJO: 9  da	(a+b)\c / (a+b)\d
				} else if (isComp()) {		// (a + b) =? (c / d)
				}
			} else if (L.isSub()) { 		// (a - b) op (c / d)
				if (isSum()) {  		// (a - b) + (c / d)  	OJO: 9 da 	((a-b)*d) +c)/d
				} else if (isSub()) {		// (a - b) - (c / d)  	OJO: 9 da 	((a-b)*d) -c)/d
				} else if (isMul()) {		// (a - b) * (c / d) 	OJO  9 y 10 dan 	((a-b)*c)/d   y	a*(c/d)-b*(c/d)
				} else if (isDiv()) {		// (a - b) / (c / d)  	OJO  9 y 10 dan 	(a-b)*d/c     y	a/(c/d) -b/(c/d)
				} else if (isExp()) {		// (a - b) ^ (c / d) 	OJO: 9  da 	rootd ((a-b)^c)
				} else if (isRoot()) {		// (a - b) \ (c / d)  	OJO: 9  da	(a-b)\c / (a-b)\d
				} else if (isComp()) {		// (a - b) =? (c / d)
				}
			} else if (L.isMul()) { 		// (a * b) op (c / d)
				if (isSum()) {  		// (a * b) + (c / d)  	OJO: 9 da 	((a*b)*d) +c)/d
				} else if (isSub()) {		// (a * b) - (c / d)  	OJO: 9 da 	((a*b)*d) -c)/d
				} else if (isMul()) {		// (a * b) * (c / d) 	OJO  9 y 10 dan 	((a*b)*c)/d   y	a*(b*(c/d))
				} else if (isDiv()) {		// (a * b) / (c / d)  	OJO  9 da 	(a*b)*d/c     y	ver nota en10
				} else if (isExp()) {		// (a * b) ^ (c / d) 	OJO: 9  y 10 dan 	rootd ((a*b)^c)    y	a^(c/d) * b^(c/d)
				} else if (isRoot()) {		// (a * b) \ (c / d)  	OJO: 9  da	(a*b)\c / (a*b)\d   y ver nota en 10
				} else if (isComp()) {		// (a * b) =? (c / d)
				}
			} else if (L.isDiv()) { 		// (a / b) op (c / d)
				if (isSum()) {  			// (a / b) + (c / d)
					addFractions(V,"+");
				} else if (isSub()) {		// (a / b) - (c / d)
					addFractions(V,"-");
				} else if (isMul()) {				// (a / b) * (c / d)
					if (L.L.equals(R.R)) {			// (a / b) * (c / a)
						AN=Div(R.L,L.R);
						//cond="BB";
						msg="(A / B) * (C / A) = C / B";
						addResultado(V,AN,msg,cond);
					} else if (L.R.equals(R.L)) {
						AN=Div(L.L,R.R);
						//cond="BB";
						msg="(A / B) * (B / C) = A / C";
						addResultado(V,AN,msg,cond);
					}
					AN=Div(Mul(L.L,R.L),Mul(L.R,R.R));
					//cond="BB";
					msg="(A / B) * (C / D) = (A * C) / (B * D)";
				} else if (isDiv()) {
					AN=Div(Mul(L.L,R.R),Mul(L.R,R.L));
					//cond="BB";
					msg="(A / B) / (C / D) = (A * D) / (B * C)";
				} else if (isExp()) {		// (a / b) ^ (c / d)
				} else if (isRoot()) {		// (a / b) \ (c / d)
				} else if (isComp()) {		// (a / b) = (c / d)
					if (L.R.equals(R.R)) {
						AN=Equal(L.L,R.L);
						cond=" si C # 0 ";
						msg="A / C = B / C == A = B";
					}
				}
			} else if (L.isExp()) { 		// (a ^ b) op (c / d)
				if (isSum()) {  		// (a ^ b) + (c / d)	OJO: faltaran casos de factorizacin por ej a=c  d
				} else if (isSub()) {		// (a ^ b) - (c / d)	OJO: faltaran casos de factorizacin
				} else if (isMul()) {		// (a ^ b) * (c / d)	OJO: 9  da 	((a^b)*c)/d
				} else if (isDiv()) {		// (a ^ b) / (c / d)	OJO: 9  da	 ((a^b)*d) /c
				} else if (isExp()) {		// (a ^ b) ^ (c / d)	OJO: 9  da 	rootd ((a^b)^c)    	faltara a^((b*c)/d))
				} else if (isRoot()) {		// (a ^ b) \ (c / d) 	OJO: 9  da 	(a^b)\c / (a^b)\d
				} else if (isComp()) {		// (a ^ b) =? (c / d)
				}
			} else if (L.isRoot()) { 		// (a \ b) op (c / d)
				if (isSum()) {  		// (a \b) + (c / d)
				} else if (isSub()) {		// (a \ b) - (c / d)
				} else if (isMul()) {		// (a \ b) * (c / d) 	OJO  llamar a fracciones?
				} else if (isDiv()) {		// (a \ b) / (c / d)  	OJO  llamar a fracciones?
				} else if (isExp()) {		// (a \ b) ^ (c / d) 	OJO 9  y 10 dan		rootd ((a/b)^c)  y 	a^(c/d)/ b^(c/d)
				} else if (isRoot()) {		// (a \ b) \ (c / d)  	OJO: 9  da 	(a\b)\c / (a\b)\d  y ver nota en 10
				} else if (isComp()) {		// (a \ b) =? (c / d)
				}
			}
		} else if (R.isExp()) {
			if (L.isSum()) { 		// (a + b) op (c ^ d)
				if (isSum()) {  		// (a + b) + (c ^ d)  	OJO: 10  da	a+(b + c^d)
				} else if (isSub()) {		// (a + b) - (c ^ d)  	OJO: 10  da 	a+(b - c^d)
				} else if (isMul()) {		// (a + b) * (c ^ d) 	OJO : 10  da	a*(c^d) + b*(c^d)
				} else if (isDiv()) {		// (a + b) / (c ^ d)  	OJO : 10  da	a/(c^d) + b/(c^d)
				} else if (isExp()) {		// (a + b) ^ (c ^ d)
				} else if (isRoot()) {		// (a + b) \ (c ^ d)    OJO:  casos particulares por ejemplo a+b=d
				} else if (isComp()) {		// (a + b) =? (c ^ d)
				}
			} else if (L.isSub()) { 		// (a - b) op (c ^ d)
				if (isSum()) {  		// (a - b) + (c ^ d)  	OJO: 10  da	a-(b - c^d)
				} else if (isSub()) {		// (a - b) - (c ^ d)  	OJO: 10  da 	a-(b + c^d)
				} else if (isMul()) {		// (a - b) * (c ^ d) 	OJO : 10  da	a*(c^d) - b*(c^d)
				} else if (isDiv()) {		// (a - b) / (c ^ d)  	OJO : 10  da	a/(c^d) - b/(c^d)
				} else if (isExp()) {		// (a - b) ^ (c ^ d)
				} else if (isRoot()) {		// (a - b) \ (c ^ d)    OJO:  casos particulares por ejemplo a-b=d
				} else if (isComp()) {		// (a - b) =? (c ^ d)
				}
			} else if (L.isMul()) { 		// (a * b) op (c ^ d)
				if (isSum()) {  		// (a * b) + (c ^ d)	OJO: faltaran casos de factorizacin por ej c=a  b
				} else if (isSub()) {		// (a * b) - (c ^ d)	OJO: faltaran casos de factorizacin
				} else if (isMul()) {		// (a * b) * (c ^ d)	OJO: 10  da 	a*(b*(c^d))
				} else if (isDiv()) {		// (a * b) / (c ^ d)	OJO: ver nota en 10
				} else if (isExp()) {		// (a * b) ^ (c ^ d)	OJO: 10  da 	a^(c^d) * b^(c^d)
				} else if (isRoot()) {		// (a * b) \ (c ^ d) 	OJO: ver notaen10 y casos defactorizacin por ej d=a  b
				} else if (isComp()) {		// (a * b) =? (c ^ d)
				}
			} else if (L.isDiv()) { 		// (a / b) op (c ^ d)
				if (isSum()) {  		// (a / b) + (c ^ d)	OJO: faltaran casos de factorizacin por ej c=a  b
				} else if (isSub()) {		// (a / b) - (c ^ d)	OJO: faltaran casos de factorizacin
				} else if (isMul()) {		// (a / b) * (c ^ d)	OJO: 10  da 	(a*(c^d))/b
				} else if (isDiv()) {		// (a / b) / (c ^ d)	OJO: 10 da 	a/(b*(c^d))
				} else if (isExp()) {		// (a / b) ^ (c ^ d)	OJO: 10  da 	a^(c^d) / b^(c^d)
				} else if (isRoot()) {		// (a / b) \ (c ^ d) 	OJO: 10 da (c^d)^(b/a) faltaran casos defactorizacin por ej d=a  b otro paso?
				} else if (isComp()) {		// (a / b) =? (c ^ d)
				}
			} else if (L.isExp()) { 		// (a ^ b) op (c ^ d)
				if (isSum()) {  		// (a ^ b) + (c ^ d)
				} else if (isSub()) {		// (a ^ b) - (c ^ d)
				} else if (isMul()) {		// (a ^ b) * (c ^ d)
					if (L.R.equals(R.R)) {
						AN=Exp(Mul(L.L,R.L),L.R);
						//cond="BB";
						msg="(A ^ B) * (C ^ B) = (A * C) ^ B";
					} else if (L.L.equals(R.L)) {
						AN=Exp(L.L,Sum(L.R,R.R));
						//cond="BB";
						msg="(A ^ B) * (A ^ C) = A ^ (B + C)";
					}
				} else if (isDiv()) {		// (a ^ b) / (c ^ d)
					if (L.R.equals(R.R)) {
						AN=Exp(Div(L.L,R.L),L.R);
						//cond="BB";
						msg="(A ^ B) / (C ^ B) = (A / C) ^ B";
					} else if (L.L.equals(R.L)) {
						AN=Exp(L.L,Sub(L.R,R.R));
						//cond="BB";
						msg="(A ^ B) / (A ^ C) = A ^ (B - C)";
					}
				} else if (isExp()) {		// (a ^ b) ^ (c ^ d)
				} else if (isRoot()) {		// (a ^ b) \ (c ^ d)
				} else if (isComp()) {		// (a ^ b) = (c ^ d)
				}
			} else if (L.isRoot()) { 		// (a \ b) op (c ^ d)
				if (isSum()) {  			// (a \ b) + (c ^ d)
				} else if (isSub()) {		// (a \ b) - (c ^ d)
				} else if (isMul()) {		// (a \ b) * (c ^ d)
					if (L.R.equals(R.L)) {
						AN=Exp(R.L,Sum(Div(Num(1),L.L),R.R));
						//cond="BB";
						msg="(A \\ B) * (B ^ C) = B ^ (1/A + C)";
					}
				} else if (isDiv()) {		// (a \ b) / (c ^ d)
					if (L.R.equals(R.L)) {
						AN=Exp(R.L,Sub(Div(Num(1),L.L),R.R));
						//cond="BB";
						msg="(A \\ B) / (B ^ C) = B ^ (1/A - C)";
					}
				} else if (isExp()) {		// (a \ b) ^ (c ^ d)
				} else if (isRoot()) {		// (a \ b) \ (c ^ d)
				} else if (isComp()) {		// (a \ b) = (c ^ d)
				}
			}
		} else if (R.isRoot()) {
			if (L.isSum()) { 		// (a + b) op (c \ d)
				if (isSum()) {  		// (a + b) + (c \ d)  	OJO: 10  da	a+(b + c\d)
				} else if (isSub()) {		// (a + b) - (c \ d)  	OJO: 10  da 	a+(b - c\d)
				} else if (isMul()) {		// (a + b) * (c \ d) 	OJO : 10  da	a*(c\d) + b*(c\d)
				} else if (isDiv()) {		// (a + b) / (c \ d)  	OJO : 10  da	a/(c\d) + b/(c\d)
				} else if (isExp()) {		// (a + b) ^ (c \ d)
				} else if (isRoot()) {		// (a + b) \ (c \ d)    	OJO: Faltara que esto fuera: ((a+b)*c)\d
				} else if (isComp()) {		// (a + b) =? (c \ d)
				}
			} else if (L.isSub()) { 		// (a - b) op (c \ d)
				if (isSum()) {  		// (a - b) + (c \ d)  	OJO: 10  da	a-(b - c\d)
				} else if (isSub()) {		// (a - b) - (c \ d)  	OJO: 10  da 	a-(b + c\d)
				} else if (isMul()) {		// (a - b) * (c \ d) 	OJO : 10  da	a*(c\d) - b*(c\d)
				} else if (isDiv()) {		// (a - b) / (c \ d)  	OJO : 10  da	a/(c\d) - b/(c\d)
				} else if (isExp()) {		// (a - b) ^ (c \ d)
				} else if (isRoot()) {		// (a - b) \ (c \ d)    	OJO: Faltara que esto fuera: ((a-b)*c)\d
				} else if (isComp()) {		// (a - b) =? (c \ d)
				}
			} else if (L.isMul()) { 		// (a * b) op (c \ d)
				if (isSum()) {  		// (a *b) + (c \ d)  Faltaran casos como a*b=d
				} else if (isSub()) {		// (a * b) - (c \ d)  Faltaran casos como a*b=d
				} else if (isMul()) {		// (a * b) * (c \ d) 	OJO  10  da 	(a*(b*c\d)
				} else if (isDiv()) {		// (a * b) / (c \ d)  	OJO  Ver nota de10
				} else if (isExp()) {		// (a * b) ^ (c \ d)
				} else if (isRoot()) {		// (a * b) \ (c \ d)  	OJO: Ver nota en 10
				} else if (isComp()) {		// (a * b) =? (c \ d)
				}
			} else if (L.isDiv()) { 		// (a / b) op (c \ d)
				if (isSum()) {  		// (a /b) + (c \ d)  Faltaran casos como a*b=d
				} else if (isSub()) {		// (a / b) - (c \ d)  Faltaran casos como a*b=d
				} else if (isMul()) {		// (a / b) * (c \ d) 	OJO  10  da 	(a*(b*c\d)
				} else if (isDiv()) {		// (a / b) / (c \ d)  	OJO  10 da a/(b*(c\d))
				} else if (isExp()) {		// (a / b) ^ (c \ d)
				} else if (isRoot()) {		// (a / b) \ (c \ d)  	OJO: Ver nota en 10
				} else if (isComp()) {		// (a / b) =? (c \ d)
				}
			} else if (L.isExp()) { 		// (a ^ b) op (c \ d)
				if (isSum()) {  		// (a ^ b) + (c \ d)
				} else if (isSub()) {		// (a ^ b) - (c \ d)
				} else if (isMul()) {		// (a ^ b) * (c \ d)
					if (L.L.equals(R.R)) {
						AN=Exp(L.L,Sum(L.R,Div(Num(1),R.L)));
						msg="(A ^ B) * (C \\ A) = A ^ (B + 1/C)";
					}
				} else if (isDiv()) {		// (a ^ b) / (c \ d)
					if (L.L.equals(R.R)) {
						AN=Exp(L.L,Sub(L.R,Div(Num(1),R.L)));
						//cond="BB";
						msg="(A ^ B) / (C \\ A) = A ^ (B - 1/C)";
					}
				} else if (isExp()) {		// (a ^ b) ^ (c \ d)
				} else if (isRoot()) {		// (a ^ b) \ (c \ d)
				} else if (isComp()) {		// (a ^ b) = (c \ d)
				}
			} else if (L.isRoot()) {
				if (isSum()) {  		// (a \ b) + (c \ d)
				} else if (isSub()) {		// (a \ b) - (c \ d)
				} else if (isMul()) {		// (a \ b) * (c \ d)
					if (L.L.equals(R.L)) {
						AN=Root(L.L,Mul(L.R,R.R));
						//cond="BB";
						msg="(A \\ B) * (A \\ C) = A \\ (B * C)";
					}
				} else if (isDiv()) {		// (a \ b) / (c \ d)
					if (L.L.equals(R.L)) {
						AN=Root(L.L,Div(L.R,R.R));
						//cond="BB";
						msg="(A \\ B) / (A \\ C) = A \\ (B / C)";
					}
				} else if (isExp()) {		// (a \ b) ^ (c \ d)
				} else if (isRoot()) {		// (a \ b) \ (c \ d)
				} else if (isComp()) {		// (a \ b) = (c \ d)
				}
			}
		}
		if (AN!=null) {
			return new Resultado(AN,msg,cond);
		}
		return null;
	}

	Resultado perform_BN(Vector V) {
		if (L.isBinaryOperator() && R.isPositiveNumber()) {
			String msg="(A "+L.symbol+" B) "+symbol+ " n ";
			String cond="";
			ANode AN=null;
			
			if (isExp()) {
				if (L.isSum()) {
					if (R.equals(Num(2))) {
						msg=" (A + B) = A + 2AB + B ";
						AN=Sum(Sum(Exp(L.L,Num(2)),Mul(Num(2),Mul(L.L,L.R))),Exp(L.R,Num(2)));
					} else if (R.equals(Num(3))) {
						msg=" (A + B) = A + 3AB + 3AB + B ";
					}
				} else if (L.isSub()) {
					if (R.equals(Num(2))) {
						msg=" (A - B) = A - 2AB + B ";
						AN=Sum(Sub(Exp(L.L,Num(2)),Mul(Num(2),Mul(L.L,L.R))),Exp(L.R,Num(2)));
					} else if (R.equals(Num(3))) {
					}
				}
			}	
	
			if (AN!=null) {
				return new Resultado(AN,msg,cond);
			}
		}
		return null;
	}

	Resultado perform_NB(Vector V) {
		if (R.isBinaryOperator() && L.isPositiveNumber()) {
			String msg=" n "+symbol+ " (A "+R.symbol+" B)";
			String cond="";
			ANode AN=null;

			if (AN!=null) {
				return new Resultado(AN,msg,cond);
			}
		}
		return null;
	}

	Resultado perform_BB_notables(Vector V) {
		String msg="(A "+L.symbol+" B) "+symbol+ " (C "+R.symbol+" D)";
		String cond="";
		ANode AN=null;
		if (R.isSum()) {
			if (L.isSum()) { 				// (a + b) op (c + d)
				if (isSum()) {  			// (a + b) + (c + d)  	OJO 9 y 10 dan  ((a+b)+c)+d  y  a+(b+(c+d)) falta a+(b+c)+d y (c+d)+(a+b) alcanzables?
				} else if (isSub()) {		// (a + b) - (c + d)  	OJO 9 y 10 dan  ((a+b)-c)-d   y  a+(b-(c+d))		(a+b)+(-c-d) o (a+b)+(-c+(-d)) y caer en caso anterior?
				} else if (isMul()) {		// (a + b) * (c + d)  	OJO contemplados en 9 y 10
					if (L.L.equals(R.L)) {	
						msg="(A + B) * (A + C) = A ^ 2 + (B + C) * A + B * C";
						AN=Sum(Sum(Exp(L.L,Num(2)),Mul(Sum(L.R,R.R),L.L)), Mul(L.R,R.R));
					}
			//		si son iguales lo hace ANode al principio
				} else if (isDiv()) {		// (a + b) / (c + d) 	OJO 10 da   a/(c+d) + b/(c+d)
				} else if (isExp()) {		// (a + b) ^ (c + d) 	OJO 9 da   (a+b)^c * (a+b)^d
				} else if (isRoot()) {		// (a + b) \ (c + d)  	OJO nada?
				} else if (isComp()) {		// (a + b) = (c + d)
				}
			} else if (L.isSub()) { 		// (a - b) op (c + d)
				if (isSum()) {  			// (a - b) + (c + d)  	OJO 9 y 10 dan  ((a-b)+c)+d  y  a-(b-(c+d))
				} else if (isSub()) {		// (a - b) - (c + d)  	OJO: 9 y 10 dan  ((a-b)-c)-d  y  a-(b+(c+d))    (a-b)+(-c-d) o (a-b)+(-c+(-d)) y caer en el caso anterior?
				} else if (isMul()) {		// (a - b) * (c + d) 	OJO: contemplados en 9 y 10
					if (L.L.equals(R.L) && L.R.equals(R.R)) {		// (a - b) * (a + b)
						//cond="BB";
						msg="(A - B) * (A + B) = A ^ 2 - B ^ 2 ";
						AN=Sub(Exp(L.L,Num(2)),Exp(R.R,Num(2)));// a ^2 - b ^ 2
					} else if (L.L.equals(R.L)) {	
						msg="(A - B) * (A + C) = A ^ 2 - (B - C) * A - B * C";
						AN=Sub(Sub(Exp(L.L,Num(2)),Mul(Sub(L.R,R.R),L.L)), Mul(L.R,R.R));
					}
				} else if (isDiv()) {		// (a - b) / (c + d) 	OJO 10 da   a/(c+d) - b/(c+d)
				} else if (isExp()) {		// (a - b) ^ (c + d) 	OJO:9 da   (a-b)^c * (a-b)^d
				} else if (isRoot()) {		// (a - b) \ (c + d) 	OJO: nada
				} else if (isComp()) {		// (a - b) =? (c + d)
				}
			} else if (L.isMul()) { 		// (a * b) op (c + d)
			} else if (L.isDiv()) { 		// (a / b) op (c + d)
			} else if (L.isExp()) { 		// (a ^ b) op (c + d)
			} else if (L.isRoot()) { 		// (a \ b) op (c + d)
			}
		} else if (R.isSub()) {
			if (L.isSum()) {				// (a + b) op (c - d)
				if (isSum()) {  		// (a + b) + (c - d)  		OJO: 9 y 10 dan 	((a+b)+c)-d          y 	a+(b+(c-d))
				} else if (isSub()) {		// (a + b) - (c - d)	OJO: 9 y 10 dan 	((a+b)-c)+d          y  	a+(b-(c-d))
				} else if (isMul()) {		// (a + b) * (c - d)	OJO: 9 y 10 dan 	(a+b)*c-(a+b)*d   y   	a*(c-d) + b*(c-d)
					if (L.L.equals(R.L) && L.R.equals(R.R)) {		// (a - b) * (a + b)
						msg="(A + B) * (A - B) = A ^ 2 - B ^ 2 ";
						AN=Sub(Exp(L.L,Num(2)),Exp(L.R,Num(2)));// a ^2 - b ^ 2
					} else if (L.L.equals(R.L)) {	
						msg="(A + B) * (A - C) = A ^ 2 + (B - C) * A - B * C";
						AN=Sub(Sum(Exp(L.L,Num(2)),Mul(Sub(L.R,R.R),L.L)), Mul(L.R,R.R));
					}
				} else if (isDiv()) {		// (a + b) / (c - d)	OJO: 10 da	 a/(c-d) +b/(c-d)
				} else if (isExp()) {		// (a + b) ^ (c - d)	OJO: 9 da 	(a+b)^c / (a+b)^d
				} else if (isRoot()) {		// (a + b) \ (c - d)
				} else if (isComp()) {		// (a + b) =? (c - d)
				}
			} else if (L.isSub()) { 		// (a - b) op (c - d)
				if (isSum()) {  		// (a - b) + (c - d)  		OJO 9 y 10 dan  ((a-b)+c)-d  y  a-(b-(c-d))
				} else if (isSub()) {		// (a - b) - (c - d)  	OJO: 9 y 10 dan  ((a-b)-c)+d  y  a-(b+(c-d))    (a-b)+(-c+d) o (a-b)+(-c+d) y caer en el caso anterior?
				} else if (isMul()) {		// (a - b) * (c - d) 	OJO: contemplados en 9 y 10
					if (L.L.equals(R.L)) {	
						msg="(A - B) * (A - C) = A ^ 2 - (B + C) * A + B * C";
						AN=Sum(Sub(Exp(L.L,Num(2)),Mul(Sum(L.R,R.R),L.L)), Mul(L.R,R.R));
					}
			//		si son iguales lo hace ANode al principio
				} else if (isDiv()) {		// (a - b) / (c - d) 	OJO 10 da   a/(c-d) - b/(c-d)
				} else if (isExp()) {		// (a - b) ^ (c - d) 	OJO:9 da   (a-b)^c / (a-b)^d
				} else if (isRoot()) {		// (a - b) \ (c - d) 	OJO nada
				} else if (isComp()) {		// (a - b) =? (c - d)
				}
			} else if (L.isMul()) { 		// (a * b) op (c - d)
			} else if (L.isDiv()) { 		// (a / b) op (c - d)
			} else if (L.isExp()) { 		// (a ^ b) op (c - d)
			} else if (L.isRoot()) { 		// (a \ b) op (c - d)
			}
		} else if (R.isMul()) {
		} else if (R.isDiv()) {
		} else if (R.isExp()) {
			if (L.isSum()) { 		// (a + b) op (c ^ d)
			} else if (L.isSub()) { 		// (a - b) op (c ^ d)
			} else if (L.isMul()) { 		// (a * b) op (c ^ d)
			} else if (L.isDiv()) { 		// (a / b) op (c ^ d)
			} else if (L.isExp()) { 		// (a ^ b) op (c ^ d)
				if (isSum()) {  		// (a ^ b) + (c ^ d)
				} else if (isSub()) {		// (a ^ b) - (c ^ d)
					if (L.R.equals(Num(2))&&R.R.equals(Num(2)) ) {
						msg="A ^ 2 - B ^ 2 = (A + B) * (A - B)";
						AN=Mul(Sum(L.L,R.L),Sub(L.L,R.L));
						addResultado(V,AN,msg,cond);
						msg="A ^ 2 - B ^ 2 = (A - B) * (A + B)";
						AN=Mul(Sub(L.L,R.L),Sum(L.L,R.L));
						addResultado(V,AN,msg,cond);
						AN=null;
					}
				} else if (isMul()) {		// (a ^ b) * (c ^ d)
				} else if (isDiv()) {		// (a ^ b) / (c ^ d)
				} else if (isExp()) {		// (a ^ b) ^ (c ^ d)
				} else if (isRoot()) {		// (a ^ b) \ (c ^ d)
				} else if (isComp()) {		// (a ^ b) = (c ^ d)
				}
			} else if (L.isRoot()) { 		// (a \ b) op (c ^ d)
			}
		} else if (R.isRoot()) {
		}
		if (AN!=null) {
			return new Resultado(AN,msg,cond);
		}
		return null;
	}


}