/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.algebra;

import java.util.*;
import com.mja.algebra.*;

public class ANode_N extends ANode {

	public ANode_N(ANode AN) {
		super(AN.N,AN.an_cfg);
	}

	void perform_NN(Vector V) { // 3				m bop n
		if (isRoot()) {
			if (L.toExpression(true).equals("") && R.isPositiveNumber()) {
				performSqrt(V,R);
			}
		}
		if (L.isPositiveNumber() && R.isPositiveNumber()) {
			ANode AN=null;
			String msg="";
			String cond="";
			if (L.isInteger()&&R.isInteger()) {
				if (R.equals(Num(0))) {
				} else if (R.equals(Num(1))) {
				}
				if (isSum()) {  			// m + n
				} else if (isSub()) {		// m - n
				} else if (isMul()) {		// m * n
				} else if (isDiv()) {		// m / n
					divideIntegers(V);
					return;
				} else if (isExp()) {		// m ^ n

				} else if (isRoot()) {		// m \ n
					if (L.equals(Num(2))) {
						performSqrt(V,R);
					}
				} else if (isComp()) {		// m = n
				}
			}
			AN=Num(N.Evaluate(0));
			msg=L.toExpression(true)+" "+N.getSymbol()+" "+R.toExpression(true)+" = "+AN.N.toExpression(true);
			cond="";
			addResultado(V,new Resultado(AN,msg,cond));
		}
	}
	

	void perform_NU(Vector V) {				// n bop |b|
		ANode AN=null;
		String msg="";
		String cond="";
		if (R.isAbs()) {
			cond= " si n es positivo ";
			if (isSum()) {						// n + |b|
			} else if (isSub()) {				// n - |b|
			} else if (isMul()) {				// n * |b|
				AN=Abs(Mul(L,R.R));
				msg=" n * |A| = |n * A|";
				addResultado(V,new Resultado(AN,msg,cond));
			} else if (isDiv()) {				// n / |b|
				AN=Abs(Div(L,R.R));
				msg=" n / |A| = |n * A|";
				addResultado(V,new Resultado(AN,msg,cond));
			} else if (isExp()) {				// n ^ |b|
			} else if (isRoot()) {				// n \ |b|
				AN=Abs(Root(L,R.R));
				cond="";
				msg=" n \\ |A| = |n \\ A|";
				addResultado(V,new Resultado(AN,msg,cond));
			} else if (isComp()) {				// n =? |b|
			}
		} else if (R.isUnaryMinus()) {
			if (isSum()) {						// n + (-b)
				if (R.R.isPositiveNumber()) {
					AN=Num(L.value-R.R.value);
					msg=" -"+L.toExpression(true)+" + ("+R.toExpression(true)+") = "+AN.N.toExpression(true);
					addResultado(V,new Resultado(AN,msg,cond));
				}
			} else if (isSub()) {				// n - (-b)
				if (R.R.isPositiveNumber()) {
					AN=Num(L.value+R.R.value);
					msg=" -"+L.toExpression(true)+" - ("+R.toExpression(true)+") = "+AN.N.toExpression(true);
					addResultado(V,new Resultado(AN,msg,cond));
				}
			} else if (isMul()) {				// n * (-b)
			} else if (isDiv()) {				// n / (-b)
			} else if (isExp()) {				// n ^ (-b)
			} else if (isRoot()) {				// n \ (-b)
			} else if (isComp()) {				// n =? (-b)
			}
		}
	}

	void perform_UN(Vector V) {					// |a| bop n
		ANode AN=null;
		String msg="";
		String cond="";
		if (L.isAbs()) {
			if (isSum()) {						// |a| + n
			} else if (isSub()) {				// |a| - n
			} else if (isMul()) {				// |a| * n
				AN=Abs(Mul(L.R,R));
				cond= " si n es positivo: ";
				//cond="N";
				msg=" |A| * n = |A * n|";
				addResultado(V,new Resultado(AN,msg,cond));
			} else if (isDiv()) {				// |a| / n
				AN=Abs(Div(L.R,R));
				cond= " si n es positivo: ";
				//cond="N";
				msg=" |A|/ n = |A / n|";
				addResultado(V,new Resultado(AN,msg,cond));
			} else if (isExp()) {				// |a| ^ n
				AN=Abs(Exp(L.R,R));
				//cond="N";
				msg=" |A| ^ n = |A ^ n|";
				addResultado(V,new Resultado(AN,msg,cond));
			} else if (isRoot()) {				// |a| \ n
			} else if (isComp()) {				// |a| = n
			}
		} else if (L.isUnaryMinus()) {
			if (isSum()) {						// (-a) + n
				if (L.R.isPositiveNumber()) {
					AN=Num(R.value-L.R.value);
					msg=" -"+L.R.toExpression(true)+" + "+R.toExpression(true)+" = "+AN.N.toExpression(true);
					addResultado(V,new Resultado(AN,msg,cond));
				}
			} else if (isSub()) {				// (-a) - n
				if (L.R.isPositiveNumber()) {
					AN=Num(-R.value-L.R.value);
					msg=" -"+L.R.toExpression(true)+" - "+R.toExpression(true)+" = "+AN.N.toExpression(true);
					addResultado(V,new Resultado(AN,msg,cond));
				}
			} else if (isMul()) {				// (-a) * n
			} else if (isDiv()) {				// (-a) / n
			} else if (isExp()) {				// (-a) ^ n
			} else if (isRoot()) {				// (-a) \ n
			} else if (isComp()) {				// (-a) = n
			}
		}
	}

	void perform_NA_0(Vector V) {						// n bop B
		if (L.equals(Num(0))) {
			if (isMul()) {
				addResultado(V,new Resultado(Num(0)," 0 * A = 0 ",""));
			} else if (isDiv() && !R.equals(Num(0))) {
				addResultado(V,new Resultado(Num(0)," 0 / A = 0 ","A # 0"));
			}
		}
	}

	void perform_NA_1(Vector V) {						// n bop B
		ANode AN=null;
		String msg="";
		String cond="";
		if (L.isPositiveNumber()) {
			if (isSum()) {						// n + b
				if (L.equals(Num(0))) {			// 0 + b
					AN=Copy(R);
					//cond="N";
					msg=" 0 + A = A";
					addResultado(V,new Resultado(AN,msg,cond));
				}
			} else if (isSub()) {				// n - b
				if (L.equals(Num(0))) {			// 0 - b
					AN=Minus(R);
					//cond="N";
					msg=" 0 - A = -A";
					addResultado(V,new Resultado(AN,msg,cond));
				}
			} else if (isMul()) {				// n * b
				if (L.equals(Num(0))) {			// 0 * b
					AN=Num(0);
					//cond="N";
					msg=" 0 * A = 0";
					addResultado(V,new Resultado(AN,msg,cond));
				} else if (L.equals(Num(1))) {	// 1 * b
					AN=Copy(R);
					//cond="N";
					msg=" 1 * A = A";
					addResultado(V,new Resultado(AN,msg,cond));
				}
			} else if (isDiv()) {				// n / b
				if (L.equals(Num(0))) {  		// 0 / b
					AN=Num(0);
					cond= " si B # 0 ";
					//cond="N";
					msg=" 0 / B = 0";
					addResultado(V,new Resultado(AN,msg,cond));
				} else
				if (L.equals(Num(1))) {  // 1 / b
					AN=Exp(R,Minus(Num(1)));// b ^ (-1)
					//cond="N";
					msg=" 1 / B = (B)^(-1)";
					addResultado(V,new Resultado(AN,msg,cond));
				}
			} else if (isExp()) {				// n ^ b
				if (L.equals(Num(0))) { 		// 0 ^ b
					AN=Num(0);
					cond=" B > 0 ";
					msg=" 0 ^ B = 0";
					addResultado(V,new Resultado(AN,msg,cond));
				} else if (L.equals(Num(1))) {	// 1 ^ b
					AN=Num(1);
					//cond="N";
					msg=" 1 ^ B = 1";
					addResultado(V,new Resultado(AN,msg,cond));
				}
			} else if (isRoot()) {				// n \ b
			// OJO: habra que distinguir entre as pares e impares, para permitir o no esto.
				if (L.equals(Num(0))) {  		// 0 \ b
					AN=Exp(R,Div(Num(1),Num(0)));  // b ^ (1/0)
					//cond="N";
					msg=" 0 \\ B = B ^ (1/0)";
					addResultado(V,new Resultado(AN,msg,cond));
				} else if (L.equals(Num(1))) {	// 1 \ b
					AN=Copy(R);
					//cond="N";
					msg=" 1 \\ B = B";
					addResultado(V,new Resultado(AN,msg,cond));
				}
			} else if (isComp()) {				// n =? b
			}
		}
	}

	void perform_AN_0(Vector V) {						// 	A bop n
		if (R.equals(Num(0)) && (isMul())) {
			addResultado(V,new Resultado(Num(0)," A * 0 = 0 ",""));
		}
	}

	void perform_AN_1(Vector V) {						// 	A bop n
		ANode AN=null;
		String msg="";
		String cond="";
		if (R.isPositiveNumber()) {
			if (isSum()) {						// a + n
				if (R.equals(Num(0))) {  		// a + 0
					AN=Copy(L);
					//cond="N";
					msg=" A + 0 = A";
					addResultado(V,new Resultado(AN,msg,cond));
				}
			} else if (isSub()) {				// a - n
				if (R.equals(Num(0))) {			// a - 0
					AN=Copy(L);
					//cond="N";
					msg=" A - 0 = A";
					addResultado(V,new Resultado(AN,msg,cond));
				}
			} else if (isMul()) {				// a * n
				if (R.equals(Num(0))) {    	 	// a * 0
					AN=Num(0);
					//cond="N";
					msg=" A * 0 = 0";
					addResultado(V,new Resultado(AN,msg,cond));
				} else if (R.equals(Num(1))) {	// a * 1
					AN=Copy(L);
					//cond="N";
					msg=" A * 1 = A";
					addResultado(V,new Resultado(AN,msg,cond));
				}
			} else if (isDiv()) {				// a / n
				if (R.equals(Num(0))) {  		// a / 0
				} else if (R.equals(Num(1))) {  // a / 1
					AN=Copy (L);
					//cond="N";
					msg=" A / 1 = A";
					addResultado(V,new Resultado(AN,msg,cond));
				}
			} else if (isExp()) {				// a ^ n
				if (R.equals(Num(0))) {  		// a ^ 0
					AN=Num(1);
					msg=" A ^ 0 = 1";
					addResultado(V,new Resultado(AN,msg,cond));
				} else if (R.equals(Num(1))) {   // a ^ 1
					AN=Copy(L);
					msg=" A ^ 1 = A";
					addResultado(V,new Resultado(AN,msg,cond));
				} else if (R.equals(Num(2))) {   // a ^ 2
					AN=Mul(L,L);
					msg=" A ^ 2 = A * A";
					addResultado(V,new Resultado(AN,msg,cond));
				} else {
					ANode aux=Sub(R,Num(1));
					aux=new ANode(aux.N.Evaluate(0),an_cfg);
					AN=Mul(Exp(L,aux),L);
					//cond="BA";
					msg="A ^ n  = (A ^ (n - 1)) * A";
					addResultado(V,new Resultado(AN,msg,cond));
				}
			} else if (isRoot()) {				// a \ n
				if (R.equals(Num(0))) {  		// a \ 0     -->  0 ^ (1/a)  por si a es cero
				} else if (R.equals(Num(1))) {  // a \ 1	-->  1 ^ (1/a)  por si a es cero
				}
			} else if (isComp()) {				// a =? n
			}
		}
	}

	void performSqrt(Vector V,ANode R) {
		ANode AN=null;
		String msg="";
		String cond="";
		int n=(int) R.value;
		if (isPerfectSqr(n)) {
			msg=" 2 \\ A = B";
			cond="si A = B^2";
			AN=Num(N.Evaluate(0));
			addResultado(V,new Resultado(AN,msg,cond));
		} else {
			int m=maxSqr(n);
			if (m>1) {
				msg=" 2\\A = (2\\n) * abs(m)";
				cond="si A = n*m^2";
				AN=Mul(Root(Num(2),Num(n/(m*m))),Num(m));
				addResultado(V,new Resultado(AN,msg,cond));
			}
		}
	}

	int maxSqr(int n) {
		int m=(int) Math.sqrt(n);
		while (m>1) {
			if (isInteger( ((double)n)/((double)(m*m) ))) {
				return m;
			}
			m--;
		}
		return 1;
	}

	boolean isInteger(double x) {
		return Math.round(x)==x;
	}
}