/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.algebra;

import com.mja.algebra.*;

public class ANode_U extends ANode {

	public ANode_U(ANode AN) {
		super(AN.N,AN.an_cfg);
	}

	static ANode doAbs(ANode AN) {
		if (AN.isAbs()) {
			Resultado r=(new ANode_U(AN)).perform_U();
			if (r!=null) {
				return r.getANode();
			}
		}
		return AN;
	}

/* --------------- do Unary Operations ---------------- */

	Resultado perform_U() {
		ANode AN=null;
		String msg="";
		String cond="";
		if (isAbs()) {									// |  |
			if (R.isVar()) {
				if (R.isPositiveNumber()) {				// |n|
					AN=Copy(R);
//					cond="U";
					msg="|n| = n (si n es un nmero positivo)";
				}
			} else if (R.isUnaryOperator()) {
				if (R.isAbs()) {						// ||a||
					AN=Copy(R);
//					cond="U";
					msg="||A|| = |A|";
				} else if (R.isUnaryMinus()) {
					AN=doAbs(Abs(R.R));
//					cond="U";
					msg="|-A| = |A|";
				}
			} else if (R.isBinaryOperator()) {			// | a bop b |
				if (R.isSum()) {
				} else if (R.isSub()) {
				} else if (R.isMul()) {					// | a * b |
					AN=Mul(doAbs(Abs(R.L)),doAbs(Abs(R.R)));
//					cond="U";
					msg="| a * b | = |a| * |b|";
				} else if (R.isDiv()) {					// | a / b |
					AN=Div(doAbs(Abs(R.L)),doAbs(Abs(R.R)));
//					cond="U";
					msg="| a / b | = |a| / |b|";
				} else if (R.isExp()) {					// | a ^ b |
					AN=Exp(doAbs(Abs(R.L)),R.R);
//					cond="U";
					msg="| a ^ b | = |a| ^ b |";
				} else if (R.isRoot()) {				//  | a \ b |
					AN=Root(R.L,doAbs(Abs(R.R)));
//					cond="U";
					msg="| a \\ b | = a \\ |b|";
				} else if (R.isComp()) {
				}
			}
		} else if (isUnaryMinus()) {					// - a
			if (R.equals(Num(0))) {					// - 0
//				AN=Copy(R);	
				AN=Num(0);	
//				cond="U";					//   0
				msg="- 0 = 0";
			} else if (R.isUnaryOperator()) {			// - uop (a)
				if (R.isAbs()) {						// - | a |
				} else if (R.isUnaryMinus()) {			// - ( -a )
					AN= Copy(R.R);
//					cond="U";					//  a
					msg="- (- A) = A";
				}
			} else if (R.isBinaryOperator()) {			// - ( a bop b )
				if (R.isSum()) {						// - ( a + b )
					AN= Sum(Minus(R.L).performOperation(),Minus(R.R).performOperation());
//					cond="U";
					msg="- (A + B) = - A - B";
				} else if (R.isSub()) {					// - ( a - b )
					AN= Sub(R.R,R.L);				//    b - a
//					cond="U";
					msg="- (A - B) = B - A";
				} else if (R.isMul()) {					// - ( a * b )
					AN= Mul(Minus(R.L),R.R);			// ( -a) * b
//					cond="U";
					msg="- (A * B) = (-A) * B ";
				} else if (R.isDiv()) {					// - ( a / b )
					AN= Div(Minus(R.L),R.R);			//  (- a) / b
//					cond="U";
					msg="- (A / B) = (-A) / B ";
				} else if (R.isExp()) {					// - ( a ^ b )
				} else if (R.isRoot()) {				// - ( a \ b )
				} else if (R.isComp()) {
					R.error("invalid binary operator for sqr");
				} else {
					R.error("unknow binary operator");
				}
			}
			if (AN==null) {
				AN=Mul(Minus(Num(1)),R);
//				cond="U";
				msg="- A = (-1) * A ";
			}
		}
		if (AN!=null) {
			return new Resultado(AN,msg,cond);
		}
		return null;
	}

}