/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.algebra;

import java.util.*;
import java.net.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import javax.swing.*;
import javax.swing.border.*;

import com.jla.nippe.*;
import com.jla.calc.*;

import com.mja.parser.*;
import com.mja.util.*;
import com.mja.gui.*;
import com.mja.cmpedit.mjaLineEditor;
import com.mja.text.*;
import com.mja.file.*;
import com.mja.lang.*;
import org.unam.matem.Attribute;
import org.unam.matem.Communicator;

public class DescartesA extends com.jla.nippe.LMSApplet implements ActionListener, MouseListener, KeyListener, Runnable, AdjustmentListener {
	
	static public final String Version="1."+com.jla.nippe.AbstractNippe.sub_ver;

	static Font explFont,Monospaced_15,bFont,lblFont,msgFont;
	
	static final Color eqFC=Color.black;
	static final Color eqBC=new Color(0xeeeeee);
	static final Color explFC=new Color(0x000088);
	static final int exact=0, comm=1, numb=2;
	static final Frame EF=new Frame("DescartesA");

	static boolean firstTime=true;
	static String str_Help="";

	Parser parser=new Parser(this);
	translator Tr=new translator(this);
	
	private boolean doUnaryToBinaryMinus=false;
	
	public boolean inD3=false;
	
/* ------------- Communicator implementation --------------- */

	public Attribute[] getState() {
		return new Attribute[0];
	}
	
	public void changed(Communicator cc) {
	}
	
/* --------------------------------------------------------- */
	
	public String toAppletString() {
		return getAppliedCode();
	}

	protected String getInfoInd() {
		return "";
	}

	protected String getInfoEst() {
		return "";
	}

	public String getAppliedCode() {
		return DAC.toApplet(proposedDimension);
	}

/* ---------------------- DescartesA Public Config -------------------- */

	public String class_Id() {
		return "DescartesA";
	}

	public String[] getFilePaths() {
		return new String[0];
	}

	private String getVersion() {
		return Version;
	}

	public Dimension getRealSize() {
		return getSize();
	}

	public void updateProposedDimension() {
		if (DAC!=null) {
			proposedDimension=DAC.proposedDimension();
		} else {
			proposedDimension=getSize();
		}
	}

	public static String getDefaultConfig(String codebase) {
		String s="";
		s+="code=\"DescartesA.class\"\n"+
		"        codebase=\""+codebase+"\"\n"+
		"        archive=\"DescartesA.jar";
		s+="\"\n"+
		"        MAYSCRIPT\n";
		s+="        width=640 height=480>\n";
		return s;
	}

	String controles="arriba";
	String arbol="no";
	String arbol_sensible="no";
	String altura_paso="3";
	String font_type="Serif";
	String font_points="25";
	String por_str="";
	boolean por_siempre=false;
	boolean parenthesis_always=true;
	int decimales=2;

	double H_step=2;
	int fuente_puntos=25;

	boolean arbol_visible=false;
	TreeNodeConfig tn_cfg=new TreeNodeConfig();
	TreeCanvas TC;

	boolean userSelectsOption() {
		return an_cfg.showResult||an_cfg.showRule;
	}
	
	
	private String DAName="";
	public void setName(String name) {
		DAName=name;
		super.setName(name);
	}
	
/* -------------------- Public API -------------------- */

	public void setControls(String s) {
		controles=s;
	}

	public void setTreeVisibility(String s) {
		arbol=s;
	}

	public void setTreeSensibility(String s) {
		arbol_sensible=s;
	}

	public void setFontType(String s) {
		font_type=s;
	}

	public void setFontPoints(String s) {
		font_points=s;
	}

	public void setSeriesConfig(SeriesConfig[] sc) {
		serie=sc;
	}
/* -------------------- Internal State Structure ----------------- */

	ANodeConfig an_cfg;
	SeriesConfig[] serie;
	DescartesAConfig DAC;

	// State control objects
	AEditorCanvas FEC,EFEC;
	Panel activeP, efecP;
	Panel lastP;
	private mjaLineEditor nLE;
	StepConfig step;
	String s_model;

	// State control variables
	private int equiv=comm;
	private int mode;
	private boolean guided;

	int NotaMediaEnEscena(int N) {
		double a=0.0;
		for (int i=0;i<=N;i++) {
			a+=serie[i].getAverage();
		}
		return (int) Math.round(a / (double) (N+1));
	}

	int sN, esN, ser_num,exer_num=0,mode_num=0;
	int H=0,DH;

/* ------------------ Step Handling ------------------- */

	Vector VSN,VEN,VEC,VIN,VSP; //,ExplLbl;

	void resetSteps() {
		VSN=new Vector();
		VEN=new Vector();
		VEC=new Vector();
		VIN=new Vector();
		VSP=new Vector();
		EFEC=null;
		efecP=null;
		H=0;
		sN=0;
		esN=0;
		MP.removeAll();
		MP.setLayout(null);
	}

	void addStep(StepConfig step) {
		VSN.addElement(step);
		FEC=addVisualStep(step,true);
//		FEC.start(); // eliminado el 9 de abril de 2009
		VEC.addElement(FEC);
		VSP.addElement(lastP);
		VIN.addElement(nLE);
		VEN.addElement(new Integer(esN));
	}

	void destroyEFEC() {
		if (efecP!=null) {
			EFEC.stop();
			EFEC=null;
			H-=efecP.getSize().height;
			ScrP.remove(MP);
			MP.remove(efecP);
			MP.setBounds(0,-jsb.getValue(),ScrP.getSize().width,Math.max(H+DH,ScrP.getSize().height));
			ScrP.add(MP);
			efecP=null;
		}
	}

	void removeSteps(int sN) {
		destroyEFEC();
		if (FEC!=null) {
			FEC.stop();
		}
		while (VSN.size()>sN) {
			Panel p=(Panel) VSP.elementAt(sN);
			H-=p.getSize().height;
			MP.remove(p);
			VSN.removeElementAt(sN);
			VEC.removeElementAt(sN);
			VIN.removeElementAt(sN);
			VSP.removeElementAt(sN);
			VEN.removeElementAt(sN);
		}
	}

	void deactivateStep(int sN,boolean keepVisible) {
		destroyEFEC();
		if (FEC!=null) {
			FEC.stop();
		}
		if (!keepVisible) {
System.out.println("HIDE");
			AEditorCanvas EC=(AEditorCanvas) VEC.elementAt(sN);
			EC.setVisible(false);
			mjaLineEditor LE=(mjaLineEditor) VIN.elementAt(sN);
			LE.setVisible(false);
		}
	}

	void activateStep(int sN) {
		while (sN>=VSN.size()) {
//System.out.println("ERROR sN="+sN+" >= "+VSN.size());
//new Exception().printStackTrace();
			return;
		}
		step=(StepConfig) VSN.elementAt(sN);
		esN=((Integer) VEN.elementAt(sN)).intValue();
		activeP=(Panel) VSP.elementAt(sN);
		FEC=(AEditorCanvas) VEC.elementAt(sN);
		FEC.setVisible(true);
		nLE=(mjaLineEditor) VIN.elementAt(sN);
		nLE.setVisible(true);
		if (usesMouse()) {
			FEC.setEnabled(true);
		}
		FEC.updateScreen();
		if (mode==SeriesConfig.kbd) {
			setEditableFormula();
		}
		updateScroll();
		paintAll(getGraphics());
	}
	
	public void paint(Graphics g) {
		super.paint(g);
		for (int i=0;i<VEC.size();i++) {
			AEditorCanvas aec=(AEditorCanvas) VEC.elementAt(i);
			aec.updateScreen();
		}
	}
	
	void updateScroll() {
   		jsb.setVisible(MP.getSize().height>ScrP.getSize().height+(3*DH)/4);
		jsb.setMaximum(MP.getSize().height-ScrP.getSize().height);
		if (sN*DH<jsb.getValue()) {
			jsb.setValue(sN*DH);
		} else if (jsb.getValue()+ScrP.getSize().height<(sN+1)*DH) {
			jsb.setValue((sN+1)*DH);
		}
	}

	void setEditableFormula() {
		if (usesKbd()) {
			removeSteps(sN+1);
			StepConfig sc=step.cloneStep();
			sc.setExplanation("...");
			EFEC=addVisualStep(sc,false);
			EFEC.updateSize();
			efecP=lastP;
			EFEC.setEnabled(true);
			EFEC.setEditing(true);
			EFEC.start();
			EFEC.requestFocus();
		}
	}

/* -------------------- private auxiliary methods ----------------- */

	boolean usesKbd() {
		return (mode==SeriesConfig.mousenkbd) || (mode==SeriesConfig.kbd);
	}

	boolean usesMouse() {
		return (mode==SeriesConfig.mouse) || (mode==SeriesConfig.mousenkbd);
	}

	Formula NodeToFormula(TFont tf,Node N,boolean separate) {
		Formula F=N.toFormula(parser,separate,por_str,por_siempre,parenthesis_always);
		F.setFonts(tf);
		return F;
	}

	int userExercise() {
		return exer_num*serie[ser_num].countModes()+mode_num+1;
	}

//	int countUserExercises() {
//		return serie[ser_num].countExercises()*serie[ser_num].countModes();
//	}

	void showHelp() {
		mjaText.showPlainTextFrame("Ayuda del Manipulador de Expresiones (DescartesA)",str_Help);
	}

	void showMsg(String title,String msg) {
		mjaText.msg(this,title,20,50,true,"\n	"+msg+"\n\n","aceptar",msgFont,mjaText.center);
	}

	void showCalculator() {
		if (calculadora==null) {
			calculadora=new calcWin(false,false);
		} else {
			calculadora.setVisible(true);
			calculadora.toFront();
		}
	}

/* ------------------------ Initialization ------------------------ */

	public void init() {
		if (firstTime) {
			firstTime=false;
			System.out.println(class_Id()+" ver. "+getVersion());
			try {
				URL url=getClass().getResource("/doc/DescartesA.txt");
				str_Help=mjaFile.readURL(url);
			} catch (Exception e) {
				str_Help="No se encuentra la documentacin de Descartes A";
			}
			Node.inAlgebraTutor=true;
			mjaFont.prepareFonts(this);
			explFont=mjaFont.AWTSansSerif;
			bFont=mjaFont.AWTSansSerif;
			lblFont=mjaFont.AWTSansSerif;
			msgFont=mjaFont.AWTMono;
			Monospaced_15=mjaFont.makeFont("Monospaced",Font.PLAIN,17);
		}
		super.init();
		doUnaryToBinaryMinus=(getParameter("menosUnarioABinario")!=null && getParameter("menosUnarioABinario").indexOf("no")<=0);
		tn_cfg.fractionsAsNumbers="s".equalsIgnoreCase(getParameter("fraccionesEnterasComoNmeros"));
		tn_cfg.negativeNumbersAsNumbers="s".equalsIgnoreCase(getParameter("nmerosNegativosComoNmeros"));

		decimales=BasicStr.parseInteger(getParameter(DescartesAConfig.paramName[DescartesAConfig.ix_decimales]),2,2);
		an_cfg=new ANodeConfig(this,decimales);
		serie=SeriesConfig.readAllSeries(this,parser,decimales,inWeb());
		DAC=new DescartesAConfig(this);
		DAC.readDescartesACfg();
		build();
	}
	
	void setSeries(String info,String ser_cfg,String cfg) {
		if (BasicStr.hasContent(cfg)) {
//			setConfig(cfg);
		}
		serie=SeriesConfig.readAllSeries(this,Tr,ser_cfg,info,parser,decimales,inWeb());
		build();
		startSeries(0);
	}

	public void setConfig(String[] paramContent) {
		controles=paramContent[DescartesAConfig.ix_controles];
		arbol=paramContent[DescartesAConfig.ix_arbol];
		arbol_visible=BasicStr.hasContent(arbol) && !"no".equalsIgnoreCase(arbol);
		arbol_sensible=paramContent[DescartesAConfig.ix_arbol_sensible];
		if (!BasicStr.hasContent(arbol_sensible)) {
			if (arbol_visible) {
				arbol_sensible="s";
			} else {
				arbol_sensible="no";
			}
		}
		boolean tree_is_sensitive = !"no".equalsIgnoreCase(arbol_sensible);
		if (arbol_visible) {
			TC=new TreeCanvas(this,tree_is_sensitive);
		} else {
			TC=null;
		}
		controles=paramContent[DescartesAConfig.ix_controles];
		if (paramContent[DescartesAConfig.ix_por]!=null) {
			StringTokenizer st=new StringTokenizer(paramContent[DescartesAConfig.ix_por],", ");
			if (st.hasMoreTokens()) {
				String s=st.nextToken();
				if ("aspas".equals(s)) {
					por_str="\u00d7";
				} else if ("\u00d7".equals(s)) {
					por_str="\u00d7";
				} else if ("punto".equals(s)) {
					por_str="";
				} else if (".".equals(s)) {
					por_str="";
				} else if ("asterisco".equals(s)) {
					por_str="*";
				} else if ("*".equals(s)) {
					por_str="*";
				} else {
					por_str="";
				}
			}
			if (st.hasMoreTokens()) {
				String s=st.nextToken();
				if ("siempre".equalsIgnoreCase(s)) {
					por_siempre=true;
				}
			}
		}
		parenthesis_always=translator.isTrue(paramContent[DescartesAConfig.ix_parntesisSiempre]);
		decimales=BasicStr.parseInteger(paramContent[DescartesAConfig.ix_decimales],2,2);
		an_cfg.setDecimals(decimales);
		font_type=paramContent[DescartesAConfig.ix_fuente_tipo];
		if (!BasicStr.hasContent(font_type)) {
			font_type="Serif";
		}
		altura_paso=paramContent[DescartesAConfig.ix_altura_paso];
		font_points=paramContent[DescartesAConfig.ix_fuente_puntos];
	}

//	void setConfig(String cfg) {
//		controles="no";
//		String str_por="punto,no_siempre";
//		if (str_por!=null) {
//			StringTokenizer st=new StringTokenizer(str_por,", ");
//			if (st.hasMoreTokens()) {
//				String s=st.nextToken();
//				if ("aspas".equals(s)) {
//					por_str="\u00d7";
//				} else if ("\u00d7".equals(s)) {
//					por_str="\u00d7";
//				} else if ("punto".equals(s)) {
//					por_str="";
//				} else if (".".equals(s)) {
//					por_str="";
//				} else if ("asterisco".equals(s)) {
//					por_str="*";
//				} else if ("*".equals(s)) {
//					por_str="*";
//				} else {
//					por_str="";
//				}
//			}
//			if (st.hasMoreTokens()) {
//				String s=st.nextToken();
//				if ("siempre".equalsIgnoreCase(s)) {
//					por_siempre=true;
//				}
//			}
//		}
//		parenthesis_always=false;
//		decimales=2;
//		an_cfg.setDecimals(decimales);
//		font_type="SansSerif";
//		if (!BasicStr.hasContent(font_type)) {
//			font_type="Serif";
//		}
//		altura_paso="3";
//		font_points="25";
//
//	}


	
/* ------------------ Graphic Interface Objects ------------------- */

	Panel EEP;
	TextField TF0=new TextField(30),
				TF=new TextField(30);
	Label lbl_exerinfo=new Label();
	Label lbl_serinfo=new Label();
	Label lbl_exereval=new Label();
	Label lbl_sereval=new Label();

	Button
			b_nextE,
			b_prevE,
			b_nextS,
			b_prevS,
			b_repeatE,
			b_repeatS,
			b_undo,
			b_redo;



//	JScrollPane ScrP;
	Panel ScrP=new Panel();
	JScrollBar jsb=new JScrollBar(JScrollBar.VERTICAL);
	Panel MP;
//	GridBagConstraints gbc=new GridBagConstraints();
	TFont eqTFont;

/* ---------------------- Graphic Interface ------------------------ */

	public void build() {
		removeAll();
		setBackground(eqBC);
		fuente_puntos=BasicStr.parseInteger(font_points,25,25);
		H_step=BasicStr.parseDouble(altura_paso,2,2)+1;
		mjaFont eqFont=new mjaFont(font_type,Font.PLAIN,fuente_puntos);
		setFont(eqFont.getAwtFont());
		eqTFont=new TFont(eqFont);
		setLayout(new BorderLayout());
		MP=new Panel();
		MP.setBackground(eqBC);
		MP.setLayout(new GridBagLayout());
		ScrP.setBackground(eqBC);
		ScrP.setLayout(null);
		ScrP.addMouseListener(this);

		b_nextE=new Button(">");
		b_repeatE=new Button("R");
		b_prevE=new Button("<");
		b_nextS=new Button(">>");
		b_repeatS=new Button("R");
		b_prevS=new Button("<<");
		b_undo=new Button("-");
		b_redo=new Button("+");

		b_undo.setFont(Monospaced_15);
		b_redo.setFont(Monospaced_15);

		b_prevE.addActionListener(this);
		b_repeatE.addActionListener(this);
		b_nextE.addActionListener(this);
		b_prevS.addActionListener(this);
		b_repeatS.addActionListener(this);
		b_nextS.addActionListener(this);
		b_undo.addActionListener(this);
		b_redo.addActionListener(this);

		lbl_serinfo.setBackground(DescartesAConfig.scColor);
		lbl_serinfo.setAlignment(Label.LEFT);
		lbl_serinfo.addMouseListener(this);
		lbl_exerinfo.setBackground(DescartesAConfig.seColor);
		lbl_exerinfo.setAlignment(Label.LEFT);
		lbl_exerinfo.addMouseListener(this);
		
		lbl_sereval.setBackground(DescartesAConfig.scColor);
		lbl_sereval.setAlignment(Label.RIGHT);
		lbl_sereval.addMouseListener(this);
		lbl_exereval.setBackground(DescartesAConfig.seColor);
		lbl_exereval.setAlignment(Label.RIGHT);
		lbl_exereval.addMouseListener(this);


		Panel PN=new Panel();
		PN.setFont(bFont);
		PN.setLayout(new BorderLayout());
		Panel PC=new Panel();
		PC.setLayout(new GridLayout(2,1));
		lbl_serinfo.setText("");
		lbl_exerinfo.setText("");
		lbl_sereval.setText("");
		lbl_exereval.setText("");
		PC.add(lbl_serinfo);
		PC.add(lbl_exerinfo);
		PN.add("Center",PC);
		if (an_cfg.nextExercise==ANodeConfig.auto) {
			Panel PE=new Panel();
			PE.setLayout(new GridLayout(2,1));
			PE.add(lbl_sereval);
			PE.add(lbl_exereval);
			PN.add("East",PE);
		} else {
			Panel PW=new Panel();
			Panel PE=new Panel();
			PW.setLayout(new GridLayout(2,1));
			PE.setLayout(new GridLayout(2,1));
			PW.add(b_undo);
			PW.add(b_redo);
			Panel PEN=new Panel();
			Panel PES=new Panel();
			PEN.setLayout(new GridLayout(1,3));
			PES.setLayout(new GridLayout(1,3));
			PEN.add(b_prevS);
			PEN.add(b_repeatS);
			PEN.add(b_nextS);
			PES.add(b_prevE);
			PES.add(b_repeatE);
			PES.add(b_nextE);
			PE.add(PEN);
			PE.add(PES);
			PN.add("West",PW);
			PN.add("East",PE);
		} 

		if ("arriba".equals(controles)) {
			add("North",PN);
		} else if ("abajo".equals(controles)){
			add("South",PN);
		}
		Panel GP=new Panel();
//		GP.setBackground(Color.blue);
		if (arbol_visible) {
			GP.setLayout(new GridLayout(1,2));
			if ("solo".equalsIgnoreCase(arbol)) {
				GP.setLayout(new GridLayout(1,1));
				GP.add(TC);
			} else if ("izquierda".equalsIgnoreCase(arbol)) {
				GP.setLayout(new GridLayout(1,2));
				GP.add(TC);
				GP.add(ScrP);
			} else {
				GP.setLayout(new GridLayout(1,2));
				GP.add(ScrP);
				GP.add(TC);
			}
		} else {
			GP.setLayout(new GridLayout(1,1));
			GP.add(ScrP);
		}
		add("Center",GP);
		MP.addMouseListener(this);
		jsb.setMaximum(0);
		jsb.setVisibleAmount(50);
		jsb.setValue(0);
		jsb.setVisible(false);
		add("East",jsb);
		jsb.addAdjustmentListener(this);
	}
	
/* ------------------------ Start - Stop - Restart -------------------- */

	private int initialExercise=0;

	public void start(int sn,int en) {
		updateProposedDimension();
		ser_num=sn;
		if (DAC!=null) {
			DAC.updateSize();
		}
		initialExercise=en;
		starting=true;
		thr=new Thread(this);
		thr.start();
	}
	
	public void start() {
		super.start();
		start(0,0);
	}

	public void stop() {
		if (FEC!=null) {
			FEC.setEditing(false);
			FEC.stop();
			FEC=null;
		}
		if (EFEC!=null) {
			EFEC.setEditing(false);
			EFEC.stop();
			EFEC=null;
		}
	}

	public void destroy() {
		if (DAC!=null) {
			DAC.setVisible(false);
			DAC.destroy();
			DAC.dispose();
			DAC=null;
		}
		mjaText.destroy();
		super.destroy();
	}

	public void restart() {
		stop();
		build();
		start();
	}


/* ------------------------- Runnable  ------------------------ */

	private Thread thr;
	private boolean pleaseStop;
	private volatile boolean evaluation=false, starting=false, autorun=false;
	
	private boolean inEvaluation() {
		return evaluation;
	}

	private boolean inAutorun() {
		return autorun;
	}

	private boolean isStarting() {
		return starting;
	}

	void doStart() {
		if (thr==null) {
			autorun=true;
			thr=new Thread(this);
			thr.start();
		} else {
			Exception e=new Exception("thr is still running");
			e.printStackTrace();
		}
	}

	void doStop() {
		pleaseStop=true;
		int n=0;
		while (thr()!=null && n++<10) {
			try {
				Thread.sleep(500);
			} catch (InterruptedException ex) {
			}
		}
	}

	private boolean mustStop() {
		return pleaseStop;
	}
	
	private Thread thr() {
		return thr;
	}
	
	public void run() {
		pleaseStop=false;
		try {
			if (isStarting()) {
				try {
					boolean waited=false;
					while (true) {
						Thread.sleep(100);
						startSeries(initialExercise);
						if (FEC!=null && FEC.start()) {
							updateEnablings();
//							if (waited) {
//								System.out.println("Descartes A started");
//							}
							break;
						} else if (!waited) {
//							System.out.println("Descartes A not started, waiting ...");
							waited=true;
						}
					}
				} catch (InterruptedException e) {
				}
				starting=false;
			} else if (inEvaluation()) {
				Evaluate();
				evaluation=false;
			} else if (inAutorun()) {
				while (!mustStop()) {
					if (mode==SeriesConfig.auto) {
						if (serie[ser_num].isGuided()) {
							Thread.sleep(2000);
						} else {
							Thread.sleep(1000);
							if (sN>0) {
								Thread.sleep(1000);
//								if (!findRule()) {
//									showMsg("Error del autor","No hay regla que aplicar");
//								}
							}
						}
						if (mustStop()) {
							break;
						}
						sN++;
						if (sN>=VSN.size()) { // Ojo: esto es muy delicado para lograr que avance al terminar.
							updateScroll();
							pleaseStop=true;
							thr=null;
							controlExerciseAdvance();
							return;
						}
						activateStep(sN);
					} else {
						break;
					}
				}
			}
		} catch (InterruptedException e) {
		}
		thr=null;
	}
	
/* ----------------------------------------------------------- */
	void updateEnablings() {
		b_nextS.setEnabled(ser_num+1<serie.length
							&&!(an_cfg.nextExercise==ANodeConfig.auto));
		b_prevS.setEnabled(ser_num>0
							&&!(an_cfg.nextExercise==ANodeConfig.auto));
		if (serie!=null && ser_num<serie.length) {
			b_nextE.setEnabled((exer_num+1<serie[ser_num].countExercises()||mode_num+1<serie[ser_num].countModes())
								&&!(an_cfg.nextExercise==ANodeConfig.auto));
		} else {
			b_nextE.setEnabled(false);
		}
		b_prevE.setEnabled((exer_num>0||mode_num>0)
							&&!(an_cfg.nextExercise==ANodeConfig.auto));
		b_undo.setEnabled(sN>0);
		b_redo.setEnabled(sN+1<VSN.size());
	}

/* -------------------------------------------------------------------- */

	void startSeries(int en) {
		mode_num=0;
		exer_num=en;
		resetSteps();
		if (serie!=null && ser_num<serie.length) {
			serie[ser_num].randomize();
			guided=serie[ser_num].isGuided();
			serie[ser_num].reset();
			if (serie[ser_num].countExercises()>0) {
				startExercise();
			}
		}
	}
	
	String getSeriesInfo() {
		return "  Serie "+(ser_num+1)+" de "+serie.length;
	}
	
	String getExerciseInfo() {
		return "  Ejercicio "+userExercise()+" de "+serie[ser_num].countExercises();
	}

	void startExercise() {
		if (serie!=null && serie.length>0) {
			serie[ser_num].getExercise(exer_num).reset();
			resetSteps();
			mode=serie[ser_num].getMode(mode_num);
			if ((mode==SeriesConfig.auto) || (mode==SeriesConfig.mouse)) {
				equiv=exact;
			} else if (mode==SeriesConfig.mousenkbd) {
				equiv=comm;
			} else if (mode==SeriesConfig.kbd) {
				if (guided) {
					equiv=comm;
				} else {
					equiv=numb;
				}
			}
			DH=0;
			setStep(0);
			if (mode==SeriesConfig.auto) {
				for (int i=1;i<serie[ser_num].getExercise(exer_num).countSteps();i++) {
					sN++;
					setStep(i);
				}
			}
			if (mode==SeriesConfig.auto && !serie[ser_num].isGuided()) {
				while (sN>0) {
					deactivateStep(sN--,false);
					activateStep(sN);
				}
				doStart();
			} else {
				sN=0;
				activateStep(sN);
			}
			updateScroll();
			updateProgress();
			if (TC!=null) {
				TC.paint(TC.getGraphics());
			}
		}
	}

	void setStep(int n) {
		if (exer_num<serie[ser_num].countExercises()) {
			setStep(serie[ser_num].getRandomVector(),
					serie[ser_num].getExercise(exer_num).getStep(n).getSExpression(),
					serie[ser_num].getExercise(exer_num).getStep(n).getExplanation());
		}
	}

	void setStep(Vector rnv,String expr,String expl) {
		TF0.setText(expr);
		Node N=parser.Analyse(expr);
		if (N!=null) {
			step=new StepConfig(rnv,parser,N,expl,decimales);
			s_model=step.getSNode().toExpression(true);
			addStep(step);
		}
	}
	
	int dH;

	AEditorCanvas addVisualStep(StepConfig step,boolean separate) {
		if (FEC!=null) {
			FEC.unmarkSegment();
			FEC.stop();
			FEC.setEditing(false);
			FEC.setEnabled(false);
//			FEC.updateSize();
//			FEC.updateScreen();
		}
		AEditorCanvas nEC=createEC();
		nLE=createLE();
		Formula F=new Formula(parser,eqTFont);
		if (step!=null) {
			nLE.setText(step.getExplanation());
			F=NodeToFormula(eqTFont,step.getSNode(),separate);
		}
		nEC.setMainFormula(F);
		nEC.getText().setTopAndBottomMargin(4);
		lastP=new Panel();
		lastP.setLayout(null);
		lastP.add(nEC);
		if (guided) {
			lastP.add(nLE);
		}

		nEC.setEditing(false);
		nEC.setEnabled(false);
		nEC.updateSize();
		int W2=nLE.getSize().width;
//		int W=ScrP.getSize().width-18;
		int W=ScrP.getSize().width;
		int W1=W;
		if (guided) {
			W1=W1-W2;
		}
		dH=nEC.getSize().height;
		DH=Math.max(DH,dH);
		nEC.setBounds(0,0,W1,dH);
		if (guided) {
			nLE.setBounds(W1,0,W2,dH);
		}

		ScrP.remove(MP);
//		lastP.setBounds(0,H,ScrP.getSize().width-18,dH);
		lastP.setBounds(0,H,ScrP.getSize().width,dH);
		MP.add(lastP);
		H+=dH;
		MP.setBounds(0,-jsb.getValue(),ScrP.getSize().width,Math.max(H+DH,ScrP.getSize().height));
//		MP.setBounds(0,0,ScrP.getSize().width,Math.max(H,ScrP.getSize().height));
		ScrP.add(MP);
		return nEC;
	}
	
	AEditorCanvas createEC() {
		AEditorCanvas EC=new AEditorCanvas(this,EF,Tr,parser,eqTFont,eqFC,
											an_cfg,por_str,por_siempre,parenthesis_always);
		EC.setMultStr(por_str);
		int Hmin=fuente_puntos/2+(int) Math.round(fuente_puntos*H_step);
		EC.setMinimumHeight(Hmin);
		EC.setBackground(eqBC);
		EC.setFormulaColors(new TColors(eqBC,eqFC));
		EC.addActionListener(this);
		EC.addMouseListener(this);
		EC.addKeyListener(this); // new 20-04-2006
		EC.setLayout(null);
		return EC;
	}

	mjaLineEditor createLE() {
//		int W2=((ScrP.getSize().width-17)*2)/5;
		int W2=((ScrP.getSize().width)*2)/5;
		int Hmin=8+(int) Math.round(fuente_puntos*H_step);
		mjaLineEditor LE=new mjaLineEditor(W2,Hmin,14,false,decimales,false,0);
		LE.setAlignment(data.a_left);
		LE.setAdjust(data.wrap);
		LE.setFont(explFont);
		LE.setBackground(DescartesAConfig.apColor);
		LE.setForeground(explFC);
		LE.setSize(W2,Hmin);
		LE.setInitialPoint(5,8);
		LE.addMouseListener(this);
		return LE;
	}

/* ----------------------------------------------------------- */

	int verifySelected(String l_expr,String o_expr) {
//System.out.println("verifySelected_0: "+l_expr+" =? "+o_expr);
		try {
			Node M=parser.Analyse(o_expr);
			M.setDecimals(decimales);
			String obj_expr=M.toExpression(true);
			Node N=parser.Analyse(l_expr);
			N.setDecimals(decimales);
			String usr_expr=N.toExpression(true);
			if (equiv==comm) {
				usr_expr=Node_A.toCommCanonicalForm(N);
				obj_expr=Node_A.toCommCanonicalForm(M);
			}
//System.out.println("verifySelected_1: "+usr_expr+" =? "+obj_expr);
			if (obj_expr.equals(usr_expr)) {
				return 1;
			}
		} catch (Exception e) {
			showMsg("Error",e.getMessage());
		}
//System.out.println("verifySelected returns 0");
		return 0;
	}

	int verifyAll(String l_expr,boolean all) {
//System.out.println("verifyAll "+l_expr);
		try {
			Node N=parser.Analyse(l_expr);
			N.setDecimals(decimales);
			String usr_expr=N.toExpression(true);
			if (equiv==comm) {
				usr_expr=Node_A.toCommCanonicalForm(N);
			}
			for (int i=1;esN+i<serie[ser_num].getExercise(exer_num).countSteps();i++) {
				Node objN=parser.Analyse(serie[ser_num].getSExpression(exer_num,esN+i));
				objN.setDecimals(decimales);
				String obj_expr=objN.toExpression(true);
				if (equiv==comm) {
					obj_expr=Node_A.toCommCanonicalForm(objN);
				}
//System.out.println("verifyAll ("+i+"): "+obj_expr+" =? "+usr_expr);
				if (obj_expr.equals(usr_expr)) {
					return i;
				}
				if (!all) {
					break;
				}
			}
		} catch (Exception e) {
			showMsg("Error",e.getMessage());
		}
//System.out.println("verifyAll returns 0");
		return 0;
	}

	int checkNumerically(String wexpr,String s_model) {
//System.out.println("check numerically: "+s_model+" =? "+wexpr);
		int ok=0;
		String title="";
		String msg=null;
		try {
			Node userN=parser.Analyse("DescartesA",wexpr,false,false);
			userN.setDecimals(decimales);
			Node nm=parser.Analyse("DescartesA",s_model,false,false);
			nm.setDecimals(decimales);
			if (parser.areNumericallyEqual(nm,userN)) {
				ok=1;
			} else {
				if (userN.getSymb()==Node.IGUAL && nm.getSymb()==Node.IGUAL) {
					title="Advertencia";
					msg="  Quizs haya un error,\no tal vez te has saltado pasos.  ";
				} else {
					title="Error";
					msg=s_model;
					msg+="  "+ANode.getPrettySymbol("#")+"  ";
					msg+=wexpr;
				}
			}
		} catch (Exception e) {
			msg=e.getMessage();
		}
		if (msg!=null && !msg.equals("null")) {
			Toolkit.getDefaultToolkit().beep();
			showMsg(title,msg);
		}
		return ok;
	}

/* ----------------------- interface implementations ------------------------- */

	public void actionPerformed(ActionEvent e) {
		doStop();
		Object s=e.getSource();
		if (s==b_repeatE) {
			startExercise();
		} else if (s==b_repeatS) {
			startSeries(0);
		} else if (s==b_prevE) {
			if (mode_num>0) {
				mode_num--;
				startExercise();
			} else if (exer_num>0) {
				mode_num=serie[ser_num].countModes()-1;
				exer_num--;
				startExercise();
			}
		} else if (s==b_nextE) {
			if (mode_num+1<serie[ser_num].countModes()) {
				mode_num++;
				startExercise();
			} else if (exer_num+1<serie[ser_num].countExercises()) {
				mode_num=0;
				exer_num++;
				startExercise();
			}
		} else if (s==b_prevS && ser_num>0) {
			ser_num--;
			exer_num=0;
			mode_num=0;
			startSeries(0);
		} else if (s==b_nextS && ser_num+1<serie.length) {
			ser_num++;
			exer_num=0;
			mode_num=0;
			startSeries(0);
		} else if (s==b_undo) {
			if (sN>0) {
				deactivateStep(sN--,false);
				activateStep(sN);
			}
		} else if (s==b_redo) {
			if (sN+1<VSN.size()) {
				deactivateStep(sN++,true);
				activateStep(sN);
			}
		} else if (s==FEC) {
			Formula F=FEC.getFormula();
			if (F!=null) {
				Node N=F.getNode();
				if (N!=null) {
					if (arbol_visible) {
						TC.Ns=N;
						TC.paint(TC.getGraphics());
					}
					if ("single_click".equals(e.getActionCommand())) {
						if (mode!=SeriesConfig.auto) {
							removeSteps(sN+1);
						}
						setEditableFormula();
						updateScroll();
						if (an_cfg.associateOnClick) {
							ANode AN=new ANode(N,an_cfg);
							if (!AN.isVar()) {
								performOperation(true,false,N);
							}
						}
					} else if ("right_click".equals(e.getActionCommand())) {
						ANode AN=new ANode(N,an_cfg);
						userAN=AN.userModified(p);
						performOperation();
					} else if ("double_click".equals(e.getActionCommand())) {
//						if (!arbol_visible || N.isBasicBinaryOperation() || an_cfg.associateOnDoubleClick ) {
//						Condicin eliminada el 9 de abril de 2009
							performOperation(false,false,N);
//						} 
					} else if ("formula_dragged".equals(e.getActionCommand())) {
						ANode AN=new ANode(N,an_cfg);
						performOperation(false,true,N);
					}
				}
			}
		} else if (s==EFEC) {
			if ("Verify".equalsIgnoreCase(e.getActionCommand())) {
				performOperation();
			}
		}
		updateEnablings();
	}
	
	void showSolution(int x,int y) {
		if (esN+1<serie[ser_num].getExercise(exer_num).countSteps()) {
			serie[ser_num].getExercise(exer_num).addStep();
			serie[ser_num].getExercise(exer_num).addError();
			Node N=parser.Analyse(serie[ser_num].getSExpression(exer_num,esN+1));
			ANode AN=new ANode(N,an_cfg);
			UserSelection.showFormula(p,AN,x,y);
		}
	}

/* ---------------------- Mouse Listener  --------------------- */

	private calcWin calculadora;
	private MouseEvent ea;

	public void mouseClicked(MouseEvent e) {
		if (e.getClickCount()==1) {
			if (e.getModifiers()==MouseEvent.BUTTON3_MASK) {
				if (e.getSource()==lbl_serinfo) {
					showHelp();
				} else if (e.getSource()==lbl_exerinfo) {
					showCalculator();
				} else if (guided && e.getSource()==nLE) {
					if (esN+1<serie[ser_num].getExercise(exer_num).countSteps()) {
						serie[ser_num].getExercise(exer_num).addStep();
						serie[ser_num].getExercise(exer_num).addError();
						doNextStep(1,serie[ser_num].getSExpression(exer_num,esN+1));
					}
				} else if ((!inD3) && (e.getX()>2*getSize().width/3)) {
					DAC.editSeries();
				}
			} else if (guided && e.getSource()==nLE) {
				showSolution(nLE.getLocationOnScreen().x+e.getX()-100,nLE.getLocationOnScreen().y+e.getY()-75);
			}
			dispatchEvent(e);
		} else if (e.getClickCount()==2) {
			if (e.getSource()==lbl_serinfo) {
				if ((!inD3) && (e.getModifiers()==MouseEvent.BUTTON1_MASK)) {
					DAC.editSeries();
				}
			} else if (e.getSource()==lbl_exerinfo) {
				if (e.getModifiers()==MouseEvent.BUTTON1_MASK) {
					if (e!=ea) {
						if (DAC.editExercise(ser_num,exer_num)) {
							start(ser_num,exer_num);
						}
					}
				}
			}
		}
		ea=e;
	}
	public void mousePressed(MouseEvent e) {
	}
	public void mouseReleased(MouseEvent e) {
	}
	public void mouseEntered(MouseEvent e) {
	}
	public void mouseExited(MouseEvent e) {
	}

/* ---------------- Component Listener ---------------- */

//	public void componentResized(ComponentEvent e) {
//		if (e.getSource()==MP) {
//System.out.println("MP resized");
//			startSeries(ser_num);
//		}
//	}
//
//	public void componentMoved(ComponentEvent e) {}
//
//	public void componentShown(ComponentEvent e) {
//		if (e.getSource()==MP) {
//System.out.println("MP shown");
//			startSeries(ser_num);
//		}
//	}
//
//	public void componentHidden(ComponentEvent e) {}

/* ------------------- Key Listener ------------------- */

	private boolean CtrlOn;

	public void keyPressed(KeyEvent e) {
		CtrlOn =e.isControlDown();
		if (CtrlOn) {
			System.out.println("Control On");
		} else {
			System.out.println("Control Off");
		}
	}
	public void keyTyped(KeyEvent e) {}
	public void keyReleased(KeyEvent e) {
		CtrlOn =e.isControlDown();
		if (CtrlOn) {
			System.out.println("Control On");
		} else {
			System.out.println("Control Off");
		}
	}

/* -------------------- Abstract Nippe ----------------------- */

	public String getParameter(String pn) {
		String name=new String(pn);
		if (Promete==null && BasicStr.hasContent(DAName)) {
			name=DAName+"."+name;
		}
		String res=filterParameter(name);
		if (res!=null) {
			return res;
		}
		return super.getParameter(name);
	}

	public String getInfo(String type,String param) {
		return "";
	}

	public void doAction(String actionName,String actionParam) {
		if ("restart".equalsIgnoreCase(actionName)) {
			startSeries(0);
		} else if ("refresh".equalsIgnoreCase(actionName)) {
			startExercise();
		} else if ("nextSeries".equalsIgnoreCase(actionName)) {
			nextSeries();
		} else if ("siguiente".equalsIgnoreCase(actionName)||"nextExercise".equalsIgnoreCase(actionName)) {
			if (exer_num+1<serie[ser_num].countExercises()) {
				nextExercise();
			} else {
				nextSeries();
			}
		} else if ("prevSeries".equalsIgnoreCase(actionName)) {
			prevSeries();
		} else if ("anterior".equalsIgnoreCase(actionName)||"prevExercise".equalsIgnoreCase(actionName)) {
			if (exer_num>0) {
				exer_num--;
				startExercise();
			} else {
				if (ser_num>0) {
					ser_num--;
				}
				startSeries(serie[ser_num].countExercises()-1);
			}
		} else if ("setExercise".equalsIgnoreCase(actionName)) {
	        String connected_nippe = getParameter("conectar_con_Nippe");
	        if (BasicStr.hasContent(connected_nippe)) {
	            comm c = new comm(this);
                if (c.openCommTo(connected_nippe)) {
                	StringTokenizer st=new StringTokenizer(actionParam," ");
                	String param_contents=c.getInfo(st.nextToken(),"");
                	param_contents=" \n\n"+param_contents+"| ";
                	String ser_cfg="";
                	if (st.hasMoreTokens()) {
                		String str=st.nextToken();
                		ser_cfg=c.getInfo(str,"");
                	}
					setSeries(param_contents,ser_cfg,"");
                }
            }
//		} else if ("setSeries".equalsIgnoreCase(actionName)) {
//	        String connected_nippe = getParameter("conectar_con_Nippe");
//	        if (BasicStr.hasContent(connected_nippe)) {
//	            comm c = new comm(this);
//                if (c.openCommTo(connected_nippe)) {
//                	String param_contents=c.getInfo(actionParam,"");
//					param_contents=BasicStr.replace(param_contents,"\\n","\n");
//					setSeries(param_contents,"","");
//                }
//            }
		}
	}

	/* -------------- Adjustment Listener ------------- */

	public void adjustmentValueChanged(AdjustmentEvent e) {
		jsb.setMaximum(MP.getSize().height-ScrP.getSize().height);
		jsb.setVisibleAmount(20);
		MP.setLocation(0,-jsb.getValue());
	   	ScrP.invalidate();
	   	ScrP.repaint(10);
	}

/* ----------------------- Explainer ------------------------- */

	public String getExplLabel(MouseEvent e) {
		return "";
	}

	public String getExplanation(MouseEvent e){
		return "";
	}

	/* ------------------- Perform Operations ------------------ */

	ANode userAN;

	boolean findRule() {
		StepConfig step0=(StepConfig) VSN.elementAt(sN-1);
		StepConfig step1=(StepConfig) VSN.elementAt(sN);
		int x=FEC.getLocationOnScreen().x+FEC.getSize().width/4;
		int y=FEC.getLocationOnScreen().y+FEC.getSize().height/4;
		while (!mustStop()) {
			ANode AN0= new ANode(step0.getSNode(),an_cfg);
			ANode AN1= new ANode(step1.getSNode(),an_cfg);
System.out.println("findModified "+AN0.toExpression(true)+" ? "+AN1.toExpression(true));
			ANode ANm=AN0.findModifiedANode(AN1);
			if (ANm==null) {
				Toolkit.getDefaultToolkit().beep();
				return false;
			}
			ANode ANM=ANm.performOperation(0,false,an_cfg.associateOnDoubleClick,true,false,true,x,y,"Qu operacin se us?");
			if (ANM==null) {
				doStop();
				break;
			}
System.out.println(ANm.toExpression(true)+" --> "+ANM.toExpression(true));
			if (ANM!=ANm) {
				Node PN=(Node) AN0.getNode().cloneAndReplaceEquals(ANm.getNode(),ANM.getNode());
System.out.println(PN.toExpression(true)+" =? "+AN1.getNode().toExpression(true) );
				if (PN.toExpression(true).equals(AN1.getNode().toExpression(true) )) {
System.out.println(PN.toExpression(true)+" == "+AN1.getNode().toExpression(true) );
					break;
				} else {
System.out.println(PN.toExpression(true)+" != "+AN1.getNode().toExpression(true) );
					Toolkit.getDefaultToolkit().beep();
					try {
						Thread.sleep(250);
					} catch (Exception e) {
						return false;
					}
				}
			}
System.out.println("");
		}
		return true;
	}

	public void performOperation() {
		performOperation(false);
	}

	public void performOperation(boolean onlyAssoc) {
		performOperation(onlyAssoc,false);
	}

	void performOperation(boolean onlyAssoc,boolean dragged) {
		performOperation(onlyAssoc,dragged,null);
	}

	void performOperation(boolean onlyAssoc,boolean dragged,Node ns) {
		String l_expr="",o_expr="";
		Formula MF=FEC.getMainFormula();
		Formula F=FEC.getFormula();
		Node Ns=F.getNode();
		if (ns!=null) {
			Ns=ns;
		}
		if (!onlyAssoc && TC!=null && ns!=null) {
			TC.animate();
			while (TC.thr!=null) {
				try {
					Thread.sleep(100);
				} catch (InterruptedException e) {
				}
			}
		}
		boolean ok=false;
		int numOptions=1;
		int n=0;
		ANode AN=null;
		do {
			if (usesMouse()){
				if (Ns==null) {
					System.out.println("Ns==null");
					return;
				}
				Node MN=MF.getNode();
	//			N=parser.Analyse(Ns.toExpression());  hay que probar si genera algo diferente.
				AN=new ANode(Ns,an_cfg);
				ANode AN0=AN;
				if (userAN!=null&&!dragged) {
					AN=userAN;
					userAN=null;
				} else {
					int x=0,y=0;
					try { // por si no se est mostrando en la pantalla;
						x=FEC.getLocationOnScreen().x+FEC.getSize().width/4;
						y=FEC.getLocationOnScreen().y+FEC.getSize().height/4;
					} catch (Exception e) {
					}
					if (mode==SeriesConfig.mouse && dragged) {
						AN=FEC.performDragOperation(onlyAssoc,userSelectsOption()&&!usesKbd(),
													an_cfg.showResult,an_cfg.showRule,x,y,"Operaciones posibles");
						if (AN==null) {
							AN=AN0;
						}
					} else {
						ANode AN1=AN.performOperation(n,onlyAssoc,an_cfg.associateOnDoubleClick,userSelectsOption()&&!usesKbd(),
												an_cfg.showResult,an_cfg.showRule,x,y,"Operaciones posibles");
						numOptions=AN.countResults;
						AN=AN1;
					}
				}
				if (AN==null || AN==AN0 || AN.equals(AN0)) {
					return;
				}
				if (!onlyAssoc && AN.equals(AN0)) {
					System.out.println(AN0.toExpression(true)+" NOT Modified!");
					Toolkit.getDefaultToolkit().beep();
					return;
				}
				Node PN=null;
				if (dragged) {
					PN=AN.getNode();
				} else {
					PN=(Node) MN.cloneAndSubstitute(Ns,AN.getNode());
				}
				if (onlyAssoc) {
					FEC.setMainFormula(NodeToFormula(eqTFont,PN,true));
					FEC.setActiveFormulaAtNode(AN.getNode());
					if (arbol_visible) {
						TC.paintSlowly();
					} else {
						FEC.updateScreen();
					}
					return;
				}
				l_expr=PN.toExpression(true);
				o_expr=l_expr;
			} else {
				o_expr=s_model;
			}
			if (usesKbd()) {
				Formula EFM=EFEC.getMainFormula();
				l_expr=EFM.toExpresion(true);
			}
			int incStep=0;
			if (mode==SeriesConfig.kbd) {
				if (guided) {
					incStep=verifyAll(l_expr,userSelectsOption()/*&&!usesKbd()*/); //eliminado el 2007-03-26
				} else {
					incStep=checkNumerically(l_expr,o_expr);
				}
			} else if (mode==SeriesConfig.mouse) {
				if (guided) {
					incStep=verifyAll(l_expr,userSelectsOption()&&!usesKbd());
				} else {
					incStep=1;
	//				incStep=checkNumerically(l_expr,s_model);	//para detectar errores de ANode
				}
			} else if (mode==SeriesConfig.mousenkbd) {
				if (guided) {
					incStep=verifyAll(l_expr,userSelectsOption()&&!usesKbd());
				} else {
					incStep=verifySelected(l_expr,o_expr);
				}
			}
			ok=incStep>0;
			if (ok) {
				serie[ser_num].getExercise(exer_num).addStep();
				s_model=l_expr;
				doNextStep(incStep,l_expr);
			} else {
				serie[ser_num].getExercise(exer_num).addError();
				updateProgress();
				Toolkit.getDefaultToolkit().beep();
			}
		} while (!ok && n++<numOptions);
		if (arbol_visible) {
			if (onlyAssoc || ns!=null && AN!=null && !AN.getNode().isSignedNumber() /*AN.getNode().getType()!=Node.Vi*/ ) {
				TC.paintSlowly();
			} else {
				TC.paint(TC.getGraphics());
			}
		}
	}
	
	void doNextStep(int incStep,String expr) {
		removeSteps(sN+1);
		deactivateStep(sN,true);
		sN++;
		esN+=incStep;

		boolean exerciseFinished=false;
		Node N1=parser.Analyse(expr);
		if (serie[ser_num].getExercise(exer_num).countSteps()>1) {
			int SL=serie[ser_num].getSExpressions(exer_num).length;
			String final_expr=serie[ser_num].getSExpressions(exer_num)[SL-1];
			Node N2=parser.Analyse(final_expr);
			N1.setDecimals(decimales);
			N2.setDecimals(decimales);
//System.out.println(N1.toExpression(true)+" =? "+N2.toExpression(true));
			exerciseFinished = N1.toExpression(true).equals(N2.toExpression(true));
		} else if (serie[ser_num].getExercise(exer_num).countSteps()==1) {
			ANode AN=new ANode(N1,an_cfg);
			exerciseFinished = AN.isSimple();
		}

		if (doUnaryToBinaryMinus) {
			Node N3=Node.unaryToBinaryMinus(N1,true);
			expr=N3.toExpression(true);
		}

		String expl="";
		if (esN<serie[ser_num].getExercise(exer_num).countSteps()) {
			expl=serie[ser_num].getExercise(exer_num).getStep(esN).getExplanation();
		}
		step=new StepConfig(serie[ser_num].getRandomVector(),parser,expr,expl,decimales);
		addStep(step);
		updateScroll();
		if (exerciseFinished) {
			controlExerciseAdvance();
		} else {
			activateStep(sN);
		}
	}
	
	void controlExerciseAdvance() {
		serie[ser_num].getExercise(exer_num).setDone();
		String msg="";
		if (an_cfg.nextExercise==ANodeConfig.auto) {
			evaluation=true;
			if (thr==null) {
				thr=new Thread(this);
				thr.start();
			}
		}
	}

	void updateProgress() {
		lbl_serinfo.setText(getSeriesInfo()+"  "+serie[ser_num].getInstructions()+" ("+serie[ser_num].getModeAndGuidedStr()+")");
		lbl_exerinfo.setText(getExerciseInfo()+"  "+serie[ser_num].getExercise(exer_num).getInstruction());
		lbl_sereval.setText(getSeriesProgress());
		lbl_exereval.setText(getExerciseProgress());
	}
	
	String getSeriesProgress() {
		return "      Nota = "+NotaMediaEnEscena(ser_num)+"% ";
	}
	
	String getExerciseProgress() {
		String msg="";
		msg+="(Pase: "+serie[ser_num].bienParaAvance()+"  "+serie[ser_num].bienConsecutivosParaAvance()+"C) ";
		msg+=" Bien: "+serie[ser_num].countExercisesOk()+" , "+serie[ser_num].countConsecutiveOks(exer_num)+"C ";
		return msg;
	}
	
	void Evaluate() {
		long dT=750;
		try {
			Thread.sleep(dT);
			String msg="";
			serie[ser_num].getExercise(exer_num).setDone();
			if ( serie[ser_num].countConsecutiveOks(exer_num)>=serie[ser_num].bienConsecutivosParaAvance() 
				|| serie[ser_num].countExercisesOk()>=serie[ser_num].bienParaAvance() ) {
				lbl_sereval.setBackground(DescartesAConfig.scColorLight);
				if (ser_num+1<serie.length) {
					msg+="Serie "+(ser_num+1)+" aprobada con "+(int) Math.round(serie[ser_num].getAverage())+"%.\n";
					msg+="     Pasas a la siguiente.\n";
					msg+="     Tu nota media es de "+NotaMediaEnEscena(ser_num)+"%.\n";
				} else {
					msg+="Felicidades!\n";
					msg+="     Has aprobado este grupo de ejercicios\n";
					msg+="     Tu nota final es de "+NotaMediaEnEscena(ser_num)+"%";
				}
			} else if (exer_num+1<serie[ser_num].countExercises()) {
				lbl_exereval.setBackground(DescartesAConfig.seColorLight);
			} else if (serie[ser_num].getAverage()<serie[ser_num].notaDeRetroceso()) {
				msg+="nota < "+serie[ser_num].notaDeRetroceso();
				if (ser_num>0) {
					msg+="No ests preparado para esta serie.\n";
					msg+="     Regresas a la anterior.\n";
				} else {
					msg+="No ests preparado para este grupo.\n";
					msg+="     Regresa a uno anterior.\n";
				}
			} else {
				msg+="No has aprobado esta serie.\n";
				msg+="     Tendrs que repetirla.\n";
			}
			updateProgress();
			Thread.sleep(dT);
			if (BasicStr.hasContent(msg)) {
				if (ser_num+1<serie.length) {
					showMsg("Informe de la Serie "+ser_num,msg);
				} else {
					showMsg("Informe Final",msg);
				}
			} else {
				Thread.sleep(dT);
			}
			
			if ( serie[ser_num].countConsecutiveOks(exer_num)>=serie[ser_num].bienConsecutivosParaAvance() 
				|| serie[ser_num].countExercisesOk()>=serie[ser_num].bienParaAvance() ) {
				nextSeries();
			} else if (exer_num+1<serie[ser_num].countExercises()) {
				nextExercise();
			} else if (serie[ser_num].getAverage()<serie[ser_num].notaDeRetroceso()) {
				prevSeries();
			} else {
				startSeries(0);
			}
			lbl_sereval.setBackground(DescartesAConfig.scColor);
			lbl_exereval.setBackground(DescartesAConfig.seColor);
		} catch (InterruptedException e) {
		}
	}

	void prevSeries() {
		if (ser_num>0) {
			ser_num--;
			exer_num=0;
		} else {
			ser_num=0;
			exer_num=0;
		}
		startSeries(0);
	}

	void nextSeries() {
		if (ser_num+1<serie.length) {
			ser_num++;
			exer_num=0;
		} else {
			ser_num=0;
			exer_num=0;
		}
		startSeries(0);
	}

	void nextExercise() {
		mode_num=0;
		exer_num++;
		startExercise();
	}

}