/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.algebra;

import java.util.*;

import com.mja.parser.*;
import com.mja.util.*;
import com.mja.gui.*;


public class UU extends ANode {

	public UU(ANode AN) {
		super(AN.N,AN.an_cfg);
	}

	void perform(Vector V) {
System.out.println("UU.perform on: "+toExpression(false));
		ANode AN=null;
		String msg=symbol+"("+R.symbol+"(A))"; //  uop (uop(A ))
		String cond="";
		
		if (isUnaryPlus()) {
			if (R.isUnaryPlus()) {  //  +(+ A) = A
				AN=Copy(R.R);
				msg=" +( + A )  =  A " ;
			} else if (R.isUnaryMinus()) { // + ( - A ) = - A
				AN=Copy(R);
				msg="+ ( - A ) = - A";
			} else if (R.isAbs()) { // + | A | =  | A |
				AN=Copy(R);
				msg="+ | A | =  | A |";
			} else if (R.isSqrt()) { // + 2 \ A =  2 \ A    // tratado en U
//				AN=Copy(R);
//				msg="+ ( 2 \ A ) =  2 \ A ";
			} else if (R.isSqr()) { // + (A ^ 2) =  (A ^ 2)  // tratado en U
//				AN=Copy(R);
//				msg="+ (A ^ 2) =  (A ^ 2)";
			}
		} else if (isUnaryMinus()) {
			if (R.isUnaryPlus()) {  //  - (+ A) = - A
				AN=Minus(Copy(R.R));
				msg=" - ( + A )  =  - A " ;
			} else if (R.isUnaryMinus()) { // - ( - A ) = A
				AN=Copy(R.R);
				msg=" - ( - A ) =  A";
			} else if (R.isAbs()) { // - | A | =  - | A |     // tratado en U
			} else if (R.isSqrt()) { // - 2 \ A = - 2 \ A     // tratado en U
			} else if (R.isSqr()) { // - (A ^ 2) =  - A ^ 2   // tratado en U
			}
		} else if (isAbs()) {
			if (R.isUnaryPlus()) {  //  | + A | = | A |
				AN=Abs(Copy(R.R));
				msg=" | + A | =  | A | " ;
			} else if (R.isUnaryMinus()) { // | - A | = | A |
				AN=Abs(Copy(R.R));
				msg=" | - A | = | A | ";
			} else if (R.isAbs()) { // || A || = | A |
				AN=Copy(R);
				msg=" || A || = | A |";
			} else if (R.isSqrt()) { // | 2 \ A | = 2 \ A    ?
//				AN=Abs(Copy(R));
//				msg="| 2 \ A | = 2 \ A ";
			} else if (R.isSqr()) { // | A ^ 2 | = A ^ 2
				AN=Copy(R);
				msg=" | A ^ 2 | = A ^ 2 ";
			}
		} else if (isSqrt()) {    // HAY CONDICIONALES
			if (R.isUnaryPlus()) {  //  2 \ ( + A ) = 2 \ A , si A > 0 o A = 0
				AN= Sqrt(R.R);
				msg="2 \\ ( + A ) = 2 \\ A , si A > 0 o A = 0" ;
			} else if (R.isUnaryMinus()) { // 2 \ ( - A ) = 2 \ A , si A < 0 o A = 0
			} else if (R.isAbs()) { // 2 \ ( | A | ) = 4 \ (A ^ 2)
				// ?
			} else if (R.isSqrt()) { // 2 \ (2 \ A) = 4 \ A , si A > 0 o A = 0
				AN= Root(Num(4),R.R);
				msg="2 \\ (2 \\ A) = 4 \\ A , si A > 0 o A = 0";
			} else if (R.isSqr()) { // 2 \ (A ^ 2) = | A |
				AN=Abs(Copy(R.L));
				msg=" 2 \\ (A ^ 2) = | A | ";
			}
		} else if (isSqr() && L==null) {
			if (R.isUnaryPlus()) {  //  ( + A ) ^ 2 = A ^ 2
				AN=Exp(Copy(R.R),Num(2));
				msg="( + A ) ^ 2 = A ^ 2" ; 
			} else if (R.isUnaryMinus()) { // ( - A ) ^ 2 = A ^ 2
				AN=Exp(Copy(R.R),Num(2));
				msg=" ( - A ) ^ 2 = A ^ 2 "; 
			} else if (R.isAbs()) { // ( | A |) ^ 2 = A ^ 2
				AN=Exp(Copy(R.R),Num(2));
				msg="( | A | ) ^ 2 = A ^ 2";
			} else if (R.isSqrt()) { // ( 2 \ A ) ^ 2 = A , si A > 0 o A = 0
				AN= Copy(R.R);
				msg="( 2 \\ A ) ^ 2 = A , si A > 0 o A = 0";
			} else if (R.isSqr()) { // (A ^ 2) ^ 2 = A ^ 4
				AN= Exp(R.R,Num(4));
				msg="(A ^ 2) ^ 2 = A ^ 4";
		
			}
		} else if (isSqr() && L!=null) {
			if (L.isUnaryPlus()) {  //  ( + A ) ^ 2 = A ^ 2
				AN=Exp(Copy(L.R),Num(2));
				msg="( + A ) ^ 2 = A ^ 2" ; 
			} else if (L.isUnaryMinus()) { // ( - A ) ^ 2 = A ^ 2
				AN=Exp(Copy(L.R),Num(2));
				msg=" ( - A ) ^ 2 = A ^ 2 "; 
			} else if (L.isAbs()) { // ( | A |) ^ 2 = A ^ 2
				AN=Exp(Copy(L.R),Num(2));
				msg="( | A | ) ^ 2 = A ^ 2";
			} else if (L.isSqrt()) { // ( 2 \ A ) ^ 2 = A   // si A > 0 o A = 0, pero ocurre si la raz existe
				AN= Copy(L.R);
				msg="( 2 \\ A ) ^ 2 = A , si A > 0 o A = 0";
			} else if (L.isSqr()) { // (A ^ 2) ^ 2 = A ^ 4
				AN= Exp(L.L,Num(4));
				msg="(A ^ 2) ^ 2 = A ^ 4";
		
			}
		}
		if (AN!=null) {
System.out.println("addResult "+V.size()+": "+AN.toExpression(false));
			addResultado(V,AN,msg,cond);
		}
	}
	
}