/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.cmp;
/*
 * @(#)mjaButton.java    1.0   2003/11/26
 *
 * This software is property of MJA
 *
 */
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.font.FontRenderContext;
import java.awt.font.TextLayout;
import java.awt.geom.AffineTransform;
import java.text.AttributedCharacterIterator;
import java.text.AttributedString;
import java.util.*;

import org.unam.matem.Attribute;
//import javax.swing.JButton;

import com.mja.gui.mjaText;
import com.mja.util.BasicStr;
import com.mja.file.mjaFile;
import com.mja.file.mjaFont;

public class mjaButton extends mjaComponent implements MouseListener , Runnable /*, ActionListener*/ {

	public static final int pause=-1,play=0,stop=1,rewind=2,back=3,next=4,toend=5,other=6;
	public static final String[] args={"play/pause","stop","rewind","back","next","toend","" };
	private static final Color 
		transpGray=new Color(0x00,0x00,0x00,0x10),
		overColor=new Color(0x00,0x00,0x80,0x08);
		
	public int type;

	private int w=-1,h=-1,w1,h1,w2,h2,dw,dh,ddw;
	private Polygon Pplay,Pback1,Pback2,Pnext1,Pnext2;
	private Vector listeners;
	private String arg;
	private boolean down,over,imaTransp=false;
	private Image ima,ima_over,ima_down;
	private boolean imaCovers;
	private boolean underLine;
	private boolean drawbg;
	private com.mja.gui.mjaColor FCOL,BCOL;
	private Hashtable images;
	private Applet A;
	
	public mjaButton() {
		this("");
	}

	public mjaButton(int type) {
		super();
		this.type=type;
		listeners=new Vector();
		addMouseListener(this);
		if (type>=0&&this.type<args.length) {
			arg=args[type];
		} else {
			arg=args[other];
		}
		setSize(8+16,BasicStr.lineVSize());
	}

	public mjaButton(String label) {
		this(other);
		setLabel(label);
	}
	
	public mjaButton(Hashtable images,Applet A,String label,String imageFile,boolean drawbg) {
		this(label);
		this.A=A;
		this.images=images;
		this.drawbg=drawbg;
		setImage(imageFile);
	}

	public void setImage(String imageFile) {
		imaTransp=false;
		if (BasicStr.hasContent(imageFile) ) {
			drawbg=false;
			if (imageFile.toUpperCase().indexOf("VACIO.GIF")>=0) {
				ima=createImage(w,h);
				imaTransp=true;
			} else {
				ima=mjaFile.loadImage(images,A,imageFile);
				String s=imageFile;
				int n=s.lastIndexOf(".");
				if (n>0) {
					String s_ext=s.substring(n);
					String s_name=s.substring(0,n);
					s_file_over=s_name+"_over"+s_ext;
					s_file_down=s_name+"_down"+s_ext;
					Thread thr=new Thread(this);
					thr.start();
				}
			}
		} else {
			ima=null;
		}
		if (ima!=null) {
			imaCovers= (!BasicStr.hasContent(getLabel())) ;
		} else {
			imaCovers=false;
		}
		imaCovers=imaCovers || imaTransp;
	}

	private String s_file_over="";
	private String s_file_down="";

	public void run() {
			ima_over=mjaFile.loadImage(images,A,s_file_over);
			ima_down=mjaFile.loadImage(images,A,s_file_down);
	}
	
	public void setForeground(Color c) {
		super.setForeground(c);
		buffer=null;
		repaint();
	}
	
	public void setBackground(Color c) {
		super.setBackground(c);
		buffer=null;
		repaint();
	}

	public void forceTranspIfImaExists() {
		if (ima!=null) {
			imaCovers=true;
		}
	}

	public void setLabel(String label) {
		setLabel(label,true);
	}

	public void setLabel(String label,boolean updateSize) {
		arg=label;
		if (updateSize) {
			Graphics g=getGraphics();
			int lb_w=8*arg.length()+20;
			if (g!=null) {
				FontMetrics fm=g.getFontMetrics();
				lb_w=fm.stringWidth(arg)+20;
			}
			setSize(lb_w,getSize().height);
		}
	}

	public void setUnderline(boolean un) {
		underLine=un;
	}

	public void setMjaFCOL(com.mja.gui.mjaColor c) {
		FCOL=c;
	}
	
	public void setMjaBCOL(com.mja.gui.mjaColor c) {
		BCOL=c;
	}
	
	public String getLabel() {
		return arg;
	}

	private Image buffer;
	
	public void resetOverAndDown() {
		down=false;
		over=false;
	}

	private void drawImage(Graphics g,int x,int y) {
		if (!imaTransp) {
			if (down && (ima_down!=null) ) {
				g.drawImage(ima_down,x,y,this);
			} else if (over && ima_over!=null) {
				g.drawImage(ima_over,x,y,this);
			} else {
				g.drawImage(ima,x,y,this);
			}
		}
	}
	
	Image bgimage=null;

	private volatile boolean painting=false;
	private boolean isPainting() {
		return painting;
	}

	public synchronized void paint (Graphics G) {
		if (isPainting() || G==null || getSize().width<=0 || getSize().height<=0) {
			return;
		}
		painting=true;
		if (w!=getSize().width || h!=getSize().height) {
			w=getSize().width; 
			h=getSize().height;
			makePolygons(w,h);
		}
		if (buffer==null || buffer.getWidth(this)!=w || buffer.getHeight(this)!=h) {
			buffer=createImage(w,h);
			bgimage=null;
		}
		if (w>0 && h>0 && buffer!=null) {
			Graphics g=buffer.getGraphics();
			if (imaCovers) {
				super.paint(g);
			}
			g.setFont(getFont());
			Color c;
			if (FCOL!=null) {
				c=FCOL.getAdaptedColor();
			} else {
				c=Color.black;
			}
			g.setColor(c);
			if (isEnabled()) {
				g.setColor(Color.black);
			} else {
				g.setColor(Color.gray);
			}
			switch (type) {
			case pause: 
				g.fillRect(w1,h1,ddw+1,dh); 
				g.fillRect(w2-ddw-1,h1,ddw+1,dh); 
				break;
			case play : 
				g.fillPolygon(Pplay);
				break;
			case rewind : 
				g.fillRect((w/4)-2,h1,2,dh); 
			case back : 
				g.fillPolygon(Pback1); 
				g.fillPolygon(Pback2); 
				break;
			case toend : 
				g.fillRect(w-(w/4)-1,h1,2,dh); 
			case next : 
				g.fillPolygon(Pnext1); 
				g.fillPolygon(Pnext2); 
				break;
			case stop : 
				g.fillRect(w1,h1,dw,dh); 
				break;
			case other :
				if ( drawbg 
					|| ( (getBackground()!=null) && (!imaCovers) && bgimage==null) 
					|| ( (ima==null)&&(!imaTransp) ) ) {
					bgimage=createImage(w,h);
					Graphics bgimg=bgimage.getGraphics();
					if (BCOL!=null) {
						bgimg.setColor(BCOL.getAdaptedColor());
					} else {
						bgimg.setColor(Color.white);
					}
					bgimg.fillRect(0,0,getSize().width,getSize().height);
					bgimg.setColor(new Color(0,0,0,0x40));
					bgimg.drawLine(w-1,0,w-1,h);
					bgimg.setColor(new Color(0,0,0,0x30));
					bgimg.drawLine(w-2,0,w-2,h);
					bgimg.setColor(new Color(0,0,0,0x20));
					bgimg.drawLine(0,0,0,h);
					bgimg.setColor(new Color(0,0,0,0x10));
					bgimg.drawLine(1,0,1,h);
					bgimg.drawLine(w-2,0,w-2,h);
					int hh=h*h;
					for (int i=0;i<h;i++) {
						int di=(i-(35*h)/100);
						bgimg.setColor(new Color(0,0,0,(di*di*192)/hh));
						bgimg.drawLine(0,i,w-1,i);
					}
				}
				boolean shift=down && (ima_down==null);
				Color fcol;
				if (FCOL!=null) {
					fcol=FCOL.getAdaptedColor();
				} else {
					fcol=Color.black;
				}
				g.setColor(fcol);
				Color bcol;
				if (BCOL!=null) {
					bcol=BCOL.getAdaptedColor();
				} else {
					bcol=Color.white;
				}
				g.setFont(getFont());
				FontMetrics fm=g.getFontMetrics();
				int fh=fm.getHeight();
				if (ima!=null) {
					int x=(getSize().width-ima.getWidth(this))/2;
					int y=(getSize().height-ima.getHeight(this))/2;
					if (y<=(fh+2)/2) {
						imaCovers=true;
					} else {
						y=(getSize().height-ima.getHeight(this)-fh+4)/2;
					}
					if ( getBackground()!=null && BasicStr.hasContent(arg) 
						&& (!arg.equalsIgnoreCase("_no_")) 
						&& (!arg.equalsIgnoreCase("_nada_")) 
						&& (!arg.equalsIgnoreCase("_._")) 
						&& ((!imaCovers)||drawbg) )  {
						if (!imaTransp) {
							g.setColor(BCOL.getAdaptedColor());
							g.fillRect(0,0,getSize().width,getSize().height);
							if (over) {
								g.setColor(overColor);
								g.fillRect(0,0,getSize().width,getSize().height);
							}
							g.setColor(FCOL.getAdaptedColor());
							g.drawRect(0,0,getSize().width-1,getSize().height-1);
						}
						drawImage(g,x+(down?1:0),y+(down?1:0));
						int sh=fm.getMaxDescent();
						Point p = new Point((w-fm.stringWidth(arg))/2+(down?1:0),getSize().height-sh-2-((underLine)?2:0)+(down?1:0));
						mjaFont.drawTextBorder((Graphics2D)g,arg,p,bcol);
						g.drawString(arg,p.x,p.y);
						int sw=fm.stringWidth(arg);
						if (underLine) {
							g.drawLine(p.x,p.y+sh,p.x+sw,p.y+sh);
						}
						break;
					} else {
						if (over&!imaTransp) {
							g.setColor(overColor);
							g.fillRect(0,0,getSize().width,getSize().height);
						}
						drawImage(g,x+(shift?1:0),y+(shift?1:0));
						if (down&!imaTransp) { 
							g.setColor(transpGray);
							g.fillRect(x+(shift?1:0),y+(shift?1:0),ima.getWidth(this),ima.getHeight(this));
						}
					}
				} else if (bgimage!=null) {
					g.drawImage(bgimage,0,0,this);
					if (over&!imaTransp) {
						g.setColor(overColor);
						g.fillRect(0,0,getSize().width,getSize().height);
					}
				}
				if (BasicStr.hasContent(arg) && (!arg.equalsIgnoreCase("_no_"))
					&& (!arg.equalsIgnoreCase("_nada_")) && (!arg.equalsIgnoreCase("_._"))) {
					Font font=getFont();
					int sz=font.getSize();
					fm=getFontMetrics(font);
					while (fm.stringWidth(getLabel())+getSize().height/4>getSize().width) {
						sz=sz-1;
						font=mjaFont.makeFont(font.getFamily(),font.getStyle(),sz);
						fm=getFontMetrics(font);
					}
					int y0=(h-fm.getHeight())/2+fm.getAscent()-1;
				    Graphics2D g2=(Graphics2D) g;
				    g2.setFont(font);
					Stroke bs=new BasicStroke(font.getSize()/10,BasicStroke.CAP_ROUND,BasicStroke.JOIN_ROUND);
					g2.setStroke(bs);
				    if ( font.getSize()>17 || (BasicStr.antialias&& font.getSize()>15)) {
					    g2.setRenderingHint(RenderingHints.KEY_STROKE_CONTROL, RenderingHints.VALUE_STROKE_PURE);
					    g2.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
				    }
					g2.setColor(fcol);
					int sw=fm.stringWidth(arg);
					int sh=fm.getMaxDescent();
					int x=(w-sw)/2+(down?1:0);
					int y=y0+(down?1:0);
					mjaFont.drawTextBorder(g2, arg, new Point(x,y),bcol);
					g2.drawString(arg,x,y);
					
					if (underLine) {
						g2.drawLine(x,y+sh,x+sw,y+sh);
					}
					
					if (down && !imaTransp) { 
						g2.setColor(transpGray);
						Point p = new Point((w-fm.stringWidth(arg))/2+(down?1:0),y0+(down?1:0));
						mjaFont.drawTextBorder(g2, arg, p, bcol);
						g2.drawString(arg,p.x,p.y);
						
						if (underLine) {
							g2.drawLine(x,y+sh,x+sw,y+sh);
						}
					}
				    g2.setRenderingHint(RenderingHints.KEY_STROKE_CONTROL, RenderingHints.VALUE_STROKE_DEFAULT);
				    g2.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_OFF);
				}
				break;
			}
			if (down && (ima!=null) && !imaTransp ) { 
				g.setColor(Color.gray); 
				g.drawLine(0,0,0,h-2);
				g.drawLine(0,0,w-1,0); 
				g.setColor(transpGray); 
				g.fillRect(0,0,w,h);
			} 
			g.setColor(c);
			if (!isEnabled() && !imaTransp) {
				g.setColor(new Color(0xf0,0xf0,0xf0,0xa0));
				g.fillRect(0,0,w,h);
			}
			G.drawImage(buffer,0,0,this);
		}
		painting=false;
	}

	private void makePolygons(int w,int h) {
		if (type!=other) {
			int wc=w/2,hc=h/2;
			w1=w/3;h1=h/3;dw=w-2*w1;dh=h-2*h1;w2=w1+dw;h2=h1+dh;
			ddw=w/8;
			switch(type) {
			case pause:
			case play:
				Pplay=new Polygon();
				Pplay.addPoint(w1,h1-1);
				Pplay.addPoint(w2,hc);
				Pplay.addPoint(w1,h2+1);
				break;
			case next:
			case toend:
				Pnext1=new Polygon();
				Pnext1.addPoint(wc-ddw,h1);
				Pnext1.addPoint(wc+ddw,hc);
				Pnext1.addPoint(wc-ddw,h2);
				Pnext1.translate(-ddw-1,0);
				Pnext2=new Polygon();
				Pnext2.addPoint(wc-ddw,h1);
				Pnext2.addPoint(wc+ddw,hc);
				Pnext2.addPoint(wc-ddw,h2);
				Pnext2.translate(ddw,0);
				break;
			case back:
			case rewind:
				Pback1=new Polygon();
				Pback1.addPoint(wc+ddw,h1);
				Pback1.addPoint(wc-ddw,hc);
				Pback1.addPoint(wc+ddw,h2);
				Pback1.translate(-ddw-1,0);
				Pback2=new Polygon();
				Pback2.addPoint(wc+ddw,h1);
				Pback2.addPoint(wc-ddw,hc);
				Pback2.addPoint(wc+ddw,h2);
				Pback2.translate(ddw,0);
				break;
			}
		}
	}
	
	public void setEnabled(boolean en) {
		super.setEnabled(en);
		repaint();
	}

	public void addActionListener(ActionListener  c) {
		listeners.addElement(c);
	}
	
	private void callListeners() {
		Enumeration e=listeners.elements();
		while (e.hasMoreElements()) {
			ActionListener al=(ActionListener) e.nextElement();
			al.actionPerformed(new ActionEvent(this,ActionEvent.ACTION_PERFORMED,arg));
		}	
	}
	
	public void mousePressed(MouseEvent e) {
		requestFocus();
		down=true;
		over=false;
		paint(getGraphics());
		setCursor(null);
		callListeners();
	}
	public void mouseReleased(MouseEvent e) {
		down=false;
		over=(0<e.getX()&&e.getX()<w) && (0<e.getY()&&e.getY()<h) ;
		paint(getGraphics());
	}
	public void mouseEntered (MouseEvent e) {
		down=false;
		over=true;
		paint(getGraphics());
		if (getCursor().getType()==Cursor.DEFAULT_CURSOR) {
			setCursor(new Cursor(Cursor.HAND_CURSOR));
		}
	} 
	public void mouseExited (MouseEvent e) {
		down=false;
		over=false;
		paint(getGraphics());
		if (getCursor().getType()==Cursor.HAND_CURSOR) {
			setCursor(null);
		}
	} 
	public void mouseClicked (MouseEvent e) {
		down=false;
		over=(0<e.getX()&&e.getX()<w) && (0<e.getY()&&e.getY()<h) ;
		paint(getGraphics());
		setCursor(null);
	} 

	
	
}