/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descartes;
import java.applet.*;
import java.util.*;
import java.awt.*;

import com.mja.util.*;
import com.mja.lang.*;
import com.mja.descartes.*;
import common.*;
import org.unam.matem.Attribute;
import org.unam.matem.Communicator;

public class Descartes3 extends com.mja.descartes.Descartes implements DescartesInterface {

	/* ----- public interface for use with JavaScript ----- */

	public void init() {
		super.init();
	}

	/**
	  * Starts the applet.<br>
	  * If called when the applet is running then it re-starts.
	  */

	public void start() {
		super.start();
	}

	/**
	  * Stops the applet.<br>
	  * Disposes external controls window and edit window.
	  */

	public void stop() {
		super.stop();
	}

	public Applet getApplet() {
		return this;
	}

	public String getEvaluation() { 
		return super.getEvaluation(); 
	}

	public String dump() {
		return super.dump();
	}

	public void undump(String dump) {
		super.undump(dump);
	}

	public void showSolution() { 
		super.showSolution(); 
	}
	
	public void showAnswer() { 
		super.showAnswer(); 
	}

	public String Evaluate(String expression) throws Exception { 
		return super.Evaluate(expression); 
	}

	/**
	  * Displays the "about" or Copyright dialog box.
	  */

	public void about() {
		super.about();
	}

	/**
	  * Cleans the screen form any traces left by graphs. <br>
	  * It doesn't change parameter or auxiliary values. <br>
	  * The function may be called while the animation is running. <br>
	  */

	public void clear() {
		super.clear();
	}
	

	/**
	  * Refresheds the scene. <br>
	  * This method redraws the scene without cleaning the trace left by moving graphs.
	  */

	public void refresh() {
		super.refresh(true);
	}

	/**
	  * Recovers the original configuration, i.e. the one provided by the applet parameters.
	  */

	public void original() {
//		Comentado el 060704 porque la creacin de cfg0 requiere mucho tiempo.
//		stop();
//		cfg=cfg0.cloneConfig();
//		getToolsFromConfig();
//		start();
	}

	/**
	  * Continues or pauses animation. <br>
	  * If the animation has not started starts it.<br>
	  * If the animation is running it puts it in "pause" mode.<br>
	  * If the animation is in "pause" mode then it continues running.<br>
	  */

	public void toggleAnimation() {
		super.toggleAnimation();
	}

	/**
	  * Initializes the animation. <br>
	  * It works both on a paused or a running animation.<br>
	  */

	public void initAnimation() {
		super.initAnimation();
	}

	/**
	 * Opens the configuration editor window.
	 */

	public void edit() {
		super.edit(null);
	}

	/* ----------------- Buttons ----------------- */

	/**
	  * Sets the configuration of the buttons.<br>
	  * @param s Configuration String for the buttons.<br>
	  * <br>
	  * A typical form is<br>
	  * <br>
      * s="crditos=si config=no inicio=si limpiar=si"
	  */
	public void setButtons(String s) {
		stop();
		Buttons=new Attribute(Tr.getTr(data.p_buttons),s);
		cfg=new config(this,getAttributesFromTools());
		start();
	}

	/* ----------------- Space ----------------- */

	/**
	  * Sets the configuration of the Descartes space.<br>
	  * If the scene has more than one space, all other spaces are deleted
	  * and the only one remaining is the one defined by this method call.
	  * Note: in order to modify one space of several, use <a href="Descartes.html#replaceSpace(java.lang.String, java.lang.String)">replaceSpace(String, String).</a>
	  * @param s Configuration String for the space.<br>
	  * <br>
	  * A typical form is<br>
	  * <br>
      * s="fondo=blanco red=no red10=gris ejes=gris texto=grisObscuro"
	  */
	public void setSpace(String s) {
		stop();
		Space=new Attribute(Tr.getTr(data.p_space),s);
		cfg=new config(this,getAttributesFromTools());
		start();
	}

	/* ----------------- Spaces ----------------- */

	/**
	  * Removes all spaces from the configuration.<br>
	  */
	public void removeSpaces() {
		stop();
		Spaces=new Vector();
		cfg=new config(this,getAttributesFromTools());
		start();
	}

	/**
	  * Adds a new space object.<br>
	  * @param s Configuration String for the space object.<br>
	  * <br>
	  * Typical forms for s are:<br>
	  * <br>
	  * s="id='E00' R3='false' fondo='negro' red='grisObscuro' red10='gris' nmeros='false' despliegue_del_fondo='arriba-izquierda'" <br>
	  * s="id='E01' R3='true' x='59%' y='53%' ancho='32%' alto='44%' escala='24' O.y='20' fondo='turquesa' despliegue_del_fondo='arriba-izquierda' despliegue='pintor' cortar='true'" <br>
	  * s="id='E02' x='5%' y='5%' ancho='30%' alto='30%' escala='10%' fondo='blanco' red10='gris' ejes='gris'" <br>
	  * s="id='E03' R3='si' x='5%' y='53%' ancho='32%' alto='44%' escala='32' fondo='turquesa'" <br>
	  */
	public void addSpace(String s) {
		if (BasicStr.hasContent(s)) {
			stop();
			Spaces.addElement(new Attribute(data.spacePrefix+BasicStr.IntegerToString(Spaces.size(),2),s));
			cfg=new config(this,getAttributesFromTools());
			start();
		}
	}

	/**
	  * Replaces the num space object.<br>
	  * @param num String representing the number of the space object.<br>
	  * @param s Configuration String for the new space object.<br>
	  * <br>
	  * Typical forms for s are:<br>
	  * s="id='E00' R3='false' fondo='negro' red='grisObscuro' red10='gris' nmeros='false' despliegue_del_fondo='arriba-izquierda'" <br>
	  * s="id='E01' R3='true' x='59%' y='53%' ancho='32%' alto='44%' escala='24' O.y='20' fondo='turquesa' despliegue_del_fondo='arriba-izquierda' despliegue='pintor' cortar='true'" <br>
	  * s="id='E02' x='5%' y='5%' ancho='30%' alto='30%' escala='10%' fondo='blanco' red10='gris' ejes='gris'" <br>
	  * s="id='E03' R3='si' x='5%' y='53%' ancho='32%' alto='44%' escala='32' fondo='turquesa'" <br>
	  * <br>
	  */
	public void replaceSpace(String num,String s) {
		try {
			int n=Integer.parseInt(num);
			if (Spaces.size()>n) {
				stop();
				((Attribute) Spaces.elementAt(n)).value=s;
				cfg=new config(this,getAttributesFromTools());
				start();
			}
		} catch (NumberFormatException e) {
		}
	}

	/**
	  * Returns the num-th space configuration String.<br>
	  * @param num String representing the number of the space object.<br>
	  */
	public String getSpace(String num) {
		try {
			int n=Integer.parseInt(num);
			if (Spaces.size()>n) {
				String s=((Attribute) Spaces.elementAt(n)).value;
				return s;
			} else {
				return null;
			}
		} catch (NumberFormatException e) {
			return null;
		}
	}

	/**
	  * Deletes the num-th space object.<br>
	  * @param num String representing the number of the space object to be deleted.<br>
	  */
	public void deleteSpace(String num) {
		try {
			int n=Integer.parseInt(num);
			if (Spaces.size()>n) {
				stop();
				Spaces.removeElement(Spaces.elementAt(n));
				cfg=new config(this,getAttributesFromTools());
				start();
			}
		} catch (NumberFormatException e) {
		}
	}

	/* ----------------- Controls ----------------- */

	/**
	  * Removes all numerical and graphics controls from the configuration.<br>
	  */
	public void removeControls() {
		stop();
		Controls=new Vector();
		cfg=new config(this,getAttributesFromTools());
		start();
	}

	/**
	  * Adds a new control object.<br>
	  * @param s Configuration String for the control object.<br>
	  * <br>
	  * Typical forms for s are:<br>
	  * <br>
      * s="id=p tipo=numrico valor='1.5' decimales='2' incr='0.1'"<br>
      * s="id=C tipo=grfico expresin='[1,0]' constriccin='x^2+y^2=1' text='([C.x],[C.y])'"<br>
	  */
	public void addControl(String s) {
		if (BasicStr.hasContent(s)) {
			stop();
			Controls.addElement(new Attribute(data.controlPrefix+BasicStr.IntegerToString(Controls.size(),2),s));
			cfg=new config(this,getAttributesFromTools());
			start();
		}
	}

	/**
	  * Replaces the num control object.<br>
	  * @param num String represinting the number of the control object.<br>
	  * @param s Configuration String for the new control object.<br>
	  * <br>
	  * Typical forms for s are:<br>
      * s="id=p tipo=numrico valor='1.5' decimales='2' incr='0.1'"<br>
      * s="id=C tipo=grfico expresin='[1,0]' constriccin='x^2+y^2=1' text='([C.x],[C.y])'"<br>
	  * <br>
	  */
	public void replaceControl(String num,String s) {
		try {
			int n=Integer.parseInt(num);
			if (Controls.size()>n) {
				stop();
				((Attribute) Controls.elementAt(n)).value=s;
				cfg=new config(this,getAttributesFromTools());
				start();
			}
		} catch (NumberFormatException e) {
		}
	}

	/**
	  * Returns the num-th control configuration String.<br>
	  * @param num String represinting the number of the control object.<br>
	  */
	public String getControl(String num) {
		try {
			int n=Integer.parseInt(num);
			if (Controls.size()>n) {
				String s=((Attribute) Controls.elementAt(n)).value;
				return s;
			} else {
				return null;
			}
		} catch (NumberFormatException e) {
			return null;
		}
	}

	/**
	  * Deletes the num-th control object.<br>
	  * @param num String representing the number of the control object to be deleted.<br>
	  */
	public void deleteControl(String num) {
		try {
			int n=Integer.parseInt(num);
			if (Controls.size()>n) {
				stop();
				Controls.removeElement(Controls.elementAt(n));
				cfg=new config(this,getAttributesFromTools());
				start();
			}
		} catch (NumberFormatException e) {
		}
	}

	/* ----------------- Auxiliars ----------------- */

	/**
	  * Removes all auxiliar objects from the configuration.<br>
	  */
	public void removeAux() {
		stop();
		Aux=new Vector();
		cfg=new config(this,getAttributesFromTools());
		start();
	}

	/**
	  * Adds a new auxiliar object.<br>
	  * @param s Configuration String for the auxiliar object.<br>
	  * <br>
	  * Typical forms for s are:<br>
	  * <br>
      * s="id=Ta expresin='0' constante=si evaluar=una-sola-vez"<br>
      * s="id=f(x) expresin='P*cos(x)'"<br>
	  */
	public void addAux(String s) {
		if (BasicStr.hasContent(s)) {
			stop();
			Aux.addElement(new Attribute(data.auxPrefix+BasicStr.IntegerToString(Aux.size(),2),s));
			cfg=new config(this,getAttributesFromTools());
			start();
		}
	}

	/**
	  * Replaces the num-th auxiliar object.<br>
	  * @param num String represinting the number of the auxiliar object.<br>
	  * @param s Configuration String for the new auxiliar object.<br>
	  * <br>
	  * Typical forms for s are:<br>
      * s="id=Ta expresin='0' constante=si evaluar=una-sola-vez"<br>
      * s="id=f(x) expresin='P*cos(x)'"<br>
	  * <br>
	  */
	public void replaceAux(String num,String s) {
		try {
			int n=Integer.parseInt(num);
			if (Aux.size()>n) {
				stop();
				((Attribute) Aux.elementAt(n)).value=s;
				cfg=new config(this,getAttributesFromTools());
				start();
			}
		} catch (NumberFormatException e) {
		}
	}

	/**
	  * Returns the num-th auxiliar configuration String.<br>
	  * @param num String represinting the number of the auxiliar object.<br>
	  */
	public String getAux(String num) {
		try {
			int n=Integer.parseInt(num);
			if (Aux.size()>n) {
				String s=((Attribute) Aux.elementAt(n)).value;
				return s;
			} else {
				return null;
			}
		} catch (NumberFormatException e) {
			return null;
		}
	}

	/**
	  * Deletes the num-th auxiliar object.<br>
	  * @param num String representing the number of the auxiliar object to be deleted.<br>
	  */
	public void deleteAux(String num) {
		try {
			int n=Integer.parseInt(num);
			if (Aux.size()>n) {
				stop();
				Aux.removeElement(Aux.elementAt(n));
				cfg=new config(this,getAttributesFromTools());
				start();
			}
		} catch (NumberFormatException e) {
		}
	}

	/* ----------------- Graphs ----------------- */

	/**
	  * Removes all graphic objects from the configuration.<br>
	  */
	public void removeGraphs() {
		stop();
		Graphs=new Vector();
		cfg=new config(this,getAttributesFromTools());
		start();
	}

	/**
	  * Adds a new graphic object.<br>
	  * @param s Configuration String for the graphic object.<br>
	  * <br>
	  * Typical forms for s are:<br>
	  * <br>
      * s="tipo=ecuacin expresin='y=f(x)' rastro=turquesa"<br>
      * s="tipo=segmento expresin='(-3,-1)(4,3)' color=magenta"<br>
      * s="tipo=curva expresin='(R*t*cos(2*pi*t),R*t*sen(2*pi*t))' color=rojo visible=no parmetro=t t.intervalo=[0,1] t.pasos=32 ancho=3"<br>
      * s="tipo=polgono expresin='(0,0)(1,1)(2,-1)(0,0)' color=gris"<br>
	  */
	public void addGraph(String s) {
		if (BasicStr.hasContent(s)) {
			stop();
			Graphs.addElement(new Attribute(data.graphPrefix+BasicStr.IntegerToString(Graphs.size(),2),s));
			cfg=new config(this,getAttributesFromTools());
			start();
		}
	}

	/**
	  * Replaces the num-th graphic object.<br>
	  * @param num String representing the number of the graphic object.<br>
	  * @param s Configuration String for the new graphic object.<br>
	  * <br>
	  * Typical forms for s are:<br>
	  * <br>
      * s="tipo=ecuacin expresin='y=f(x)' rastro=turquesa"<br>
      * s="espacio='Principal' tipo=segmento expresin='(-3,-1)(4,3)' color=magenta"<br>
      * s="espacio='E01_2D' tipo=curva expresin='(R*t*cos(2*pi*t),R*t*sen(2*pi*t))' color=rojo visible=no parmetro=t t.intervalo=[0,1] t.pasos=32 ancho=3"<br>
      * s="espacio='E02' tipo=polgono expresin='(0,0)(1,1)(2,-1)(0,0)' color=gris"<br>
	  */
	public void replaceGraph(String num,String s) {
		try {
			int n=Integer.parseInt(num);
			if (Graphs.size()>n) {
				stop();
				((Attribute) Graphs.elementAt(n)).value=s;
				cfg=new config(this,getAttributesFromTools());
				start();
			}
		} catch (NumberFormatException e) {
		}
	}

	/**
	  * Returns the num-th graphic configuration String.<br>
	  * @param num String representing the number of the graphic object.<br>
	  */
	public String getGraph(String num) {
		try {
			int n=Integer.parseInt(num);
			if (Graphs.size()>n) {
				String s=((Attribute) Graphs.elementAt(n)).value;
				return s;
			} else {
				return null;
			}
		} catch (NumberFormatException e) {
			return null;
		}
	}

	/**
	  * Deletes the num-th graphic object.<br>
	  * @param num String representing the number of the graphic object to be deleted.<br>
	  */
	public void deleteGraph(String num) {
		try {
			int n=Integer.parseInt(num);
			if (Graphs.size()>n) {
				stop();
				Graphs.removeElement(Graphs.elementAt(n));
				cfg=new config(this,getAttributesFromTools());
				start();
			}
		} catch (NumberFormatException e) {
		}
	}

	/* ----------------- Graphs 3D ----------------- */

	/**
	  * Removes all 3D graphic objects from the configuration.<br>
	  */
	public void remove3DGraphs() {
		stop();
		Graphs3D=new Vector();
		cfg=new config(this,getAttributesFromTools());
		start();
	}

	/**
	  * Adds a new 3D graphic object.<br>
	  * @param s Configuration String for the graphic object.<br>
	  * <br>
	  * Typical forms for s are:<br>
	  * <br>
	  * s="espacio='E01' tipo='Octaedro' color='naranja' color_reverso='rosa' aristas='true' rotini='(180,0,30*(1+C.x))' posini='(0,0,1.5*C.y+1.5)' modelo='luz' cortar='false'" <br>
	  * s="espacio='E01' tipo='Superficie' expresin='x=3*u-1.5 y=3*v-1.5 z=p*(y^2-x^2)/1.5' Nu='Nu' Nv='Nu' color_reverso='rosa' aristas='false' rotini='(0,0,30)' modelo='metal' cortar='false'" <br>
	  * s="espacio='E03' tipo='Superficie' expresin='x=3*u-1.5 y=3*v-1.5 z=0' Nu='Nu' Nv='Nu' color_reverso='rosa' aristas='false' rotini='(0,0,30)' posini='(0,0,-1.5)' modelo='alambre' cortar='false'" <br>
	  * s="espacio='E03' tipo='Paraleleppedo' ancho='3' largo='3' alto='3' color_reverso='rosa' aristas='false' rotini='(0,0,30)' modelo='alambre' cortar='false'" <br>
	  * s="espacio='E03' tipo='Esfera' Nu='Nu' Nv='2*Nu' ancho='2.5' color='naranja' color_reverso='rosa' aristas='true' modelo='luz' cortar='false'" <br>
	  * s="espacio='E01' tipo='macro' expresin='ejes' color_reverso='rosa' aristas='false' rot='(0,0,30)' cortar='false' nombre='mis_ejes'" <br>
	  */
	public void add3DGraph(String s) {
		if (BasicStr.hasContent(s)) {
			stop();
			Graphs3D.addElement(new Attribute(data.graph3Prefix+BasicStr.IntegerToString(Graphs.size(),2),s));
			cfg=new config(this,getAttributesFromTools());
			start();
		}
	}

	/**
	  * Replaces the num-th 3D graphic object.<br>
	  * @param num String representing the number of the graphic object.<br>
	  * @param s Configuration String for the new 3D graphic object.<br>
	  * <br>
	  * Typical forms for s are:<br>
	  * <br>
	  * s="espacio='E01' tipo='Octaedro' color='naranja' color_reverso='rosa' aristas='true' rotini='(180,0,30*(1+C.x))' posini='(0,0,1.5*C.y+1.5)' modelo='luz' cortar='false'" <br>
	  * s="espacio='E01' tipo='Superficie' expresin='x=3*u-1.5 y=3*v-1.5 z=p*(y^2-x^2)/1.5' Nu='Nu' Nv='Nu' color_reverso='rosa' aristas='false' rotini='(0,0,30)' modelo='metal' cortar='false'" <br>
	  * s="espacio='E03' tipo='Superficie' expresin='x=3*u-1.5 y=3*v-1.5 z=0' Nu='Nu' Nv='Nu' color_reverso='rosa' aristas='false' rotini='(0,0,30)' posini='(0,0,-1.5)' modelo='alambre' cortar='false'" <br>
	  * s="espacio='E03' tipo='Paraleleppedo' ancho='3' largo='3' alto='3' color_reverso='rosa' aristas='false' rotini='(0,0,30)' modelo='alambre' cortar='false'" <br>
	  * s="espacio='E03' tipo='Esfera' Nu='Nu' Nv='2*Nu' ancho='2.5' color='naranja' color_reverso='rosa' aristas='true' modelo='luz' cortar='false'" <br>
	  * s="espacio='E01' tipo='macro' expresin='ejes' color_reverso='rosa' aristas='false' rot='(0,0,30)' cortar='false' nombre='mis_ejes'" <br>
	  */
	public void replace3DGraph(String num,String s) {
		try {
			int n=Integer.parseInt(num);
			if (Graphs3D.size()>n) {
				stop();
				((Attribute) Graphs3D.elementAt(n)).value=s;
				cfg=new config(this,getAttributesFromTools());
				start();
			}
		} catch (NumberFormatException e) {
		}
	}

	/**
	  * Returns the num-th 3D graphic configuration String.<br>
	  * @param num String representing the number of the 3D graphic object.<br>
	  */
	public String get3DGraph(String num) {
		try {
			int n=Integer.parseInt(num);
			if (Graphs3D.size()>n) {
				String s=((Attribute) Graphs3D.elementAt(n)).value;
				return s;
			} else {
				return null;
			}
		} catch (NumberFormatException e) {
			return null;
		}
	}

	/**
	  * Deletes the num-th 3D graphic object.<br>
	  * @param num String representing the number of the 3D graphic object to be deleted.<br>
	  */
	public void delete3DGraph(String num) {
		try {
			int n=Integer.parseInt(num);
			if (Graphs3D.size()>n) {
				stop();
				Graphs3D.removeElement(Graphs3D.elementAt(n));
				cfg=new config(this,getAttributesFromTools());
				start();
			}
		} catch (NumberFormatException e) {
		}
	}

	/* ----------------- Animation ----------------- */

	/**
	  * Removes the animation.<br>
	  */
	public void removeAnimation() {
		stop();
		Animation=new Attribute(Tr.getTr(data.p_anim),"");
		cfg=new config(this,getAttributesFromTools());
		start();
	}

	/**
	  * Returns the animation configuration String.<br>
	  */
	public String getAnimation() {
		return Animation.value;
	}

	/**
	  * Defines a new animation.<br>
	  * @param s Configuration String for the new animation.<br>
	  * <br>
	  * A typical form for s:<br>
	  * <br>
      * s="id=Animacin algoritmo=si inicio='Ta=0' hacer='Ta=Ta+0.05' mientras='Ta<2' auto=si repetir=si controles=no evaluar=siempre"<br>
	  */
	public void setAnimation(String s) {
		stop();
		Animation=new Attribute(Tr.getTr(data.p_anim),s);
		cfg=new config(this,getAttributesFromTools());
		start();
	}

	/* ----------------- Applet Code ----------------- */

	/**
	  * Returns the applet configuration i.e. the html code that defines the applet configuration.<br>
	  */
	public String getCode() {
		return super.getAppliedCode(false);
	}

	/**
	  * Returns the applet configuration i.e. the html code that defines the applet configuration using the standard HTML encoding of accents and "foreign" characters.<br>
	  */
	public String getHTMLEncodedCode() {
		return super.getAppliedCode(true);
	}
	public void setDescartesWeb2_0(boolean b) { 
		super.setDescartesWeb2_0(b); 
	}

/* ---------------- Communicator Interface --------------- */
	public Attribute[] getState() {
		return super.getState();
	}
	public void changed(Communicator cc) {
		super.changed(cc);
	}
	public void addCommunicator(Communicator comm) {
		super.addCommunicator(comm);
	}
	public void sendChanges() {
		super.sendChanges();
	}
/* ------------------------------------------------------- */	

}