/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descartes;

import java.util.Hashtable;
import java.util.Vector;
import java.net.URL;

import org.unam.matem.Attribute;

import com.mja.file.mjaHtml;
import com.mja.file.mjaFile;
import com.mja.lang.data;
import com.mja.util.BasicStr;

public class Descartes5 extends com.mja.descartes.Descartes3 {

	private static final int ctrAudioType = 1000023;
	private static final int ctrVideoType = 1000024;
	
	private Hashtable<String,String> controlsIgnore = new Hashtable<String,String>();
	public Descartes5() {	
		super();
		inArquimedes=false;
		BasicStr.antialias=true;
		spaceConfig.bcol="f0f8fa";
		spaceConfig.netcol="b8c4c8";
		spaceConfig.net10col="889498";
		spaceConfig.axescol="405860";
		spaceConfig.textcol="405860"; 
		graphR2Config.col="20303a";
		graphR2Config.fill="ffff80";
		graphR2Config.fillplus="00ff80";
		graphR3Config.fcol="eeffaa";
		graphR3Config.bcol="6090a0";
		controlConfig.bcol="406080";
		controlConfig.icol="cc0022";
	}

	@Override
	public String getParameter(String s) {
		if(s == null)
			return null;
		String res = super.getParameter(s); 

		if(BasicStr.hasContent(res) && s.startsWith(data.controlPrefix)){
			Attribute[] aa = Attribute.parse(res);
			int type=Tr.getIndex(data.ctrlix,Tr.getValue(aa,data.type),data.NotFound);
			if(type == data.NotFound){
				controlsIgnore.put(s,res);
				return null;
			}
		}
		return res;
	}




	public Hashtable<String, String> getIgnoredCtrCfgs(){
		return (Hashtable<String, String>) controlsIgnore.clone();
	}
	public String class_Id() {
		return "Descartes 5";
	}

	public static String getDefaultConfig(String codebase) {
		try {
			Object O=new Object();
			URL url=O.getClass().getResource("/resources/modelos/Descartes5.html");
			String name_html=mjaFile.readURL(url);
			name_html=mjaHtml.decodeHTMLEncoding(name_html);
			String str_applet=name_html.substring(name_html.toLowerCase().indexOf("<applet"),name_html.toLowerCase().indexOf("</applet>")+9);
			return str_applet+"\n";
		} catch (Exception e) {
			e.printStackTrace();
			return "";
		}
	}

}