/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descartes;

import java.awt.Frame;
import java.awt.Panel;
import java.net.*;
import com.mja.util.BasicStr;
import com.mja.file.mjaFile;
import com.mja.file.mjaHtml;

public class Item extends com.mja.descartes.Arquimedes {
	
	private static final void initialization() {	// de momento esto no funciona
		BasicStr.antialias=true;
		spaceConfig.bcol="f0f8fa";
		spaceConfig.netcol="b8c4c8";
		spaceConfig.net10col="889498";
		spaceConfig.axescol="405860";
		spaceConfig.textcol="405860"; 
		graphR2Config.col="20303a";
		graphR2Config.fill="ffff80";
		graphR2Config.fillplus="00ff80";
		graphR3Config.fcol="eeffaa";
		graphR3Config.bcol="6090a0";
		controlConfig.bcol="406080";
		controlConfig.icol="cc0022";
	}

	public Item() {
		super(null);
		inArquimedes=true;
	}

	public Item(Frame pf) {
		super(pf);
	}
	
	public String class_Id() {
		return "Item";
	}

	public static String getDefaultConfig(String codebase) {
		try {
			Object O=new Object();
			URL url=O.getClass().getResource("/resources/modelos/Item.html");
			String arquimedes_html=mjaFile.readURL(url);
			arquimedes_html=mjaHtml.decodeHTMLEncoding(arquimedes_html);
			String str_applet=arquimedes_html.substring(arquimedes_html.toLowerCase().indexOf("<applet"),arquimedes_html.toLowerCase().indexOf("</applet>")+9);
			return str_applet+"\n";
		} catch (Exception e) {
			e.printStackTrace();
			return "";
		}
	}

/*
	public static String getDefaultConfig(String codebase) {
		String s="<applet ";
		s+="code=\"ArquimedesItem.class\"\n"+
		"        archive=\"ItemEditor.jar\"\n";
		s+="        codebase=\""+codebase+"\"\n"+
		"        MAYSCRIPT\n"+
		"        width=790 height=480>\n";
		s+="   <param name=\"pleca\" value=\"title='Item para evaluacin' subtitle='Funciones y sus grficas'\">\n";
		s+="   <param name=\"Versin\" value=\""+getVersion()+"\">\n";
		s+="   <param name=\"Idioma\" value=\"espaol\">\n";
		s+="   <param name=\"decimal_symbol\" value=\".\">\n";
		s+="   <param name=\"antialias\" value=\"si\">\n";
		s+="   <param name=\"Botones\" value=\"crditos=no config=no inicio=no limpiar=no alto=30\">\n";
		s+="   <param name=\"rtf\" value=\"{\\rtf1\\uc0{\\fonttbl\\f0\\fcharset0 Arial;}\\f0\\fs34 Est\\u237 mulo\\par \\par                                       {\\*\\component\\Space 126c61bdeae}\\par \\par \\par \\par \\par \\par \\par \\par \\par \\par \\par Preguntas\\par \\par \\u191 Qu\\u233  tipo de funci\\u243 n tiene una gr\\u225 fica como la que se muestra arriba?  {\\*\\component\\NumCtrl 126c61f1b7a}\\par \\u191 Cual es el valor m\\u225 ximo de esa funci\\u243 n?  {\\*\\component\\NumCtrl 126c6217326}\\par }\">\n";
		s+="   <param name=\"E_00\" value=\"tipo='R2' id='E0' x='0' y='0' ancho='360' alto='200' O.y='20' fijo='s' despl_imagen='arr-izq' red='b8c4c8' red10='889498' ejes='405860' texto='405860' cID='126c61bdeae'\">\n";
		s+="   <param name=\"C_00\" value=\"id='resp0' tipo='numrico' interfaz='men' regin='escenario' espacio='E0' expresin='(0,0,120,25)' fijo='s' visible='no' opciones=' , lineal, cuadrtica, gaussiana, polinmica' pos_mensajes='centro' cID='126c61f1b7a'\">\n";
		s+="   <param name=\"C_01\" value=\"id='resp1' valor='||' tipo='numrico' interfaz='campo de texto' solo_texto='s' regin='escenario' espacio='E0' expresin='(0,0,60,25)' fijo='s' visible='s' pos_mensajes='centro' cID='126c6217326'\">\n";
		s+="   <param name=\"G_00\" value=\"espacio='E0' tipo='ecuacin' expresin='y=2*exp(-(x/2)^2)' visible='no'\">\n";
		s=s+"</applet>\n";
		return s;
	}
*/

}