/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descartes;

import java.util.*;
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.JTextField;
import com.mja.lang.*;
import com.mja.util.*;
import com.mja.gui.*;
import com.mja.file.*;
import org.unam.matem.Attribute;

public class TitleCanvas extends Canvas implements MouseListener {

	/* PLECA de ARQUIMEDES */	
//	private static Color fgcolor=new Color(0xf8fdff);
//	private static Color bgcolor=new Color(0x3bb3c3);
	private Color bgcolor=new Color(0x536891);	// Color 1
//	private static Color bgcolor=new Color(0x556082);	// Color 2
//	private static Color bgcolor=new Color(0x2c396d);	// Color 3
	private Color fgcolor=new Color(0xffffff);
	private String s_bgcolor="0x536891";
	private String s_fgcolor="0xffffff";

	private Scene sc;
	private String tit="Ttulo";
	private String subtit="Subttulo.",s_titima="",s_titfont="SansSerif,BOLD,20",s_subtitfont="SansSerif,ITALIC,18" ; //,s_subtitima;
	private String s_align="left";
	private int LEFT=0,CENTER=1,RIGHT=2;
	private int align=LEFT;
	private int subtitlines=0;
	private Vector subtit_vector;
	private Font subtit_font0=new Font("SansSerif",Font.PLAIN,18), 
			subtit_font=subtit_font0,
			tit_font=new Font("SansSerif",Font.BOLD,20);
	private Image bima,titima;
	private Frame PF;
	private int fsz=18,titsz=0,subtitsz=0;
	private int width=790;
	public int height=0;
	
	TitleCanvas(translator Tr,Frame PF,Applet A,Hashtable images,Scene sc,String pleca) {
		this.PF=PF;
		this.sc=sc;
		if (BasicStr.hasContent(pleca)) {
			tit=Attribute.getValue(pleca,"title");
			subtit=Attribute.getValue(pleca,"subtitle");
			String s_subtitlines=Attribute.getValue(pleca,"subtitlines");

			s_align=Attribute.getValue(pleca,"align");
			if (BasicStr.hasContent(s_align)) {
				s_align=s_align.toLowerCase();
				if (s_align.equals("center")) {
					align=CENTER;
				} else if (s_align.equals("right")) {
					align=RIGHT;
				} else {
					align=LEFT;
				}
			} else {
				align=LEFT;
			}

			s_bgcolor=Attribute.getValue(pleca,"bgcolor");
			if (s_bgcolor.startsWith("0x")) {
				s_bgcolor=s_bgcolor.substring(2);
			}
			s_fgcolor=Attribute.getValue(pleca,"fgcolor");
			if (s_fgcolor.startsWith("0x")) {
				s_fgcolor=s_fgcolor.substring(2);
			}
			subtitlines=BasicStr.parseInteger(s_subtitlines,0,0);
			s_titima=Attribute.getValue(pleca,"titleimage");
			if (BasicStr.hasContent(s_titima)) {
				titima=mjaFile.loadImage(images,A,s_titima);
			}
			s_titfont=Attribute.getValue(pleca,"titlefont");
			tit_font=BasicStr.parseFont(s_titfont,tit_font);
			s_subtitfont=Attribute.getValue(pleca,"subtitlefont");
			subtit_font0=BasicStr.parseFont(s_subtitfont,subtit_font0);
			fsz=subtit_font0.getSize();
			bgcolor=Tr.ParseColor(s_bgcolor,bgcolor,bgcolor);
			fgcolor=Tr.ParseColor(s_fgcolor,fgcolor,fgcolor);
		}
		setBackground(bgcolor);
		if (PF!=null) {
			addMouseListener(this);
		}
		makeSubtitVector();
	}
	
	String getConfig() {
//		return "title='"+mjaHtml.getHTMLEncoding(tit)+"' subtitle='"+mjaHtml.getHTMLEncoding(subtit)+"' "
		return "title='"+tit+"' subtitle='"+subtit+"' "
						+"subtitlines='"+subtitlines+"' bgcolor='"+s_bgcolor+"' fgcolor='"+s_fgcolor+"' "
						+"align='"+s_align+"' titleimage='"+s_titima+"' "
						+"titlefont='"+s_titfont+"' subtitlefont='"+s_subtitfont+"' ";
	}
	
	void makeSubtitVector() {
		subtit_font=subtit_font0;
		FontMetrics fm=getFontMetrics(subtit_font);
		subtit_vector=new Vector();
		if (BasicStr.hasContent(subtit)) {
			if (subtitlines==1) {
				while (fm.stringWidth(subtit)>765 && fsz>8) {
					fsz--;
					subtit_font=new Font(subtit_font.getName(),subtit_font.getStyle(),fsz);
					fm=getFontMetrics(subtit_font);
				}
				subtit_vector.addElement(subtit);
			} else {
				StringTokenizer st=new StringTokenizer(subtit," ");
				String str="";
				while (st.hasMoreTokens()) {
					String auxstr=(String) st.nextToken();
					if (fm.stringWidth(str+" "+auxstr)<765) {
						if (str.length()>0) {
							str+=" ";
						}
						str+=auxstr;
					} else {
						if (BasicStr.hasContent(str)) {
							subtit_vector.addElement(str);
						}
						str=auxstr;
					}
				}
				if (BasicStr.hasContent(str)) {
					subtit_vector.addElement(str);
				}
			}
		}
		subtit_font=mjaFont.makeFont(subtit_font0.getName(),subtit_font0.getStyle(),fsz);
		tit_font=mjaFont.makeFont(tit_font.getName(),tit_font.getStyle(),tit_font.getSize());
		fm=getFontMetrics(tit_font);
		titsz=0;
		if (BasicStr.hasContent(tit)) {
			titsz+=(fm.getAscent()+fm.getDescent());
		} 
		fm=getFontMetrics(subtit_font);
		subtitsz=0;
		if (subtit_vector.size()>0) {
			subtitsz+=(subtit_vector.size()*(fm.getAscent()+fm.getDescent()-2));
		} 
		if (titima!=null) {
			height=titima.getHeight(this);
		} else if (titsz+subtitsz>0) {
			height=titsz+subtitsz+6+11;
		}
		setSize(width,height);
	}
	
	void updateBGImage() {
		if (BasicStr.hasContent(tit)||(subtit_vector.size()>0)) {
			width=getSize().width;
			if (titima!=null) {
				height=titima.getHeight(this);
			} else if (titsz+subtitsz>0) {
				height=titsz+subtitsz+6+11;
			}
			setSize(width,height);
			bima=createImage(width,height);
			if (bima!=null) {
				Graphics2D g2=(Graphics2D) bima.getGraphics();
				if (g2!=null) {
					g2.setColor(bgcolor);
					g2.fillRect(0,0,getSize().width,getSize().height);
					if (titima!=null) {
						g2.drawImage(titima,0,0,getSize().width,getSize().height,this);
					}
					TFont.setAntialias(g2,true);
					g2.setColor(fgcolor);
					g2.setFont(tit_font);
					FontMetrics fm=getFontMetrics(tit_font);
					int W=fm.stringWidth(tit);
					int X0=16;
					int X=X0;
					if (align==CENTER) {
						X=(width-W)/2;
					} else if (align==RIGHT) {
						X=width-W-16;
					}
					g2.drawString(tit,X,1+fm.getAscent()+6);
					g2.setFont(subtit_font);
					fm=getFontMetrics(subtit_font);
					for (int i=0;i<subtit_vector.size();i++) {
						String auxstr=(String) subtit_vector.elementAt(i);
						W=fm.stringWidth(auxstr);
						X=X0;
						if (align==CENTER) {
							X=(width-W)/2;
						} else if (align==RIGHT) {
							X=width-W-16;
						}
						g2.drawString(auxstr,X,titsz+6+fm.getAscent()+i*(fm.getAscent()+fm.getDescent()-2));
					}
					TFont.setAntialias(g2,false);
					if (titima==null) {
						int gr=5;
						for (int i=0;i<gr;i++) {
							g2.setColor(new Color(0,0,0,(3*(gr-i)*(gr-i))/2));
//							g2.drawLine(0,getSize().height-i,getSize().width,getSize().height-i);
							g2.drawRect(i,i,getSize().width-2*i,getSize().height-2*i);
							g2.drawLine(i-1,i-1,i,i);
						}
					}
				}
			}
		}
	}

	private boolean firstTime=true;

	public void paint(Graphics g) {
		if (bima==null) {
			updateBGImage();
		}
		if (bima!=null) {
			g.drawImage(bima,0,0,this);
		}
	}

	/* -------------- Mouse Listener ------------- */

	public void mousePressed(MouseEvent e) {
	}

	public void mouseReleased(MouseEvent e) {
	}
	public void mouseClicked(MouseEvent e) {
		if (e.getClickCount()==2) {
			if (inputDialog==null) {
				makeInputDialog();
			}
			tf_tit.setText(tit);
			tf_subtit.setText(subtit);
			inputDialog.display(true,true);
			if (inputDialog.ok) {
				tit=tf_tit.getText();
				subtit=tf_subtit.getText();
				makeSubtitVector();
				updateBGImage();
				repaint();
				sc.paintAll(sc.getGraphics());
			}
			
		}
	}
	public void mouseEntered(MouseEvent e) {
	}
	public void mouseExited(MouseEvent e) {
	}

	private editDialog inputDialog;
	private JTextField tf_tit;
	private JTextField tf_subtit;

	void makeInputDialog() {
		inputDialog=new editDialog(PF,"Ttulo y subttulo",true,"Aceptar","Cancelar");
		tf_tit=new JTextField(30);
		tf_subtit=new JTextField(50);
		tf_tit.setText(tit);
		tf_subtit.setText(subtit);
		Panel MP=new Panel();
		MP.setBackground(bgcolor);
		tf_tit.setBackground(bgcolor);
		tf_tit.setForeground(fgcolor);
		tf_tit.setFont(tit_font);
		tf_subtit.setBackground(bgcolor);
		tf_subtit.setFont(subtit_font0);
		tf_subtit.setForeground(fgcolor);
		MP.setLayout(new GridBagLayout());
		GridBagConstraints gbc=new GridBagConstraints();
		gbc.anchor=GridBagConstraints.WEST;
		gbc.gridx=0;
		gbc.gridy=0;
		gbc.insets = new Insets(12,16,0,16);
		MP.add(tf_tit,gbc); gbc.gridy++;
		gbc.insets.top=0;
		MP.add(tf_subtit,gbc); gbc.gridy++;
		gbc.insets.top=6;
		Canvas c=new Canvas();
		c.setBackground(bgcolor);
		c.setSize(width-32,6);
		MP.add(c,gbc); gbc.gridy++;
		inputDialog.add("Center",MP);
	}
	
}