/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descartes;
/*------------------------------------------------------------*/
/*                        animConfig                          */
/*                         (c)  MJA                           */
/*                      Agosto de 2002                        */
/*------------------------------------------------------------*/

import java.util.*;
import com.mja.util.*;
import com.mja.gui.*;
import com.mja.descgui.*;
import com.mja.descgui.edit.*;
import com.mja.lang.*;

import com.mja.descgui.edit.editObject;
import org.unam.matem.Attribute;

public class animConfig extends editObject {

	public static final int ixdelay=0,ixcontrols=1,ixauto=2,ixloop=3,
							ixini=4,ixdo=5,ixwhile=6,
							numFields=7;
	private static editObjectType[] animEOT;

	public static final editField[] animfield=new editField[numFields];
	
	public void defineFields() {
		int n=0;
		animfield[n++]=new editField(data.delay     ,""      ,""      ,editObject.string      , 4);
		animfield[n++]=new editField(data.controls  ,"si"    ,"si"    ,editObject.select      , 1);
		animfield[n++]=new editField(data.auto      ,"si"    ,"si"    ,editObject.select      , 1);
		animfield[n++]=new editField(data.loop      ,"no"    ,"no"    ,editObject.select      , 1);
		animfield[n++]=new editField(data.ini       ,""      ,""      ,editObject.string      , 75,true);
		animfield[n++]=new editField(data.doWord    ,""      ,""      ,editObject.textArea    , 75,true);
		animfield[n++]=new editField(data.whileWord ,""      ,""      ,editObject.string      , 75,true);
	};

	public boolean active=true,loop=false,autorun=true,controls=true;
	private translator Tr;
	private String name;

	public animConfig(translator Tr,String stype,String svalue) {
		this(Tr,svalue);
	}

	public animConfig(translator Tr,String values) {
		defineFields();
		expl=Expl.Anim;
		this.Tr=Tr;
		if (animEOT==null) {
			createAnimEOT();
		}
		initialize(Tr,animfield,animEOT,Attribute.parse(values));
	}

	public void updateInfo(translator Tr) {
//		active=Tr.isTrue(s_value[ixanim]);
		loop=Tr.isTrue(s_value[ixloop]);
		autorun=Tr.isNotFalse(s_value[ixauto]);
		controls=Tr.isNotFalse(s_value[ixcontrols]);
	}

	private static void createAnimEOT() {
		BitSet anim_attr=new BitSet(numFields);
		for (int i=0;i<numFields;i++) {
			anim_attr.set(i);
		}

		animEOT=new editObjectType[1];
		animEOT[0]=new editObjectType("",anim_attr);
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name=name;
	}

	public void setEditName(String name) {
		setName(name);
	}

	public String getEditName() {
		return getName();
	}

	private static final String[] defaultExpresion={
	};
	public int getNumTypes() {
		return defaultExpresion.length;
	}
	public String getType(translator Tr,int i) {
		return null;
	}
	public String getDefaultExpresion(translator Tr,int i) {
		return null;
	}
	public String getListTitle(translator Tr) {
		return null;
	}
	public String getTypesInfo(translator Tr) {
		return null;
	}
	public int getTypeIndex(translator Tr) {
		return 0;
	}

}