/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descartes;
/*------------------------------------------------------------*/
/*                         auxConfig                          */
/*                         (c)  MJA                           */
/*                      Febrero de 2001                       */
/*------------------------------------------------------------*/

import java.util.*;
import java.awt.*;
import java.applet.*;
import com.mja.gui.*;
import com.mja.descgui.*;
import com.mja.descgui.edit.*;
import com.mja.util.*;
import com.mja.lang.*;
import com.mja.parser.*;
import com.mja.descgui.edit.editObject;
import com.mja.file.*;
import org.unam.matem.Attribute;

public class auxConfig extends editObject {

	static public final int[] auxix={data.var,data.constant,data.array,data.matrix,data.func,data.sequence,data.alg,data.event};

	private static final String[] defaultExpresion={
		"v?","c?","V?","M?","f?","s?","a?","e?"
	};

	private static final int[] evalTypes={data.once,data.always};
	private static editObjectType[] auxEOT;

	public Font param_font;
	public int msgloc=mjaText.center;
	public mjaLabelAndText exprEd;
	private String parameter;


	private static int ix=0;
	public static final int ixid=ix++, 
							ixisalg=ix++,
							ixconstant=ix++,
							ixarray=ix++,
							ixmatrix=ix++,
							ixseq=ix++,
							ixisev=ix++,
							ixexpr=ix++,
							ixeval=ix++,
							ixsize=ix++,
							ixcolumns=ix++,
							ixrows=ix++,
							ixrange=ix++,
							ixalg=ix++,
							ixvexpr=ix++,
							ixlocalvars=ix++,
							ixini=ix++,
							ixdo=ix++,
							ixwhile=ix++,
							ixcondition=ix++,
							ixaction=ix++,
							ixparam=ix++,
							ixmode=ix++,
							ixmsgloc=ix++,
							ixeditable=ix++,
							ixfile=ix++,
							numFields=ix;

	private static final editField[] auxfield=new editField[numFields];
	
	public void defineFields() {
		int n=0;
		auxfield[n++]=new editField(data.id        ,""      ,""      ,editObject.string      ,15,-1,true,-1,-1,-1,data.empty,null);
		auxfield[n++]=new editField(data.alg       ,"no"    ,"no"    ,editObject.select      , 0);
		auxfield[n++]=new editField(data.constant  ,"no"    ,"no"    ,editObject.select      , 0);
		auxfield[n++]=new editField(data.array     ,"no"    ,"no"    ,editObject.select      , 0);
		auxfield[n++]=new editField(data.matrix    ,"no"    ,"no"    ,editObject.select      , 0);
		auxfield[n++]=new editField(data.sequence  ,"no"    ,"no"    ,editObject.select      , 0);
		auxfield[n++]=new editField(data.event     ,"no"    ,"no"    ,editObject.select      , 0);
		auxfield[n++]=new editField(data.expr      ,""      ,""      ,editObject.string      ,40,-1,true,-1,-1,-1,data.equals,null);
		auxfield[n++]=new editField(data.evaluate  ,"always","always",editObject.choice      , 1,-1,true,-1,-1,-1,data.evaluate,evalTypes);
		auxfield[n++]=new editField(data.size      ,"3"     ,"3"     ,editObject.string      , 7);
		auxfield[n++]=new editField(data.columns   ,"3"     ,"3"     ,editObject.string      , 5);
		auxfield[n++]=new editField(data.rows      ,"3"     ,"3"     ,editObject.string      , 5);
		auxfield[n++]=new editField(data.range     ,""      ,""      ,editObject.string      ,47,false);
		auxfield[n++]=new editField(data.alg       ,"no"    ,"no"    ,editObject.select      , 1);
		auxfield[n++]=new editField(data.expr      ,""      ,""      ,editObject.textArea    ,55,false);
		auxfield[n++]=new editField(data.localVars ,""      ,""      ,editObject.string      ,50,false);
		auxfield[n++]=new editField(data.ini       ,""      ,""      ,editObject.string      ,55,true);
		auxfield[n++]=new editField(data.doWord    ,""      ,""      ,editObject.textArea    ,55,true);
		auxfield[n++]=new editField(data.whileWord ,""      ,""      ,editObject.string      ,55,true);
		auxfield[n++]=new editField(data.condition ,""      ,""      ,editObject.string      ,41);
		auxfield[n++]=new editField(data.action    ,""      ,""      ,editObject.choice      , 1,-1,true,-1,-1,-1,data.action,Action.actions);
		auxfield[n++]=new editField(data.parameter ,""      ,""      ,editObject.text        ,27,-1,true,-1,data.font,data.parameter,data.parameter ,null); //,ixparam
		auxfield[n++]=new editField(data.execution ,"alternate","alternate",editObject.choice, 1,-1,true,-1,-1,-1,data.execution,Action.modes);
		auxfield[n++]=new editField(data.msgloc    ,"center","center",editObject.choice      , 1,-1,true,-1,-1,-1,data.msgloc,data.msglocs);
		auxfield[n++]=new editField(data.editable  ,"no"    ,"no"    ,editObject.select      , 1);
		auxfield[n++]=new editField(data.file      ,""      ,""      ,editObject.string      ,40);
	};


	public String[] VarName;
	public String funcName;
	public boolean evOnce,isConst,isArray,isMatrix,hasAlg,isSequence=false;
	public int type=data.var;
	private translator Tr;
	private String name;

	public String getAction() {
		return s_value[ixaction];
	}
	public String getParameter() {
		return parameter;
	}
	public String getCondition() {
		return s_value[ixcondition];
	}
	public int mode=data.alternate;

	public boolean isEditable;
	
	

/* -------------------------- extends editObject --------------------- */

	public void updateInfo(translator Tr) {
		if (BasicStr.hasContent(s_value[ixaction])) {
			s_value[ixisev]=Tr.getTr(data.Yes);
		}
		setName(s_value[ixid]);
		isSequence=Tr.isTrue(s_value[ixseq]);
		hasAlg=Tr.isTrue(s_value[ixalg]);
		String evals=s_value[ixeval];
//		evOnce=Tr.getTr(data.once).equals(evals);
		evOnce=Tr.equals(evals,data.once);
		isConst=Tr.isTrue(s_value[ixconstant]);
		isMatrix=Tr.isTrue(s_value[ixmatrix]);
		isArray=!isMatrix && Tr.isTrue(s_value[ixarray]);
		if (isFunction()) {
			if (isSequence) {
				type=data.sequence;
			} else {
				type=data.func;
			}
		} else if (Tr.isTrue(s_value[ixisalg])) {
			type=data.alg;
		} else if (isArray) {
			type=data.array;
		} else if (isMatrix) {
			type=data.matrix;
		} else if (isConst) {
			type=data.constant;
		} else if (Tr.isTrue(s_value[ixisev])) {
			type=data.event;
		}

		mode=Tr.getIndex(Action.modes,s_value[ixmode],data.alternate);
		param_font=BasicStr.parseGeneralFont(h_value[ixparam],mjaFont.AWTMono);
		msgloc=Tr.parseLocation(s_value[ixmsgloc]);
		isEditable=Tr.isTrue(s_value[ixeditable]);
		String s=getName()+" (";
		if (type==data.event) {
			s+=Tr.getTr(data.event);
			parameter=BasicStr.replace(s_value[ixparam],"\\n","\n");
		} else if (type==data.alg) {
			s+=Tr.getTr(data.alg);
		} else if (type==data.array) {
			s+=Tr.getTr(data.array);
		} else if (type==data.matrix) {
			s+=Tr.getTr(data.matrix);
		} else if (type==data.func) {
			s+=Tr.getTr(data.func);
		} else if (type==data.sequence) {
			s+=Tr.getTr(data.sequence);
		} else if (type==data.constant) {
			s+=Tr.getTr(data.constant);
		} else {
			s+=Tr.getTr(data.var);
		}
		s+=")";
		setId(s);
//System.out.println("columns="+s_value[ixcolumns]+" rows="+s_value[ixrows]);
//new Exception().printStackTrace();
	}

	public void setEditName(String name) {
		setName(name);
	}

	public String getEditName() {
		if (type==data.func||type==data.sequence) {
			return funcName;
		} else {
			return getName();
		}
	}
	
	public String getSize() {
		return s_value[ixsize];
	}
	
	public String getColumns() {
		return s_value[ixcolumns];
	}
	
	public String getRows() {
		return s_value[ixrows];
	}
	
	public String getExpr() {
		return s_value[auxConfig.ixvexpr];
	}
	
	public String getFileName() {
		return s_value[ixfile];
	}

	public int getNumTypes() {
		return defaultExpresion.length;
	}
	public String getType(translator Tr,int i) {
		return Tr.getTr(auxix[i]);
	}
	public String getDefaultExpresion(translator Tr,int i) {
		return defaultExpresion[i];
	}
	public String getListTitle(translator Tr) {
		return Tr.getTr(data.p_auxiliaries);
	}
	public String getTypesInfo(translator Tr) {
		return Tr.getTr(data.auxiliary);
	}
	public int getTypeIndex(translator Tr) {
		for (int i=0;i<auxix.length;i++) {
			if (type==auxix[i]) {
				return i;
			}
		}
		return 0;
	}


/* ----------------------------------------------------------------- */

	private void fixFields() {
		auxfield[ixisalg].isFixed=true;
		auxfield[ixconstant].isFixed=true;
		auxfield[ixarray].isFixed=true;
		auxfield[ixmatrix].isFixed=true;
		auxfield[ixseq].isFixed=true;
		auxfield[ixisev].isFixed=true;
	}

	public auxConfig(translator Tr,Attribute[] aa) {
		defineFields();
		fixFields();
		expl=Expl.Aux;
		this.Tr=Tr;
		if (auxEOT==null) {
			createAuxEOT();
		}
		initialize(Tr,auxfield,auxEOT,aa);
	}

	public auxConfig(translator Tr,String stype,String svalue) {
		this(Tr,svalue,Tr.getIndex(auxix,stype,data.var));
	}
	public auxConfig(translator Tr,String id,int type) {
		fixFields();
		expl=Expl.Aux;
		this.Tr=Tr;
		if (auxEOT==null) {
			createAuxEOT();
		}
		String[] nullv=new String[numFields];
		for (int i=0;i<nullv.length;i++) {
			nullv[i]=auxfield[i].null_val;
		}
		String s_id=id;
		nullv[ixexpr]="0";
		nullv[ixeval]=Tr.getTr(data.always);
		nullv[ixmode]=Tr.getTr(data.alternate);
		if (type==data.event) {
			nullv[ixaction]="";
			nullv[ixparam]="";
			nullv[ixcondition]="";
			nullv[ixmode]=Tr.getTr(data.alternate);
			nullv[ixisev]=Tr.getTr(data.Yes);
		} else if (type==data.alg) {
			nullv[ixini]="";
			nullv[ixdo]="";
			nullv[ixwhile]="";
			nullv[ixisalg]=Tr.getTr(data.Yes);
		} else if (type==data.array) {
			nullv[ixsize]="3";
			nullv[ixvexpr]=id+"[0]=0;"+id+"[1]=0;"+id+"[2]=0";
			nullv[ixeval]=Tr.getTr(data.once);
			nullv[ixarray]=Tr.getTr(data.Yes);
			nullv[ixfile]="";
		} else if (type==data.matrix) {
			nullv[ixcolumns]="3";
			nullv[ixrows]="3";
			nullv[ixvexpr]=id+"[0,0]=0;"+id+"[1,0]=0;"+id+"[2,0]=0\n";
			nullv[ixvexpr]+=id+"[0,1]=0;"+id+"[1,1]=0;"+id+"[2,1]=0\n";
			nullv[ixvexpr]+=id+"[0,2]=0;"+id+"[1,2]=0;"+id+"[2,2]=0\n";
			nullv[ixeval]=Tr.getTr(data.once);
			nullv[ixmatrix]=Tr.getTr(data.Yes);
			nullv[ixfile]="";
		} else if (type==data.func) {
			if (s_id.indexOf("(")<0) {
				s_id+="(x)";
			}
			nullv[ixexpr]="x";
		} else if (type==data.sequence) {
			if (s_id.indexOf("(")<0) {
				s_id+="(n)";
			}
			nullv[ixexpr]="n";
			nullv[ixseq]=Tr.getTr(data.Yes);
		} else if (type==data.constant) {
			nullv[ixeval]=Tr.getTr(data.once);
			nullv[ixconstant]=Tr.getTr(data.Yes);
		}
		String s="id="+s_id;
		Attribute[] aa=Attribute.parse(s);
		initialize(Tr,auxfield,auxEOT,aa,nullv);
	}

	private static void createAuxEOT() {
		BitSet var_attr=new BitSet(numFields);
		for (int i=0;i<numFields;i++) {
			var_attr.clear(i);
		}
		var_attr.set(ixid);
		var_attr.set(ixexpr);
		var_attr.set(ixeditable);
		BitSet constant_attr=new BitSet(numFields);
		for (int i=0;i<numFields;i++) {
			constant_attr.clear(i);
		}
		constant_attr.set(ixid);
		constant_attr.set(ixexpr);
		constant_attr.set(ixeval);
//		constant_attr.clear(ixconstant);
		BitSet array_attr=new BitSet(numFields);
		for (int i=0;i<numFields;i++) {
			array_attr.clear(i);
		}
		array_attr.set(ixid);
		array_attr.set(ixsize);
		array_attr.set(ixeval);
//		array_attr.clear(ixarray);
		array_attr.set(ixvexpr);
		array_attr.set(ixfile);
		BitSet matrix_attr=new BitSet(numFields);
		for (int i=0;i<numFields;i++) {
			matrix_attr.clear(i);
		}
		matrix_attr.set(ixid);
		matrix_attr.set(ixcolumns);
		matrix_attr.set(ixrows);
		matrix_attr.set(ixeval);
//		matrix_attr.clear(ixmatrix);
		matrix_attr.set(ixvexpr);
		matrix_attr.set(ixfile);
		BitSet func_attr=new BitSet(numFields);
		for (int i=0;i<numFields;i++) {
			func_attr.clear(i);
		}
		func_attr.set(ixlocalvars);
		func_attr.set(ixrange);
		func_attr.set(ixini);
		func_attr.set(ixdo);
		func_attr.set(ixwhile);
		func_attr.set(ixid);
		func_attr.set(ixexpr);
		func_attr.set(ixalg);
		BitSet sequence_attr=new BitSet(numFields);
		for (int i=0;i<numFields;i++) {
			sequence_attr.clear(i);
		}
		sequence_attr.set(ixini);
		sequence_attr.set(ixdo);
		sequence_attr.set(ixwhile);
		sequence_attr.set(ixid);
		sequence_attr.set(ixexpr);
//		sequence_attr.clear(ixseq);
		sequence_attr.set(ixrange);
		sequence_attr.set(ixalg);
		BitSet alg_attr=new BitSet(numFields);
		for (int i=0;i<numFields;i++) {
			alg_attr.clear(i);
		}
		alg_attr.set(ixini);
		alg_attr.set(ixdo);
		alg_attr.set(ixwhile);
		alg_attr.set(ixid);
		alg_attr.set(ixeval);
//		alg_attr.clear(ixisalg);
		BitSet act_attr=new BitSet(numFields);
		for (int i=0;i<numFields;i++) {
			act_attr.clear(i);
		}
		act_attr.set(ixid);
		act_attr.set(ixaction);
		act_attr.set(ixparam);
		act_attr.set(ixcondition);
		act_attr.set(ixmode);
//		act_attr.clear(ixisev);
		act_attr.set(ixmsgloc);

		auxEOT=new editObjectType[auxix.length];
		auxEOT[0]=new editObjectType("",var_attr);
		auxEOT[1]=new editObjectType("",constant_attr);
		auxEOT[2]=new editObjectType("",array_attr);
		auxEOT[3]=new editObjectType("",matrix_attr);
		auxEOT[4]=new editObjectType("",func_attr);
		auxEOT[5]=new editObjectType("",sequence_attr);
		auxEOT[6]=new editObjectType("",alg_attr);
		auxEOT[7]=new editObjectType("",act_attr);
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		s_value[ixid]=name;
		this.name=name;
		if (name.indexOf("(")>0) {
			StringTokenizer st=new StringTokenizer(name,"()");
			funcName=st.nextToken().trim();
			if (st.hasMoreTokens()) {
				String auxs=st.nextToken().trim();
				st=new StringTokenizer(auxs,",");
				VarName=new String[st.countTokens()];
				for (int i=0;i<VarName.length;i++) {
					VarName[i]=st.nextToken();
				}
			} else {
				VarName=new String[0];
			}
		} else {
			VarName=null;
			funcName=null;
		}
	}

	public boolean isFunction() {
		return (VarName!=null);
	}

	public void addVariables(Attribute[] aa,Vector replv) {
		addVariables(Attribute.getValue(aa,Tr.getTr(data.ini)),replv);
		addVariables(Attribute.getValue(aa,Tr.getTr(data.doWord)),replv);
	}

	private void addVariables(String s,Vector replv) {
		String[] sa=BasicStr.getElements(s);
		for (int i=0;i<sa.length;i++) {
			int pos=sa[i].indexOf("=");
			if (pos>0) {
				String varname=sa[i].substring(0,pos).trim();
				int ixlb=varname.indexOf("[");
				if (ixlb>0) { // Array
				} else {
					if (!replv.contains(varname)) {
						replv.addElement(varname);
					}
				}
			}
		}
	}

	public static void updateValues(translator Tr,Attribute[] aa,String mname,String dibujarsi,Vector replv,int[] noreplix,int[] colorix) {
		for (int i=0;i<aa.length;i++) {
			boolean replace=true;
			for (int k=0;k<noreplix.length;k++) {
				if (Tr.equals(aa[i].name,noreplix[k])) {
					replace=false;
					break;
				}
			}
			if (replace) {
				if (!aa[i].value.trim().startsWith("(")) {
					for (int k=0;k<colorix.length;k++) {
						if (Tr.equals(aa[i].name,colorix[k])) {
							replace=false;
							break;
						}
					}
				}
				if (replace) {
//					if (Tr.equals(aa[i].name,data.t_text)) {
					// habra que sacar las expresiones y sustituir slo all.
					// mientras esto no se haga en los macros se prefijarn
					// las palabras claves del macro con el nombre del macro.
//					} else {
						for (int j=0;j<replv.size();j++) {
							aa[i].value=auxConfig.insertAtToken(aa[i].value,(String) replv.elementAt(j),mname+".");
						}
//					}
				}
			}
			if (Tr.equals(aa[i].name,data.cond) && BasicStr.hasContent(dibujarsi)) {
				aa[i].value="("+aa[i].value+")&("+dibujarsi+")";
			}
		}
	}

	private static final int[] ixa={ixsize,ixcolumns,ixrows,ixexpr,ixrange,ixvexpr,ixini,ixdo,ixwhile,ixcondition,ixparam};
	
	public void macroUpdate(String name,Attribute[] aa,Vector replv) {
		setName(name+"."+getName());
		for (int i=0;i<replv.size();i++) {
			String token=(String) replv.elementAt(i);
			for (int j=0;j<ixa.length;j++) {
				if (BasicStr.hasContent(s_value[ixa[j]])) {
					s_value[ixa[j]]=insertAtToken(s_value[ixa[j]],token,name+".");
				}
			}
		}
	}

	private static String insertAtToken(String s,String s1,String insrt) {
		String auxs=s;
		int pos=0,l1=s1.length(),dl=l1+insrt.length();
		while ((pos=auxs.indexOf(s1,pos))>=0) {
			if ( ( pos==0 || (auxs.charAt(pos-1)!='.')&&(!isAlphaNum(auxs.charAt(pos-1))))  &&
				 ( pos+l1==auxs.length() || !isAlphaNum(auxs.charAt(pos+l1)) ) 
				) {
				auxs=auxs.substring(0,pos)+insrt+auxs.substring(pos);
				pos+=dl;
			} else {
				pos++;
			}
		}
		return auxs;
	}

	private static boolean isAlphaNum(char ch) {
		return ( BasicStr.isPureAlpha(ch) || (ch>='0'&&ch<='9') ) ;
	}

}