/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descartes;
/*------------------------------------------------------------*/
/*                        graphConfig                         */
/*                         (c)  MJA                           */
/*                       Enero de 2001                        */
/*------------------------------------------------------------*/
import java.awt.*;
import java.util.*;
import com.mja.gui.*;
import com.mja.descgui.*;
import com.mja.descgui.edit.*;
import com.mja.parser.*;
import com.mja.util.*;
import com.mja.lang.*;
import com.mja.file.mjaFile;
import com.mja.file.mjaFont;
import org.unam.matem.Attribute;

import com.mja.descgui.edit.editObject;

public class graphR2Config extends editObject {
	
	public static String col="azul",fill="yellow",fillplus="green"; // Descartes
//	public static String col="20303a",fill="ffff80",fillplus="00ff80"; // Arquimedes
	Font font=com.mja.file.mjaFont.AWTMono;
	protected static int numFields = 0;
	public static int
		ixspace=numFields++,
		ixtype=numFields++,
		ixbackground=numFields++,
		ixcolor=numFields++,
		ixcond=numFields++,
		ixabscoor=numFields++,
		ixmacros=numFields++,
		ixexpr=numFields++,
		ixcenter=numFields++,
		ixradius=numFields++,
		ixini=numFields++,
		ixend=numFields++,
		ixvectors=numFields++,
		ixtrace=numFields++,
		ixfamily=numFields++,
		ixf_parameter=numFields++,
		ixf_interval=numFields++,
		ixf_steps=numFields++,
		ixparameter=numFields++,
		ixinterval=numFields++,
		ixsteps=numFields++,
		ixt_text=numFields++,
		ixdecimals=numFields++,
		ixfixed=numFields++,
		ixfill=numFields++,
		ixfillplus=numFields++,
		ixfillminus=numFields++,
		ixsize=numFields++,
		ixwidthness=numFields++,
		ixarrow_w=numFields++,
		ixspear=numFields++,
		ixarrow=numFields++,
		ixvisible=numFields++,
		ixeditable=numFields++,
		ixrange=numFields++,	
		ixfile=numFields++, 
		ixanim=numFields++, 
		ixanimfreq=numFields++,
		ixrotini=numFields++,
		ixposini=numFields++,
		ixrotation=numFields++, 
		ixlocation=numFields++,
		ixname=numFields++,
		ixtextborder = numFields++,
		ixcomment=numFields++;

	public static final int[] colorix={data.color,data.trace,data.fill,data.fillplus,data.fillminus,data.arrow};
	public static final int[] noreplix={data.space,data.type,data.background,data.family,data.fixed,data.visible,data.editable,data.animated,data.name,data.abscoor};

	protected static editField[] gR2field=new editField[numFields];
	
	
	protected void defineFields() {
		//							attrix       ,defval   ,nullval,       eType				,sz,prefix,write,writeifix,hattrix,hprefix,uattrix,chvalues
		gR2field[ixspace]		= new editField(data.space     ,""       ,""       ,editObject.choice      , 1,-1    ,true ,-1       ,-1     ,-1,data.space   ,null);
		gR2field[ixtype]		= new editField(data.type      ,""       ,""       ,editObject.string      , 7);
		gR2field[ixbackground]	= new editField(data.background,"no"     ,"no"     ,editObject.select      , 1);
		gR2field[ixcolor]		= new editField(data.color     ,col      ,col      ,editObject.color_button, 1,-1    ,true ,-1       ,-1     ,-1,-1           ,null);
		gR2field[ixcond]		= new editField(data.cond      ,""       ,""       ,editObject.string      ,17);
		gR2field[ixabscoor]		= new editField(data.abscoor   ,"no"     ,"no"     ,editObject.select      , 1);
		gR2field[ixmacros]		= new editField(data.expr      ,""       ,""       ,editObject.macro       ,12,-1    ,true ,-1       ,-1     ,-1,data.macro   ,null);
		gR2field[ixexpr]		= new editField(data.expr      ,""       ,""       ,editObject.string      ,48);
		gR2field[ixcenter]		= new editField(data.center    ,"(0,0)"  ,"(0,0)"  ,editObject.string      , 5);
		gR2field[ixradius]		= new editField(data.radius    ,"1"      ,"1"      ,editObject.string      , 3);
		gR2field[ixini]			= new editField(data.ini       ,"0"      ,"0"      ,editObject.string      , 5);
		gR2field[ixend]			= new editField(data.end       ,"90"     ,"90"     ,editObject.string      , 5);
		gR2field[ixvectors]		= new editField(data.vectors   ,"no"     ,"no"     ,editObject.select      , 1);
		gR2field[ixtrace]		= new editField(data.trace     ,"gray"   ,"no"     ,editObject.color_select, 1);
		gR2field[ixfamily] 		= new editField(data.family    ,"no"     ,"no"     ,editObject.select      , 1,-1    ,false,-1       ,-1      ,-1,data.family  ,null);
		gR2field[ixf_parameter]	= new editField(data.family    ,"s"      ,"s"      ,editObject.string      , 5,-1    ,true ,ixfamily ,-1      ,-1,data.parameter,null);
		gR2field[ixf_interval]	= new editField(data.interval  ,"[0,1]"  ,"[0,1]"  ,editObject.string      ,16,ixf_parameter,true,ixfamily,-1,-1,data.interval ,null);
		gR2field[ixf_steps]		= new editField(data.steps     ,"8"      ,"8"      ,editObject.string      , 8,ixf_parameter,true,ixfamily,-1,-1,data.steps    ,null);
		gR2field[ixparameter]	= new editField(data.parameter ,"t"      ,"t"      ,editObject.string      , 5);
		gR2field[ixinterval]	= new editField(data.interval  ,"[0,1]"  ,"[0,1]"  ,editObject.string      ,16,ixparameter,true,-1   ,-1     ,-1,data.interval ,null);
		gR2field[ixsteps]		= new editField(data.steps     ,"8"      ,"8"      ,editObject.string      , 8,ixparameter,true,-1   ,-1     ,-1,data.steps    ,null);
		gR2field[ixt_text]		= new editField(data.t_text    ,""       ,""       ,editObject.text        ,40,-1    ,true ,-1       ,data.font,-1,data.t_text ,null,false,ixcolor);
		gR2field[ixdecimals]	= new editField(data.decimals  ,"2"      ,"2"      ,editObject.string      , 3);
		gR2field[ixfixed]		= new editField(data.fixed     ,"si"     ,"si"     ,editObject.select      , 1);
		gR2field[ixfill]		= new editField(data.fill      ,fill     ,"no"     ,editObject.color_select, 1);
		gR2field[ixfillplus]	= new editField(data.fillplus  ,fillplus ,"no"     ,editObject.color_select, 1);
		gR2field[ixfillminus]	= new editField(data.fillminus ,"orange" ,"no"     ,editObject.color_select, 1);
		gR2field[ixsize]		= new editField(data.size      ,"2"      ,"2"      ,editObject.string      , 5);
		gR2field[ixwidthness]	= new editField(data.widthness ,"1"      ,"1"      ,editObject.string      , 5);
		gR2field[ixarrow_w]		= new editField(data.widthness ,"5"      ,"5"      ,editObject.string      , 5);
		gR2field[ixspear]		= new editField(data.spear     ,"8"      ,"8"      ,editObject.string      , 5);
		gR2field[ixarrow]		= new editField(data.arrow     ,"ee0022" ,"ee0022" ,editObject.color_button, 1);
		gR2field[ixvisible]		= new editField(data.visible   ,"no"     ,"no"     ,editObject.select      , 1);//Para que no sea visible en descartesJS 20/08/2011
		gR2field[ixeditable]	= new editField(data.editable  ,"no"     ,"no"     ,editObject.select      , 1);
		gR2field[ixrange]		= new editField(data.range     ,"[1,100]","[1,100]",editObject.string      , 8);
		gR2field[ixfile]		= new editField(data.file      ,""       ,""       ,editObject.string      , 24);
		gR2field[ixanim]		= new editField(data.animated  ,"no"     ,"no"     ,editObject.select      , 1);
		gR2field[ixanimfreq]	= new editField(data.animfrec  ,"60"     ,"60"     ,editObject.string      , 2);
		gR2field[ixrotini]		= new editField(data.inirot    ,"0"      ,"0"      ,editObject.string      , 6);
		gR2field[ixposini]		= new editField(data.inipos    ,"[0,0]"  ,"[0,0]"  ,editObject.string      , 12);
		gR2field[ixrotation]	= new editField(data.rotation  ,"0"      ,"0"      ,editObject.string      , 8);
		gR2field[ixlocation]	= new editField(data.location  ,"[0,0]"  ,"[0,0]"  ,editObject.string      , 12);
		gR2field[ixname]		= new editField(data.name      ,""       ,""       ,editObject.string      , 12);
		gR2field[ixcomment]		= new editField(data.info      ,""       ,""       ,editObject.string      , 55);
		gR2field[ixtextborder]	= new editField(data.border     ,"black"   ,"no"     ,editObject.color_select, 2); 
		
	}

	private static final String[] defaultExpresion={
		"y=x",             // t_equation
		"(t,t)",           // t_curve
		"(n,1/n)",         // sequence
		"(0,0)",           // t_point
		"(0,0)(1,1)",      // t_segment
		"(0,0)(1,1)",      // arrow
		"(0,0)(1,1)(2,-1)",// t_polygon
		"(0,0)1(0,90)",    // t_arc
		"(0,0)",           // fill
		"[20,20]",         // t_text
		"(0,0)",           // t_image
		""                 // t_macro
	};

	private static editObjectType[] R2EOT;

	private static void createR2EOT() {
		BitSet[] attr=new BitSet[data.gtix.length]; //numTypes
		for (int i=0;i<attr.length;i++) {
			int type=data.gtix[i];
			attr[i]=new BitSet(numFields);
			for (int j=0;j<numFields;j++) {
				attr[i].clear(j);
			}
			attr[i].set(ixspace);
			attr[i].clear(ixtype);
			attr[i].set(ixbackground);
			attr[i].set(ixcond);
			attr[i].set(ixcolor);
			attr[i].set(ixexpr);
			attr[i].set(ixtrace);
			attr[i].set(ixfamily);
			attr[i].set(ixf_parameter);
			attr[i].set(ixf_interval);
			attr[i].set(ixf_steps);
			attr[i].set(ixt_text);
			attr[i].set(ixdecimals);
			attr[i].set(ixfixed);
			attr[i].set(ixabscoor);
			attr[i].set(ixcomment);
			switch (type) {
			case data.sequence:
				attr[i].set(ixvisible);
				attr[i].set(ixeditable);
				attr[i].set(ixrange);
				attr[i].set(ixsize);
				attr[i].clear(ixt_text);
				attr[i].clear(ixdecimals);
				attr[i].clear(ixfixed);
				break;
			case data.arrow:
				attr[i].set(ixarrow_w);
				attr[i].set(ixspear);
				attr[i].set(ixarrow);
			case data.t_segment:
				attr[i].set(ixwidthness);
			case data.t_point:
				attr[i].set(ixsize);
				break;
			case data.t_arc:
				attr[i].clear(ixexpr);
				attr[i].set(ixcenter);
				attr[i].set(ixradius);
				attr[i].set(ixini);
				attr[i].set(ixend);
				attr[i].set(ixvectors);
				attr[i].set(ixfill);
				attr[i].set(ixwidthness);
				break;
			case data.t_equation:
				attr[i].set(ixvisible);
				attr[i].set(ixeditable);
				attr[i].set(ixfillplus);
				attr[i].set(ixfillminus);
				attr[i].set(ixwidthness);
				attr[i].clear(ixfill);
				attr[i].clear(ixt_text);
				attr[i].clear(ixdecimals);
				attr[i].clear(ixfixed);
				break;
			case data.t_curve:
				attr[i].set(ixvisible);
				attr[i].set(ixeditable);
				attr[i].set(ixparameter);
				attr[i].set(ixinterval);
				attr[i].set(ixsteps);
				attr[i].set(ixfill);
				attr[i].set(ixwidthness);
				attr[i].clear(ixt_text);
				attr[i].clear(ixdecimals);
				attr[i].clear(ixfixed);
				break;
			case data.t_polygon:
				attr[i].set(ixfill);
				attr[i].set(ixwidthness);
				attr[i].clear(ixt_text);
				attr[i].clear(ixdecimals);
				attr[i].clear(ixfixed);
				break;
			case data.fill:
				attr[i].clear(ixt_text);
				attr[i].clear(ixdecimals);
				attr[i].clear(ixfixed);
				break;
			case data.t_text:
				attr[i].set(ixwidthness);
				attr[i].clear(ixabscoor);
				attr[i].set(ixtextborder);
				break;
			case data.t_image:
				attr[i].set(ixfile);
				attr[i].set(ixrotini);
				attr[i].set(ixanim);
				attr[i].set(ixanimfreq);
				attr[i].clear(ixcolor);
				attr[i].clear(ixt_text);
				attr[i].clear(ixdecimals);
				attr[i].clear(ixfixed);
				break;
			case data.t_macro:
				attr[i].set(ixname);
				attr[i].set(ixposini);
				attr[i].set(ixrotini);
				attr[i].clear(ixcolor);
				attr[i].clear(ixtrace);
//				attr[i].clear(ixfamily);
//				attr[i].clear(ixf_parameter);
//				attr[i].clear(ixf_interval);
//				attr[i].clear(ixf_steps);
				attr[i].clear(ixt_text);
				attr[i].clear(ixdecimals);
				attr[i].clear(ixfixed);
				attr[i].set(ixmacros);
				attr[i].clear(ixexpr);
				break;
			default:
				break;
			}

		}
		R2EOT=new editObjectType[attr.length];
		for (int i=0;i<attr.length;i++) {
			R2EOT[i]=new editObjectType("",attr[i]);
		}
	}


	private translator Tr;
	

	private void fixFields() {
		gR2field[ixtype].isFixed=true;
	}

	public graphR2Config(translator Tr,Attribute[] aa,String version0) {
		defineFields();
		fixFields();
		this.Tr=Tr;
		expl=Expl.GraphR2;
		if (R2EOT==null) {
			createR2EOT();
		}
		initialize(Tr,gR2field,R2EOT,aa);
		if (version0.startsWith("3.90")||version0.startsWith("3.91")) {
			s_value[ixvectors]="si";
			useVectors=true;
		}
	}
	
	public graphR2Config(translator Tr,String s,String version0) {
		this(Tr,Attribute.parse(s),version0);
	}
	
	public graphR2Config(translator Tr,String stype,String svalue,String version0) {
		this(Tr,Tr.getTr(data.type)+"="+stype+" "+Tr.getTr(data.expr)+"='"+svalue+"'",version0);
	}

	void setName(String newname) {
		s_value[ixname]=newname;
	}

	public String getName() {
		return s_value[ixname];
	}

	public String getSpace() {
		return s_value[ixspace];
	}

	public String getExpr() {
		return s_value[ixexpr];
	}

	public String getLocation() {
		return s_value[ixposini];
	}

	public String getRotation() {
		return s_value[ixrotini];
	}

	public String getCondition() {
		return s_value[ixcond];
	}

	public boolean isAnimated(translator Tr) {
		return Tr.isTrue(s_value[ixanim]);
	}

	public int getAnimFreq() {
		return BasicStr.parseInteger(s_value[ixanimfreq],60,60);
	}

/* -------------------------- extends editObject --------------------- */

	public void setEditName(String name) {
	}

	public String getEditName() {
		return "";
	}

	public int getNumTypes() {
		return defaultExpresion.length;
	}
	public String getType(translator Tr,int i) {
		return Tr.getTr(data.gtix[i]);
	}
	public String getDefaultExpresion(translator Tr,int i) {
		return defaultExpresion[i];
	}
	public String getListTitle(translator Tr) {
		return Tr.getTr(data.p_graphics);
	}
	public String getTypesInfo(translator Tr) {
		return Tr.getTr(data.expr);
	}

	public int getTypeIndex(translator Tr) {
		String stype=s_value[ixtype];
		for (int i=0;i<data.gtix.length;i++) {
			if (Tr.equals(stype,data.gtix[i])) {
				return i;
			}
		}
		if (stype.length()>0) {
			System.out.println(stype+" not in data.gtix");
		}
		return 0;
	}

	public void updateInfo(translator Tr) {
		type=Tr.getIndex(data.gtix,s_value[ixtype],data.t_equation);
		s_value[ixtype]=Tr.getTr(type);
		if (type==data.t_macro) {
			s_value[ixexpr]=s_value[ixmacros];
		}
		initWidth();
		formula=s_value[ixexpr];
		file=s_value[ixfile];
		s_location=s_value[ixlocation];
		s_rotation=s_value[ixrotation];
		if (type==data.t_arc) {
			s_center=s_value[ixcenter];
			s_radius=s_value[ixradius];
			s_ini=s_value[ixini];
			s_end=s_value[ixend];
			useVectors=Tr.isTrue(s_value[ixvectors]);
			if (!BasicStr.hasContent(s_center)&&BasicStr.hasContent(formula)) {
				getArcFromFormula(true);
			}
			makeArcFormula();
		}
//		parentSpace=s_value[ixspace];
		cond=s_value[ixcond];
		font=BasicStr.parseFont(h_value[ixt_text],font);

		gcolor=Tr.parseColor(s_value[ixcolor],gcolor,null);

		text=s_value[ixt_text];

		isVisible=Tr.isNotFalse(s_value[ixvisible])&&(type==data.t_equation||type==data.t_curve||type==data.sequence);
		isEditable=isVisible&&Tr.isTrue(s_value[ixeditable]);
		isInBack=Tr.isTrue(s_value[ixbackground]);
		mjaColor auxc=Tr.parseColor(s_value[ixtrace],traceColor,null);
		hasTrace=(auxc!=null);
		if (hasTrace) {
			traceColor=auxc;
		}
		arrowColor=Tr.parseColor(s_value[ixarrow],arrowColor,null);
		
		String strColorBordeTexto = s_value[ixtextborder];
		mjaColor borderColor = Tr.parseColor(strColorBordeTexto,null,null);
		hasTextBorder = borderColor!=null;
		if(hasTextBorder){
			colorTextBorder = borderColor;
		}
		
//		Eliminado el 11 de Diciembre de 2008
//		if (arrowColor!=null&&type==data.t_segment) { // correccin por si hay flechas de segmentos
//			type=data.arrow;
//		}
		s_width=s_value[ixwidthness];
		s_arrow_w=s_value[ixarrow_w];
		s_spear=s_value[ixspear];
		String s_fill=s_value[ixfill];
		if (type==data.t_curve) {
		}
		if (type==data.t_curve||type==data.t_arc||type==data.t_polygon) {
			auxc=Tr.parseColor(s_fill,fillColor,null);
			hasFill=(auxc!=null);
			if (hasFill) {
				fillColor=auxc;
			}
		} else {
			String s_fillplus=s_fill;
			String s_fillminus=s_fillplus;
			auxc=Tr.parseColor(s_value[ixfillplus],fillplusColor,null);
			hasFillplus=(auxc!=null);
			if (hasFillplus) {
				fillplusColor=auxc;
			}
			auxc=Tr.parseColor(s_value[ixfillminus],fillminusColor,null);
			hasFillminus=(auxc!=null);
			if (hasFillminus) {
				fillminusColor=auxc;
			}
		}
		s_decimals=s_value[ixdecimals];
		fixed=Tr.isNotFalse(s_value[ixfixed]);
		s_size=s_value[ixsize];
		if (type==data.t_text) { // para corregir un error de la versin 4.5 a la 4.51
			int sz=BasicStr.parseInteger(s_size,2,2);
			if (!"2".equals(s_size)) {
				s_value[ixwidthness]=s_size;
				s_width=s_size;
				s_value[ixsize]="2";
				s_size="2";
			}
		}
		String auxs=s_value[ixfamily];
		isFamily=Tr.isNotFalse(auxs);
		if (isFamily) {
			fparam=s_value[ixf_parameter];
			f_interval=s_value[ixf_interval];
			f_steps=s_value[ixf_steps];
			if (BasicStr.hasContent(fparam)&&!BasicStr.hasContent(f_interval)) {
				try {
					String[] bst=BasicStr.getTokens(fparam);
					if (bst.length==4) {
						fparam=bst[0];
						f_interval="["+bst[1]+","+bst[2]+"]";
						f_steps=bst[3];
					}
				} catch(Exception exc) {
				}
			}
		}
		parameter=s_value[ixparameter];
		p_interval=s_value[ixinterval];
		p_steps=s_value[ixsteps];
		if (BasicStr.hasContent(parameter)&&!BasicStr.hasContent(p_interval)) {
			try {
				String[] bst=BasicStr.getTokens(parameter);
				if (bst.length==4) {
					parameter=bst[0];
					p_interval="["+bst[1]+","+bst[2]+"]";
					p_steps=bst[3];
				}
			} catch(Exception exc) {
			}
		}
		seqRange=s_value[ixrange];
		absCoor=Tr.isTrue(s_value[ixabscoor]);
		if (type==data.t_text) {
			absCoor=true;
//			if (!BasicStr.hasContent(s_value[ixabscoor])) {
//				s_value[ixabscoor]=Tr.getTr(data.Yes);
//				absCoor=true;
//			}
		}

		setId(s_value[ixtype]+" "+formula);
	}

	// R2 graphs (mjaGraph)
	public int type;
//	public String parentSpace="";
	public String formula="",cond="",text="";
	public String seqRange="[1,100]";
	public String fparam="s", f_interval="[0,1]",f_steps="8";
	public String parameter="t", p_interval="[0,1]",p_steps="8";
	public String s_decimals="2", s_size="2", s_width="",s_arrow_w="", s_spear="";
	public String s_center,s_radius,s_ini,s_end;
	public String file="";
	public String s_location="[0,0]",s_rotation="0";
	public boolean isEditable, isInBack, isFamily,fixed=true;
	public mjaColor gcolor=new mjaColor(Color.blue);
	public boolean hasTrace, hasFillplus, hasFillminus, hasFill, absCoor,hasTextBorder;
	public mjaColor traceColor=new mjaColor(Color.gray),
		fillplusColor=new mjaColor(Color.green), fillminusColor=new mjaColor(Color.orange),
		arrowColor=new mjaColor(Color.red),fillColor=new mjaColor(Color.yellow), colorTextBorder = new mjaColor(Color.black);
	private boolean isVisible;
	public boolean useVectors=false;
	
	public boolean isVisible() {
		return isVisible;
	}

/* ------------------------------------------------------------------- */

	public void analyseColors(Parser p) {
		gcolor.analyse(p);
		if (traceColor!=null) {
			traceColor.analyse(p);
		}
		if (fillplusColor!=null) {
			fillplusColor.analyse(p);
		}
		if (fillminusColor!=null) {
			fillminusColor.analyse(p);
		}
		if (arrowColor!=null) {
			arrowColor.analyse(p);
		}
		if (fillColor!=null) {
			fillColor.analyse(p);
		}
	}

	private void initWidth() {
		if (type==data.arrow) {
			s_width="5";
		} else {
			s_width="1";
		}
	}

	private void makeArcFormula() {
		if (s_ini.startsWith("[")||s_ini.startsWith("(")) {
			formula=s_center+s_radius+s_ini+s_end;
		} else {
			formula=s_center+s_radius+"["+s_ini+","+s_end+"]";
		}
	}

	private void getArcFromFormula(boolean old) {
		try {
			String[] st=BasicStr.getTokens(formula);
			if (st.length==5||st.length==7) {
				s_center="("+st[0]+","+st[1]+")";
				s_radius=st[2];
				if (st.length==5) {
					s_ini=st[3];
					s_end=st[4];
					if (old) {
						s_end="("+s_ini+")+("+s_end+")";
					}
				} else {
					s_ini="("+st[3]+","+st[4]+")";
					s_end="("+st[5]+","+st[6]+")";
				}
			}
		} catch (Exception exc) {
			System.out.println("bad expression "+formula);
		}
	}

}