/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descartes;
/*------------------------------------------------------------*/
/*                        graphConfig                         */
/*                         (c)  MJA                           */
/*                       Enero de 2001                        */
/*------------------------------------------------------------*/
import java.awt.*;
import java.util.*;
import com.mja.gui.*;
import com.mja.descgui.*;
import com.mja.descgui.edit.*;
import com.mja.util.*;
import com.mja.lang.*;
import com.mja.parser.*;
import com.mja.file.*;
import org.unam.matem.Attribute;

import com.mja.descgui.edit.editObject;

public class graphR3Config extends editObject {
	
	public static String fcol="magenta", bcol="pink"; // for Descartes
//	public static String fcol="eeffaa", bcol="6090a0"; // for Arquimedes
	
	private static int n=0;

	public static final int
		name=n++,
		space=n++,
		type=n++,
		ixbackground=n++,
		color=n++,
		backColor=n++,
		ixcond=n++,
		macros=n++,
		expr=n++,
		ixfamily=n++,
		ixf_parameter=n++,
		ixf_interval=n++,
		ixf_steps=n++,
		inirot=n++,
		inipos=n++,
		split=n++,
		finrot=n++,
		finpos=n++,
		edges=n++,
		text=n++,
		dec=n++,
		fixed=n++,
		model=n++,
		grueso=n++,
		ancho=n++,
		largo=n++,
		alto=n++,
		Nu=n++,
		Nv=n++,
		rotation=n++,
		location=n++,
		numFields=n++;

	public Font font=com.mja.file.mjaFont.Monospaced;
    private String nameValue="";
	private static final int[] modelTypes={data.plain,data.light,data.metal,data.wire};

	public static int[] colorix={data.color,data.backColor};
	public static int[] noreplix={data.space,data.type,data.background,data.name,data.fixed,data.edges,data.model,data.split};

	public static final editField[] gR3field=new editField[numFields];
	
	public void defineFields() {
		int n=0;
		gR3field[n++]=new editField(data.name     ,""       ,""       ,editObject.string      , 5);
		gR3field[n++]=new editField(data.space    ,""       ,""       ,editObject.choice      , 1,-1,true,-1,-1,-1,data.space,null);
		gR3field[n++]=new editField(data.type     ,""       ,""       ,editObject.string      ,16);
		gR3field[n++]=new editField(data.background,"no"    ,"no"     ,editObject.select      , 1);
		gR3field[n++]=new editField(data.color    ,fcol     ,fcol     ,editObject.color_button, 1);
		gR3field[n++]=new editField(data.backColor,bcol     ,bcol     ,editObject.color_button, 1);
		gR3field[n++]=new editField(data.cond     ,""       ,""       ,editObject.string      ,50);
		gR3field[n++]=new editField(data.expr     ,""       ,""       ,editObject.macro       ,16,-1    ,true ,-1       ,-1     ,-1,data.macro   ,null);
		gR3field[n++]=new editField(data.expr     ,""       ,""       ,editObject.text        ,50);
		gR3field[n++]=new editField(data.family    ,"no"     ,"no"     ,editObject.select      , 1,-1    ,false,-1       ,-1      ,-1,data.family  ,null);
		gR3field[n++]=new editField(data.family    ,"s"      ,"s"      ,editObject.string      , 5,-1    ,true ,ixfamily ,-1      ,-1,data.parameter,null);
		gR3field[n++]=new editField(data.interval  ,"[0,1]"  ,"[0,1]"  ,editObject.string      ,12,ixf_parameter,true,ixfamily,-1,-1,data.interval ,null);
		gR3field[n++]=new editField(data.steps     ,"8"      ,"8"      ,editObject.string      , 8,ixf_parameter,true,ixfamily,-1,-1,data.steps    ,null);
		gR3field[n++]=new editField(data.inirot   ,"(0,0,0)","(0,0,0)",editObject.string      ,21);
		gR3field[n++]=new editField(data.inipos   ,"(0,0,0)","(0,0,0)",editObject.string      ,21);
		gR3field[n++]=new editField(data.split    ,"no"     ,"no"     ,editObject.select      , 1);
		gR3field[n++]=new editField(data.finrot	,"(0,0,0)","(0,0,0)",editObject.string      ,21);
		gR3field[n++]=new editField(data.finpos	,"(0,0,0)","(0,0,0)",editObject.string      ,21);
		gR3field[n++]=new editField(data.edges    ,"no"     ,"no"     ,editObject.select      , 1);
		gR3field[n++]=new editField(data.t_text   ,""       ,""       ,editObject.text        ,30,-1,true ,-1,data.font,-1,data.t_text ,null,false,color);
		gR3field[n++]=new editField(data.decimals ,"2"      ,"2"      ,editObject.string      , 3);
		gR3field[n++]=new editField(data.fixed    ,"yes"    ,"yes"    ,editObject.select      , 1);
		gR3field[n++]=new editField(data.model    ,"color"  ,"color"  ,editObject.choice      , 1,-1,true,-1,-1,-1,data.model,modelTypes);
		gR3field[n++]=new editField(data.widthness,"1"      ,"1"      ,editObject.string      , 9);
		gR3field[n++]=new editField(data.ancho    ,"2"      ,"2"      ,editObject.string      , 9);
		gR3field[n++]=new editField(data.largo    ,"2"      ,"2"      ,editObject.string      , 9);
		gR3field[n++]=new editField(data.alto     ,"2"      ,"2"      ,editObject.string      , 9);
		gR3field[n++]=new editField(data.Nu       ,"7"      ,"7"      ,editObject.string      , 9);
		gR3field[n++]=new editField(data.Nv       ,"7"      ,"7"      ,editObject.string      , 9);
		gR3field[n++]=new editField(data.rotation	,"(0,0,0)","(0,0,0)",editObject.string      ,20);
		gR3field[n++]=new editField(data.location	,"(0,0,0)","(0,0,0)",editObject.string      ,20);
	}

	private static final String[] defaultExpresion={
		"(0,0,0)", 								// t_point
		"(0,0,0)(1,1,1)", 						// t_segment
		"(0,0,0)(1,0,0)(1,1,0)(1,1,1)", 		// t_polygon
		"'x=cos(4*pi*u) y=sen(4*pi*u) z=2*u-1'",// t_curve
		"(1,0,0)(0,1,0)(0,0,1)",				// t_triangle
		"(0,0)(0,1)(1,1)",						// t_face
		"",										// t_regpoly
		"'x=2*u-1 y=2*v-1 z=x^2-y^2'",			// t_surface
		"[20,20]",  							// t_text
		"mi_macro", 							// t_macro
		"", // t_cube
		"", // t_box
		"", // t_tetrahedron
		"", // t_octahedron
		"", // t_dodecahedron
		"", // t_icosahedron
		"", // t_sphere
		"", // t_ellipsoid
		"", // t_cone
		"", // t_cylinder
	};

	private static editObjectType[] R3EOT;

	private static void createR3EOT() {
		BitSet[] attr=new BitSet[data.gtR3ix.length]; //numTypes
		for (int i=0;i<attr.length;i++) {
			attr[i]=new BitSet(numFields);
			for (int j=0;j<numFields;j++) {
				attr[i].set(j);
			}
			attr[i].clear(type);
			int type=data.gtR3ix[i];
			if (type==data.t_macro) {
				attr[i].clear(expr);
				attr[i].clear(color);
				attr[i].clear(backColor);
				attr[i].clear(edges);
				attr[i].clear(model);
				attr[i].clear(split);
			} else {
				attr[i].clear(macros);
			}
			if (type==data.t_point || type==data.t_segment || type==data.t_polygon || type==data.t_curve) {
				attr[i].clear(backColor);
				attr[i].clear(edges);
				attr[i].clear(model);
			} else {
				attr[i].clear(grueso);
			}
			attr[i].clear(graphR3Config.Nu);
			attr[i].clear(graphR3Config.Nv);
			if (type==data.t_surface || type==data.t_cone || type==data.t_cylinder ||
				type==data.t_ellipsoid || type==data.t_sphere) {
				attr[i].set(graphR3Config.Nu);
				attr[i].set(graphR3Config.Nv);
			} else if (type==data.t_curve||type==data.t_segment||type==data.t_polygon||type==data.t_regpoly) {
				attr[i].set(graphR3Config.Nu);
			}
			attr[i].clear(graphR3Config.ancho);
			attr[i].clear(graphR3Config.largo);
			attr[i].clear(graphR3Config.alto);
			if (type==data.t_regpoly) {
				attr[i].set(graphR3Config.ancho);
				attr[i].set(graphR3Config.largo);
			}
			if (type==data.t_sphere || type==data.t_tetrahedron ||
					type==data.t_cube || type==data.t_octahedron ||
					type==data.t_dodecahedron || type==data.t_icosahedron) {
				attr[i].set(graphR3Config.ancho);
			} else if (type==data.arrow) {
				attr[i].set(graphR3Config.ancho);
				attr[i].set(graphR3Config.largo);
			} else if (type==data.t_cone || type==data.t_cylinder ||
					type==data.t_ellipsoid || type==data.t_box) {
				attr[i].set(graphR3Config.ancho);
				attr[i].set(graphR3Config.largo);
				attr[i].set(graphR3Config.alto);
			}
			attr[i].clear(rotation);
			attr[i].clear(location);
			attr[i].set(finrot);
			attr[i].set(finpos);

			attr[i].clear(text);
			attr[i].clear(dec);
			attr[i].clear(fixed);
			if (type==data.t_text) {
				attr[i].set(text);
				attr[i].set(dec);
				attr[i].set(fixed);
				attr[i].clear(inirot);
				attr[i].clear(inipos);
				attr[i].clear(backColor);
				attr[i].clear(edges);
				attr[i].clear(model);
				attr[i].clear(split);
			}
			if (type==data.t_point) {
				attr[i].set(backColor);
				attr[i].set(text);
				attr[i].set(dec);
				attr[i].set(fixed);
			}
		}
		R3EOT=new editObjectType[attr.length];
		for (int i=0;i<attr.length;i++) {
			R3EOT[i]=new editObjectType("",attr[i]);
		}
	}

	private void fixFields() {
		gR3field[type].isFixed=true;
	}

	public graphR3Config(translator Tr,Attribute[] aa) {
		defineFields();
		fixFields();
		expl=Expl.GraphR3;
		if (R3EOT==null) {
			createR3EOT();
		}
		initialize(Tr,gR3field,R3EOT,aa);
	}

	public graphR3Config(translator Tr,String s) {
		this(Tr,Attribute.parse(s));
	}

	public graphR3Config(translator Tr,String stype,String svalue) {
		this(Tr,Tr.getTr(data.type)+"="+stype+" "+Tr.getTr(data.expr)+"="+svalue);
		s_value[model]=Tr.getTr(data.metal); // para cambiar a "metal" el valor por defecto del model
	}

	void setName(String newname) {
		s_value[name]=newname;
	}
	public String getName() {
		return s_value[name];
	}

	public String getSpace() {
		return s_value[space];
	}

	public String getExpr() {
		return s_value[expr];
	}

	public String getLocation() {
		return s_value[inipos];
	}

	public String getRotation() {
		return s_value[inirot];
	}

	public String getCondition() {
		return s_value[ixcond];
	}


/* -------------------------- extends editObject --------------------- */

	public boolean isFamily=false;

	public void updateInfo(translator Tr) {
// porque en las primeras versiones se fueron
// ejemplos con 'Paramtrica' en vez de 'Superficie'.
		if ("Paramtrica".equalsIgnoreCase(s_value[type])) {
			s_value[type]=Tr.getTr(data.t_surface);
		}
		s_value[type]=Tr.getTr(Tr.getIndex(data.gtR3ix,s_value[type],data.t_surface));
		s_value[type]=s_value[type].toLowerCase();
		if (data.gtR3ix[getTypeIndex(Tr)]==data.t_macro) {
			s_value[expr]=s_value[macros];
		}
		String sid=s_value[type];
		if (BasicStr.hasContent(s_value[name])) {
			sid+=" "+s_value[name];
		}
		sid+=" "+s_value[expr];
		setId(sid);
		font=BasicStr.parseFont(h_value[text],font);
		String auxs=s_value[ixfamily];
		isFamily=Tr.isNotFalse(auxs);
	}

	public void setEditName(String name) {
	}

	public String getEditName() {
		return "";
	}

	public int getNumTypes() {
		return defaultExpresion.length;
	}
	public String getType(translator Tr,int i) {
		return Tr.getTr(data.gtR3ix[i]);
	}
	public String getDefaultExpresion(translator Tr,int i) {
		if (defaultExpresion[i].length()==0) {
			return Tr.getTr(data.gtR3ix[i]);
		} else {
			return defaultExpresion[i];
		}
	}
	public String getListTitle(translator Tr) {
		return Tr.getTr(data.p_graphics);
	}
	public String getTypesInfo(translator Tr) {
		return Tr.getTr(data.expr);
	}
	public int getTypeIndex(translator Tr) {
		String stype=s_value[type];
				for (int i=0;i<data.gtR3ix.length;i++) {
			if (Tr.equalsIgnoreCase(stype,data.gtR3ix[i])) {
				return i;
			}
		}
		if (stype.length()>0) {
			System.out.println(stype+" not in data.gtR3ix");
		}
		return 0;
	}

}