/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descartes;

/*------------------------------------------------------------*/
/*                         mjaGraph                           */
/*                         (c)  MJA                           */
/*                       Marzo de 2001                        */
/*------------------------------------------------------------*/

import javax.swing.*;


import java.awt.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import java.util.*;
import java.net.*;
import javax.swing.JTextField;
import com.mja.parser.*;
import com.mja.util.*;
import com.mja.math.*;
import com.mja.file.*;
import com.mja.gui.*;
import com.mja.descgui.*;
import com.mja.lang.*;
import com.mja.poly.*;
import com.mja.text.*;

public class mjaGraph {

	Descartes D;
	graphR2Config gc;
	int size=2;
	parametrization sparz;
	JTextField TF;
	imageThread ith;
	Image image;
	private static final double dosPi=2.0*Math.PI, Pim=Math.PI/2.0,MAX_INT=32767,epsilon=0.0001;
	private static final int segment=0, equation=1,curve=2,sequence=3,line=4,conic=5,funcOfX=6,funcOfY=7;
	private int eqType;
	private int width=-1,arrow_width=-1,spear=-1;
	private Node decimals,cond,N_width, N_size, N_rotini;
	private parametrization tparz;
	private static final String[] lineEq={"y=m*x+b","x=m*y+a","A*x+B*y=C"};
	private static final String[] conicEq={
		"e=sqrt((x-Fx)^2+(y-Fy)^2)/(d+(x-Fx)*cos(t)+(y-Fy)*sen(t))",
		"e=sqrt((x-Fx)^2+(y-Fy)^2)/(d-((x-Fx)*(Dx-Fx)+(y-Fy)*(Dy-Fy))/d)"
	};
	private Node F,fx,fy;
	private int caso,w,h,Fx,Fy,x,y,z,dx,zx,zxx,dy,zy,zyy,zxy;
	private Node x1,y1,x2,y2,r,aN,daN,Si,Sf,iniX,iniY,iniRot,fileN;
	private Node[] xNa,yNa;
	private boolean directedAngle=false, useVectors=false;
	private boolean inited=false;
	private double X0,Y0,X1,Y1,XR,YR,X1R,Y1R,A,Xini,Yini,Cini,Sini;
	private boolean conRTF=false;

	SpaceR2 cs;
	Curve [] lasCurvas;

	public mjaGraph(Descartes D,int gn) {
		this.D=D;
		gc=D.cfg.allgR2c[gn];
		if (gc.type==data.t_equation||gc.type==data.t_curve||gc.type==data.sequence) {
		} else if (gc.type==data.t_arc) {
		} else {
			eqType=segment;
			if (BasicStr.hasContent(gc.file)) {
				String imfnm=gc.file.toLowerCase();
				if (imfnm.endsWith(".gif")||imfnm.endsWith(".jpg")||imfnm.endsWith(".png")||imfnm.endsWith(".bmp")||imfnm.endsWith(".jpeg")) {
					image=mjaFile.loadImage(D.imagesHT,D,gc.file);
				}
				if (image==null) {
					try {
						fileN=D.p.Analyse(gc.file);
					} catch (Exception e) {
						fileN=new Node(D.p,gc.file);
					}
				}
			}
		}
		Space sp=D.scene.getSpace(spaceConfig.dosD,gc.getSpace());
		if (sp instanceof SpaceR2) {
			cs=(SpaceR2)sp;
		}
	}
	
	boolean ifItIsTextCenterIt=false;
	
	void initialize() {
		gc.analyseColors(D.p);
		if (cs!=null) {
			cond=D.p.Analyse(gc.getCondition(),"1");
			decimals=D.p.Analyse(gc.s_decimals,2);
			N_size=D.p.Analyse(gc.s_size);
			size=(int) Math.round(N_size.Evaluate(2));
			N_width=D.p.Analyse(gc.s_width);
			width=(int) Math.round(N_width.Evaluate(1));
			if (BasicStr.hasContent(gc.text)) {
				conRTF = gc.text.indexOf("{\\rtf")>=0;
			}
			N_rotini=D.p.Analyse(gc.getRotation());
			arrow_width=BasicStr.parseInteger(gc.s_arrow_w,1,1);
			spear=BasicStr.parseInteger(gc.s_spear,5,spear);
			if (gc.isFamily) {
				sparz=new parametrization(D.p,gc.fparam,gc.f_interval,gc.f_steps);
			}
			if (BasicStr.hasContent(gc.parameter)) {
				tparz=new parametrization(D.p,gc.parameter,gc.p_interval,gc.p_steps);
			}
			if (gc.type==data.t_equation||gc.type==data.t_curve||gc.type==data.sequence) {
				analyse();
			} else if (gc.type==data.t_arc) {
				eqType=segment;
				xNa=new Node[1];
				yNa=new Node[1];
				try {
					String[] st=BasicStr.getTokens(gc.s_center);
					xNa[0]=D.p.Analyse(st[0]);
					yNa[0]=D.p.Analyse(st[1]);
				} catch (Exception exc) {
					System.out.println("bad expression "+gc.s_center);
				}
				r=D.p.Analyse(gc.s_radius);
				String sini=gc.s_ini;
				if (sini.startsWith("_(")||sini.startsWith("_[")) {
					directedAngle=true;
					sini=sini.substring(1);
				}
				if (sini.startsWith("[")||sini.startsWith("(")) {
					try {
						String[] st=BasicStr.getTokens(sini);
						x1=D.p.Analyse(st[0]);
						y1=D.p.Analyse(st[1]);
						st=BasicStr.getTokens(gc.s_end);
						x2=D.p.Analyse(st[0]);
						y2=D.p.Analyse(st[1]);
					} catch (Exception exc) {
						System.out.println("bad expression "+gc.s_center);
					}
				} else {
					aN=D.p.Analyse(sini);
					daN=D.p.Analyse("("+gc.s_end+")-("+sini+")");
				}
			} else {
				eqType=segment;
				try {
					String[] st=BasicStr.getTokens(gc.formula);
					int N=st.length/2,ix=0;
					ifItIsTextCenterIt=(N>1);
					xNa=new Node[N];
					yNa=new Node[N];
					for (int i=0;i<N;i++) {
						xNa[i]=D.p.Analyse(st[ix++]);
						yNa[i]=D.p.Analyse(st[ix++]);
					}
				} catch (Exception exc) {
					System.out.println("bad expression "+gc.formula);
				}
			}
			try {
				String[] st=BasicStr.getTokens(gc.s_location);
				if (st.length==2) {
					iniX=D.p.Analyse(st[0]);
					iniY=D.p.Analyse(st[1]);
				}
				iniRot=D.p.Analyse(gc.s_rotation);
			} catch (Exception exc) {
				System.out.println("bad expression "+gc.s_location);
			}
		}
		inited=true;
	}
	
	void analyse() {
		if (cs!=null) {
			if (gc.type!=data.t_equation) {
				try {
					String[] st=BasicStr.getTokens(gc.formula);
					int ix=0;
					if (st.length>1)	{
						if (gc.type==data.sequence) {
							eqType=sequence;
							Si=D.p.Analyse("1");
							Sf=D.p.Analyse("100");
							try {
								String[] st2=BasicStr.getTokens(gc.seqRange);
								int ix2=0;
								if (st2.length>1) {
									Si=D.p.Analyse(st2[ix2++].trim());
									Sf=D.p.Analyse(st2[ix2++].trim());
								}
							} catch (Exception exc2) {
							}
						} else {
							eqType=curve;
						}
						fx=D.p.Analyse(st[ix++]);
						fy=D.p.Analyse(st[ix++]);
						return;
					}
				} catch (Exception exc) {
				}
			} else {
				for (int i=0;i<lineEq.length;i++) {
					if (gc.formula.equals(lineEq[i])) {
						eqType=line;
						return;
					}
				}
				for (int i=0;i<conicEq.length;i++) {
					if (gc.formula.equals(conicEq[i])) {
						eqType=conic;
						return;
					}
				}
				StringTokenizer st=new StringTokenizer(gc.formula,"=");
				if (st.hasMoreTokens()) {
					String initial=st.nextToken();
					if (initial.equals("y")||initial.equals("x")) {
						F=D.p.Analyse(gc.formula.substring(gc.formula.indexOf('=')+1,gc.formula.length()).trim());
						if (initial.equals("y")&&!F.contains("y")) {
							eqType=funcOfX;
						return;
						}
						if (initial.equals("x")&&!F.contains("x")) {
							eqType=funcOfY;
							return;
						}
					}
				}
				eqType=equation;
			}
		}
	}

	private R2 TR(R2 p) {
		return new R2(Xini+Cini*p.x-Sini*p.y,Yini+Sini*p.x+Cini*p.y);
	}
	
	private int curveIndex=0;
	
	void createLasCurvas(int sz) {
		lasCurvas=new Curve[sz+1];
		for (int i=0;i<=sz;i++){
			lasCurvas[i]=new Curve();
		}
	}

	void draw(Image imag,Graphics[] g,mjaColor[] mjac,int n) {
		curveIndex=n;
		if (inited) {
			width=(int) Math.round(N_width.Evaluate(1));
			size=(int) Math.round(N_size.Evaluate(2));
			lasCurvas[curveIndex].WIDTH=width;
			lasCurvas[curveIndex].SIZE=size;
			lasCurvas[curveIndex].bc=gc.fillColor.getAdaptedColor();
			lasCurvas[curveIndex].fill=gc.hasFill;
			if (cs!=null) {
				double toDraw=cond.Evaluate(1);
				lasCurvas[n].draw=(toDraw>0);
				if (toDraw<1 && ith!=null) {
					ith.pleaseStop();
					ith=null;
				}
				if (toDraw>0||eqType==funcOfX||eqType==funcOfY) {
					for (int i=0;i<g.length;i++) {
						lasCurvas[n].fc=mjac[i].getAdaptedColor();
						g[i].setColor(mjac[i].getAdaptedColor());
					}
					if (iniX!=null && iniY!=null) {
						Xini=iniX.Evaluate(0);
						Yini=iniY.Evaluate(0);
					} else {
						Xini=0; Yini=0;
					}
					if (iniRot!=null) {
						A=iniRot.Evaluate(0);
						Cini=Math.cos(Math.PI*A/180);
						Sini=Math.sin(Math.PI*A/180);
					} else {
						A=0; Cini=1; Sini=0;
					}
					if (xNa!=null&& xNa.length>0 && xNa[0]!=null && yNa[0]!=null) {
						X0=xNa[0].Evaluate(0); Y0=yNa[0].Evaluate(0);
					} else {
						X0=0; Y0=0;
					}
					if (xNa!=null&& xNa.length>1 && xNa[1]!=null && yNa[1]!=null) {
						X1=xNa[1].Evaluate(0); Y1=yNa[1].Evaluate(0);
					} else {
						X1=0; Y1=0;
					}
					XR=Xini+Cini*X0-Sini*Y0;
					YR=Yini+Sini*X0+Cini*Y0;
					X1R=Xini+Cini*X1-Sini*Y1;
					Y1R=Yini+Sini*X1+Cini*Y1;
	
					if (BasicStr.antialias) {		// agregado el 29 de septiembre de 2008
						for (int i=0;i<g.length;i++) {
							Stroke bs=new BasicStroke(width,BasicStroke.CAP_ROUND,BasicStroke.JOIN_ROUND);
							((Graphics2D)g[i]).setStroke(bs);
							((Graphics2D)g[i]).setRenderingHint(RenderingHints.KEY_ALPHA_INTERPOLATION, RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY);
						    ((Graphics2D)g[i]).setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
						    ((Graphics2D)g[i]).setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
						    ((Graphics2D)g[i]).setRenderingHint(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_QUALITY);
						    ((Graphics2D)g[i]).setRenderingHint(RenderingHints.KEY_COLOR_RENDERING, RenderingHints.VALUE_COLOR_RENDER_QUALITY);
						    ((Graphics2D)g[i]).setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BICUBIC);
						    ((Graphics2D)g[i]).setRenderingHint(RenderingHints.KEY_STROKE_CONTROL, RenderingHints.VALUE_STROKE_NORMALIZE);
						}
					} else if (width>1) {
						for (int i=0;i<g.length;i++) {
						    ((Graphics2D)g[i]).setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
						}
					} else {
						Stroke bs=new BasicStroke(1,BasicStroke.CAP_BUTT,BasicStroke.JOIN_ROUND);
						for (int i=0;i<g.length;i++) {
						    ((Graphics2D)g[i]).setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_OFF);
						    ((Graphics2D)g[i]).setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_OFF);
							((Graphics2D)g[i]).setStroke(bs);
						}
					}
	
					for (int i=0;i<g.length;i++) {
						Graphics2D g2=(Graphics2D)g[i];
						Stroke bs=new BasicStroke(1,BasicStroke.CAP_ROUND,BasicStroke.JOIN_ROUND);
						g2.setStroke(bs);
					}
	
					switch (eqType) {
					case segment  : drawSegment(imag,g,mjac); break;
					case curve    : drawCurve(g,mjac); break;
					case sequence : drawSequence(g,mjac); break;
					case line     : drawLine(g); break;
					case conic    : drawConic(g); break;
					case funcOfX  : drawFunction(g,mjac,false); break;
					case funcOfY  : drawFunction(g,mjac,true); break;
					case equation : drawEquation(g,mjac); break;
					}
	
					if (width>1 && !BasicStr.antialias) {	// agregado el 29 de septiembre de 2008
						for (int i=0;i<g.length;i++) {
						    ((Graphics2D)g[i]).setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_OFF);
						}
					}
	
				}
			}
		}
	}

	static void Arc(Graphics g,int width,int x0, int y0, int r, int ai, int da) {
		if (da<0) {
			ai=ai+da;
			da=-da;
		}
		Graphics2D g2=(Graphics2D)g;
		Stroke bs=new BasicStroke(width,BasicStroke.CAP_ROUND,BasicStroke.JOIN_ROUND);
		g2.setStroke(bs);
		g2.drawArc(x0-r,y0-r,2*r,2*r,ai,da);
		bs=new BasicStroke(1);
		g2.setStroke(bs);
	}

	static void circle(Graphics g,int xc, int yc, double r) {
		if (r>0) {
			if (r>1.4) {
				g.fillOval(xc-(int) Math.round(r),yc-(int) Math.round(r),(int) Math.round(2*r),(int) Math.round(2*r));
			} else {
				g.drawLine(xc,yc,xc,yc);
			}
		}
	}

	static void drawPolygon(Graphics[] g,int width,Polygon P,boolean fill,Color fillColor) {
		if (fill) {
			for (int i=0;i<g.length;i++) {
				Color c=g[i].getColor();
				g[i].setColor(fillColor);
				g[i].fillPolygon(P);
				g[i].setColor(c);
			}
		}
		if (width>0) {	// agregado el 13 de marzo de 2008
			for (int i=0;i<g.length;i++) {
				Graphics2D g2=(Graphics2D)g[i];
				Stroke bs=new BasicStroke(width,BasicStroke.CAP_ROUND,BasicStroke.JOIN_ROUND);
				g2.setStroke(bs);
				g2.drawPolyline(P.xpoints,P.ypoints,P.npoints);
				bs=new BasicStroke(1);
				g2.setStroke(bs);
			}
		}
	}

	/* ---------------------- segment, point, arc or text ------------------- */

	private void Line(Graphics g,int width,int x1,int y1,int x2,int y2) {
		Line(g,width,x1,y1,x2,y2,false);
	}

	private void Line(Graphics g,int width,int x1,int y1,int x2,int y2,boolean invert) {
		if (width>0) {
			int h=cs.getSize().height;
			Graphics2D g2=(Graphics2D)g;
			Stroke bs=new BasicStroke(width,BasicStroke.CAP_ROUND,BasicStroke.JOIN_ROUND);
			g2.setStroke(bs);
			if (invert) {
				g2.drawLine(y1,h-x1,y2,h-x2);
			} else {
				g2.drawLine(x1,y1,x2,y2);
			}
			bs=new BasicStroke(1);
			g2.setStroke(bs);
		}
	}

	void drawSegment(Image img,Graphics[] g,mjaColor[] mjac)	{
		if (gc.type==data.t_arc) {
			drawArc(g);
		} else if (xNa.length<=2) {
			lasCurvas[curveIndex].sz=2;
			lasCurvas[curveIndex].X=new double[2];
			lasCurvas[curveIndex].Y=new double[2];
			R2 q=new R2(0,0);
			int _Text_H_=0;
			D.p.Var("_Text_H_").setDouble(_Text_H_);
			try {
				R2 p0=new R2(XR,YR);
				R2 p1=p0;
				if (gc.type==data.t_segment||gc.type==data.arrow) {
					p1=new R2(X1R,Y1R);
				}
				p0=cs.projection(p0,gc.absCoor);
				p1=cs.projection(p1,gc.absCoor);
				lasCurvas[curveIndex].X[0]=p0.x;
				lasCurvas[curveIndex].Y[0]=p0.y;
				lasCurvas[curveIndex].X[1]=p1.x;
				lasCurvas[curveIndex].Y[1]=p1.y;
				if (gc.type==data.t_image) {
					if (fileN!=null) {
						try {
							boolean imagedone=false;
							Space space=D.scene.getSpaceByPrefix(gc.file);
							if (space!=null) {
								if (gc.file.endsWith(".back")) {
									image=space.getBackImage();
									imagedone=true;
								} else if (gc.file.endsWith(".image")) {
									image=space.main;
									imagedone=true;
								}
							} 
							if (!imagedone) {
								fileN.Evaluate();
								if (fileN.getStr()!=null) {
									image=mjaFile.loadImage(D.imagesHT,D,fileN.getStr());
								}
							}
						} catch (Exception e) {
						}
					}
					if (gc.isAnimated(D.Tr)) {
						if (ith==null) {
							ith=new imageThread(image,cs,gc.getAnimFreq());
						}
						ith.setPos(p0.ix(),p0.iy());
					} else {
						for (int i=0;i<g.length;i++) {
							if(BasicStr.isJava2()){
								double scale_x=1,scale_y=1;
								boolean center=false;
								if (X1!=0) {
									scale_x=X1;
									center=true;
								}
								if (Y1!=0) {
									scale_y=Y1;
									center=true;
								}
								AffineTransform xform = new AffineTransform();
								if (!center) {
								    xform.translate(image.getWidth(cs)/2.0, image.getHeight(cs)/2.0);
								} 
								xform.translate(p0.ix(), p0.iy());
							    double rot = -N_rotini.Evaluate(0); 
							    xform.rotate(rot*(Math.PI/180.0));
							    xform.translate(-image.getWidth(cs)*scale_x/2.0, -image.getHeight(cs)*scale_y/2.0);
							    xform.scale(scale_x,scale_y);
							    ((Graphics2D)g[i]).drawImage(image, xform, cs);
							}else{
								g[i].drawImage(image,p0.ix(),p0.iy(),cs);
							}
						}
					}
				} else if (gc.type!=data.arrow &&(p0.ix()!=p1.ix()||p0.iy()!=p1.iy()))	{
					for (int i=0;i<g.length;i++) {
						Line(g[i],width,p0.ix(),p0.iy(),p1.ix(),p1.iy());
					}
				}
				if (gc.type!=data.t_text&&size>0)	{
					if (gc.type==data.arrow) {
						for (int i=0;i<g.length;i++) {
							drawArrow(g[i],gc.arrowColor.getAdaptedColor(),gc.gcolor.getAdaptedColor(),p0.ix(),p0.iy(),p1.ix(),p1.iy(),arrow_width,spear);
						}
					} else if (gc.type==data.fill) {
						int x0=p0.ix() , y0=p0.iy() ;
						int w=cs.getSize().width;
						int h=cs.getSize().height;
						if ( 0<=x0 && 0<=y0 && x0<w && y0<h ) {
							Stroke bs=new BasicStroke(1,BasicStroke.CAP_BUTT,BasicStroke.JOIN_ROUND);
							for (int i=0;i<g.length;i++) {
							    ((Graphics2D)g[i]).setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_OFF);
								((Graphics2D)g[i]).setStroke(bs);
							}
							int[] pixels = mjaGui.grabPixelsFromImage(w,h,img);
							mjaGui.fillShape(g,pixels,w,h,x0,y0);
						}
					} else if (gc.type!=data.t_image) {
						for (int i=0;i<g.length;i++) {
							if (cs.inside(p0)) {
								circle(g[i],p0.ix(),p0.iy(),size);
							}
							if ((p0.ix()!=p1.ix()||p0.iy()!=p1.iy()) && cs.inside(p1)) {
								circle(g[i],p1.ix(),p1.iy(),size);
							}
						}
					}
				}
				if (conRTF) {
					q=new R2((2*p0.ix()+p1.ix())/3 + width + 1,(2*p0.iy()+p1.iy())/3 - width -1);
				} else {
					q=new R2((2*p0.ix()+p1.ix())/3 +  2  + 1,(2*p0.iy()+p1.iy())/3 -  2  -1);
				}
			} catch (Exception e) {
			}
			if (gc.type==data.t_text) {
				lasCurvas[curveIndex].WIDTH=0;
			}
			if (BasicStr.hasContent(gc.text)) {
				R2 qq=getTextPos(g[0],q,gc.type==data.t_text);
				lasCurvas[curveIndex].mt=new MathText(D.p,D.Tr,gc.text,decimals,gc.fixed,gc.font,gc.gcolor.getAdaptedColor());
				lasCurvas[curveIndex].xt=qq.ix();
				if (conRTF) {
					lasCurvas[curveIndex].mt.draw(cs,qq.ix(),qq.iy(),g);
				} else if (gc.type!=data.t_text) {
					lasCurvas[curveIndex].mt.draw(cs,qq.ix(),qq.iy(),g);
				} else {
					String[] text_sa=makeStringArray(gc.text,width,gc.font,g[0]);
					String elTexto="";
					for (int i=0;i<text_sa.length;i++) {
						elTexto+=text_sa[i];
						elTexto+=((i+1)<text_sa.length)?"\n":"";
					}
					lasCurvas[curveIndex].mt=new MathText(D.p,D.Tr,elTexto,decimals,gc.fixed,gc.font,gc.gcolor.getAdaptedColor());
					FontMetrics fm=g[0].getFontMetrics();
					int fA=fm.getAscent();
					int fD=fm.getDescent();
					int fH=fm.getHeight();
					int HTEXT=text_sa.length*fH;
					int dH=text_sa.length*(fH-fA-fD);
					lasCurvas[curveIndex].dyt=qq.iy()-dH-fD;
					if (ifItIsTextCenterIt ) {
						lasCurvas[curveIndex].xt=qq.ix()+((int)X1-WTEXT)/2;
						lasCurvas[curveIndex].dyt=qq.iy()+((int)Y1-HTEXT-dH)/2;
					}
					lasCurvas[curveIndex].hasBorder=(gc.type==data.t_text)&&this.gc.hasTextBorder;
					lasCurvas[curveIndex].borderColor=gc.colorTextBorder.getFullColor();
					for (int i=0;i<g.length;i++) {
						g[i].setFont(gc.font);
						HTEXT=text_sa.length*fH;
						for (int j=0;j<text_sa.length;j++) {
							int x=(int) q.x;
							int y=(int) q.y + fA + _Text_H_;
							if ((gc.type==data.t_text)&&ifItIsTextCenterIt) {
								x=x+((int)X1-WTEXT)/2;
								y=y+((int)Y1-HTEXT)/2;
							}
							Point p = new Point(x,y);
							if(this.gc.hasTextBorder){
								mjaFont.drawTextBorder((Graphics2D) g[i],text_sa[j] , p, this.gc.colorTextBorder.getFullColor());
							}
							g[i].setColor(gc.gcolor.getAdaptedColor());
							g[i].drawString(text_sa[j],p.x,p.y);
							_Text_H_+=fH;
							D.p.Var("_Text_H_").setDouble(_Text_H_);
						}
					}
						
				}
			}
		} else {
			Polygon P=new Polygon();
			try {
				lasCurvas[curveIndex].sz=xNa.length;
				lasCurvas[curveIndex].X=new double[xNa.length];
				lasCurvas[curveIndex].Y=new double[xNa.length];
				for (int n=0;n<xNa.length;n++)	{
					double x=xNa[n].Evaluate();
					double y=yNa[n].Evaluate();
					R2 p1=cs.projection(TR(new R2(x,y)),gc.absCoor);
					P.addPoint(p1.ix(),p1.iy());
					lasCurvas[curveIndex].X[n]=p1.ix();
					lasCurvas[curveIndex].Y[n]=p1.iy();
				}
				drawPolygon(g,width,P,gc.hasFill,gc.fillColor.getAdaptedColor());
			} catch (Exception e) {
			}
		}
	}

	private int WTEXT;
	
	public String[] makeStringArray(String str,int width,Font font,Graphics g0) {
		width=(width<20)?1000000:width;
		g0.setFont(font);
		FontMetrics fm=g0.getFontMetrics();
		Vector<String> V=new Vector<String>();
		String sb="",s0="",s="";
		int k=0;		
		str = BasicStr.replace(str, "\\n", "\n");
		String text = D.p.evaluateString(str,(int)Math.round(decimals.Evaluate(2)),gc.fixed);
		text = BasicStr.replace(text, "\\n", "\n");
		WTEXT=0;
		while (k<text.length()) {
			char ch=text.charAt(k);
			if ((ch != '\n') && ((ch==' ')||(fm.stringWidth(sb+ch)<width))) {
				sb+=ch;
				if (ch==' ') {
					s=sb;
					s0="";
				} else {
					s0+=ch;
				}
				k++;
			} else {
				if(ch=='\n'){
					k++;
				}
				
				if (s.length()==0 || ch=='\n') {
					s=sb;
					s0="";
				} 
				int swidth=fm.stringWidth(s);
				WTEXT=(WTEXT<swidth)?swidth:WTEXT;
				V.add(s);
				sb=s0;
				s="";
			}
		}
		if (sb.length()>0) {
			int sbwidth=fm.stringWidth(sb);
			WTEXT=(WTEXT<sbwidth)?sbwidth:WTEXT;
			V.addElement(sb);
		}
		String[] sa=new String[V.size()];
		for (int i=0;i<V.size();i++) {
			sa[i]=(String) V.elementAt(i);
		}
		return sa;
	}
	


	void drawArc(Graphics[] g) {
		R2 q=new R2(0,0);
		lasCurvas[curveIndex].isCircle=true;
		try {
			R2 p0=cs.projection(new R2(XR,YR),gc.absCoor); // estas ya son absolutas si gc.absCoor.
			lasCurvas[curveIndex].sz=1;
			lasCurvas[curveIndex].X=new double[1];
			lasCurvas[curveIndex].Y=new double[1];
			lasCurvas[curveIndex].X[0]=p0.x;
			lasCurvas[curveIndex].Y[0]=p0.y;
			int ra=(int)Math.round(cs.Nesc.getDouble()*r.Evaluate());
			if (gc.absCoor) {
				ra=(int)Math.round(r.Evaluate());
			}
			lasCurvas[curveIndex].radius=ra;
			int ai=0,da=360;
			if (aN!=null&&daN!=null)	{
				ai=(int)Math.round(A+aN.Evaluate());
				da=(int)Math.round(daN.Evaluate());
				if (gc.absCoor) {
					ai=-ai;
					da=-da;
				}
			} else {
				R2 P1=new R2(1,0);
				R2 P2=new R2(0,1);
				if (gc.useVectors) {
					P1=cs.projection(TR(new R2(x1.Evaluate()+XR,y1.Evaluate()+YR)),gc.absCoor);
					P2=cs.projection(TR(new R2(x2.Evaluate()+XR,y2.Evaluate()+YR)),gc.absCoor);
				} else { // use points
					P1=cs.projection(TR(new R2(x1.Evaluate(),y1.Evaluate())),gc.absCoor);
					P2=cs.projection(TR(new R2(x2.Evaluate(),y2.Evaluate())),gc.absCoor);
				}
				P1.sub(p0);
				P2.sub(p0);
				P1.normalize();
				P2.normalize();
				ai=(int)Math.round(180.0*Math.asin(-P1.y)/Math.PI);
				double dA=P1.dot(P2);
				da=(int)Math.round(180.0*Math.acos(dA)/Math.PI);
				if (P1.x<0) { ai=180-ai; }
				while (ai<0) { ai+=360; }
				while (ai>360) { ai-=360; }
				double Det=P1.det(P2);
				if (Det>0) {
					if (directedAngle) { 
						da=360-da; 
					} else {
						da=-da;
					}
					
				} 
			}
			lasCurvas[curveIndex].ai=ai;
			lasCurvas[curveIndex].da=da;
			if (Math.abs(((double)ra*da)*Math.PI/180)>=1.0 && Math.abs(ra-p0.norm())<4096) {
				if (da<0) {
					ai+=da;
					da=-da;
				}
				if (gc.hasFill) {
					for (int i=0;i<g.length;i++) {
						Color c=g[i].getColor();
						g[i].setColor(gc.fillColor.getAdaptedColor());
						g[i].fillArc(p0.ix()-ra,p0.iy()-ra,2*ra,2*ra,ai,da);
						g[i].setColor(c);
					}
				}
				for (int i=0;i<g.length;i++) {
					Arc(g[i],width,p0.ix(),p0.iy(),ra,ai,da);
				}
			}
			q=p0;
		} catch (Exception e) {
			e.printStackTrace();
		}
		if (BasicStr.hasContent(gc.text)) {
			lasCurvas[curveIndex].mt=new MathText(D.p,D.Tr,gc.text,decimals,gc.fixed,gc.font,gc.gcolor.getAdaptedColor());
			R2 qq=getTextPos(g[0],q,gc.type==data.t_text);
			lasCurvas[curveIndex].mt.draw(cs,qq.ix(),qq.iy(),g);
		}
	}

	private R2 getTextPos(Graphics g,R2 q,boolean topcoor) {
		int y0=0;
		TFont tf=new TFont(gc.font);
		y0=-tf.getAscent();
		if (topcoor) {
			y0=4;
		}
		return new R2(q.ix()+size,y0+q.iy()-size);
	}

	private void drawArrow(Graphics g,Color in,Color out,int x, int y, int x1, int y1,int W,int S) {
		if (W<0) {
			W=6;
		}
		W=2*((W+1)/2);
		if (S<0) {
			S=W;
		}
		S=2*((S+1)/2);
		int dx=x1-x, dy=y1-y;
		double L=Math.sqrt((double)(dx*dx+dy*dy));
		double A=0;
		if (L>0) {
			A=Math.acos(dx/L);
		}
		if (dy<0) {
			A=2*Math.PI-A;
		}
		g.setColor(in);
		Polygon poly=flecha(x,y,W,S,L,A);
		lasCurvas[curveIndex].WIDTH=1;
		lasCurvas[curveIndex].bc=in;
		lasCurvas[curveIndex].fc=out;
		lasCurvas[curveIndex].fill=true;
		lasCurvas[curveIndex].sz=poly.npoints+1;
		lasCurvas[curveIndex].X=new double[poly.npoints+1];
		lasCurvas[curveIndex].Y=new double[poly.npoints+1];
		for (int i=0;i<poly.npoints;i++) {
			lasCurvas[curveIndex].X[i]=poly.xpoints[i];
			lasCurvas[curveIndex].Y[i]=poly.ypoints[i];
		}
		lasCurvas[curveIndex].X[poly.npoints]=poly.xpoints[0];
		lasCurvas[curveIndex].Y[poly.npoints]=poly.ypoints[0];
		g.fillPolygon(poly);
		g.setColor(out);
		g.drawPolygon(poly);
	}

	private static Polygon flecha(int x,int y,double W,double S,double L,double A) {
		R2[] poly0= new R2[7];
		poly0[0]=new R2(-W/2,W/2);
		poly0[1]=new R2(L-W-S,W/2);
		poly0[2]=new R2(L-2*S,S+W/2);
		poly0[3]=new R2(L,0);
		poly0[4]=new R2(L-2*S,-S-W/2);
		poly0[5]=new R2(L-W-S,-W/2);
		poly0[6]=new R2(-W/2,-W/2);
		int[] xx = new int[poly0.length];
		int[] yy = new int[poly0.length];
		for (int i=0; i<poly0.length; i++) {
			poly0[i].rot(-A);
			xx[i]=x+(int) Math.round(poly0[i].x);
			yy[i]=y-(int) Math.round(poly0[i].y);
		}
		return new Polygon(xx,yy,poly0.length);
	}

	/* ----------------------------- Curve ----------------------------- */

	void drawCurve(Graphics[] g,mjaColor[] mjac) {
		if (tparz!=null) {
			Node T=D.p.Var(tparz.name);
			synchronized (T) {
				double t=T.getDouble();
				R2 P0=new R2(0,0);
				boolean firstPoint=true;
				int tN=(int)Math.round(tparz.NN.Evaluate(32));
				double ti=tparz.Ni.Evaluate(0);
				double tf=tparz.Nf.Evaluate(1);
				Polygon P=new Polygon();
//				boolean conda=false;
				double xa=0,ya=0;
				boolean hasPoints=false;
				for (int n=0;n<=tN;n++)	{
					boolean addpoint=true;
					T.setDouble(ti+(tf-ti)*(double)n/(double)tN);
					double x=0,y=0;
					try {
						x=fx.Evaluate();
						y=fy.Evaluate();
						xa=x;
						ya=y;
					} catch (Exception e) {
						addpoint=false;	
					}
					if (addpoint) {
						R2 p1=cs.projection(TR(new R2(x,y)),gc.absCoor);
						P.addPoint(p1.ix(),p1.iy());
						hasPoints=true;
					} else {
						if (hasPoints) {
							lasCurvas[curveIndex].bc=gc.fillColor.getAdaptedColor();
							drawPolygon(g,width,P,false,null);
							if (gc.hasFill||!BasicStr.hasContent(gc.cond)||(cond.Evaluate(1)>0)) {
								drawPolygon(g,width,P,gc.hasFill,gc.fillColor.getAdaptedColor());
							}
							}
						P=new Polygon();
						hasPoints=false;
					}
				}
				if (hasPoints) {
					lasCurvas[curveIndex].sz=P.npoints-1;
					lasCurvas[curveIndex].X=new double[P.npoints+1];
					lasCurvas[curveIndex].Y=new double[P.npoints+1];
					for (int n=0;n<P.npoints+1;n++) {
						lasCurvas[curveIndex].X[n]=P.xpoints[n];
						lasCurvas[curveIndex].Y[n]=P.ypoints[n];
					}
					drawPolygon(g,width,P,false,null);
					if (gc.hasFill||!BasicStr.hasContent(gc.cond)||(cond.Evaluate(1)>0)) {
						lasCurvas[curveIndex].sz++;
						lasCurvas[curveIndex].bc=gc.fillColor.getAdaptedColor();
						drawPolygon(g,width,P,gc.hasFill,gc.fillColor.getAdaptedColor());
					}
				}
				T.setDouble(t);
			}
		}
	}

	/* ----------------------------- Sequence ----------------------------- */

	void drawSequence(Graphics[] g,mjaColor[] mjac) {
		int N1=(int) Math.round(Si.Evaluate(1));
		int N2=(int) Math.round(Sf.Evaluate(1));
		Node N=D.p.Var("n");
		synchronized (N) {
			double nv=N.getDouble();
			for (int n=N1;n<=N2;n++) {
				N.setDouble(n);
				if (cond.Evaluate(1)>0) {
					try {
						double x=fx.Evaluate();
						double y=fy.Evaluate();
						R2 p=cs.projection(TR(new R2(x,y)),gc.absCoor);
						for (int i=0;i<g.length;i++) {
							g[i].setColor(mjac[i].getAdaptedColor());
							circle(g[i],p.ix(),p.iy(),size);
						}
					} catch (Exception e) {
						System.out.println(e);
					}
				}
			}
			N.setDouble(nv);
		}
	}

	/* -------------------------- Line --------------------------- */

	private void drawLine(Graphics[] g) {
		int x1=0,y1=0,x2=0,y2=0;
		if (gc.formula.equals(lineEq[0])) {
			double m0=D.p.rvalue("m");
			double b0=cs.Nesc.getDouble()*D.p.rvalue("b");
			x1=0;    y1=cs.Oy-(int)Math.round(b0+m0*(x1-cs.Ox));
			x2=cs.getSize().width; y2=cs.Oy-(int)Math.round(b0+m0*(x2-cs.Ox));
		}
		if (gc.formula.equals(lineEq[1])) {
			double m1=D.p.rvalue("m");
			double a1=cs.Nesc.getDouble()*D.p.rvalue("a");
			y1=0;    x1=cs.Ox+(int)Math.round(m1*(y1-cs.Oy)+a1);
			y2=cs.getSize().height; x2=cs.Ox+(int)Math.round(m1*(y2-cs.Oy)+a1);
		} else if (gc.formula.equals(lineEq[2])) {
			double A=D.p.rvalue("A");
			double B=D.p.rvalue("B");
			double C=D.p.rvalue("C");
			if (Math.abs(B)>Math.abs(A)) {
				double m1=-A/B;
				double b1=(C/B)*cs.Nesc.getDouble();
				x1=0;   y1=cs.Oy-(int)Math.round(b1+m1*(x1-cs.Ox));
				x2=cs.getSize().width;; y2=cs.Oy-(int)Math.round(b1+m1*(x2-cs.Ox));
			} else if (Math.abs(A)>0.01) {
				double m1=-B/A;
				double b1=-(C/A)*cs.Nesc.getDouble();
				y1=0;   x1=cs.Ox-(int)Math.round(b1+m1*(y1-cs.Oy));
				y2=cs.getSize().height; x2=cs.Ox-(int)Math.round(b1+m1*(y2-cs.Oy));
			} else {
				return;
			}
		}
		for (int i=0;i<g.length;i++) {
			Line(g[i],width,x1,y1,x2,y2);
		}
	}

	/* -------------------------- Conic --------------------------- */

//	private Graphics[] g;

	private void drawConic(Graphics[] g) {
//		this.g=g;
		boolean twoBranches=false;
		w=cs.getSize().width; h=cs.getSize().height;
		double d=1.0,e=1.0,t=0.0;
		R2 F=cs.projection(new R2(D.p.rvalue("Fx"),D.p.rvalue("Fy")),gc.absCoor);
		if (gc.formula.equals(conicEq[0]))	{
			e=D.p.rvalue("e");
			if (e>20) {
				return;
			}
			d=cs.Nesc.getDouble()*D.p.rvalue("d");
			t=D.p.rvalue("t");
			twoBranches=false;
		} else if (gc.formula.equals(conicEq[1])) {
			R2 Q=cs.projection(new R2(D.p.rvalue("Dx"),D.p.rvalue("Dy")),gc.absCoor);
			R2 P=cs.projection(new R2(D.p.rvalue("Px"),D.p.rvalue("Py")),gc.absCoor);
			d=Q.distance(F);
			double PF=P.distance(F),PQ=P.distance(Q);
			if (PQ<0.1||PF<0.1||d<0.1) {
				return;
			}
			double sint=F.y-Q.y, cost=F.x-Q.x;
			if (cost==0) {
				if (sint>=0) {
					t=-Pim;
				} else {
					t=Pim;
				}
			} else {
				t=Math.atan(-sint/cost);
				if (cost<0) {
					t=t+Math.PI;
				}
			}
			P.sub(F); Q.sub(F);
			e=(d - (Q.dot(P)/d))/PF;
			if (e<0.05) {
				return;
			}
			e=1/e;
			twoBranches=false;
		}
		Fx=F.ix(); Fy=F.iy();
		doDrawConic(g,d,e,t);
		if (twoBranches&&e>1.0) {
			double e2=e*e;
			double d2=d+d; double ar=(1.E+16)/e2;
			if ((e2-1.0)/d2>1.E-16) {
				ar=e2*d2/(e2-1.0);
			}
			F.x=F.x-ar*Math.cos(t);
			F.y=F.y+ar*Math.sin(t);
			Fx=F.ix(); Fy=F.iy();
			doDrawConic(g,d,e,t+Math.PI);
		}
	}

	private void Plot(Graphics[] g,int x, int y) {
		for (int i=0;i<g.length;i++) {
			Line(g[i],width,x,y,x,y);
		}
	}

	private void Pon(Graphics[] g) {
		switch (caso) {
		case 0 : Plot(g,Fx+x,Fy+y); break;
		case 1 : Plot(g,Fx+y,Fy-x); break;
		case 2 : Plot(g,Fx-x,Fy-y); break;
		case 3 : Plot(g,Fx-y,Fy+x); break;
		}
	}

	private void Dx() {
		x+=dx; z+=zx; zx+=zxx; zy+=zxy;
	}

	private void Dy() {
		y+=dy; z+=zy; zy+=zyy; zx+=zxy;
	}

	private void loop(Graphics[] g)	{
		if (Math.abs(z+zy)<Math.abs(z+zx)) {
			Dy();
			if (Math.abs(z)>=Math.abs(z+zx)) {
				Dx();
			}
		} else 	{
			Dx();
			if (Math.abs(z)>=Math.abs(z+zy)) {
				Dy();
			}
		}
		Pon(g);
	}

	private void doDrawConic(Graphics[] g,double d, double e, double t0)	{
		boolean elip=(e<1); boolean hip=(e>1);
		double t=t0;
		while (t<0.0)    {
			t=t+dosPi;
		}
		while (t>=dosPi) {
			t=t-dosPi;
		}
		caso=0;
		while (t>=Pim) {
			t=t-Pim; caso=caso+1;
		}
		if ( t>Pim-epsilon) {
			t=0;
			caso=(caso+1)%4;
		}
		if ( t<epsilon ) {
			t=0;
		}
		int minx=0,miny=0,maxx=w,maxy=h;
		switch (caso) {
		case 0: minx=-Fx;  miny=-Fy;  maxx=w-Fx; maxy=h-Fy; break;
		case 1: minx=Fy-h; miny=-Fx;  maxx=Fy;   maxy=w-Fx; break;
		case 2: minx=Fx-w; miny=Fy-h; maxx=Fx;   maxy=Fy;   break;
		case 3: minx=-Fy;  miny=Fx-w; maxx=h-Fy; maxy=Fx;   break;
		}
		double cost= Math.cos(t),sent=-Math.sin(t);
		double p=d*e/(1.0+e), e2mint=e*e*MAX_INT;
		x=-(int)Math.round(p*cost); y=-(int)Math.round(p*sent);
		int dxx=(int)Math.round(MAX_INT-e2mint*cost*cost);
		int dyy=(int)Math.round(MAX_INT-e2mint*sent*sent);
		e2mint*=2;
		int dxy=-(int)Math.round(e2mint*cost*sent);
		e2mint*=d;
		int zxo=dxx*(x+x+1)+dxy*y-(int)Math.round(e2mint*cost);
		int zyo=dyy*(y+y+1)+dxy*x-(int)Math.round(e2mint*sent);
		zxx=2*dxx; zyy=2*dyy;
		int xo=x; int yo=y;
		Pon(g);
		z=0;
		dx=1;zx=zxo; dy=1;zy=zyo;zxy=dxy;
		do {
			loop(g);
		} while (zx<=0&&x<=maxx&&(!hip||y<=maxy));
		if (zx>0) {
			dy=-1; zy=zyy-zy; zxy=-dxy;
			do {
				loop(g);
			} while (x<=maxx&&(elip||y>=miny)&&(!elip||zy<=0));
		}
		x=xo; y=yo;
		dx=-1;zx=zxx-zxo; dy=-1;zy=zyy-zyo; zxy=dxy;
		z=0;
		do {
			loop(g);
		} while (zy<=0&&y>=miny&&(!hip||x>=minx));
		if (zy>0) {
			dx=1; zx=zxx-zx; zxy=-dxy;
			do {
				loop(g);
			} while (x<=maxx&&(elip||y>=miny)&&(!elip||zx<=0));
		}
		if (elip && x<maxx) {
			dx=1; dy=1;zy=zyy-zy; zxy=dxy;
			do {
				loop(g);
			} while (zy<=0&&x<=maxx&&y<=maxy);
		}
	}


	/* -------------------------- y=f(x) --------------------------- */

	static R2 extrapolate(Node cond,Node X,Node Y,Node F,double v,double dx) {
		double saveX=X.getDouble();
		double dxx=dx/2,Dx=0;
		double vv=v;
		while (Math.abs(dxx)>1E-15) {
			double xa=X.getDouble();
			double x=X.getDouble()+dxx;
			X.setDouble(x);
			boolean ok=true;
			try {
				double vva=vv;
				vv=F.Evaluate();
				Y.setDouble(vv);
				if (cond.Evaluate(1)>0) {
					R2 minmax=new R2(Math.min(vva,vv),Math.max(vva,vv));
					int sing=0;
					if (dx>0) {
						sing=Singularity(Math.abs(dxx),X,F,xa,vva,x,vv,minmax);
					} else {
						sing=Singularity(Math.abs(dxx),X,F,x,vv,xa,vva,minmax);
					}
					if (sing>0) {
						ok=false;
					}
				} else {
					ok=false;
				}
			} catch (Exception e) {
				ok=false;
			}
			if (ok) {
				Dx+=dxx;
			} else {
				X.setDouble(xa);
			}
			dxx/=2;
		}
		X.setDouble(saveX);
		return new R2(Dx/Math.abs(dx),vv);
	}

	static R2 extrapolateOnSingularity(Node cond,Node X,Node Y,Node F,double v,double dx) {
		double saveX=X.getDouble();
		double dxx=dx/2,Dx=0;
		double vv=v;
		while (Math.abs(dxx)>1E-15) {
			X.setDouble(X.getDouble()+dxx);
			boolean ok=true;
			if (cond.Evaluate(1)>0){
				try {
					double vva=vv;
					vv=F.Evaluate();
					Y.setDouble(vv);
					if (cond.Evaluate(1)<=0) {
						ok=false;
					}
				} catch (Exception e) {
					ok=false;
				}
			} else {
				ok=false;
			}
			if (ok) {
				Dx+=dxx;
			} else {
				X.setDouble(X.getDouble()-dxx);
			}
			dxx/=2;
		}
		
		if (Dx==0.0) {
//System.out.println("CORRECTING "+dx+" "+v);
			dxx=dx/2;
			Dx=dx;
			vv=v;
			while (Math.abs(dxx)>1E-15) {
				X.setDouble(X.getDouble()-dxx);
				boolean ok=true;
				if (cond.Evaluate(1)>0){
					try {
						vv=F.Evaluate();
					} catch (Exception e) {
						ok=false;
					}
				} else {
					ok=false;
				}
				if (ok) {
					Dx+=-dxx;
				} else {
					X.setDouble(X.getDouble()+dxx);
				}
				dxx/=2;
			}
		}
		
		X.setDouble(saveX);
		return new R2(Dx/Math.abs(dx),vv);
	}



	static int Singularity(double e,Node X,Node F,double a,double va,double b,double vb,R2 minmax) {
		if (Double.isNaN(vb)||Double.isNaN(va)||Double.isNaN(minmax.y)||Double.isNaN(minmax.x)) {
			return 2;
		}
		if (a>=b) {
			return 2;
		}
		double saveX=X.getDouble();
		int disc=0;
		try {
			if ( Math.abs(b-a)<1E-15 || (Math.abs(b-a)<1E-12&&Math.abs(vb-va)>Math.abs(e)) ) {
				X.setDouble(saveX);
				return 1;
			}
			double ab2=(a+b)/2;
			X.setDouble(ab2);
			double auxv=Double.NaN;
			try {
				auxv=F.Evaluate();
			} catch (Exception ex2) {
				return 2;
			}
			if (Double.isNaN(auxv)) {
				return 2;
			}
			if (Math.abs(vb-va)>e) {	// detectar saltos
				double epsilon=1E-12;
				X.setDouble(a-epsilon);
				double _v=F.Evaluate();
				double _D=(va-_v)/epsilon;
				X.setDouble(b+epsilon);
				double v_=F.Evaluate();
				double D_=(v_-vb)/epsilon;
				double Dj=(vb-va)/(b-a);
				if (Math.abs(D_)<10 || Math.abs(_D)<10) {	// agregado el 090615 para evitar tratar como saltos las singularidades del tipo 1/(x-a)
					if ((D_>=0 && _D>=0) || (D_<=0 && _D<=0) ) {
						if (4*Math.abs(D_)<Math.abs(Dj)) {
							X.setDouble(saveX);
							return 2;
						}
					}
				}
			}
			if (Double.isNaN(minmax.x)||Double.isNaN(minmax.y)||Double.isNaN(auxv)) {
				return 2;
			} else if (!(minmax.x<=auxv && auxv<=minmax.y)) {
				X.setDouble(ab2);
				minmax.x=Math.min(va,auxv);
				minmax.y=Math.max(va,auxv);
				int s1=Singularity(e/2,X,F,a,va,ab2,auxv,minmax);
				X.setDouble(b);
				minmax.x=Math.min(vb,auxv);
				minmax.y=Math.max(vb,auxv);
				int s2=Singularity(e/2,X,F,ab2,auxv,b,vb,minmax);
				disc=Math.max(s1,s2);
			}
		} catch (Exception exc) {
			disc=1;
		}
		X.setDouble(saveX);
		return disc;
	}

	private void drawFunction(Graphics[] g,mjaColor[] mjac,boolean of_y) {
		Node X=D.p.Var("x");
		Node Y=D.p.Var("y");
		if (of_y) {
			Y=X;
			X=D.p.Var("y");
		}
		synchronized (X) {
		synchronized (Y) {
			double savex=X.getDouble();
			double savey=Y.getDouble();
			if (F.isSequence()) {
				int Xr=0;
				int Xf=cs.getSize().width;
				if (of_y) {
					Xf=cs.getSize().height;
				}
				if (gc.absCoor) {
					while(Xr<Xf) {
						X.setDouble(Xr);
						try {
							double v=F.Evaluate();
							if (cond.Evaluate(1)>0) {
// 2013-Oct-14
// Esto estuvo mal por aos, quizs aparezcan casos en donde se "cuchare" una aplicacin y ahora no funcione.
//								int x=cs.getSize().height-(int)Math.round(Xr);
								int x=(int)Math.round(Xr);
								int y=(int)Math.round(v);
								for (int i=0;i<g.length;i++) {
									Line(g[i],width,x,y,x,y,of_y);
								}
							}
						} catch (Exception e) {
						}
						Xr++;
					}
				} else {
					if (of_y) {
						Xr=(int)Math.round(-1-(cs.getSize().height-cs.Oy)/cs.Nesc.getDouble());
						Xf=(int)Math.round(1+cs.Oy/cs.Nesc.getDouble());
					} else {
						Xr=(int)Math.round(-1-cs.Ox/cs.Nesc.getDouble());
						Xf=(int)Math.round(1+(cs.getSize().width-cs.Ox)/cs.Nesc.getDouble());
					}
					while(Xr<Xf) {
						X.setDouble(Xr);
						try {
							double v=F.Evaluate();
							Y.setDouble(v);
							if (cond.Evaluate(1)>0) {
								int x=(of_y)?cs.getSize().height-cs.YY(width,Xr,gc.absCoor):cs.XX(width,Xr,gc.absCoor);
								int y=(of_y)?cs.XX(width,v,gc.absCoor):cs.YY(width,v,gc.absCoor);
								for (int i=0;i<g.length;i++) {
									Line(g[i],width,x,y,x,y,of_y);
								}
							}
						} catch (Exception e) {
						}
						Xr++;
					}
				}
			} else {
				boolean defa=false;
				int singa=0;
				R2 Or=new R2(cs.Ox,cs.Oy);
				int y0=(of_y)?Or.ix():Or.iy();
				int y=0,ya=0,x=0,xa=0;
				double dx=1/cs.Nesc.getDouble();
				double Xr=dx*((of_y)?-cs.getSize().height+cs.Oy:-cs.Ox);
				double va=0;
				if (gc.absCoor) {
// 2013-Oct-14
// Esto estuvo mal por aos, quizs aparezcan casos en donde se "cuchare" una aplicacin y ahora no funcione.
//					Xr=cs.getSize().height;
//					dx=-1;
					Xr=0;
					dx=1;
				}
				while(x<((of_y)?cs.getSize().height+2:cs.getSize().width+2)) {
					boolean def=true;
					int sing=0;
					X.setDouble(Xr);
					try {
						double v=F.Evaluate();
						Y.setDouble(v);
						if (cond.Evaluate(1)>0) {
							if (defa) {
								double min=Math.min(va,v);
								double max=Math.max(va,v);
								R2 minmax=new R2(min,max);
								sing=Singularity(dx,X,F,Xr-dx,va,Xr,v,minmax);
								if (sing==0) {
									if (va<=v) {
										va=minmax.x; v=minmax.y;
									} else {
										v=minmax.x; va=minmax.y;
									}
									int nya=(of_y)?cs.XX(width,va,gc.absCoor):cs.YY(width,va,gc.absCoor);
									if (gc.absCoor) {
										y=(int)Math.round(v);
									} else {
										y=(of_y)?cs.XX(width,v,gc.absCoor):cs.YY(width,v,gc.absCoor);
									}
									for (int i=0;i<g.length;i++) {
										if (gc.hasFillminus&&y>y0) {
											g[i].setColor(gc.fillminusColor.getAdaptedColor());
											Line(g[i],width,x,y0+1,x,y,of_y);
										}
										if (gc.hasFillplus&&y<y0) {
											g[i].setColor(gc.fillplusColor.getAdaptedColor());
											Line(g[i],width,x,y0-1,x,y,of_y);
										}
										g[i].setColor(mjac[i].getAdaptedColor());
										if (ya!=nya) {
											Line(g[i],width,xa,ya,xa,nya,of_y);
										}
										Line(g[i],width,xa,nya,x,y,of_y);
									}
								} else if (sing==1) {
									X.setDouble(Xr-dx);
									R2 pn=extrapolate(cond,X,Y,F,va,dx);
									y=(of_y)?cs.XX(width,pn.y,gc.absCoor):cs.YY(width,pn.y,gc.absCoor);
									for (int i=0;i<g.length;i++) {
										g[i].setColor(mjac[i].getAdaptedColor());
										Line(g[i],width,xa,ya,xa+(int)Math.round(pn.x),y,of_y);
									}
									X.setDouble(Xr);
									R2 pa=extrapolate(cond,X,Y,F,v,-dx);
									ya=(of_y)?cs.XX(width,pa.y,gc.absCoor):cs.YY(width,pa.y,gc.absCoor);
									y=(of_y)?cs.XX(width,v,gc.absCoor):cs.YY(width,v,gc.absCoor);
									for (int i=0;i<g.length;i++) {
										g[i].setColor(mjac[i].getAdaptedColor());
										Line(g[i],width,x+(int)Math.round(pa.x),ya,x,y,of_y);
									}
								} else if (sing==2) {
									y=(of_y)?cs.XX(width,v,gc.absCoor):cs.YY(width,v,gc.absCoor);
									for (int i=0;i<g.length;i++) {
										g[i].setColor(mjac[i].getAdaptedColor());
										Line(g[i],width,x,y,x,y,of_y);
									}
								}
							} else {	// defa==false;  extrapolar hacia adelante
								R2 pa=extrapolateOnSingularity(cond,X,Y,F,v,-dx);
								ya=(of_y)?cs.XX(width,pa.y,gc.absCoor):cs.YY(width,pa.y,gc.absCoor);
								y=(of_y)?cs.XX(width,v,gc.absCoor):cs.YY(width,v,gc.absCoor);
								for (int i=0;i<g.length;i++) {
									g[i].setColor(mjac[i].getAdaptedColor());
									Line(g[i],width,x+(int)Math.round(pa.x),ya,x,y,of_y);
								}
							}
							va=v;
						} else {
							def=false;
						}
					} catch (Exception e) {
						def=false;
					}
					if (defa&&!def) { // extrapolar desde atrs
						X.setDouble(Xr-dx);
						Y.setDouble(va);
						R2 pn=extrapolate(cond,X,Y,F,va,dx);
						y=(of_y)?cs.XX(width,pn.y,gc.absCoor):cs.YY(width,pn.y,gc.absCoor);
						for (int i=0;i<g.length;i++) {
							g[i].setColor(mjac[i].getAdaptedColor());
							Line(g[i],width,xa,ya,xa+(int)Math.round(pn.x),y,of_y);
						}
						X.setDouble(Xr);
					}
					defa=def;
					singa=sing;
					Xr+=dx;
					ya=y; xa=x++;
				}
			}
			X.setDouble(savex);
			Y.setDouble(savey);
		}
		}
	}

static double vez=0,c1,c2,c3,c4;

	private void drawEquation(Graphics[] g,mjaColor[] mjac) {
		vez++;
		c1=0;
		c2=0;
		c3=0;
		c4=0;
		String equation=gc.formula;
		if (D.p.isVar(equation)&&D.p.Var(equation).getStr()!=null) {
			equation=D.p.Var(equation).getStr();
		}
		if (BasicStr.hasContent(equation)) {
			Node X=D.p.Var("x");
			Node Y=D.p.Var("y");
			synchronized(X) {
				synchronized(Y) {
				double savex=X.getDouble();
				double savey=Y.getDouble();
				try {
					R2Newton newt=new R2Newton(D.p,equation);
					int w=cs.getSize().width;
					int h=cs.getSize().height;
					int dx=w/9; if (dx<3) { dx=3; }
					int dy=h/7; if (dy<3) { dy=3; }
					boolean[][] b=new boolean[w+24][h+24];
					R2 q0=new R2(), qb=new R2(), t=new R2();
					int np=8;
					double dist=0.25;
					double ds=np;
					if (!gc.absCoor) {
						double scale=cs.Nesc.getDouble();
						dist=dist/scale;
						ds=ds/scale;
					}			
					for (int j=dy/2; j<h; j+=dy) {
						for (int i=dx/2; i<w; i+=dx) {
							R2 q;
							try {
								q=newt.findZero(cs.injection(i,j,gc.absCoor),dist);
							} catch (Exception exc) {
								continue;
							} 
							X.setDouble(q.x);
							Y.setDouble(q.y);
							R2 Q=cs.projection(q,gc.absCoor);
							int Qx=Q.ix(), Qy=Q.iy();
							boolean inSpace=(Qx>=-12)&&(Qx<w+12)&&(Qy>=-12)&&(Qy+12<h);
							if (inSpace) {
								if (b[Qx+12][Qy+12]) {
c1++;
									continue; /* Zero already detected */
								}
								b[Qx+12][Qy+12]=true;
							}
							if (newt.rangeOK()) {
								for (int ix=0;ix<g.length;ix++) {
									g[ix].setColor(mjac[ix].getAdaptedColor());
									Line(g[ix],width,Qx,Qy,Qx,Qy);
								}
							}
							q0.x=q.x; q0.y=q.y;
							qb.x=q.x; qb.y=q.y;
							// t=t0= Unit Tangent Vector
							R2 t0=newt.getUnitNormal();
							if (t0.x==0&&t0.y==0) {
								continue; /* Zero normal vector */
							}
							t0.rotL90();
							t.x=t0.x; t.y=t0.y;
							int zeroVisited=0,side=0;
							boolean changeSide=false;
							while (side<2)	{
								if (changeSide)	{
									t.x=-t0.x; t.y=-t0.y; // Invert Unit Tangent Vector
									q.x=q0.x; q.y=q0.y;
									qb.x=q.x; qb.y=q.y;
									Q=cs.projection(q,gc.absCoor);
									Qx=Q.ix(); Qy=Q.iy();
									changeSide=false;
									zeroVisited=0;
								}
								q.x+=ds*t.x; 
								q.y+=ds*t.y; // advance along t np pixels
								try {
									q=newt.findZero(q,dist);
								} catch (Exception exc2) {
									continue;
								} 
								X.setDouble(q.x);
								Y.setDouble(q.y);
								t.x=q.x-qb.x; t.y=q.y-qb.y; t.normalize(); // update Unit Tangent Vector
								if ((t.x==0)&&(t.y==0)) {
									break; /* Zero tangent vector */
								}
								qb.x=q.x; qb.y=q.y;
								Q=cs.projection(q,gc.absCoor);
								int Px=Q.ix(),Py=Q.iy();
								if (Px!=Qx||Py!=Qy) {
									int Qxa=Qx,Qya=Qy;
									Qx=Px; Qy=Py;
									inSpace=(Qx>=-12)&&(Qx<w+12)&&(Qy>=-12)&&(Qy<h+12);
									if (inSpace)	{
										zeroVisited=0;
										boolean secondVisit=b[Qx+12][Qy+12];
										b[Qx+12][Qy+12]=true;
										for (int s=1;s<np;s++) {
											int Qsx=Qxa+(int) Math.round((Qx-Qxa)*s/np);
											int Qsy=Qya+(int) Math.round((Qy-Qya)*s/np);
											if ((0<=Qsx)&&(Qsx<w)&&(0<=Qsy)&&(Qsy<h)) {
												b[Qsx+12][Qsy+12]=true;
											}
										}
										for (int k=0;k<g.length;k++) {
											g[k].setColor(mjac[k].getAdaptedColor());
											if (newt.rangeOK()) {
												Line(g[k],width,Qxa,Qya,Qx,Qy);
											}
										}
										if (secondVisit) {
c2++;
											break;
										}
									} else {
c3++;
										changeSide=true; side++; /* Zero out of bounds */
									}
								} else if ( ++zeroVisited>4 ) {
c4++;
									changeSide=true; side++; /* Stationary Zero */
								}
		
							}
						}
					}
				} catch (Exception e) {
					e.printStackTrace();
				}
				X.setDouble(savex);
				Y.setDouble(savey);
				}
			}
		}
//System.out.println("vez = "+vez);
//System.out.println("c1 = "+c1+"    c2 = "+c2+"    c3 = "+c3+"    c4 = "+c4);
//System.out.println("Suma = "+(c1+c2+c3+c4));
//new Exception().printStackTrace();
	}
	
	public void flush() {
		image.flush();
		if (ith!=null) {
			ith.pleaseStop();
			ith=null;
		}
		image=null;
	}

}


class imageThread extends Canvas implements Runnable {

	Image image,back;
	int x,y;
	Space S;
	Thread thr;
	boolean pleaseStop;
	long freq=60;

	imageThread(Image image,Space S,long freq) {
		this.image=image;
		this.S=S;
		this.freq=freq;
	}

	void pleaseStop() {
		pleaseStop=true;
		S.remove(this);
	}
	
	boolean stop() {
		return pleaseStop;
	}

	void setPos(int x,int y) {
		this.x=x;
		this.y=y;
		setBounds(x,y,image.getWidth(S),image.getHeight(S));
		S.add(this);
		paint(getGraphics());
		thr=new Thread(this);
		thr.start();
	}
	
	public void run() {
		try {
			while (!stop()) {
				paint(getGraphics());
				Thread.sleep(freq);
			}
		} catch (InterruptedException e) {
		}
	}
	
	public void paint(Graphics g) {
		int dx=image.getWidth(this);
		int dy=image.getHeight(this);
		if (dx>0 && dy>0) {
			if (back==null) {
				back=createImage(dx,dy);
				setBounds(x,y,dx,dy);
			}
			if (back!=null) {
				Graphics G=back.getGraphics();
				G.drawImage(S.main,-x,-y,null);
				G.drawImage(image,0,0,null);
				g.drawImage(back,0,0,this);
			}
		}
	}

}