package com.mja.descedit.descartesJS;

import java.awt.Component;
import java.util.BitSet;

import com.mja.descartes.Descartes;
import com.mja.descartes.controlConfig;
import com.mja.descedit.configEdit;
import com.mja.descedit.controlEP;
import com.mja.descgui.edit.editObject;
import com.mja.descgui.edit.editObjectType;
import com.mja.lang.data;
import com.mja.lang.translator;
import com.mja.util.BasicStr;

public class ControlsEditorPane extends controlEP {
	private static final long serialVersionUID = -3546562749599195186L;

	public ControlsEditorPane(Descartes D, configEdit parent, Component C) {
		super(D, parent, C);
	}

	
	public void setInfo(translator Tr, editObject neO) {
		if(neO != null && !(neO instanceof ControlEditObject))
			neO = newObject(Tr,neO.toString(" ", Tr)); 
		super.setInfo(Tr, neO);
	}


	public editObject newObject(String stype, String svalue) {
		return new ControlEditObject(this.D.Tr, stype, svalue);
	}

	
	public editObject newObject(translator Tr, String svalue) {
		return new ControlEditObject(Tr,svalue);
	}

	class ControlEditObject extends controlConfig {
		private final int[] auxix = {data.c_numeric,data.c_graphic,data.c_string,data.c_audio,data.c_video};
		private String[] defaultExpresion = {
			"n?","g?","t?","a?","v?"
		};
		public ControlEditObject(translator Tr,String stype,String svalue) {
			super(Tr,stype,svalue);
			overwriteCfg();
		}
		
		public ControlEditObject(translator Tr, String svalue) {
			super(Tr, svalue);
			overwriteCfg();
		}

		private void overwriteCfg(){
			this.field[controlConfig.ixgui].chvalues	= new int[]{data.spinner,data.textfield,data.choice,data.scrollbar,data.button};
//			this.field[controlConfig.ixregion].chvalues = new int[]{data.south, data.north, data.interior};
			this.field[controlConfig.ixregion].chvalues = regions;
			this.field[controlConfig.ixaction].chvalues = new int[]{data.empty, data.calculate, data.ini, data.clear, data.anim, data.openURL, data.openScene, data.play };
			
			this.eot = new editObjectType[]{
					new editObjectType(this.eot[0].defaultExpresion,(BitSet) this.eot[0].attributes.clone()),
					new editObjectType(this.eot[1].defaultExpresion,(BitSet) this.eot[1].attributes.clone()),
					new editObjectType(this.eot[2].defaultExpresion,(BitSet) this.eot[2].attributes.clone()),
					new editObjectType(this.eot[3].defaultExpresion,(BitSet) this.eot[3].attributes.clone()),
					new editObjectType(this.eot[4].defaultExpresion,(BitSet) this.eot[4].attributes.clone())
			};
			
			int iEOT = 0; //control numerico
			this.eot[iEOT].attributes.clear(controlConfig.ixtooltip);
			this.eot[iEOT].attributes.clear(controlConfig.ixexpl);
			this.eot[iEOT].attributes.clear(controlConfig.ixmsgloc);
//			this.eot[iEOT].attributes.clear(controlConfig.ixcontrolID);
			
			/*
				this.eot[iEOT].attributes.clear(controlConfig.ixeval);
				1this.eot[iEOT].attributes.clear(controlConfig.ixanswer);
				this.eot[iEOT].attributes.clear(controlConfig.ixweight);
			*/
			//Quitamos los parmetros de :
			//texto, decimales, fijo, rastro, tooltip y explicacin.
			iEOT=1; //Control grafico
			this.eot[iEOT].attributes.clear(controlConfig.ixtext);
			this.eot[iEOT].attributes.clear(controlConfig.ixdecimals);
			this.eot[iEOT].attributes.clear(controlConfig.ixfixed);
			this.eot[iEOT].attributes.clear(controlConfig.ixtrace);
			this.eot[iEOT].attributes.clear(controlConfig.ixtooltip);
			this.eot[iEOT].attributes.clear(controlConfig.ixexpl);

		}
		
		public int getNumTypes() {
			return defaultExpresion.length;
		}

		
		public String getType(translator Tr, int i) {
			return Tr.getTr(auxix[i]);
		}

		
		public String getDefaultExpresion(translator Tr, int i) {
			return defaultExpresion[i];
		}

		
		public String getListTitle(translator Tr) {
			return "Controles";
		}

		
		public String getTypesInfo(translator Tr) {
			return Tr.getTr(data.control);
		}

		
		public int getTypeIndex(translator Tr) {
			for (int i=0;i<auxix.length;i++) {
				if (type==auxix[i]) {
					return i;
				}
			}
			return 0;
		}

	}
	
	protected void resetEnabling() {
		super.resetEnabling();
		if (eO instanceof controlConfig) {
			controlConfig cc = (controlConfig) eO;
			String s_type = BasicStr
					.trim(cc.s_value[controlConfig.ixtype], ' ');
			if (Tr.equals(s_type, data.c_numeric)) {
				mp[controlConfig.ixspace].setEnabled(true);
				mp[controlConfig.ixexpr].setEnabled(true);
			}
		}
	}
}
