package com.mja.descedit.descartesJS;

import java.awt.Component;
import java.util.BitSet;

import org.unam.matem.Attribute;

import com.mja.descartes.Descartes;
import com.mja.descartes.graphR2Config;
import com.mja.descedit.configEdit;
import com.mja.descedit.graphEP;
import com.mja.descgui.edit.editObject;
import com.mja.descgui.edit.editObjectType;
import com.mja.lang.data;
import com.mja.lang.translator;

public class Graph2DEditorPane extends graphEP {
	private static final long serialVersionUID = -3546562749599195186L;

	public Graph2DEditorPane(Descartes D, configEdit parent, Component C) {
		super(D, parent, C);
	}

	
	public void setInfo(translator Tr, editObject neO) {
		if(!(neO instanceof Graph2DEditObject) && neO != null){
			newObject(Tr,""); // hacemos esto para que los cambios que se hace 
			                  // Graph2DEditObject configuracin, se reflejen en el toString
			String svalue = neO.toString(" ", Tr);
			neO = newObject(Tr,svalue);
		}
		super.setInfo(Tr, neO);
	}


	public editObject Graph2DEditObject(String stype,String svalue) {
		return new Graph2DEditObject(this.D.Tr,stype,svalue,"");
	}
	public editObject newObject(translator Tr,String svalue) {
		return new Graph2DEditObject(Tr,svalue,"");
	}
	
	public class Graph2DEditObject extends graphR2Config {
		private final int[] auxix = {
				data.t_equation,
				data.t_curve,
				data.t_point,
				data.t_segment,
				data.arrow,
				data.t_polygon,
				data.t_arc,
				data.fill,
				data.t_text,
				data.t_image,
				data.t_macro
				};
		private String[] defaultExpresion = {
				"y=x",				//9 t_ecuation
				"(t,t)",			//0 t_curve
				"(0,0)",			//1 t_point
				"(0,0)(1,1)",		//2 t_segment
				"(0,0)(1,1)",		//3 arrow
				"(0,0)(1,1)(2,-1)",	//4 t_polygon
				"(0,0)1(0,90)",		//5 t_arc
				"(0,0)",			//6 fill
				"[20,20]",			//7 t_text
				"(0,0)",			//8 t_image
				""				//? macro
				};
		
		public Graph2DEditObject(translator Tr, String s, String version0) {
			super(Tr, s, version0);
			overwriteCfg();
		}

		public Graph2DEditObject(translator Tr,String stype,String svalue,String version0) {
			this(Tr,
				Tr.getTr(data.type)+"="+stype+" "+Tr.getTr(data.expr)+"='"+svalue+"'",
				version0);
		}
		public Graph2DEditObject(translator Tr,Attribute[] aa,String version0) {
			super(Tr,aa,version0);
			overwriteCfg();
		}
		
		private void overwriteCfg(){
			this.field[graphR2Config.ixeditable].def_val = "no";
			this.field[graphR2Config.ixeditable].null_val = "no";
			
			this.field[graphR2Config.ixvisible].def_val = "no";
			this.field[graphR2Config.ixvisible].null_val = "no";
			
			this.field[graphR2Config.ixcolor].def_val = "";
			this.field[graphR2Config.ixcolor].null_val = "";
			
			
			nullv[graphR2Config.ixcolor]="";
			nullv[graphR2Config.ixvisible]="no";			
				
			editObjectType[] tmpEOT = this.eot;
			this.eot = new editObjectType[auxix.length];
			//{ t_equation, t_curve, sequence, t_point, t_segment, arrow, t_polygon, t_arc, fill, t_text, t_image, t_macro };
			int idx = 0;
			int idxNew = 0;
			BitSet tmpBitSet;
			
			
			idx = 0; //ecuacion
			idxNew = 0 ;
			tmpBitSet = new BitSet(numFields);
			tmpBitSet.or(tmpEOT[idx].attributes);
			this.eot[idxNew] = new editObjectType(tmpEOT[idx].defaultExpresion,tmpBitSet);
			this.eot[idxNew].attributes.clear(this.ixvisible);
			this.eot[idxNew].attributes.clear(this.ixeditable);
			
			idx = 1; //curva
			idxNew = 1; 
			tmpBitSet = new BitSet(numFields);
			tmpBitSet.or(tmpEOT[idx].attributes);
			this.eot[idxNew] = new editObjectType(tmpEOT[idx].defaultExpresion,tmpBitSet);
			this.eot[idxNew].attributes.clear(this.ixvisible);
			this.eot[idxNew].attributes.clear(this.ixeditable);
			
			idx = 3; //punto
			idxNew = 2; 
			tmpBitSet = new BitSet(numFields);
			tmpBitSet.or(tmpEOT[idx].attributes);
			this.eot[idxNew] = new editObjectType(tmpEOT[idx].defaultExpresion,tmpBitSet);

			idx = 4; //segmento
			idxNew = 3; 
			tmpBitSet = new BitSet(numFields);
			tmpBitSet.or(tmpEOT[idx].attributes);
			this.eot[idxNew] = new editObjectType(tmpEOT[idx].defaultExpresion,tmpBitSet);
			
			idx = 5; //flecha
			idxNew = 4; 
			tmpBitSet = new BitSet(numFields);
			tmpBitSet.or(tmpEOT[idx].attributes);
			this.eot[idxNew] = new editObjectType(tmpEOT[idx].defaultExpresion,tmpBitSet);
			
			idx = 6; //poligono
			idxNew = 5; 
			tmpBitSet = new BitSet(numFields);
			tmpBitSet.or(tmpEOT[idx].attributes);
			this.eot[idxNew] = new editObjectType(tmpEOT[idx].defaultExpresion,tmpBitSet);
			
			idx = 7; //arco
			idxNew = 6; 
			tmpBitSet = new BitSet(numFields);
			tmpBitSet.or(tmpEOT[idx].attributes);
			this.eot[idxNew] = new editObjectType(tmpEOT[idx].defaultExpresion,tmpBitSet);
			
			idx = 8; //relleno
			idxNew = 7; 
			tmpBitSet = new BitSet(numFields);
			tmpBitSet.or(tmpEOT[idx].attributes);
			this.eot[idxNew] = new editObjectType(tmpEOT[idx].defaultExpresion,tmpBitSet);
			
			idx = 9; //texto
			idxNew = 8; 
			tmpBitSet = new BitSet(numFields);
			tmpBitSet.or(tmpEOT[idx].attributes);
			tmpBitSet.set(ixtextborder);
			this.eot[idxNew] = new editObjectType(tmpEOT[idx].defaultExpresion,tmpBitSet);
			
			
			idx = 10; //imagen
			idxNew = 9; 
			tmpBitSet = new BitSet(numFields);
			tmpBitSet.or(tmpEOT[idx].attributes);
			this.eot[idxNew] = new editObjectType(tmpEOT[idx].defaultExpresion,tmpBitSet);
			this.eot[idxNew].attributes.clear(this.ixanim);
			this.eot[idxNew].attributes.clear(this.ixanimfreq);
			
			
			idx = 11; //imagen
			idxNew = 10; 
			tmpBitSet = new BitSet(numFields);
			tmpBitSet.or(tmpEOT[idx].attributes);
			this.eot[idxNew] = new editObjectType(tmpEOT[idx].defaultExpresion,tmpBitSet);
		}
		
		public int getNumTypes() {
			return auxix.length;
		}

		
		public String getType(translator Tr, int i) {
			return Tr.getTr(auxix[i]);
		}

		public String getDefaultExpresion(translator Tr, int i) {
			return defaultExpresion[i];
		}

	
		public int getTypeIndex(translator Tr) {
			for (int i=0;i<auxix.length;i++) {
				if (type == auxix[i]) {
					return i;
				}
			}
			return 0;
		}

	}
}
