/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descedit;

import java.awt.*;
import java.awt.event.*;
import com.mja.descartes.*;
import com.mja.gui.*;
import com.mja.descgui.*;
import com.mja.text.*;
import com.mja.lang.*;

import com.mja.util.TFont;
import com.mja.file.mjaFont;
import com.mja.textedit.EditorQPanel;
import com.mja.textedit.EditorButtons;

public class editRTFDialog extends editDialog {

	private mjaFont font;
	private String rtf_str="";
	private boolean firstTime=true;
	private EditorQPanel EA;
	private Descartes D;

	public editRTFDialog(Frame parent,Descartes D,boolean modal,String okLabel,String cancelLabel) {
		super(parent,D.Tr.getTr(data.TextEd),modal,okLabel,cancelLabel);
		this.D=D;
		EA=new EditorQPanel(D,parent,D.Tr,D.p,true,false,false,true);
		EA.init();
		EA.getEB().setAttributes(EditorButtons.DescartesAttributes);
		EA.setCanvasSize(600,400);
		add("Center",EA);
	}

	public void display(boolean center) {
//		EA.updateTranslation();
		super.display(center);
	}

	public mjaFont getSelectedMjaFont() {
		font=EA.getFirstFont().getMjaFont();
		return font;
	}

	public void setSelectedFont(Font font) {
		this.font=new mjaFont(font);
		EA.setDefaultFont(new TFont(this.font));
	}

	public void setSelectedColor(mjaColor mjac) {
		EA.setFGColor(mjac.getAdaptedColor());
	}

	public void setText(String s) {
		rtf_str=MathText.DescartesToRTF(font.getAwtFont(),s);
		firstTime=true;
	}

	public void setBGColor(Color c) {
		EA.setBGColor(c);
	}

	public String getText() {
		return EA.getText(true);
	}

	public void setExprDefaults(int dec,boolean fixed,int aL) {
		EA.setExprDefaults(dec,fixed,aL);
	}

//    public void windowActivated(WindowEvent e){
//		if (firstTime) {
//			EA.start();
//			EA.setText(rtf_str);
//			EA.getEC().setEnabled(true);
//			EA.getEC().setEditing(true);
//			EA.getEC().requestFocus();
//			EA.getEC().updateScreen();
//			firstTime=false;
//		}
//	}

    public void windowOpened(WindowEvent e){
		if (firstTime) {
//System.out.println("editRTFDialog.windowOpened firsttime");
			EA.start();
			EA.setText(rtf_str);
			EA.getEC().setEnabled(true);
			EA.getEC().setEditing(true);
			EA.getEC().requestFocus();
			EA.getEC().updateScreen();
			firstTime=false;
		} else {
//System.out.println("editRTFDialog.windowOpened NOT firsttime");
		}
    	super.windowOpened(e);
	}
    public void windowClosed(WindowEvent e){
    	EA.stop();
		super.windowClosed(e);
	}

}