/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descgui;
/*------------------------------------------------------------*/
/*                       ButtonControl                        */
/*                         (c)  MJA                           */
/*                     Septiembre de 2002                     */
/*------------------------------------------------------------*/
import java.awt.*;
import java.awt.event.*;
import java.text.NumberFormat;
import java.util.*;
import com.mja.cmp.*;
import com.mja.gui.*;
import com.mja.util.*;
import com.mja.file.*;
import com.mja.lang.*;
import com.mja.parser.*;
import com.mja.descartes.*;

public class ButtonControl extends NumericControl implements Runnable {

	private mjaButton b;
	private Node valueN, nLBL,nBC,nFC,nAC;
	private double initialValue;
	private mjaColor FCOL,BCOL;
	private Node imgNode;
	private String imaname,imgFile;

	public ButtonControl(Descartes D,controlConfig ccfg,String ne,String nv,String v,String inf,String sup,String vc,String ac,String s_color, String s_bc,String s_bold,String s_it,String s_un,String s_fsize ,String imaname,String s_drawbg) {
		super();
		if ((ne!=null) && ne.startsWith("[") && ne.endsWith("]")) {
			int end =ne.lastIndexOf("]");
			String varne=ne.substring(1,end);
			nLBL=D.p.Analyse(varne);
		} else {
			nLBL=D.p.Analyse("'"+ne+"'");
		}
		init(D, ccfg, ne, nv, "0", false, v, "1", inf, sup, true, "",vc,ac);
		super.reinitialize();
		TF.setVisible(false);
		TF.setEnabled(false);
		initialValue=getDoubleValue();
		valueN=D.p.Analyse(v,initialValue);
		setLayout(new GridLayout(1,1));
		FCOL=D.Tr.parseColor(s_color,new mjaColor(Color.black),new mjaColor(Color.black));
		BCOL=D.Tr.parseColor(s_bc,new mjaColor(Color.white),new mjaColor(Color.white));
		FCOL.analyse(D.p);		
		BCOL.analyse(D.p);		
		Color color=FCOL .getAdaptedColor();
		Color backcolor= BCOL.getAdaptedColor();
		boolean drawbg=D.Tr.isTrue(s_drawbg);
		b=new mjaButton(D.getImagesHashtable(),D,getTitle(),"",drawbg);
		this.imaname=imaname;
		int fsize=Integer.parseInt(s_fsize);
		int ftype=Font.PLAIN;
		if (D.Tr.isTrue(s_bold)) {
			ftype=Font.BOLD;
		}
		if (D.Tr.isTrue(s_it)) {
			ftype=Font.ITALIC;
		}
		if (D.Tr.isTrue(s_bold)&&D.Tr.isTrue(s_it)) {
			ftype=Font.BOLD+Font.ITALIC;
		}
		Font font=mjaFont.makeFont("SansSerif",ftype,fsize);
		setFont(font);
		b.setFont(font);
		b.setUnderline(D.Tr.isTrue(s_un));
		b.setMjaFCOL(FCOL);
		b.setMjaBCOL(BCOL);
		defineValue(0);
		setCursor(new Cursor(Cursor.HAND_CURSOR));
		b.addMouseListener(this);
		add(b);
	}
	
	public void setFont(int fh) {
	}

	public void updateFont() {
	}

	public mjaButton getMjaButton() {
		return b;
	}
	
	public void setSize(int w,int h) {
		super.setSize(w,h);
		b.setSize(w,h);
		updateFont();
	}
	
	public void setBounds(int x0,int y0,int w,int h) {
		super.setBounds(x0,y0,w,h);
		b.setSize(w,h);
		updateFont();
	}

	private void getFileName() {
		if ((imgNode==null) && BasicStr.hasContent(imaname)) {
		    if (imaname.startsWith("[")&&imaname.endsWith("]")) {
				imaname=imaname.substring(1,imaname.length()-1);
			} else {
				imaname="'"+imaname+"'";
			}
			try {
				imgNode=D.p.Analyse(imaname);
				imgFile="";
			} catch (Exception e) {
				imgFile="";
				imaname="";
			}
		}
	}
	
	public void paint(Graphics g) {
		super.paint(g);
		try {
			nLBL.Evaluate();
			if (!getTitle().equals(nLBL.getStr())) {
				setTitle(nLBL.getStr())	;		
				b.setLabel(getTitle(),false);
			}
			getFileName();
			try {
				imgNode.Evaluate();
				if (!imgFile.equals(imgNode.getStr())) {
					imgFile=imgNode.getStr();
					b.setImage(imgFile);
				}
			} catch (Exception e) {
			}
		} catch (Exception e) {
		}
		b.paint(g);
	}

	public void reinitialize() {
// Buttons are NOT reinitialized because it produces the effect of being clicked
	}

	public void updateVisualComponent() {
// Buttons have no visual text component
	}

	public void getTextValue() { // to overide NmericControl Method;
// Buttons are NOT updated from their text value because they have no text component
	}
	
	protected void defineTextValue(String s0) {
	}

	private void doit() {
		if (isActive()) {
			D.updateNodesFromControls();
			double d=valueN.Evaluate(initialValue);
			defineValue(d);
			executeAction();
			D.updateTextFieldsFromNodes();
			callListeners("");
			D.invalidate();
			D.paintAll(D.getGraphics());
// Cambio de repaint a paintAll el 26-06-2014, ver 5.308
		}
	}

	public void locate() throws Exception {
		b.setEnabled(isActive());
		super.locate();
	}
	/* -------------- Runnable ------------- */

	private Thread thr;
	private boolean pleaseStop;

	private void startThread() {
		pleaseStop=false;
		if (thr==null) {
			thr=new Thread(this);
//			thr.setPriority(Thread.MAX_PRIORITY);
			thr.start();
		}
	}

	private boolean mustStop() {
		return pleaseStop||(!b.isEnabled());
	}

	public void run() {
		long T=30;
		try {
			while (!mustStop() ) {
				for (int t=0;t<T;t++) {
					if (mustStop()) {
						break;
					}
					thr.sleep(20);
				}
				if (!mustStop()) {
					T=1;
					doit();
				}
			}
		} catch (InterruptedException ie) {
		}
		b.repaint();
		thr=null;
	}

	boolean isRunning() {
		return thr!=null;
	}
	
	public void stop() {
		pleaseStop=true;
		while (isRunning()) {
			try {
				Thread.sleep(10);
			} catch (InterruptedException e) {
			}
		}
	}

	public void setVisible(boolean visible) {
		super.setVisible(visible);
		if (visible) {
			repaint();
		} else {
			b.resetOverAndDown();
		}
	}

	/* -------------- Mouse Listener ------------- */
	
	private boolean isCalculation() {
		return (getAction()!=null) && (getAction().isCalculation());
	}

	public void mousePressed (MouseEvent e) {
		if (isActive()) {
			stop();
			if (e.getSource()==b && e.getModifiers()==MouseEvent.BUTTON1_MASK) {
				if (isCalculation()) {
					doit(); // necesario para que funcionen los mensajes desde eventos
					startThread();
				}
			}
		}
	}

	public void mouseReleased(MouseEvent e) {
		if (isActive()) {
			stop();
			if (e.getSource()==b && e.getModifiers()==MouseEvent.BUTTON1_MASK) {
				if (!isCalculation()) {
					doit();
				}
			}
		}
	}
	public void mouseEntered (MouseEvent e) {
		if (isActive()) {
			stop();
			super.mouseEntered(e);
		}
	}
	public void mouseExited (MouseEvent e) {
		stop();
		super.mouseExited(e);
	}

	public void mouseClicked (MouseEvent e) {
		if (isActive()) {
			stop();
			super.mouseClicked(e);
		}
	}

	/* -------------- MouseMotion Listener ------------- */
	public void mouseMoved(MouseEvent e) {
		if (isActive()) {
			stop();
		}
	}
	public void mouseDragged(MouseEvent e) { }
		
}