/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descgui;
/*------------------------------------------------------------*/
/*                      ScrollBarControl                      */
/*                         (c)  MJA                           */
/*                     Septiembre de 2002                     */
/*------------------------------------------------------------*/
import java.awt.*;
import java.io.*;
import java.net.*;
import java.awt.event.*;
import com.mja.util.*;
import com.mja.gui.*;
import com.mja.descartes.*;
import com.mja.parser.*;
import com.mja.file.*;
import javax.swing.JScrollBar;

public class ScrollBarControl extends NumericControl implements AdjustmentListener, FocusListener {

	private JScrollBar sb;
	private double value_ant;

	public ScrollBarControl(Descartes D,controlConfig ccfg,String ne,String nv,String s_p,boolean fixed,String s_v,String s_vincr,String s_vmin,String s_vmax,boolean visible,String s_notexp,boolean vert,String vc,String ac) {
		super();
		vertical=vert;
		if (vertical) {
			sb=new JScrollBar(JScrollBar.VERTICAL, 0, 10, 0, 110);
		} else {
			sb=new JScrollBar(JScrollBar.HORIZONTAL, 0, 10, 0, 110);
		}
//		if (!BasicStr.hasContent(s_vmin) && !BasicStr.hasContent(s_vmax)) {
//			s_vmin="0";
//			s_vmax="100";
//		}
		init(D, ccfg, ne, nv, s_p, fixed, s_v, s_vincr, s_vmin, s_vmax, visible, s_notexp,vc,ac);
		value_ant=getDoubleValue();
		TF.addFocusListener(this);
		GridBagLayout gbl=new GridBagLayout();
		setLayout(gbl);
		GridBagConstraints c=new GridBagConstraints();
		c.insets=new Insets(0,0,0,0);
		c.fill=GridBagConstraints.BOTH;
		c.anchor=GridBagConstraints.NORTHWEST;
		c.gridwidth=1; c.gridheight=1; 
		c.gridx=0; c.gridy=0; c.weightx=1.0; c.weighty=1.0;
		if (vertical) {
			int y=0;
			if (visible) {
				c.gridy=y; c.weighty=0.05; gbl.setConstraints(TF,c); add(TF);
				y++;
			}
			c.gridy=y; c.weighty=0.9; gbl.setConstraints(sb,c); add(sb);
			y=y+1;
			if (BasicStr.hasContent(getTitle())) {
				c.gridy=y; c.weighty=0.05; gbl.setConstraints(lb,c); add(lb);
				y++;
			}
		} else {
			int x=0;
			c.insets=new Insets(0,4,0,4);
			if (BasicStr.hasContent(getTitle())) {
				c.gridx=x; c.weightx=0.1; gbl.setConstraints(lb,c); add(lb);
				x++;
			}
			c.insets=new Insets(0,0,0,0);
			c.gridx=x; c.weightx=0.6; gbl.setConstraints(sb,c); add(sb);
			x=x+1;
			if (visible) {
				c.gridx=x; c.weightx=0.3; gbl.setConstraints(TF,c); add(TF);
				x++;
			}
		}

		updateScrollBarPos();
		
//		sb.setBackground(Color.lightGray); // Esta lnea agregada para la versin 3.915, abril 29 de 2008
		sb.addAdjustmentListener(this);
		sb.addMouseListener(this);
	}

	public void setBounds(int x, int y, int w, int h) {
		super.setBounds(x,y,w,h);
		if (!vertical) {
			setLayout(null);
			int minsbw=58;
			int lbw=minlbw;
			int TFw=minTFw;
			if (!BasicStr.hasContent(getTitle())) {
				lbw=0;
			}
			if (!TF.isVisible()) {
				TFw=0;
			}
			int sbw=w-TFw-lbw;
			while (sbw<minsbw && lbw>0)	{
				lbw--;
				sbw++;
			}
			while (sbw<minsbw && TFw>0)	{
				TFw--;
				sbw++;
			}
			int sbx=lbw;
			int TFx=sbx+sbw;
			TFw=w-TFx;
	
			lb.setBounds(0,0,lbw,h);
			sb.setBounds(sbx,0,sbw,h);
			TF.setBounds(TFx,0,TFw,h);
		}
	}
	
	public void stop() {
	}
	
	private volatile boolean fireAdjustmentEvent=true;
	private volatile boolean adjust=true;
	
	void updateScrollBarPos() {
		double d=var.getDouble();
		int val=(int) Math.round(100*(d-getMin())/(getMax()-getMin()));
		if (vertical) {
			val = 100 - val;
		}
		if (sb.getValue()!=val) {
			adjust=false;
			fireAdjustmentEvent=false;
			sb.setValue(val);
			fireAdjustmentEvent=true;
			adjust=true;
		}
	}

	protected void defineTextValue(String s0) {
	}

	public void updateVisualComponent() {
		if (TF!=null && (!getStringValue().equals(TF.getText()))) {
			TF.setText(getStringValue());
			var.setDouble(getDoubleValue());
		}
		updateScrollBarPos();
	}

	private volatile boolean updating=false;

	private boolean isUpdating() {
		return updating;
	}
	
	private double pos_ant=Double.MIN_VALUE;

	public void adjustmentValueChanged(AdjustmentEvent e) {
		if (isActive() && e.getSource()==sb && adjust) {
			if ((e.getSource()==sb))  {
				double pos=(double)sb.getValue();
				if (!isUpdating() && (pos!=pos_ant)) {  // added on 25/feb/2007
					updating=true;
					double d=pos;
					if (vertical) {
						d = 100 - d;
					}
					double val=getMin()+(getMax()-getMin())*d/100;
					/* agregado el 28 de enero de 2009 */
					double incr=BasicStr.minIncr(precision());
					if (val>value_ant) {
						val=Math.max(val,value_ant+incr);
					} else {
						val=Math.min(val,value_ant-incr);
					}
					/* ------------------------------- */
					if (val!=var.getDouble()) {
						defineValue(val);
						D.updateTextFieldsFromNodes();
						executeAction();
						if (fireAdjustmentEvent) {
							callListeners("");
						}
					}
					value_ant=getDoubleValue();
					pos_ant=pos;
					updating=false;
				} else {
	//				System.out.println("updating");
				}
			}
		}
	}
	
	/* -------------- Focus Listener ------------- */

//	boolean TFhasFocus=false;
//
//	public void focusLost(FocusEvent fe) {
//		if (fe.getSource()==TF) {
//			TFhasFocus=false;
//		}
//	}
//	public void focusGained(FocusEvent fe) {
//		if (fe.getSource()==TF) {
//			TFhasFocus=true;
//		}
//	}

	boolean isVertical() {
		return vertical;
	}

	public boolean isActive() {
		boolean active=activityN.Evaluate(1)>0;
		sb.setEnabled(active);
		return super.isActive();
	}

	public void locate() throws Exception {
		if (vertical) {
			setVisible(visibilityN.Evaluate(1)>0);
			if (isInterior()&&xN!=null&&yN!=null&&wN!=null&&hN!=null) {
				double w=wN.Evaluate(100);
				double h=hN.Evaluate(23);
				int x1=(int)Math.round(xN.Evaluate(0));
				int y1=(int)Math.round(yN.Evaluate(0));
				int w1=(int)Math.round(w);
				int h1=(int)Math.round(h);
				Point loc=getLocation();
				Dimension d=getSize();
				if (loc.x!=x1||loc.y!=y1||d.width!=w1||d.height!=h1) {
					setBounds(x1,y1,w1,h1);
//					updateFont();
				}
			}
		} else {
			super.locate();
		}
	}

}