/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descgui;
/*------------------------------------------------------------*/
/*                         Spinner                            */
/*                         (c)  MJA                           */
/*                     Septiembre de 2002                     */
/*------------------------------------------------------------*/
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import com.mja.util.*;
import com.mja.descartes.*;
import com.mja.gui.*;
import com.mja.parser.*;

public class Spinner extends NumericControl implements Runnable, MouseMotionListener, FocusListener {


	private spinnerControl sp;

	public Spinner(Descartes D,controlConfig ccfg,String ne,String nv,String s_p,boolean fixed,String s_v,String s_vincr,String s_vmin,String s_vmax,boolean visible,String s_notexp,String vc,String ac) {
		super();
		init(D,ccfg,ne, nv, s_p, fixed, s_v, s_vincr, s_vmin, s_vmax, visible, s_notexp,vc,ac);
		TF.addFocusListener(this);
		sp=new spinnerControl(D instanceof com.mja.descartes.Arquimedes);
		GridBagLayout gbl=new GridBagLayout();
		setLayout(gbl);
		GridBagConstraints c=new GridBagConstraints();
		c.fill=GridBagConstraints.BOTH;
		c.anchor=GridBagConstraints.NORTHWEST;
		c.gridwidth=1; c.gridheight=1;
		c.gridy=0; c.weighty=1.0;
		c.insets=new Insets(0,2,0,2);
		c.gridx=0; c.weightx=0.4; add(lb,c);
		c.insets=new Insets(0,0,0,0);
		c.gridx=1; c.weightx=0.0; add(sp,c);
		c.gridx=2; c.weightx=0.6; add(TF,c);
		sp.addMouseListener(this);
		sp.addMouseMotionListener(this);

	}
	
	public void setBounds(int x, int y, int w, int h) {
		super.setBounds(x,y,w,h);
		setLayout(null);
		int spw=2+h/2;
		int lbw=w/2-spw/2;
		int minTFWidth=minTFw;
		if (!TF.isVisible()) {
			lbw=w-spw;
			minTFWidth=0;
		}
		if (lbw<minlbw) {
			lbw=minlbw;
		}
		if (!BasicStr.hasContent(getTitle())) {
			lbw=0;
		}
		if (w-lbw-spw<minTFWidth) {
			lbw=w-spw-minTFWidth;
		}
		if (lbw<0) {
			lbw=0;
		}
		int spx=lbw;
		int TFx=spx+spw;
		int TFw=w-TFx;

		lb.setBounds(0,0,lbw,h);
		sp.setBounds(spx,0,spw,h);
		TF.setBounds(TFx,0,TFw,h);
	}
	
	public boolean isActive() {
		boolean active=activityN.Evaluate(1)>0;
		sp.setEnabled(active);
		return super.isActive();
	}

	protected void defineTextValue(String s0) {
	}
	
	public void updateVisualComponent() {
		if ( TF!=null && (!getStringValue().equals(TF.getText())) ) {
			TF.setText(getStringValue());
			TF.repaint();
		}
	}

	private void spinStep() {
		if (sp.isEnabled()) {
			String arg="";
			if (sp.up) {
				arg="up";
				step(true);
			} else {
				arg="down";
				step(false);
			}
			D.updateTextFieldsFromNodes();
			executeAction();
			callListeners(arg);
			TF.setText(getStringValue());
			TF.repaint();
		}
	}

	/* -------------- Runnable ------------- */

	private Thread thr;
	private boolean pleaseStop;

	private boolean pleaseStop() {
		return pleaseStop;
	}
	
	private boolean running;
	private boolean isRunning() {
		return running;
	}

	public void run() { // no hacerlo synchronized NUNCA!
		if (!isRunning()) {
//System.out.println("run IN");
			running=true;
			pleaseStop=false;
			long T=20;
			try {
				while (!pleaseStop()) {
					spinStep();
					for (int t=0;t<T;t++) {
						if (pleaseStop()) {
							break;
						}
						thr.sleep(25);
					}
					T=1;
				}
			} catch (InterruptedException ie) {
			}
			thr=null;
			running=false;
//System.out.println("run OUT");
		} else {
			System.out.println("run no entr");
		}
	}
	
	public void stop() {
		pleaseStop=true;
		while (isRunning()) {
			try {
				Thread.sleep(10);
			} catch (InterruptedException e) {
			}
		}
	}

	public void paint(Graphics g) {
		super.paint(g);
//		paintComponents(g);
		sp.paint(sp.getGraphics());
	}

	/* -------------- Mouse Listener ------------- */
	public void mousePressed(MouseEvent e) {
		if (isActive()) {
			sp.requestFocus();
			stop();
			if (e.getModifiers()==MouseEvent.BUTTON1_MASK) {
				if (e.getSource()==sp) {
					if (e.getY()<sp.getSize().height/2) {
						sp.up=true;
					} else {
						sp.down=true;
					}
					sp.repaint();
					if (thr==null) {
						thr=new Thread(this);
						thr.start();
					}
				}
			}
			super.mousePressed(e);
		}
	}

	public void mouseReleased(MouseEvent e) {
		if (isActive()) {
			pleaseStop=true;
			sp.up=false;
			sp.down=false;
			sp.repaint();
			stop();
			super.mouseReleased(e);
		}
	}
	public void mouseEntered (MouseEvent e) {
		if (isActive()) {
			stop();
			super.mouseEntered(e);
		}
	}
	public void mouseExited (MouseEvent e) {
		if (isActive()) {
			stop();
			super.mouseExited(e);
		}
	}

	/* -------------- MouseMotion Listener ------------- */
	public void mouseMoved(MouseEvent e) {
		if (isActive()) {
			stop();
		}
	}
	public void mouseDragged(MouseEvent e) { }

	/* -------------- Focus Listener ------------- */


}