/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descgui;

import java.util.*;
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.net.*;
import javax.swing.JTextField;
import com.mja.util.*;
import com.mja.file.*;
import com.mja.gui.*;

public class mjaGui {

	public static Panel embedPanel(Container C,int gap) {
		GridBagLayout gbl=new GridBagLayout();
		C.setLayout(gbl);
		GridBagConstraints gbc=new GridBagConstraints();
		gbc.insets=new Insets(gap,gap,gap,gap);
		gbc.fill=GridBagConstraints.BOTH;
		gbc.weightx=1; gbc.weighty=1;
		Panel p=new Panel();
		p.setLayout(new BorderLayout());
		C.add(p,gbc);
		return p;
	}

	private static Tooltip tooltip=null;

	public static void showTooltip(Component parentC,Component c,String msg,String more,Font font) {
		Point p=new Point(c.getLocationOnScreen().x+c.getSize().width/2,c.getLocationOnScreen().y+c.getSize().height/2);
		showTooltip(parentC,c,p,msg,more,font);
	}



	public static void setEditor(TextField C) {
		if (tooltip!=null) {
			tooltip.setEditor(C);
		}
	}

//	public static void closeTooltip() {
//		if (tooltip!=null) {
//			tooltip.close();
//		}
//	}
//
	public static void hideTooltip() {
		if (tooltip!=null) {
			tooltip.setVisible(false);
		}
	}

	private static Frame F=null;

	public static void showTooltip(Component parentC,Component c,Point p,String msg,String more,Font font) {
		if (F==null) {
			F=new Frame();
		}
		if (tooltip==null) {
			tooltip=new Tooltip(F);
			tooltip.setEditor(null);
		}
		tooltip.reset(parentC,c,p,msg,more,font);
	}

	public static int[] grabPixelsFromImage(int w, int h,Image img) {
		int[] pixels=new int[w*h];
		PixelGrabber pg = new PixelGrabber(img, 0, 0, w, h, pixels, 0, w);
		try {
			pg.grabPixels();
		} catch (InterruptedException e) {
		}
		return pixels;
	}

	public static void fillShape(Graphics[] g,int[] pixels,int w, int h,int x0, int y0) {
		if ( 0<=x0 && 0<=y0 && x0<w && y0<h ) {
			int c0=pixels[x0+y0*w];
			int c=c0^0x00ffffff;
			Stack S=new Stack();
			S.push(new Point(x0,y0));
			while (!S.empty()) {
				Point P=(Point) S.pop();
				int x=P.x, y=P.y, p=x+y*w;
				while (x>=0 && pixels[p]==c0) {
					x--; pixels[p--]=c;
				}
				int mi=x+1;
				x=P.x+1; p=x+y*w;
				while (x<w && pixels[p]==c0) {
					x++; pixels[p++]=c;
				}
				int mf=x-1;
				for (int i=0;i<g.length;i++) {
					g[i].drawLine(mi,y,mf,y);
				}
				for (int caso=0;caso<2;caso++) {
					if (caso==0) {
						y++;
					} else {
						y--; y--;
					}
					if (0<=y && y<h) {
						x=mi;
						p=x+y*w;
						while (x<mf) {
							boolean pflag=false;
							while (x<=mf && pixels[p]==c0) {
								pflag=true; x++; p++;
							}
							if (pflag) {
								if (x==mf && pixels[p]==c0) {
									S.push(new Point(x,y));
								} else {
									S.push(new Point(x-1,y));
								}
								pflag=false;
							}
							int aux=x;
							while (x+1<mf && pixels[p]!=c0) {
								x++;p++;
							}
							if (x==aux) {
								x++;p++;
							}
						}
					}
				}
			}
		}
	}

	public static GridBagConstraints newGBC() {
		GridBagConstraints c=new GridBagConstraints();
		c.insets=new Insets(1,1,1,1);
		c.anchor=GridBagConstraints.CENTER;
		c.fill  =GridBagConstraints.BOTH;
		c.gridwidth=1; c.gridheight=1;
		c.weightx=1; c.weighty=1;
		c.gridx=0; c.gridy=0;
		return c;
	}

}

class Tooltip extends Window implements MouseListener, MouseMotionListener, Runnable, KeyListener {

	private Thread thr;
	private Component parentC,C;
	private Point p;
	private String msg,moremsg;
	private TextField tf;
	private TextArea TA;
	private Font font;

	Tooltip(Frame parent) {
		super(parent);
		setBackground(Color.black);
		setForeground(Color.gray);
		setLayout(new BorderLayout());
		addKeyListener(this);
		addMouseListener(this);
		addMouseMotionListener(this);
	}

	void reset(Component parentC,Component C,Point p,String msg,String moremsg,Font font) {
		close();
		removeAll();
		if (this.C!=null) {
			this.C.removeMouseListener(this);
			this.C.removeMouseMotionListener(this);
		}
		if (this.parentC!=null) {
			this.parentC.removeMouseListener(this);
			this.parentC.removeMouseMotionListener(this);
		}
		this.C=C;
		this.parentC=parentC;
		this.p=p;
		this.msg=msg;
		this.moremsg=moremsg;
		this.font=font;
		C.addMouseListener(this);
		C.addMouseMotionListener(this);
		parentC.addMouseListener(this);
		parentC.addMouseMotionListener(this);
		thr=new Thread(this);
		thr.start();
	}

	private void close() {
		pleaseStop=true;
		while (thr!=null) {
			try {
				Thread.sleep(20);
			} catch (InterruptedException e) {
				break;
			}
		}
	}

	void setEditor(TextField C) {
		tf=C;
	}

	/* -------------- Runnable ------------- */
	private volatile boolean pleaseStop,moved, mousexit;

	private boolean pleaseStop() {
		return pleaseStop;
	}

	private boolean moved() {
		return moved;
	}

	private boolean mousexit() {
		return mousexit;
	}

	public void run() {
		pleaseStop=false;
		int i=0;
		while (i<25&&!pleaseStop()) {
			try {
				Thread.sleep(20);
			} catch (InterruptedException e) {
				break;
			}
			i++;
		}
		if (!pleaseStop()) {
			moved=false;
			i=0;
			while (i<25&&!pleaseStop()&&!moved()) {
				try {
					Thread.sleep(20);
				} catch (InterruptedException e) {
					break;
				}
				i++;
			}
		}
		if (!pleaseStop()&&!moved()) {
			mousexit=false;
			Dimension d=new Dimension();
			String adjmsg=BasicStr.adjust(msg,30,d,true,getFontMetrics(font));
			String[] sa=BasicStr.toStringArray(adjmsg,true);
			adjmsg="";
			d.height=0;
			boolean newline=false;
			for (i=0;i<sa.length;i++) {
				adjmsg+=sa[i];
				if (sa[i].equals("\n")) {
					d.height++;
					if (i+1<sa.length && (d.height>6 || newline)) {
						if (!newline) {
							adjmsg+="\n";
							d.height++;
						}
						adjmsg+=" ... "+moremsg+" ...";
						break;
					}
					newline=true;
				} else {
					newline=false;
				}
			}
			TA=new TextArea(adjmsg,d.height+1,31,TextArea.SCROLLBARS_NONE);
			TA.addMouseListener(this);
			TA.addMouseMotionListener(this);
			TA.setFont(font);
			TA.setEditable(false);
			TA.setForeground(mjaColor.DeepBlue);
			TA.setBackground(Color.white);
			removeAll();
			add("Center",TA);
			pack();
			p.x=Math.min(p.x,parentC.getLocationOnScreen().x+parentC.getSize().width-getSize().width);
			p.y=Math.min(p.y+16,parentC.getLocationOnScreen().y+parentC.getSize().height-getSize().height);
			setLocation(p.x,p.y);
			setVisible(true);
//			toFront();   // eliminado 20/Junio/2005 porque en NippeEditor ms bien lo oculta.
			if (mousexit()) {
				pleaseStop=false;
				moved=false;
				mousexit=false;
			}
			i=0;
			while (i<200 && !pleaseStop() && !moved())  {
				try {
					Thread.sleep(20);
				} catch (InterruptedException e) {
					break;
				}
				i++;
			}
			setVisible(false);
		}
		thr=null;
	}
	/* -------------- Mouse Listener ------------- */
	public void mousePressed(MouseEvent e) {
		pleaseStop=true;
	}
	public void mouseReleased(MouseEvent e) {}
	public void mouseClicked (MouseEvent e) {
		pleaseStop=true;
	}
	private boolean inC=false,inParent=false;
	public void mouseEntered (MouseEvent e) {
	}

	public void mouseExited (MouseEvent e) {
		mousexit=true;
		pleaseStop=true;
	}

	public void mouseMoved (MouseEvent e) {
		moved=true;
	}
	public void mouseDragged (MouseEvent e) {}

	/* -------------- Key Listener ------------- */
	public void keyPressed(KeyEvent e) {
	}
	public void keyReleased(KeyEvent e) {
	}
	public void keyTyped(KeyEvent e) {
		pleaseStop=true;
		if (tf!=null) {
			int n=tf.getCaretPosition();
			String s=tf.getText();
			tf.setText(s.substring(0,n)+e.getKeyChar()+s.substring(n));
			tf.setCaretPosition(n+1);
			tf.requestFocus();
		}
	}

}