/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descgui;
/*------------------------------------------------------------*/
/*                      spinnerControl                        */
/*                         (c)  MJA                           */
/*                     Agosto de 2000                         */
/*------------------------------------------------------------*/
import java.awt.*;
import java.awt.event.*;
import com.mja.cmp.*;
import com.mja.util.*;

public class spinnerControl extends Canvas {

	public boolean up,down;
	private static Color bgcolor=new Color(0xf0f8ff), almostWhite=new Color(0xf0f8ff);

	private Color ue=new Color(0x2244cc),ud=new Color(0x8888aa),de=new Color(0xd00018),dd=new Color(0xaa8888);

	public spinnerControl(boolean serious) {
		if (serious) {
			ue=new Color(0x554466);ud=new Color(0x9988aa);
			de=ue;dd=ud;
		}
		setSize(13,BasicStr.lineVSize());
	}
	
	public void setEnabled(boolean b) {
		boolean a=isEnabled();
		super.setEnabled(b);
		if (a!=b) {
			repaint();
		}
	}
	
	private Image bima;

	public void paint(Graphics g0) {
		if (g0!=null) {
			Graphics2D g=(Graphics2D) g0;
			g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
			int h=getSize().height;
			int w=getSize().height/2+2;
			if (w==2*(w/2)) { w++; }
			if (getSize().width!=w) {
				setSize(w,getSize().height);
				if (getParent()!=null) {
					getParent().paint(getParent().getGraphics());
				}
			}
			if (bima==null) {
				bima=createImage(Math.max(getSize().width,1),Math.max(getSize().height,1));
				Graphics bimag=bima.getGraphics();
				bimag.setColor(bgcolor);
				bimag.fillRect(0,0,getSize().width,getSize().height);
				int hh=h*h;
				for (int i=0;i<h;i++) {
					int di=(i-(40*h)/100);
					bimag.setColor(new Color(0,0,0,(di*di*192)/hh));
					bimag.drawLine(0,i,w,i);
				}
			}
			g.drawImage(bima,0,0,this);
			Color c1,c2;
			if (up) { 
				c1=Color.gray; c2=almostWhite; 
			} else { 
				c1=almostWhite; c2=Color.gray; 
			}
			g.setColor(c1); g.drawLine(0,0,w,0);  g.drawLine(0,0,0,h/2);
			g.setColor(c2); g.drawLine(0,h/2,w,h/2); g.drawLine(w-1,0,w-1,h/2);
			if (down) { 
				c1=Color.gray; c2=almostWhite; 
			} else { 
				c1=almostWhite; c2=Color.gray; 
			}
			g.setColor(c1); g.drawLine(0,h/2+1,w,h/2+1); g.drawLine(0,h/2+1,0,h);
			g.setColor(c2); g.drawLine(0,h-1,w,h-1); g.drawLine(w-1,h/2+1,w-1,h-1);
			int[] x=new int[3];
			x[0]=w/2; x[1]=w/5; x[2]=w-w/5-1;
			int[] y=new int[3];
			y[0]=h/8+1; y[1]=y[0]+h/4; y[2]=y[1];
			if (isEnabled()) { g.setColor(ue); } else { g.setColor(ud);	}
			g.fillPolygon(x,y,3);
			y[0]=h-h/8-1; y[1]=y[0]-h/4; y[2]=y[1];
			if (isEnabled()) { g.setColor(de); } else { g.setColor(dd); }
			g.fillPolygon(x,y,3);
			g.setColor(new Color(0,0,0,0x18));
			if (up) { g.fillRect(0,0,w,h/2); } 
			if (down) { g.fillRect(0,h/2,w,h); }
		}
	}
	
}