/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/

package com.mja.file;

import java.applet.Applet;
import java.awt.Component;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Toolkit;
import java.awt.image.BufferedImage;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataOutputStream;
import java.io.OutputStreamWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.Proxy;
import java.net.ProxySelector;
import java.net.URISyntaxException;
import java.net.URL;
import java.net.URLConnection;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import javax.imageio.ImageIO;
import javax.imageio.ImageWriter;
import javax.imageio.stream.FileImageOutputStream;

import com.mja.util.BasicStr;

public final class mjaFile {
	
	public static String readURL(URL url) {
		InputStream is=null;
		try {
			is=url.openStream();
			if (is!=null) {
				String s = readInputStream(is);
				return s;
			}
		} catch (IOException ioe) {
		}
		try {
			is=getURLInputStream(url);
			if (is!=null) {
				String s=readInputStream(is);
				return s;
			}
		} catch  (IOException ioe) {
		}
		return "";
	}

	public static InputStream getURLInputStream(URL url) {
		try {
			URLConnection c = null;
			Proxy tmpProxy = getProxyFor(url);
			if ((tmpProxy!=null)&&(!tmpProxy.type().equals("DIRECT"))) {
				System.out.println("Proxy = "+tmpProxy.type());
				c = url.openConnection(tmpProxy);
			} else {
				c = url.openConnection();
			}
			InputStream is=c.getInputStream();
			return is;
		} catch (Exception e) {
			return null;
		}
	}

	private static String pureReadFile(String path) {
		try {
			File f=new File(path);
			
			FileInputStream is=new FileInputStream(f);
			String s=readInputStream(is);
			if(s.indexOf("charset=UTF-8")>=0) {
				s = com.mja.file.mjaHtml.readUTF8(f);
			}
			if (s!=null) {
//System.out.println(path+"="+s.length());
				return s;
			}
		} catch (IOException e1) {
		}
		return null;
	}

	private static String pureReadUri(String uri) {
		try {
			URL url=new URL(uri);
			String s=readURL(url);
			if (s!=null) {
				return s;
			}
		} catch (Exception e4) {
		}
		return null;
	}
	
	public static String readURL(String uri) {
		try {
			URL url = new URL(uri);
			return mjaFile.readURL(url);
		} catch (Exception exc) {
			return readFile(uri);
		}
	}

	public static String readFile(String path) {
		if (path.startsWith("http:")) {
			return readURL(path);
		}
		String s=pureReadFile(path);
		if (s!=null) {
			return s;
		}
		return readFile(BasicStr.A,BasicStr.inWeb,path,true);
	}

	public static String readFile(Applet A,boolean inWeb,String filename,boolean inform) {
		String uri = filename;
		if (!uri.startsWith("http:")){
			URL docBase = A.getDocumentBase();
			uri = docBase.toExternalForm();
			int ix = uri.lastIndexOf("/");
			if ((ix>=0) && (ix<uri.length())) {
				uri=uri.substring(0,ix+1)+filename;
			}
			if(docBase.getProtocol().equals("file")){
				uri = uri.replaceAll("^file://([^/])", "file:///$1");
				uri = uri.replaceAll("^file:/([^/])", "file:///$1");
			}
		}
		
		
		if (uri.startsWith("file:") || uri.startsWith("http:")) {
			String s = readURL(uri);
			if (BasicStr.hasContent(s)) {
				return s;
			}
		}
		
		if (inWeb) {
			uri = uri.replaceAll("^file:/// ([^/])", "$1");
			uri = uri.replaceAll("^file://([^/])", "$1");
			uri = uri.replaceAll("^file:/([^/])", "$1");
			System.out.println("Vamos a intentar leer desde el filesystem : "+uri);
			String s = pureReadUri(uri);
			if (BasicStr.hasContent(s)) {
				return s;
			}
		}
		if (inform) {
			System.out.println("File: "+filename+" not found");
		}
		return "";
	}

	public static String getResource(Applet A,String path) {
		if (A!=null) {
			URL url = A.getClass().getResource("/"+path);
			if (url != null) {
				return readURL(url);
			} else {
				return "";
			}
		} else {
			return readFile(path);
		}
	}


	private static String tryFile(boolean inWeb,String path) throws Exception {
		String str="";
		if (inWeb) {
			try {
				URL url =new URL(path);
				str=readURL(url);
			} catch (Exception e) {
			}
		} else {
			path = BasicStr.replace(path,"/",File.separator);
			try {
				File f=new File(path);
				InputStream is=new FileInputStream(f);
				str=readInputStream(is);
			} catch (IOException e1) {
			}
		}
		if (!BasicStr.hasContent(str)) {
			throw (new Exception("file "+path+" not found"));
		}
		return str;
	}

	public static String getCodeBasePath(Applet A,boolean inWeb,String filename) {
//System.out.println("getPATH inWeb="+inWeb+" file="+filename);
		String s="";
		String path=filename;
			try {
				path=A.getCodeBase().toExternalForm();
				if (!path.endsWith("/")) {
					path+="/";
				}
				path+=filename;
				s=tryFile(inWeb,path);
//System.out.println("1. Path inWeb="+inWeb+" path="+path);
				return path;
			} catch (Exception e) {
			}
		return "";
	}

	public static String getDocBasePath(Applet A,boolean inWeb,String filename) {
//System.out.println("getPATH inWeb="+inWeb+" file="+filename);
		String s="";
		String path=filename;
			try {
				path=A.getDocumentBase().toExternalForm();
				if (!path.endsWith("/")) {
					path+="/";
				}
				path+=filename;
				s=tryFile(inWeb,path);
//System.out.println("1. Path inWeb="+inWeb+" path="+path);
				return path;
			} catch (Exception e) {
			}
		return "";
	}

	public static boolean updateFromURL(URL url,String filename,boolean onlyIfNotExists) throws IOException {
		try { 
			URLConnection c;
			try {
				Proxy tmpProxy = getProxyFor(url);
				c = url.openConnection(tmpProxy);
			} catch (Exception e) {
				c = url.openConnection();
			}
			int N = c.getContentLength();
			long D = c.getLastModified();
			File f = new File(filename);
			boolean doit=true;
			if (f.exists()) {
				if (onlyIfNotExists) {
					doit=false;
				} else {
					URL urlf = f.toURL();
					URLConnection cf;
					try {
						Proxy tmpProxy = getProxyFor(url);
						cf = urlf.openConnection(tmpProxy);
					} catch (Exception e) {
						cf = urlf.openConnection();
					}
					long Df=cf.getLastModified();
					doit=Df<D;
				}
			}
			if (doit) {
				int ix=filename.lastIndexOf(File.separator);
				String path="";
				if (ix>0) {
					path=filename.substring(0,ix+1);
				}
				File p=new File(path);
				p.mkdirs();
				InputStream is=c.getInputStream();
				OutputStream os=new FileOutputStream(filename,false);
				byte[] b=new byte[8092];
				int n=0;
				while (n<N) {
					int k=is.read(b);
					if (k<=0) {
						break;
					}
					os.write(b,0,k);
					n+=k;
				}
				is.close();
				os.flush();
				os.close();
				return true;
			}
		} catch (MalformedURLException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return false;
	}

	public static boolean copyFromURL(URL url,String filename,boolean onlyIfNotExists) throws IOException {
		try { 
			URLConnection c;
			try {
				Proxy tmpProxy = getProxyFor(url);
				c = url.openConnection(tmpProxy);
			} catch (Exception e) {
				c = url.openConnection();
			}
			int N = c.getContentLength();
			long D = c.getLastModified();
			File f = new File(filename);
			boolean doit=true;
			if (f.exists()) {
				if (onlyIfNotExists) {
					doit=false;
				} else {
					doit=true;
				}
			}
			if (doit) {
				int ix=filename.lastIndexOf(File.separator);
				String path="";
				if (ix>0) {
					path=filename.substring(0,ix+1);
				}
				File p=new File(path);
				p.mkdirs();
				InputStream is=c.getInputStream();
				OutputStream os=new FileOutputStream(filename,false);
				byte[] b=new byte[8092];
				int n=0;
				while (n<N) {
					int k=is.read(b);
					if (k<=0) {
						break;
					}
					os.write(b,0,k);
					n+=k;
				}
				is.close();
				os.flush();
				os.close();
				return true;
			}
		} catch (MalformedURLException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return false;
	}

	public static String readInputStream(InputStream is) throws IOException {
//		InputStreamReader isr = new InputStreamReader(is,"UTF-8");
		InputStreamReader isr = new InputStreamReader(is,"ISO-8859-1");
		// ISO-8859-1 codification added on ver 3.913 2008-02-15
		BufferedReader br=new BufferedReader(isr);
		StringBuffer sb=new StringBuffer();
		String auxs = br.readLine();
		while (auxs != null){
			sb.append(auxs+"\n");
			auxs = br.readLine();
		}
		isr.close();
		String str=sb.toString();

		return str;
	}
	
	private static String readContent(InputStream is, String codification) {
		try {
			InputStreamReader isr = new InputStreamReader(is,codification);
			BufferedReader br=new BufferedReader(isr);
			StringBuffer sb=new StringBuffer();
			String auxs = br.readLine();
			while (auxs != null){
				sb.append(auxs+"\n");
				auxs = br.readLine();
			}
//			isr.close();
			String str=sb.toString();
			return str;
		}
		catch(IOException e) {
			e.printStackTrace();
			return "";
		}
	}

	public static String readStrResource(Class cl,String filename) {
		try {
			return readInputStream(cl.getResourceAsStream(filename));
		} catch (IOException e) {
			e.printStackTrace();
		}
		return null;
	}

	public static Vector readStrArrResource(Class cl,String filename,String prefix) {
		Vector v=new Vector();
		try {
			URL url=cl.getResource(filename);
			if (url!=null) {
				BufferedReader br=new BufferedReader(new InputStreamReader(url.openStream()));
				String s=br.readLine();
				while (s!=null) {
					s=s.trim();
					if (BasicStr.hasContent(s)&&!s.startsWith("//")) {
						if (prefix!=null) {
							if (s.startsWith(prefix)) {
								v.addElement(s.substring(prefix.length()));
							}
						} else {
							v.addElement(s);
						}
					}
					s=br.readLine();
				}
				br.close();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return v;
	}

	public static Vector readStrArrResource(Class cl,String filename) {
		return readStrArrResource(cl,filename,null);
	}

	public static boolean fileExists(URL url) {
		if (url==null) {
			return false;
		}
		boolean ok=false;
		try {
			Proxy tmpProxy = getProxyFor(url);
			URLConnection con=url.openConnection(tmpProxy);
			con.connect();
			ok=true;
		} catch (Exception e) {
			System.out.println("Exception: "+url);
			System.out.println(e);
			ok=false;
		}
		return ok;
	}

	private static void doLoad(Image image,Component C) throws Exception {
		try {
			if (image==null) {
				throw new Exception("null Image");
			}
			MediaTracker mt=new MediaTracker(C);
			mt.addImage(image,0);
			mt.waitForID(0);
			if (mt.isErrorAny()||image.getWidth(C)<=0||image.getHeight(C)<=0) {
				throw new Exception("Exception loading image");
			}
		} catch (Exception e) {
			throw e;
		}
	}
	
	public static Image loadImage(Hashtable images,Applet A,String fname) {
		if (images.containsKey(fname)) {
			Object o=images.get(fname);
			if (o instanceof Image) {
				return (Image) o;
			} else {
				return null;
			}
		} else {
			Image image=null;
			if (!BasicStr.hasContent(fname)) {
				images.put(fname,new Object());
				return image;
			}
			if (BasicStr.hasContent(fname)) {
				String filename=fname;
				if (filename.startsWith("/")) {
					filename=filename.substring(1);
				}
				URL url;
				if ( image==null ) {
					try {
						String uri=A.getDocumentBase().toExternalForm();
						int ix=uri.lastIndexOf("/");
						if (ix>=0 && ix<uri.length()) {
							uri=uri.substring(0,ix+1);
						}
						uri=uri+filename;
						url=new URL(uri);
						boolean inNippeEditor=(uri.indexOf("file://")>=0);
						if (inNippeEditor) {
							image=A.getImage(url);
						} else {
							Proxy tmpProxy = getProxyFor(url);
							url.openConnection(tmpProxy);
							image=Toolkit.getDefaultToolkit().getImage(url);
						}
						doLoad(image,A);
//System.out.println("type 1 "+url.toExternalForm());
					} catch (Exception e) {
						image=null;
					}
				}
				if ( image==null ) {
					try {
						String uri=A.getDocumentBase().toExternalForm();
						int ix=uri.lastIndexOf("/");
						if (ix>=0 && ix<uri.length()) {
							uri=uri.substring(0,ix+1);
						}
						uri=uri+filename;
						url=new URL(uri);
						image=A.getImage(url);
						doLoad(image,A);
//System.out.println("type 2 "+url.toExternalForm());
					} catch (Exception e) {
						image=null;
					}
				}
				if ( image==null ) {
					try {
						String uri=A.getDocumentBase().toExternalForm()+fname;
						url=new URL(uri);
						Proxy tmpProxy = getProxyFor(url);
						url.openConnection(tmpProxy);
						image=Toolkit.getDefaultToolkit().getImage(url);
						doLoad(image,A);
//System.out.println("type 3 "+url.toExternalForm());
					} catch (Exception e) {
						image=null;
					}
				}
			}
			return image;	
		}
	}
	
	static public boolean fileExists(String filename) {
		File f=new File(filename);
		return f.exists();
	}

	static public void delete(String filename) {
		if (fileExists(filename)) {
			File f=new File(filename);
			f.delete();
		}
	}

	static public void save(String filename,String s) {
		delete(filename);
		try {
			File file=new File(filename);
//			BufferedWriter bw=new BufferedWriter(new OutputStreamWriter(new FileOutputStream(filename), "UTF-8"));
			BufferedWriter bw=new BufferedWriter(new FileWriter(file));
			bw.write(s,0,s.length());
			bw.close();
		} catch (IOException e) {
			if (BasicStr.A!=null) {
				String uri=BasicStr.A.getDocumentBase().toExternalForm();
				int ix=uri.lastIndexOf("/");
				if ((ix>=0) && (ix<uri.length())) {
					uri=uri.substring(0,ix+1)+filename;
				}
				if (uri.startsWith("file://")) {
					uri=uri.substring("file://".length());
					try {
//						BufferedWriter bw=new BufferedWriter(new OutputStreamWriter(new FileOutputStream(uri), "UTF-8"));
						BufferedWriter bw=new BufferedWriter(new FileWriter(new File(uri)));
						bw.write(s,0,s.length());
						bw.close();
						return;
					} catch(Exception e1) {
					}
				} else if (uri.startsWith("file:/")) {
					uri=uri.substring("file:/".length());
					try {
//						BufferedWriter bw=new BufferedWriter(new OutputStreamWriter(new FileOutputStream(uri), "UTF-8"));
						BufferedWriter bw=new BufferedWriter(new FileWriter(new File(uri)));
						bw.write(s,0,s.length());
						bw.close();
						return;
					} catch(Exception e2) {
					}
				}
			}
			System.out.println("could not save file "+filename);
//			e.printStackTrace();
		}
	}

// @DANIELOSO : UPLOAD FUNCTION 

	static public String upload(String server,String user,String pwd,String project,String filename,String whatToSave) {
		String result="failed";
		try {
			String contents=java.net.URLEncoder.encode(whatToSave);
			result = post(("http://"+server+"/descartesServer.php"), ("service=upload&user="+user+"&password="+pwd+"&project="+project+"&file="+filename+"&contents="+contents));
//System.out.println(result);
			
		} catch (Exception e) {
			e.printStackTrace();
			result=e.getMessage();
		}
		result=BasicStr.trim(result,'\n');
		return BasicStr.trim(result,'\r');
	}

	public static Proxy getProxyFor(URL url){
		try {
			ProxySelector tmpPS = ProxySelector.getDefault();
			List<Proxy> psl;
				psl = tmpPS.select(url.toURI());
			
			Proxy tmpProxy =  null;
			for (Iterator<Proxy> iterator = psl.iterator(); iterator.hasNext();) {
				tmpProxy = (Proxy) iterator.next();
			}
	
			return tmpProxy;
		} catch (URISyntaxException e) {
//			e.printStackTrace();
		}
		return null;
	}
	
	
	
// @DANIELOSO : NEW POST FUNCTION 
	
	public static String post(String address, String content) { 
		String input = "";
		String response = "";
		
		try {
			URL url = new URL(address);
			Proxy tmpProxy = getProxyFor(url);
//			if ((tmpProxy!=null)&&(!tmpProxy.type().equals("DIRECT"))) {
//				System.out.println("Proxy = "+tmpProxy.type());
//			}
			HttpURLConnection http = (HttpURLConnection)url.openConnection(tmpProxy);
			http.setDoInput(true);
			http.setDoOutput(true);
			http.setUseCaches(false);
			http.setRequestMethod("POST");
			http.connect();
//System.out.println("Client : Connected");
			DataOutputStream out = new DataOutputStream(http.getOutputStream());
//System.out.println("Client : Writing Content");
			out.writeBytes(content);
//System.out.println("Client : Flushing Stream");
			out.flush();
//System.out.println("Client : Waiting for response from Server");
			BufferedReader in = new BufferedReader(new InputStreamReader(http.getInputStream()));
//System.out.println("Client : Opened input stream");
			input = "";
			response = "";
			while((input = in.readLine()) != null) {
				response = input + "\r";
			}
//System.out.println("Client : received : " + response);
		} catch(Exception e) {
//System.out.println("Client : Error : "+e.getMessage());
			return "0";
		}
		return response;
	}

	public static boolean save(String filename,BufferedImage bima,String format) {
		// format may be "png","jpeg",etc...
		String abrevFormat=format;
		if (format.equals("jpg")) {
			format="jpeg";
		}
		Iterator it=ImageIO.getImageWritersByFormatName(format);
		boolean imgfileOK=false;
		while (it.hasNext()) {
			ImageWriter iw=(ImageWriter) it.next();
			try {
				File file=new File(filename);
				if (file.exists()) {
					file.delete();
				}
				FileImageOutputStream fios=new FileImageOutputStream(file);
				iw.setOutput(fios);
				iw.write(bima);
				fios.flush();
				fios.close();
				iw.dispose();
				imgfileOK=true;
				break;
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		return imgfileOK;
	}

}