/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.file;

import java.io.*;
import java.net.*;
import java.util.*;
import java.awt.*;
import java.applet.*;
import java.awt.font.FontRenderContext;
import java.awt.font.TextLayout;
import java.awt.geom.AffineTransform;
import java.awt.geom.Rectangle2D;

import com.mja.util.BasicStr;

public final class mjaFont /*extends Font*/ {
	
	private static Applet A;
	
	public static Font AWTMono=new Font("Monospaced",Font.PLAIN,15);
	public static Font AWTMonoB=new Font("Monospaced",Font.BOLD,17);
	public static Font AWTSerif=new Font("Serif",Font.PLAIN,15);
	public static Font AWTSansSerif=new Font("SansSerif",Font.PLAIN,15);
	public static Font AWTSansSerif_I=new Font("SansSerif",Font.ITALIC,15);
	public static Font AWTSansSerif_B=new Font("SansSerif",Font.BOLD,15);

	public static Font Monospaced=AWTMono;
	private static Font Serif=AWTSerif;
	private static Font SansSerif=AWTSansSerif;
	private static Font Monospaced_I;
	private static Font Serif_I	;
	private static Font SansSerif_I;
	private static Font Monospaced_B;
	private static Font Serif_B	;
	private static Font SansSerif_B;
	private static Font Monospaced_BI;
	private static Font Serif_BI		;
	private static Font SansSerif_BI	;
	private static Font mathF=null;

	private static boolean awfldd=false;
	private static boolean[][] wfldd=new boolean [3][4];
	private static int M=0,SS=1,S=2;
	private static int P=0,I=1,B=2,BI=3;
	
	public static synchronized void prepareFonts(Applet B) {
		if (A==null) {
			A=B;
		}
	}
	
	public static Font MathFont() {
		if (mathF==null) {
//			System.out.println("Loading Descartes Math Font...");
			mathF = loadFont(mathF,Font.PLAIN,"DESCARTES.TTF");
//			System.out.println("Descartes Math Font Loaded.");
		}
		return mathF;
	}

	private static Font loadFont(InputStream is,int font_type) throws Exception {
		// This is VERY slow for DESCARTES.TTF.
		Font f=Font.createFont(Font.TRUETYPE_FONT,is);
		is.close();
		return f.deriveFont(font_type,12);
	}
	
	private static Font loadFont(URL url,int font_type) throws Exception {
		if (url==null) {
			throw new Exception("Null URL");
		}
//System.out.println("loading "+url.toExternalForm());
		try {
			URLConnection c=url.openConnection();
			byte[] buffer=new byte[(int) c.getContentLength()];
			InputStream is=c.getInputStream();
			int N=0;
			while (N<buffer.length) {
				int bytesread=is.read(buffer,N,buffer.length-N);
				N=N+bytesread;
			}
			InputStream bis=new ByteArrayInputStream(buffer);
			Font f1=loadFont(bis,font_type);
//System.out.println("DONE!");
			return f1;
		} catch (Exception e) {
//System.out.println("FAILED!");
			throw e;
		}
	}
	
	private static Font loadFont(Font f,int font_type,String filename) {
		if (A!=null) {
			URL url=null;
			try {
				url=A.getClass().getResource("/resources/fuentes/"+filename);
				return loadFont(url,font_type);
			} catch (Exception e) {
			}
//			try {
//				url=new URL(A.getCodeBase(),"fuentes/"+filename);
//				return loadFont(url,font_type);
//			} catch (Exception e) {
//			}
		}
//		try {
//			File F=new File("fuentes"+File.separator+filename);
//			InputStream is=new FileInputStream(F);
//			Font f1=loadFont(is,font_type);
//			return f1;
//		} catch (Exception e) {
//		}
//		try {
//			InputStream is=new FileInputStream("resources"+File.separator+"fuentes"+File.separator+filename);
//			Font f1=loadFont(is,font_type);
//			return f1;
//		} catch (Exception e) {
//		}
//System.out.println("Usando fuente del sistema como "+filename);
		return f;
	}

	public static Font makeFont(String font_name,int font_type,int font_size) {
		switch (font_type) {
			case Font.ITALIC :
				if (font_name!=null) {
					if (font_name.startsWith("Times")||font_name.startsWith("Serif")) {
//						if (!wfldd[S][I]) {
//							Serif_I=loadFont(Serif_I,font_type,"TIMESI.TTF");
//						}
						if (Serif_I==null) {
							Serif_I=Serif;
						}
						wfldd[S][I]=true;
						return Serif_I.deriveFont(font_type,font_size);
					} else if (font_name.startsWith("Courier")||font_name.startsWith("Monospaced")) {
//						if (!wfldd[M][I]) {
//							Monospaced_I=loadFont(Monospaced_I,font_type,"COURI.TTF");
//						}
						if (Monospaced_I==null) {
							Monospaced_I=Monospaced;
						}
						wfldd[M][I]=true;
						return Monospaced_I.deriveFont(font_type,font_size);
					}
				}
//				if (!wfldd[SS][I]) {
//					SansSerif_I=loadFont(SansSerif_I,font_type,"ARIALI.TTF");
//				}
				if (SansSerif_I==null) {
					SansSerif_I=SansSerif;
				}
				wfldd[SS][I]=true;
				return SansSerif_I.deriveFont(font_type,font_size);
			case Font.BOLD :
				if (font_name!=null) {
					if (font_name.startsWith("Times")||font_name.startsWith("Serif")) {
//						if (!wfldd[S][B]) {
//							Serif_B=loadFont(Serif_B,font_type,"TIMESBD.TTF");
//						}
						if (Serif_B==null) {
							Serif_B=Serif;
						}
						wfldd[S][B]=true;
						return Serif_B.deriveFont(font_type,font_size);
					} else if (font_name.startsWith("Courier")||font_name.startsWith("Monospaced")) {
//						if (!wfldd[M][B]) {
//							Monospaced_B=loadFont(Monospaced_B,font_type,"COURBD.TTF");
//						}
						if (Monospaced_B==null) {
							Monospaced_B=Monospaced;
						}
						wfldd[M][B]=true;
						return Monospaced_B.deriveFont(font_type,font_size);
					}
				}
//				if (!wfldd[SS][B]) {
//					SansSerif_B=loadFont(SansSerif_B,font_type,"ARIALBD.TTF");
//				}
				if (SansSerif_B==null) {
					SansSerif_B=SansSerif;
				}
				wfldd[SS][B]=true;
				return SansSerif_B.deriveFont(font_type,font_size);
			case Font.BOLD+Font.ITALIC :
				if (font_name!=null) {
					if (font_name.startsWith("Times")||font_name.startsWith("Serif")) {
//						if (!wfldd[S][BI]) {
//							Serif_BI=loadFont(Serif_BI,font_type,"TIMESBI.TTF");
//						} 
						if (Serif_BI==null) {
							Serif_BI=Serif;
						}
						wfldd[S][BI]=true;
						return Serif_BI.deriveFont(font_type,font_size);
					} else if (font_name.startsWith("Courier")||font_name.startsWith("Monospaced")) {
//						if (!wfldd[M][BI]) {
//							Monospaced_BI=loadFont(Monospaced_BI,font_type,"COURBI.TTF");
//						}
						if (Monospaced_BI==null) {
							Monospaced_BI=Monospaced;
						}
						wfldd[M][BI]=true;
						return Monospaced_BI.deriveFont(font_type,font_size);
					}
				}
//				if (!wfldd[SS][BI]) {
//					SansSerif_BI=loadFont(SansSerif_BI,font_type,"ARIALBI.TTF");
//				}
				if (SansSerif_BI==null) {
					SansSerif_BI=SansSerif;
				}
				wfldd[SS][BI]=true;
				return SansSerif_BI.deriveFont(font_type,font_size);
			case Font.PLAIN :
			default :
				if (font_name!=null) {
					if (font_name.startsWith("Times")||font_name.startsWith("Serif")) {
//						if (!wfldd[S][P]) {
//							Serif=loadFont(Serif,Font.PLAIN,"TIMES.TTF");
//						}
						Font tmpFont = Serif.deriveFont(font_type,font_size);
						wfldd[S][P]=true;
						return tmpFont;
					} else if (font_name.startsWith("Courier")||font_name.startsWith("Monospaced")) {
//						if (!wfldd[M][P]) {
//							Monospaced=loadFont(Monospaced,Font.PLAIN,"COUR.TTF");
//						}
							wfldd[M][P]=true;
						return Monospaced.deriveFont(font_type,font_size);
					}
				}
//				if (!wfldd[SS][P]) {
//					SansSerif=loadFont(SansSerif,Font.PLAIN,"ARIAL.TTF");
//				}
				wfldd[SS][P]=true;
				return SansSerif.deriveFont(font_type,font_size);
		}
	}


/* ------------------------------ Font methods -------------------------------- */


	private Font awtfont;
	
	public Font getAwtFont() {
		return awtfont;
	}

	public Font getMathFont() {
		return MathFont().deriveFont(awtfont.getStyle(),awtfont.getSize());

	}
	
	public static void finishLoadingMathFont() {
		Font mf=MathFont();
	}

	public mjaFont() {
		awtfont=makeFont("SansSerif",Font.BOLD,14);
	}
	
	public mjaFont(String font_name,int font_type,int font_size) {
		awtfont=makeFont(font_name,font_type,font_size);
	}
	
	public mjaFont(Font f) {
		if (f!=null) {
			awtfont=makeFont(f.getName(),f.getStyle(),f.getSize());
		} else {
			awtfont=makeFont("SansSerif",Font.PLAIN,16);
		}
	}
	
	public int getAscent(Component C) {
		Graphics2D g = getGraphics(C);
		FontMetrics fm=C.getFontMetrics(awtfont);
		FontMetrics mfm=C.getFontMetrics(getMathFont());
		return Math.max(fm.getAscent(),mfm.getAscent());
	}
	
	public int getDescent(Component C) {
		Graphics2D g = getGraphics(C);
		FontMetrics fm=C.getFontMetrics(awtfont);
		FontMetrics mfm=C.getFontMetrics(getMathFont());
		return Math.max(fm.getDescent(),mfm.getDescent());
	}
	
	public Graphics2D getGraphics(Component C) {
		Graphics2D g = (Graphics2D) C.getGraphics();
		setRenderingHints(g);
	    return g;
	}

	public int stringWidth(Component C,String s) {
		return drawString(C,getGraphics(C),s,0,0,false);
	}
	
	public int drawString(Component C,Graphics2D g,String s,int x,int y) {
		return drawString(C,g,s,x,y,true);
	}
	
	private void setRenderingHints(Graphics2D g) {
		if(g == null)
			return;
		Object rhv=RenderingHints.VALUE_FRACTIONALMETRICS_OFF;
		if (BasicStr.osIsMac()) {
			rhv=RenderingHints.VALUE_FRACTIONALMETRICS_ON;
		}
	    g.setRenderingHint(RenderingHints.KEY_FRACTIONALMETRICS,rhv);
		if (g.getFont().getSize()<=17) {
			rhv=RenderingHints.VALUE_TEXT_ANTIALIAS_OFF;
		} else {
			rhv=RenderingHints.VALUE_TEXT_ANTIALIAS_ON;
		}
	    g.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING,rhv);
	}

	private int drawString(Component C,Graphics2D g,String s,int x,int y,boolean draw) {
		if ( s==null || g==null ) {
			return 0;
		}
		g.setFont(getAwtFont());
		setRenderingHints(g);
		FontMetrics fm=C.getFontMetrics(g.getFont());
		int w=0;
		char[] cha=new char[s.length()];
		s.getChars(0,s.length(),cha,0);
		boolean spch=false;
		for (int i=0;i<s.length();i++) {
			char ch=s.charAt(i);
			if (0x2135<=ch && ch<0x228f) {
				g.setFont(getMathFont());
				fm=C.getFontMetrics(g.getFont());
				spch=true;
			}
			if (draw) {
				g.drawChars(cha,i,1,(int) Math.round(x+w),y);
			}
			Rectangle2D rect = fm.getStringBounds(String.valueOf(ch),g);
			w+=(int) rect.getWidth();
			if (spch) {
				g.setFont(getAwtFont());
				fm=C.getFontMetrics(g.getFont());
				spch=false;
			}
		}
		return w;
	}
	public static void drawTextBorder(Graphics2D g2d,String text, Point p,Color color){
		
		Color textColor  = g2d.getColor(); 
		if (textColor!=null) {
			try {
				float diff = 
						Math.abs(textColor.getRed() - color.getRed())		+
						Math.abs(textColor.getGreen() - color.getGreen())	+
						Math.abs(textColor.getBlue() - color.getBlue());
				diff /= 255;
				float maxDiff = 0.5f; 
				if (diff < maxDiff) return;
			} catch (Exception ex) {
			}
		}
		
		Object antializaAnt = g2d.getRenderingHint(RenderingHints.KEY_ANTIALIASING);
		Object antializaTextAnt = g2d.getRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING);
		Object FRACTIONALMETRICS_ANT = g2d.getRenderingHint(RenderingHints.KEY_FRACTIONALMETRICS);
		
		//g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		//g2d.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
		//g2d.setRenderingHint(RenderingHints.KEY_FRACTIONALMETRICS, RenderingHints.VALUE_FRACTIONALMETRICS_ON);
		
		Color c = g2d.getColor(); 
		Font f = g2d.getFont();
		float strokeSize = f.getSize()/24;
		strokeSize = Math.max(Math.min(2f, strokeSize),1f);
		Stroke tmp = g2d.getStroke();
		g2d.setColor(color);
		boolean pintarPoligono = false;
		if(pintarPoligono){
			//Para pintar con el borde de java;
			FontRenderContext fontRenderContext = g2d.getFontRenderContext();
			TextLayout tl = new TextLayout(text,f,fontRenderContext);
			
			AffineTransform trans = AffineTransform.getTranslateInstance(p.x-0.2,p.y-0.2);
			
			Shape shapeStr = (Shape) tl.getOutline(trans);
			BasicStroke stroke = new BasicStroke(2f*strokeSize,BasicStroke.CAP_ROUND,BasicStroke.JOIN_ROUND);
			g2d.setStroke(stroke);
			g2d.fill(shapeStr);
			g2d.draw(shapeStr);
		} else {
			
			int nTextos = 12;
			double PI2 = 2*Math.PI;
			PI2 = 360;
			float paso = (float) (PI2/nTextos);
			for(float i = 0; i < PI2; i+=paso){
				float xDes = (float) (p.getX()+strokeSize*Math.cos(i));
				float yDes = (float) (p.getY()+strokeSize*Math.sin(i));
				g2d.drawString(text, xDes, yDes);
			}
		}
		g2d.setColor(c);
		g2d.setStroke(tmp);
		g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,antializaAnt);
		g2d.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING,antializaTextAnt);
		g2d.setRenderingHint(RenderingHints.KEY_FRACTIONALMETRICS, FRACTIONALMETRICS_ANT);
	}
}