/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.gui;
/*------------------------------------------------------------*/
/*                       MouseCursorHandler                   */
/*                          (c)  MJA                          */
/*                       Octubre de 2001                      */
/*              ltima actualizacin Octubre de 2002          */
/*------------------------------------------------------------*/
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.net.*;
import com.mja.file.mjaFont;

public class MouseCursorHandler implements MouseListener {


	Component parent;
	Explainer E;
	private Cursor qCursor;
	
	public boolean handEnabled=true;

	public MouseCursorHandler (Component parent,Explainer E) {
		this.parent=parent;
		this.E=E;
		URL	url=getClass().getResource("/resources/images/questionMark.png");
		Image img=Toolkit.getDefaultToolkit().getImage(url);
		MediaTracker mt=new MediaTracker(parent);
		mt.addImage(img,0);
		try {
			mt.waitForID(0);
		} catch (InterruptedException e) {
		}
		BufferedImage image=new BufferedImage(32,32,BufferedImage.TYPE_4BYTE_ABGR);
		Graphics g=image.getGraphics();
		g.setColor(new Color(0,0,0,0));
		g.fillRect(0,0,20,20);
		g.drawImage(img,8,5,parent);
		qCursor=Toolkit.getDefaultToolkit().createCustomCursor(image,new Point(16,16),"question");
	}


	public void setHand() {
//		parent.setCursor(new Cursor(Cursor.HAND_CURSOR));
		parent.setCursor(qCursor);
	}

	public void setWait() {
		parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
	}

	public void setNull() {
		parent.setCursor(null);
	}

	public boolean isHand() {
		if (parent.getCursor()==null) {
			return false;
		} else {
//			return parent.getCursor().getType()==Cursor.HAND_CURSOR;
			return parent.getCursor()==qCursor;
		}
	}

	public String getExplLabel(MouseEvent e) {
		return "";
	}

	public String getExplanation(MouseEvent e) {
		return "";
	}

	public void mousePressed(MouseEvent e) {
		if (isHand()) {
			e.consume();
		}
	}
	public void mouseReleased(MouseEvent e) {
//		   this should be in Mouse released to avoid selections to be performed and
//		   on the other hand to avoid sececting parts in text areas 
		if (
			e.getModifiers()==MouseEvent.BUTTON3_MASK
			|| (e.getSource() instanceof Label) 
//			|| handEnabled
//			|| isHand() 
			) {
//			if (isHand()) {
				e.consume();
//			}
			if (E!=null) {
				mjaText.msg((Component) e.getSource(),E.getExplLabel(e),E.getExplanation(e),mjaFont.AWTMonoB);
			}
//			if (isHand()) {
//				setNull();
//			}
			setNull();
		}
	}
	public void mouseClicked(MouseEvent e) {
		if (isHand()) {
			e.consume();
		}
	}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}

}