/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.gui;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.JTextField;
//import com.jla.nippe.AbstractNippe;
import com.mja.util.BasicStr;
import com.mja.file.mjaFile;
import com.mja.file.mjaFont;

public class mjaLabelAndText extends Panel implements ActionListener {
	
	private Label lb;
	private JTextField tf;

	public mjaLabelAndText(Component parent,double w1,double w2) {
		setBackground(new Color(0xe0e4e8));
		lb=new Label();
		lb.setAlignment(Label.CENTER);
		lb.setFont(mjaFont.AWTSansSerif);
		tf=new JTextField();
		tf.setBackground(Color.white);
		tf.addActionListener(this);
		tf.setFont(mjaFont.AWTMono);
		setLayout(new GridBagLayout());
		GridBagConstraints c=new GridBagConstraints();
		c.insets=new Insets(0,0,0,0);
		c.fill=GridBagConstraints.BOTH;
		c.gridx=0;  c.weightx=w1; add(lb,c);
		c.gridx+=1; c.weightx=w2; add(tf,c);
	}
	
	public void setInfo(String label,String value) {
		lb.setText(label);
		tf.setText(value);
	}
	
	public String getInfo() {
		return tf.getText();
	}

	private Vector listeners=new Vector();

	public void addActionListener(ActionListener c) {
		listeners.addElement(c);
	}

	public void removeActionListener(ActionListener c) {
		listeners.removeElement(c);
	}

	private void callListeners(String arg) {
		Enumeration e=listeners.elements();
		while (e.hasMoreElements()) {
			ActionListener al=(ActionListener) e.nextElement();
			al.actionPerformed(new ActionEvent(this,ActionEvent.ACTION_PERFORMED,arg));
		}
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==tf) {
			callListeners(tf.getText());
		}
	}

	public void updateFonts(int h1) {
		Font font=mjaFont.AWTMono;
		setFont(font);
		if (lb!=null) {
			lb.setFont(mjaFont.AWTSansSerif);
		}
		if (tf!=null) {
			tf.setFont(font);
		}
	}

}