/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.gui;

import java.awt.*;

public class mjaLayout {

	public static Panel flow(int hgap,int vgap,Component c) {
		return flow(FlowLayout.CENTER,hgap,vgap,c);
	}

	public static Panel fix(int hgap,int vgap,Component c) {
		Panel P=new Panel();
		P.setLayout(new GridLayout(1,1,hgap,vgap));
		P.add(c);
		return P;
	}

	public static Panel flow(int align,int hgap,int vgap,Component c) {
		Panel P=new Panel();
		P.setLayout(new FlowLayout(align,hgap,vgap));
		P.add(c);
		return P;
	}

	public static Panel pair(Component c1,Component c2) {
		Panel P=new Panel();
		P.setLayout(new GridLayout(1,2));
		P.add(c1);
		P.add(c2);
		return P;
	}

	public static Panel pair(double w1,double w2,Component c1,Component c2) {
		return pair(1,1,w1,w2,c1,c2);
	}

	public static Panel pair(int n1,int n2,double w1,double w2,Component c1,Component c2) {
		Panel P=new Panel();
		P.setLayout(new GridBagLayout());
		GridBagConstraints c=new GridBagConstraints();
		c.fill=GridBagConstraints.BOTH;
		c.gridx=0; c.gridwidth=n1; c.weightx=w1; P.add(c1,c);
		c.gridx=n1; c.gridwidth=n2;c.weightx=w2; P.add(c2,c);
		return P;
	}

	public static Panel triplet(double w1,double w2,double w3,Component c1,Component c2,Component c3) {
		return triplet(1,1,1,w1,w2,w3,c1,c2,c3);
	}

	public static Panel triplet(int n1,int n2,int n3,double w1,double w2,double w3,Component c1,Component c2,Component c3) {
		Panel P=new Panel();
		P.setLayout(new GridBagLayout());
		GridBagConstraints c=new GridBagConstraints();
		c.fill=GridBagConstraints.BOTH;
		c.gridx=0; c.gridwidth=n1; c.weightx=w1; P.add(c1,c);
		c.gridx=n1; c.gridwidth=n2;c.weightx=w2; P.add(c2,c);
		c.gridx=n1+n2; c.gridwidth=n3;c.weightx=w3; P.add(c3,c);
		return P;
	}

}