/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.gui;

import java.util.*;
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.net.*;
import javax.swing.*;
//import com.mja.cmp.mjaButton;
import com.mja.file.mjaFont;
import com.mja.util.BasicStr;

public class mjaText {

	public static final int center=0,top_left=1,top=2,top_right=3,
					left=4,right=5,bottom_left=6,bottom=7,bottom_right=8;
	private static editFrame showTextEF;
	private static TextArea showTextTA;

	public static void showPlainText(Frame pf,String title,String text) {
		editDialog ed_rtf=new editDialog(pf,title,true,"   Ok   ",null);
		TextArea tA=new TextArea(20,80);
		ed_rtf.add("Center",tA);
		tA.setFont(mjaFont.AWTMono);
		tA.setText(text);
		ed_rtf.display(true);
		ed_rtf.dispose();
	}

	static public void showPlainTextFrame(String title,String text) {
		showPlainTextFrame(title,"   Ok   ",text,20,80,false);
	}

	static public void showPlainTextFrame(String title,String ok,String text,int rows,int cols,boolean editable) {
		if (showTextEF!=null) {
			showTextEF.dispose();
			showTextEF=null;	
		}
		showTextEF=new editFrame(title,ok,null,null);
		showTextEF.pack=true;
		showTextTA=new TextArea(rows,cols);
		showTextEF.add("Center",showTextTA);
		showTextTA.setEditable(editable);
		showTextTA.setFont(mjaFont.AWTMono);
		showTextTA.setText(text);
		showTextEF.display(true);
		showTextEF.requestFocus();
	}
	
	public static void destroy() {
		if (showTextEF!=null) {
			showTextEF.dispose();
			showTextEF=null;	
		}
	}

	public static void msg(Component c,String title,String msg) {
		msg(c,title,msg,mjaFont.AWTMonoB);
	}

	public static void msg(Component c,String title,String msg,Font font) {
//		int w=800/font.getSize();
		Font origfont=c.getFont();
		c.setFont(font);
		FontMetrics fm=c.getFontMetrics(font);
		int w=480/fm.stringWidth("m");
		c.setFont(origfont);
		msg(c,title,16,w,true,msg,"ok",font,center);
	}

	public static void msg(Component c,String title,String msg,Font font,int loc) {
//		int w=800/font.getSize();
		Font f0=c.getFont();
		c.setFont(font);
		FontMetrics fm=c.getFontMetrics(font);
		int w=480/fm.stringWidth("m");
		c.setFont(f0);
		msg(c,title,16,w,true,msg,"ok",font,loc);
		c.setFont(f0);
	}

	public static void msg(Component c,String title,int rows,int columns,boolean nlap,String msg,String yesLbl,Font font,int loc) {
		Point p;
		Dimension d;
		if (c!=null) {
			p=c.getLocationOnScreen();
			d=c.getSize();
		} else {
			p=new Point(0,0);
			d=Toolkit.getDefaultToolkit().getScreenSize();
		}
		switch (loc) {
		case top_left :		p.x-=0;				p.y-=0; break;
		case top :			p.x+=d.width/2;		p.y-=0; break;
		case top_right :	p.x+=d.width;		p.y-=0; break;

		case left :			p.x-=0;				p.y+=d.height/2; break;
		case center :		p.x+=d.width/2;		p.y+=d.height/2; break;
		case right :		p.x+=d.width;		p.y+=d.height/2; break;

		case bottom_left :	p.x-=0;				p.y+=d.height; break;
		case bottom:		p.x+=d.width/2;		p.y+=d.height; break;
		case bottom_right :	p.x+=d.width;		p.y+=d.height; break;

		default : p.x+=d.width/2; 			p.y+=d.height/2; break;
		}
		msg(p,title,rows,columns,nlap,msg,yesLbl,font);
	}

	private static void msg(Point p,String title,int rows,int columns,boolean nlap,String msg,String yesLbl,Font font) {
		Frame F=new Frame();
		editDialog ed=new editDialog(F,title,true,yesLbl,null);
		Panel P=new Panel();
//		P.setBackground(Color.lightGray);
		P.setBackground(new Color(0xc4c8cc));
		P.setLayout(new FlowLayout());
		Dimension d=new Dimension();
		TextArea TA=new TextArea("",rows,columns+1,TextArea.SCROLLBARS_VERTICAL_ONLY);
		TA.setFont(font);
		String adjmsg=BasicStr.adjust(msg,columns,d,nlap,TA.getFontMetrics(font));
		TA.setRows(Math.min(d.height+1,rows));
		TA.setText(adjmsg);
		TA.setEditable(false);
		TA.setForeground(mjaColor.DeepBlue);
		TA.setBackground(Color.white);
		P.add(TA);
		ed.add("Center",P);
		ed.pack();
		ed.setSize(ed.getSize().width+32,ed.getSize().height+8);
		Dimension dim=ed.getSize();
		Point q=new Point(p.x-dim.width/2,p.y-dim.height/2);
		q.x=Math.max(0,q.x);
		q.y=Math.max(0,q.y);
		Dimension scrsz=Toolkit.getDefaultToolkit().getScreenSize();
		q.x=Math.min(scrsz.width-dim.width,q.x);
		q.y=Math.min(scrsz.height-dim.height,q.y);
		ed.setLocation(q.x,q.y);
		ed.show();
		ed.dispose();
		F.dispose();
	}

	public static boolean ask (String title,String msg,String yesLbl,String noLbl) {
		return ask(title,3,40,msg,yesLbl,noLbl);
	}

	public static boolean ask (String title,int rows,int columns,String msg,String yesLbl,String noLbl) {
		return ask(title,rows,columns,msg,yesLbl,noLbl,mjaFont.AWTMono.deriveFont(Font.BOLD,12));
	}

	public static boolean ask (String title,int rows,int columns,String msg,String yesLbl,String noLbl,Font font) {
		Frame F=new Frame();
		editDialog ed=new editDialog(F,title,true,yesLbl,noLbl);
		Panel P=new Panel();
		P.setLayout(new FlowLayout());
		JTextArea TA=new JTextArea(rows,columns);
		TA.setText(msg);
		TA.setFont(font);
		TA.setEditable(false);
		P.add(TA);
		ed.add("Center",P);
		ed.display();
		boolean ok=ed.ok;
		ed.dispose();
		F.dispose();
		F=null;
		return ok;
	}

	public static String getInfo(String title,String msg,String yesLbl,String noLbl,String[] options,String defaultValue,boolean allowNew) {
		getInfoDlg gid=new getInfoDlg(title,msg,true,false,"",yesLbl,noLbl);
		gid.allowNew=allowNew;
		gid.textField[0].setText(defaultValue);
		gid.textField[0].setEnabled(allowNew);
		gid.textField[0].setBackground(Color.white);
		gid.textField[0].setForeground(Color.black);
		gid.useComboBox(0,options);
		gid.setVisible(true);
		String value=null;
		if (gid.value!=null && gid.value.length>0) {
			value=gid.value[0];
		}
		gid.dispose();
		return value;
	}

	public static String getInfo(String title,String msg,String yesLbl,String noLbl,boolean hidden,String content) {
		getInfoDlg gid=new getInfoDlg(title,msg,true,hidden,content,yesLbl,noLbl);
		gid.setVisible(true);
		String value=null;
		if (gid.value!=null && gid.value.length>0) {
			value=gid.value[0];
		}
		gid.dispose();
		return value;
	}

	public static String[] getInfo(String title,String[] msg,String yesLbl,String noLbl) {
		boolean[] editable=new boolean[msg.length];
		boolean[] hidden=new boolean[msg.length];
		String[] content=new String[msg.length];
		for (int i=0;i<msg.length;i++) {
			editable[i]=false;
			hidden[i]=false;
			content[i]="";
		}
		return getInfo(title,msg,yesLbl,noLbl,editable,hidden,content);
	}

	public static String[] getInfo(String title,String[] msg,String yesLbl,String noLbl,boolean[] editable,boolean[] hidden,String[] content) {
		getInfoDlg gid=new getInfoDlg(title,msg,editable,hidden,content,yesLbl,noLbl);
		gid.setVisible(true);
		String[] value=gid.value;
		gid.dispose();
		return value;
	}

}

class getInfoDlg extends Dialog implements ActionListener, ItemListener, Runnable, WindowListener {

	public String[] value;

	boolean allowNew;
	TextField[] textField;

	private static final Font monof=new Font("SansSerif",Font.PLAIN,18);
	private static final int NormalText=0,PasswordText=1;
	private Label[] label;
	private JComboBox[] combos;
	private String[] message,defaultValue;
	private boolean[] hide,editable;
	private JButton ok_b, cancel_b;
	private Thread thr;
	private String[][] options;
	private boolean pleaseStop=false;
	private String[] textstr=null;

	getInfoDlg(String title,String message,boolean editable,boolean hide,String defaultValue,String accept,String cancel) {
		this(title,BasicStr.toArr(message),BasicStr.toArr(editable),BasicStr.toArr(hide),BasicStr.toArr(defaultValue),accept,cancel);
	}

	getInfoDlg(String title,String[] message,boolean[] editable,boolean[] hide,String[] defaultValue,String accept,String cancel) {
		super(new Frame());
		setFont(monof);
		setModal(true);
		setTitle(title);
		setBackground(new Color(0xe0eaef));
		setLayout(new GridLayout(message.length+3,1,0,0));
		label = new Label[message.length];
		combos=new JComboBox[message.length];
		options=new String[message.length][];
		textField=new TextField[message.length];
		for (int i=0;i<message.length;i++) {
			label[i]=new Label(message[i]);
			label[i].setAlignment(Label.RIGHT);
			textField[i]=new TextField(40-message[i].length());
			textField[i].setFont(monof);
			textField[i].addActionListener(this);
			if (editable[i] || BasicStr.arrayContains(message,defaultValue[i])) {
				textField[i].setText(defaultValue[i]);
			} else {
				textField[i].setText("");
			}
		}
		ok_b=new JButton(accept);
		cancel_b=new JButton(cancel);
		ok_b.addActionListener(this);
		cancel_b.addActionListener(this);
		this.editable=editable;
		this.hide=hide;
		this.message=message;
		this.defaultValue=defaultValue;
		addWindowListener(this);
	}
	
	void useComboBox(int ix,String[] options) {
		this.options[ix]=options;
		combos[ix]=new JComboBox();
		combos[ix].setFont(monof);
		combos[ix].addItem("");
		combos[ix].setLightWeightPopupEnabled(false);
		String defaultValue=textField[ix].getText();
		for (int i=0;i<options.length;i++) {
			combos[ix].addItem(options[i]);
		}
		if (!"".equals(defaultValue) && !BasicStr.arrayContains(options,defaultValue) && editable[ix]) {
			combos[ix].addItem(defaultValue);
		}
		if (!"".equals(defaultValue) && (BasicStr.arrayContains(options,defaultValue)|| editable[ix])) {
			textField[ix].setText(defaultValue);
			combos[ix].setSelectedItem(defaultValue);
		}
		combos[ix].addActionListener(this);
	}
	
	boolean selectionsInList() {
		for (int i=0;i<textField.length;i++) {
			if (options[i]!=null) {
				String test=(String) combos[i].getEditor().getItem();
				boolean ok=false;
				for (int j=0;j<options[i].length;j++) {
					if (test.length()>0 && test.equals(options[i][j])) {
						value[i]=test;
						ok=true;
						break;
					}
				}
				if (!ok) {
					return false;
				}
			}
		}
		return true;
	}

	public void setVisible(boolean visible) {
		if (visible) {
			value = new String[textField.length];
			add(new Canvas());
			for (int i=0;i<textField.length;i++) {
				Panel pi=new Panel();
				pi.setLayout(new FlowLayout(FlowLayout.LEFT,16,0));
				if (hide[i]) {
					textField[i].setEchoChar('*');
				}
				pi.add(label[i]);
				if (combos[i]!=null) {
					combos[i].setEditable(editable[i]);
					combos[i].addItemListener(this);
					pi.add(combos[i]);
				} else {
					pi.add(textField[i]);
				}
				add(pi);
			}
			add(new Canvas());
			Panel sp=new Panel();
			sp.setLayout(new FlowLayout(FlowLayout.CENTER,64,8));
			sp.setBackground(new Color(0xcacaca));
			sp.add(ok_b);
			sp.add(cancel_b);
			add(sp);
			pack();
			Dimension d=getSize();
			Dimension sz=Toolkit.getDefaultToolkit().getScreenSize();
			setLocation((sz.width-d.width)/2,(sz.height-d.height)/2);
		} else {
			pleaseStop=true;
		}
		super.setVisible(visible);
	}
	
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() instanceof TextField || e.getSource()==ok_b) {
			for (int i=0;i<textField.length;i++) {
				value[i]=textField[i].getText();
			}
		} else if (e.getSource()==cancel_b) {
			value=null;
		} else {
			for (int i=0;i<combos.length;i++) {
				if (e.getSource()==combos[i]) {
					textField[i].setText((String) combos[i].getSelectedItem());
				}
			}
		}
		if ( (e.getSource()==ok_b) || (textField.length==1&&((e.getSource() instanceof TextField)||(e.getSource() instanceof JComboBox)))) {
			if (allowNew || selectionsInList()) {
				setVisible(false);
			}
		} else if (e.getSource()==cancel_b) {
			setVisible(false);
		}
	}
		
	public void itemStateChanged(ItemEvent e) {
		if (e.getSource() instanceof JComboBox && combos.length==1) {
			for (int i=0;i<combos.length;i++) {
				if (e.getSource()==combos[i]) {
					textField[i].setText((String) combos[i].getSelectedItem());
				}
			}
			for (int i=0;i<textField.length;i++) {
				value[i]=textField[i].getText();
			}
			if (allowNew || selectionsInList()) {
				setVisible(false);
			}
		}
	}

	public void run() {
		try {
			while (!pleaseStop) {
				Thread.sleep(100);
				if (pleaseStop) {
					break;
				}
				if (textstr==null) {
					textstr=new String[combos.length];
					for (int i=0;i<combos.length;i++) {
						textstr[i]="";
					}
					for (int i=0;i<combos.length;i++) {
						if (combos[i]!=null && combos[i].getEditor().getItem()!=null) {
							textstr[i]=(String) combos[i].getEditor().getItem();
						}
					}
				}
				for (int i=0;i<combos.length;i++) {
					if (combos[i]!=null) {
						String test=(String) combos[i].getEditor().getItem();
						if (!textstr[i].equals(test)) {
							textstr[i]=(String) combos[i].getEditor().getItem();
							combos[i].hidePopup();
							combos[i].removeActionListener(this);
							combos[i].removeItemListener(this);
							combos[i].removeAllItems();
							for (int j=0;j<options[i].length;j++) {
								if (options[i][j].toLowerCase().startsWith(textstr[i].toLowerCase())) {
									combos[i].addItem(options[i][j]);
								}
							}
							combos[i].setMaximumRowCount(8);
							combos[i].getEditor().setItem(textstr[i]);
							((JTextField) combos[i].getEditor().getEditorComponent()).setCaretPosition(textstr[i].length());
							combos[i].addItemListener(this);
							combos[i].addActionListener(this);
							combos[i].repaint();
							try {
								combos[i].showPopup();
								combos[i].repaint(0);
								paintAll(getGraphics());
							} catch (Exception ex) {
								ex.printStackTrace();
							}
						}
					}
				}
			}
		} catch(InterruptedException e) {
			e.printStackTrace();
		}
	}
	
	public void windowOpened(WindowEvent we) {
		thr=new Thread(this);
		thr.start();
	}
	public void windowClosing(WindowEvent we) {
		setVisible(false);
	}
	public void windowClosed(WindowEvent we) {
	}
	public void windowActivated(WindowEvent we) {
	}
	public void windowDeactivated(WindowEvent we) {
	}
	public void windowIconified(WindowEvent we) {
	}
	public void windowDeiconified(WindowEvent we) {
	}


}