/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.lang;

import java.awt.print.Printable;

import com.mja.util.PropertiesManager;

/*------------------------------------------------------------*/
/*                         Expl                               */
/*                        (c) MJA                             */
/* Creacin:             Agosto de 2003                       */
/* ltima actualizacin: Junio  de 2010                       */
/*------------------------------------------------------------*/


public class Expl {
	
	public static String[] langs; // = {"catala","english","espanol","euskera","galego","francais","portugues","valencia"};
	public static String pathBase = "/resources/idiomas/";
	
	public static String[][] Edit;
	public static String[][] Code;
	public static String[][] List;
	public static String[][] Panels;
	public static String[][] ButtonsDefault;
	public static String[][] Buttons;
	public static String[][] Space;
	public static String[][] Control;
	public static String[][] Aux;
	public static String[][] GraphR2;
	public static String[][] GraphR3;	
	public static String[][] MacroPair;
	public static String[] Animation;
	public static String[][] Anim;
	public static String[] Help;
	public static String[][] EditColor;
	public static String[] LMS;
	public static String[] Course;
	public static String[] Unit;
	public static String[][] EditText;
	public static String[][] EditFormula;
	public static String[][] EditExpression;
	public static String[][] SymbolsTable;
	public static String[][] AlgebraTutor;
	
		
	public static boolean inited=false;
	private static Object O;

	public static void init(Object Ob,boolean useExplanations) {
		O=Ob;
		if (!inited) {
			if (useExplanations) {
				Edit			= getAllLangAndPropertiesDouble("Edit.properties", IndexProperties.Edit);
				Code			= getAllLangAndPropertiesDouble("Code.properties", IndexProperties.Code);
				List			= getAllLangAndPropertiesDouble("List.properties", IndexProperties.List);
				Panels			= getAllLangAndPropertiesDouble("Panels.properties", IndexProperties.Panels);
				ButtonsDefault	= getAllLangAndPropertiesDouble("ButtonsDefault.properties", IndexProperties.ButtonsDefault);
				Buttons			= getAllLangAndPropertiesDouble("Buttons.properties", IndexProperties.Buttons);
				Space			= getAllLangAndPropertiesDouble("Space.properties", IndexProperties.Space);
				Control			= getAllLangAndPropertiesDouble("Control.properties", IndexProperties.Control);
				Aux				= getAllLangAndPropertiesDouble("Auxiliar.properties", IndexProperties.Auxiliar);
				GraphR2			= getAllLangAndPropertiesDouble("GraphR2.properties", IndexProperties.GraphR2);
				GraphR3			= getAllLangAndPropertiesDouble("GraphR3.properties", IndexProperties.GraphR3);	
				MacroPair		= getAllLangAndPropertiesDouble("MacroPair.properties", IndexProperties.MacroPair);
				Animation		= getAllLangAndPropertiesSimple("Animation.properties", IndexProperties.Animation);
				Anim			= getAllLangAndPropertiesDouble("Anim.properties", IndexProperties.Anim);
				Help			= getAllLangAndPropertiesSimple("Help.properties", IndexProperties.Help);
				EditColor		= getAllLangAndPropertiesDouble("EditColor.properties", IndexProperties.EditColor);
				LMS				= getAllLangAndPropertiesSimple("LMS.properties", IndexProperties.LMS);
				Course			= getAllLangAndPropertiesSimple("Course.properties", IndexProperties.Course);
				Unit			= getAllLangAndPropertiesSimple("Unit.properties", IndexProperties.Unit);
				EditText		= getAllLangAndPropertiesDouble("EditText.properties", IndexProperties.EditText);
				EditFormula		= getAllLangAndPropertiesDouble("EditFormula.properties", IndexProperties.EditFormula);
				EditExpression	= getAllLangAndPropertiesDouble("EditExpression.properties", IndexProperties.EditExpression);
				SymbolsTable	= getAllLangAndPropertiesDouble("SymbolsTable.properties", IndexProperties.SymbolsTable);
				AlgebraTutor	= getAllLangAndPropertiesDouble("AlgebraTutor.properties", IndexProperties.AlgebraTutor);
				inited=true;
			} else {
			}
		}
	}

	private static String[][] getAllLangAndPropertiesDouble(String $file, String[] $index) {
//System.out.println($file);
		String[][] obj = new String[langs.length][];
		for(int i = 0; i < langs.length; i++) {
			obj[i] = PropertiesManager.getAllProperties(O, pathBase + langs[i] + "/" + $file, $index);
		}
		String[][] result=new String[obj[0].length][langs.length];
		for (int i=0;i<langs.length;i++) {
			for (int j=0;j<obj[i].length;j++) {
				result[j][i]=obj[i][j];
			}
		}
		for (int i=0;i<langs.length;i++) {
			for (int j=0;j<obj[i].length;j++) {
				if ( (result[j][i]==null) || (result[j][i].length()==0) ) {
					result[j][i]=result[j][1];
				}
			}
		}
		return result;
	}
	
	private static String[] getAllLangAndPropertiesSimple(String $file, String[] $index) {	
		String[] obj = new String[langs.length];
		for(int i = 0; i < langs.length; i++) {
			obj[i] = PropertiesManager.getAllProperties(O,pathBase + langs[i] + "/" + $file, $index)[0];
		}
		return obj;
	}

	public static String get(String[] explarr,int i) {
		if (inited && explarr!=null && explarr.length>i) {
			if ("0".equals(explarr[i])) {
				return explarr[1];
			} else if ("1".equals(explarr[i])) {
				return explarr[1];
			} else if ("2".equals(explarr[i])) {
				return explarr[2];
			} else if ("3".equals(explarr[i])) {
				return explarr[3];
			} else {
				return explarr[i];
			}
		} else {
			return "";
		}
	}
}

class IndexProperties {
	
	public static String[] Animation = {"text"};
	
	public static String[] Help = {"text"};
	
	public static String[] LMS = {"text"};
	
	public static String[] Course = {"text"};

	public static String[] Unit = {"text"};
	
	public static String[] Edit = {
		"language-select",
		"undo-activate",
		"b_original",
		"b_undo",
		"b_redo",
		"b_new",
		"b_code",
		"b_macro",
		"b_help"
	};

	public static String[] Code = {
		"name",
		"codebase",
		"width",
		"height",
		"HTMLencoding",
		"pop",
		"bwidth",
		"bheight",
		"b_apply"
	};

	public static String[] List = {
		"0=B_add",
		"1=B_duplicate",
		"2=B_delete",
		"3=tlbl",
		"4=up-down"
	};

	public static String[] Panels = {
		"0=Buttons",
		"1=Spaces",
		"2=Controls",
		"3=Auxiliaries",
		"4=Graphs",
		"5=Graphs3D",
		"6=Animation"
	};

	public static String[] ButtonsDefault = {
		"0=Crditos",
		"1=Config",
		"2=Inicio",
		"3=Limpiar",
		"4=Anim",
		"5=IniAnim"
	};

	public static String[] Buttons = {
		"0=Crditos",
		"1=Config",
		"2=Inicio",
		"3=Limpiar",
		"4=rowsNorth",
		"5=rowsSouth",
		"6=widthEast",
		"7=widthWest",
		"8=rowsHeight",
		"9=editor",
		"10=audio",
		"11=algebra",
		"12=RAD",
		"13=infoInd",
		"14=infoEst",
		"15=decsymb",
		"16=antialias"
	};

	public static String[] Space = {
		"spaceType",
		"id",
		"left",
		"top",
		"width",
		"height",
		"cond",
		"fixed",
		"scale",
		"Ox",
		"Oy",
		"bgimage",
		"bgdisplay",
		"BACKGROUND",
		"NET",
		"NET10",
		"AXES",
		"TEXT",
		"numbers",
		"x_axis",
		"y_axis",
		"render",
		"split",
		"mousem",
		"controles",
		"rbol",
		"sensible (el rbol)",
		"paso",
		"fonttype",
		"fontsize",
		"signo de multiplicacin",
		"parntesis siempre",
		"decimales",
		"guiado",
		"modo",
		"ecuacin",
		"ejercicios"
	};

	public static String[] Control = {
		"id",
		"type",
		"gui",
		"onlytext",
		"region",
		"space",
		"color",
		"icolor",
		"size",
		"name",
		"expr",
		"value",
		"constraint",
		"text",
		"buttons",
		"solution",
		"incr",
		"inf",
		"sup",
		"discrete",
		"decimals",
		"fixed",
		"notexp",
		"visible",
		"trace",
		"fgcol",
		"bgcol",
		"bold",
		"italic",
		"underline",
		"fontsize",
		"drawbg",
		"image",
		"options",
		"action",
		"param",
		"condvis",
		"condactiv",
		"evaluation",
		"answer",
		"weight",
		"tooltip",
		"expl",
		"msgloc",
		"controlID"
	};

	public static String[] Auxiliar = {
		"id",
		"alg (internal)",
		"constant (internal)",
		"array (internal)",
		"matrix (internal)",
		"sequence (internal)",
		"event (internal)",
		"expr",
		"evaluate",
		"size",
		"columns",
		"rows",
		"range",
		"alg",
		"expr2",
		"localvars",
		"ini",
		"do",
		"while",
		"condition",
		"action",
		"parameter",
		"execution",
		"msg_pos",
		"editable",
		"file"
	};

	public static String[] GraphR2 = {
		"space",
		"type",
		"background",
		"color",
		"cond",
		"coord_abs",
		"macro",
		"expr",
		"center",
		"radius",
		"ini",
		"end",
		"vectors",
		"trace",
		"family",
		"family-2",
		"interval",
		"steps",
		"parameter",
		"interval",
		"steps",
		"text",
		"decimals",
		"fixed",
		"fill",
		"fillplus",
		"fillminus",
		"size",
		"width",
		"widthness",
		"spear",
		"arrow",
		"visible",
		"editable",
		"range",
		"file",
		"animated",
		"animation frequency",
		"inirot",
		"inipos",
		"rotation",
		"location",
		"name",
		"info"
	};

	public static String[] GraphR3 = {
		"name",
		"space",
		"type",
		"background",
		"color",
		"backColor",
		"cond",
		"macro",
		"expr",
		"is_family",
		"family_param",
		"family_interval",
		"family_steps",
		"inirot",
		"inipos",
		"split",
		"finrot",
		"finpos",
		"edges",
		"text",
		"decimals",
		"fixed",
		"model",
		"widthness",
		"ancho",
		"largo",
		"alto",
		"Nu",
		"Nv",
		"rotation",
		"location"
	};

	public static String[] MacroPair = {
		"Aux",
		"Doc"
	};

	public static String[] Anim = {
		"pausa",
		"controles",
		"auto",
		"repetir",
		"init",
		"do",
		"while"
	};

	public static String[] EditColor = {
		"transp",
		"red",
		"green",
		"blue",
		"copy",
		"paste",
		"help",
		"color by name",
		"color actual"
	};

	public static String[] EditText = {
		"type",
		"1 size",
		"2 bold",
		"3 italic",
		"4 underline",
		"5 overline",
		"6 edit",
		"7 show",
		"8 color",
		"9 help",
		"10 unicode",
		"11 formula",
		"12 RTF",
		"13 Insert Char",
		"14 Select symbol/greek",
		"15 char in hex TextField tf",
		"16 img",
		"17 hl",
		"18 ctrl",
		"19 text_",
		"20 text__",
		"21 text___",
		"22 menu",
		"23 barra",
		"24 button",
		"25 spR2",
		"26 spR3",
		"27 spTA"
	};

	public static String[] EditFormula = {
		"0 fraction",
		"1 superindex",
		"2 radical (square root)",
		"3 sum",
		"4 integral",
		"5 limit",
		"6 matrix",
		"7 defparts",
		"8 expresion",
		"9 subindex"
	};

	public static String[] EditExpression = {
		"decimals",
		"fixed",
		"help",
		"expression"
	};

	public static String[] SymbolsTable = {
		"UNICODE",
		"help",
		"all characters",
		"Alphabet List",
		"Base UNICODE"
	};

	public static String[] AlgebraTutor = {
		"0 b_bh",
		"1 b_help",
		"2 b_toappl",
		"3 b_add",
		"4 b_insert",
		"5 b_delete",
		"6 b_undo",
		"7 V",
		"8 S",
		"9 Config",
		"10 EB",
		"11 Enunciado del ejercicio",
		"12 1 Frmula EditorCanvas",
		"13 EditorCanvas",
		"14 (Formula) EditorCanvas",
		"15 lb_title"
	};
}