/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free softwareMTXTOSTR; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.parser;

import com.mja.util.BasicStr;
import java.util.Vector;
import java.util.Enumeration;
import java.util.StringTokenizer;
import com.mja.text.Formula;
import com.mja.text.TNode;
import java.awt.Component;

public class Node {
	
	public Parser parser;

	public static boolean inAlgebraTutor=false;

	static final double epsilon=0.000001;
	static final String derivation_symbol="";
	
	public static Component C=null;

	public Node ns;
	boolean sequence=false;
	boolean evOnce;
	boolean predefined=false;
	String filename="";
	int level=0;
	public boolean format=false;
	double[] rarray;
	String[] sarray;
	private Node[] Narray;
	double[][] rmatrix;
	String[][] smatrix;
	Node[] var;
	Node[] localVarsList;
	Node parent;
	protected Node left;
	Node range,func,size,arr,nrows,ncols;
	protected Node[] right;
	protected int type;
	protected int symb;
	protected String symbstr="";
	Algorithm alg;
	private boolean error;
	private int errType;
	private String s;
	private double r;
	
	public static final int // SYMBOL
		END    = 0,SEP   = 1,LP    = 2,COMA   =3,RP    = 4,
		ASSIGN = 5, IF =6, THENELSE= 7,
		RND   = 8,IGUAL = 9,NOI    =10,
		OR     =11,AND   =12,MEN   =13,MAY   =14,
		MEOI   =15,MAOI  =16,MAS   =17,MENOS =18, MASMEN=19,
		POR    =20,DIV   =21,EXPON =22,MOD   =23,
		NO     =24,SQR   =25,SQRT  =26,EXP   =27,
		LOG    =28,LOG10 =29,ABS   =30,ENT   =31, 
		SGN    =32,IND   =33,SIN   =34,COS   =35,
		TAN    =36,COT   =37,SEC   =38,CSC   =39,
		SINH   =40,COSH  =41,TANH  =42,SECH  =43,
		CSCH   =44,COTH  =45,ASIN  =46,ACOS  =47,
		ATAN   =48,
		/* ACOT  =49,ASEC  =50,ACSC  =51,
		ASINH  =52,ACOSH =53,ATANH =54,ACOTH =55,
		ASECH  =56,ACSCH =57,FAC   =58, SUMN   =59, */
		SUMA   =60,
		MIN    =61, MAX  =62, isok=63, isOk=64, 
		FUNC   =71, DER  =72,
		ARRAY  =73,
		MATRIX =74,
		VAR    =75,
		EQN    =76,
		EQA    =77,
		EQX    =78,
		NUM    =79,
		EXPR   =80,
		EVAL   =81,
		NUMB   =82,
		ROOT   =83,
		ENT_ANT=84,
		SAVE   =85,
		LOAD   =86,
		EXEC   =87,
		GETVAL =88,
		GETVEC =89,
		GETMTX =90,
		MTXTOSTR =91,
		STRTOMTX =92,
		STRTOVEC =93,
		VECTOSTR =94,
		EXECSTR = 95,
		EXEBLOCK= 96,
		NUMTOSTR= 97,
		STRWDTH = 98,
		RED = 99,
		GREEN = 100,
		BLUE = 101,
		CHARAT=102,
		SUBSTR=103,
		STRLENGTH=104,
		IXOF  =105,
		PRNT =106,
		NOOP   =107;
	
	public String getStringValue() {
		return getStringValue(16,false);
	}

	public String getStringValue(int precision,boolean fixed) {
		if (s!=null) {
			return s;
		} else {
			return BasicStr.DoubleToString(Evaluate(0.0),precision,fixed);
		}
	}
	
	public String getString() {
		if (s!=null) {
			return "'"+s+"'";
		} else {
			return BasicStr.DoubleToString(Evaluate(0.0),16,false);
		}
	}
	
	public Node cloneNode() {
		Node n=new Node(parser,type,symb,symbstr);
		n.r=r;
		if (s!=null) {
			n.s=new String(s);
			n.ns=ns;
		}
		n.size=size;
		n.var=var;
		n.localVarsList=localVarsList;
		n.sequence=sequence;
		n.evOnce=evOnce;
		n.format=format;
		n.rarray=rarray;
		if (sarray!=null) {
			n.sarray=new String[sarray.length];
			for (int i=0;i<sarray.length;i++) {
				n.sarray[i]=new String(sarray[i]);
			}
		}
		n.rmatrix=rmatrix;
		if (smatrix!=null) {
			int n1=smatrix.length;
			if (n1>0) {
				int n2=smatrix[0].length;
				n.smatrix=new String[n1][n2];
				for (int j=0;j<n2;j++) {
					for (int i=0;i<n1;i++) {
						n.smatrix[i][j]=new String(smatrix[i][j]);
					}
				}
			}
		}
		n.Narray=Narray;
		n.var=var;
		n.range=range;
		n.func=func;
		n.arr=arr;
		n.nrows=nrows;
		n.ncols=ncols;
		n.alg=alg;
		n.left=null;
		if (left!=null) {
			n.left=left.cloneNode();
		}
		n.right=null;
		if (right!=null) {
			n.right=new Node[right.length];
			for (int i=0;i<right.length;i++) {
				n.right[i]=null;
				if (right[i]!=null) {
					n.right[i]=right[i].cloneNode();
				}
			}
		}
		return n;
	}

	public Node getParent(Node N) {
		if (N==null) {
			return null;
		}
		if (this==N) {
			return null;
		}
		if (left!=null) {
			if (left==N) {
				return this;
			} else {
				Node aux=left.getParent(N);
				if (aux!=null) {
					return aux;
				}
			}
		}
		if (right!=null) {
			for (int i=0;i<right.length;i++) {
				if (right[i]!=null) {
					if (right[i]==N) {
						return this;
					} else {
						Node aux=right[i].getParent(N);
						if (aux!=null) {
							return aux;
						}
					}
				}
			}
		}
		return null;
	}

	public boolean contains(Node N) {
		if (N==null) {
			return false;
		}
		if (this==N) {
			return true;
		}
		if (left!=null) {
			if (left==N|| left.contains(N)) {
				return true;
			}
		}

		if (right!=null) {
			for (int i=0;i<right.length;i++) {
				if (right[i]!=null) {
					if (right[i]==N||right[i].contains(N)) {
						return true;
					}
				}
			}
		}
		return false;
	}

	public boolean ContainsACopyOf(Node N) {
		if (N==null) {
			return false;
		}
		if (this.equals(N)) {
			return true;
		}
		if (left!=null) {
			if (left.equals(N)|| left.ContainsACopyOf(N)) {
				return true;
			}
		}

		if (right!=null) {
			for (int i=0;i<right.length;i++) {
				if (right[i]!=null) {
					if (right[i].equals(N)||right[i].ContainsACopyOf(N)) {
						return true;
					}
				}
			}
		}
		return false;
	}

	public Node substituteStrictly(Node N0,Node N1) {
		if (this==N0) {
			return N1;
		}
		if (left!=null) {
			if (left==N0) {
				left=N1;
				return this;
			} else {
				left=left.substituteStrictly(N0,N1);
			}
		}

		if (right!=null) {
			for (int i=0;i<right.length;i++) {
				if (right[i]!=null) {
					if (right[i]==N0) {
						right[i]=N1;
						return this;
					} else {
						right[i]=right[i].substituteStrictly(N0,N1);
					}
				}
			}
		}
		return this;
	}

	public Node cloneAndSubstitute(Node N0,Node N1) {
		Node aux=cloneNode();
		if (this==N0) {
			return N1;
		}
		if (left!=null) {
			if (left==N0) {
				aux.left=N1;
				return aux;
			} else {
				aux.left=left.cloneAndSubstitute(N0,N1);
			}
		}

		if (right!=null) {
			for (int i=0;i<right.length;i++) {
				if (right[i]!=null) {
					if (right[i]==N0) {
						aux.right[i]=N1;
						return aux;
					} else {
						aux.right[i]=right[i].cloneAndSubstitute(N0,N1);
					}
				}
			}
		}
		return aux;
	}

	public Node cloneAndReplaceEquals(Node N0,Node N1) {
		Node aux=cloneNode();
		if (this==N0) {
			return N1;
		}
		if (left!=null) {
			if (left.equals(N0)) {
				aux.left=N1;
				return aux;
			} else {
				aux.left=left.cloneAndReplaceEquals(N0,N1);
			}
		}

		if (right!=null) {
			for (int i=0;i<right.length;i++) {
				if (right[i]!=null) {
					if (right[i].equals(N0)) {
						aux.right[i]=N1;
						return aux;
					} else {
						aux.right[i]=right[i].cloneAndReplaceEquals(N0,N1);
					}
				}
			}
		}
		return aux;
	}

	public boolean equals(Node N) {
		if (N==null) {
			return false;
		}
		if (symb!=N.symb || type!=N.type || !symbstr.equals(N.symbstr)) {
			return false;
		}
		if (type==Vi) {
			return true;
		}
		if (left!=null) {
			if (!left.equals(N.left)) {
				return false;
			}
		} else if (N.left!=null) {
			return false;
		}
		if (right!=null&&N.right!=null) {
			if (right.length!=N.right.length) {
				return false;
			}
			for (int i=0;i<right.length;i++) {
				if (right[i]!=null) {
					if (!right[i].equals(N.right[i])) {
						return false;
					}
				} else if (N.right[i]!=null) {
					return false;
				}
			}
		} else if (right!=null && N.right==null) {
			return false;
		} else if (right==null&&N.right!=null) {
			return false;
		}
		return true;
	}

	public int getType() {
		return type;
	}

	int getColumns() {
		return (int) Math.round(ncols.Evaluate(3.0));
	}
	int getRows() {
		return (int) Math.round(nrows.Evaluate(3.0));
	}

	void assign(Node N) {
		type=Vi;
		left=N;
		if (symb==ARRAY) {
			Narray=N.Narray;
			rarray=new double[Narray.length];
			sarray=new String[Narray.length];
			evOnce=N.evOnce;
			size=N.size;
			arr=N.arr;
		} else if (symb==MATRIX) {
			Narray=N.Narray;
			int cols=getColumns();
			int rows=getRows();
			rmatrix=new double[cols][rows];
			smatrix=new String[cols][rows];
			evOnce=N.evOnce;
			size=N.size;
			arr=N.arr;
		}
	}

	private static final int noerror=0,undefined=1,divzero=2,outofbounds=3,zerothroot=4;
	private static String[][] errMsg= {
		{"","Function not defined; ","Division by zero ","Index out of bounds ","Invalid root index " },
		{"","Funcin no definida; ","Divisin por cero ","ndice invlido ","radical invlido " }
	};
	public static final int // TYPE
		No=0,Sep=1,Lp=2,Coma=3,Rp=4,
		As=5,If=6,ThenElse=7,
		B0=8,B1=9,B2=10,B3=11,In=12,
		Us=13,Ua=14,Za=15,Vi=16,Str=17;


//  Slo se usaba cuando el rbol era visible		
//	public boolean isBasicBinaryOperation() {
//		return (B0<=type && type<=B3 && left!=null && 
//				( left.isSignedNumber() ) 
//				&& right!=null && right.length==1 && right[0].isSignedNumber());
//	}
	
	public boolean isSignedNumber() {
		return type==Vi || (type==Us&& right[0].isSignedNumber());
	}

//	public boolean isPositiveNumber() {
//		return type==Vi && r>=0;
//	}

	public Node getLeft() {
		return left;
	}

	public void setLeft(Node N) {
		left=N;
	}

	public void setRight(Node N) {
		right=new Node[1];
		right[0]=N;
	}

	public Node[] getRight() {
		return right;
	}
	
	public void setStrAndAnalyse(String s) { 
		this.s=s;
		if (s!=null) {
			try {
				ns=parser.Analyse("Node",s,true,false);
			} catch (Exception e) {
				ns=new Node(parser,s);
			}
			this.r=Double.NaN;
		} else {
			setDouble(0);
		}
	}

	public void setOnlyStr(String s) {
		this.s=s;
		if (s!=null) {
			this.r=Double.NaN;
		} else {
			setDouble(0);
		}
	}

	public String getStr() {
		return s;
	}
	
	public void setDouble(double r) {
		this.r=r;
		if (r!=Double.NaN) {
			ns=null;
			this.s=null;
		}
	}
	
	public double getDouble() {
		if (r==Double.NaN) {
			new Exception("returning NaN").printStackTrace();
		}
		return r;
	}
	
/* ---------------------- Symbolic operations ---------------------- */

	public static Node Sum(Node A,Node B) {
		Node N=new Node(A.parser,Node.B1,Node.MAS,"+");
		N.setLeft(A);
		N.setRight(B);
		return N;
	}

	public static Node Subtract(Node A,Node B) {
		Node N=new Node(A.parser,Node.B1,Node.MENOS,"-");
		N.setLeft(A);
		N.setRight(B);
		return N;
	}

	public static Node Multiply(Node A,Node B) {
		Node N=new Node(A.parser,Node.B2,Node.POR,"*");
		N.setLeft(A);
		N.setRight(B);
		return N;
	}

	public static Node Divide(Node A,Node B) {
		Node N=new Node(A.parser,Node.B2,Node.DIV,"/");
		N.setLeft(A);
		N.setRight(B);
		return N;
	}

	public static Node Exponentiate(Node A,Node B) {
		Node N=new Node(A.parser,Node.B3,Node.EXPON,"^");
		N.setLeft(A);
		N.setRight(B);
		return N;
	}

	public static Node Root(Node A,Node B) {
		Node N=new Node(A.parser,Node.B3,Node.ROOT,"\\");
		N.setLeft(A);
		N.setRight(B);
		return N;
	}

	public static Node Equal(Node A,Node B) {
		Node N=new Node(A.parser,Node.B0,Node.IGUAL,"=");
		N.setLeft(A);
		N.setRight(B);
		return N;
	}

	public static Node Abs(Node A) {
		Node N=new Node(A.parser,Node.Ua,Node.ABS,"abs");
		N.setRight(A);
		return N;
	}

	public static Node Expr(Node A) {
		Node N=new Node(A.parser,Node.Ua,Node.EXPR,"expr");
		N.setRight(A);
		return N;
	}

//	public static Node Sqr(Node A) {
//		Node N=new Node(Node.Ua,Node.SQR,"sqr");
//		N.setRight(A);
//		return N;
//	}

	public static Node Sqrt(Node A) {
		Node N=new Node(A.parser,Node.Ua,Node.SQRT,"sqrt");
		N.setRight(A);
		return N;
	}

	public static Node Minus(Node A) {
		Node N=new Node(A.parser,Node.Us,Node.MENOS,"-");
		N.setRight(A);
		return N;
	}

/* ---------------------- Token Analysis ---------------------- */

	static String[] getTokens(String expr) throws Exception {
		String expstr=expr.trim();
		int pos=0;
		Vector v=new Vector();
		String auxs="";
		do {
			StringBuffer sb=new StringBuffer();
			char ch='\0';
			if (pos>=expstr.length()) {
				sb.append(ch);
			} else {
				while (isSpace(expstr.charAt(pos))) { pos++; }
				sb.append(ch=expstr.charAt(pos++));
				if (pos<expstr.length()) {
					if (isOperator(ch)) {
						while (isOperator(ch=expstr.charAt(pos))) {
							if (knownOperator(new String(sb)+String.valueOf(ch))) {
								sb.append(ch); pos++;
							} else {
								break;
							}
							if (pos>=expstr.length()) { break; }
						}
//					} else if (isDecimal(ch)) {   // new 2006-Oct-21
					} else if (isDigit(ch)) {   // changed on 2006-Dec-01
						while(true) {
							ch=expstr.charAt(pos);
							boolean minusExp= (ch=='-' && sb.length()>1
											&& sb.charAt(sb.length()-1)=='E'
											&& isDigit(sb.charAt(0)));
							if (isDecimal(ch)||minusExp||ch=='E') {
								sb.append(ch); pos++;
								if (pos>=expstr.length()) { break; }
							} else if (isDigit(ch) || BasicStr.isPureAlpha(ch)) {
								auxs=new String(sb);
								v.addElement(auxs);
								sb=new StringBuffer();
								sb.append("*");
								break;
							} else {
								break;
							}
						}
					} else if (isAlphaNum(ch)) {
						boolean isStr = (ch=='\''),strFinished=false;
						while (true) {
							ch=expstr.charAt(pos);
							boolean minusExp= (ch=='-' && sb.length()>1
											&& sb.charAt(sb.length()-1)=='E'
											&& isDigit(sb.charAt(0)));
							if (isAlphaNum(ch)||minusExp||isStr) {
								if (isStr && ch=='\'') {
									sb.append(ch); pos++;
									strFinished=true;
									break;
								} else {
									sb.append(ch); pos++;
									if (strFinished || (pos>=expstr.length())) { 
										if (isStr && !strFinished) {
											sb.append('\'');
											throw new Exception("Unfinished String");
										}
										break; 
									}
								}
							} else {
								break;
							}
//							strFinished=('\''==expstr.charAt(pos));
						}
					}
				}
			}
			auxs=new String(sb);
			v.addElement(auxs);
		} while (!isSeparator(auxs));
		String[] sa=new String[v.size()];
		Enumeration e=v.elements();
		for (int i=0;i<sa.length;i++) {
			sa[i]=(String) e.nextElement();
//System.out.print(sa[i]+" ");
		}
//System.out.println();
		return sa;
	}

	public static boolean isVarName(String name) {
		for (int i=0;i<name.length();i++) {
			char ch=name.charAt(i);
			if ((i==0)&&(!BasicStr.isPureAlpha(ch))) {
				return false;
			}
			if ((i>0)&&(!isAlphaNum(ch))) {
				return false;
			}
		}
		return true;
	}

	private static boolean isSpace(char ch) {
		return ch==' ' || ch=='\10' || ch=='\13';
	}

	private static boolean isAlphaNum(char ch) {
		return isDecimal(ch)||BasicStr.isPureAlpha(ch)||ch=='\''||ch==''||ch=='"';
	}
	public static boolean isDecimal(char ch)  {
		return isDigit(ch)||ch=='.';
	}
	public static boolean isDigit(char ch) {
		return ch>='0'&&ch<='9';
	}

	public static boolean isHexDigit(char ch) {
		return isDigit(ch)||(ch>='a'&&ch<='f');
	}

	public static boolean isOperator(char ch) {
		switch (ch) {
		case '|' : case '&' :
		case '=' : case '#' : case '<' : case '>' :
		case '+' : case '-' : case '*' : case '/' :
		case '%' : case '^' : case ':' : case '~' :
		case '!' : case '?' : case '' : case '\\' :
				   return true;
		default  :  return false;
		}
	}

	private static boolean isSeparator(String s)   {
		return s.equals(";") || s.equals("\0") || s.equals("\26");
	}

/* ----------------------------------------------------------------- */

	public boolean isANumber() {
		try {
			double x=Double.valueOf(symbstr).doubleValue();
			return true;
		} catch(NumberFormatException nfe) {
			return false;
		}
	}
	public String getSymbol() {
		return symbstr;
	}

	public int getSymb() {
		return symb;
	}

	public void equalToMinus() { // This is to convert "f(x,y)=g(x,y)" into "f(x,y)-g(x,y)=0" .
		symb=MENOS;
		type=B1;
		symbstr="-";
	}

//	public Node () {
//		this(0);
//	}

	public Node(Parser p,double d) {
		this(p,d,8);
	}

	public Node(Parser p,String s) {
		this.parser=p;
		this.symbstr=s;
		this.type=Str;
		this.s=s;
		this.ns=null;
		if (s!=null) {
			this.r=Double.NaN;
		} else {
			this.r=0;
		}
	}

	protected int decimales=12;

	public void setDecimals(int dec) {
		decimales=dec;
	}

	public Node(Parser p,double d,int decimales) {
		this.parser=p;
		this.decimales=decimales;
		if (d>=0) {
			r=d; type=Vi;
			symbstr=BasicStr.DoubleToString(r,decimales,false,".");
		} else {
			type=Us;
			symb=MENOS;
			symbstr="-";
			right=new Node[1];
			right[0]=new Node(parser,-d);
		}
	}

	public Node (Parser p,String name,double d) {
		this.parser=p;
		symbstr=name; r=d; type=Vi;
	}
	
	public Node (Parser p,int type, int symb,String symbstr) {
		this.parser=p;
		this.type=type;
		this.symb=symb;
		this.symbstr=symbstr;
	}
	Node (Parser p,String name,Node szN,Node[] Narr0,boolean evOnce) {
		this.parser=p;
		symbstr=name;
		symb=ARRAY;
		type=nodeType(symb);
		Narray=Narr0;
		rarray=new double[Narray.length];
		sarray=new String[Narray.length];
		this.evOnce=evOnce;
		size=szN;
	}
	Node (Parser p,String name,Node ncols,Node nrows,Node[] Narr0,boolean evOnce) {
		this.parser=p;
		symbstr=name;
		symb=MATRIX;
		type=nodeType(symb);
		this.ncols=ncols;
		this.nrows=nrows;
		int n1=getColumns();
		int n2=getRows();
		rmatrix=new double[n1][n2];
		smatrix=new String[n1][n2];
		this.evOnce=evOnce;
		Narray=Narr0;
	}
	Node (Parser p,String name,Node arrN,boolean isMatrix) {
		this.parser=p;
		symbstr=name;
		if (isMatrix) {
			symb=MATRIX;
		} else {
			symb=ARRAY;
		}
		type=nodeType(symb);
		this.arr=arrN;
	}
	Node (Parser p,String name,boolean der_exp,Node func,Algorithm a) {
		this.parser=p;
		symbstr=name;
		this.func=func;
		if (der_exp) {
			symb=DER;
		} else {
			symb=FUNC;
		}
		this.alg=a;
		type=nodeType(symb);
	}
	Node (Parser p,String s,boolean isvar) {
		this.parser=p;
		symbstr=s;
		if (isvar) {
			symb=VAR;
			type=Vi;
//		} else if ((s!=null)&&s.startsWith("'")&&s.endsWith("\'")) {
//System.out.println("Creando nodo para "+s);
//			symb=VAR;
//			type=Vi;
//			this.s=BasicStr.trim(s,'\'');
//			this.r=Double.NaN;
		} else {
			symb=symbol(s);
			type=nodeType(symb);
		}
	}
	
	public boolean isVar() {
		return (type==Vi && symb==VAR);
	}

	public boolean isUnaryOp() {
		return (type==Us || type==Ua);
	}

	public boolean isSequence() {
		return symb==FUNC && func.sequence ;
	}

	private int nodeType(int symbol) {
		switch (symbol) {
		case END    : return Sep;
		case SEP    : return Sep;
		case LP     : return Lp;
		case COMA   : return Coma;
		case RP     : return Rp;
		case ASSIGN : return As;
		case IF     : return If;
		case THENELSE: return ThenElse;
		case RND    : return Za;
		case MAS    :
		case MENOS  :
		case MASMEN : return In;
		case IGUAL  :
		case NOI    :
		case MEN    :
		case MAY    :
		case MEOI   :
		case MAOI   : return B0;
		case OR     : return B1;
		case AND    :
		case POR    :
		case DIV    : return B2;
		case EXPON  :
		case ROOT	:
		case MOD    : return B3;
		case NO     : return Us;
		case SQR    :
		case SQRT   :
		case EXP    :
		case LOG    :
		case LOG10  :
		case ABS    :
		case ENT    :
		case ENT_ANT:
		case SGN    :
		case IND    :
		case SIN    :
		case COS    :
		case TAN    :
		case COT    :
		case SEC    :
		case CSC    :
		case SINH   :
		case COSH   :
		case TANH   :
		case SECH   :
		case CSCH   :
		case COTH   :
		case ASIN   :
		case ACOS   :
		case ATAN   :
		/*    case ACOT   :
		case ASEC   :
		case ACSC   :
		case ASINH  :
		case ACOSH  :
		case ATANH  :
		case ACOTH  :
		case ASECH  :
		case ACSCH  :
		case FAC    :
		case SUMN   : */
		case SUMA   :
		case MIN    :
		case MAX    :
		case isok   :
		case isOk	:
		case SAVE	:
		case LOAD	:
		case GETVEC :
		case GETMTX	:
		case MTXTOSTR:
		case STRTOMTX:
		case VECTOSTR:
		case STRTOVEC:
		case EXECSTR:
		case EXEBLOCK :
		case GETVAL	:
		case NUMTOSTR :
		case STRWDTH :
		case CHARAT:
		case SUBSTR:
		case STRLENGTH:
		case IXOF:
		case PRNT :
		case RED	:
		case GREEN	:
		case BLUE	:
		case FUNC   :
		case DER    :
		case EQN    :
		case EQA    :
		case EQX    :
		case NUM    :
		case EXPR   :
		case EVAL	:
		case EXEC	:
		case NUMB	:
		case ARRAY  : 
		case MATRIX : return Ua;
		case VAR    : return Vi;
		case NOOP   :
		default     : return No;
		}
	}

	public static boolean knownOperator(String s) {
		int sy=symbol(s);
		return (ASSIGN<=sy && sy<=NO);
	}

	public static int symbol(String s) {
		if (s.equals("\0"))      { return END; }
		if (s.equals(";"))       { return SEP; }
		if (s.equals("("))       { return LP; }
		if (s.equals(")"))       { return RP; }
		if (s.equals("["))       { return LP; }
		if (s.equals("]"))       { return RP; }
		if (s.equals(","))       { return COMA; }
		if (s.equals(":="))      { return ASSIGN; }
		if (s.equals("?"))       { return IF; }
		if (s.equals(":"))       { return THENELSE; }
		if (s.equals("="))       { return IGUAL; }
		if (s.equals("=="))      { return IGUAL; }
		if (s.equals("?="))      { return IGUAL; }
		if (s.equals("=?"))      { return IGUAL; }
		if (s.equals(""))       { return IGUAL; }
		if (s.equals("?"))      { return IGUAL; }
		if (s.equals("="))      { return IGUAL; }
		if (s.equals("=?"))     { return IGUAL; }
		if (s.equals("#"))       { return NOI; }
		if (s.equals("!="))      { return NOI; }
		if (s.equals("|"))       { return OR; }
		if (s.equals("||"))      { return OR; }
		if (s.equals("&"))       { return AND; }
		if (s.equals("&&"))      { return AND; }
		if (s.equals("<"))       { return MEN; }
		if (s.equals(">"))       { return MAY; }
		if (s.equals("<="))      { return MEOI; }
		if (s.equals(">="))      { return MAOI; }
		if (s.equals("+"))       { return MAS; }
		if (s.equals("-"))       { return MENOS; }
		if (s.equals("\u00b1"))  { return MASMEN; }
		if (s.equals("*"))       { return POR; }
		if (s.equals("/"))       { return DIV; }
		if (s.equals("^"))       { return EXPON; }
		if (s.equals("\\"))    	 { return ROOT; }
		if (s.equals("%"))       { return MOD; }
		if (s.equals("~"))       { return NO; }
		if (s.equals("!"))       { return NO; }
		if (s.equals("sqr"))     { return SQR; }
		if (s.equals("sqrt"))    { return SQRT; }
		if (s.equals("raz"))    { return SQRT; }
		if (s.equals("exp"))     { return EXP ; }
		if (s.equals("log"))     { return LOG ; }
		if (s.equals("log10"))   { return LOG10;}
		if (s.equals("abs"))     { return ABS ; }
		if (s.equals("ent"))     { return ENT ; }
		if (s.equals("ent_ant")) { return ENT_ANT ; }
		if (s.equals("sgn"))     { return SGN ; }
		if (s.equals("ind"))     { return IND ; }
		if (s.equals("sin"))     { return SIN ; }
		if (s.equals("sen"))     { return SIN ; }
		if (s.equals("cos"))     { return COS ; }
		if (s.equals("tan"))     { return TAN ; }
		if (s.equals("cot"))     { return COT ; }
		if (s.equals("sec"))     { return SEC ; }
		if (s.equals("csc"))     { return CSC ; }
		if (s.equals("sinh"))    { return SINH; }
		if (s.equals("senh"))    { return SINH; }
		if (s.equals("cosh"))    { return COSH; }
		if (s.equals("tanh"))    { return TANH; }
		if (s.equals("coth"))    { return SECH; }
		if (s.equals("sech"))    { return CSCH; }
		if (s.equals("csch"))    { return COTH; }
		if (s.equals("asin"))    { return ASIN; }
		if (s.equals("asen"))    { return ASIN; }
		if (s.equals("acos"))    { return ACOS; }
		if (s.equals("atan"))    { return ATAN; }
		/*
		if (s.equals("acot"))    { return ACOT; }
		if (s.equals("asec"))    { return ASEC; }
		if (s.equals("acsc"))    { return ACSC; }
		if (s.equals("asinh"))   { return ASINH;}
		if (s.equals("asenh"))   { return ASINH;}
		if (s.equals("acosh"))   { return ACOSH;}
		if (s.equals("atanh"))   { return ATANH;}
		if (s.equals("acoth"))   { return ACOTH;}
		if (s.equals("asech"))   { return ASECH;}
		if (s.equals("acsch"))   { return ACSCH;}
		if (s.equals("fac"))     { return FAC;  }
		if (s.equals("suma"))    { return SUMN; }
		*/
		if (s.equals("sum"))     { return SUMA; }
		if (s.equals("min"))     { return MIN;  }
		if (s.equals("max"))     { return MAX;  }
		if (s.equals("isOk"))       { return isOk;  }
		if (s.equals("esCorrecto")) { return isOk;  }
		if (s.equals("isok"))       { return isok;  }
		if (s.equals("escorrecto")) { return isok;  }
		if (s.equals("_Save_"))     { return SAVE;  }
		if (s.equals("_Load_"))     { return LOAD;  }
		if (s.equals("_GetVector_")) { return GETVEC;  }
		if (s.equals("_GetMatrix_")) { return GETMTX;  }
		if (s.equals("_MatrixToStr_")) { return MTXTOSTR;  }
		if (s.equals("_StrToMatrix_")) { return STRTOMTX;  }
		if (s.equals("_VectorToStr_")) { return VECTOSTR;  }
		if (s.equals("_StrToVector_")) { return STRTOVEC;  }
		if (s.equals("_ExecStr_")) { return EXECSTR;  }
		if (s.equals("_ExecBlock_")) { return EXEBLOCK;  }
		if (s.equals("_GetValues_")) { return GETVAL;  }

		if (s.equals("_NumToStr_")) { return NUMTOSTR;  }
		if (s.equals("_NumACadena_")) { return NUMTOSTR;  }
		if (s.equals("_strWidth_")) { return STRWDTH;  }
		if (s.equals("_AnchoDeCadena_")) { return STRWDTH;  }
		if (s.equals("_length_")) { return STRLENGTH;  }
		if (s.equals("_longitud_")) { return STRLENGTH;  }
		if (s.equals("_charAt_")) { return CHARAT;  }
		if (s.equals("_letraEn_")) { return CHARAT;  }
		if (s.equals("_substring_")) { return SUBSTR;  }
		if (s.equals("_subcadena_")) { return SUBSTR;  }
		if (s.equals("_indexOf_")) { return IXOF;  }
		if (s.equals("_ndiceDe_")) { return IXOF;  }
		if (s.equals("_Print_")) { return PRNT;  }
		if (s.equals("_Trace_")) { return PRNT;  }
		if (s.equals("_Rojo_")) { return RED;  }
		if (s.equals("_Verde_")) { return GREEN;  }
		if (s.equals("_Azul_")) { return BLUE;  }

		if (s.equals("rnd"))        { return RND;  }
		if (inAlgebraTutor) {
			if (s.equals("eqn"))     { return EQN;  }
			if (s.equals("eqa"))     { return EQA;  }
			if (s.equals("eqx"))     { return EQX;  }
			if (s.equals("num"))     { return NUM;  }
			if (s.equals("expr"))     { return EXPR;  }
		}
		if (s.equals("_Eval_"))     { return EVAL;  }
		if (s.equals("_Exec_"))     { return EXEC;  }
		if (s.equals("_Num_"))     { return NUMB;  }
		if (s.equals(""))        { return NOOP; }
		return VAR;
	}

	public int NumVars() {
		int nvars=0;
		if (type==Ua) {
			if (func!=null) {
				nvars=func.var.length;
			} else if (symb==ARRAY) {
				nvars=1;
			} else if (symb==MATRIX) {
				nvars=2;
			} else {
				switch (symb) {
				case SQR    :
				case SQRT   :
				case EXP    :
				case LOG    :
				case LOG10  :
				case ABS    :
				case ENT_ANT:
				case ENT    :
				case SGN    :
				case IND    :
				case SIN    :
				case COS    :
				case TAN    :
				case COT    :
				case SEC    :
				case CSC    :
				case SINH   :
				case COSH   :
				case TANH   :
				case SECH   :
				case CSCH   :
				case COTH   :
				case ASIN   :
				case ACOS   :
				case ATAN   :
				/*    case ACOT   :
				case ASEC   :
				case ACSC   :
				case ASINH  :
				case ACOSH  :
				case ATANH  :
				case ACOTH  :
				case ASECH  :
				case ACSCH  :
				case FAC    : */
				case EQN    :
				case EQA    :
				case EQX    :
				case NUM    :
				case EVAL   :
				case EXEC   :
				case NUMB   :
				case MTXTOSTR :
				case VECTOSTR :
				case EXECSTR :
				case STRLENGTH :
				case PRNT :
					nvars=1;
					break;
				case EXPR    :
				case SUBSTR    :
					nvars=3;
					break;
				case MIN    :
				case MAX    :
				case isok   :
				case isOk   :
				case SAVE   :
				case STRTOMTX :
				case STRTOVEC :
				case GETMTX :
				case GETVEC :
				case GETVAL :
				case EXEBLOCK :
				case IXOF :
				case CHARAT :
				case NUMTOSTR :
					nvars=2;
					break;
				case STRWDTH :
					nvars=4;
					break;
				case LOAD   :
				case RED :
				case GREEN :
				case BLUE :
					nvars=1;
					break;
//				case SUMN   :
				case SUMA   :
					nvars=nvars;
					break;
				default     :
					nvars=0;
					break;
				}
			}
		}
		return nvars;
	}

/* ------------------------------------------------------------------ */

	private Exception NodeException(String errmsg,Node mainNode,Node n) {
		Exception e = new Exception(errmsg+"\nAt: "+n.toExpression()+"\nIn: "+mainNode.toExpression());
		return e;
	}

	private double divide(Node mainNode,double num,double den) throws Exception {
		boolean denIsZero=Math.abs(den)<epsilon;
		if (num==0.0&&!denIsZero) {
			return 0.0;
		}
		if (denIsZero) {
			error=true;
			errType=divzero;
//			s=errMsg[1][errType];
//			r=Double.NaN;
			throw NodeException(errMsg[1][errType],mainNode,this);
		} else {
			return num/den;
		}
	}

	private double log(Node mainNode,double x) throws Exception {
		if (x<epsilon) {
			error=true;
			errType=undefined;
//			s=errMsg[1][errType];
//			r=Double.NaN;
			throw NodeException(errMsg[1][errType],mainNode,this);
		} else {
			return Math.log(x);
		}
	}

	private double posexpon(Node mainNode,double x, double y) throws Exception {
		if (y==0) {
			return 1;
		}
		if (y<0) {
			error=true;
			errType=undefined;
//			s=errMsg[1][errType];
//			r=Double.NaN;
			throw NodeException(errMsg[1][errType],mainNode,this);
		}
		if ((x>=0)||((int) Math.floor(y)==y)) {
			return Math.pow(x,y);
		}
		if (x<0) {
			double yinv=1/y;
			int q=(int) Math.floor(yinv);
			if (q==yinv) {
				if (q%2==1) {
					return -Math.pow(-x,y);
				}
			}
		}
		error=true;
		errType=undefined;
//		s=errMsg[1][errType];
//		r=Double.NaN;
		throw NodeException(errMsg[1][errType],mainNode,this);
	}

	double expon(Node mainNode,double x, double y) throws Exception {
		if (y>=0) {
			return posexpon(mainNode,x,y);
		} else if (posexpon(mainNode,x,-y)!=0.0) {
			return 1/posexpon(mainNode,x,-y);
		} else {
			errType=divzero;
//			s=errMsg[1][errType];
//			r=Double.NaN;
			throw NodeException(errMsg[1][errType],mainNode,this);
		}
	}

	private double sqrt(Node mainNode,double x) throws Exception {
		if (x<0) {
			error=true;
			errType=undefined;
//			s=errMsg[1][errType];
//			r=Double.NaN;
			throw NodeException(errMsg[1][errType],mainNode,this);
		} else {
			return Math.sqrt(x);
		}
	}

	public boolean rangeOK() {
		try {
			Evaluate(this,false);
			return true;
		} catch (Exception e) {
			return false;
		}
	}

	public static String VectorToString(Parser parser,String vecname) {
		Node vector=parser.getArray(vecname);
		if (vector==null) return "";
		String S="<"+vecname+">\r\n";
		int L= vector.Narray.length;
		try {
			Node maxix=parser.Var(vecname+".long_usada");
			int ue=(int) maxix.Evaluate();
			if (ue>0) {
				L=Math.min(ue,L);
			}
		} catch (Exception e) {
		}
		for (int i=0;i<L;i++) {
			if (i==0) {
				S=S+" ";
			}
			if (vector.sarray[i]==null) {
				S=S+vector.rarray[i];
			} else {
				S=S+"'"+vector.sarray[i]+"'";
			}
			S=S+"\r\n";
		}
		S=S+"</"+vecname+">\r\n";
		return S;
	}

	public static String MatrixToString(Parser parser,String mtxname) {
		Node matrix=parser.getMatrix(mtxname);
		if (matrix==null) return "";
		String S="<"+mtxname+">\r\n";
		int cols=matrix.getColumns();
		try {
			Node maxcol=parser.Var(mtxname+".columnas_usadas");
			int ucols=(int) maxcol.Evaluate();
			if (ucols>0) {
				cols=Math.min(ucols,cols);
			}
		} catch (Exception e) {
		}
		int rows=matrix.getRows();
		try {
			Node maxrow=parser.Var(mtxname+".filas_usadas");
			int urows=(int) maxrow.Evaluate();
			if (urows>0) {
				rows=Math.min(urows,rows);
			}
		} catch (Exception e) {
		}
		for (int j=0;j<cols;j++) {
			for (int i=0;i<rows;i++) {
				if (i==0) {
					S=S+" ";
				}
				if (matrix.smatrix[j][i]==null) {
					S=S+matrix.rmatrix[j][i];
				} else {
					S=S+"'"+matrix.smatrix[j][i]+"'";
				}
				if (i+1<rows) {
					S=S+"  ";
				} else {
					S=S+"\r\n";
				}
			}
		}
		S=S+"</"+mtxname+">\r\n";
		return S;
	}

	public static String getVectorValues(Parser parser,String svec,String vecname) {
		Node vector=parser.getArray(vecname);
		if (vector==null) return "Vector not found";
		int ixm1=svec.indexOf("<"+vecname+">")+vecname.length()+2;
		int ixm2=svec.indexOf("</"+vecname+">");
		if ((ixm1>=vecname.length()+2)&&(ixm2>ixm1)) {
			svec=svec.substring(ixm1,ixm2);
			String[] sa=BasicStr.toStringArray(svec);
			Node maxix=parser.Var(vecname+".long_usada");
			int L=Math.min(sa.length,vector.Narray.length);
			maxix.setDouble(L);
			for (int j=0;j<L;j++) {
				String tok=sa[j];
				if (tok.startsWith("'") && tok.endsWith("'")) {
					tok=tok.substring(1,tok.length()-1);
					vector.rarray[j]=Double.NaN;
					vector.sarray[j]=tok;
				} else {
					try {
						double d=Double.parseDouble(tok);
						vector.rarray[j]=d;
						vector.sarray[j]=null;
					} catch (Exception ex) {
						vector.rarray[j]=Double.NaN;
						vector.sarray[j]=tok;
					}
				}
			}
			return "Ok";
		} else {
			return "ERROR";
		}
	}

	public static String StringToMatrix(Parser parser,String smtx,String mtxname) {
		Node matrix=parser.getMatrix(mtxname);
		if (matrix==null) return "Matrix not found";
		int ixm1=smtx.indexOf("<"+mtxname+">")+mtxname.length()+2;
		int ixm2=smtx.indexOf("</"+mtxname+">");
		if ((ixm1>=mtxname.length()+2)&&(ixm2>ixm1)) {
			smtx=smtx.substring(ixm1,ixm2);
			String[] sa=BasicStr.toStringArray(smtx);
			Node maxix=parser.Var(mtxname+".columnas_usadas");
			int L=Math.min(sa.length,matrix.getColumns());
			maxix.setDouble(L);
			int maxfilas=0;
			for (int col=0;col<L;col++) {
				String scol=sa[col];
				String[] sacol=BasicStr.getElements(scol,"");
				maxfilas=Math.max(maxfilas,sacol.length);
				for (int row=0;row<sacol.length;row++) { 
					String tok=sacol[row].trim();

					if (tok.startsWith("'") && tok.endsWith("'")) {
						tok=tok.substring(1,tok.length()-1);
						matrix.rmatrix[col][row]=Double.NaN;
						matrix.smatrix[col][row]=tok;
					} else {
						try {
							double d=Double.parseDouble(tok);
							matrix.rmatrix[col][row]=d;
							matrix.smatrix[col][row]=null;
						} catch (Exception ex) {
							matrix.rmatrix[col][row]=Double.NaN;
							matrix.smatrix[col][row]=tok;
						}
					}
				}
			}
			Node maxfi=parser.Var(mtxname+".filas_usadas");
			int F=Math.min(maxfilas,matrix.getRows());
			maxfi.setDouble(F);
			return "Ok";
		}
		return "ERROR";
	}

	public static String getValuesFromStr(Parser parser,String skv,String aux) {
		int ix1=skv.indexOf("<"+aux+">")+aux.length()+2;
		int ix2=skv.indexOf("</"+aux+">");
		if ((ix1<0) || ("".equals(aux))) { ix1=0; }
		if ((ix2<0) || ("".equals(aux))) { ix2=skv.length(); }
		if ((ix1>=0)&&(ix2>ix1)) {
			skv=skv.substring(ix1,ix2);
			StringTokenizer st=new StringTokenizer(skv,"\r\n");
			int i=0;
			while (st.hasMoreTokens()) { 
				String tok=st.nextToken();
				tok=tok.trim();
				int ix=tok.indexOf("=");
				if (ix>0) {
					String key=tok.substring(0,ix);
					key=key.trim();
					String value=tok.substring(ix+1);
					value=value.trim();
					Node nod=parser.Var(key);
					if (value.startsWith("'") && value.endsWith("'")) {
						value=value.substring(1,value.length()-1);
						nod.r=Double.NaN;
						nod.s=value;
					} else {
						try {
							nod.r=Double.parseDouble(value);
							nod.s=null;
						} catch (Exception ex) {
							nod.r=Double.NaN;
							nod.s=value;
						}
					}
				}
			}
			return "OK";
		} else {
			return "ERROR";
		}
	} 

	private double UnOp(Node mainNode,boolean ignoreRange,double[] v,String[] vs,Node[] Ns) throws Exception {
		double x=0;
		String ss="";
		Node ns=null;
		if (v!=null&&v.length>0) {
			x=v[0];
			ss=vs[0];
			ns=Ns[0];
		}
		switch (symb) {
		case MIN      : return Math.min(v[0],v[1]);
		case MAX      : return Math.max(v[0],v[1]);
		case isok     : return (parser.isok(vs[0],vs[1]))?1:0;
		case isOk     : return (parser.isOk(vs[0],vs[1]))?1:0;
		case SAVE 	  : String str=vs[1];
						str=BasicStr.replace(str,"\\r\\n","\r\n");
						str=BasicStr.replace(str,"\\r","\r");
						str=BasicStr.replace(str,"\\n","\n");
						str=BasicStr.replace(str,"\\q","'");
						str=BasicStr.replace(str,"\\_","\\");	// added 2016-05-03
						com.mja.file.mjaHtml.writeInUTF8File(str,vs[0]);
						return r=Double.NaN;
		case LOAD 	  : 
						s=com.mja.file.mjaFile.readFile(vs[0]);
						while ((s!=null)&&(s.length()>0)&&(s.charAt(s.length()-1)=='\n')) {
							s=s.substring(0,s.length()-1);
						}
						return r=Double.NaN;
		case GETVEC	  : s="";
						String svec=com.mja.file.mjaFile.readFile(vs[0]);
						s=getVectorValues(parser,svec,vs[1]);
						return r=Double.NaN;
		case GETMTX	  : s="";
						String smtx=com.mja.file.mjaFile.readFile(vs[0]);
						s=StringToMatrix(parser,smtx,vs[1]);
						return r=Double.NaN;
		case MTXTOSTR	  : 
						s=MatrixToString(parser,vs[0]);
						return r=Double.NaN;
		case VECTOSTR	  : 
						s=VectorToString(parser,vs[0]);
						return r=Double.NaN;
		case STRTOMTX     : 
						s=StringToMatrix(parser,vs[0],vs[1]);
						return r=Double.NaN;
		case STRTOVEC     : 
						s=getVectorValues(parser,vs[0],vs[1]);
						return r=Double.NaN;
		case EXECSTR	  : 
						s=getValuesFromStr(parser,vs[0],"");
						return r=Double.NaN;
		case EXEBLOCK	  : 
						s=getValuesFromStr(parser,vs[0],vs[1]);
						return r=Double.NaN;
		case GETVAL	  : 
						String skv=com.mja.file.mjaFile.readFile(vs[0]);
						s=getValuesFromStr(parser,skv,vs[1]);
						return r=Double.NaN;
		case RED	  : r=BasicStr.getRed(vs[0]);
						return r;
		case GREEN	  : r=BasicStr.getGreen(vs[0]);
						return r;
		case BLUE	  : r=BasicStr.getBlue(vs[0]);
						return r;
		case  NUMTOSTR : 
						s=BasicStr.DoubleToString(v[0],(int) v[1],true);
						return Double.NaN;
		case STRWDTH  : 
						String vs3=vs[3];
						if (vs[3]==null) {
							vs3=""+(int)v[3];
						}
						r=BasicStr.getStringWidth(vs[0],vs[1],vs[2],vs3,C);
						return r;
		case STRLENGTH  :
						s=null;
						return vs[0].length(); 
		case SUBSTR  :
						int ix1=(int) Math.round(v[1]);
						int ix2=(int) Math.round(v[2]);
						int iaux=(ix1>ix2)?ix1:ix2;
						ix1=(ix1<ix2)?ix1:ix2;
						ix2=(ix1<ix2)?ix2:iaux;
						if (ix1<0) {
							s=vs[0].substring(ix2); 
						} else {
							s=vs[0].substring(ix1,ix2); 
						}
						return Double.NaN;
		case CHARAT  :
						s=Character.toString(vs[0].charAt((int) Math.round(v[1])));
						return  Double.NaN;
		case IXOF  :
						s=null;
						return vs[0].indexOf(vs[1]); 
		case PRNT  :
						s=null;
						System.out.println(vs[0]);
						return 0;
//		case SUMN	  :
		case SUMA	  :
			x=0;
			for (int i=0;i<v.length;i++) {
				x+=v[i];
			}
			return x;
		case FUNC     :
			double result=0.0;
			if (func.var!=null && func.var.length==v.length) {
				if (func.sequence) {
					for (int i=0;i<v.length;i++) {
						if (v[i]!=Math.round(v[i])) {
							error=true;
							errType=undefined;
//							s=errMsg[1][errType];
//							r=Double.NaN;
							throw NodeException(errMsg[1][errType],mainNode,this);
						}
					}
				}
				double[] va=new double[v.length];
				String[] sa=new String[v.length];
				for (int i=0;i<v.length;i++) {
					va[i]=func.var[i].r;
					sa[i]=func.var[i].s;
					func.var[i].r=v[i];
					func.var[i].s=vs[i];
				}
				
				double[] vLocalAnt = null;
				String[] sLocalAnt = null;		
				if(func.localVarsList != null){
					// Protegemos el valor de las variables que estan declaradas como locales 
					// para cuando salga se restaure su valor en el ambiente general
					vLocalAnt = new double[func.localVarsList.length];
					sLocalAnt = new String[func.localVarsList.length];
					for (int i=0;i < func.localVarsList.length; i++) {
						Node varVal = func.localVarsList[i];
						varVal.Evaluate();
						vLocalAnt[i] = varVal.r;
						sLocalAnt[i] = varVal.s;
						varVal.r = 0;
						varVal.s = null;
					}
				}
				boolean ok=true;
				if (ignoreRange || func.range==null || func.range.Evaluate(1.0)>0) {
					if (alg!=null&&!alg.isNull) {
						// EJECUTAMOS EL ALGORITMO
						alg.perform();
					}
					try {
						r=func.Evaluate(mainNode,ignoreRange);
						s=func.s;
						result=r;
						if (s!=null) {
							r=Double.NaN;
						}
						result=r;
					} catch (Exception e) {
						ok=false;
					}
				} else {
					ok=false;
				}
				for (int i=0;i<v.length;i++) {
					func.var[i].r=va[i];
					func.var[i].s=sa[i];
				}
				
				if(vLocalAnt != null){
					//Regresamos el valor de las variables
					for (int i=0;i < func.localVarsList.length; i++) {
						Node varVal = func.localVarsList[i];
						varVal.Evaluate();
						varVal.r = vLocalAnt[i]; 
						varVal.s = sLocalAnt[i];
					}
				}
				if (!ok) {
					error=true;
					errType=undefined;
//					s=errMsg[1][errType];
//					r=Double.NaN;
					throw NodeException(errMsg[1][errType],mainNode,this);
				}
			}
			return result;
		case DER      :
			double y0=0,y1=0;
			if (func.var!=null && func.var.length==v.length) {
				double[] va=new double[v.length];
				for (int i=0;i<v.length;i++) {
					va[i]=func.var[i].r;
					func.var[i].r=v[i];
				}
				boolean ok=true;
				try {
					if (alg!=null&&!alg.isNull) {
						alg.perform();
					}
					y0=func.Evaluate(mainNode,ignoreRange);
					func.var[0].r=x+epsilon;
					if (alg!=null&&!alg.isNull) {
						alg.perform();
					}
					y1=func.Evaluate(mainNode,ignoreRange);
				}  catch (Exception e) {
					ok=false;
				}
				for (int i=0;i<v.length;i++) {
					func.var[i].r=va[i];
				}
				if (!ok) {
					error=true;
					errType=undefined;
//					s=errMsg[1][errType];
//					r=Double.NaN;
					throw NodeException(errMsg[1][errType],mainNode,this);
				}
			}
			return (y1-y0)/epsilon;
		case MATRIX:
			int n1=(int) Math.round(v[0]);
			int n2=(int) Math.round(v[1]);
			if (arr.smatrix!=null) {
				s=arr.smatrix[n1][n2];
			}
			if (arr.rmatrix!=null) {
				return arr.rmatrix[n1][n2]; 
			}
			return 0;
		default       : return 0.0;
		}
	}

	private double UnOp(Node mainNode,boolean ignoreRange,double x,String ss,Node ns) throws Exception {
		switch (symb) {
		case NO       : if (x==1.0) return 0.0; else return 1.0;
		case MAS      : return x;
		case MENOS    : return -x;
		case MASMEN   : return x;
		case ABS      : if (x<0) return -x; else return x;
		case SQR      : return x*x;
		case SQRT     : return sqrt(mainNode,x);
		case EXP      : return Math.exp(x);
		case LOG      : return log(mainNode,x);
		case LOG10    : return log(mainNode,x)/Math.log(10.0);
		case COS      : return Math.cos(x);
		case SIN      : return Math.sin(x);
		case TAN      : return divide(mainNode,Math.sin(x),Math.cos(x));
		case SEC      : return divide(mainNode,1.0,Math.cos(x));
		case CSC      : return divide(mainNode,1.0,Math.sin(x));
		case COT      : return divide(mainNode,1.0,Math.tan(x));
		case SINH     : return (Math.exp(x)-Math.exp(-x))/2.0;
		case COSH     : return (Math.exp(x)+Math.exp(-x))/2.0;
		case TANH     : return divide(mainNode,Math.exp(x)-Math.exp(-x),Math.exp(x)+Math.exp(-x));
		case COTH     : return divide(mainNode,Math.exp(x)+Math.exp(-x),Math.exp(x)-Math.exp(-x));
		case SECH     : return 2.0/(Math.exp(x)+Math.exp(-x));
		case CSCH     : return divide(mainNode,2.0,Math.exp(x)-Math.exp(-x));
		case ENT_ANT  : return Math.floor(x);
		case ENT      : return Math.floor(x+Math.abs(x)/(1000000000000000.0));
		case SGN      : if (x>0.0) return 1.0; else if (x<0) return -1.0;
		case IND      : if (x!=0.0) return 1.0; else return 0.0;
		case ASIN     : return Math.asin(x);
		case ACOS     : return Math.acos(x);
		case ATAN     : return Math.atan(x);
		case RND      : double rnd=Math.random();
						if (parser.lms_applet!=null) {
							String[][] stra=new String[1][2];
							stra[0][0]="rnd"; 
							stra[0][1]=Double.toString(rnd);
							(parser.lms_applet).informLMS("azar","rnd","",stra);
						}
						return rnd;
		case EQN :
		case EQA :
		case EQX :
		case NUM : return x;
		case EXPR :
			try {
				return r=right[0].Evaluate(mainNode,false);
			} catch (Exception ex) {
				return x;
			}
		case ARRAY:
			double[] a=arr.rarray;
			if (a==null) {
				error=true;
				errType=outofbounds;
//				s=errMsg[1][errType];
//				r=Double.NaN;
				throw NodeException("Internal Error: null array",mainNode,this);
			}
			int n=(int) Math.round(x);
			if (n>=0 && n<a.length) {
				s=arr.sarray[n];
				return a[n];
			} else {
				error=true;
				errType=outofbounds;
//				s=errMsg[1][errType];
//				r=Double.NaN;
				throw NodeException(errMsg[1][errType]+" n="+n+" "+getSymbol()+".length="+a.length,mainNode,this);
			}
		case NUMB : String str=BasicStr.replace(ss,",",".");
					return r=BasicStr.parseDouble(str,Double.NaN,Double.NaN);
		case EXEC : try {
						Runtime.getRuntime().exec(ss);
						return 1;
					} catch (Exception e) {
						System.out.println("Could not execute "+ss);
						e.printStackTrace();
						return 0;
					}
		case EVAL : 
					if (ns!=null) {
						r=ns.Evaluate(mainNode,false);
						s=ns.s;
						return r;
					} else {
						String auxstr=ss;
						if (auxstr!=null) {
							auxstr=BasicStr.trim(auxstr,'\'');
							auxstr=BasicStr.trim(auxstr,'|');
							try {
								Node nn=parser.Analyse(auxstr);
								r=nn.Evaluate(mainNode,false);
								s=nn.s; // Ojo con esto No causa problemas? Seguro...?
								ns=nn;
								return r;
							} catch (Exception e) {
							}
						}
					}
					return r=Double.NaN;
		default       : return 0.0;
		}
	}

	private double BnOp(Node mainNode,double x, double y) throws Exception {
		switch (symb) {
		case IGUAL : if (x==y) return 1.0; else return 0.0;
		case MEN   : if (x<y)  return 1.0; else return 0.0;
		case MEOI  : if (x<=y) return 1.0; else return 0.0;
		case MAY   : if (x>y)  return 1.0; else return 0.0;
		case MAOI  : if (x>=y) return 1.0; else return 0.0;
		case NOI   : if (x!=y) return 1.0; else return 0.0;
		case AND   : if ((x==1.0)&&(y==1.0)) { return 1.0; } else { return 0.0; }
		case OR    : if ((x==1.0)||(y==1.0)) { return 1.0; } else { return 0.0; }
		case MAS   : return (x+y);
		case MENOS : return (x-y);
		case MASMEN: return (x+y);
		case POR   : if ((x==0.0)||(y==0.0)) { return 0.0; } else { return (x*y); }
		case DIV   : return divide(mainNode,x,y);
		case EXPON : return expon(mainNode,x,y);
		case ROOT  : if (x!=0) {
						return expon(mainNode,y,1/x);
					 } else {
						error=true;
						errType=zerothroot;
//						s=errMsg[1][errType];
//						r=Double.NaN;
						throw NodeException(errMsg[1][errType],mainNode,this);
					 }
		case MOD   : return x - y*Math.floor(x/y); // no va --> (Math.IEEEremainder(x,y));
		default    : if ((x==0.0)||(y==0.0)) { 
						return 0.0; 
					 } else { 
					 	return (x*y); 
					 }
		}
	}

	public static void check(Node N) throws Exception {
		if (N.left==N) {
			throw new Exception("N.left==N");
		} else if (N.left!=null) {
			check(N.left);
		}
		if (N.right!=null) {
			for (int i=0;i<N.right.length;i++) {
				if (N.right[i]==N) {
					throw new Exception("N.right["+i+"]==N");
				} else if (N.right[i]!=null) {
					check(N.right[i]);
				}
			}
		}
	}
	
	public double Evaluate(double defaultValue) {
		try {
			return Evaluate();
		} catch (Exception e) {
			return defaultValue;
		}
	}

	public double Evaluate() throws Exception {
		return Evaluate(this,false);
	}

	public double Evaluate(Node mainNode,boolean ignoreRange) throws Exception {
		return Evaluate(mainNode,ignoreRange,decimales,false);
	}

	private double Evaluate(Node  mainNode, boolean ignoreRange,int precision,boolean fixed) throws Exception {
		errType=0;
		error=false;
		try {
			switch(type) {
			case Vi:double val=0.0;
					if (left!=null && left!=this) {
						val=left.Evaluate(mainNode,ignoreRange);
						s=left.s;
					} else {
						val=r;
					}
					return val;
			case Za: return UnOp(mainNode,ignoreRange,0.0,"",null);
			case Us:
			case Ua:
				double d=0;
				if (right!=null) {
					// generara excepcin en matrices porque right == null
					if (symb==MIN||symb==MAX||symb==isok||symb==isOk||symb==SAVE||symb==LOAD||
						symb==SUMA||symb==FUNC||symb==DER||
						symb==GETVAL||symb==GETMTX||symb==GETVEC||symb==VECTOSTR||symb==STRTOVEC||
						symb==MTXTOSTR||symb==STRTOMTX||symb==EXECSTR||symb==EXEBLOCK||
						symb==MATRIX||symb==RED||symb==GREEN||symb==BLUE||symb==STRWDTH||symb==NUMTOSTR
						||symb==STRLENGTH||symb==CHARAT|symb==SUBSTR||symb==IXOF||symb==PRNT) {
						double[] v=new double[right.length];
						String[] vs=new String[right.length];
						Node[] Ns=new Node[right.length];
						for (int i=0;i<right.length;i++) {
							v[i]=right[i].Evaluate(mainNode,ignoreRange);
							vs[i]=right[i].s;
							Ns[i]=right[i].ns;
						}
						d=UnOp(mainNode,ignoreRange,v,vs,Ns);
					} else {
						double x=right[0].Evaluate(mainNode,ignoreRange);
						d=UnOp(mainNode,ignoreRange,x,right[0].s,right[0].ns);
					}

				} else {
					// No tengo claro qu pasa con las matrices, pero 
					// parece que funciona bien as, sin hacer nada.
//					d=Double.NaN;
				}
				return d;
			case B0:
			case B1:
			case B2:
			case B3:
//					if (left!=null && right!=null && right.length>0&& right[0]!=null && parser.isMatrix(left.toExpression()) && parser.isMatrix(right[0].toExpression())) {
//System.out.println("Matrix operation "+left.toExpression()+" "+symbstr+" "+right[0].toExpression());
//System.out.println("Matrix operation? "+left.symbstr+" "+symbstr+" "+right[0].symbstr);
					if (left!=null &&  
						parser.isMatrix(left.symbstr) && (left.right==null || left.right.length==0 ) && 
						right!=null && right.length>0&& right[0]!=null &&
						parser.isMatrix(right[0].symbstr) && (right[0].right==null||right[0].right.length==0)) 
					{
						rmatrix=MatrixBinOp(left,symb,right[0]);
						smatrix=null;
						s=null;
						return r=0;
//						return Double.NaN;
					}
		// introduced on May 2, 2009 in order to shortcircuit boolean operations
					left.r=left.Evaluate(mainNode,ignoreRange);
					if (symb == AND && left.r==0) {
						return r=0;
					}
					if (symb == OR && left.r==1) {
						return r=1;
					}
		// ---------------------------------------------------------------------
					right[0].r=right[0].Evaluate(mainNode,ignoreRange);
					if (symb == MAS && (left.s!=null || right[0].s!=null)) {
						s=(left.s!=null)?left.s:BasicStr.DoubleToString(left.r,precision,fixed);
						s+=(right[0].s!=null)?right[0].s:BasicStr.DoubleToString(right[0].r,precision,fixed);
						return 0;
//						return Double.NaN;
					} else if ( (symb == IGUAL || symb == NOI) && (left.s!=null || right[0].s!=null) ) {
						String strL = (left.s!=null)?left.s:String.valueOf(left.r);
						String strR = (right[0].s!=null)?right[0].s:String.valueOf(right[0].r);
						boolean res = strL.equals(strR);
						if (symb == IGUAL) {
							return (res)?1:0; 
						} else {
							return (res)?0:1; 
						}
					} else {
						s=null;
//						if (left.s!=null) {
//							s=left.s;
//						} else if (right[0].s!=null) {
//							s=right[0].s;
//						} 
//						if (left.r==Double.NaN) {
//							r=left.r;
//						} else if (right[0].r==Double.NaN) {
//							r=right[0].r;
//						}
//						if ((r==Double.NaN)||(s!=null)) {
//							throw new Exception(s);
//						}
						return BnOp(mainNode,left.r,right[0].r);
					}

			case As: left.r=right[0].Evaluate(mainNode,ignoreRange);
					 left.s=right[0].s;	// added on 08/Dec/2006
					return left.r;
			case If :
				if (left.Evaluate(mainNode,ignoreRange)>0) {
					double res=right[0].left.Evaluate(mainNode,ignoreRange);
					rmatrix=right[0].left.rmatrix;
					smatrix=right[0].left.smatrix;
					s=right[0].left.s;
					return res;
				} else {
					double res=right[0].right[0].Evaluate(mainNode,ignoreRange);
					rmatrix=right[0].right[0].rmatrix;
					smatrix=right[0].right[0].smatrix;
					s=right[0].right[0].s;
					return res;
				}
			default: 
				return 0;
			}
		} catch (Exception e) {
			throw e;
		}
	}
	
	static double[][] MatrixBinOp(Node left,int symb ,Node right) {
		int cols=left.getColumns();
		int rows=left.getRows();
		double[][] result=new double[cols][rows];
		switch (symb) {
			case MAS : 
						for (int j=0;j<rows;j++) {
							for (int i=0;i<cols;i++) {
								result[i][j]=left.rmatrix[i][j]+right.rmatrix[i][j];
							}
						}
						break;
			case MENOS : 
						for (int j=0;j<rows;j++) {
							for (int i=0;i<cols;i++) {
								result[i][j]=left.rmatrix[i][j]-right.rmatrix[i][j];
							}
						}
						break;
			case POR : 	result=com.mja.math3D.LinearTransformation.Multiply(left.rmatrix,right.rmatrix);
						break;
			case DIV :	try {
							double[][] inverse=com.mja.math3D.LinearTransformation.inverse(right.rmatrix);
							result=com.mja.math3D.LinearTransformation.Multiply(left.rmatrix,inverse);
						} catch (Exception e) {
							e.printStackTrace();
						}
						break;
			default : 
						break;
		}
		return result;
	}

	public boolean error() {
		if (error) {
			return true;
		}
		switch(type) {
		case Us:
		case Ua:
			for (int i=0;i<right.length;i++) {
				if (right[i].error()) {
					return true;
				}
			}
			return false;
		case B0:
		case B1:
		case B2:
		case B3:
		case If:
		case ThenElse:
		case As: return left.error()||right[0].error();
		default: return false;
		}
	}

	private String translate(int Lang,int em) {
		return errMsg[Lang][em];
	}

	private String errorMsg(int Lang) {
		String msg=translate(Lang,errType);
		switch(type) {
		case Us:
		case Ua:
			for (int i=0;i<right.length;i++) {
				msg+=right[i].errorMsg(Lang);
			}
			break;
		case B0:
		case B1:
		case B2:
		case B3:
		case If:
		case ThenElse:
		case As: msg+=left.errorMsg(Lang)+" "+right[0].errorMsg(Lang); break;
		}
		return msg;
	}

	public boolean contains(String s) {
		if (symbstr.equals(s)) { return true; }
		switch(type) {
		case Us:
		case Ua:
			for (int i=0;i<right.length;i++) {
				if (right[i].contains(s)) {
					return true;
				}
			}
			return false;
		case B0:
		case B1:
		case B2:
		case B3:
		case If:
		case ThenElse:
		case As: return left.contains(s)||right[0].contains(s);
		default: return false;
		}
	}

		/* ------------------------------------------------------ */

	public String toString(int precision,boolean fixed,int Lang) throws Exception {
		if (s!=null) {
			return s;
		} else {
			StringBuffer textb=new StringBuffer("");
			if (type==Node.Str) {
				textb.append(symbstr);
			} else {
				try {
					double x=Evaluate(this,false);
					textb.append(BasicStr.DoubleToString(x,precision,fixed));
				} catch (Exception e) {
					throw e;
				}
			}
			return new String(textb);
		}
	}


	private static String symbolStr(int symbol) {
		switch (symbol) {
		case END      : return "\0";
		case SEP      : return ";";
		case LP       : return "(";
		case RP       : return ")";
		case ASSIGN: return ":=";
		case IF : return "?";
		case THENELSE : return ":";
		case IGUAL: return "=";
		case NOI: return "!=";
		case OR: return "|";
		case AND: return "&";
		case MEN: return "<";
		case MAY: return ">";
		case MEOI: return "<=";
		case MAOI: return ">=";
		case MAS: return "+";
		case MENOS: return "-";
		case MASMEN: return "\u00b1";
		case POR: return "*";
		case DIV: return "/";
		case EXPON: return "^";
		case ROOT: return "\\";
		case MOD: return "%";
		case NO: return "!";
		case SQR: return "sqr";
		case SQRT: return "sqrt";
		case EXP: return "exp";
		case LOG: return "log";
		case LOG10: return "log10";
		case ABS: return "abs";
		case ENT: return "ent";
		case ENT_ANT: return "ent_ant";
		case SGN: return "sgn";
		case IND: return "ind";
		case SIN: return "sin";
		case COS: return "cos";
		case TAN: return "tan";
		case COT: return "cot";
		case SEC: return "sec";
		case CSC: return "csc";
		case SINH: return "sinh";
		case COSH: return "cosh";
		case TANH: return "tanh";
		case SECH: return "coth";
		case CSCH: return "sech";
		case COTH: return "csch";
		case ASIN: return "asin";
		case ACOS: return "acos";
		case ATAN: return "atan";
//		case ACOT: return "acot";
//		case ASEC: return "asec";
//		case ACSC: return "acsc";
//		case ASINH: return "asinh";
//		case ACOSH: return "acosh";
//		case ATANH: return "atanh";
//		case ACOTH: return "acoth";
//		case ASECH: return "asech";
//		case ACSCH: return "acsch";
//		case FAC: return "fac";
//		case SUMN: return "sumn";
		case SUMA: return "suma";
		case MIN: return "min";
		case MAX: return "max";
		case isok: return "isok";
		case isOk: return "isOk";
		case SAVE: return "_Save_";
		case LOAD: return "_Load_";
		case GETMTX: return "_GetMatrix_";
		case GETVEC: return "_GetVector_";
		case MTXTOSTR: return "_MatrixToStr_";
		case VECTOSTR: return "_VectorToStr_";
		case STRTOMTX: return "_StrToMatrix_";
		case STRTOVEC: return "_StrToVector_";
		case EXEBLOCK: return "_ExecBlock_";
		case EXECSTR: return "_ExecStr_";
		case GETVAL: return "_GetValues_";
		case NUMTOSTR: return "_NumToStr_";
		case STRWDTH: return "_AnchoDeCadena_";
		case STRLENGTH: return "_longitud_";
		case CHARAT: return "_letraEn_";
		case SUBSTR: return "_subcadena_";
		case IXOF: return "_ndiceDe_";
		case PRNT: return "_Print_";
		case RED: return "_Rojo_";
		case GREEN: return "_Verde_";
		case BLUE: return "_Azul_";
		case RND: return "rnd";
		case EQN: return "eqn";
		case EQA: return "eqa";
		case EQX: return "eqx";
		case NUM: return "num";
		case EXPR: return "expr";
		case EVAL: return "_Eval_";
		case EXEC: return "_Exec_";
		case NUMB: return "_Num_";
		case NOOP: return "";
		default :return "";
		}
	}

	public boolean isInteger() {
		return (symbstr!=null) && isNumber(symbstr) && (symbstr.indexOf(".")<0);
	}

	public boolean isPositiveNumber() {
		return (symbstr!=null) && isNumber(symbstr) ;
	}

	public boolean isNumber() {
		return isNumber(symbstr);
	}

	public boolean isNumberProduct() {
		if (isNumber()) {
			return true;
		} else if (symb==POR) {
			return left.isNumberProduct()&&right[0].isNumberProduct();
		} else if (type==Us) {
			return right[0].isNumberProduct();
		} else {
			return false;
		}
	}

	public static boolean isNumber(String s) {
		for (int i=0;i<s.length();i++) {
			if (!isDecimal(s.charAt(i))) {
				return false;
			}
		}
		return s.length()>0;
	}

	public Node decomposeInPrimeFactors() {
		if (isInteger()) {
			return this;
//			int n=2;
//			while (true) {
//				Node N=new Node(r/n);
//				if (N.isInteger()) {
//
//				}
//			}
		} else {
			return this;
		}
	}

/* -------------------- simplify calculating inside num() ------------------ */

//	public Node simplify(Parser p,int precision) {
//		if (symb==NUM||symb==EXPR) {
//			try {
//				Node n=new Node(parser,Evaluate(false));
//				n.symbstr=BasicStr.DoubleToString(n.r,precision,false);
//				return n;
//			} catch (Exception e) {
//			}
//			return new Node(parser,0.0);
//		} else if (p.isVar(symbstr)) {
//			return this;
//		} else {
//			Node n=cloneNode();
//			if (left!=null) {
//				n.left=left.simplify(p,precision);
//			}
//			if (right!=null) {
//				n.right=new Node[right.length];
//				for (int i=0;i<right.length;i++) {
//					if (right[i]!=null) {
//						n.right[i]=right[i].simplify(p,precision);
//					}
//				}
//			}
//			return n;
//		}
//	}

/* -------------------- Unused Methods ------------------- */

/*
	public static boolean almostEqual(Node n1,Node n2,double epsilon) {
		if (n1.type!=n2.type) {
			return false;
		}
		if (n1.symb!=n2.symb) {
			return false;
		}
		switch(n1.type) {
		case Vi: return (Math.abs(n1.r-n2.r)<=epsilon);
		case Za: return n1.symbstr.equals(n2.symbstr);
		case Us:
		case Ua:
			double[] v=new double[n1.right.length];
			for (int i=0;i<v.length;i++) {
				if (!almostEqual(n1.right[i],n2.right[i],epsilon)) {
					return false;
				}
			}
			return true;
		case B0:
		case B1:
		case B2:
		case B3:
		case If:
				if (!almostEqual(n1.left,n2.left,epsilon)) {
					return false;
				}
				if (!almostEqual(n1.right[0],n2.right[0],epsilon)) {
					return false;
				}
				return true;
		case As: return almostEqual(n1.left,n2.left,epsilon);
		default: return false;
		}
	}
*/

/*
	public Node performExprEvaluations(Parser p) {
		Node N=cloneNode();
		switch(type) {
		case Vi:double val=0.0;
				if (N.left!=null) {
					N.left=left.performExprEvaluations(p);
				}

				break;
		case Za: break;
		case Us:
		case Ua:
			for (int i=0;i<right.length;i++) {
				N.right[i]=N.right[i].performExprEvaluations(p);
			}
			break;
		case B0:
		case B1:
		case B2:
		case B3:
		case As:
		case If :
			N.left=N.left.performExprEvaluations(p);
			for (int i=0;i<right.length;i++) {
				N.right[i]=N.right[i].performExprEvaluations(p);
			}
			break;
		default:;
		}
		if (symb==EXPR) {
			try {
				double x=N.Evaluate(false);
				return new Node(p,x,decimales);
			} catch (Exception ex) {
			}
		}
		return N;
	}
*/

/* --------------- Expression and Formula ------------- */

/* ----------------- Convert Node to Expression ---------------- */

	
	public String toExpression() {
		return toExpression(false);
	}

	public String toExpression(boolean allParenthesis) {
		return toExpression(allParenthesis,false);
	}

	public String toExpression(boolean allParenthesis,boolean onlyBracketsInExpr) {
		boolean AP=allParenthesis;
		boolean OB=onlyBracketsInExpr;
		String expr="";
		switch(type) {
		case Vi:if (isNumber(getSymbol())) {
					expr+=BasicStr.DoubleToString(r,decimales,false,".");
				} else {
					expr+=getSymbol();
				}
				break;
		case Za:
				expr+=symbstr;
				break;
		case Us:
				if (AP) {
					expr+=symbstr+"("+((Node) right[0]).toExpression(AP,OB)+")";
				} else if (symb==MAS) {
					expr+=((Node) right[0]).toExpression(AP,OB);
				} else {
					if (right[0].type<Ua) {
						expr+=symbstr+"("+((Node) right[0]).toExpression(AP,OB)+")";
					} else {
						expr+=((Node) right[0]).signedExpression(symb==MAS,AP,OB);
//						expr+=signedExpression(symb==MENOS,AP,OB);  cambiado el 15 de febrero de 2009
					}
				}
				break;
		case Ua:if (symb==SQR) {
					expr+=addParenthesis(this,(Node) right[0],((Node) right[0]).type<Ua,AP,OB);
					expr+="^2";
					break;
				} else if (symb==SUMA){
					for (int i=0;i<right.length;i++) {
						if (right[i].type==Us&&right[i].symb==MENOS) {
							expr+="-"+((Node) right[i].right[0]).toExpression(AP,OB);
						} else {
							if (i>0) {
								expr+="+";
							}
							expr+=((Node) right[i]).toExpression(AP,OB);
						}
					}
					break;
				} else if (symb==SQRT) {
					expr="sqrt("+((Node) right[0]).toExpression(AP,OB)+")";
					break;
				} else if (onlyBracketsInExpr && symb==EXPR) {
					expr="["+((Node) right[0]).toExpression(AP,OB)+"]";
					break;
				}
				expr+=symbstr;
				if (right!=null) {
					expr+="(";
					for (int i=0;i<right.length;i++) {
						if (i>0) {
							expr+=",";
						}
						if (right[i]!=null) {
							expr+=((Node) right[i]).toExpression(AP,OB);
						} else {
							expr+="0";
						}
					}
					expr+=")";
				}
				break;
		case B0:expr+=((Node) left).toExpression(AP,OB);
				expr+=symbstr;
				expr+=((Node) right[0]).toExpression(AP,OB);
				break;
		case B1:if (AP) {
					expr+=addParenthesis(this,(Node) left,true,AP,OB);
					expr+=symbstr;
					expr+=addParenthesis(this,(Node) right[0],true,AP,OB);
				} else if (symb==MAS){
					expr+=((Node) left).toExpression(AP,OB);
					expr+=((Node) right[0]).signedExpression(symb==MAS,AP,OB);
				} else if (symb==MENOS){
					expr+=((Node) left).toExpression(AP,OB);
					expr+=((Node) right[0]).signedExpression(symb==MAS,AP,OB);
				} else {
					expr+=addParenthesis(this,(Node) left,true,AP,OB);
					expr+=symbstr;
					expr+=addParenthesis(this,(Node) right[0],true,AP,OB);
				}
				break;
		case B2:
		case B3:
				if (symb==ROOT && left==null) {
					expr+="sqrt("+((Node) right[0]).toExpression(AP,OB)+")";
					break;
				}
		
				boolean addLP=(type!=left.type);
				addLP|=(symb==DIV && !(left.symb==POR));
				addLP|=(symb==POR && left.symb==DIV);
				addLP|=(type==B3 && left.type!=Vi && left.type!=Ua);
				addLP&=!(left.type==Ua);
				expr+=addParenthesis(this,(Node) left,addLP,AP,OB);
				expr+=symbstr;
				boolean addRP=(type!=right[0].type);
				addRP|=	(right[0].symb==DIV);
				addRP|= (symb==DIV && right[0].symb==POR);
//				addRP|=(symb==POR && right[0].symb==DIV);
				addRP|=(type==B3);
				addRP&=!(right[0].type==Ua);
				addRP&=!(symb==POR && right[0].type==B3);
				expr+=addParenthesis(this,(Node) right[0],addRP,AP,OB);
				break;
		case As: expr=((Node) left).toExpression(AP,OB)+symbstr+((Node) right[0]).toExpression(AP,OB);
				break;
		case If:
		case ThenElse :
				expr+="("+addParenthesis(this,(Node) left,false,AP,OB)+symbstr+addParenthesis(this,(Node) right[0],false,AP,OB)+")";
				break;
		default:
				expr+=getSymbol();
				break;
		}
		return expr;
	}

	private String signedExpression(boolean sign,boolean AP,boolean OB) {
		String expr="";
		if (AP) {
			if (sign) {
				expr+="+("+toExpression(AP,OB)+")";
			} else {
				expr+="-("+toExpression(AP,OB)+")";
			}
		} else if (type==B1 && (symb==MAS||symb==MENOS) ) {
			expr+=eliminateParenthesis(false,false).toExpression(AP,OB);
			if (!expr.startsWith("-")) {
				expr="+"+expr;
			}
		} else if (type==Us && symb==MENOS) {
			expr+=((Node) right[0]).signedExpression(!sign,AP,OB);
		} else if (type==Vi) {
			if (symbstr.startsWith("-")) {
				if (sign) {
					expr+=symbstr;
				} else {
					expr+="+"+symbstr.substring(1);
				}
			} else {
				if (sign) {
					expr+="+"+symbstr;
				} else {
					expr+="-"+symbstr;
				}
			}
		} else if (sign) {
			expr+="+"+toExpression(AP,OB);
		} else {
			expr+="-"+toExpression(AP,OB);
		}
		return expr;
	}

	private String addParenthesis(Node parent,Node N,boolean addP,boolean AP,boolean OB) {
		String expr=N.toExpression(AP,OB);
		if (AP || addP) {
			if (expr.length()>1 && !isNumber(expr)) {
				expr="("+expr+")";
			}
		}
		return expr;
	}

	public Node eliminateParenthesis(boolean recursive,boolean all) {
		Node N=binaryToUnaryMinus(recursive);
		N=N.distributeUnaryMinusInSums(recursive,all);
		N=N.eliminateConsecutiveUnarySigns(recursive);
		N=N.unaryToBinaryMinus(N,recursive);	// agregado el 9 de abril de 2009
		return N.doEliminateParenthesis(recursive,all);
	}

	public Node binaryToUnaryMinus(boolean recursive) {
		Node N=(Node) cloneNode();
		if (recursive) {
			if (N.left!=null) {
				N.left=((Node)N.left).binaryToUnaryMinus(recursive);
			}
			if (N.right!=null) {
				for (int j=0;j<N.right.length;j++) {
					if (N.right[j]!=null) {
						N.right[j]=((Node)N.right[j]).binaryToUnaryMinus(recursive);
					}
				}
			}
		}
		if (N.type==B1&&N.symb==MENOS) {
			Node[] aux=(Node[]) N.right;
			N.type=B1;
			N.symb=MAS;
			N.symbstr="+";
			N.right=new Node[1];
			N.right[0]=new Node(parser,Us,MENOS,"-");
			N.right[0].right=aux;
			N.right[0]=((Node) N.right[0]).eliminateConsecutiveUnarySigns(false);
		}
		return N;
	}

	public static Node unaryToBinaryMinus(Node N0,boolean recursive) {
		Node N=N0.cloneNode();
		if (recursive) {
			if (N.left!=null) {
				N.left=unaryToBinaryMinus(N.left,recursive);
			}
			if (N.right!=null) {
				for (int j=0;j<N.right.length;j++) {
					if (N.right[j]!=null) {
						N.right[j]=unaryToBinaryMinus(N.right[j],recursive);
					}
				}
			}
		}
		if (N.type==Node.B1 && N.symb==Node.MAS) {
			if (N.right[0].type==Node.Us&&N.right[0].symb==Node.MENOS) {
				Node[] aux=N.right[0].right;
				N.symb=Node.MENOS;
				N.symbstr="-";
				N.right=aux;
			} else if (N.left.type==Node.Us&&N.left.symb==Node.MENOS) {
				Node[] aux=N.left.right;
				N.symb=Node.MENOS;
				N.symbstr="-";
				N.left=N.right[0];
				N.right=aux;
			} else if (N.right[0].type==Node.B1&&N.right[0].symb==Node.MAS) {
				Node B=N.right[0].left;
				Node[] c=N.right[0].right;
				Node C=N.right[0].right[0];
				if (B.type==Node.Us && B.symb==Node.MENOS) {
					if (C.type==Node.Us && C.symb==Node.MENOS) {
						N.symb=Node.MENOS;
						N.symbstr="-";
						N.right[0].left=B.right[0];
						N.right[0].right[0]=C.right[0];
					} else {
						N.right[0].left=C;
						N.right[0].right[0]=B.right[0];
					}
				}
			} else if (N.right[0].type==Node.B1&&N.right[0].symb==Node.MENOS) {
				if (N.right[0].left.type==Node.Us && N.right[0].left.symb==Node.MENOS) {
					Node[] B=N.right[0].left.right;
					Node[] C=N.right[0].right;
					N.symb=Node.MENOS;
					N.symbstr="-";
					N.right[0].symb=Node.MAS;
					N.right[0].symbstr="+";
					N.right[0].left=B[0];
					N.right[0].right=C;
				}
			}
		}
		return (Node) N;
	}

	public Node distributeUnaryMinusInSums(boolean recursive, boolean all) {
		Node N=(Node) cloneNode();
		if (recursive) {
			if (N.left!=null) {
				N.left=((Node) N.left).distributeUnaryMinusInSums(recursive,all);
			}
			if (N.right!=null) {
				for (int j=0;j<N.right.length;j++) {
					if (N.right[j]!=null) {
						N.right[j]=((Node) N.right[j]).distributeUnaryMinusInSums(recursive,all);
					}
				}
			}
		}
		if (N.type==Us&&N.symb==MENOS &&
			(N.right[0].symb==MAS&&N.right[0].type==B1 || N.right[0].symb==SUMA) ) {
			N=(Node) N.right[0];
			if (N.symb==MAS) {
				Node A=(Node) N.left;
				Node[] B=(Node[]) N.right;
				N.left=new Node(parser,Us,MENOS,"-");
				N.left.right=new Node[1];
				N.left.right[0]=A;
				N.left=((Node) N.left).eliminateConsecutiveUnarySigns(false);
				N.right=new Node[1];
				N.right[0]=new Node(parser,Us,MENOS,"-");
				N.right[0].right=B;
				N.right[0]=((Node) N.right[0]).eliminateConsecutiveUnarySigns(false);
				if (all) {
					N.left=((Node) N.left).distributeUnaryMinusInSums(recursive,all);
					N.right[0]=((Node) N.right[0]).distributeUnaryMinusInSums(recursive,all);
				}
			} else if (N.symb==SUMA) {
				Node[] A=(Node[]) N.right;
				N.right=new Node[A.length];
				for (int i=0;i<A.length;i++) {
					if (A[i].type==Us&&A[i].symb==MENOS) {
						N.right[i]=A[i].right[0];
					} else {
						N.right[i]=new Node(parser,Us,MENOS,"-");
						N.right[i].right=new Node[1];
						N.right[i].right[0]=A[i];
						N.right[i]=((Node) N.right[i]).eliminateConsecutiveUnarySigns(false);
					}
					if (all) {
						N.right[i]=((Node) N.right[i]).distributeUnaryMinusInSums(recursive,all);
					}
				}
			}
		}
		return N;
	}

	public Node eliminateConsecutiveUnarySigns(boolean recursive) {
		Node N=(Node) cloneNode();
		if (recursive) {
			if (N.left!=null) {
				N.left=((Node)N.left).eliminateConsecutiveUnarySigns(recursive);
			}
			if (N.right!=null) {
				for (int j=0;j<N.right.length;j++) {
					if (N.right[j]!=null) {
						N.right[j]=((Node) N.right[j]).eliminateConsecutiveUnarySigns(recursive);
					}
				}
			}
		}
		while (N.type==Us && N.right[0].type==Us &&
			( 	(N.symb==MENOS && N.right[0].symb==MENOS) ||
				(N.symb==MAS && N.right[0].symb==MAS)         ) ) {
			N=(Node) N.right[0].right[0];
		}
		return N;
	}

	Node doEliminateParenthesis(boolean recursive,boolean all) {
		Node N=(Node) cloneNode();
		if (recursive) {
			if (N.left!=null) {
				N.left=((Node) N.left).eliminateParenthesis(recursive,all);
			}
			if (N.right!=null) {
				for (int j=0;j<N.right.length;j++) {
					if (N.right[j]!=null) {
						N.right[j]=((Node) N.right[j]).eliminateParenthesis(recursive,all);
					}
				}
			}
		}
		if (type==B1&&symb==MAS) {
			Vector V=new Vector();
			addOperandNodes(B1,MAS,V);
			N=new Node(parser,Ua,SUMA,"suma");
			N.right=new Node[V.size()];
			for (int i=0;i<V.size();i++) {
				N.right[i]=(Node) V.elementAt(i);
				if (all) {
					N.right[i]=((Node) N.right[i]).eliminateParenthesis(recursive,all);
				}
			}
		}
		return N;
	}

	void addOperandNodes(int thistype,int thisymb,Vector V) {
		if (type==thistype && symb==thisymb) {
			if (left!=null) {
				((Node) left).addOperandNodes(thistype,thisymb,V);
			}
			if (right!=null&&right.length>0) {
				for (int i=0;i<right.length;i++) {
					((Node) right[0]).addOperandNodes(thistype,thisymb,V);
				}
			}
		} else {
			V.addElement(this);
		}
	}


/* ----------------- Convert Node to Formula ---------------- */

	public Formula F;
	
	public Formula toFormula() {
		return toFormula(new Parser(1),false,"",true,true);
	}

	public Formula toFormula(Parser p,boolean separate,String por_str,boolean msa,boolean par_all) {
		exprCfg ecfg=new exprCfg(p,por_str,separate,msa,par_all);
		return toFormula(ecfg);
	}

	private Formula toFormula(exprCfg ecfg) {
		setParents();
		F=new Formula(ecfg.p);
		insertInFormula(F,ecfg,false);
		F.setNode(this);
		return F;
	}

	public void insertInFormula(Formula F,Parser p,boolean separate,String por_str,boolean msa,boolean par_all) {
		exprCfg ecfg=new exprCfg(p,por_str,separate,msa,par_all);
		insertInFormula(F,ecfg,separate);
	}

	public void setParents() {
		if (left!=null) {
			left.parent=this;
			((Node) left).setParents();
		}
		if (right!=null) {
			for (int i=0;i<right.length;i++) {
				right[i].parent=this;
				((Node) right[i]).setParents();
			}
		}
	}

	private void insertInFormula(Formula F,exprCfg ec,boolean separate) {
		Formula Gu;
		switch(type) {
			case Vi:F.insertString(toExpression(false));
					break;
			case Za: F.insertString(toExpression(false));
					break;
			case Us:
					F.insertString(symbstr);
					Gu=((Node) right[0]).toFormula(ec);
					if (right[0].type<B2||right[0].symb==MENOS||right[0].symb==SUMA) {
						Gu=addParenthesis((Node) right[0],Gu,ec.p,ec.separate);
					}
					F.insertFormula(Gu,ec.separate);
				break;
			case Ua:if (symb==SUMA) {
						for (int i=0;i<right.length;i++) {
							if (right[i].type==Us&&right[i].symb==MENOS) {
								F.insertString("-");
								((Node) right[i].right[0]).insertInFormula(F,ec,separate);
							} else {
								if (i>0) {
									F.insertString("+");
								}
								((Node) right[i]).insertInFormula(F,ec,separate);
							}
						}
					} else if (symb==SQRT) {
						Formula L=new Formula(ec.p);
					//   Se cambia el nodo a uno binario ROOT 
						symb=ROOT;
						symbstr="\\";
						type=B3;
						left=new Node(ec.p,2);
						// esto est a prueba
 						Formula R=((Node) right[0]).toFormula(ec);
						F.insertRadical(L,R);
					} else if (symb==SQR) {
						Gu=((Node) right[0]).toFormula(ec);
						if (right[0].type<=Us || right[0].symb==SUMA) {
							Gu=addParenthesis((Node) right[0],Gu,ec.p,ec.separate);
						}
 						Gu.insertSuperIndex("2");
						F.insertFormula(Gu,ec.separate);
					} else if (symb==EXP) {
						Formula auxF=new Formula(ec.p);
						auxF.insertString("e");
						auxF.setNode(this); // Est bien esto?
						F.insertRadical(auxF,((Node) right[0]).toFormula(ec));
					} else if (symb==ABS) {
						F.insertString("|");
						F.insertFormula(((Node) right[0]).toFormula(ec),ec.separate);
						F.insertString("|");
					} else {
						((Node) right[0]).insertInFormula(F,ec,separate);
					}
				break;
			case B0: Formula LL=((Node) left).toFormula(ec);
 					 Formula RR=((Node) right[0]).toFormula(ec);
					 F.insertFormula(LL,ec.separate);
					 F.insertString(" "+TNode.getComparisonSymbol(symbstr)+" ");
					 F.insertFormula(RR,ec.separate);
					 break;
			case B1:
			case B2:
			case B3:if (symb==EXPON) {
						Formula G=((Node) left).toFormula(ec);
						if (left.type<=Us || left.symb==SUMA) {
							G=addParenthesis((Node) left,G,ec.p,ec.separate);
						}
						F.insertFormula(G,ec.separate);
 						G=((Node) right[0]).toFormula(ec);
	 					F.insertSuperIndex(G);
 					} else if (symb==ROOT) {
 						Formula L=((Node) left).toFormula(ec);
 						if (((Node) left).type==Vi && ((Node) left).r==2) {
 						// Se quita de la frmula el ndice 2 pero se deja en el nodo.
	 						L=new Formula(ec.p);
	 						left=new Node(ec.p,2);
 						}
 						Formula R=((Node) right[0]).toFormula(ec);
						F.insertRadical(L,R);
 					} else if (symb==DIV) {
 						Formula L=((Node) left).toFormula(ec);
 						Formula R=((Node) right[0]).toFormula(ec);
 						F.insertFraction(L,R);
					} else if (symb==POR) {
 						Formula L=((Node) left).toFormula(ec);
						if (((left.type<B2||left.symb==SUMA)&& left.symb!=POR) 
							|| left.type==Us
							|| (ec.par_always&&left.symb==POR)) {
							L=addParenthesis((Node) left,L,ec.p,ec.separate);
	 					}
 						Formula R=((Node) right[0]).toFormula(ec);
						if (((right[0].type<B2||right[0].symb==SUMA)&& right[0].symb!=POR) 
							|| right[0].type==Us
							|| (ec.par_always&&right[0].symb==POR)
							|| left.isNumber()&&right[0].symb==POR&&right[0].left.isNumber()
							) {
							R=addParenthesis((Node) right[0],R,ec.p,ec.separate);
						}
						if (separate) {
	 						F.insertProduct(L,R);
						} else {
							F.insertFormula(L,ec.separate);
							if (ec.msa || isNumberProduct()
								|| (left.type==Vi&&right[0].type==Vi&&left.symbstr.equals(right[0].symbstr)) // a*a
								|| (left.type==Vi&&right[0].symb==EXPON&&left.symbstr.equals(right[0].left.symbstr))    // a*a^n
								|| (left.symb==EXPON&&right[0].type==Vi&&left.left.symbstr.equals(right[0].symbstr))
//								|| (left.type==Vi&&right[0].symb==EXPON)  // a*b^n
//								|| (left.symb==EXPON&&right[0].type==Vi)  // a^n*a
								) {
								F.insertString(ec.por_str);
							}
							F.insertFormula(R,ec.separate);
						}
					} else if (symb==MAS){
 						Formula L=((Node) left).toFormula(ec);
						if (  ec.par_always&&left.type==B1
							||(left.type==Us && parent!=null && parent.type==B1 && parent.right[0]==this )
							||left.type<B1 ) {
							L=addParenthesis((Node) left,L,ec.p,ec.separate);
	 					}
 						Formula R=((Node) right[0]).toFormula(ec);
						if (  ec.par_always&&right[0].type==B1
							||right[0].type<B1||right[0].type==Us||right[0].symb==SUMA) {
							R=addParenthesis((Node) right[0],R,ec.p,ec.separate);
						}
						F.insertFormula(L,ec.separate);
						F.insertString(symbstr);
						F.insertFormula(R,ec.separate);
					} else if (symb==MENOS){
 						Formula L=((Node) left).toFormula(ec);
						if (  ec.par_always&&left.type==B1
							||(left.type==Us && parent!=null && parent.type==B1 && parent.right[0]==this )
							||left.type<B1 ) {
							L=addParenthesis((Node) left,L,ec.p,ec.separate);
	 					}
 						Formula R=((Node) right[0]).toFormula(ec);
						if (right[0].type<=B1||right[0].type==Us||right[0].symb==SUMA) {
							R=addParenthesis((Node) right[0],R,ec.p,ec.separate);
						}
						F.insertFormula(L,ec.separate);
						F.insertString(symbstr);
						F.insertFormula(R,ec.separate);
					} else {
						Formula L=((Node) left).toFormula(ec);
 						Formula R=((Node) right[0]).toFormula(ec);
						F.insertFormula(L,ec.separate);
						F.insertString(symbstr);
						F.insertFormula(R,ec.separate);
					}
					break;
			case As: ((Node) left).insertInFormula(F,ec,separate);
					F.insertString("=");
					((Node) right[0]).insertInFormula(F,ec,separate);
					break;
		}
	}

	static Formula addParenthesis(Node n,Formula F,Parser p,boolean separate) {
		Formula G=new Formula(p);
		G.insertString("(");
		G.insertFormula(F,separate);
		G.insertString(")");
		G.setNode(n);
		return G;
	}

/* ------------------ Formula to Node ------------------- */

	public static Node formulaToNode(Formula F,Parser p) {
		String expr=F.toExpresion(true);
		Node N=p.Analyse(expr);
		N.setParents();
		return N;
	}
}

class exprCfg {
	Parser p;
	String por_str="";
	boolean separate=false;
	boolean msa=false;
	boolean par_always=true;


	exprCfg(Parser p, String por_str, boolean separate, boolean msa,boolean par_always) {
		this.p=p;
		this.por_str=por_str;
		this.separate=separate;
		this.msa=msa;
		this.par_always=par_always;
	}
}