/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.parser;

import java.util.Vector;

public class Node_A {
	
/* ------------------- Opraciones algebraicas ------------------- */

	public static Node Multiply(Node N0,boolean recursive,boolean all) {
		Node N=N0.cloneNode();
		N=eliminateZeroAndOneInProductsAndFractions(N,recursive);
		if (recursive&&!all) {
			if (N.left!=null) {
				N.left=Multiply(N.left,recursive,all);
			}
			if (N.right!=null) {
				for (int i=0;i<N.right.length;i++) {
					N.right[i]=Multiply(N.right[i],recursive,all);
				}
			}
		}
		if (N.symb==Node.POR) {
			Node A=N.left;
			Node B=N.right[0];
			if (A.type==Node.Vi && Node.isNumber(A.symbstr) && B.type==Node.Vi && Node.isNumber(B.symbstr) ) {
				N=orderAlphabetically(N,false);
				N=associateOnTheLeft(N,false);
				A=N.left;		// Se vuelven a definir porque pueden haber cambiado.
				B=N.right[0];
				N=new Node(N.parser,A.getDouble()*B.getDouble());
			} else if (A.toExpression(true).equals(B.toExpression(true))) {
				N=new Node(N0.parser,Node.B3,Node.EXPON,"^");
				N.left=A;
				N.right=new Node[1];
				N.right[0]=new Node(N.parser,2);
			} else if (A.symb==Node.EXPON&&B.symb==Node.EXPON) {
				if (A.left.toExpression(true).equals(B.left.toExpression(true))) {
					N=new Node(N0.parser,Node.B3,Node.EXPON,"^");
					N.left=A.left;
					N.right=new Node[1];
					N.right[0]=new Node(N0.parser,Node.B1,Node.MAS,"+");
					N.right[0].left=A.right[0];
					N.right[0].right=new Node[1];
					N.right[0].right[0]=B.right[0];
				}
			} else if (B.symb==Node.EXPON
					&& A.toExpression(true).equals(((Node) B.left).toExpression(true))) {
				N=new Node(N0.parser,Node.B3,Node.EXPON,"^");
				N.left=A;
				N.right=new Node[1];
				N.right[0]=new Node(N0.parser,Node.B1,Node.MAS,"+");
				N.right[0].left=new Node(N0.parser,1);
				N.right[0].right=new Node[1];
				N.right[0].right[0]=B.right[0];
			} else if (B.symb==Node.DIV) {
				if (A.toExpression(true).equals(((Node) B.right[0]).toExpression(true))) {
					N=(Node) B.left;
				} else {
					Node L=(Node) B.left;
					N=B;
					N.left=new Node(N0.parser,Node.B2,Node.POR,"*");
					N.left.left=A;
					N.left.right=new Node[1];
					N.left.right[0]=L;
				}
			} else if 	(N.getLeft().getType()==Node.B1
						||N.getRight()[0].getType()==Node.B1) {
				N=distributeFactor(N,false,false);
			} else if (N.getRight()[0].getSymbol().equals("-")
					&& N.getRight()[0].getType()==Node.Us) {
				N=factorUnaryMinusOnProductsAndFractions(N,false);
			} else if (N.getLeft().getSymbol().equals("-")
					&& N.getLeft().getType()==Node.Us) {
				N=factorUnaryMinusOnProductsAndFractions(N,false);
			} else if (N.getLeft().getType()==Node.B1) {
				N=factorize(N,false,false);
			} else if (N.getRight()[0].getType()==Node.B1) {
				N=factorize(N,false,false);
			} else {
				N.left=B;
				N.right[0]=A;
			}
		} else if (N.symb==Node.EXPON) {
			Node A=(Node) N.left;
			Node B=(Node) N.right[0];
			if (A.type==Node.Vi && Node.isNumber(A.symbstr) && B.type==Node.Vi && Node.isNumber(B.symbstr) ) {
				try {
					N=new Node(N0.parser,N0.expon(N0,A.getDouble(),B.getDouble()));
				} catch (Exception e) {
				}
			} else if (A.symb==Node.EXPON) {
				N=new Node(N0.parser,Node.B3,Node.EXPON,"^");
				N.left=A.left;
				N.right=new Node[1];
				N.right[0]=new Node(N0.parser,Node.B2,Node.POR,"*");
				N.right[0].left=A.right[0];
				N.right[0].right=new Node[1];
				N.right[0].right[0]=B;
			} else if (B.type==Node.B1&&B.symb==Node.MAS) {
				N=new Node(N0.parser,Node.B2,Node.POR,"*");
				N.left=new Node(N0.parser,Node.B3,Node.EXPON,"^");
				N.left.left=A;
				N.left.right=new Node[1];
				N.left.right[0]=B.left;
				N.right=new Node[1];
				N.right[0]=new Node(N0.parser,Node.B3,Node.EXPON,"^");
				N.right[0].left=A.cloneNode();
				N.right[0].right=B.right;
			} else if (B.symb==Node.POR) {
				N=new Node(N0.parser,Node.B3,Node.EXPON,"^");
				N.left=new Node(N0.parser,Node.B3,Node.EXPON,"^");;
				N.left.left=A;
				N.left.right=new Node[1];
				N.left.right[0]=B.left;
				N.right=B.right;
			} else if (B.symb==Node.DIV) {
				if (B.right[0].symbstr.equals("2")) {
					N=new Node(N0.parser,Node.Ua,Node.SQRT,"sqrt");
					N.left=B.right[0];
					N.right=new Node[1];
					N.right[0]=new Node(N0.parser,Node.B3,Node.EXPON,"^");
					N.right[0].left=A;
					N.right[0].right=new Node[1];
					N.right[0].right[0]=B.left;
				}
			}
		} else if (N.symb==Node.SQRT) {
			Node A=(Node) N.right[0];
			if (A.symb==Node.EXPON) {
				N=new Node(N0.parser,Node.B3,Node.EXPON,"^");
				N.left=A.left;
				N.right=new Node[1];
				N.right[0]=new Node(N0.parser,Node.B2,Node.DIV,"/");
				N.right[0].left=A.right[0];
				N.right[0].right=new Node[1];
				N.right[0].right[0]=new Node(N0.parser,2);
			} else if (A.symb==Node.VAR && Node.isNumber(A.symbstr)) {
				N=new Node(N0.parser,Math.sqrt(A.getDouble()));
			} else {
				N=new Node(N0.parser,Node.B3,Node.EXPON,"^");
				N.left=A;
				N.right=new Node[1];
				N.right[0]=new Node(N0.parser,Node.B2,Node.DIV,"/");
				N.right[0].left=new Node(N0.parser,1);
				N.right[0].right=new Node[1];
				N.right[0].right[0]=new Node(N0.parser,2);
			}
		}
		if (recursive&&all) {
			if (N.left!=null) {
				N.left=Multiply(N.left,recursive,all);
			}
			if (N.right!=null) {
				for (int i=0;i<N.right.length;i++) {
					N.right[i]=Multiply(N.right[i],recursive,all);
				}
			}
		}
		return N;
	}

	public static Node orderAlphabetically(Node N0,boolean recursive) {
		Node N=N0.cloneNode();
		if (N.symb==Node.POR || (N.symb==Node.MAS && N.type==Node.B1)) {
			Vector V=new Vector();
			N.addOperandNodes(N.type,N.symb,V);
			order(V,N.symb==Node.MAS);
			Node n=N;
			for (int i=0;i<V.size()-1;i++) {
				Node ni=(Node) V.elementAt(i);
				n.left=ni;
				n.right=new Node[1];
				if (i<V.size()-2) {
					n.right[0]=new Node(N0.parser,N.type,N.symb,N.symbstr);
					n=(Node) n.right[0];
				} else {
					ni=(Node) V.elementAt(i+1);
					n.right[0]=ni;
				}
			}
		} else if (N.symb==Node.SUMA) {
			Vector V=new Vector();
			for (int i=0;i<N.right.length;i++) {
				V.addElement(N.right[i]);
			}
			order(V,true);
			for (int i=0;i<N.right.length;i++) {
				N.right[i]=(Node) V.elementAt(i);
			}
		}
		if (recursive) {
			if (N.left!=null) {
				N.left=orderAlphabetically(N.left,recursive);
			}
			if (N.right!=null) {
				for (int j=0;j<N.right.length;j++) {
					if (N.right[j]!=null) {
						N.right[j]=orderAlphabetically(N.right[j],recursive);
					}
				}
			}
		}
		return N;
	}

	/* -------------------------------------------------- */

		private static void order(Vector V,boolean direct) {
			for (int j=1;j<V.size();j++) {
				Node nj=(Node)V.elementAt(j);
				for (int i=0;i<j;i++) {
					Node ni=(Node)V.elementAt(i);
					if (alfaLessThan(nj,ni,direct)) {
						V.removeElementAt(j);
						V.insertElementAt(nj,i);
						break;
					}
				}
			}
		}

		private static boolean alfaLessThan(Node N0,Node N,boolean direct) {
			String s1=getMainSymbolStr(N0,direct);
			String s2=getMainSymbolStr(N,direct);
			int comp=0;
			comp=s1.toLowerCase().compareTo(s2.toLowerCase());
			if (!direct) comp=-comp;
			if (comp<0) {
				return true;
			} else if (comp>0) {
				return false;
			}
			if (!direct) comp=-comp;
			comp=s1.compareTo(s2);
			if (comp<0) {
				return true;
			} else if (comp>0) {
				return false;
			}
			/*----- to avoid zero traps like -x+x ------*/
			String S1=N0.toExpression(false);
			String S2=N.toExpression(false);
			comp=-S1.toLowerCase().compareTo(S2.toLowerCase());
			if (!direct) comp=-comp;
			if (comp<0) {
				return true;
			} else if (comp>0) {
				return false;
			}
			comp=S1.compareTo(S2);
			if (!direct) comp=-comp;
			if (comp<0) {
				return true;
			} else {
				return false;
			}
		}

		private static String getMainSymbolStr(Node N0,boolean direct) {
			String s="";
			if (N0.type==Node.Us&&(N0.symb==Node.MENOS||N0.symb==Node.MAS)) {
				s+=getMainSymbolStr(N0.right[0],direct);
			} else if (Node.B1<=N0.type && N0.type<=Node.B3) {
//				switch (type) {
//					case Node.B1 : s="3"; break;
//					case Node.B2 : s="2"; break;
//					case Node.B3 : s="1"; break;
//				}
				s+="0";
				s+=getMainSymbolStr(N0.left,direct);
				s+=getMainSymbolStr(N0.right[0],direct);
			} else if (N0.type==Node.Vi) {
				if (Node.isNumber(N0.symbstr)) {
					String s1="",s2="";
					int pos=N0.symbstr.indexOf(".");
					if (pos>0) {
						s1=N0.symbstr.substring(0,pos);
						s2=N0.symbstr.substring(pos+1);
					} else {
						s1=N0.symbstr;
					}
					while (s1.length()<32) {
						s1=" "+s1;
					}
					while (s2.length()<32) {
						s2=s2+"0";
					}
					s+=s1+"."+s2;
					s="8"+s;
				} else {
					s="7"+N0.symbstr;
					if (N0.symbstr.startsWith("x")||
						N0.symbstr.startsWith("y")||
						N0.symbstr.startsWith("z")) {
						s="6"+N0.symbstr;
					}
				}
			} else {
				s+="9"+N0.symbstr;
			}
			return s;
		}

/* ------------------- FACTORIZATION -------------------- */

	public static Node factorize(Node N0,boolean recursive,boolean all) {
		Node N=N0.cloneNode();
		if (recursive) {
			if (N.left!=null) {
				N.left=factorize(N.left,recursive,all);
			}
			if (N.right!=null) {
				for (int j=0;j<N.right.length;j++) {
					if (N.right[j]!=null) {
						N.right[j]=factorize(N.right[j],recursive,all);
					}
				}
			}
		}
		if (N.type==Node.B1 && (N.symb==Node.MAS||N.symb==Node.MENOS)) {
			Node F=Factorize(N.symb==Node.MAS,N.left,N.right[0]);
			if (F!=null) {
				N=F;
			}
		} else if (N.type==Node.Ua && N.symb==Node.SUMA) {
			Node F=null;
			for (int i=0;i<N.right.length;i++) {
				for (int j=i+1;j<N.right.length;j++) {
					F=Factorize(true,N.right[i],N.right[j]);
					if (F!=null) {
						N.right[i]=F;
						N.right[j]=new Node(N0.parser,0);
						break;
					}
				}
				if (F!=null) break;
			}
			if (F!=null) {
				N=eliminateAddedZero(N,true);
				if (recursive) {
					N=factorize(N,recursive,all);
				}
			}
		}
		if (all) {
			if (N.left!=null) {
				N.left=factorize(N.left,recursive,all);
			}
			if (N.right!=null) {
				for (int j=0;j<N.right.length;j++) {
					if (N.right[j]!=null) {
						N.right[j]=factorize(N.right[j],recursive,all);
					}
				}
			}
		}
		return N;
	}

	private static Node Factorize(boolean mas,Node L,Node R) {
		boolean chngsgn=false;
		boolean L_menos=false;
		if (L.type==Node.Us && L.symb==Node.MENOS) {
			L=(Node) L.right[0];
			L_menos=true;
			chngsgn=!chngsgn;
		}
		boolean R_menos=false;
		if (R.type==Node.Us && R.symb==Node.MENOS) {
			R=(Node) R.right[0];
			R_menos=true;
			chngsgn=!chngsgn;
		}
		if (chngsgn) {
			mas=!mas;
		}
		Node F=null;
		if (L.symb==Node.POR&&R.symb==Node.POR) {
			F=Factorize(mas,(Node) L.left,(Node) L.right[0],(Node) R.left,(Node) R.right[0]);
		} else {
			Node One=new Node(L.parser,1);
			if (L.symb==Node.POR) {
				F=Factorize(mas,(Node) L.left,(Node) L.right[0],(Node) One,(Node) R);
			} else if (R.symb==Node.POR) {
				F=Factorize(mas,One,L,R.left,R.right[0]);
			} else {
				String s1=canonizeComm(L).toExpression(true);
				String s2=canonizeComm(R).toExpression(true);
				int symb=Node.MAS;
				String sys="+";
				if (!mas) {
					symb=Node.MENOS;
					sys="-";
				}
				if (s1.equals(s2)) {
					F=(Node) new Node(L.parser,Node.B2,Node.POR,"*");
					F.left=new Node(L.parser,Node.B1,symb,sys);
					F.left.left=new Node(L.parser,1);
					F.left.right=new Node[1];
					F.left.right[0]=new Node(L.parser,1);
//					F.left=new Node(2);
					F.right=new Node[1];
					F.right[0]=L;
				}
			}
		}
		return F;
	}

	private static Node Factorize(boolean mas,Node A0,Node B0,Node C0,Node D0) {
		int symb=Node.MAS;
		String symbstr="+";
		if (!mas) {
			symb=Node.MENOS;
			symbstr="-";
		}
		Node A=canonizeComm(A0);
		Node B=canonizeComm(B0);
		Node C=canonizeComm(C0);
		Node D=canonizeComm(D0);
		String sA=A.toExpression(true);
		String sB=B.toExpression(true);
		String sC=C.toExpression(true);
		String sD=D.toExpression(true);
		Node auxN=null;
		if (sA.equals(sC)) {
			auxN=(Node) new Node(A0.parser,Node.B2,Node.POR,"*");
			auxN.left=A0;  // A * ( B + D )
			auxN.right=new Node[1];
			auxN.right[0]=new Node(A0.parser,Node.B1,symb,symbstr);
			auxN.right[0].left=B0; // = B
			auxN.right[0].right=new Node[1];
			auxN.right[0].right[0]=D0;  // =D)
		} else if (sA.equals(sD)) {
			auxN=(Node) new Node(A0.parser,Node.B2,Node.POR,"*");
			auxN.left=A0;  // A * ( B + C )
			auxN.right=new Node[1];
			auxN.right[0]=new Node(A0.parser,Node.B1,symb,symbstr);
			auxN.right[0].left=B0; // = B
			auxN.right[0].right=new Node[1];
			auxN.right[0].right[0]=C0;  // =C)
		} else if (sB.equals(sD)) {
			auxN=(Node) new Node(A0.parser,Node.B2,Node.POR,"*");
			auxN.left=new Node(A0.parser,Node.B1,symb,symbstr);
			auxN.left.left=A0;  // A
			auxN.left.right=new Node[1];
			auxN.left.right[0]=C0;  // C
			auxN.right=new Node[1];
			auxN.right[0]=B0; // B
		} else if (sB.equals(sC)) {
			auxN=(Node) new Node(A0.parser,Node.B2,Node.POR,"*");
			auxN.left=new Node(A0.parser,Node.B1,symb,symbstr);
			auxN.left.left=A0;  // A
			auxN.left.right=new Node[1];
			auxN.left.right[0]=D0;  // D
			auxN.right=new Node[1];
			auxN.right[0]=B0; // B
		}
		return auxN;
	}
	
/* ----------------------- Association ------------------------ */

	public static Node associateOnTheLeft(Node N0,boolean recursive) {
		Node N=N0.cloneNode();
		int n=0;
		if ((N.symb==Node.POR) || (N.symb==Node.MAS&&N.type==Node.B1) ) {
			while (N.symb==N.right[0].symb && N.type==N.right[0].type) {
				Node A=N.left;
				Node B=N.right[0].left;
				Node C=N.right[0].right[0];
				N.left=new Node(N0.parser,N.type,N.symb,N.symbstr);
				N.left.left=A;
				N.left.right=new Node[1];
				N.left.right[0]=B;
				if (recursive) {
					N.left=associateOnTheLeft(N.left,recursive);
				}
				N.right[0]=C;
				if (!recursive) {
					break;
				}
			}
		}
		if (recursive) {
			if (N.left!=null) {
				N.left=associateOnTheLeft(N.left,recursive);
			}
			if (N.right!=null) {
				for (int j=0;j<N.right.length;j++) {
					if (N.right[j]!=null) {
						N.right[j]=associateOnTheLeft(N.right[0],recursive);
					}
				}
			}
		}
		return N;
	}

	public static Node associateOnTheRight(Node N0,boolean recursive) {
		Node N=N0.cloneNode();
		if ((N.symb==Node.POR) || ((N.symb==Node.MAS)&&(N.type==Node.B1)) ) {
			while ((N.symb==N.left.symb) && (N.type==N.left.type)) {
				Node A=N.left.left;
				Node B=N.left.right[0];
				Node C=N.right[0];
				N.left=A;
				N.right=new Node[1];
				N.right[0]=new Node(N0.parser,N.type,N.symb,N.symbstr);
				N.right[0].left=B;
				N.right[0].right=new Node[1];
				N.right[0].right[0]=C;
				if (recursive) {
					N.right[0]=associateOnTheRight(N.right[0],recursive);
				}
				if (!recursive) {
					break;
				}
			}
		}
		if (recursive) {
			if (N.left!=null) {
				N.left=associateOnTheRight(N.left,recursive);
			}
			if (N.right!=null) {
				for (int j=0;j<N.right.length;j++) {
					if (N.right[j]!=null) {
						N.right[j]=associateOnTheRight(N.right[j],recursive);
					}
				}
			}
		}
		return N;
	}
	
/* --------------------- Eliminate 0 and/or 1 ----------------------- */

	public static Node eliminateAddedZero(Node N0,boolean recursive) {
		Node N=N0.cloneNode();
		if (recursive) {
			if (N.left!=null) {
				N.left=eliminateAddedZero(N.left,recursive);
			}
			if (N.right!=null) {
				for (int i=0;i<N.right.length;i++) {
					N.right[i]=eliminateAddedZero(N.right[i],recursive);
				}
			}
		}
		if (N.type==Node.Us && (N.symb==Node.MAS||N.symb==Node.MENOS)) {
			if ((N.right[0].type==Node.Vi) && "0".equals(N.right[0].symbstr)) {
				N=N.right[0];
			}
		} else if (N.type==Node.B1 && N.symb==Node.MAS) {
			if ((N.right[0].type==Node.Vi) && "0".equals(N.right[0].symbstr)) {
				N=N.left;
			} else if ((N.left.type==Node.Vi) && "0".equals(N.left.symbstr)) {
				N=N.right[0];
			}
		} else if (N.type==Node.B1 && N.symb==Node.MENOS) {
			if (N.right[0].type==Node.Vi && "0".equals(N.right[0].symbstr)) {
				N=N.left;
			} else if ((N.left.type==Node.Vi) && "0".equals(N.left.symbstr)) {
				Node A=N.right[0];
				N=new Node(N0.parser,Node.Us,Node.MENOS,"-");
				N.right=new Node[1];
				N.right[0]=A;
				N=((Node) N).eliminateConsecutiveUnarySigns(false);
			}
		} else if (N.symb==Node.SUMA) {
			Vector V=new Vector();
			for (int i=0;i<N.right.length;i++) {
				if (!((N.right[i].type==Node.Vi) && "0".equals(N.right[i].symbstr))) {
					V.addElement(N.right[i]);
				}
			}
			if (V.size()==0) {
				N=new Node(N0.parser,0.0);
			} else if (V.size()==1) {
				N=(Node) V.elementAt(0);
			} else if (V.size()<N.right.length) {
				N.right=new Node[V.size()];
				for (int i=0;i<N.right.length;i++) {
					N.right[i]=(Node) V.elementAt(i);
				}
			}
		}
		if (recursive) {
			if (N.left!=null) {
				N.left=eliminateAddedZero(N.left,recursive);
			}
			if (N.right!=null) {
				for (int i=0;i<N.right.length;i++) {
					N.right[i]=eliminateAddedZero(N.right[i],recursive);
				}
			}
		}
		return (Node) N;
	}

	public static Node eliminateZeroAndOneInProductsAndFractions(Node N0,boolean recursive) {
		Node N=N0.cloneNode();
		if (recursive) {
			if (N.left!=null) {
				N.left=eliminateZeroAndOneInProductsAndFractions(N.left,recursive);
			}
			if (N.right!=null) {
				for (int i=0;i<N.right.length;i++) {
					N.right[i]=eliminateZeroAndOneInProductsAndFractions(N.right[i],recursive);
				}
			}
		}
		if (N.symb==Node.POR) {
			if ((N.left.type==Node.Vi && "0".equals(N.left.symbstr))
				|| (N.right[0].type==Node.Vi && "0".equals(N.right[0].symbstr)) ) {
				N=new Node(N0.parser,0.0);
			} else if (N.left.type==Node.Vi && "1".equals(N.left.symbstr)) {
				N=N.right[0];
			} else if (N.right[0].type==Node.Vi && "1".equals(N.right[0].symbstr)) {
				N=N.left;
			}
		} else if (N.symb==Node.DIV && !(N.right[0].type==Node.Vi && "0".equals(N.right[0].symbstr)) ) {
			if (N.left.type==Node.Vi && "0".equals(N.left.symbstr)) {
				N=new Node(N0.parser,0.0);
			} else if (N.right[0].type==Node.Vi && "1".equals(N.right[0].symbstr)) {
				N=N.left;
			}
		}
		if (recursive) {
			if (N.left!=null) {
				N.left=eliminateZeroAndOneInProductsAndFractions(N.left,recursive);
			}
			if (N.right!=null) {
				for (int i=0;i<N.right.length;i++) {
					N.right[i]=eliminateZeroAndOneInProductsAndFractions(N.right[i],recursive);
				}
			}
		}
		return (Node) N;
	}

	public static Node factorUnaryMinusOnProductsAndFractions(Node N0,boolean recursive) {
		Node N=N0.cloneNode();
		if (recursive) {
			if (N.left!=null) {
				N.left=factorUnaryMinusOnProductsAndFractions(N.left,recursive);
			}
			if (N.right!=null) {
				for (int j=0;j<N.right.length;j++) {
					if (N.right[j]!=null) {
						N.right[j]=factorUnaryMinusOnProductsAndFractions(N.right[j],recursive);
					}
				}
			}
		}
		N=((Node) N).eliminateConsecutiveUnarySigns(false);
		if (N.symb==Node.POR||N.symb==Node.DIV) {
			int numminus=0;
			if (N.left.type==Node.Us && N.left.symb==Node.MENOS) {
				numminus++;
				N.left=N.left.right[0];
			}
			if (N.right[0].type==Node.Us && N.right[0].symb==Node.MENOS) {
				numminus++;
				N.right[0]=N.right[0].right[0];
			}
			if (numminus==1) {
				Node aux=N;
				N=new Node(N0.parser,Node.Us,Node.MENOS,"-");
				N.right=new Node[1];
				N.right[0]=aux;
				N=((Node) N).eliminateConsecutiveUnarySigns(false);
			}
		}
		return (Node) N;
	}
	
	public static Node eliminateUnnecessaryZerosAndOnes(Node N0,boolean recursive) {
		Node N=N0.cloneNode();
		if (recursive) {
			if (N.left!=null) {
				N.left=eliminateUnnecessaryZerosAndOnes(N.left,recursive);
			}
			if (N.right!=null) {
				for (int i=0;i<N.right.length;i++) {
					N.right[i]=eliminateUnnecessaryZerosAndOnes(N.right[i],recursive);
				}
			}
		}
		if (N.symb==Node.POR) {
			if ((N.left.type==Node.Vi && "0".equals(N.left.symbstr))
				|| (N.right[0].type==Node.Vi && "0".equals(N.right[0].symbstr)) ) {
				N=(Node) new Node(N0.parser,0.0);
			} else if (N.left.type==Node.Vi && "1".equals(N.left.symbstr)) {
				N=(Node) N.right[0];
			} else if (N.right[0].type==Node.Vi && "1".equals(N.right[0].symbstr)) {
				N=(Node) N.left;
			}
		} else if (N.symb==Node.DIV && !(N.right[0].type==Node.Vi && "0".equals(N.right[0].symbstr)) ) {
			if (N.left.type==Node.Vi && "0".equals(N.left.symbstr)) {
				N=(Node) new Node(N0.parser,0.0);
			} else if (N.right[0].type==Node.Vi && "1".equals(N.right[0].symbstr)) {
				N=(Node) N.left;
			}
		} else if (N.type==Node.B1 && (N.symb==Node.MAS || N.symb==Node.MENOS)) {
			if (N.left.type==Node.Vi && "0".equals(N.left.symbstr)) {
				if (N.symb==Node.MAS) {
					N=(Node) N.right[0];
				} else {
					Node[] A=N.right;
					N=(Node) new Node(N0.parser,Node.Us,Node.MENOS,"-");
					N.right=A;
				}
			} else if (N.right[0].type==Node.Vi && "0".equals(N.right[0].symbstr)) {
				N=(Node) N.left;
			}
		}
		if (recursive) {
			if (N.left!=null) {
				N.left=eliminateUnnecessaryZerosAndOnes(N.left,recursive);
			}
			if (N.right!=null) {
				for (int i=0;i<N.right.length;i++) {
					N.right[i]=eliminateUnnecessaryZerosAndOnes(N.right[i],recursive);
				}
			}
		}
		return N;
	}

/* ---------------------- Distribution ---------------------- */

	public static Node distributeFactor(Node N0,boolean recursive,boolean all) {
		Node N=N0.cloneNode();
		if (recursive&&all) {
			if (N.left!=null) {
				N.left=distributeFactor(N.left,recursive,all);
			}
			if (N.right!=null) {
				for (int j=0;j<N.right.length;j++) {
					if (N.right[j]!=null) {
						N.right[j]=distributeFactor(N.right[j],recursive,all);
					}
				}
			}
		}
		if (N.symb==Node.POR) {
			Node A=null,B=null,C=null;
			Node[] b,c;
			if ( (N.right[0].type==Node.B1 && (N.right[0].symb==Node.MAS||N.right[0].symb==Node.MENOS))
			    || (N.right[0].type==Node.Ua && N.right[0].symb==Node.SUMA) ) {
				A=N.left;
				B=N.right[0].left;
				c=N.right[0].right;
				if (c.length>1) {
					N=new Node(N0.parser,Node.Ua,Node.SUMA,"suma");
					N.right=new Node[c.length];
					for (int i=0;i<c.length;i++) {
						N.right[i]=new Node(N0.parser,Node.B2,Node.POR,"*");
						N.right[i].left=A.cloneNode();
						N.right[i].right=new Node[1];
						N.right[i].right[0]=c[i];
						if (recursive) {
							N.right[i]=distributeFactor(N.right[i],recursive,all);
						}
					}
				} else {
					N=new Node(N0.parser,Node.B1,N.right[0].symb,N.right[0].symbstr);
					N.left=new Node(N0.parser,Node.B2,Node.POR,"*");
					N.left.left=A;
					N.left.right=new Node[1];
					N.left.right[0]=B;
					if (recursive) {
						N.left=distributeFactor(N.left,recursive,all);
					}
					N.right=new Node[1];
					N.right[0]=new Node(N0.parser,Node.B2,Node.POR,"*");
					N.right[0].left=A.cloneNode();
					N.right[0].right=c;
					if (recursive) {
						N.right[0]=distributeFactor(N.right[0],recursive,all);
					}
				}
			} else if ( (N.left.type==Node.B1 && (N.left.symb==Node.MAS ||N.left.symb==Node.MENOS))
					 || (N.left.type==Node.Ua&&N.left.symb==Node.SUMA) ) {
				A=N.left.left;
				b=N.left.right;
				C=N.right[0];
				if (b.length>1) {
					N=new Node(N0.parser,Node.Ua,Node.SUMA,"suma");
					N.right=new Node[b.length];
					for (int i=0;i<b.length;i++) {
						N.right[i]=new Node(N0.parser,Node.B2,Node.POR,"*");
						N.right[i].left=b[i];
						if (recursive) {
							N.right[i].left=distributeFactor(N.right[i].left,recursive,all);
						}
						N.right[i].right=new Node[1];
						N.right[i].right[0]=C.cloneNode();;
						if (recursive) {
							N.right[i]=distributeFactor(N.right[i],recursive,all);
						}
					}
				} else {
					N=new Node(N0.parser,Node.B1,N.left.symb,N.left.symbstr);
					N.left=new Node(N0.parser,Node.B2,Node.POR,"*");
					N.left.left=A;
					N.left.right=new Node[1];
					N.left.right[0]=C;
					if (recursive) {
						N.left=distributeFactor(N.left,recursive,all);
					}
					N.right=new Node[1];
					N.right[0]=new Node(N0.parser,Node.B2,Node.POR,"*");
					N.right[0].right=new Node[1];
					N.right[0].left=b[0];
					N.right[0].right[0]=C.cloneNode();
					N.right[0]=distributeFactor(N.right[0],recursive,all);
				}
			}
		}
		if (recursive&&!all) {
			if (N.left!=null) {
				N.left=distributeFactor(N.left,recursive,all);
			}
			if (N.right!=null) {
				for (int j=0;j<N.right.length;j++) {
					if (N.right[j]!=null) {
						N.right[j]=distributeFactor(N.right[j],recursive,all);
					}
				}
			}
		}
		return (Node) N;
	}

/* --------------------------- Cannonization ----------------------------- */

	public static Node canonizeComm(Node N0) {
		Node N=N0.cloneNode();
		N=N.eliminateParenthesis(true,true);
		N=doCanonizeComm(N,true);
		N=N.distributeUnaryMinusInSums(false,false); // to avoid zero Trap -(x-x)
		return N;
	}

	private static Node doCanonizeComm(Node N0,boolean recursive) {
		Node N=N0.cloneNode();
		if (recursive) {
			if (N.left!=null) {
				N.left=doCanonizeComm(N.left,recursive);
			}
			if (N.right!=null) {
				for (int i=0;i<N.right.length;i++) {
					N.right[i]=doCanonizeComm(N.right[i],recursive);
				}
			}
		}
		int n=0;
		while (n<10) {
			int i=0;
			String s=N.toExpression(true);
			N=factorUnaryMinusOnProductsAndFractions(N,true);
			N=orderAlphabetically(N,true);
			N=extractFirstUnaryMinusInSums(N,true);
			N=orderAlphabetically(N,true);
			N=associateOnTheLeft(N,true);
			if (n>10 || s.equals(N.toExpression(true))) {
				break;
			}
			n++;
		}
		if (n>1) {
			System.out.println("INDIRECT "+n+" "+N0.toExpression(true));
		}
		return (Node) N;
	}

	public static Node extractFirstUnaryMinusInSums(Node N0,boolean recursive) {
		Node N=N0.cloneNode();
		if (recursive) {
			if (N.left!=null) {
				N.left=extractFirstUnaryMinusInSums(N.left,recursive);
			}
			if (N.right!=null) {
				for (int j=0;j<N.right.length;j++) {
					if (N.right[j]!=null) {
						N.right[j]=extractFirstUnaryMinusInSums(N.right[j],recursive);
					}
				}
			}
		}
		if (N.type==Node.B1&&N.symb==Node.MAS) {
			if (N.left.type==Node.Us && N.left.symb==Node.MENOS) {
				Node A=N.left.right[0];
				Node[] B=N.right;
				N=(Node) new Node(N0.parser,Node.Us,Node.MENOS,"-");
				N.right=new Node[1];
				N.right[0]=new Node(N0.parser,Node.B1,Node.MENOS,"-");
				N.right[0].left=A;
				N.right[0].right=B;
			}
		} else if (N.type==Node.Ua&&N.symb==Node.SUMA) {
			if (N.right[0].type==Node.Us && N.right[0].symb==Node.MENOS) {
				Node[] A=N.right;
				N=(Node) new Node(N0.parser,Node.Us,Node.MENOS,"-");
				N.right=new Node[1];
				N.right[0]=new Node(N0.parser,Node.Ua,Node.SUMA,"suma");
				N.right[0].right=new Node[A.length];
				for (int i=0;i<A.length;i++) {
					if (A[i].type==Node.Us&&A[i].symb==Node.MENOS) {
						N.right[0].right[i]=A[i].right[0];
					} else {
						N.right[0].right[i]=new Node(N0.parser,Node.Us,Node.MENOS,"-");
						N.right[0].right[i].right=new Node[1];
						N.right[0].right[i].right[0]=A[i];
						N.right[0].right[i]=((Node) N.right[0].right[i]).eliminateConsecutiveUnarySigns(false);
					}
				}
			}
		}
		if (recursive) {
			if (N.left!=null) {
				N.left=extractFirstUnaryMinusInSums(N.left,recursive);
			}
			if (N.right!=null) {
				for (int j=0;j<N.right.length;j++) {
					if (N.right[j]!=null) {
						N.right[j]=extractFirstUnaryMinusInSums(N.right[j],recursive);
					}
				}
			}
		}
		return (Node) N.eliminateConsecutiveUnarySigns(false);
	}

/* ---------- convert expressions to canonical form --------- */

	public static String toCommCanonicalForm(Node N0) {
		Node N=canonizeComm(N0);
		return N.toExpression(true);
	}


/* --------------------- Simplify Nodes --------------------- */
/* ----------------------  (NOT USED) ----------------------- */

//	public Node Simplify(Node N0) {
//		Node N=canonizeComm(N0);
//		N=doSimplify(N,true,true);
//		N=orderAlphabetically(N,true);
//		return N;
//	}
//
//	private Node doSimplify(Node N0,boolean recursive,boolean all) {
//		Node N=N0.cloneNode();
//		if (recursive) {
//			if (N.left!=null) {
//				N.left=doSimplify(N.left,recursive,all);
//			}
//			if (N.right!=null) {
//				for (int i=0;i<N.right.length;i++) {
//					N.right[i]=doSimplify(N.right[i],recursive,all);
//				}
//			}
//		}
//		String s="",S=" ";
//		int n=0;
//		while (!s.equals(S=N.toExpression(true))&& n++<=10) {
//			s=S;
//			N=Sum(N,recursive,all);
//			N=Subtract(N,recursive,all);
//			N=factorUnaryMinusOnProductsAndFractions(N,recursive);
//			N=distributeFactor(N,recursive,all);
//			N=Multiply(N,recursive,all);
//			N=N.eliminateParenthesis(recursive,all);
//			N=factorize(N,recursive,all);
//			N=distributeDenominator(N,recursive,all);
//			N=Divide(N,recursive,all);
//			N=extractCommonDenominator(N,recursive,all);
//		}
//		if (!s.equals(S)) {
//			System.out.println("Simplificacin incompleta "+S);
//		}
//		if (all) {
//			if (N.left!=null) {
//				N.left=doSimplify(N.left,recursive,all);
//			}
//			if (N.right!=null) {
//				for (int i=0;i<N.right.length;i++) {
//					N.right[i]=doSimplify(N.right[i],recursive,all);
//				}
//			}
//		}
//		return (Node) N;
//	}
//
//	public Node Sum(Node N0,boolean recursive,boolean all) {
//		Node N=N0.cloneNode();
//		N=eliminateAddedZero(N,recursive);
//		if (recursive&&all) {
//			if (N.left!=null) {
//				N.left=Sum(N.left,recursive,all);
//			}
//			if (N.right!=null) {
//				for (int i=0;i<N.right.length;i++) {
//					N.right[i]=Sum(N.right[i],recursive,all);
//				}
//			}
//		}
//		if (N.type==Node.B1 && N.symb==Node.MAS) {
//			Node A=N.left;
//			Node B=N.right[0];
//			if (A.type==Node.Vi && Node.isNumber(A.symbstr) && B.type==Node.Vi && Node.isNumber(B.symbstr) ) {
//				double x=A.r+B.r;
//				N=(Node) new Node(N.parser,x);
//			} else if (A.type==Node.Us && A.symb==Node.MENOS && B.type==Node.Us && B.symb==Node.MENOS
//				&& B.right[0].type==Node.Vi && Node.isNumber(B.right[0].symbstr)
//				&& A.right[0].type==Node.Vi && Node.isNumber(A.right[0].symbstr)
//				) {
//				double x=-A.right[0].r-B.right[0].r;
//				N=new Node(N.parser,x);
//			} else if (((Node) A).toExpression(true).equals(((Node) B).toExpression(true))) {
//				N=(Node) new Node(Node.B2,Node.POR,"*");
//				N.left=(Node) new Node(N.parser,2);
//				N.right=new Node[1];
//				N.right[0]=A;
//			} else {
//				N.left=B;
//				N.right[0]=A;
//			}
//		} else if (N.type==Node.B1 && N.symb==Node.MENOS) {
//			Node A=N.left;
//			Node B=N.right[0];
//			if ( A.type==Node.Us && A.symb==Node.MENOS && B.type==Node.Vi && Node.isNumber(B.symbstr)) {
//				double x=-A.right[0].r-B.r;
//				N=(Node)new Node(N.parser,x);
//			}
//		} else if ( N.type==Node.Ua && N.symb==Node.SUMA) {
//			N=Sum(N.right,false);
//		}
//		if (recursive&&!all) {
//			if (N.left!=null) {
//				N.left=Sum(N.left,recursive,all);
//			}
//			if (N.right!=null) {
//				for (int i=0;i<N.right.length;i++) {
//					N.right[i]=Sum(N.right[i],recursive,all);
//				}
//			}
//		}
//		return N;
//	}
//
//	public Node Subtract(Node N0,boolean recursive,boolean all) {
//		Node N=N0.cloneNode();
//		N=eliminateAddedZero(N,recursive);
//		if (recursive&&all) {
//			if (N.left!=null) {
//				N.left=Subtract(N.left,recursive,all);
//			}
//			if (N.right!=null) {
//				for (int i=0;i<N.right.length;i++) {
//					N.right[i]=Subtract(N.right[i],recursive,all);
//				}
//			}
//		}
//		if (N.type==Node.B1 && (N.symb==Node.MENOS)) {
//			Node A=N.left;
//			Node B=N.right[0];
//			if (((Node) A).toExpression(true).equals(((Node) B).toExpression(true))) {
//				N=(Node) new Node(N.parser,0.0);
//			} else if (A.type==Node.Vi && Node.isNumber(A.symbstr) && B.type==Node.Vi && Node.isNumber(B.symbstr) ) {
//				double x=A.r-B.r;
//				N=(Node) new Node(N.parser,x);
//			} else if (A.type==Node.Vi && Node.isNumber(A.symbstr) && B.type==Node.Us && B.symb==Node.MENOS
//				&& B.right[0].type==Node.Vi && Node.isNumber(B.right[0].symbstr)) {
//				double x=A.r+B.right[0].r;
//				N=(Node) new Node(N.parser,x);
//			} else if ( A.type==Node.Us && A.symb==Node.MENOS && B.type==Node.Vi && Node.isNumber(B.symbstr)
//				&& A.right[0].type==Node.Vi && Node.isNumber(A.right[0].symbstr)) {
//				double x=-A.right[0].r-B.r;
//				N=(Node) new Node(N.parser,x);
//			}
//		} else if (N.type==Node.Ua && N.symb==Node.SUMA) {
//			N=Sum(N.right,true);
//		}
//		if (recursive&&!all) {
//			if (N.left!=null) {
//				N.left=Subtract(N.left,recursive,all);
//			}
//			if (N.right!=null) {
//				for (int i=0;i<N.right.length;i++) {
//					N.right[i]=Subtract(N.right[i],recursive,all);
//				}
//			}
//		}
//		return N;
//	}
//
//	private static Node Sum(Node[] na,boolean subtract) {
//		Vector V_Mas=new Vector();
//		Vector V_Menos=new Vector();
//		Vector V_Other=new Vector();
//		double mas=0,menos=0;
//		for (int i=0;i<na.length;i++) {
//			Node A=na[i];
//			if (A.type==Node.Vi && Node.isNumber(A.symbstr)) {
//				V_Mas.addElement(A);
//				mas+=A.r;
//			} else if (A.type==Node.Us && A.symb==Node.MENOS
//				&& A.right[0].type==Node.Vi && Node.isNumber(A.right[0].symbstr)) {
//				V_Menos.addElement(A.right[0]);
//				menos+=A.right[0].r;
//			} else {
//				V_Other.addElement(A);
//			}
//		}
//		if (subtract) {
//			mas=mas-menos;
//			menos=0;
//		}
//		int n=0;
//		if (mas!=0) {
//			n++;
//		}
//		if (menos!=0) {
//			n++;
//		}
//		n+=V_Other.size();
//		Node N=new Node(null,0.0);
//		if (n>1) {
//			N=new Node(Node.Ua,Node.SUMA,"suma");
//			N.right=new Node[n];
//			int j=0;
//			if (mas!=0) {
//				N.right[j++]=new Node(null,mas);
//			}
//			if (menos!=0) {
//				N.right[j++]=new Node(null,-menos);
//			}
//			for (int i=0;i<V_Other.size();i++) {
//				N.right[j++]=(Node) V_Other.elementAt(i);
//			}
//		} else if (n==1) {
//			if (mas!=0) {
//				N=new Node(null,mas);
//			} else if (menos!=0) {
//				N=new Node(null,-menos);
//			} else {
//				N=(Node) V_Other.elementAt(0);
//			}
//		}
//		return (Node) N;
//	}
//
//	public Node Divide(Node N0,boolean recursive,boolean all) {
//		Node N=N0.cloneNode();
//		N=eliminateZeroAndOneInProductsAndFractions(N,recursive);
//		if (recursive) {
//			if (N.left!=null) {
//				N.left=Divide(N.left,recursive,all);
//			}
//			if (N.right!=null) {
//				for (int i=0;i<N.right.length;i++) {
//					N.right[i]=Divide(N.right[i],recursive,all);
//				}
//			}
//		}
//		if (N.symb==Node.DIV) {
//			Node A=N.left;
//			Node B=N.right[0];
//			if (((Node) A).toExpression(true).equals(((Node) B).toExpression(true) )) {
//				N=(Node) new Node(N.parser,1);
//			} else if (B.type==Node.Vi && Node.isNumber(B.symbstr) && B.symbstr.equals("1")) {
//				N=(Node) A;
//			} else if (A.type==Node.Vi && Node.isNumber(A.symbstr) && B.type==Node.Vi && Node.isNumber(B.symbstr) ) {
//				if (B.r!=0) {
//					N=(Node) new Node(N.parser,A.r/B.r);
//				}
//			} else if (A.type==Node.B1) {
//				N=distributeDenominator(N,false,false);
//				N.setRight(Multiply(B,false,false));
//			} else if (A.symb==Node.MENOS && A.type==Node.Us) {
//				N=factorUnaryMinusOnProductsAndFractions(N,false);
//			} else if (B.symb==Node.MENOS && B.type==Node.Us) {
//				N=factorUnaryMinusOnProductsAndFractions(N,false);
//			} else if (A.symb==Node.POR) {
//				if (B.symb==Node.POR) {
//					A=associateOnTheRight(A,false);
//					if (A.left.toExpression(true).equals(B.left.toExpression(true))) {
//						N.left=A.right[0];
//						N.right[0]=B.right[0];
//					} else if (((Node) A.right[0]).toExpression(true).equals(((Node) B.right[0]).toExpression(true))) {
//						N.left=A.left;
//						N.right[0]=B.left;
//					} else if (((Node) A.left).toExpression(true).equals(((Node) B.right[0]).toExpression(true))) {
//						N.left=A.right[0];
//						N.right[0]=B.left;
//					} else if (((Node) A.right[0]).toExpression(true).equals(((Node) B.left).toExpression(true))) {
//						N.left=A.left;
//						N.right[0]=B.right[0];
//					} else if (((Node) A.left).toExpression(true).equals(((Node) B).toExpression(true))) {
//						N=(Node) A.right[0];
//					} else if (((Node) A.right[0]).toExpression(true).equals(((Node) B).toExpression(true))) {
//						N=(Node) A.left;
//					}
//				} else {
//					if (((Node) A.left).toExpression(true).equals(((Node) B).toExpression(true))) {
//						N=(Node) A.right[0];
//					} else if (((Node) A.right[0]).toExpression(true).equals(((Node) B).toExpression(true))) {
//						N=(Node) A.left;
//					}
//				}
//			}
//		}
//		if (all) {
//			if (N.left!=null) {
//				N.left=Divide(N.left,recursive,all);
//			}
//			if (N.right!=null) {
//				for (int i=0;i<N.right.length;i++) {
//					N.right[i]=Divide(N.right[i],recursive,all);
//				}
//			}
//		}
//		return N;
//	}
//
//	public Node distributeDenominator(Node N0,boolean recursive,boolean all) {
//		Node N=N0.cloneNode();
//		if (recursive) {
//			if (N.left!=null) {
//				N.left=distributeDenominator(N.left,recursive,all);
//			}
//			if (N.right!=null) {
//				for (int i=0;i<N.right.length;i++) {
//					N.right[i]=distributeDenominator(N.right[i],recursive,all);
//				}
//			}
//		}
//		if (N.symb==Node.DIV) {
//			Node A=N.left;
//			Node B=N.right[0];
//			if (A.type==Node.B1&&(A.symb==Node.MAS||A.symb==Node.MENOS)) {
//				Node N1=A.left;
//				Node N2=A.right[0];
//				N=new Node(A.type,A.symb,A.symbstr);
//				N.left=new Node(Node.B2,Node.DIV,"/");
//				N.left.left=N1;
//				N.left.right=new Node[1];
//				N.left.right[0]=B.cloneNode();
//				N.right=new Node[1];
//				N.right[0]=new Node(Node.B2,Node.DIV,"/");
//				N.right[0].left=N2;
//				N.right[0].right=new Node[1];
//				N.right[0].right[0]=B.cloneNode();
//			} else if (A.symb==Node.SUMA) {
//				N=new Node(Node.Ua,Node.SUMA,"suma");
//				N.right=new Node[A.right.length];
//				for (int i=0;i<A.right.length;i++) {
//					N.right[i]=new Node(Node.B2,Node.DIV,"/");
//					N.right[i].left=A.right[i];
//					N.right[i].right=new Node[1];
//					N.right[i].right[0]=B.cloneNode();
//				}
//			}
//		}
//		if (all) {
//			if (N.left!=null) {
//				N.left=distributeDenominator(N.left,recursive,all);
//			}
//			if (N.right!=null) {
//				for (int i=0;i<N.right.length;i++) {
//					N.right[i]=distributeDenominator(N.right[i],recursive,all);
//				}
//			}
//		}
//		return N;
//	}
//
//	public Node extractCommonDenominator(Node N0,boolean recursive, boolean all) {
//		Node N=N0.cloneNode();
//		if (recursive) {
//			if (N.left!=null) {
//				N.left=extractCommonDenominator(N.left,recursive,all);
//			}
//			if (N.right!=null) {
//				for (int j=0;j<N.right.length;j++) {
//					if (N.right[j]!=null) {
//						N.right[j]=extractCommonDenominator(N.right[j],recursive,all);
//					}
//				}
//			}
//		}
//		if (N.type==Node.B1 && (N.symb==Node.MAS||N.symb==Node.MENOS)) {
//			if (N.left.symb==Node.DIV && N.right[0].symb==Node.DIV) {
//				Node A=N.left.left;
//				Node B=N.left.right[0];
//				Node C=N.right[0].left;
//				Node D=N.right[0].right[0];
//				Node F=CommonDenominator(N.symb,A,B,C,D);
//				if (F!=null) {
//					N=F;
//				}
//			}
//		} else if (N.type==Node.Ua && N.symb==Node.SUMA) {
//			boolean quit=false;
//			for (int i=0;i<N.right.length;i++) {
//				if (N.right[i].symb==Node.DIV) {
//					Node A=N.right[i].left;
//					Node B=N.right[i].right[0];
//					for (int j=i+1;j<N.right.length;j++) {
//						if (N.right[j].symb==Node.DIV) {
//							Node C=N.right[j].left;
//							Node D=N.right[j].right[0];
//							Node F=CommonDenominator(Node.MAS,A,B,C,D);
//							if (F!=null) {
//								N.right[i]=F;
//								N.right[j]=new Node(N.parser,0);
//								quit=true;
//							}
//							if (quit) break;
//						}
//					}
//				}
//				if (quit) break;
//			}
//			if (quit) {
//				N=eliminateAddedZero(N,true);
//				if (recursive) {
//					N=extractCommonDenominator(N,recursive,all);
//				}
//			}
//		}
//		if (all) {
//			if (N.left!=null) {
//				N.left=extractCommonDenominator(N.left,recursive,all);
//			}
//			if (N.right!=null) {
//				for (int j=0;j<N.right.length;j++) {
//					if (N.right[j]!=null) {
//						N.right[j]=extractCommonDenominator(N.right[j],recursive,all);
//					}
//				}
//			}
//		}
//		return N;
//	}
//
//	private static Node CommonDenominator(int sym,Node A,Node B,Node C,Node D) {
//		String sB=canonizeComm(B).toExpression(true);
//		String sD=canonizeComm(D).toExpression(true);
//		if (sB.equals(sD)) {
//			Node N=new Node(Node.B2,Node.DIV,"/");
//			String sys="+";
//			if (sym==Node.MENOS) {
//				sys="-";
//			}
//			N.left=new Node(Node.B1,sym,sys);
//			N.left.left=A;
//			N.left.right=new Node[1];
//			N.left.right[0]=C;
//			N.right=new Node[1];
//			N.right[0]=B;
//			return N;
//		}
//		return null;
//	}


/* ------------------------ Unused methods ----------------------- */

//	public Node Expon(Node N0) {
//		if (N0.symb==Node.EXPON) {
//			Node A=N0.left;
//			Node B=N0.right[0];
//			if (A.type==Node.Vi && Node.isNumber(A.symbstr) && B.type==Node.Vi && Node.isNumber(B.symbstr) ) {
//				try {
//					return (Node) new Node(N0.parser,N0.expon(A.r,B.r));
//				} catch (Exception e) {
//				}
//			}
//		} else if (N0.symb==Node.SQRT) {
//			Node B=N0.right[0];
//			if (B.type==Node.Vi && Node.isNumber(B.symbstr) && B.r>=0 ) {
//				try {
//					return (Node) new Node(N0.parser,Math.sqrt(B.r));
//				} catch (Exception e) {
//				}
//			}
//		} else if (N0.symb==Node.SQR) {
//			Node B=N0.right[0];
//			if (B.type==Node.Vi && Node.isNumber(B.symbstr) ) {
//				try {
//					return (Node) new Node(N0.parser,B.r*B.r);
//				} catch (Exception e) {
//				}
//			}
//		}
//		return N0;
//	}

}