/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.poly;

import com.mja.math.*;
import com.mja.math3D.*;

public class viewR3 { 

	R3 Eye=new R3(0,0,0);

	private static final int A=15;
	private int X0, Y0;
	private double S, D;
	private double RX0, RY0;
	private boolean firstTime=true;
	private double bfactor;
	private static final double cfactor=3;
	

	public viewR3(int x0,int y0,double D,double s) {
		setScale(s);
		setView(x0,y0,D); 
	}

	public void setScale(double s) {
		S=s; 
	}
	public double getScale () { 
		return S; 
	}

	public void setView(int x0,int y0,double D) {
		X0=x0; Y0=y0; setDepth(D);
	}
	public R3 getView () { 
		return new R3(X0,Y0,getDepth()); 
	}
	
	public void setDepth(double depth) {
		D=depth/cfactor; 
		Eye.x=D/S;
		Eye.y=0;
		double incl=Math.tan(Math.PI*A/180);
 		Eye.z=D/S*incl;
 		RX0=X0;
 		RY0=Y0-D*incl;
 		bfactor=S*Eye.x;
	}
	public double getDepth () { 
		return cfactor*D; 
	}
	
	R2 pr(R3 r) {
		double lambda=bfactor/(r.x-Eye.x);
		double xp = RX0 - lambda*(r.y-Eye.y);
		double yp = RY0 + lambda*(r.z-Eye.z);
		return new R2(xp,yp);
	}

/*
	R2 pr(R3 r) {
		double dx=Eye.x-r.x,dy=Eye.y-r.y,dz=Eye.z-r.z;
		double t=-r.x/Math.sqrt(dx*dx+dy*dy+dz*dz);
		dx = X0 + S*(r.y+t*(Eye.y-r.y));
		dy = Y0 - S*(r.z+t*(Eye.z-r.z));
		return new R2(dx,dy);
	}
*/

	R3 rayFromEye(double x, double y) {
		return new R3(-Eye.x,(x-X0)/S - Eye.y,(Y0-y)/S - Eye.z);
	}
	
}