/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.textedit;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import javax.swing.JComboBox;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JCheckBox;

import com.mja.guiedit.*;
import com.mja.gui.*;
import com.mja.util.*;
import com.mja.util.BasicStr;
import com.mja.util.TFont;
import com.mja.lang.*;
import com.mja.parser.*;
import com.mja.img.*;
import com.mja.cmp.mjaButton;

import com.mja.algebra.*;
import com.mja.text.TColors;
import com.mja.text.RTF;
import com.mja.file.mjaFont;
import org.unam.matem.Attribute;

public class EditorButtons extends Panel implements 
	ActionListener, ItemListener, MouseListener, MouseMotionListener, Explainer {

	public static int Latin=0,Symbols=1,Greek=2,GREEK=3;
//	public static final Color borderColor=new Color(0x50a090);
	public static final Color borderColor=new Color(0x78a098);

	public static final int FUENTES=0,COLORES=1,fract=2,power=3,radical=4,sum=5,integral=6,limit=7,matrix=8,defparts=9, expr=10,FORMULAS=11,CARACTERES=12,UNICODE=13,TO_RTF=14,IMAGES=15,HYPERLINK=16,CONTROL=17,TEXT_=18,TEXT__=19,TEXT___=20,MENU=21,BARRA=22,BUTTON=23,SPACER2=24,SPACER3=25,SPACETA=26,SPACEGL=27,SPACEHF=28,HELP=29;
	public static final String[] attrName={"fuentes","colores","fracciones","potencias","radicales","series","integrales","lmites","matrices","defparts","expresiones","formulas","caracteres","unicode","rtf","imgenes","hipervnculos","controles","texto_","texto__","texto___","men","barra","botn","espaciosR2","espaciosR3","espaciosTA","espaciosGL","espaciosHF","ayuda"};
	public static final String[] attrSymbol={"fuentes","colores","\u00be","x\u00b2","\u221a\u00af","\u2211","\u222b","lim","(::)","{:","ex","[F]","caracteres","tabla","rtf","imgenes","Hv","Cn","Txt_","Txt__","Txt___","Mnu","Scr","Btn","R2","R3","TA","AP","HF","?"};

	public static final String ItemsAttributes="fuentes=no colores=no formulas=si fracciones=si potencias=si radicales=si series=si integrales=si limites=si matrices=si defparts=si expresiones=no caracteres=no unicode=si rtf=no imgenes=no ayuda=no";
	public static final String DefaultAttributes="fuentes=si colores=si formulas=no fracciones=si potencias=si radicales=si series=no integrales=no limites=no matrices=si defparts=si expresiones=no caracteres=si unicode=no rtf=no imgenes=no ayuda=si";
	public static final String DescartesAttributes="fuentes=si colores=si formulas=si fracciones=si potencias=si radicales=si series=si integrales=si limites=si matrices=si defparts=si expresiones=si caracteres=no unicode=si rtf=no imgenes=no ayuda=si";
	public static final String ArquimedesAttributes="fuentes=si colores=si formulas=si fracciones=si potencias=si radicales=si series=si integrales=si lmites=si matrices=si defparts=si expresiones=si caracteres=si unicode=si rtf=no imgenes=no hipervnculos=si ayuda=si controles=si espaciosR2=si espaciosR3=si espaciosTA=no espaciosHF=si espaciosGL=no";
//	public static final String FormulaEditorAttributes="fuentes=si colores=no fracciones=si potencias=si radicales=si series=si integrales=si limites=si matrices=si expresiones=no formulas=no caracteres=si unicode=no rtf=no imgenes=no";
//	public static final String TextEditorAttributes="fuentes=si colores=si formulas=si fracciones=si potencias=si radicales=si series=si integrales=si limites=si expresiones=no caracteres=no unicode=si rtf=si imgenes=no ayuda=si";
//	public static final String PECEIAttributes="fuentes=si colores=si formulas=si fracciones=no potencias=no radicales=no series=no integrales=no limites=no expresiones=no caracteres=no unicode=si rtf=no imgenes=si ayuda=si";
//	public static final String DescartesAttributes="fuentes=si colores=si formulas=si fracciones=si potencias=si radicales=si series=si integrales=si limites=si matrices=si expresiones=si caracteres=si unicode=no rtf=no imgenes=no ayuda=si";
//	public static final String AuthorAttributes="fuentes=si colores=si formulas=si fracciones=si potencias=si radicales=si series=si integrales=si limites=si matrices=si expresiones=si caracteres=si unicode=no rtf=no imgenes=no ayuda=si";
//	public static final String StudentAttributes="fuentes=no colores=no formulas=no fracciones=si potencias=si radicales=si series=si integrales=si limites=si matrices=si expresiones=no caracteres=si unicode=no rtf=no imgenes=no ayuda=si";

	public boolean[] boolAttr=new boolean[attrName.length];

	private JComboBox ch_type, ch_size, ch_symb;
	private JCheckBox chb_bold, chb_italic, chb_underline, chb_overline;
	private ColorButton colorButton;

	private mjaButton b_uc,b_for,b_rtf, b_hl, b_ctrl, b_text_, b_text__, b_text___, b_menu, b_barra, b_button, b_spR2, b_spR3, b_spTA, b_spHF, b_spGL, b_help;
	private static final String[] bFTit={"Fraccin","Potencia","Radical","Suma","Integral","Lmite","Matriz","Definicin por partes","Expresin"};
	private mjaButton[] bFEC=new mjaButton[FORMULAS-fract];
	private Panel NP1,NP2,spsymb;
	private String[] lbSymb={"Latino","Smbolos","Griegas","GRIEGAS"};
	private int[] charbase={0x0061,0x2200,0x03B1,0x0391};
	private int base=0x0000;
	private com.mja.cmp.mjaButton[] bSymb=new com.mja.cmp.mjaButton[32];
	private editFrame ef_rtf,ef_symbol,ef_special;
	private TextArea t_rtf;
	private editColorDialog ecd;
	private Frame pf;
	private translator Tr;
	private com.mja.gui.MouseCursorHandler mch,extra_mch;
	private boolean editable, symbTbl, images, toRTF, inFormula;
	private EditorCanvas EC;
	private int ixOther=-1;
	private TextField tf;
	private boolean fill,useKB,useListeners=false,empty=true;
	private Applet A;
	private mjaFont mf;
	
	public EditorButtons(Applet A,Frame parent,translator Tr,boolean editable,boolean images,boolean fill,boolean useKB) {
		this.A=A;
		pf=parent;
		this.Tr=Tr;
		this.editable=editable;
		this.images=images;
		this.fill=fill;
		this.useKB=useKB;
		mch=new com.mja.gui.MouseCursorHandler(this,this);
		setFont(mjaFont.makeFont("SansSerif",Font.PLAIN,12));
		/* ---------- build all components ------------- */
		ch_type=new JComboBox();
		for (int i=0;i<RTF.Java2FontNames.length;i++) {
			ch_type.addItem(RTF.Java2FontNames[i]);
		}
		ch_type.setSelectedIndex(RTF.Serif);
		ch_size=new JComboBox();
		for (int i=8;i<80;i+=1) {
			if (i>30) {
				i+=1;
			}
			if (i>40) {
				i+=2;
			}
			ch_size.addItem(Integer.toString(i));
		}
		chb_bold=new JCheckBox("n"); chb_bold.setFont(mjaFont.makeFont("SansSerif",Font.BOLD,12));
		chb_italic=new JCheckBox("it");  chb_italic.setFont(mjaFont.makeFont("SansSerif",Font.ITALIC,12));
		chb_underline=new JCheckBox("_");
		chb_overline=new JCheckBox(new Character((char)0xAF).toString());
		ch_symb=new JComboBox();
		setCharsList(lbSymb,charbase);
		ch_symb.addItemListener(this);
		ch_symb.addMouseListener(mch);
		b_hl=new mjaButton(attrSymbol[HYPERLINK]);
		b_ctrl=new mjaButton(attrSymbol[CONTROL]);
		b_text_=new mjaButton(attrSymbol[TEXT_]);
		b_text__=new mjaButton(attrSymbol[TEXT__]);
		b_text___=new mjaButton(attrSymbol[TEXT___]);
		b_menu=new mjaButton(attrSymbol[MENU]);
		b_barra=new mjaButton(attrSymbol[BARRA]);
		b_button=new mjaButton(attrSymbol[BUTTON]);
		b_spR2=new mjaButton(attrSymbol[SPACER2]);
		b_spR3=new mjaButton(attrSymbol[SPACER3]);
		b_spTA=new mjaButton(attrSymbol[SPACETA]);
		b_spHF=new mjaButton(attrSymbol[SPACEHF]);
		b_spGL=new mjaButton(attrSymbol[SPACEGL]);
		b_uc=new mjaButton(attrSymbol[UNICODE]);
		b_rtf=new mjaButton(attrSymbol[TO_RTF]);
		b_help=new mjaButton(attrSymbol[HELP]);
		CheckboxGroup chbg=new CheckboxGroup();
		b_for=new mjaButton(attrSymbol[FORMULAS]);
//		mf=new mjaFont(mjaFont.makeFont("Serif",Font.PLAIN,16));
		mf=new mjaFont("SansSerif",Font.PLAIN,16);
		spsymb=new Panel();
		for (int i=0;i<bSymb.length;i++) {
			bSymb[i]=new mjaButton(mjaButton.other);
			bSymb[i].setSize(24,25);
			bSymb[i].addActionListener(this);
			bSymb[i].addMouseListener(this);
			bSymb[i].addMouseListener(mch);
			bSymb[i].addMouseMotionListener(this);
			bSymb[i].setFont(mf.getMathFont());
		}
		tf=new TextField(4);
		tf.setBackground(Color.white);
		tf.addActionListener(this);
		tf.addMouseListener(mch);
//		b_uc.addActionListener(this);
		b_uc.addMouseListener(this);
//		b_for.addActionListener(this);
		b_for.addMouseListener(this);
		b_rtf.addActionListener(this);
		b_help.addActionListener(this);
		b_hl.addMouseListener(this);
		b_ctrl.addMouseListener(this);
		b_text_.addMouseListener(this);
		b_text__.addMouseListener(this);
		b_text___.addMouseListener(this);
		b_menu.addMouseListener(this);
		b_barra.addMouseListener(this);
		b_button.addMouseListener(this);
		b_spR2.addMouseListener(this);
		b_spR3.addMouseListener(this);
		b_spTA.addMouseListener(this);
		b_spHF.addMouseListener(this);
		b_spGL.addMouseListener(this);
		addItemListeners(true);
		ch_type.addMouseListener(mch);
		ch_size.addMouseListener(mch);
		chb_bold.addMouseListener(mch);
		chb_italic.addMouseListener(mch);
		chb_underline.addMouseListener(mch);
		chb_overline.addMouseListener(mch);
		colorButton=new ColorButton("C");
		colorButton.setTextColor(new mjaColor(Color.black));
		colorButton.setBackColor(new mjaColor(Color.white));
		colorButton.addMouseListener(this);
		b_uc.addMouseListener(mch);
		b_for.addMouseListener(mch);
		b_rtf.addMouseListener(mch);
		b_help.addMouseListener(mch);  // Se quita porque entonces da su 
//	propia ayuda y al cerrarse quita la posibilidad de otra ayuda
		b_hl.addMouseListener(mch);
		b_ctrl.addMouseListener(mch);
		b_text_.addMouseListener(mch);
		b_text__.addMouseListener(mch);
		b_text___.addMouseListener(mch);
		b_menu.addMouseListener(mch);
		b_barra.addMouseListener(mch);
		b_button.addMouseListener(mch);
		b_spR2.addMouseListener(mch);
		b_spR3.addMouseListener(mch);
		b_spTA.addMouseListener(mch);
		b_spHF.addMouseListener(mch);
		b_spGL.addMouseListener(mch);
		colorButton.addMouseListener(mch);
		String ua="";
		if (A!=null) {
			ua=A.getParameter("EditorConfig");
		}
//		mjaFont.finishLoadingMathFont();
		if (BasicStr.hasContent(ua)) {
			setAttributes(ua);
		} else {
			setAttributes(DefaultAttributes);
		}
	}
	
	public void selectChars(int selection) {
		if (0<=selection && selection<lbSymb.length) {
			ch_symb.setSelectedIndex(selection);
		}
	}

	public void setCharsList(String[] names,int[] unicodes) {
		lbSymb=names;
		charbase=unicodes;
		ch_symb.removeAllItems();
		for (int i=0;i<names.length;i++) {
			ch_symb.addItem(names[i]);
		}
		if (names.length>0) {
			ch_symb.setSelectedIndex(0);
		}
	}

	public void setAttributes(String s) {
		Attribute[] AA=Attribute.parse(s);
		empty=true;
		for (int i=0;i<boolAttr.length;i++) {
			String attr=Attribute.getValue(AA,attrName[i]);
			boolAttr[i]=BasicStr.hasContent(attr)&&
				(!attr.equalsIgnoreCase("no"))&&
				(!attr.equalsIgnoreCase("0"));
			if (boolAttr[i]) empty=false;
		}
		rebuild();
		updateChars();
	}

	public void setEditorCanvas(EditorCanvas ec,boolean update) {
		if (EC!=null) {
			EC.removeMouseListener(this);
			EC.removeMouseMotionListener(this);
		}
		EC=ec;
		EC.addMouseListener(this);
		EC.addMouseMotionListener(this);
		if (update) {
			setEditing(EC.isEditing());
			updateSelectors();
			EC.activateButtons();
		}
	}

	public void addExtraMH(com.mja.gui.MouseCursorHandler e) {
		extra_mch=e;
	}

	public void removeExtraMH() {
		extra_mch=null;
	}

	private void rebuild() {
		removeAll();
		NP1=new Panel();
		NP1.setBackground(borderColor);
		NP1.setLayout(new FlowLayout(FlowLayout.LEFT,0,0));
		GridBagConstraints gc1=new GridBagConstraints();
		gc1.insets=new Insets(0,0,0,0);
		gc1.anchor=GridBagConstraints.CENTER;
		if (fill) {
			gc1.weightx=1;
			gc1.fill=GridBagConstraints.BOTH;
		} else {
			gc1.weightx=0;
			gc1.fill=GridBagConstraints.NONE;
		}
		gc1.weighty=1;
		gc1.gridwidth=1;
		gc1.gridheight=1;
		gc1.gridx=0;
		gc1.gridy=0;

		if (boolAttr[HELP]) {
			NP1.add(b_help,gc1); gc1.gridx++;
		}

		if (boolAttr[FUENTES]) {
			NP1.add(ch_type,gc1); gc1.gridx++;
			NP1.add(ch_size,gc1); gc1.gridx++;
			NP1.add(chb_bold,gc1); gc1.gridx++; chb_bold.setFont(mjaFont.makeFont("SansSerif",Font.BOLD,12));
			NP1.add(chb_italic,gc1); gc1.gridx++;  chb_italic.setFont(mjaFont.makeFont("SansSerif",Font.ITALIC,12));
			NP1.add(chb_underline,gc1); gc1.gridx++;
			NP1.add(chb_overline,gc1); gc1.gridx++;
		}
		if (boolAttr[COLORES]) {
			NP1.add(colorButton,gc1); gc1.gridx++;
		}
		if (boolAttr[FORMULAS]) {
			NP1.add(b_for,gc1); gc1.gridx++;
		}
		for (int i=0;i<bFEC.length;i++) {
			bFEC[i]=new mjaButton(attrSymbol[fract+i]);
			if (boolAttr[fract+i]) {
				NP1.add(bFEC[i],gc1); gc1.gridx++;
			}
			bFEC[i].addActionListener(this);
			bFEC[i].addMouseListener(this);
			bFEC[i].addMouseListener(mch);
			bFEC[i].addMouseMotionListener(this);
		}
		if (boolAttr[HYPERLINK]) {
			NP1.add(b_hl,gc1); gc1.gridx++;
		}
		if (boolAttr[UNICODE]) {
			NP1.add(b_uc,gc1); gc1.gridx++;
			NP1.add(tf); gc1.gridx++;
		}
//		if (useOtros) {
//			NP1.add(bSymb[I]); gc1.gridx++;
//		}
		if (boolAttr[TO_RTF]) {
			NP1.add(b_rtf,gc1); gc1.gridx++;
		}
		if (boolAttr[HELP]) {
			NP1.add(b_help,gc1); gc1.gridx++;
		}
		NP2=new Panel();
		NP2.setBackground(borderColor);
		NP2.setLayout(new GridBagLayout());
		boolean hayNP2=false;
		GridBagConstraints gc2=new GridBagConstraints();
		gc2.insets=new Insets(0,0,0,0);
		gc2.anchor=GridBagConstraints.WEST;
		if (fill) {
			gc2.weightx=1;
			gc2.fill=GridBagConstraints.BOTH;
		} else {
			gc2.weightx=0;
			gc2.fill=GridBagConstraints.NONE;
		}
		gc2.weighty=1;
		gc2.gridwidth=1;
		gc2.gridheight=1;
		gc2.gridx=0;
		gc2.gridy=0;
		if (boolAttr[CONTROL]) {
			NP2.add(b_ctrl,gc2); gc2.gridx++;
			NP2.add(b_text_,gc2); gc2.gridx++;
			NP2.add(b_text__,gc2); gc2.gridx++;
			NP2.add(b_text___,gc2); gc2.gridx++;
			NP2.add(b_menu,gc2); gc2.gridx++;
			NP2.add(b_barra,gc2); gc2.gridx++;
			NP2.add(b_button,gc2); gc2.gridx++;
			hayNP2=true;
		}
		if (boolAttr[SPACER2]) {
			NP2.add(b_spR2,gc2); gc2.gridx++;
			hayNP2=true;
		}
		if (boolAttr[SPACER3]) {
			NP2.add(b_spR3,gc2); gc2.gridx++;
			hayNP2=true;
		}
		if (boolAttr[SPACETA]) {
			NP2.add(b_spTA,gc2); gc2.gridx++;
			hayNP2=true;
		}
		if (boolAttr[SPACEHF]) {
			NP2.add(b_spHF,gc2); gc2.gridx++;
			hayNP2=true;
		}
		if (boolAttr[SPACEGL]) {
			NP2.add(b_spGL,gc2); gc2.gridx++;
			hayNP2=true;
		}
		if (hayNP2) {
			NP2.add(new Label("               "),gc2); gc2.gridx++;
		}
		if (boolAttr[CARACTERES]&&hayNP2) {
			setLayout(new GridLayout(3,1));
			add(NP1);
			add(NP2);
			add(spsymb);
		} else if (hayNP2) {
			setLayout(new GridLayout(2,1));
			add(NP1);
			add(NP2);
		} else if (boolAttr[CARACTERES]) {
			setLayout(new GridLayout(2,1));
			add(NP1);
			add(spsymb);
		} else {
			setLayout(new GridLayout(1,1));
			add(NP1);
		}
		ch_size.setSelectedItem("17");
		ch_symb.setSelectedIndex(1);
	}

	public void updateChars() {
//		System.out.println(System.getProperty("java.version"));
		spsymb.removeAll();
		spsymb.repaint();
		spsymb.setBackground(borderColor);
		spsymb.setLayout(new FlowLayout(FlowLayout.LEFT,0,0));
		spsymb.add(ch_symb);
		ixOther=-1;
		int I=26;
		base=charbase[ch_symb.getSelectedIndex()];
		if (ch_symb.getSelectedIndex()==Symbols) {
			int i=0;
			bSymb[i++].setLabel("+"); // signo +
			bSymb[i++].setLabel(new Character((char) (base+0x12)).toString()); // signo -
			bSymb[i++].setLabel(new Character((char) (00+0xB7)).toString()); // punto de multiplicar
			bSymb[i++].setLabel(new Character((char) (00+0xD7)).toString()); // x de multiplicacin
			bSymb[i++].setLabel(new Character((char) (00+0xF7)).toString()); // entre
			bSymb[i++].setLabel(new Character((char) (00+0xB1)).toString()); // mas menos
			bSymb[i++].setLabel("="); // equals =
			bSymb[i++].setLabel(new Character((char) (base+0x60)).toString()); // not equal
			bSymb[i++].setLabel(new Character((char) (base+0x64)).toString()); // less than or equal
			bSymb[i++].setLabel(new Character((char) (base+0x65)).toString()); // bigger than or equal
			bSymb[i++].setLabel(new Character((char) (base+0x48)).toString()); // similar
			bSymb[i++].setLabel(new Character((char) (base+0x61)).toString()); // identical
			bSymb[i++].setLabel(new Character((char) (0x192)).toString()); // f
			bSymb[i++].setLabel(new Character((char) (base+0x1E)).toString()); // infinito
			bSymb[i++].setLabel(new Character((char) (base+0x00)).toString()); // para todo
			bSymb[i++].setLabel(new Character((char) (base+0x03)).toString()); // existe
			bSymb[i++].setLabel(new Character((char) (base+0x04)).toString()); // no existe
			bSymb[i++].setLabel(new Character((char) (base+0x08)).toString()); // pertenece
			bSymb[i++].setLabel(new Character((char) (base+0x09)).toString()); // no pertenece
			bSymb[i++].setLabel(new Character((char) (base+0x34)).toString()); // por lo tanto
			bSymb[i++].setLabel(new Character((char) (0x21d2)).toString()); // implica
			bSymb[i++].setLabel(new Character((char) (base+0x05)).toString()); // vaco
			bSymb[i++].setLabel(new Character((char) (base+0x29)).toString()); // Unin
			bSymb[i++].setLabel(new Character((char) (base+0x2A)).toString()); // Interseccin
			bSymb[i++].setLabel(new Character((char) (base+0x02)).toString()); // derivada parcial
			bSymb[i++].setLabel(new Character((char) (base+0x06)).toString()); // delta
			bSymb[i++].setLabel(new Character((char) (base+0x07)).toString()); // nabla
			bSymb[i++].setLabel(new Character((char) (0x3C0)).toString()); // pi
			I=i;
			for (int j=0;j<I;j++) {
				spsymb.add(bSymb[j]);
			}
		} else {
			if (base==0x03B1 || base==0x0391) {
				I=25;
			}
			for (int i=0;i<I;i++) {
				bSymb[i].setLabel(new Character((char) (base+i)).toString());
				spsymb.add(bSymb[i]);
			}
		}
//		bSymb[I].setLabel("otros"); // otros smbolos
//		ixOther=I;
		for (int i=0;i<I+1;i++) {
			String str=bSymb[i].getLabel();
			char ch=(str!=null && str.length()==1)?str.charAt(0):0;
			if (ch > 0x2100) {
				bSymb[i].setFont(mf.getMathFont());
			} else {
				bSymb[i].setFont(mf.getAwtFont());
			}
		}
		if (EC!=null&&useKB) {
			EC.setUnicodeBase(base);
		}
//		invalidate();
//		repaint();
		ch_symb.invalidate();
		ch_symb.repaint();
		for (int i=0;i<I+1;i++) {
			bSymb[i].invalidate();
			bSymb[i].repaint();
		}
	}

	private void updateEnabling() {
		colorButton.setEnabled(editable);
		ch_type.setEnabled(editable);
		ch_size.setEnabled(editable);
		chb_bold.setEnabled(editable);
		chb_italic.setEnabled(editable);
		chb_underline.setEnabled(editable);
		chb_overline.setEnabled(editable);
		b_uc.setEnabled(editable);
		b_for.setEnabled(editable);
		b_rtf.setEnabled(editable);
		b_hl.setEnabled(editable);
		b_ctrl.setEnabled(editable);
		b_text_.setEnabled(editable);
		b_text__.setEnabled(editable);
		b_text___.setEnabled(editable);
		b_menu.setEnabled(editable);
		b_barra.setEnabled(editable);
		b_button.setEnabled(editable);
		b_spR2.setEnabled(editable);
		b_spR3.setEnabled(editable);
		b_spTA.setEnabled(editable);
		b_spHF.setEnabled(editable);
		b_spGL.setEnabled(editable);
//		b_help.setEnabled(editable);
		for (int i=0;i<bFEC.length;i++) {
			bFEC[i].setEnabled(editable);
		}
		for (int i=0;i<bSymb.length;i++) {
			bSymb[i].setEnabled(editable);
		}
		if (editable) {
			for (int j=0;j<bFEC.length;j++) {
//				bFEC[j].setEnabled(inFormula);
				bFEC[j].setEnabled(true);
			}

			b_for.setEnabled(!inFormula);  
			b_hl.setEnabled(!inFormula);
//			b_ctrl.setEnabled(!inFormula);
			b_spR2.setEnabled(!inFormula);
			b_spR3.setEnabled(!inFormula);
			b_spTA.setEnabled(!inFormula);
			b_spHF.setEnabled(!inFormula);
			b_spGL.setEnabled(!inFormula);
		}
	}

	public void updateTranslation() {
		chb_bold.setLabel(Tr.getTr(data.bold));
		chb_italic.setLabel(Tr.getTr(data.italics));
		chb_underline.setLabel(Tr.getTr(data.underlined));
		chb_overline.setLabel(Tr.getTr(data.overlined));
		colorButton.setLabel(Tr.getTr(data.color));
		b_uc.setLabel(Tr.getTr(data.symbols));
		b_for.setLabel(Tr.getTr(data.formula));
	}

	public  void addItemListeners(boolean permanent) {
//showDebug(null,"addpermanent");
		useListeners=permanent;
		addItemListeners();
	}
	public  void removeItemListeners(boolean permanent) {
//showDebug(null,"removepermanent");
		removeItemListeners();
		useListeners=!permanent;
	}

	private void addItemListeners() {
		if (useListeners) {
			ch_type.addItemListener(this);
			ch_size.addItemListener(this);
			chb_bold.addItemListener(this);
			chb_italic.addItemListener(this);
			chb_underline.addItemListener(this);
			chb_overline.addItemListener(this);
		}
	}

	private void removeItemListeners() {
		if (useListeners) {
			ch_type.removeItemListener(this);
			ch_size.removeItemListener(this);
			chb_bold.removeItemListener(this);
			chb_italic.removeItemListener(this);
			chb_underline.removeItemListener(this);
			chb_overline.removeItemListener(this);
		}
	}

	public void updateSelectors() {
		if (EC!=null) {
			TColors tc=EC.getCursorColors();
			TFont f=EC.getCursorTFont();
			removeItemListeners();
			ch_type.setSelectedItem(f.getName());
			chb_bold.setSelected(f.isBold());
			chb_italic.setSelected(f.isItalic());
			chb_underline.setSelected(f.isUnderline());
			chb_overline.setSelected(f.isOverline());
			ch_size.setSelectedItem(Integer.toString(f.getSize()));
			colorButton.setColors(new mjaColor(tc.getBackColor()),new mjaColor(tc.getTextColor()));
			tf.setText(EC.getCharAtCursor());
			addItemListeners();
		}
	}

	TColors getColorsFromControls() {
		return new TColors(colorButton.getBackColor(),colorButton.getTextColor());
	}

	TFont getTFontFromControls() {
		int sz=12;
		try {
			sz=Integer.parseInt((String) ch_size.getSelectedItem());
		} catch (NumberFormatException ex) {
		}
		return new TFont((String) ch_type.getSelectedItem(),
			chb_bold.isSelected(),chb_italic.isSelected(),
			chb_underline.isSelected(),
			chb_overline.isSelected(),
			sz);
	}

	void insertTFont() {
		if (EC!=null) {
			EC.saveText();
			EC.insertTFont(getTFontFromControls());
		}
	}

	private void openSymbolsDialog(Component b) {
		String ch=UnicodeSelector.getUnicodeChar(pf,Tr);
		if (ch!=null && ch.length()>0) {
			EC.saveText();
			EC.insertText(ch);
		}
		b.setEnabled(false); // porque en JVM de Sun 1.4 el botn vuelve a coger el foco.
		EC.requestFocus();
	}

    public void actionPerformed(ActionEvent e) {
    	if (extra_mch!=null) {
    		return;
    	}
    	if (!mch.isHand()) {
			if (e.getSource()==EC&& e.getActionCommand().equals("focus")) {
				if (!useListeners) {
					addItemListeners(true);
				}
			}
	    	if (e.getSource()==b_rtf) {
	    		mjaText.showPlainText(pf,"  RTF  "," \n"+EC.toRTF(false));
	    	} else if (e.getSource()==b_help) {
//	    		mch.setHand();
				mjaText.msg((Component) b_help,"smbolo especial",Expl.get(Expl.Help,Tr.getActiveLanguage()),mjaFont.AWTMonoB);
			} else if (e.getSource()==EC) {
	    		if (e.getActionCommand().equals(EditorCanvas.UpdateSelectors)) {
					updateSelectors();
				} else if (e.getActionCommand().equals(EditorCanvas.ActivateFormulaButtons)||
					 (e.getActionCommand().equals(EditorCanvas.ActivateTextButtons))) {
					inFormula=(e.getActionCommand().equals(EditorCanvas.ActivateFormulaButtons));
					updateEnabling();
				}
			} else if (e.getSource()==tf) {
				String s=tf.getText();
				if (s.startsWith("0x")) {
					s=s.substring(2);
				}
				try {
					EC.saveText();
					EC.insertChar((char) Integer.parseInt(s,16));
				} catch (Exception ex) {
					System.out.println("Invalid hexadecimal expresion");
				}
			}
		}
    }

    public void setEditing(boolean b) {
    	editable=b;
    	EC.setEditing(b);
    	removeItemListeners();
    	addItemListeners();
 		updateEnabling();
    }

	public String getExplLabel(MouseEvent e) {
		Component c=(Component) e.getSource();
    	if (extra_mch!=null) {
			return "Controles del texto.";
		} else if (c instanceof ColorButton) {
			return "Colores de texto y fondo.";
		} else if (c instanceof mjaButton) {
			mjaButton b=(mjaButton) c;
			for (int i=0;i<bFEC.length;i++) {
				if (b==bFEC[i]) {
					return bFTit[i];
				}
			}
			return b.getLabel();
		} else if (c instanceof mjaButton) {
			mjaButton b=(mjaButton) c;
			for (int i=0;i<bSymb.length;i++) {
				if (b==bSymb[i]) {
					if (i==ixOther) {
						return "Otros caracteres";
					} else {
						return "Smbolo especial";
					}
				}
			}
			return b.getLabel();
		} else if (c instanceof JComboBox) {
			JComboBox ch=(JComboBox) c;
			if (ch==ch_type) {
				return "tipo de letra";
			} else if (ch==ch_size) {
				return "tamao de letra";
			}
		} else if (c instanceof Checkbox) {
			Checkbox chb=(Checkbox) c;
			return chb.getLabel();
		}
		return "";
	}

	public String getExplanation(MouseEvent e) {
		String[] sa=null;
		Component c=(Component) e.getSource();
    	if (extra_mch!=null) {
			sa=Expl.AlgebraTutor[10];
			extra_mch.setNull();
			extra_mch=null;
		} else if (c instanceof JComboBox) {
			JComboBox ch=(JComboBox) c;
			if (ch==ch_type) {
				sa=Expl.EditText[0];
			} else if (ch==ch_size) {
				sa=Expl.EditText[1];
			} else if (ch==ch_symb) {
				sa=Expl.EditText[14];
			}
		} else if (c instanceof JCheckBox) {
			JCheckBox chb=(JCheckBox) c;
			if (chb==chb_bold) {
				sa=Expl.EditText[2];
			} else if (chb==chb_italic) {
				sa=Expl.EditText[3];
			} else if (chb==chb_underline) {
				sa=Expl.EditText[4];
			} else if (chb==chb_overline) {
				sa=Expl.EditText[5];
			}
		} else if (c instanceof mjaButton) {
			mjaButton b=(mjaButton) c;
			if (b==colorButton) {
				sa=Expl.EditText[8];
			} else if (b==b_help) {
				sa=Expl.EditText[9];
			} else if (b==b_uc) {
				sa=Expl.EditText[10];
			} else if (b==b_for) {
				sa=Expl.EditText[11];
			} else if (b==b_rtf) {
				sa=Expl.EditText[12];
			} else if (b==b_hl) {
				sa=Expl.EditText[17];
			} else if (b==b_ctrl) {
				sa=Expl.EditText[18];
			} else if (b==b_text_) {
				sa=Expl.EditText[19];
			} else if (b==b_text__) {
				sa=Expl.EditText[20];
			} else if (b==b_text___) {
				sa=Expl.EditText[21];
			} else if (b==b_menu) {
				sa=Expl.EditText[22];
			} else if (b==b_barra) {
				sa=Expl.EditText[23];
			} else if (b==b_button) {
				sa=Expl.EditText[24];
			} else if (b==b_spR2) {
				sa=Expl.EditText[25];
			} else if (b==b_spR3) {
				sa=Expl.EditText[26];
			} else if (b==b_spTA) {
				sa=Expl.EditText[27];
			} else if (b==b_spHF) {
				sa=Expl.EditText[27];
			} else if (b==b_spGL) {
				sa=Expl.EditText[28];
			} else {
				for (int i=0;i<bFEC.length;i++) {
					if (b==bFEC[i]) {
						sa=Expl.EditFormula[i];
						break;
					}
				}
			}
			for (int i=0;i<bSymb.length;i++) {
				if (b==bSymb[i]) {
					if (i==ixOther) {
						sa=Expl.EditText[10];
					} else {
						sa=Expl.EditText[13];
					}
					break;
				}
			}
		} else if (c instanceof ColorButton) {
			ColorButton cb=(ColorButton) c;
			if (cb==colorButton) {
				sa=Expl.EditText[7];
			}
		} else if (c instanceof TextField) {
			if (c==tf) {
				sa=Expl.EditText[15];
			}
		}
		return Expl.get(sa,Tr.getActiveLanguage());
	}

/* ------------------ ItemListener -------------------- */

    public void itemStateChanged(ItemEvent e) {
		if (e.getStateChange()==ItemEvent.SELECTED) {
	    	if (extra_mch!=null) {
			    updateSelectors();
	    		return;
	    	}
	    	if (!mch.isHand()) {
		    	if (e.getSource()==ch_type || e.getSource()==ch_size ||
		    		e.getSource()==chb_bold || e.getSource()==chb_italic ||
		    		e.getSource()==chb_underline||e.getSource()==chb_overline
		    		) {
		    		insertTFont();
		    		if (EC!=null && !EC.segIsMarked()) {
		    			EC.requestFocus();
		    		}
		    	} else if (e.getSource()==ch_symb) {
		    		updateChars();
					for (int i=0;i<bSymb.length;i++) {
						bSymb[i].invalidate();
						bSymb[i].repaint();
					}
		    	}
			}
		} else {
	    	if (!mch.isHand()) {
		    	if (e.getSource()==chb_bold || e.getSource()==chb_italic ||
		    		e.getSource()==chb_underline||e.getSource()==chb_overline
		    		) {
		    		insertTFont();
		    		if (!EC.segIsMarked()) {
		    			EC.requestFocus();
		    		}
		    	}
		    }
		}
		updateSelectors();
    }

/* ------------------ MouseListener -------------------- */

	private void insertNewFormulaItem(int what) {
		switch (fract+what) {
			case fract:
		    	EC.setEditing(true);
				EC.saveText();
		    	if (!inFormula)  {
					EC.insertFormula("");
		    	}
				EC.insertFraction("","");
				break;
			case power:
		    	EC.setEditing(true);
				EC.saveText();
		    	if (!inFormula)  {
					EC.insertFormula("");
		    	}
   				EC.insertSuperIndex("");
				break;
			case radical:
		    	EC.setEditing(true);
				EC.saveText();
		    	if (!inFormula)  {
					EC.insertFormula("");
		    	}
   				EC.insertRadical("","");
				break;
			case sum:
		    	EC.setEditing(true);
				EC.saveText();
		    	if (!inFormula)  {
					EC.insertFormula("");
		    	}
   				EC.insertSum("","","");
				break;
			case integral:
		    	EC.setEditing(true);
				EC.saveText();
		    	if (!inFormula)  {
					EC.insertFormula("");
		    	}
   				EC.insertIntegral("","","");
				break;
			case limit:
		    	EC.setEditing(true);
				EC.saveText();
		    	if (!inFormula)  {
					EC.insertFormula("");
		    	}
   				EC.insertLimit("","","");
				break;
			case matrix:
				EC.saveText();
		    	if (!inFormula)  {
					EC.insertFormula("");
		    	}
				Frame F=new Frame();
				editDialog ed=new editDialog(F,"matriz mxn",true,"aceptar","cancelar");
				Label lm=new Label("m ="),ln=new Label("n =");
				TextField tfm=new TextField("2"),tfn=new TextField("2");
				Panel P=new Panel();
				P.setLayout(new GridLayout(2,2,8,8));
				P.add(lm); P.add(tfm);
				P.add(ln); P.add(tfn);
				ed.add("Center",P);
				ed.display(true,true);
				if (ed.ok) {
					int rows=BasicStr.parseInteger(tfm.getText(),2,2);
					int cols=BasicStr.parseInteger(tfn.getText(),2,2);
			    	EC.setEditing(true);
			    	String[][] sa=new String[rows][cols];
	   				EC.insertMatrix(sa);
	   			}
				F.dispose();
				ed.dispose();
				break;
			case defparts:
				EC.saveText();
		    	if (!inFormula)  {
					EC.insertFormula("");
		    	}
				F=new Frame();
				ed=new editDialog(F,"Def. por partes",true,"aceptar","cancelar");
				ln=new Label("partes"); ln.setAlignment(Label.CENTER);
				tfn=new TextField("2");
				P=new Panel();
				P.setLayout(new GridLayout(1,2,8,8));
				P.add(ln); P.add(tfn);
				ed.add("Center",P);
				ed.display(true,true);
				if (ed.ok) {
					int parts=BasicStr.parseInteger(tfn.getText(),2,2);
			    	EC.setEditing(true);
			    	String[] sa=new String[parts];
	   				EC.insertDefParts(sa);
	   			}
				F.dispose();
				ed.dispose();
				break;
			case expr:
		    	EC.setEditing(true);
				EC.saveText();
   				EC.insertExpr("0.00");
				break;
		}
		EC.requestFocus();
	}

	private int isymb=-1,ifec=-1,as_in=-1;
    private boolean dragged=false;

	public void mousePressed(MouseEvent e) {
    	if (extra_mch!=null) {
    		return;
    	}
    	if (!mch.isHand()) {
    		ifec=-1; isymb=-1;
			for (int i=0;i<bFEC.length;i++) {
				if (e.getSource()==bFEC[i]) {
					ifec=i;
					break;
				}
			}
			for (int i=0;i<bSymb.length;i++) {
				if (e.getSource()==bSymb[i]) {
					isymb=i;
					break;
				}
			}
    	}
	}

	public void mouseReleased(MouseEvent e) {
    	if (extra_mch!=null) {
    		return;
    	}
    	if (!mch.isHand() && e.getModifiers()!=e.BUTTON3_MASK) {
	    	if (e.getSource()==b_hl) {
				EC.saveText();
	    		EC.insertHyperlink();
	    	} else if (e.getSource()==b_ctrl) {
				EC.saveText();
	    		EC.insertControl(0,inFormula);
	    	} else if (e.getSource()==b_text_) {
				EC.saveText();
	    		EC.insertControl(1,inFormula);
	    	} else if (e.getSource()==b_text__) {
				EC.saveText();
	    		EC.insertControl(2,inFormula);
	    	} else if (e.getSource()==b_text___) {
				EC.saveText();
	    		EC.insertControl(3,inFormula);
	    	} else if (e.getSource()==b_menu) {
				EC.saveText();
	    		EC.insertControl(4,inFormula);
	    	} else if (e.getSource()==b_barra) {
				EC.saveText();
	    		EC.insertControl(5,inFormula);
	    	} else if (e.getSource()==b_button) {
				EC.saveText();
	    		EC.insertControl(6,inFormula);
	    	} else if (e.getSource()==b_spR2) {
				EC.saveText();
	    		EC.insertSpace(0);
	    	} else if (e.getSource()==b_spR3) {
				EC.saveText();
	    		EC.insertSpace(1);
	    	} else if (e.getSource()==b_spTA) {
				EC.saveText();
	    		EC.insertSpace(2);
	    	} else if (e.getSource()==b_spHF) {
System.out.println("inserting space HF ");
				EC.saveText();
	    		EC.insertSpace(4);
	    	} else if (e.getSource()==b_spGL) {
				EC.saveText();
	    		EC.insertSpace(3);
	    	} else if (e.getSource()==b_for ) {
				EC.saveText();
	    		EC.insertFormula("");
				EC.activateButtons();
	    		EC.requestFocus();
	    		return;
    		} else if (e.getSource()==b_uc) {
	    		openSymbolsDialog(b_uc);
	    		return;
    		} else if (e.getSource()==colorButton && (e.getModifiers()==16 || e.getModifiers()==18)) {


				// Esto va aqu porque en el JVM de MS el ActionEvent no tiene modifiers!=0
				// y por tanto no puede distinguirse si se puls el botn con Ctrl o sin l.
				if (ecd==null) {
					ecd=new editColorDialog(pf,"",true,"","");
				}
				ecd.setTitle(Tr.getTr(data.color));
				ecd.setLabels(Tr.getTr(data.accept),Tr.getTr(data.cancel));
				ecd.setCopyLabels(Tr.getTr(data.copy),Tr.getTr(data.paste));
				ecd.setColorNames(Tr);
				if (e.getModifiers()==16) {
					ecd.setMjaColor(colorButton.getMjaTextColor());
				} else {
					ecd.setMjaColor(colorButton.getMjaBackColor());
				}
				ecd.display();
				if (ecd.ok) {
					if (e.getModifiers()==16) {
						colorButton.setTextColor(ecd.getMjaColor());
					} else {
						colorButton.setBackColor(ecd.getMjaColor());
					}
		    		EC.insertColors(getColorsFromControls());
		    		if (!EC.segIsMarked()) {
						colorButton.setEnabled(false); // porque en JVM de Sun 1.4 el botn vuelve a coger el foco.
	    				EC.requestFocus();
	    			}
				}
			}
			if (isymb>=0||ifec>=0) {
		    	if (!dragged) {
					for (int i=0;i<bFEC.length;i++) {
						if (e.getSource()==bFEC[i]) {
							insertNewFormulaItem(i);
							return;
						}
					}
					for (int i=0;i<bSymb.length;i++) {
						if (e.getSource()==bSymb[i]) {
							if (i==ixOther) {
					    		openSymbolsDialog(bSymb[ixOther]);
							} else {
								EC.saveText();
								EC.insertText(bSymb[i].getLabel());
								EC.requestFocus();
							}
							return;
						}
					}
		    	} else {
					Point bl=null;
					if (isymb>=0) {
						bl=bSymb[isymb].getLocationOnScreen();
					} else if (ifec>=0) {
						bl=bFEC[ifec].getLocationOnScreen();
					}
					Point ecl=EC.getLocationOnScreen();
					int ex=(bl.x+e.getX())-ecl.x;
					int ey=(bl.y+e.getY())-ecl.y;
					if (0<=ex && ex<EC.getSize().width && 0<=ey && ey<EC.getSize().height) {
						EC.doMousePressed(ex,ey);
						if (isymb>=0) {
							if (isymb!=ixOther) {
								EC.saveText();
								EC.insertText(bSymb[isymb].getLabel());
								EC.requestFocus();
							}
						} else if (ifec>=0) {
							insertNewFormulaItem(ifec);
						}
					}
				}
				isymb=-1;
				ifec=-1;
//				setCursor(null);
			}
		}
		dragged=false;
	}
	public void mouseClicked(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {
    	if (extra_mch!=null) {
    		return;
    	}
    	if (!mch.isHand()) {
			if (e.getSource()==EC&&!dragged) {
				updateEnabling();
			}
		}
	}
	public void mouseExited(MouseEvent e) {
	}
	
/* ------------------ MouseMotionListener -------------------- */

	public void mouseMoved(MouseEvent e) {
	}
	public void mouseDragged(MouseEvent e) {
    	if (extra_mch!=null) {
    		return;
    	}
    	if (!mch.isHand()) {
			if (ifec>=0||(isymb>=0&&isymb!=ixOther)) {
				setCursor(Cursor.getPredefinedCursor(Cursor.MOVE_CURSOR));
				dragged=true;
			}
		}
	}
}