/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.textedit;

import java.awt.*;
import java.awt.event.*;

import com.mja.lang.translator;
import com.mja.file.mjaFile;
import com.mja.file.mjaFont;
import com.mja.util.BasicStr;
import com.mja.util.TFont;
import com.mja.cmp.mjaButton;
import com.mja.text.*;
import com.mja.textedit.*;

public class FormulaEditor extends Panel {
	
	static final String FormulaEditorAttributes="fuentes=si colores=si fracciones=si potencias=si radicales=si series=si integrales=si limites=si matrices=si expresiones=no formulas=si caracteres=si unicode=no rtf=no imgenes=no";
	private static Color defaultBGColor=Color.white, defaultFGColor=Color.black;
	private static Color panelBGColor=new Color(0xffffff);
	private static final boolean variableSize=true, onlyFormula=false;
	private static Frame parent=new Frame();
	private static TFont tfont;

	private EditorButtons EB;
	private EditorCanvas EC;
	private String in_formula;

	public FormulaEditor(Frame fr,translator Tr,String in_formula) {
		this.parent=fr;
		this.in_formula=in_formula;
		setBackground(panelBGColor);
		setForeground(defaultFGColor);
		if (tfont==null) {
			tfont = new TFont(mjaFont.makeFont("Serif",Font.PLAIN,40));
		}
		EC=new EditorCanvas(null,parent,Tr,null,null,tfont,defaultFGColor,false,false,variableSize,onlyFormula);
		EC.setBackground(defaultBGColor);
		EC.setSize(760,300);
		EB=new EditorButtons(null,parent,Tr,true,true,true,false);
//		EB.useOtros=false;
		EB.setAttributes(FormulaEditorAttributes);
		EB.setEditorCanvas(EC,false);
 		EB.setEditing(true);
		EB.selectChars(EditorButtons.Latin);
		EB.updateChars();
		EC.addActionListener(EB);
		setLayout(new BorderLayout());
		add("North",EB);
		add("Center",EC);
	}

	public void setText(String rtf_str) {
		Text T=new Text(null,tfont,defaultBGColor,defaultFGColor);
		RTF.parseRTF(rtf_str,T);
		T.setTopAndBottomMargin(0);
		T.setLeftMargin(3);
		EC.setText(T);
		EC.updateScreen();
	}

	public String getText() {
		return EC.toRTF(false);
	}
	
}