/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.util;

import java.util.*;
import java.applet.Applet;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FontMetrics;
import java.awt.Font;
import java.awt.Color;
import com.mja.file.mjaFont;

public final class BasicStr {
	
	public static boolean antialias=false;
	public static final int real_precision=13;
	public static String decimal_symbol=",";
	public static boolean ShiftOn=false;
	public static boolean CtrlOn=false;
	public static Applet A=null;
	public static boolean inWeb=true;
	
	public static boolean arrayContains(String[] options,String option) {
		for (int i=0;i<options.length;i++) {
			if (options[i].equals(option)) {
				return true;
			}
		}
		return false;
	}
	
	public static String[] toArr(String str) {
		String[] stra=new String[1];
		stra[0]=str;
		return stra;
	}

	public static boolean[] toArr(boolean b) {
		boolean [] ba=new boolean[1];
		ba[0]=b;
		return ba;
	}

	public static boolean classExists(String classname) {
		try {
			Class cl=Class.forName(classname);
			return true;
		} catch(Exception e) {
			return false;
		}
	}

	public static boolean isJava2() {
		return "1.3".compareTo(System.getProperty("java.version"))<=0;
	}

	public static boolean hasContent(String s) {
		return (s!=null && s.trim().length()>0);
	}

	public static String trim(String s,char ch) {
		if (s==null||s.length()==0) {
			return s;
		}
		int i1=0;
		while (s.charAt(i1)==ch) {
			i1++;
			if (i1>=s.length()) {
				return "";
			}
		}
		int i2=s.length()-1;
		while (s.charAt(i2)==ch) {
			i2--;
		}
		return s.substring(i1,i2+1);
	}

	public static String justify(String s,int j,char ch) {
		StringBuffer sb=new StringBuffer(s);
		if (j>0) {
			while (sb.length()<j) {
				sb.append(ch);
			}
		} else {
			while (sb.length()<-j) {
				sb.insert(0,ch);
			}
		}
		String auxs=new String(sb);
		if (j>0) {
			if (auxs.length()>j) {
				auxs=auxs.substring(0,j);
			}
		} else {
			if (auxs.length()>-j) {
				auxs=auxs.substring(auxs.length()+j);
			}
		}
		return auxs;
	}

/* ----------------------- Fonts ---------------------- */

	public static int fontSizeForHeight(int hh) {
		int fh=Math.min(50,hh);
		if (fh>=24) {
			fh=(int) Math.floor(fh/2+2-fh/16);
		} else if (fh>=20) {
			fh=12;
		} else if (fh>=17) {
			fh=11;
		} else if (fh>=15) {
			fh=10;
		} else {
			fh=9;
		}
		return fh;
	}
	
	public static String FontToString(Font f) {
		String s="";
		if (f!=null) {
			String style="PLAIN";
			if (f.isBold()&&f.isItalic()) {
				style="BOLD+ITALIC";
			} else if (f.isBold()) {
				style="BOLD";
			} else if (f.isItalic()) {
				style="ITALIC";
			}
			s=f.getName()+","+style+","+String.valueOf(f.getSize());
		}
		return s;
	}

	public static Font parseGeneralFont(String str,Font deffont)	{
		return parseFont(str,deffont,true);
	}

	public static Font parseFont(String str,Font deffont)	{
		return parseFont(str,deffont,false);
	}

	private static Font parseFont(String str,Font deffont,boolean general)	{
		if (str!=null) {
			StringTokenizer st=new StringTokenizer(str,",",true);
			if (st.countTokens()>=2) {
				String fn=st.nextToken();
				if (fn.equals(",")) {
					fn = "";
				} else {
					st.nextToken();
				}
				String ft=st.nextToken();
				if (ft.equals(",")) {
					ft = "";
				} else {
					st.nextToken();
				}
				String fs = "";
				if (st.hasMoreTokens()) {
					fs=st.nextToken();
					if (fs.equals(",")) {
						fs = "";
					}
				}
				return parseFont(fn, ft, fs,deffont,general);
			}
		}
		return deffont;
	}

	public static Font parseFont(String fName, String fStyle, String fSize, Font deffont,boolean general) {
		String fname  = fName;
		if (fname==null || fname.length()==0) {
			fname = deffont.getName();
		}
		int fstyle = deffont.getStyle();
		if (BasicStr.hasContent(fStyle)) {
			fstyle = Font.PLAIN;
			if (fStyle.indexOf("BOLD")>=0) {
				fstyle += Font.BOLD;
			}
			if (fStyle.indexOf("ITALIC")>=0) {
				fstyle += Font.ITALIC;
			}
		}
		int fsize = deffont.getSize();
		if (BasicStr.hasContent(fSize)) {
			try {
				fsize = Integer.parseInt(fSize);
			} catch (NumberFormatException nfe) {
				fsize = deffont.getSize();
			}
		}
		if (general) {
			return new Font(fname,fstyle,fsize);
		} else {
			return mjaFont.makeFont(fname,fstyle,fsize);
		}
	}
	
	public static double getStringWidth(String s,String fontName,String fontType,String fontSize,Component C)	{
		int size=parseInteger(fontSize,15,15);
		Font font =parseFont(fontName,fontType,fontSize,new Font("SansSerif",Font.PLAIN,size),true);
		if (C!=null) {
			FontMetrics fm=C.getFontMetrics(font);
			return fm.stringWidth(s);
		}
		return ((double) s.length())*size/2.0;
	}

	public static double getRed(String s)	{
		if (hasContent(s)) {
			try {
				s=s.substring(s.length()-6,s.length()-4);
				int red = Integer.parseInt(s,16);
				double rojo = ((double)red)/256.0;
				return rojo;
			} catch (NumberFormatException nfe) {
			}
		}
		return 0.0;
	}

	public static double getGreen(String s)	{
		if (hasContent(s)) {
			try {
				s=s.substring(s.length()-4,s.length()-2);
				int green = Integer.parseInt(s,16);
				double verde = ((double)green)/256.0;
				return verde;
			} catch (NumberFormatException nfe) {
			}
		}
		return 0.0;
	}

	public static double getBlue(String s)	{
		if (hasContent(s)) {
			try {
				s=s.substring(s.length()-2);
				int blue = Integer.parseInt(s,16);
				double azul = ((double)blue)/256.0;
				return azul;
			} catch (NumberFormatException nfe) {
			}
		}
		return 0.0;
	}

/* ------------------------------------------------------------ */


	public static String IntegerToString(int i,int sz) {
		String auxs=Integer.toString(i);
		while (auxs.length()<sz) {
			auxs="0"+auxs;
		}
		return auxs;
	}

	public static int parseInteger(String s,int defval,int nullval) {
		if (hasContent(s)) {
			try {
				return Integer.parseInt(s);
			} catch (NumberFormatException nfe) {
				return defval;
			}
		} else {
			return nullval;
		}
	}

	public static double parseDouble(String s) throws NumberFormatException {
		if (hasContent(s)) {
			try {
				double d = Double.valueOf(s).doubleValue();
				return d;
			} catch (NumberFormatException nfe) {
				throw nfe;
			}
		} else {
			throw new NumberFormatException("parsing empty string");
		}
	}
	
	public static double parseDouble(String s,double defval) {
		return parseDouble(s,defval,defval);
	}

	public static double parseDouble(String s,double defval, double nullval) {
		if (hasContent(s)) {
			try {
				double d = Double.valueOf(s).doubleValue();
				return d;
			} catch (NumberFormatException nfe) {
				return defval;
			}
		} else {
			return nullval;
		}
	}

	public static double parsePercentageOf(String s,double base,double defval,double nullval) {
		if (BasicStr.hasContent(s)) {
			String auxs=s.trim();
			boolean isPercentage=false;
			if (auxs.endsWith("%")) {
				auxs=auxs.substring(0,auxs.length()-1);
				isPercentage=true;
			}
			try {
				double r=BasicStr.parseDouble(auxs,defval,nullval);
				if (isPercentage) {
					r=(r*base)/100;
				}
				return r;
			} catch (NumberFormatException nfe) {
				return defval;
			}
		} else {
			return nullval;
		}
	}

	public static void addToStringVector(Vector V,String s) {
		StringTokenizer st=new StringTokenizer(s,"\n",false);
		while (st.hasMoreTokens()) {
			V.addElement(st.nextToken());
		}
	}

	public static String[] toStringArray(String s) {
		return toStringArray(s,false);
	}

	public static String[] toStringArray(String s,boolean returnDelims) {
		//StringTokenizer st=new StringTokenizer(s,"\n",returnDelims);
		StringTokenizer st=new StringTokenizer(s,"\r\n",returnDelims);
		String[] sa=new String[st.countTokens()];
		for (int i=0; i<sa.length; i++) {
			sa[i]=st.nextToken();
		}
		return sa;
	}

	public static String[] toStrArr(String s) {
		String s0=replace(s,"\r","");
		Vector V=new Vector();
		int pos=0;
		while ((pos=s0.indexOf("\n"))>=0) {
			V.addElement(s0.substring(0,pos));
			s0=s0.substring(pos+1);
		}
		V.addElement(s0);
		String[] sa=new String[V.size()];
		for (int i=0;i<sa.length;i++) {
			sa[i]=(String) V.elementAt(i);
		}
		return sa;
	}

	public static String[] getElements(String s0,String delim) {
		String s=s0.trim();
		for (int i=0;i<delim.length();i++) {
			s=replace(s,delim.substring(i,i+1),"\n").trim();
		}
		return toStringArray(s);
	}

	public static String[] getElements(String s) {
		return toStringArray(BasicStr.replace(s.trim(),";","\n"));
	}

/* ------- Analisis de expresiones con "puntos" como polgonos, arcos, etc... -------- */

	static final String openP="[(", closeP="])", sep=",";

	public static String[] getTokens(String s) throws Exception {
// para separar por ejemplo [0,0]R[A[0],A[1]]
// primero en [0,0],R,[A[0],A[1]]
		Vector v=new Vector();
		StringBuffer sb=new StringBuffer("");
		Stack S=new Stack();
		for (int i=0;i<s.length();i++) {
			char ch=s.charAt(i);
			int ix=openP.indexOf(ch);
			if (ix>=0) {
				S.push(new Integer(ix));
				if (S.size()==1) {
					v.addElement(new String(sb));
					sb=new StringBuffer();
				}
				sb.append(ch);
			} else {
				sb.append(ch);
				ix=closeP.indexOf(ch);
				if (ix>=0) {
					if (ix==((Integer) S.peek()).intValue()) {
						S.pop();
						if (S.empty()) {
							v.addElement(new String(sb));
							sb=new StringBuffer();
						}
					} else {
						throw new Exception(""+ch+" not expected");
					}
				}
			}
		}
		if (sb.length()>0) {
			v.addElement(new String(sb));
		}
// y luego en 0,0,R,A[0],A[1]
		Vector v2=new Vector();
		String s0="";
		Enumeration e=v.elements();
		while (e.hasMoreElements()) {
			String auxs=(String) e.nextElement();
			if ( auxs.length()>0 ) {
				if (openP.indexOf(auxs.charAt(0))>=0
					&& openP.indexOf(auxs.charAt(0))==closeP.indexOf(auxs.charAt(auxs.length()-1))) {
					auxs=auxs.substring(1,auxs.length()-1);
					int inpar=0;
					sb=new StringBuffer("");
					for (int j=0;j<auxs.length();j++) {
						char ch=auxs.charAt(j);
						if (sep.indexOf(ch)>=0 && inpar==0) {
							v2.addElement(new String(sb));
							sb=new StringBuffer("");
						} else {
							sb.append(ch);
							if (openP.indexOf(ch)>=0) {
								inpar++;
							} else if (closeP.indexOf(ch)>=0) {
								inpar--;
							}
						}
					}
					v2.addElement(new String(sb));
				} else {
					v2.addElement(auxs);
				}
			}
		}
		String[] sa=new String[v2.size()];
		e=v2.elements();
		for (int i=0;i<sa.length;i++) {
			sa[i]=(String) e.nextElement();
		}
		return sa;
	}

	public static double minIncr(int precision) {
		if (precision>0) {
			String sdv="1";
			int n=precision;
			while (n>1) {
				sdv="0"+sdv;
				n--;
			}
			return Double.parseDouble("0."+sdv);
		} else {
			return 1;
		}
	}
	
	public static double round(double d,int p) {
		String str=DoubleToString(d,p,false);
		double dd=Double.parseDouble(str.replace(',','.'));
		return dd;
	}

	public static String DoubleToString(double x,int p,boolean fixed) {
		return DoubleToString(x,p,fixed,decimal_symbol);
	}

	public static String DoubleToString(double x,int p0,boolean fixed,String decsymb) {
		double a=Math.abs(x);
		String xS=Double.toString(a);
		int exp=0;
		if (xS.indexOf("E-")>=0) {
			int posE=xS.indexOf("E-");
			String expS=xS.substring(posE+2);
			exp=-Integer.parseInt(expS);
			xS=xS.substring(0,posE);
		} else if (xS.indexOf("E")>=0) {
			int posE=xS.indexOf("E");
			String expS=xS.substring(posE+1);
			exp=Integer.parseInt(expS);
			xS=xS.substring(0,posE);
		} else if (a<Math.pow(10,-real_precision)) {
			a=0;
		}
		int pos=xS.indexOf(".");
		if (pos<0) {
			pos=xS.length();
		} else {
			xS=xS.substring(0,pos)+xS.substring(pos+1);
		}
		while (xS.length()>0 && xS.charAt(0)=='0') {
			xS=xS.substring(1);
			pos--;
		}
		if (xS.length()>real_precision) {
			if (xS.charAt(real_precision)>='5') {
				String aux=xS.substring(0,real_precision);
				long L=Long.parseLong(aux);
				L=L+1;
				xS=Long.toString(L);
				if (xS.length()>real_precision) {
					xS+="0";
					exp++;
				}
			} else {
				xS=xS.substring(0,real_precision);
			}
		}
		pos=pos+exp;
		while (pos<0) {
			xS="0"+xS;
			pos++;
		}
		while (xS.length()<pos) {
			xS=xS+"0";
		}
		if (pos>0) {
			xS=xS.substring(0,pos)+decsymb+xS.substring(pos);
		} else {
			xS="0"+decsymb+xS;
			pos=1;
		}
		int p=Math.max(0,p0);
		if (p==0 || pos+1+p < xS.length()) {
			int k=pos+1+p;
			if (xS.length()>k) {
				if ( 
						( (x>0) && (xS.charAt(k)>='5') ) ||
						( (x<0) && (xS.charAt(k)>'5') ) ||
						( (x<0) && (xS.charAt(k)=='5') && !allZero(xS.substring(k+1)) ) 
					) {
					boolean debouna=true;
					while (debouna) {
						if (k==0) {
							xS='1'+xS;
							break;
						} else {
							char ch=xS.charAt(k-1);
							if (ch!='.' && ch!=',') {
								if (ch<'9') {
									ch=(char) (ch+1);
									debouna=false;
								} else {
									ch='0';
									debouna=true;
								}
								xS=xS.substring(0,k-1)+ch+xS.substring(k);
							}
						}
						k--;
					}
				} 
			}
			xS=xS.substring(0,pos+1+p);
			if (p0<=0) {
				if (xS.length()>0 && (xS.charAt(xS.length()-1)==',' || xS.charAt(xS.length()-1)=='.') ) {
					xS=xS.substring(0,xS.length()-1);
				}
				while (xS.length()<Math.abs(p0)) {
					xS="0"+xS;
				}
			}
		} else if (fixed) {
			while (xS.length()<pos+1+p) {
				xS+=0;
			}
		}
		if (!fixed && p0>=0) {
			while (xS.length()>pos &&
				(xS.charAt(xS.length()-1)=='0' || xS.charAt(xS.length()-1)==decsymb.charAt(0))) {
				boolean quit=xS.charAt(xS.length()-1)==decsymb.charAt(0);
				xS=xS.substring(0,xS.length()-1);
				if (quit) break;
			}
		}
		if (xS.equals("")) {
			xS="0";
		}
		if (x<0 && Double.parseDouble(xS.replace(',','.'))!=0.0) {
			xS="-"+xS;
		}
		return xS;
	}

	public static boolean allZero(String s) {
		for (int i=0;i<s.length();i++) {
			if (s.charAt(i)!='0') {
				return false;
			}
		}
		return true;
	}
/* -------------------- Notacin Exponencial para Descartes ------------------- */

	public static String notExp(double d,int dec,boolean fixed) {
		return notExp(d,1,0,dec,fixed,decimal_symbol);
	}

	private static String notExp(double d,double inf, double sup,int dec,boolean fixed,String decsymb) {
		if (d==0.0) {
			return "0";
		}
		double D=Math.abs(d);
		if (inf<=D && D<=sup) {
			String s=DoubleToString(d,dec,fixed,decsymb);
			return DoubleToString(d,dec,fixed,decsymb);
		}
		String s=DoubleToString(D,50,false,decsymb);
		String sign=""; if (d<0) { sign="-"; }
		int pot=0;
		int posp=s.indexOf(decsymb);
		if (posp<0) {
			posp=s.indexOf(".");
		}
		if (posp<0) {
			posp=s.indexOf(",");
		}
		if (posp>0) {
			pot-=s.length()-1-posp;
			s=s.substring(0,posp)+s.substring(posp+1);
		}
		while (s.startsWith("0")) { // Quitar ceros a la izquierda
			s=s.substring(1);
		}
		while (s.endsWith("0")) { // Quitar ceros a la derecha y aumentar exponente
			s=s.substring(0,s.length()-1);
			pot++;
		}
		if (s.length()==0) {
			s="0";
		}
		if (s.length()>1)  { // poner nuevo punto decimal
			pot+=s.length()-1;
			s=s.substring(0,1)+"."+s.substring(1);
		}
		double x=BasicStr.parseDouble(s,0,0);
		s=DoubleToString(x,dec,fixed,decsymb);
		s+="E"+Integer.toString(pot);
		return sign+s;
	}

	public static String replace(String s,String s1,String s2) {
		if (s!=null&&s.length()>0) {
			String auxs=s;
			int pos=0,l1=s1.length();
			while ((pos=auxs.indexOf(s1,pos))>=0) {
				auxs=auxs.substring(0,pos)+s2+auxs.substring(pos+l1);
				pos+=s2.length();
			}
			return auxs;
		} else {
			return "";
		}
	}

	public static String adjust(String s,int columns,Dimension d,boolean nlap,FontMetrics fm) {
		if (!hasContent(s)) {
			return s;
		}
		int chws=0;
		for (int i=32;i<128;i++) {
			chws+=fm.charWidth((char) i);
		}
		int width=(columns*chws+1)/96;
		String s1="";
		StringTokenizer st=new StringTokenizer(s,"\n");
		d.width=0; d.height=0;
		while (st.hasMoreTokens()) {
			String auxs=st.nextToken();
			if (fm.stringWidth(auxs)>width) {
				StringTokenizer st1=new StringTokenizer(auxs," ");
				String auxs1="";
				while (st1.hasMoreTokens()) {
					String auxs2=st1.nextToken();
					if (fm.stringWidth(auxs1)+fm.charWidth(' ')+fm.stringWidth(auxs2)<width) {
						auxs1+=" "+auxs2;
					} else {
						if (auxs1.length()>0) {
							s1+="\n "+auxs1.trim();
							d.width=Math.max(d.width,fm.stringWidth(auxs1.trim()));
							d.height++;
						}
						auxs1=auxs2;
					}
				}
				if (auxs1.length()>0) {
					s1+="\n "+auxs1.trim();
					d.width=Math.max(d.width,fm.stringWidth(auxs1.trim()));
					d.height++;
				}
			} else {
				s1+="\n "+auxs;
				d.width=Math.max(d.width,fm.stringWidth(auxs.trim()));
				d.height++;
			}
			if (nlap && st.hasMoreTokens()) {
				s1+="\n";
				d.height++;
			}
			d.height++;
		}
		d.width++;
		return s1;
	}

	public static boolean equalsIgnoreAccents(String s1,String s2) {
		return normalize(s1).equals(normalize(s2));
	}

	public static String normalize(String s) {
		return toLowerCase(eliminateAccents(s));
	}

	public static String toLowerCase(String s) {
		StringBuffer t=new StringBuffer(s.toLowerCase());
		for (int i=0;i<t.length();i++) {
			switch (t.charAt(i)) {
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			case '' : t.setCharAt(i,''); break;
			}
		}
		return new String(t);
	}

	public static String eliminateAccents(String s) {
		StringBuffer t=new StringBuffer(s);
		for (int i=0;i<t.length();i++) {
			switch (t.charAt(i)) {
			case '' : case '' : case '' : case '' : t.setCharAt(i,'a'); break;
			case '' : case '' : case '' : case '' : t.setCharAt(i,'e'); break;
			case '' : case '' : case '' : case '' : t.setCharAt(i,'i'); break;
			case '' : case '' : case '' : case '' : t.setCharAt(i,'o'); break;
			case '' : case '' : case '' : case '' : t.setCharAt(i,'u'); break;
			case '' : case '' : case '' : case '' : t.setCharAt(i,'A'); break;
			case '' : case '' : case '' : case '' : t.setCharAt(i,'E'); break;
			case '' : case '' : case '' : case '' : t.setCharAt(i,'I'); break;
			case '' : case '' : case '' : case '' : t.setCharAt(i,'O'); break;
			case '' : case '' : case '' : case '' : t.setCharAt(i,'U'); break;
			case '' : 									t.setCharAt(i,'N'); break;
			case '' : 									t.setCharAt(i,'n'); break;
			}
		}
		return new String(t);
	}

	public static boolean isPureAlpha(char ch) {
		if ( (ch>='a' && ch<='z') || (ch>='A' && ch<='Z') || (ch>='\u0391' && ch<='\u03c9') ) {
			return true;
		}
	    switch (ch) {
		case '' : case '' : case '' : case '' :
		case '' : case '' : case '' : case '' :
		case '' : case '' : case '' : case '' :
		case '' : case '' : case '' : case '' :
		case '' : case '' : case '' : case '' :
		case '' : case '' : case '' : case '' :
		case '' : case '' : case '' : case '' :
		case '' : case '' : case '' : case '' :
		case '' : case '' : case '' : case '' :
		case '' : case '' : case '' : case '' :
		case '' : case '' :
		case '_' : // case '\'' : case '' : case '\"' :
				 return true;
		default  : return false;
		}
	}

	public static String reducePath(String path) {
		String s=new String(path);
		while (s.indexOf("..\\")>0) {
			int n=s.indexOf("..\\");
			String auxs1=s.substring(0,n);
			String auxs2=s.substring(n+3,s.length());
			if (auxs1.endsWith("\\")) {
				auxs1=auxs1.substring(0,auxs1.length()-1);
			}
			int m=auxs1.lastIndexOf("\\");
			String s1=s;
			if (m>0) {
				auxs1=auxs1.substring(0,m);
				s1=auxs1+"\\"+auxs2;
			}
			if (s.length()==s1.length()) {
				break;
			}
			s=s1;
		}
		while ( s.indexOf("../")>0 ) {
			int n=s.indexOf("../");
			String auxs1=s.substring(0,n);
			String auxs2=s.substring(n+3,s.length());
			if (auxs1.endsWith("/")) {
				auxs1=auxs1.substring(0,auxs1.length()-1);
			}
			int m=auxs1.lastIndexOf("/");
			String s1=s;
			if (m>0) {
				auxs1=auxs1.substring(0,m);
				s1=auxs1+"/"+auxs2;
			}
			if (s.length()==s1.length()) {
				break;
			}
			s=s1;
		}

		return replace(s,"c:","C:");
	}

	public static String getOnlyPath(String uri) {
		int n=uri.lastIndexOf("/");
		if (n>0 && n<uri.length()-2) {
			return uri.substring(0,n+1);
		}
		return uri;
	}

	public static String convertToFilePath(String uri) {
		String s=new String (uri);
		if (osIsWindows()) {
			for (char ch='C';ch<='Z';ch++) {
				if (s.indexOf(ch+":")>0) {
					int n=s.indexOf(ch+":");
					String auxs1=s.substring(0,n);
					String auxs2=s.substring(n,s.length());
					s=auxs1+replace(auxs2,"/","\\");
					break;
				}
			}
		}
		return s;
	}

	public static String getReducedCodeBase(Applet A) {
		return "./";
//		String docbase=A.getDocumentBase().toExternalForm();
//		docbase=docbase.substring(0,docbase.lastIndexOf('/')+1);
//		String codebase=A.getCodeBase().toExternalForm();
//		if (codebase.length()>0&&!codebase.endsWith("/")) {
//			codebase+="/";
//		}
//		if (docbase.equals(codebase)) {
//			codebase="./";
//		} else if (codebase.startsWith(docbase)) {
//			codebase=codebase.substring(docbase.length());
//		} else if (docbase.startsWith(codebase)) {
//			docbase=docbase.substring(0,docbase.lastIndexOf('/'));
//			codebase=codebase.substring(0,codebase.lastIndexOf('/'));
//			String cb="";
//			while (docbase.length()>codebase.length()) {
//				docbase=docbase.substring(0,docbase.lastIndexOf('/'));
//				cb+="../";
//			}
//			codebase=cb;
//		}
//		return codebase;
	}

	public static String getOs() {
		String osname=System.getProperty("os.name");
		return osname;
	}

	/**
	 *	@return true only if the os is Windows,
	 */
	public static boolean osIsWindows() {
		String osname=System.getProperty("os.name");
		if (osname!=null&&osname.toLowerCase().startsWith("windows")) {
			return true;
		}
		return false;
	}

	/**
	 *	@return true only if the os is MacOs,
	 */
	public static boolean osIsMac() {
		String osname=System.getProperty("os.name");
		if (osname!=null&&(osname.toLowerCase().indexOf("mac")>=0)) {
			return true;
		}
		return false;
	}

        /**
         *
         *  * @return true only if the os is Linux
         */
//	public static boolean osIsLinux() {
//		String osname=System.getProperty("os.name");
//		if(osname!=null&&osname.toLowerCase().startsWith("linux")) {
//		  return true;
//		}
//		return false;
//	}

        /**
         *
         *  * @return true only if the os is solaris
         */
//        public static boolean osIsSolaris(){
//          String osname=System.getProperty("os.name");
//          if(osname!=null&&osname.toLowerCase().startsWith("sunos")) {
//              return true;
//          }
//          return false;
//        }

	public static int lineVSize() {
		if (osIsWindows()) {
	   		return 23;
		} else {
			return 29;
		}
	}

/*
   public static double osScaling() {
   		if (osIsWindows()) {
   			return 1.0;
   		} else {
// comentado el 29 de abril de 2008 para la versin 3.915. Esto causar que los textos no se vean bien.
//   			return 29.0/23.0;
   			return 1;
   		}
   }
*/
   
   public static String DocPath(Applet A) {
		String doc=A.getDocumentBase().toExternalForm();
		String cod=A.getCodeBase().toExternalForm();
		String base=doc.substring(cod.length());
		String path=base+"/";
		return path;
   }

/************************* For dumping to LaTeX usins pstricks ******************************/

	public static String DblStr(double x) {
		return BasicStr.DoubleToString(x,5,false,".");
	}
	
	public static String DefineColor(boolean grayscale,String name,Color color){
		if (grayscale) {
			String gris=DblStr((double) 0.22*color.getRed()/256.0+(double) 0.66*color.getGreen()/256.0+(double) 0.12*color.getBlue()/256.0);
			return "\\definecolor{"+name+"}{rgb}{"+gris+","+gris+","+gris+"}\r\n";
		} else {
			String r=DblStr((double) color.getRed()/256.0);
			String g=DblStr((double) color.getGreen()/256.0);
			String b=DblStr((double) color.getBlue()/256.0);
			return "\\definecolor{"+name+"}{rgb}{"+r+","+g+","+b+"}\r\n";
		}
	}
	
	public static final String nL="\r\n";
	public static final String nL2=nL+nL;
	
	public static String getTeX_Header(int W,int H) {
		String str="\\documentclass{article}"+nL
						+"\\usepackage{pstricks}"+nL
						+"\\usepackage{pst-all}"+nL
						+"\\usepackage{color}"+nL
						+"\\usepackage{amsmath}"+nL
						+"\\usepackage{amssymb}"+nL
						+"\\usepackage[utf8]{inputenc}"+nL
						+"\\usepackage[vcentering,dvips]{geometry}"+nL
						+"\\geometry{papersize={"+W+"pt,"+H+"pt},total={"+W+"pt,"+H+"pt}}"+nL
						+"\\parindent=0pt"+nL2;
		return str;
	}

	public static String getTeX_BeginDoc(double SCL, int W, int H, double DX, double DY) {
		return nL+"\\begin{document}"+nL2
//					+"\\psset{unit="+SCL+"pt,algebraic=true,dotstyle=o,dotsize=1pt 0,linewidth=0.3pt,arrowsize=3pt 2,arrowinset=0.25}"+nL2
					+"\\psset{unit="+"0.5"+"pt,algebraic=true,dotstyle=o,dotsize=1pt 0,linewidth=0.3pt,arrowsize=3pt 2,arrowinset=0.25}"+nL2
					+"\\psscalebox{1}{"+nL2
					+"\\begin{pspicture}("+W+"pt,"+H+"pt)"+nL2
					+"\\rput("+BasicStr.DoubleToString(DX,5,false,".")+","+BasicStr.DoubleToString(DY,5,false,".")+"){"+nL2;
	}
	
	public static final String TeX_Tail=nL+"}"+nL2+"\\end{pspicture}"+nL2+"}"+nL2+"\\end{document}"+nL;

	public static String TeXgreek(char ch) {
		String str="";
		switch (ch) {
			case 0x0391 : str="A"; break;
			case 0x0392 : str="B"; break;
			case 0x0393 : str="\\Gamma "; break;
			case 0x0394 : str="\\Delta "; break;
			case 0x0395 : str="E"; break;
			case 0x0396 : str="Z"; break;
			case 0x0397 : str="H"; break;
			case 0x0398 : str="\\Theta "; break;
			case 0x0399 : str="I"; break;
			case 0x039A : str="K"; break;
			case 0x039B : str="\\Lambda "; break;
			case 0x039C : str="M"; break;
			case 0x039D : str="N"; break;
			case 0x039E : str="\\Xi "; break;
			case 0x039F : str="O"; break;
			case 0x03A0 : str="\\Pi "; break;
			case 0x03A1 : str="P"; break;
			case 0x03A3 : str="\\Sigma "; break;
			case 0x03A4 : str="T"; break;
			case 0x03A5 : str="\\Upsilon "; break;
			case 0x03A6 : str="\\Phi "; break;
			case 0x03A7 : str="X"; break;
			case 0x03A8 : str="\\Psi "; break;
			case 0x03A9 : str="\\Omega "; break;
			case 0x03B1 : str="\\alpha "; break;
			case 0x03B2 : str="\\beta "; break;
			case 0x03B3 : str="\\gamma "; break;
			case 0x03B4 : str="\\delta "; break;
			case 0x03B5 : str="\\epsilon "; break;
			case 0x03B6 : str="\\zeta "; break;
			case 0x03B7 : str="\\eta "; break;
			case 0x03B8 : str="\\theta "; break;
			case 0x03B9 : str="\\iota "; break;
			case 0x03BA : str="\\kappa "; break;
			case 0x03BB : str="\\lambda "; break;
			case 0x03BC : str="\\mu "; break;
			case 0x03BD : str="\\nu "; break;
			case 0x03BE : str="\\xi "; break;
			case 0x03BF : str="o"; break;
			case 0x03C0 : str="\\pi "; break;
			case 0x03C1 : str="\\rho "; break;
			case 0x03C2 : str="\\varsigma "; break;
			case 0x03C3 : str="\\sigma "; break;
			case 0x03C4 : str="\\tau "; break;
			case 0x03C5 : str="\\upsilon "; break;
			case 0x03C6 : str="\\phi "; break;
			case 0x03C7 : str="\\chi "; break;
			case 0x03C8 : str="\\psi "; break;
			case 0x03C9 : str="\\omega "; break;
			default: str=String.valueOf(ch); break;
		}
		return str;
	}
	
	public static String TeXchar(char ch,boolean mathmode) {
		String str="";
		if (ch==' ') {
			str="\\ ";
		} else if (ch=='') {
			if (mathmode) {
				str="\\acute{a}";
			} else {
				str="\\'a";
			}
		} else if (ch=='') {
			if (mathmode) {
				str="\\acute{e}";
			} else {
				str="\\'e";
			}
		} else if (ch=='') {
			if (mathmode) {
				str="\\acute{i}";
			} else {
				str="\\'i";
			}
		} else if (ch=='') {
			if (mathmode) {
				str="\\acute{o}";
			} else {
				str="\\'o";
			}
		} else if (ch=='') {
			if (mathmode) {
				str="\\acute{u}";
			} else {
				str="\\'u";
			}
		} else if (ch=='') {
			if (mathmode) {
				str="\\ddot{u}";
			} else {
				str="\\\"u";
			}
		} else if (ch=='') {
			if (mathmode) {
				str="\\tilde{n}";
			} else {
				str="\\~n";
			}
		} else if (ch=='') {
			if (mathmode) {
				str="\\acute{A}";
			} else {
				str="\\'A";
			}
		} else if (ch=='') {
			if (mathmode) {
				str="\\acute{E}";
			} else {
				str="\\'E";
			}
		} else if (ch=='') {
			if (mathmode) {
				str="\\acute{I}";
			} else {
				str="\\'I";
			}
		} else if (ch=='') {
			if (mathmode) {
				str="\\acute{O}";
			} else {
				str="\\'O";
			}
		} else if (ch=='') {
			if (mathmode) {
				str="\\acute{U}";
			} else {
				str="\\'U";
			}
		} else if (ch=='') {
			if (mathmode) {
				str="\\tilde{N}";
			} else {
				str="\\~N";
			}
		} else if (ch==0x2212) {	// Smbolos
			str="-";
		} else if (ch==0x00B7) {
			str="\\cdot";
		} else if (ch==0x00D7) {
			str="\\times ";
		} else if (ch==0x00F7) {
			str="\\div ";
		} else if (ch==0x00B1) {
			str="\\pm ";
		} else if (ch==0x2260) {
			str="\\ne ";
		} else if (ch==0x2264) {
			str="\\le ";
		} else if (ch==0x2265) {
			str="\\ge ";
		} else if (ch==0x2248) {
			str="\\aprox ";
		} else if (ch==0x2261) {
			str="\\equiv ";
		} else if (ch==0x0192) {
			str="\\f ";
		} else if (ch==0x221E) {
			str="\\infty ";
		} else if (ch==0x2200) {
			str="\\forall ";
		} else if (ch==0x2203) {
			str="\\exists ";
		} else if (ch==0x2204) {
			str="\\not\\exists ";
		} else if (ch==0x2208) {
			str="\\in ";
		} else if (ch==0x2209) {
			str="\\notin ";
		} else if (ch==0x2234) {
			str="\\ ";
		} else if (ch==0x21D2) {
			str="\\Rightarrow ";
		} else if (ch==0x2205) {
			str="\\emptyset ";
		} else if (ch==0x2229) {
			str="\\cup ";
		} else if (ch==0x222A) {
			str="\\cap ";
		} else if (ch==0x2202) {
			str="\\partial ";
		} else if (ch==0x2206) {
			str="\\Delta ";
		} else if (ch==0x2207) {
			str="\\nabla ";
		} else if ((ch=='(')||(ch=='[')||(ch=='{')) {
			str="\\left "+ch;
		} else if ((ch==')')||(ch==']')||(ch=='}')) {
			str="\\right "+ch;
		} else {
			str=String.valueOf(ch);
		}
		return str;
	}



}