/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.util;

import java.awt.*;
import com.mja.file.mjaFont;

public class TFont {
	
	// Microsoft JVM

	private int [][] AD_MS_Serif = {
							{0,0},
							{1,0},
							{2,0},
							{3,1},
							{4,1},
							{4,1},
							{5,1},
							{6,2},
							{8,2},
							{10,2},
							{10,2},
							{11,3},
							{12,3},
							{12,3},
							{13,3},
							{13,4},
							{15,4},
							{15,4},
							{16,4},
							{16,5},
							{17,5},
							{18,5},
							{20,5},
							{20,6},
							{21,6},
							{23,6},
							{23,6},
							{24,7},
							{26,7},
							{26,7},
							{27,7},
							{28,7},
							{28,8},
							{29,8},
							{31,8},
							{32,8},
							{32,9},
							{33,9},
							{34,9},
							{34,9},
							{36,10},
							{37,10},
							{38,10},
							{39,10},
							{40,11},
							{41,11},
							{42,11},
							{42,11},
							{43,12},
							{44,12},
							{45,12},
							{45,12},
							{47,13},
							{48,13},
							{48,13},
							{49,13},
							{50,14},
							{51,14},
							{53,14},
							{53,14},
							{54,14},
							{54,15},
							{55,15},
							{56,15},
							{58,15},
							{58,16},
							{59,16},
							{60,16},
							{61,16},
							{61,17},
							{63,17},
							{64,17},
							{64,17},
							{65,18},
							{66,18},
							{67,18},
							{68,18},
							{69,19},
							{70,19},
							{71,19},
							{71,19}
						};
	private int[][] AD_MS_SansSerif = {
							{0,0},
							{1,0},
							{2,0},
							{3,1},
							{4,1},
							{5,1},
							{5,1},
							{6,1},
							{8,2},
							{9,3},
							{10,3},
							{11,3},
							{12,3},
							{13,3},
							{13,3},
							{14,3},
							{15,3},
							{15,4},
							{17,4},
							{18,4},
							{19,4},
							{19,5},
							{20,5},
							{21,5},
							{21,6},
							{23,5},
							{25,6},
							{26,6},
							{26,6},
							{27,6},
							{28,7},
							{28,7},
							{29,7},
							{31,7},
							{32,7},
							{32,8},
							{33,8},
							{34,8},
							{34,9},
							{35,9},
							{36,9},
							{38,9},
							{38,9},
							{39,10},
							{40,10},
							{40,10},
							{42,10},
							{43,10},
							{45,10},
							{45,11},
							{46,11},
							{47,11},
							{48,12},
							{48,12},
							{49,12},
							{51,12},
							{52,13},
							{52,13},
							{53,13},
							{53,13},
							{54,13},
							{55,13},
							{56,13},
							{57,14},
							{58,14},
							{59,14},
							{60,14},
							{60,15},
							{61,15},
							{62,15},
							{63,16},
							{64,16},
							{65,16},
							{66,16},
							{66,16},
							{67,16},
							{68,16},
							{70,17},
							{70,17},
							{71,17},
							{72,17}
						};
	private int [][] AD_MS_Monospaced = {
							{0,0},
							{1,0},
							{2,0},
							{3,1},
							{3,1},
							{4,2},
							{5,2},
							{6,2},
							{6,2},
							{9,3},
							{9,3},
							{11,3},
							{12,3},
							{12,4},
							{13,4},
							{13,4},
							{14,4},
							{15,5},
							{15,5},
							{16,5},
							{17,5},
							{17,6},
							{18,6},
							{19,6},
							{20,7},
							{22,7},
							{22,7},
							{23,7},
							{23,8},
							{24,8},
							{25,8},
							{25,8},
							{27,9},
							{27,9},
							{28,9},
							{29,10},
							{29,10},
							{29,10},
							{30,10},
							{31,11},
							{31,11},
							{33,11},
							{33,12},
							{34,12},
							{35,12},
							{35,12},
							{36,13},
							{37,13},
							{37,13},
							{38,13},
							{39,14},
							{42,14},
							{43,14},
							{43,15},
							{44,15},
							{45,15},
							{45,15},
							{46,16},
							{46,16},
							{47,16},
							{49,16},
							{49,17},
							{50,17},
							{51,17},
							{51,18},
							{52,18},
							{53,18},
							{53,18},
							{54,19},
							{55,19},
							{56,19},
							{57,19},
							{57,20},
							{58,20},
							{59,20},
							{59,21},
							{60,21},
							{60,21},
							{62,21},
							{63,22},
							{63,22}
						};
						
	public static final int MONO=0, SERIF=1, SANSSERIF=2;

	private String name;
	private boolean bold, italic, underline, overline;
	private int size;
	private mjaFont font;
	private int type;
	
	public TFont(Font f) {
		this(new mjaFont(f));
	}

	public TFont(mjaFont font) {
		this(font.getAwtFont().getName(),font.getAwtFont().getStyle(),font.getAwtFont().getSize());
	}
	
	public TFont(String name,int style,int size) {
		this(name,(style&0x1)==1,(style&0x2)==2,(style&0x4)==4,(style&0x8)==8,size);
	}

	public TFont(String name,boolean bold,boolean italic,boolean underline,boolean overline,int size) {
		this.name=name;
		this.bold=bold;
		this.italic=italic;
		this.underline=underline;
		this.overline=overline;
		this.size=size;
		int style=((bold)?1:0) + ((italic)?2:0); 
		font=new mjaFont(name,style,size);
		type=getType(name);
	}
	
	public TFont scale(double s) {
		return new TFont(name,bold,italic,underline,overline,(int) Math.round(s*size));
	}
	
	public int getAscent() {
		return getAD(0);
	}
	
	public int getDescent() {
		return getAD(1);
	}
	
	public static int getType(String name) {
		if ("SansSerif".equals(name) || "Helvetica".equals(name) || "Arial".equals(name)) {
			return 2;
		} else if ("Serif".equals(name) || "TimesRoman".equals(name) || "Times New Roman".equals(name)) {
			return 1;
		} else if ("Monospaced".equals(name) || "Courier".equals(name) || "Courier New".equals(name)) {
			return 0;
		} else {
			return 0;
		}
	}
	
	private int getAD(int n) {
		switch (type) {
			case MONO : return AD_MS_Monospaced[size][n];
			case SERIF : return AD_MS_Serif[size][n];
			case SANSSERIF: return AD_MS_SansSerif[size][n];
			default : return 0;			
		}
	}
	
	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		this.name=name;
	}
	
	public boolean isMonospaced() {
		return type==MONO;
	}
	
	public boolean isSerif() {
		return type==SERIF;
	}
	
	public boolean isSansSerif() {
		return type==SANSSERIF;
	}
	
	public int getStyle() {
		int style=0;
		if (bold) {
			style+=1;
		}
		if (italic) {
			style+=2;
		}
		if (underline) {
			style+=4;
		}
		if (overline) {
			style+=8;
		}
		return style;
	}
	
	public int getFontStyle() {
		return getStyle()&0x3;
	}
	
	public int getSize() {
		return size;
	}
	
	public void setSize(int size) {
		this.size=size;
	}
	
	public mjaFont getMjaFont() {
		return font;
	}
	
	public boolean isBold() {
		return bold;
	}
	
	public void setBold(boolean b) {
		bold=b;
	}

	public boolean isItalic() {
		return italic;
	}

	public void setItalic(boolean b) {
		italic=b;
	}

	public boolean isUnderline() {
		return underline;
	}

	public void setUnderline(boolean b) {
		underline=b;
	}
	
	public boolean isOverline() {
		return overline;
	}

	public void setOverline(boolean b) {
		overline=b;
	}
	
	public TFont cloneTFont() {
		return new TFont(name,bold,italic,underline,overline,size);
	}
	
	private static final String s_name="name:",s_style=" style:",s_size=" size:";
	
	public String toString() {
		return s_name+name+s_style+String.valueOf(getStyle())+s_size+String.valueOf(size);
	}
	
	public static String getNameFromString(String s) {
		int p1=s.indexOf(s_name);
		int p2=s.indexOf(s_style);
		if (p1>=0&&p2>=0) {
			return s.substring(p1+s_name.length(),p2);
		}
		return "";
	}

    public static void setAntialias(Graphics2D g,TFont tf) {
    	setAntialias(g,useAntialias(tf));
    }

    public static void setAntialias(Graphics2D g,boolean al) {
	    if (al) {
			Stroke bs=new BasicStroke(1,BasicStroke.CAP_ROUND,BasicStroke.JOIN_ROUND);
			g.setStroke(bs);
			g.setRenderingHint(RenderingHints.KEY_ALPHA_INTERPOLATION, RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY);
		    g.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
		    g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		    g.setRenderingHint(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_QUALITY);
		    g.setRenderingHint(RenderingHints.KEY_COLOR_RENDERING, RenderingHints.VALUE_COLOR_RENDER_QUALITY);
		    g.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BICUBIC);
		    g.setRenderingHint(RenderingHints.KEY_STROKE_CONTROL, RenderingHints.VALUE_STROKE_PURE);
	    } else {
			Stroke bs=new BasicStroke(1,BasicStroke.CAP_ROUND,BasicStroke.JOIN_ROUND);
			g.setStroke(bs);
			g.setRenderingHint(RenderingHints.KEY_ALPHA_INTERPOLATION, RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY);
		    g.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_OFF);
		    g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_OFF);
		    g.setRenderingHint(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_QUALITY);
		    g.setRenderingHint(RenderingHints.KEY_COLOR_RENDERING, RenderingHints.VALUE_COLOR_RENDER_QUALITY);
		    g.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BICUBIC);
		    g.setRenderingHint(RenderingHints.KEY_STROKE_CONTROL, RenderingHints.VALUE_STROKE_PURE);
	    }
    }
    
    public static boolean useAntialias( TFont tf) {
    	if (tf.isItalic() || tf.isBold()) return true;
    	if (tf.isSerif()) return true;
    	if (tf.isSansSerif() && tf.getAscent()+tf.getDescent()>20) return true;
//    	if (tf.isMonospaced) return false;
    	return false;
    }
    
}