/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mos.tablas;
/* ------------ tabla ---------- */

import java.applet.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;

import com.jla.nippe.*;
import com.mja.lang.*;
import com.mja.cmp.*;
import com.mja.gui.*;
import com.mja.parser.Parser;

import com.mja.util.BasicStr;
import org.unam.matem.Attribute;
import com.mja.cmpedit.mjaLineEditor;
import org.unam.matem.Attribute;
import org.unam.matem.Communicator;

public class tabla extends NotSoAbstractNippe implements ActionListener {

/* ------------- Communicator implementation --------------- */

	public Attribute[] getState() {
		return new Attribute[0];
	}
	
	public void changed(Communicator cc) {
	}
	
/* --------------------------------------------------------- */
	
	static public final String Version="0.6";

	public static final Font SansSerif=new Font("SansSerif",Font.PLAIN,12);
	public static final Font SansSerif_16=new Font("SansSerif",Font.PLAIN,16);

	private int ancho,alto;

	private Celda[][] celdas;
	private Celda[] filas,columnas;
	private String titulo,solution,evaluation,next,previous;
	private int nfilas,ncolumnas,nborde,nborde_tit,decimales,calcalfanum;
	private boolean may_imp,fijo,editar_siempre,trimCells;
	private int alto_tit,alto_eval,
		align,align_tit,align_eval,
		adjust;
	private mjaButton b_eval,b_sol,b_reinit;
//	private mjaButton b_next,b_prev;
	private Label lb_nota;
	private translator Tr;
	private Font font, font_tit,font_eval;
	private Color correctColor,wrongColor,solutionColor;
	private Color 
		fgcolor=Color.black,
		bgcolor=new Color(0xe0e0e0),
		bcolor=fgcolor,
		fgcolor_tit=fgcolor,
		bgcolor_tit=fgcolor,
		bcolor_tit=fgcolor,
		fgcolor_eval=fgcolor,
		bgcolor_eval=bgcolor,
		pcolor_eval=fgcolor;
	private boolean nota,reiniciar;
	private Attribute attr_tabla,attr_tit,attr_eval;
	private Attribute[][] attr_celdas;
	private Attribute[] attr_filas,attr_columnas;

	private int activeCard,numCards;

	private Panel CP;

	private static boolean firsttime=true;
	
	private Hashtable images;

	public void init () {
		if (firsttime) {
			firsttime=false;
			System.out.println(class_Id()+" ver. "+Version);
		}
		super.init();
		construct();
	}
	
	private boolean constructed=false;
	private Panel SP,SP_b;	
	private void construct() {
		if (!constructed) {
			constructed=true;
			setLayout(null);
			ancho=getWidth(); alto=getHeight();
			if (Tr==null) {
				Tr=new translator(this);
			}
			String es=getParameter("editar_siempre");
			editar_siempre=(es==null)||(!"no".equals(es.toLowerCase()));
			attr_tabla=new Attribute("TABLA",getParameter("TABLA"));
			nfilas=BasicStr.parseInteger(Attribute.getValue(attr_tabla.value,"filas"),0,0);
			ncolumnas=BasicStr.parseInteger(Attribute.getValue(attr_tabla.value,"columnas"),0,0);
			font=BasicStr.parseGeneralFont(Attribute.getValue(attr_tabla.value,"fuente"),SansSerif_16);
			setFont(font);
			align=Tr.parseAlign(Attribute.getValue(attr_tabla.value,"alinear"),data.a_center);
			adjust=Tr.parseAdjust(Attribute.getValue(attr_tabla.value,"ajustar"),data.wrap);
			bgcolor=Color.white;
			bgcolor=Tr.ParseColor(Attribute.getValue(attr_tabla.value,"fondo"),bgcolor,bgcolor);
			fgcolor=Color.black;
			fgcolor=Tr.ParseColor(Attribute.getValue(attr_tabla.value,"color"),fgcolor,fgcolor);
			nborde=BasicStr.parseInteger(Attribute.getValue(attr_tabla.value,"borde_ancho"),2,2);
			bcolor=Color.black;
			bcolor=Tr.ParseColor(Attribute.getValue(attr_tabla.value,"borde_color"),bcolor,bcolor);
			correctColor=new Color(0x009944);
			correctColor=Tr.ParseColor(Attribute.getValue(attr_tabla.value,"color_bien"),correctColor,correctColor);
			wrongColor=new Color(0xee0000);
			wrongColor=Tr.ParseColor(Attribute.getValue(attr_tabla.value,"color_mal"),wrongColor,wrongColor);
			solutionColor=new Color(0x0000dd);
			solutionColor=Tr.ParseColor(Attribute.getValue(attr_tabla.value,"color_resolver"),solutionColor,solutionColor);
			may_imp=Tr.isTrue(Attribute.getValue(attr_tabla.value,"may_imp"),false);
			decimales=BasicStr.parseInteger(Attribute.getValue(attr_tabla.value,"decimales"),-1,-1);
			fijo=Tr.isNotFalse(Attribute.getValue(attr_tabla.value,"fijo"));
			trimCells=Tr.isTrue(Attribute.getValue(attr_tabla.value,"trim"));
			calcalfanum=parseCalculadora(Attribute.getValue(attr_tabla.value,"calculadora"),1);
	//System.out.println("TABLA "+"decimales="+decimales+" fijo="+fijo);
			
			attr_tit=new Attribute("TITULO",getParameter("TITULO"));
			titulo=Attribute.getValue(attr_tit.value,"texto");
			font_tit=BasicStr.parseFont(Attribute.getValue(attr_tit.value,"fuente"),SansSerif_16);
			align_tit=Tr.parseAlign(Attribute.getValue(attr_tit.value,"alinear"),data.a_center);
			bgcolor_tit=Tr.ParseColor(Attribute.getValue(attr_tit.value,"fondo"),bgcolor,bgcolor);
			fgcolor_tit=Tr.ParseColor(Attribute.getValue(attr_tit.value,"color"),fgcolor,fgcolor);
			nborde_tit=BasicStr.parseInteger(Attribute.getValue(attr_tit.value,"borde_ancho"),nborde,nborde);
			bcolor_tit=Tr.ParseColor(Attribute.getValue(attr_tit.value,"borde_color"),bcolor,bcolor);
			String auxs=Attribute.getValue(attr_tit.value,"alto");
			alto_tit=-1;
			if (BasicStr.hasContent(auxs)) {
				boolean isPercentage=false;
				if (auxs.endsWith("%")) {
					auxs=auxs.substring(0,auxs.length()-1);
					isPercentage=true;
				}
				try {
					double r=Double.valueOf(auxs).doubleValue();
					if (isPercentage) {
						alto_tit=(int)(Math.round(r*(double)alto)/100.0);
					} else {
						alto_tit=(int)Math.round(r);
					}
				} catch (NumberFormatException nfe) {
				}
			}
			if (alto_tit<25) {
				alto_tit=25;
			}
			attr_eval=new Attribute("EVALUACION",getParameter("EVALUACION"));
			if (!BasicStr.hasContent(getParameter("EVALUACION"))) {
				evaluation="Verificar";
			} else {
				evaluation=Attribute.getValue(attr_eval.value,"verificar",null);
				if (evaluation==null) {
					evaluation="Verificar";
				}
			}
			if (!BasicStr.hasContent(getParameter("EVALUACION"))) {
				solution="Resolver";
			} else {
				solution=Attribute.getValue(attr_eval.value,"resolver",null);
				if (solution==null) {
					solution="Resolver";
				}
			}
			if (!BasicStr.hasContent(getParameter("EVALUACION"))) {
				next="Siguiente";
			} else {
				next=Attribute.getValue(attr_eval.value,"siguiente",null);
				if (next==null) {
					next="Siguiente";
				}
			}
			if (!BasicStr.hasContent(getParameter("EVALUACION"))) {
				previous="Anterior";
			} else {
				previous=Attribute.getValue(attr_eval.value,"anterior",null);
				if (previous==null) {
					previous="Anterior";
				}
			}
			nota=Tr.isTrue(Attribute.getValue(attr_eval.value,"nota"));
			reiniciar=Tr.isTrue(Attribute.getValue(attr_eval.value,"reiniciar"));
			font_eval=BasicStr.parseGeneralFont(Attribute.getValue(attr_eval.value,"fuente"),SansSerif_16);
			align_eval=Tr.parseAlign(Attribute.getValue(attr_eval.value,"alinear"),data.a_center);
			bgcolor_eval=Tr.ParseColor(Attribute.getValue(attr_eval.value,"fondo"),bgcolor,bgcolor);
			fgcolor_eval=Tr.ParseColor(Attribute.getValue(attr_eval.value,"color"),fgcolor,fgcolor);
			pcolor_eval=Tr.ParseColor(Attribute.getValue(attr_eval.value,"exterior"),fgcolor_eval,fgcolor_eval);
			auxs=Attribute.getValue(attr_eval.value,"alto");
			alto_eval=-1;
			if (BasicStr.hasContent(auxs)) {
				boolean isPercentage=false;
				if (auxs.endsWith("%")) {
					auxs=auxs.substring(0,auxs.length()-1);
					isPercentage=true;
				}
				try {
					double r=Double.valueOf(auxs).doubleValue();
					if (isPercentage) {
						alto_eval=(int)(Math.round(r*(double)alto)/100.0);
					} else {
						alto_eval=(int)Math.round(r);
					}
				} catch (NumberFormatException nfe) {
				}
			}
			if (alto_eval<30) {
				alto_eval=30;
			}
			setBackground(bcolor);
			int yP=0;
			if (BasicStr.hasContent(titulo)) {
				Panel NP=new Panel();
				NP.setBackground(bcolor_tit);
				NP.setLayout(null);
				Label lb=new Label(titulo);
				lb.setFont(font_tit);
				lb.setForeground(fgcolor_tit);
				lb.setBackground(bgcolor_tit);
				if (align_tit==data.a_left) {
					lb.setAlignment(Label.LEFT);
				} else if (align_tit==data.a_right) {
					lb.setAlignment(Label.RIGHT);
				} else {
					lb.setAlignment(Label.CENTER);
				}
				lb.setBounds(nborde_tit,nborde_tit,ancho-2*nborde_tit,alto_tit-2*nborde_tit);
				NP.add(lb);
				NP.setBounds(0,yP,ancho,alto_tit);
				yP+=alto_tit;
				add(NP);
				alto-=alto_tit;
			}
			CP=new Panel();
			CP.setBackground(bcolor);
			CP.setLayout(null);
			numCards=1;
			activeCard=0;
			getCeldas();
			boolean dontPutEval=(attr_eval!=null)&&(attr_eval.value!=null)&&"no".equals(attr_eval.value.toLowerCase());
			if (hayEditables()) {
				SP=new Panel();
				SP.setBackground(pcolor_eval);
				SP.setFont(font_eval);
				SP.setLayout(null);
	
				int alto_lb=0;
				if (nota) {
					lb_nota=new Label();
					lb_nota.setAlignment(Label.CENTER);
					lb_nota.setFont(SansSerif);
					lb_nota.setForeground(fgcolor_eval);
					alto_lb=getGraphics().getFontMetrics(SansSerif).getHeight()+9;
					lb_nota.setBounds(0,0,ancho,alto_lb);
					SP.add(lb_nota);
				}

				SP_b=new Panel();
				String s_ima=Attribute.getValue(attr_eval.value,"verif_image");
				b_eval=new mjaButton(images,this,evaluation,s_ima,!BasicStr.hasContent(s_ima));
				b_eval.forceTranspIfImaExists();
				b_eval.setForeground(fgcolor_eval);
				b_eval.setBackground(bgcolor_eval);
				s_ima=Attribute.getValue(attr_eval.value,"result_image");
				b_sol=new mjaButton(images,this,solution,s_ima,!BasicStr.hasContent(s_ima));
				b_sol.forceTranspIfImaExists();
				b_sol.setForeground(fgcolor_eval);
				b_sol.setBackground(bgcolor_eval);
				s_ima=Attribute.getValue(attr_eval.value,"reini_image");
				b_reinit=new mjaButton(images,this,"Reiniciar",s_ima,!BasicStr.hasContent(s_ima));
				b_reinit.forceTranspIfImaExists();
				b_reinit.setForeground(fgcolor_eval);
				b_reinit.setBackground(bgcolor_eval);
				int alto_b=font_eval.getSize()+9;
//				int	alto_b=getGraphics().getFontMetrics(font_eval).getHeight()+9;
				if (align_eval==data.a_left) {
					SP_b.setLayout(new FlowLayout(FlowLayout.LEFT,8,(alto_eval-alto_lb-alto_b)/2));
				} else if (align_eval==data.a_right) {
					SP_b.setLayout(new FlowLayout(FlowLayout.RIGHT,8,(alto_eval-alto_lb-alto_b)/2));
				} else {
					SP_b.setLayout(new FlowLayout(FlowLayout.CENTER,8,(alto_eval-alto_lb-alto_b)/2));
				}
				if (BasicStr.hasContent(evaluation)) {
//					b_sol.setEnabled(false);
					SP_b.add(b_eval);
				}
				if (BasicStr.hasContent(solution)) {
					SP_b.add(b_sol);
				}
	//			b_next=new mjaButton(this,next,Attribute.getValue(attr_eval.value,"next_image"));
	//			b_next.setForeground(fgcolor_eval);
	//			b_next.setBackground(bgcolor_eval);
	//			b_prev=new mjaButton(this,previous,Attribute.getValue(attr_eval.value,"prev_image"));
	//			b_prev.setForeground(fgcolor_eval);
	//			b_prev.setBackground(bgcolor_eval);
	//			if (hayMultiples()) {
	//				if (BasicStr.hasContent(previous)) {
	//					SP_b.add(b_prev);
	//				}
	//				if (BasicStr.hasContent(next)) {
	//					SP_b.add(b_next);
	//				}
	//			}
				if (reiniciar) {
					SP_b.add(b_reinit);
				}
				SP_b.setBounds(0,alto_lb,ancho,alto_eval-alto_lb);
				SP.add(SP_b);
	
				SP.setBounds(0,getHeight()-alto_eval,ancho,alto_eval);
				if (!dontPutEval) {
					add(SP);
					alto-=alto_eval;
				}
				b_eval.addActionListener(this);
				b_sol.addActionListener(this);
				b_reinit.addActionListener(this);
			}
			CP.setBounds(0,yP,ancho,alto);
			double calto=alto-nborde*(nfilas+1);
			int ntotal=0;
			double suma=0;
			for (int i=0;i<nfilas;i++) {
				if (BasicStr.hasContent(attr_filas[i].value)) {
					filas[i].palto=Attribute.getValue(attr_filas[i].value,"alto").trim();
					if (BasicStr.hasContent(filas[i].palto)) {
						auxs=filas[i].palto;
						boolean isPercentage=false;
						if (auxs.endsWith("%")) {
							auxs=auxs.substring(0,auxs.length()-1);
							isPercentage=true;
						}
						try {
							double r=Double.valueOf(auxs).doubleValue();
							if (isPercentage) {
								filas[i].alto=Math.round(r*calto/100.0);
							} else {
								filas[i].alto=Math.round(r);
							}
							suma+=filas[i].alto;
						} catch (NumberFormatException nfe) {
							filas[i].palto="";
						}
						ntotal++;
					}
				} else {
					filas[i].palto="";
				}
			}
			double tsuma=0;
			for (int i=0;i<nfilas;i++) {
				if (!BasicStr.hasContent(filas[i].palto)) {
					filas[i].alto=Math.round((calto-suma)/(double)(nfilas-ntotal));
				}
				tsuma+=filas[i].alto;
			}
			for (int i=nfilas-1;i>=0;i--) {
				if (!BasicStr.hasContent(filas[i].palto)) {
					if (tsuma>calto) {
						filas[i].alto--;
						tsuma--;
					} else if (tsuma<calto) {
						filas[i].alto++;
						tsuma++;
					}
				}
			}
			double cancho=ancho-nborde*(ncolumnas+1);
			ntotal=0;
			suma=0;
			for (int j=0;j<ncolumnas;j++) {
				if (BasicStr.hasContent(attr_columnas[j].value)) {
					columnas[j].pancho=Attribute.getValue(attr_columnas[j].value,"ancho").trim();
					if (BasicStr.hasContent(columnas[j].pancho)) {
						auxs=columnas[j].pancho;
						boolean isPercentage=false;
						if (auxs.endsWith("%")) {
							auxs=auxs.substring(0,auxs.length()-1);
							isPercentage=true;
						}
						try {
							double r=Double.valueOf(auxs).doubleValue();
							if (isPercentage) {
								columnas[j].ancho=Math.round(r*cancho/100.0);
							} else {
								columnas[j].ancho=Math.round(r);
							}
							suma+=columnas[j].ancho;
						} catch (NumberFormatException nfe) {
							columnas[j].pancho="";
						}
						ntotal++;
					}
				} else {
					columnas[j].pancho="";
				}
			}
			tsuma=0;
			for (int j=0;j<ncolumnas;j++) {
				if (!BasicStr.hasContent(columnas[j].pancho)) {
					columnas[j].ancho=Math.round((cancho-suma)/(double)(ncolumnas-ntotal));
				}
				tsuma+=columnas[j].ancho;
			}
			for (int j=ncolumnas-1;j>=0;j--) {
				if (!BasicStr.hasContent(columnas[j].pancho)) {
					if (tsuma>cancho) {
						columnas[j].ancho--;
						tsuma--;
					} else if (tsuma<cancho) {
						columnas[j].ancho++;
						tsuma++;
					}
				}
			}
			for (int i=0;i<nfilas;i++) {
				for (int j=0;j<ncolumnas;j++) {
					celdas[i][j].ancho=columnas[j].ancho;
					celdas[i][j].alto=filas[i].alto;
					celdas[i][j].rancho=(int)celdas[i][j].ancho;
					celdas[i][j].ralto=(int)celdas[i][j].alto;
				}
			}
			for (int i=0;i<nfilas;i++) {
				for (int j=0;j<ncolumnas;j++) {
					for (int m=1;m<celdas[i][j].celdas_alto;m++) {
						celdas[i][j].ralto+=celdas[i+m][j].alto+nborde;
						celdas[i+m][j].ralto=0;
					}
					for (int n=1;n<celdas[i][j].celdas_ancho;n++) {
						celdas[i][j].rancho+=celdas[i][j+n].ancho+nborde;
						celdas[i][j+n].rancho=0;
					}
				}
			}
			int x=nborde,y=nborde;
			for (int i=0;i<nfilas;i++) {
				x=nborde;
				int maxalto=0;
				for (int j=0;j<ncolumnas;j++) {
					if (celdas[i][j].rancho>0&&celdas[i][j].ralto>0) {
						celdas[i][j].tb=new TextBox(this,Tr,p,
							(int)celdas[i][j].rancho,(int)celdas[i][j].ralto,
							celdas[i][j].font.getSize(),
							celdas[i][j].editable,
							celdas[i][j].decimales,
							celdas[i][j].fijo,
							celdas[i][j].calcalfanum,
							celdas[i][j].isFormula,
							celdas[i][j].str_DrawIf);
						celdas[i][j].tb.setFont(celdas[i][j].font);
						celdas[i][j].tb.setAlignment(celdas[i][j].align);
						celdas[i][j].tb.setAdjust(celdas[i][j].adjust);
						celdas[i][j].tb.setText(celdas[i][j].str_user);
						celdas[i][j].tb.setForeground(celdas[i][j].fgcolor);
						celdas[i][j].tb.setBackground(celdas[i][j].bgcolor);
	
						celdas[i][j].tb.addActionListener(this);
	
						Component comp=celdas[i][j].getVisualComponent();
						comp.setBounds(x,y,(int)celdas[i][j].rancho,(int)celdas[i][j].ralto);
						CP.add(comp);
					}
					x+=(int)celdas[i][j].ancho+nborde;
					if (celdas[i][j].alto>maxalto) {
						maxalto=(int)celdas[i][j].alto;
					}
				}
				y+=maxalto+nborde;
			}
			add(CP);
		}
	}

	/* ---------------------- Communications ---------------------- */
	
    private void getInfoFromConnectedNippe()
    {
        String connected_nippe = getParameter("conectar_con_Nippe");
        if(BasicStr.hasContent(connected_nippe))
        {
            comm c = new comm(this);
            for(int n = 0; n++ < 30;)
            {
                if(c.openCommTo(connected_nippe))
                {
                    for(int j = 0; j < celdas.length; j++)
                    {
                        for(int i = 0; i < celdas[j].length; i++)
                        	if(celdas[j][i] != null && BasicStr.hasContent(celdas[j][i].varName)){
                                String s_value = c.getInfo(celdas[j][i].varName+"_"+j+"_"+i, "");
                                celdas[j][i].setSolution(p, s_value, 0);
                                if(celdas[j][i].editable)
                                {
                                    celdas[j][i].str_user = celdas[j][i].str_initial;
                                } else{
                                    celdas[j][i].str_user = s_value;
                                    try
                                    {
                                        double d = BasicStr.parseDouble(s_value);
                                        celdas[j][i].str_user = BasicStr.DoubleToString(d, celdas[j][i].decimales, celdas[j][i].fijo, ".");
                                    }
                                    catch(NumberFormatException numberformatexception) { }
                                    celdas[j][i].tb.setText(celdas[j][i].str_user);
                                }
                            }
                    }

                    break;
                }
                try
                {
                    Thread.sleep(100L);
                }
                catch(InterruptedException interruptedexception) { }
            }

        }
    }

/*
	private void getInfoFromConnectedNippe() {
		String connected_nippe=getParameter("conectar_con_Nippe");
		if (BasicStr.hasContent(connected_nippe)) {
			comm c=new comm(this);
			int n=0;
			while (n++<30) {
				if (c.openCommTo(connected_nippe)) {
					for (int j=0;j<celdas.length;j++) {
						for (int i=0;i<celdas[j].length;i++) {
							if (celdas[j][i]!=null && BasicStr.hasContent(celdas[j][i].varName)) {
								String s_value=c.getInfo(celdas[j][i].varName,j+"_"+i);
								celdas[j][i].setSolution(p,s_value,0);
								if (celdas[j][i].editable) {
									celdas[j][i].str_user=celdas[j][i].str_initial;
								} else {
									celdas[j][i].str_user=s_value;
									try {
										double d=BasicStr.parseDouble(s_value);
										celdas[j][i].str_user=BasicStr.DoubleToString(d,celdas[j][i].decimales,celdas[j][i].fijo,".");
									} catch (NumberFormatException nfe) {
									}
									celdas[j][i].tb.setText(celdas[j][i].str_user);
								}
//System.out.println(celdas[j][i].tb.getText());
							}
						}
					}
					break;
				}
				try {
					Thread.sleep(100);
				} catch (InterruptedException e) {
				}
			}
		}
	}
*/

	private void reinit() {
		getInfoFromConnectedNippe();
		for (int i=0;i<nfilas;i++) {
			for (int j=0;j<ncolumnas;j++) {
				if (celdas[i][j].editable) {
					celdas[i][j].evaluated=false;
					celdas[i][j].str_user=celdas[i][j].str_initial;
					celdas[i][j].tb.setText(celdas[i][j].str_user);
					celdas[i][j].tb.setForeground(celdas[i][j].fgcolor);
				}
			}
		}
		if (BasicStr.hasContent(evaluation)&&BasicStr.hasContent(solution)) {
			if (hayEditables()) {
//				b_sol.setEnabled(false);
				if (nota) {
					lb_nota.setText("");
				}
			}
		}
		enableCeldas(true);
	}

	/* ---------------------- Start-Stop ---------------------- */

	public void start () {
//		paintAll(getGraphics());
		super.start();
		getInfoFromConnectedNippe();
		for (int i=0;i<nfilas;i++) {
			for (int j=0;j<ncolumnas;j++) {
				if (celdas[i][j]!=null && celdas[i][j].tb!=null) {
					celdas[i][j].tb.start();
				}
			}
		}
		validate();
		paintAll(getGraphics());
	}

	public void stop () {
		for (int i=0;i<nfilas;i++) {
			for (int j=0;j<ncolumnas;j++) {
				if (celdas[i][j]!=null && celdas[i][j].tb!=null) {
					celdas[i][j].tb.stop();
				}
			}
		}
	}


	private boolean hayEditables() {
		for (int i=0;i<nfilas;i++) {
			for (int j=0;j<ncolumnas;j++) {
				if (celdas[i][j].editable) {
					return true;
				}
			}
		}
		return false;
	}

/*
	private boolean hayMultiples() {
		return false;
//		for (int i=0;i<nfilas;i++) {
//			for (int j=0;j<ncolumnas;j++) {
//				if (celdas[i][j].editable) {
//					return true;
//				}
//			}
//		}
//		return false;
	}
*/

	private void getCeldas() {
		attr_filas = new Attribute[nfilas];
		for (int i=0;i<nfilas;i++) {
			String nom=nombreFila(i);
			attr_filas[i]=new Attribute(nom,getParameter(nom));
		}
		filas = new Celda[nfilas];
		for (int i=0;i<nfilas;i++) {
			filas[i]=new Celda();
			if (BasicStr.hasContent(attr_filas[i].value)) {
				filas[i].font=BasicStr.parseGeneralFont(Attribute.getValue(attr_filas[i].value,"fuente"),font);
				filas[i].align=Tr.parseAlign(Attribute.getValue(attr_filas[i].value,"alinear"),align);
				filas[i].adjust=Tr.parseAdjust(Attribute.getValue(attr_filas[i].value,"ajustar"),adjust);
				filas[i].fgcolor=Tr.ParseColor(Attribute.getValue(attr_filas[i].value,"color"),fgcolor,fgcolor);
				filas[i].bgcolor=Tr.ParseColor(Attribute.getValue(attr_filas[i].value,"fondo"),bgcolor,bgcolor);
				filas[i].editable=Tr.isTrue(Attribute.getValue(attr_filas[i].value,"editable"));
				filas[i].may_imp=Tr.isTrue(Attribute.getValue(attr_filas[i].value,"may_imp"),may_imp);
				filas[i].decimales=BasicStr.parseInteger(Attribute.getValue(attr_filas[i].value,"decimales"),decimales,decimales);
				filas[i].fijo=fijo;
				if (BasicStr.hasContent(Attribute.getValue(attr_filas[i].value,"fijo"))) {
					filas[i].fijo=Tr.isNotFalse(Attribute.getValue(attr_filas[i].value,"fijo"));
				}
				filas[i].calcalfanum=parseCalculadora(Attribute.getValue(attr_filas[i].value,"calculadora").toLowerCase(),calcalfanum);
//System.out.println("FILA["+i+"] decimales="+filas[i].decimales+" fijo="+filas[i].fijo);
				filas[i].isFormula=Tr.isTrue(Attribute.getValue(attr_filas[i].value,"formula"));
				if (BasicStr.hasContent(Attribute.getValue(attr_filas[i].value,"dibujar-si"))) {
					filas[i].str_DrawIf=Attribute.getValue(attr_filas[i].value,"dibujar-si");
				}
				filas[i].varName=Attribute.getValue(attr_filas[i].value,"var","");
			}
		}
		attr_columnas = new Attribute[ncolumnas];
		for (int j=0;j<ncolumnas;j++) {
			String nom=nombreColumna(j);
			attr_columnas[j]=new Attribute(nom,getParameter(nom));
		}
		columnas = new Celda[ncolumnas];
		for (int j=0;j<ncolumnas;j++) {
			columnas[j]=new Celda();
			if (BasicStr.hasContent(attr_columnas[j].value)) {
				columnas[j].font=BasicStr.parseGeneralFont(Attribute.getValue(attr_columnas[j].value,"fuente"),font);
				columnas[j].align=Tr.parseAlign(Attribute.getValue(attr_columnas[j].value,"alinear"),align);
				columnas[j].adjust=Tr.parseAdjust(Attribute.getValue(attr_columnas[j].value,"ajustar"),adjust);
				columnas[j].fgcolor=Tr.ParseColor(Attribute.getValue(attr_columnas[j].value,"color"),fgcolor,fgcolor);
				columnas[j].bgcolor=Tr.ParseColor(Attribute.getValue(attr_columnas[j].value,"fondo"),bgcolor,bgcolor);
				columnas[j].editable=Tr.isTrue(Attribute.getValue(attr_columnas[j].value,"editable"));
				columnas[j].may_imp=Tr.isTrue(Attribute.getValue(attr_columnas[j].value,"may_imp"),may_imp);
				columnas[j].decimales=BasicStr.parseInteger(Attribute.getValue(attr_columnas[j].value,"decimales"),decimales,decimales);
				columnas[j].fijo=fijo;
				if (BasicStr.hasContent(Attribute.getValue(attr_columnas[j].value,"fijo"))) {
					columnas[j].fijo=Tr.isNotFalse(Attribute.getValue(attr_columnas[j].value,"fijo"));
				}
				columnas[j].calcalfanum=parseCalculadora(Attribute.getValue(attr_columnas[j].value,"calculadora").toLowerCase(),calcalfanum);
//System.out.println("COLUMNA["+j+"] decimales="+columnas[j].decimales+" fijo="+columnas[j].fijo);
				columnas[j].isFormula=Tr.isTrue(Attribute.getValue(attr_columnas[j].value,"formula"));
				if (BasicStr.hasContent(Attribute.getValue(attr_columnas[j].value,"dibujar-si"))) {
					columnas[j].str_DrawIf=Attribute.getValue(attr_columnas[j].value,"dibujar-si");
				}
				columnas[j].varName=Attribute.getValue(attr_columnas[j].value,"var","");
			}
		}
		attr_celdas = new Attribute[nfilas][ncolumnas];
		for (int i=0;i<nfilas;i++) {
			for (int j=0;j<ncolumnas;j++) {
				String nom=nombreCelda(i,j);
				attr_celdas[i][j]=new Attribute(nom,getParameter(nom));
			}
		}
		celdas = new Celda[nfilas][ncolumnas];
		for (int i=0;i<nfilas;i++) {
			for (int j=0;j<ncolumnas;j++) {
				celdas[i][j]=new Celda();
				Font dfont=font;
				boolean desformula=false;
				String ddrawif="1";
				String devar_name="";
				Color dfgcolor=fgcolor, dbgcolor=bgcolor;
				boolean deditable=false,dmay_imp=may_imp,dfijo=fijo;
				int dcalcalfanum=1;
				int defalign=align,defadjust=adjust,ddecimales=decimales;
				if (BasicStr.hasContent(attr_columnas[j].value)) {
					dfont=columnas[j].font;
					defalign=columnas[j].align;
					defadjust=columnas[j].adjust;
					dfgcolor=columnas[j].fgcolor;
					dbgcolor=columnas[j].bgcolor;
					deditable=columnas[j].editable;
					dmay_imp=columnas[j].may_imp;
					ddecimales=columnas[j].decimales;
					dfijo=columnas[j].fijo;
					dcalcalfanum=columnas[j].calcalfanum;
					desformula=columnas[j].isFormula;
					ddrawif=columnas[j].str_DrawIf;
					devar_name=columnas[j].varName;
				}
				if (BasicStr.hasContent(attr_filas[i].value)) {
					dfont=filas[i].font;
					defalign=filas[i].align;
					defadjust=filas[i].adjust;
					dfgcolor=filas[i].fgcolor;
					dbgcolor=filas[i].bgcolor;
					deditable=filas[i].editable;
					dmay_imp=filas[i].may_imp;
					ddecimales=filas[i].decimales;
					dfijo=filas[i].fijo;
					dcalcalfanum=filas[i].calcalfanum;
					ddrawif=filas[i].str_DrawIf;
					desformula=filas[i].isFormula;
					devar_name=filas[i].varName;
				}
				celdas[i][j].font=BasicStr.parseGeneralFont(Attribute.getValue(attr_celdas[i][j].value,"fuente"),dfont);
				celdas[i][j].align=Tr.parseAlign(Attribute.getValue(attr_celdas[i][j].value,"alinear"),defalign);
				celdas[i][j].adjust=Tr.parseAdjust(Attribute.getValue(attr_celdas[i][j].value,"ajustar"),defadjust);
				celdas[i][j].fgcolor=Tr.ParseColor(Attribute.getValue(attr_celdas[i][j].value,"color"),dfgcolor,dfgcolor);
				celdas[i][j].bgcolor=Tr.ParseColor(Attribute.getValue(attr_celdas[i][j].value,"fondo"),dbgcolor,dbgcolor);
				celdas[i][j].may_imp=Tr.isTrue(Attribute.getValue(attr_celdas[i][j].value,"may_imp"),dmay_imp);
				celdas[i][j].decimales=BasicStr.parseInteger(Attribute.getValue(attr_celdas[i][j].value,"decimales"),ddecimales,ddecimales);
				celdas[i][j].fijo=dfijo;
				if (BasicStr.hasContent(Attribute.getValue(attr_celdas[i][j].value,"fijo"))) {
					celdas[i][j].fijo=Tr.isNotFalse(Attribute.getValue(attr_celdas[i][j].value,"fijo"));
				}
				celdas[i][j].calcalfanum=parseCalculadora(Attribute.getValue(attr_celdas[i][j].value,"calculadora").toLowerCase(),dcalcalfanum);
//System.out.println("CELDA["+i+","+j+"] decimales="+celdas[i][j].decimales+" fijo="+celdas[i][j].fijo);
				celdas[i][j].str_initial=Attribute.getValue(attr_celdas[i][j].value,"texto_inicial");
				celdas[i][j].varName=Attribute.getValue(attr_celdas[i][j].value,"var");
				if (BasicStr.hasContent(attr_celdas[i][j].value)) {
					celdas[i][j].editable=Tr.isTrue(Attribute.getValue(attr_celdas[i][j].value,"editable"));
					celdas[i][j].isFormula=Tr.isTrue(Attribute.getValue(attr_celdas[i][j].value,"formula"));
				} else {
					celdas[i][j].editable=deditable;
					celdas[i][j].isFormula=desformula;
				}
				if (BasicStr.hasContent(Attribute.getValue(attr_celdas[i][j].value,"dibujar-si"))) {
					celdas[i][j].str_DrawIf=Attribute.getValue(attr_celdas[i][j].value,"dibujar-si");
				} else {
					celdas[i][j].str_DrawIf=ddrawif;
				}
				celdas[i][j].setSolution(p,Attribute.getValue(attr_celdas[i][j].value,"solucion"),activeCard);
				if (celdas[i][j].editable) {
					celdas[i][j].str_user=celdas[i][j].str_initial;
				} else {
					celdas[i][j].str_user=celdas[i][j].getFirstSolution(activeCard);
				}
				celdas[i][j].celdas_ancho=BasicStr.parseInteger(Attribute.getValue(attr_celdas[i][j].value,"celdas_ancho"),1,1);
				celdas[i][j].celdas_alto=BasicStr.parseInteger(Attribute.getValue(attr_celdas[i][j].value,"celdas_alto"),1,1);
			}
		}
	}

	int parseCalculadora(String str_calc,int defvalue) {
		if (BasicStr.hasContent(str_calc)) {
			if (str_calc.startsWith("no")) {
				return 0;
			} else if (str_calc.startsWith("alfa")) {
				return 2;
			} else {
				return 1;
			}
		} else {
			return defvalue;
		}
	}


	private static String nombreCelda(int i,int j) {
		return "celda_"+BasicStr.IntegerToString(i,2)+"_"+BasicStr.IntegerToString(j,2);
	}

	private static String nombreFila(int i) {
		return "Fila_"+BasicStr.IntegerToString(i,2);
	}

	private static String nombreColumna(int j) {
		return "Columna_"+BasicStr.IntegerToString(j,2);
	}
	
	private void verify() {
		int total=0,aciertos=0,errores=0;
		for (int i=0;i<nfilas;i++) {
			for (int j=0;j<ncolumnas;j++) {
				if (celdas[i][j].editable) {
					if (!celdas[i][j].evaluated) {
						celdas[i][j].str_user=celdas[i][j].tb.getText();
						if (!editar_siempre) {
							celdas[i][j].evaluated=true;
						}
					} else {
						celdas[i][j].tb.setText(celdas[i][j].str_user);
					}
					total++;
					if (celdas[i][j].isSolution(activeCard)) {
						celdas[i][j].tb.setForeground(correctColor);
						aciertos++;
					} else {
						errores++;
						if (BasicStr.hasContent(celdas[i][j].tb.getText())) {
							celdas[i][j].tb.setForeground(wrongColor);
						}
					}
				}
			}
		}
		double dnota=(double)aciertos*100.0/(double)total;
		if (hayEditables() && nota && total>0) {
			String s=
				"aciertos "+
				String.valueOf(aciertos)+" de "+String.valueOf(total)+
				", nota="+
				BasicStr.DoubleToString(dnota,1,false)+" %";
			
			lb_nota.setText(s);
		}
		p.Var("_ACIERTOS_").setDouble(aciertos);
		p.Var("_ERRORES_").setDouble(errores);
		p.Var("_TOTAL_").setDouble(total);
		p.Var("_NOTA_").setDouble(dnota);
		sendEvaluationToConnectedNippe();
		sendTableEntriesToConnectedNippe();
		if (hayEditables()) {
			b_sol.setEnabled(true);
		}
		if (!editar_siempre) {
			enableCeldas(false);
		} else {
			enableCeldas(true);
		}
	}

	private void sendEvaluationToConnectedNippe() {
        String connected_nippe = getParameter("conectar_con_Nippe");
        if(BasicStr.hasContent(connected_nippe)) {
	        comm c=new comm(this);
	        c.openCommTo(connected_nippe);
	        String param=
	        getName()+"."+"_ACIERTOS_"+"="+p.rvalue("_ACIERTOS_")+"\n"+
	        getName()+"."+"_ERRORES_"+"="+p.rvalue("_ERRORES_")+"\n"+
	        getName()+"."+"_TOTAL_"+"="+p.rvalue("_TOTAL_")+"\n"+
	        getName()+"."+"_NOTA_"+"="+p.rvalue("_NOTA_");
	        c.doAction("processExpression",param);
	    }
	}
	
	private void sendTableEntriesToConnectedNippe() {
        String connected_nippe = getParameter("conectar_con_Nippe");
        if(BasicStr.hasContent(connected_nippe)) {
	        String param="";
            comm c = new comm(this);
            for(int n = 0; n++ < 30;) {
                if(c.openCommTo(connected_nippe)) {
                    for(int j = 0; j < celdas.length; j++) {
                        for(int i = 0; i < celdas[j].length; i++)
                        	if(celdas[j][i] != null){
                        		String str_value=celdas[j][i].tb.getText();
                        		try {
                        			double aux=Double.parseDouble(str_value);
                        		} catch (Exception e) {
	                        		if (trimCells) {
                        				str_value=str_value.trim();
    	                    		}
                        			str_value="|"+str_value+"|";
                        		}
                        		param+=getName()+"."+"_"+j+"_"+i+"="+str_value+"\n";
                            }
                    }
                    break;
                }
                try {
                    Thread.sleep(100L);
                } catch(InterruptedException interruptedexception) { 
                }
            }
	        c.doAction("processExpression",param);
        }
    }
	
//	private boolean completelyAnswered() {
//		boolean oneNotAnswered=false;
//		for (int i=0;i<nfilas;i++) {
//			for (int j=0;j<ncolumnas;j++) {
//				if (celdas[i][j].editable) {
//					if (!BasicStr.hasContent(celdas[i][j].tb.getText())) {
//						oneNotAnswered=true;
//						return false;
//					}
//				}
//			}
//		}
//		return !oneNotAnswered;
//	}

	private void solve() {
		for (int i=0;i<nfilas;i++) {
			for (int j=0;j<ncolumnas;j++) {
				if (celdas[i][j].editable) {
					celdas[i][j].tb.setForeground(solutionColor);
					if (celdas[i][j].isSolution(activeCard)) {
						if (celdas[i][j].solutionIsNumeric()) {
							if (!editar_siempre ||BasicStr.hasContent(celdas[i][j].tb.getText())) {
								celdas[i][j].tb.setText(celdas[i][j].getFirstSolution(activeCard));
							}
						}
					} else {
						celdas[i][j].tb.setText(celdas[i][j].getFirstSolution(activeCard));
					}
				}
			}
		}
		enableCeldas(false);
	}

	private void enableCeldas(boolean b) {
		for (int i=0;i<nfilas;i++) {
			for (int j=0;j<ncolumnas;j++) {
				if (celdas[i][j].editable) {
					celdas[i][j].tb.setEditable(b);
				}
			}
		}
	}

/* ----------------- AbstractNippe implementation ----------------- */

	public String getParameter(String name) {
		String res=filterParameter(name);
		if (res!=null) {
			return res;
		}
		return super.getParameter(name);
	}

	public String getInfo(String type,String param) {
		String varName=type;
        if (p.isVar(varName)) {
        	if (p.Var(varName).getStr()!=null) {
        		return p.Var(varName).getStr();
        	} else {
	            return BasicStr.DoubleToString(p.Var(varName).getDouble(), 6, false);
        	}
        }
		StringTokenizer st=new StringTokenizer(param,"_");
		if (st.hasMoreTokens()) {
			int i=BasicStr.parseInteger(st.nextToken(),0,0);
			if (st.hasMoreTokens()) {
				int j=BasicStr.parseInteger(st.nextToken(),0,0);
				String var=varName+"_"+i+"_"+j;
				if (p.isVar(var)) {
					if (p.svalue(var)!=null) {
						return p.svalue(var);
					} else {
						return BasicStr.DoubleToString(p.rvalue(var),6,false);
					}
				} else {
					System.out.println("Error en tabla.getInfo: la variable "+var+" no est definida");
					return "Error";
				}
			}
		}
		return "";
	}

	public void doAction(String actionName,String actionParam) {
		if ("restart".equalsIgnoreCase(actionName)) {
			reinit();
		} else if ("refresh".equalsIgnoreCase(actionName)) {
			reinit();
		} else if ("reiniciar".equalsIgnoreCase(actionName)) {
			reinit();
		} else if ("verify".equalsIgnoreCase(actionName)) {
			verify();
		} else if ("verificar".equalsIgnoreCase(actionName)) {
			verify();
		} else if ("solve".equalsIgnoreCase(actionName)) {
			solve();
		} else if ("resolver".equalsIgnoreCase(actionName)) {
			solve();
		} else if ("sendValues".equalsIgnoreCase(actionName)) {
			sendTableEntriesToConnectedNippe();
		}
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==b_eval)  {
			verify();
		} else if (e.getSource()==b_sol) {
			solve();
		} else if (e.getSource()==b_reinit) {
			reinit();
//			enableCeldas(true);
		} else {
			int i0=-1,j0=-1;
			for (int i=0;i<nfilas;i++) {
				for (int j=0;j<ncolumnas;j++) {
					if (e.getSource()==celdas[i][j].getVisualComponent()) {
						i0=i; j0=j;
						break;
					}
				}
			}
			int i=i0;
			int j=j0;
			while (true) {
				if ("next".equals(e.getActionCommand())) {
					j++;
					if (j==ncolumnas) {
						j=0;
						i++;
					}
				} else if ("prev".equals(e.getActionCommand())) {
					j--;
					if (j<0) {
						j=ncolumnas-1;
						i--;
					}
				} else if ("prevLine".equals(e.getActionCommand())) {
					i--;
				} else if ("nextLine".equals(e.getActionCommand())) {
					i++;
				}
				if (i<0||i>=nfilas||j<0||j>=ncolumnas) {
					break;
				}
				if (celdas[i][j].editable) {
					celdas[i][j].tb.requestFocus();
					break;
				}
			}
		}
	}
	
	public String class_Id() {
		return "Tabla";
	}

	public String[] getFilePaths() {
		return new String[0];
//		String[] files=new String[imagesHT.size()];
//		Enumeration E=imagesHT.keys();
//		for (int i=0;i<files.length;i++) {
//			files[i]=(String) E.nextElement();
//		}
//		return files;
	}

	public static String getVersion() {
		return Version;
	}

	public String getAppliedCode() {
		return "";
	}

	public Dimension getRealSize() {
		return getSize();
	}

	public void updateProposedDimension() {
		proposedDimension=getSize();
	}
}