/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
/**
 * 
 */
package edu.ite.items.metadatos.services.gui;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JEditorPane;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.JViewport;
import javax.swing.ScrollPaneLayout;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.TableCellRenderer;

import org.xml.sax.SAXException;



import edu.ite.items.beans.Item;
import edu.ite.items.beans.Metadato;
import edu.ite.items.metadatos.services.gui.componentes.tablebusqueda.BusquedaMetadatosTableModel;
import edu.ite.items.metadatos.utils.ItemsServicesConnector;

/**
 * @author oescamil
 *
 */
public class BusquedaMetadatosGUI extends JPanel implements ActionListener{

	private static final long serialVersionUID = 1L;
	private JSplitPane splitPane = null;
	private JPanel jPanel2 = null;
	private JScrollPane jScrollPane = null;
	private JTable tablaResultados = null;
	private JPanel jPanel3 = null;
	private JTextField nombreAutor = null;
	private JLabel jLabel1 = null;
	private Hashtable<String, MetadataInput> inputsMeta;  //  @jve:decl-index=0:
	private JButton buscarBtn = null;
	private JScrollPane jScrollPane1 = null;
	
	private URL hostService;  //  @jve:decl-index=0:
	/**
	 * @param hostService
	 * @throws IOException 
	 */
	public BusquedaMetadatosGUI(URL hostService) throws IOException {
		super();
		this.setHostService(hostService);
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * 
	 * @throws IOException 
	 */
	private void initialize() throws IOException {
		inputsMeta = new Hashtable<String, MetadataInput>();
		this.setLayout(new BorderLayout());
		this.add(getSplitPane(), BorderLayout.CENTER);
	}

	

	/**
	 * This method initializes splitPane	
	 * 	
	 * @return javax.swing.JSplitPane	
	 * @throws IOException 
	 */
	public JSplitPane getSplitPane() throws IOException {
		if (splitPane == null) {
			splitPane = new JSplitPane();
			splitPane.setOneTouchExpandable(true);
			splitPane.setOrientation(JSplitPane.VERTICAL_SPLIT);
			splitPane.setTopComponent(getJPanel2());
			splitPane.setBottomComponent(getJScrollPane());
		}
		return splitPane;
	}
	
	
	/**
	 * This method initializes jPanel2	
	 * 	
	 * @return javax.swing.JPanel	
	 * @throws IOException 
	 */
	private JPanel getJPanel2() throws IOException {
		if (jPanel2 == null) {
			jPanel2 = new JPanel();
			
			BoxLayout boxLayout = new BoxLayout(getJPanel2(), BoxLayout.Y_AXIS);	
			jPanel2.setLayout(boxLayout);
			
			//jPanel2.add(getJScrollPane1());
			jPanel2.add(getJPanel3());
			JPanel tmpPanel = new JPanel();
			tmpPanel.add(getBuscarBtn());
			
			Dimension ant = tmpPanel.getMaximumSize();
			tmpPanel.setMaximumSize(new Dimension(ant.width,50));
			
			jPanel2.add(tmpPanel);
		}
		return jPanel2;
	}

	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			ScrollPaneLayout layout = new ScrollPaneLayout();
			jScrollPane.setViewportView(getTablaResultados());
			
		}
		return jScrollPane;
	}

	/**
	 * This method initializes tablaResultados	
	 * 	
	 * @return javax.swing.JTable	
	 */
	public JTable getTablaResultados() {
		if (tablaResultados == null) {
			
			if(inputsMeta.isEmpty()){
				fillPanelMetadatos(null);
			}
			
			Hashtable<String, String> tmpHash = new Hashtable<String, String>();
			Iterator<String> keys = (Iterator<String>) inputsMeta.keys();
			while(keys.hasNext()){
				String key = keys.next();
				MetadataInput meta = inputsMeta.get(key);
				String value = meta.label.getText();
				value = value.replaceAll(":", "");
				tmpHash.put(key, value);
			}
			
			tablaResultados = new JTable(new BusquedaMetadatosTableModel(tmpHash)){
				private static final long serialVersionUID = 1L;
				public boolean getScrollableTracksViewportWidth() {
					if (autoResizeMode != AUTO_RESIZE_OFF) {
							if (getParent() instanceof JViewport) {
									return (((JViewport)getParent()).getWidth() > getPreferredSize().width);
							}
					}
					return false;
				}
			};
			
			
			tablaResultados.setAutoscrolls(true);
			tablaResultados.setAutoResizeMode(JTable.AUTO_RESIZE_LAST_COLUMN);
			tablaResultados.setRowHeight(100);
			tablaResultados.getColumnModel().getColumn(0).setMaxWidth(40);
			tablaResultados.getColumnModel().getColumn(0).setWidth(20);
			
			
			tablaResultados.getColumnModel().getColumn(1).setMaxWidth(150);
			tablaResultados.getColumnModel().getColumn(1).setMinWidth(150);
			
			int indexAutor = tablaResultados.getModel().getColumnCount()-1;
			tablaResultados.getColumnModel().getColumn(indexAutor).setMinWidth(150);
			tablaResultados.getColumnModel().getColumn(indexAutor).setMaxWidth(250);
			tablaResultados.getColumnModel().getColumn(indexAutor).setPreferredWidth(200);
		}
		return tablaResultados;
	}

	
	/**
	 * This method initializes jPanel3	
	 * 	
	 * @return javax.swing.JPanel	
	 * @throws IOException 
	 */
	private JPanel getJPanel3() throws IOException {
		if (jPanel3 == null) {
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.fill = GridBagConstraints.BOTH;
			gridBagConstraints1.gridx = 1;
			gridBagConstraints1.gridy = 0;
			gridBagConstraints1.weightx	= 1;  
			gridBagConstraints1.insets = new Insets(5,5,5,0);
			
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.insets = new Insets(5,0,5,5);
			gridBagConstraints.gridy = 0;
			gridBagConstraints.gridx = 0;
			gridBagConstraints.fill = GridBagConstraints.BOTH;
			gridBagConstraints.anchor = GridBagConstraints.WEST;
			
			jLabel1 = new JLabel();
			jLabel1.setText("Autor : ");
			jPanel3 = new JPanel();
			
			
			Border titulo = new TitledBorder("Buscar por ...");
			jPanel3.setBorder(titulo);
			jPanel3.setLayout(new FlowLayout(FlowLayout.LEADING));

			//jPanel3.setLayout(new GridBagLayout());
			JPanel tmpAutorP = new JPanel();
			tmpAutorP.setLayout(new BoxLayout(tmpAutorP,BoxLayout.X_AXIS));
			tmpAutorP.add(jLabel1);
			tmpAutorP.add(getNombreAutor());
			
			jPanel3.add(tmpAutorP);
			int cuantosMas = fillPanelMetadatos(jPanel3);
			if(cuantosMas <=-1){
				JOptionPane.showMessageDialog(this, "No se pudo construir la GUI. Verifique que los servicios esten activos","Error",JOptionPane.ERROR_MESSAGE);
				throw new IOException("No se pudo contactar al servidor:"+hostService);
			}
		}
		return jPanel3;
	}

	

	/**
	 * This method initializes nombreAutor	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getNombreAutor() {
		if (nombreAutor == null) {
			nombreAutor = new JTextField();
			nombreAutor.setPreferredSize(new Dimension(300,20));
			
		}
		return nombreAutor;
	}

	/**
	 * This method initializes buscarBtn	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBuscarBtn() {
		if (buscarBtn == null) {
			buscarBtn = new JButton("Buscar");
			buscarBtn.addActionListener(this);
		}
		return buscarBtn;
	}

	/**
	 * This method initializes jScrollPane1	
	 * 	
	 * @return javax.swing.JScrollPane	
	 * @throws IOException 
	 */
	private JScrollPane getJScrollPane1() throws IOException {
		if (jScrollPane1 == null) {
			jScrollPane1 = new JScrollPane();
			jScrollPane1.add(getJPanel3());
			jScrollPane1.setViewportView(getJPanel3());
			Border titulo = new TitledBorder("Buscar por ...");
			jScrollPane1.setBorder(titulo);
		}
		return jScrollPane1;
	}

	
	

	private int fillPanelMetadatos(JPanel panelMetadatos) {
		try {
			URL servicio = getHostService(); // EL URL PARA EL SERVICIO DE LOS METADATOS
			if(servicio == null)
				return -1;
			Metadato[] metadatos = ItemsServicesConnector.getMetadatosFromServices(servicio);
			
			for (int i = 0; i < metadatos.length; i++) {
				Metadato act = metadatos[i];
					
				MetadataInput tmpP = new MetadataInput(act);
				
				JLabel labelAct = tmpP.label; 
				JComponent inputAct = tmpP.input;
				inputsMeta.put(act.getLabel(),tmpP);
				JPanel tmpPanel = new JPanel();
				tmpPanel.setLayout(new BoxLayout(tmpPanel,BoxLayout.X_AXIS));
				tmpPanel.add(labelAct);
				tmpPanel.add(inputAct);
				
				tmpPanel.setAlignmentX(LEFT_ALIGNMENT);
				
				if(panelMetadatos != null)
					panelMetadatos.add(tmpPanel);
			}
			
			return metadatos.length+1;
		} catch (MalformedURLException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
			return -1;
		} catch (SAXException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return -1;
	}
	
	
	
	private int fillPanelMetadatos_GridBagLayout(JPanel panelMetadatos) {
			
			try {
				
				URL servicio = getHostService(); // EL URL PARA EL SERVICIO DE LOS METADATOS
				if(servicio == null)
					return -1;
				Metadato[] metadatos = ItemsServicesConnector.getMetadatosFromServices(servicio);
				
				for (int i = 0; i < metadatos.length; i++) {
					Metadato act = metadatos[i];
						
					MetadataInput tmpP = new MetadataInput(act);
					
					JLabel labelAct = tmpP.label; 
					JComponent inputAct = tmpP.input;
					inputsMeta.put(act.getLabel(),tmpP);
					
					GridBagConstraints constraints = new GridBagConstraints();	
					constraints.gridx	= 0;
					constraints.gridy 	= i+1;
					constraints.fill 	= GridBagConstraints.HORIZONTAL;
					constraints.anchor	= GridBagConstraints.WEST;
					constraints.insets	= new Insets(5,0,5,5);  
					constraints.weightx	= 0;
					if(panelMetadatos != null)
						panelMetadatos.add(labelAct,constraints);
					
					
					GridBagConstraints constraints2 = new GridBagConstraints();
					constraints2.gridx	= 1;
					constraints2.fill 	= GridBagConstraints.HORIZONTAL;
					constraints2.anchor	= GridBagConstraints.EAST;
					constraints2.weightx	= 1;  
					constraints2.insets	= new Insets(5,5,5,0);
					if(panelMetadatos != null)
						panelMetadatos.add(inputAct,constraints2);
				}
				GridBagConstraints constraints = new GridBagConstraints();
				constraints.gridx	= 1;
				constraints.gridy	= metadatos.length+1;
				constraints.gridwidth = 2;
				constraints.fill 	= GridBagConstraints.VERTICAL;
				constraints.anchor	= GridBagConstraints.WEST;
				constraints.weightx	= 1;  
				constraints.weighty	= 1;  
				if(panelMetadatos != null)
					panelMetadatos.add(Box.createVerticalGlue(),constraints);
				
				
				return metadatos.length+1;
			} catch (MalformedURLException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
				return -1;
			} catch (SAXException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			return -1;
	}
	
 class MetadataInput {
		Metadato metaData;
		JLabel label;
		JComponent input;
		boolean modificado;
		public MetadataInput(Metadato metadato) {
			super();
			if (metadato == null)
				throw new IllegalArgumentException(
						"El metadato no puede ser null");
			
			metaData = metadato;
			
			char[] strLabel = metaData.getLabel().toCharArray();
			strLabel[0]= Character.toUpperCase(strLabel[0]);
			String tmp = (new String(strLabel))+" : ";
			
			
			
			if(metaData.getDefaultVal().length>1){
				String[] valsOld = metaData.getDefaultVal();
				String[] valsNew = new String[valsOld.length+1];
				System.arraycopy(valsOld, 0, valsNew, 1, valsOld.length);
				valsNew[0] = "";
				final JComboBox a = new JComboBox(valsNew);
				a.setEditable(true);
				a.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						MetadataInput.this.metaData.setValue(a.getSelectedItem().toString());
						modificado = true;
					}
					});
				input = a;
			} else {
				final JTextField a = new JTextField();
				a.setPreferredSize(new Dimension(200,20));
				a.getDocument().addDocumentListener(new DocumentListener(){
					public void changedUpdate(DocumentEvent e) {}
					public void insertUpdate(DocumentEvent e) {
						
						MetadataInput.this.metaData.setValue(a.getText().trim());
						modificado = true;
					}
					public void removeUpdate(DocumentEvent e) {insertUpdate(e);}
				});
				input = a;
			}
			
			
			label = new JLabel(tmp);
			label.setLabelFor(input);
			input.setToolTipText(metaData.getDescripcion());
			label.setToolTipText(metaData.getDescripcion());
		}
		
		
		public String getUsrValue(){
			if(input instanceof JComboBox){
				return ((JComboBox)input).getSelectedItem().toString();
			} else {
				return ((JTextField)input).getText();
			}
		}
		
		
		public void setUsrValue(String value){
			modificado = false;
			if(input instanceof JComboBox){
				JComboBox tmpBox = ((JComboBox)input); 
				tmpBox.setSelectedItem(value);
				
				if(!tmpBox.getSelectedItem().equals(value))
					throw new IllegalArgumentException("'"+value+"' no es una opcion permitida para el metadato : '"+metaData.getLabel()+"'");
			} else {
				((JTextField)input).setText(value);
			}
		}
	}

public void actionPerformed(ActionEvent e) {
	
	Object source = e.getSource();
	if (source != buscarBtn) 
		return;
	buscarItemsInServer();
	
}

	private void buscarItemsInServer() {
		try {
			String strBusqueda = preparaStrToBuscar();
			Item[] resultado = ItemsServicesConnector.searchItemInServer(strBusqueda,getHostService());
			BusquedaMetadatosTableModel myModel = (BusquedaMetadatosTableModel) getTablaResultados().getModel();
			
			myModel.setRows(resultado);
			
			if(resultado.length <=0){
				JOptionPane.showMessageDialog(this, "No se encontraron coincidensias", "Sin resultados", JOptionPane.INFORMATION_MESSAGE);
			}
		} catch (IOException e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(this,
					"No se pudo conectar al servidor:\n"+getHostService(),
					"Error al contactar el servidor",
					JOptionPane.ERROR_MESSAGE, null);
		} catch (SAXException e) {
			JOptionPane.showMessageDialog(this, "Error desconocido", "Error", JOptionPane.ERROR_MESSAGE);
			e.printStackTrace();
		}
	}
	
	
	
	
	
	
	
	
	private String preparaStrToBuscar(){
		Iterator<String> keys = inputsMeta.keySet().iterator();
		Vector<Metadato> listaAbuscar = new Vector<Metadato>();
		while(keys.hasNext()){
			String key = keys.next();
			MetadataInput metaAct = (MetadataInput) inputsMeta.get(key);
			String value = metaAct.getUsrValue().trim();		
			if(value.length() > 0){
				String[] buscarList = value.split("\\+");
				for (int i = 0; i < buscarList.length; i++) {
					String aBuscar = buscarList[i].trim();
					try {
						Metadato tmpM = (Metadato) metaAct.metaData.clone();
						tmpM.setValue(aBuscar);
						listaAbuscar.add(tmpM);
					} catch (CloneNotSupportedException e) {e.printStackTrace();}
				}
			}		
		}
		String strXML = Metadato.getMetadatoXMLfromArray(listaAbuscar.toArray(new Metadato[listaAbuscar.size()]));
		String itemXML = "<item>\n";
		String nombreAutor = this.getNombreAutor().getText().trim(); 
		if(nombreAutor.length() > 0 )
			itemXML+= "\t<autor nombre='"+nombreAutor+"' />\n";
		itemXML+= strXML;
		itemXML+="</item>";	
		return itemXML;
	}
	
	
	
	public URL getHostService(){
		return hostService;
	}
	
	public void setHostService(URL host){
		hostService = host;
	}
	
}  //  @jve:decl-index=0:visual-constraint="12,9,600,400"