/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package edu.ite.items.metadatos.utils;

import java.io.BufferedOutputStream;
import java.io.ByteArrayInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.net.HttpURLConnection;
import java.net.Proxy;
import java.net.URL;
import java.net.URLEncoder;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Properties;
import java.util.Vector;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

import com.mja.file.mjaFile;

import edu.ite.items.beans.Item;
import edu.ite.items.beans.Metadato;

public class ItemsServicesConnector {
	
	private static Hashtable<String, String> cacheHosts;
	private static Properties cfgProperties;
	private static Properties cfgUsrProperties;
	private static String propertieHost = "Items.services.host";
	private static String pathCfgUsr;
	
	static{
		pathCfgUsr = System.getProperty("user.home")+File.separatorChar+"servidor"+File.separatorChar+"items.properties";
	}
	
	public static Properties getCfgProperties() throws IOException {
		if (cfgProperties == null) {
			cfgProperties = new Properties();
			
			URL url = ClassLoader.getSystemResource("resources/items/items.properties");
			if(url == null)
				url = ItemsServicesConnector.class.getResource("/resources/items/items.properties");
			if(url != null)
				cfgProperties.load(url.openStream());
		}
		return cfgProperties;
	}
	
	public static Properties getCfgUsrProperties() {
		if (cfgUsrProperties == null) {
			cfgUsrProperties = new Properties();
			
			File fileUsrHost = new File(pathCfgUsr);
			if(fileUsrHost.canRead()){
				try {
					cfgUsrProperties.load(new FileInputStream(fileUsrHost));
				} catch (Exception e) {
					e.printStackTrace();
				} 
			}
		}
		return cfgUsrProperties;
	}
	
	public static void addNewHost(String url,String name){
		try{
		if(cacheHosts == null)
			updateHostList();
		}catch (Exception e) {
			if(cacheHosts == null)
				cacheHosts = new Hashtable<String, String>();
		}
		boolean yaEsta = cacheHosts.containsKey(url);
		cacheHosts.put(url, name);
		Properties usrP = getCfgUsrProperties();
		
		String propAnt = usrP.getProperty(propertieHost);
		if(yaEsta){
			String nomAnt = cacheHosts.get(url);
			propAnt = propAnt.replace(url+","+nomAnt, url+","+name);
		} else {
			propAnt = (propAnt==null)?"":propAnt;
			String sep = (propAnt.length()>0)?"|":"";
			propAnt+=sep+url+","+name;
		}
		usrP.setProperty(propertieHost, propAnt);
		
		
		try {
			File parent = (new File(pathCfgUsr)).getParentFile();
			if(!parent.isDirectory()){
				parent.mkdirs();
			}
			usrP.store(new FileOutputStream(pathCfgUsr), "Modificado por el sistema al agregar uno nuevo");
		} catch (IOException e) {
			System.out.println("No se pudo guardar el archivo de configuracion");
			e.printStackTrace();
		}
	}

	public static Hashtable<String, String> updateHostList() throws IOException{
		Properties p = getCfgProperties();
		if(p == null)
			return cacheHosts;		
		String hosts = p.getProperty(propertieHost);
		if(hosts == null)
			throw new IOException("No se encuentra la propiedad '"+propertieHost+"'");
		
		Properties userP = getCfgUsrProperties();
		String usrHost = userP.getProperty(propertieHost);
		usrHost = (usrHost == null)?"":usrHost.trim();
		if(usrHost.length()>0)
			hosts+="|"+usrHost;		
//		System.out.println("Leido desde cfgUSR : "+usrHost);
		
		Hashtable<String, String> res = getHashHostsFromString(hosts);
		Enumeration<String> keys = res.keys();
		while (keys.hasMoreElements()) {
			String actKey = (String) keys.nextElement();
			URL host = new URL(actKey+"?servicio=servers&accion=info");
		
			String otherHost = String.valueOf(mjaFile.readURL(host));
			System.out.println();
			if(otherHost.length()>0){
				Hashtable<String, String> res2 = getHashHostsFromString(otherHost);
				Enumeration<String> keys2 = res2.keys();
				while (keys2.hasMoreElements()) {
					String actKey2 = (String) keys2.nextElement();
					String name = res2.get(actKey2);
					
					if(actKey2.toLowerCase().indexOf("<error>")<0){
						if(!res.containsKey(actKey2)){
							res.put(actKey2, name);
						}
					}
				}
			} else {
				String name = res.get(actKey)+" (offline)";
				res.put(actKey, name);
			}
		
		}
		cacheHosts = res;	
		return cacheHosts;
	}
	
	public static Hashtable<String, String> getServiceHosts() throws IOException {
		if(cacheHosts == null)
			updateHostList();
		return cacheHosts;
	}

	
	
	public static Metadato[] getMetadatosFromServices(URL hostService)
			throws IOException, SAXException {
		Proxy tmpProxy = mjaFile.getProxyFor(hostService);
		HttpURLConnection conn = (HttpURLConnection) hostService
				.openConnection(tmpProxy);

		String rawData = "accion=seleccionar&id=*&servicio=metadatos";

		conn.setDoInput(true);
		conn.setDoOutput(true);
		conn.setRequestProperty("Content-Type",
				"application/x-www-form-urlencoded");
		OutputStreamWriter wr = new OutputStreamWriter(conn.getOutputStream());
		wr.write(rawData);
		wr.flush();

		InputStream ioStream = conn.getInputStream();

		StringBuffer bufferString = new StringBuffer();
		Reader reader = new InputStreamReader(ioStream);

		int character;
		while ((character = reader.read()) != -1) {
			bufferString.append((char) character);
		}
		Metadato[] resMeta = Metadato.getMetadatosFromXMLString(bufferString
				.toString());
		wr.close();
		conn.disconnect();
		return resMeta;
	}

	public static Item[] searchItemInServer(String xmlItemBuscar,
			URL hostService) throws IOException, SAXException {
		Proxy tmpProxy = mjaFile.getProxyFor(hostService);
		HttpURLConnection conn = (HttpURLConnection) hostService
				.openConnection(tmpProxy);
		String rawData = "accion=buscar&servicio=items";
		rawData += "&xml=" + URLEncoder.encode(xmlItemBuscar, "UTF-8");
		conn.setDoInput(true);
		conn.setDoOutput(true);
		conn.setRequestProperty("Content-Type",
				"application/x-www-form-urlencoded");
		OutputStreamWriter wr = new OutputStreamWriter(conn.getOutputStream());
		wr.write(rawData);
		wr.flush();
		StringBuffer bufferString = new StringBuffer();
		try {
			InputStream ioStream = conn.getInputStream();
			DocumentBuilderFactory builderFactory = DocumentBuilderFactory
					.newInstance();
			DocumentBuilder builderXML;
			InputSource inputSource;
			inputSource = new InputSource(ioStream);
			builderXML = builderFactory.newDocumentBuilder();

			int character;
			Reader reader = new InputStreamReader(ioStream);

			while ((character = reader.read()) != -1) {
				bufferString.append((char) character);
			}
			ByteArrayInputStream bs = new ByteArrayInputStream(bufferString
					.toString().getBytes());
			inputSource = new InputSource(bs);

			Document domDoc = builderXML.parse(inputSource);

			NodeList listItemXml = domDoc.getElementsByTagName("item");
			Vector<Item> resultado = new Vector<Item>();
			for (int i = 0; i < listItemXml.getLength(); i++) {
				Element itemNode = (Element) listItemXml.item(i);
				Item tmpItem = Item.getItemFromXmlNode(itemNode,
						Item.FILL_LEVEL_METADATOS);
				resultado.add(tmpItem);
			}
			wr.close();
//			if(true){
//				System.out.println("EN la busqueda el servidor contesto:\n"+bufferString);
//			}
			conn.disconnect();
			return resultado.toArray(new Item[resultado.size()]);
		} catch (ParserConfigurationException e) {
			System.out.println("EN la busqueda el servidor contesto:\n"+bufferString);
			e.printStackTrace();
		} catch (SAXParseException e) {
			String errorMsg = "El servidor no respondio con un xml:\n"+bufferString.toString();
			System.out.println(errorMsg);
			conn.disconnect();
			throw new SAXException(errorMsg,e);
		}

		wr.close();
		conn.disconnect();
		return null;
	}

	public static Item downloadItem(URL hostService, String id, File dirDest)
			throws IOException {

		if ((dirDest == null) || (!dirDest.exists())
				|| (!dirDest.isDirectory()))
			throw new FileNotFoundException("No se encuentra el directorio:'"
					+ dirDest + "'");
		if (!dirDest.canWrite())
			throw new SecurityException(
					"No se puede escribir en el directorio:'" + dirDest + "'");

		
		Proxy tmpProxy = mjaFile.getProxyFor(hostService);
		HttpURLConnection conn = (HttpURLConnection) hostService
				.openConnection(tmpProxy);
		String rawData = "accion=download&servicio=items";
		rawData += "&id=" + URLEncoder.encode(id, "UTF-8");
		conn.setDoInput(true);
		conn.setDoOutput(true);
		conn.setRequestProperty("Content-Type",
				"application/x-www-form-urlencoded");
		OutputStreamWriter wr = new OutputStreamWriter(conn.getOutputStream());
		wr.write(rawData);
		wr.flush();
		try {
			InputStream ioStream = conn.getInputStream();
			String contentType = conn.getContentType();
			Vector<String> files = new Vector<String>();
			
			if ("application/octet-stream".equals(contentType)) {
				ZipInputStream zipInputStream = new ZipInputStream(ioStream);
				ZipEntry entry;
				int BUFFER = 2048;
				BufferedOutputStream dest = null;

				while ((entry = zipInputStream.getNextEntry()) != null) {
					// write the files to the disk
					// System.out.println(
					// "NAME		= "+entry.getName()+"\n"+
					// "TIME		= "+entry.getTime()+"\n"+
					// "COMSIZE	= "+entry.getCompressedSize()+"\n"+
					// "EXTRA		= "+entry.getExtra()+"\n"+
					// "INPUT 		= "+zipInputStream.available()
					// );
					
					
					String destPath = dirDest.getAbsolutePath()
							+ File.separatorChar + entry.getName();
					

					File destFile = new File(destPath);
					destFile = destFile.getParentFile();
					
					if (!destFile.isDirectory()) {
						destFile.mkdirs(); 
					}
					if (destPath.lastIndexOf("/") >= destPath.length() - 1) {
						destFile = new File(destPath);
						if (!destFile.isDirectory()) {
							destFile = destFile.getAbsoluteFile();
							destFile.mkdir();
						}
						continue;
					}
					
					if(entry.getName().indexOf("index.html")<0)
						files.add(entry.getName());
					
					FileOutputStream fos = new FileOutputStream(destPath);
					dest = new BufferedOutputStream(fos, BUFFER);
					int count;
					byte data[] = new byte[BUFFER];
					while ((count = zipInputStream.read(data, 0, BUFFER)) != -1) {
						dest.write(data, 0, count);
					}
					dest.flush();
					dest.close();
				}

				String infoPath = dirDest.getAbsolutePath()
						+ File.separatorChar + "info.xml";
				String codePath = dirDest.getAbsolutePath()
				+ File.separatorChar + "index.html";
				
				Item tmpItem = getItemFromInfoXml(infoPath);
				tmpItem.setHtmlCode(getItemCodeFromPath(codePath));
				tmpItem.setFiles(files.toArray(new String[files.size()]));
				conn.disconnect();
				return tmpItem;
			} else {
				int character;
				StringBuffer bufferString = new StringBuffer();
				Reader reader = new InputStreamReader(ioStream);
				while ((character = reader.read()) != -1)
					bufferString.append((char) character);

				System.out.println("El servidor respondio :\n"
						+ bufferString.toString() + "\n\n");
				conn.disconnect();
				return null;
			}

		} catch (Exception e) {
			e.printStackTrace();
		}
		conn.disconnect();
		return null;
	}

	public static Item uploadItem(
			URL hostService,
			String login,
			String pswd,
			byte[] zipFileData,
			Item item) throws IOException,SecurityException {

		String strXML = item.printtoXmlString();
		String lineEnd = "\r\n";
		String twoHyphens = "--";
		String boundary = "******************";

		Proxy tmpProxy = mjaFile.getProxyFor(hostService);
		HttpURLConnection conn = (HttpURLConnection) hostService
				.openConnection(tmpProxy);
		
		conn.setRequestMethod("POST");
		conn.setUseCaches(false);
		conn.setDoInput(true);
		conn.setDoOutput(true);
		conn.setRequestProperty("Content-Type", "multipart/form-data;boundary="
				+ boundary);

		DataOutputStream dos = new DataOutputStream(conn.getOutputStream());
		
		
		System.out.println("El xml a enviar \n"+strXML);
		Hashtable<String, Object> dataHash = new Hashtable<String, Object>();
		dataHash.put("accion",		URLEncoder.encode("actualizar", "UTF-8"));
		dataHash.put("servicio",	URLEncoder.encode("items", "UTF-8"));
		dataHash.put("xml",			strXML);
		dataHash.put("login",	URLEncoder.encode(login, "UTF-8"));
		dataHash.put("pswd",	URLEncoder.encode(pswd, "UTF-8"));
				
		dataHash.put("itemZipFile", zipFileData);
		
		
		Enumeration<String> keys = dataHash.keys();
		while(keys.hasMoreElements()){
			String key	= keys.nextElement();
			Object value = dataHash.get(key);
			boolean esFile = (value instanceof byte[]); 

			dos.writeBytes(twoHyphens + boundary + lineEnd);
			String disposition =
				"Content-Disposition: form-data; name=\"" + key	+ "\""; 
			if(esFile){
				String fileName = key+"_GEN_BY_ARQ_SRV";
				disposition+= "; filename=\""+fileName+".zip\"";
			} 
			dos.writeBytes(disposition+lineEnd);
			dos.writeBytes(lineEnd);
			
			if(esFile)
				dos.write((byte[])value);
			else
				dos.write(value.toString().getBytes("UTF-8"));
			dos.writeBytes(lineEnd);
		}
		

		
		dos.writeBytes(twoHyphens + boundary + twoHyphens + lineEnd);
		dos.flush();
		dos.close();

		InputStream ioStream = conn.getInputStream();
		StringBuffer buffer = new StringBuffer(); 
		int readed; 
		while ((readed = ioStream.read()) != -1) {
			buffer.append((char)readed);
		}
		ioStream.close();
		
		try {
			ByteArrayInputStream bs = new ByteArrayInputStream(buffer.toString()
					.getBytes());
			InputSource inputSource = new InputSource(bs);
			DocumentBuilderFactory builderFactory = DocumentBuilderFactory
					.newInstance();
			DocumentBuilder builderXML;
				builderXML = builderFactory.newDocumentBuilder();
			Document domDoc = builderXML.parse(inputSource);
			
			
			NodeList errorList = domDoc.getElementsByTagName("error");
			
			if(errorList.getLength() > 0){
				Element error = (Element) errorList.item(0);
				String errorCode = error.getAttribute("code");
				
				
				if("0".equals(errorCode)){
					throw new SecurityException("Usuario y/o contrasea no valido");
				} else if("1".equals(errorCode)){
					throw new SecurityException("No tienes permiso de modificar este Item");
				} else if("2".equals(errorCode)){
					throw new IOException("No se encontro el index.html en el zip");
				} else if("3".equals(errorCode)){
					throw new IOException("No se encontro el tag <applet>");
				} else if("4".equals(errorCode)){
					throw new IOException("No se encuentran los metadatos");
				}else if("5".equals(errorCode)){
					throw new IOException("No se reconocen algunos de los metadatos en este servidor");
				}
				throw new UnknownError("Ocurrio un error Codigo:"+errorCode+"\nTexto\n"+error.getTextContent()+"*********************************************\n"+buffer+"\n*****************************************************");
			}
			
			NodeList itemsList = domDoc.getElementsByTagName("item");
			
			if(itemsList.getLength() <=0)
				throw new IOException("El servidor no regreso ningun item. Respuesta:\n"+buffer.toString());
			
			Item itemRes = Item.getItemFromXmlNode((Element) itemsList.item(0), Item.FILL_LEVEL_METADATOS);
			conn.disconnect();
			return itemRes;
		} catch (ParserConfigurationException e) {
			e.printStackTrace();
		} catch (SAXException e) {
			e.printStackTrace();
			conn.disconnect();
			throw new IOException("El servidor no contesto con un xml:\n"+buffer.toString());
		}
		conn.disconnect();
		return null;
	} 
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	/*
	 * ******************************************************************
	 * FUNCIONES AUXILIARES
	 * ******************************************************************
	 */
	private static Item getItemFromInfoXml(String infoPath) throws IOException,
			FileNotFoundException {
		FileInputStream ioStream = new FileInputStream(infoPath);
		try {
			StringBuffer bufferString = new StringBuffer();
			Reader reader = new InputStreamReader(ioStream);
			int character;
			while ((character = reader.read()) != -1) {
				bufferString.append((char) character);
			}
			Item[] items = Item.getItemFromXmlStr(bufferString.toString(),
					Item.FILL_LEVEL_METADATOS);
			return items[0];
		} catch (SAXException e) {
			e.printStackTrace();
			throw new IOException("No se encontro ningun item");
		}
	}

	private static String getItemCodeFromPath(String indexPath)
			throws IOException, FileNotFoundException {
		FileInputStream ioStream = new FileInputStream(indexPath);

		StringBuffer bufferString = new StringBuffer();
		Reader reader = new InputStreamReader(ioStream);
		int character;
		while ((character = reader.read()) != -1) {
			bufferString.append((char) character);
		}
		return bufferString.toString();
	}

	private static Hashtable<String, String> getHashHostsFromString(String hosts){
		String[] hostList = hosts.split("\\|");
		Hashtable<String, String> res = new Hashtable<String, String>();
		for (int i = 0; i < hostList.length; i++) {
			hostList[i] = hostList[i].trim();
			if(hostList[i].length()<1)
				continue;
			String[] sp = hostList[i].split(","); 
			String hostStr = sp[0].trim();
			String nameStr = (sp.length>1)?sp[1].trim():("Unnamed "+i);
			res.put(hostStr, nameStr);
		}
		
		return res;
	}
}