/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package org.cnice.lms.client.admin;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import org.cnice.lms.common.*;
import org.cnice.lms.client.*;

public class ActivitiesInfoFrame extends Frame implements WindowListener,
	ItemListener,ActionListener {

	private ActivitiesPanel AP;
	private java.awt.List list,lst,lst_t_t_events,lst_t_events;
	private TextField tf_time,tf_score,
		tf_t_time,tf_t_scoreIni,tf_t_scoreEnd,tf_t_scoreAv;
	private TextArea ta_value;
	private Choice ch_score;
	private Label lb_title;
	private Vector events,programs;
	Hashtable t_events;
	private SqlResult values;
	private int activeAct;

	public ActivitiesInfoFrame(ActivitiesPanel AP) {
		this.AP=AP;
		setTitle("Detalles de las actividades seleccionadas");
		setBackground(Color.lightGray);
		addWindowListener(this);
		GridBagConstraints gbc=new GridBagConstraints();
		gbc.insets=new Insets(2,2,2,2);
		gbc.fill  =GridBagConstraints.BOTH;

		ScrollPane nsp=new ScrollPane();
		Panel NP=new Panel();
		nsp.add(NP);
		NP.setLayout(new GridBagLayout());
		gbc.gridheight=1; gbc.gridy=0;
		gbc.gridx=0;
		gbc.weightx=0;
		gbc.gridwidth=6;
		Label auxlb=new Label("Totales");
		auxlb.setAlignment(Label.CENTER);
		NP.add(auxlb,gbc);
		gbc.gridy++;
		gbc.gridx=0;
		gbc.gridwidth=1;
		NP.add(new Label("Tiempo (seg)"),gbc); gbc.gridx+=gbc.gridwidth;
		NP.add(tf_t_time=new TextField(3),gbc);
		gbc.gridy++; gbc.gridx=0;
		gbc.gridwidth=2;
		auxlb=new Label("Puntuacin (%)");
		auxlb.setAlignment(Label.CENTER);
		NP.add(auxlb,gbc); gbc.gridx+=gbc.gridwidth;
		gbc.gridwidth=1;
		gbc.gridy++; gbc.gridx=0;
		NP.add(new Label("promedio"),gbc); gbc.gridx+=gbc.gridwidth;
		NP.add(tf_t_scoreAv=new TextField(3),gbc); gbc.gridx+=gbc.gridwidth;
		gbc.gridy++; gbc.gridx=0;
		NP.add(new Label("primero"),gbc); gbc.gridx+=gbc.gridwidth;
		NP.add(tf_t_scoreIni=new TextField(3),gbc); gbc.gridx+=gbc.gridwidth;
		gbc.gridy++; gbc.gridx=0;
		NP.add(new Label("ltimo"),gbc); gbc.gridx+=gbc.gridwidth;
		NP.add(tf_t_scoreEnd=new TextField(3),gbc); gbc.gridx+=gbc.gridwidth;
		gbc.gridy++;
		gbc.gridwidth=4; gbc.gridheight=gbc.gridy-2;
		gbc.gridy=2; gbc.gridx=2;
		lst_t_t_events=new java.awt.List(7);
		NP.add(lst_t_t_events,gbc);
		gbc.gridheight=1;
		gbc.gridy=1; gbc.gridx=2;
		auxlb=new Label("Eventos especiales");
		auxlb.setAlignment(Label.CENTER);
		NP.add(auxlb,gbc);

		ScrollPane ssp=new ScrollPane();
		Panel SP=new Panel();
		ssp.add(SP);
		SP.setLayout(new GridBagLayout());
		gbc.gridwidth=1; gbc.gridheight=1;
		gbc.gridy=0; gbc.gridx=0;
		gbc.gridwidth=7;
		SP.add(auxlb=new Label("Actividad seleccionada"),gbc); gbc.gridx+=gbc.gridwidth;
		auxlb.setAlignment(Label.CENTER);
		gbc.gridy++; gbc.gridx=0;
		SP.add(lb_title=new Label(),gbc); gbc.gridx+=gbc.gridwidth;
		lb_title.setAlignment(Label.CENTER);
		gbc.gridy++; gbc.gridx=0;
		gbc.gridwidth=1;
		SP.add(new Label("Tiempo (seg)"),gbc); gbc.gridx+=gbc.gridwidth;
		SP.add(tf_time=new TextField(3),gbc);
		gbc.gridy++; gbc.gridx=0;
		gbc.gridwidth=2;
		auxlb=new Label("Puntuacin (%)");
		auxlb.setAlignment(Label.CENTER);
		SP.add(auxlb,gbc); gbc.gridx+=gbc.gridwidth;
		gbc.gridy++; gbc.gridx=0;
		gbc.gridwidth=1;
		SP.add(new Label("promedio"),gbc); gbc.gridx+=gbc.gridwidth;
		SP.add(tf_score=new TextField(3),gbc);  gbc.gridx+=gbc.gridwidth;
		gbc.gridy++; gbc.gridx=0;
		SP.add(new Label("todas"),gbc); gbc.gridx+=gbc.gridwidth;
		ch_score=new Choice();
		SP.add(ch_score,gbc);
		gbc.gridy++;
		gbc.gridwidth=4; gbc.gridheight=gbc.gridy-3;
		int oldy=gbc.gridy;
		gbc.gridy=3; gbc.gridx=2;
		lst_t_events=new java.awt.List(7);
		SP.add(lst_t_events,gbc);
		gbc.gridheight=1;
		gbc.gridy=2; gbc.gridx=2;
		auxlb=new Label("Eventos especiales");
		auxlb.setAlignment(Label.CENTER);
		SP.add(auxlb,gbc);
		gbc.gridy=oldy;
//		ScrollPane csp=new ScrollPane();
//		Panel CP=new Panel();
//		csp.add(CP);
//		CP.setLayout(new GridBagLayout());
		gbc.gridheight=1; gbc.gridy++;
		gbc.gridx=0;
		gbc.weightx=0;
		gbc.gridwidth=7;
		auxlb=new Label("Todos los eventos");
		auxlb.setAlignment(Label.CENTER);
		SP.add(auxlb,gbc);
		gbc.gridy++;
		gbc.gridx=0;
		lst=new java.awt.List(4);
		SP.add(lst,gbc);
		gbc.gridy++; gbc.gridx=0;
		ta_value=new TextArea(3,30);
		SP.add(ta_value,gbc); gbc.gridx+=gbc.gridwidth;

		Panel P=new Panel();
		P.setLayout(new GridBagLayout());
		gbc.gridheight=1; gbc.gridy=0;
		gbc.gridx=0;
		gbc.gridwidth=1;
		gbc.weightx=1; gbc.weighty=0.22;
		P.add(nsp,gbc);
		gbc.gridy++; gbc.gridx=0;
		gbc.gridheight=2;
		gbc.weightx=1; gbc.weighty=0.78;
		P.add(ssp,gbc);
//		gbc.gridy++; gbc.gridx=0;
//		gbc.weightx=1; gbc.weighty=0.33;
//		P.add(csp,gbc);

		setLayout(new GridLayout(1,2));
		add(list=new java.awt.List());
		list.setFont(util.Monospaced);
		list.setBackground(AdminPanel.veryLightGray);
		add(P);

		tf_time.setEditable(false);
		tf_score.setEditable(false);
		tf_t_time.setEditable(false);
		tf_t_scoreIni.setEditable(false);
		tf_t_scoreEnd.setEditable(false);
		tf_t_scoreAv.setEditable(false);
		ta_value.setEditable(false);
		tf_time.setFont(util.Monospaced);
		tf_score.setFont(util.Monospaced);
		tf_t_time.setFont(util.Monospaced);
		tf_t_scoreIni.setFont(util.Monospaced);
		tf_t_scoreEnd.setFont(util.Monospaced);
		tf_t_scoreAv.setFont(util.Monospaced);
		ta_value.setFont(util.Monospaced);
		ch_score.setFont(util.Monospaced);
		lst.setFont(util.Monospaced);
		lst_t_t_events.setFont(util.Monospaced);
		lst_t_events.setFont(util.Monospaced);
		lst.setBackground(Color.lightGray);
		lst_t_t_events.setBackground(Color.lightGray);
		lst_t_events.setBackground(Color.lightGray);
		addListeners();
		pack();
		setSize(640,600);
		Dimension scrSz=Toolkit.getDefaultToolkit().getScreenSize();
		setLocation((scrSz.width-getSize().width),0);
	}

	private void addListeners() {
		list.addActionListener(this);
		list.addItemListener(this);
		lst.addActionListener(this);
		lst_t_t_events.addActionListener(this);
		lst_t_events.addActionListener(this);
		lst.addItemListener(this);
		lst_t_t_events.addItemListener(this);
		lst_t_events.addItemListener(this);
	}

	private void removeListeners() {
		list.removeActionListener(this);
		list.removeItemListener(this);
		lst.removeActionListener(this);
		lst_t_t_events.removeActionListener(this);
		lst_t_events.removeActionListener(this);
		lst.removeItemListener(this);
		lst_t_t_events.removeItemListener(this);
		lst_t_events.removeItemListener(this);
	}

	private void refresh(String title,int ix) {
		activeAct=ix;
		if (activeAct<0) {
			activeAct=0;
		}
		if (values==null||activeAct>=values.size()) {
			activeAct=-1;
		}
		lb_title.setText(title);
		lst.removeAll();
		lst_t_events.removeAll();
		LMS_Event[] ea=new LMS_Event[0];
		if (activeAct>=0) {
			ea=(LMS_Event[])events.elementAt(activeAct);
			for (int i=0;i<ea.length;i++) {
				String s=justify(ea[i].stime,-3,' ')+" "+
					justify(ea[i].name,20,' ');
				lst.add(s);
			}
		}
		if (values!=null&&activeAct<values.size()) {
			list.select(activeAct);
		}
		ch_score.removeAll();
		Vector v_t_events=new Vector();
		if (activeAct>=0) {
			v_t_events=(Vector)t_events.get((String)programs.elementAt(activeAct));
		}
		if (ea.length>0) {
			lst.select(0);
			tf_time.setText(ea[ea.length-1].stime);
			int scAv=0,nsc=0;
			int[] n_t_events=new int[v_t_events.size()];
			for (int i=0;i<n_t_events.length;i++) {
				n_t_events[i]=0;
			}
			for (int i=0;i<ea.length;i++) {
				String auxvalue=ea[i].value.replace('	',' ');
				auxvalue=auxvalue.replace('\n',' ');
				auxvalue=auxvalue.trim();
				if ("score".equals(ea[i].name)) {
					String auxs=auxvalue;
					ch_score.add(auxs);
					auxs=auxs.replace('%',' ');
					auxs=auxs.trim();
					int sc=0;
					try {
						sc+=Integer.parseInt(auxs);
					} catch (NumberFormatException e) {
					}
					scAv+=sc;
					nsc++;
				}
				for (int j=0;j<v_t_events.size();j++) {
					if (ea[i].name.equals((String)v_t_events.elementAt(j))) {
						n_t_events[j]++;
					}
				}
			}
			for (int j=0;j<v_t_events.size();j++) {
				String s=(String)v_t_events.elementAt(j);
				s=justify(s,10,' ');
				s+=String.valueOf(n_t_events[j]);
				lst_t_events.add(s);
			}
			if (nsc>0) {
				scAv/=nsc;
				tf_score.setText(String.valueOf(scAv));
			} else {
				tf_score.setText("");
			}
		} else {
			tf_time.setText("");
			for (int j=0;j<v_t_events.size();j++) {
				String s=(String)v_t_events.elementAt(j);
				s=justify(s,10,' ');
				lst_t_events.add(s);
			}
			tf_score.setText("");
		}
		refreshValues();
	}

	void setInfo(SqlResult values,String title,int ix) {
		AP.setCursor(new Cursor(Cursor.WAIT_CURSOR));
		removeListeners();
		if (this.values!=values) {
			this.values=values;
			refreshTotals();
		}
		refresh(title,ix);
		addListeners();
		AP.setCursor(null);
	}

	private LMS_Event[] getEvents(String infos) {
		Vector v_info=new Vector();
		if (infos!=null) {
			int i0=0;
			while (true) {
				int ievent=infos.indexOf("<EVENT",i0);
				if (ievent<0) {
					break;
				}
				String sevent="";
				int ieevent=infos.indexOf("</EVENT",ievent);
				int	ieevent2=infos.indexOf("/>",ievent);
				if ((ieevent2>=0)&&(ieevent2<ieevent)) {
					i0=ieevent2+"/>".length();
					sevent=infos.substring(ievent+"<EVENT".length(),i0).trim();
				} else {
					if (ieevent<0) {
						break;
					}
					i0=infos.indexOf(">",ieevent+"</EVENT".length());
					if (i0<0) {
						break;
					}
					sevent=infos.substring(ievent+"<EVENT".length(),ieevent).trim();
				}
				String time="",name="",value="";
				int i=sevent.indexOf("\"");
				if (i<0) {
					break;
				}
				int j=sevent.indexOf("\"",i+1);
				if (j<0) {
					break;
				}
				if (sevent.startsWith("time")) {
					time=sevent.substring(i+1,j);
				} else if (sevent.startsWith("name")) {
					name=sevent.substring(i+1,j);
				}
				sevent=sevent.substring(j+1).trim();
				i=sevent.indexOf("\"");
				if (i<0) {
					break;
				}
				j=sevent.indexOf("\"",i+1);
				if (j<0) {
					break;
				}
				if (sevent.startsWith("time")) {
					time=sevent.substring(i+1,j);
				} else if (sevent.startsWith("name")) {
					name=sevent.substring(i+1,j);
				}
				sevent=sevent.substring(j+1).trim();
				i=sevent.indexOf(">");
				if (i<0) {
					break;
				}
				value=sevent.substring(i+1);
				if (value.startsWith("\n")) {
					value=value.substring(1);
				}
				v_info.addElement(new LMS_Event(time,name,value));
			}
		}
		LMS_Event[] ea=new LMS_Event[v_info.size()];
		for (int i=0;i<v_info.size();i++) {
			ea[i]=(LMS_Event)v_info.elementAt(i);
		}
		return ea;
	}

	private void refreshTotals() {
		list.removeAll();
		for (int n=0;n<values.size();n++) {
			list.add(AP.outputStr(values.valueAt(n)));
		}
		t_events=new Hashtable();
		events=new Vector();
		programs=new Vector();
		Vector prg=new Vector();
		int sct=0,N_t_events=0;
		for (int i=0;i<values.size();i++) {
			SqlValueArray va=values.valueAt(i);
//			String infos=AP.getInfo(va.getString("id"));
			String infos=va.getString("info");
			events.addElement(getEvents(infos));
			String LearningProgram=va.getString("LearningProgram");
			programs.addElement(LearningProgram);
			if (prg.indexOf(LearningProgram)<0) {
				prg.addElement(LearningProgram);
			}
			if (t_events.get(LearningProgram)==null) {
				Vector v=new Vector();
				if (LearningProgram.equals("Malted")) {
					v.addElement("task");
					v.addElement("help");
					v.addElement("solve");
					v.addElement("score");
					v.addElement("audio");
					v.addElement("video");
				} else if (LearningProgram.equals("Descartes")) {
					v.addElement("score");
				} else {
					v.addElement("score");
				}
				t_events.put(LearningProgram,v);
				N_t_events+=v.size();
			}
		}
		LMS_Score sc_t=new LMS_Score(0,0,0);
		long t_t=0;
		int nsc=0;
		int[] n_t_events=new int[N_t_events];
		for (int i=0;i<n_t_events.length;i++) {
			n_t_events[i]=0;
		}
		for (int i=0;i<events.size();i++) {
			LMS_Event[] ea=(LMS_Event[])events.elementAt(i);
			if (ea.length>0) {
				t_t+=ea[ea.length-1].time;
			}
			for (int j=0;j<ea.length;j++) {
				int ne=0;
				for (int k=0;k<prg.size();k++) {
					String LearningProgram=(String)prg.elementAt(k);
					Vector vp=(Vector)t_events.get(LearningProgram);
					for (int n=0;n<vp.size();n++) {
						if (ea[j].name.equals((String)vp.elementAt(n))) {
							n_t_events[ne]++;
						}
						ne++;
					}
				}
			}
			LMS_Score sc=getScore(ea);

			if (sc.scIni>=0) {
				nsc++;
				sc_t.scIni+=sc.scIni;
				sc_t.scEnd+=sc.scEnd;
				sc_t.scAv+=sc.scAv;
			}

		}
//		if (events.size()>0) {
//			t_t/=events.size();
//		}

		if (nsc>0) {
			sc_t.scIni/=nsc;
			sc_t.scEnd/=nsc;
			sc_t.scAv/=nsc;
			tf_t_scoreIni.setText(String.valueOf(sc_t.scIni));
			tf_t_scoreEnd.setText(String.valueOf(sc_t.scEnd));
			tf_t_scoreAv.setText(String.valueOf(sc_t.scAv));
		} else {
			sc_t.scIni=-1;
			sc_t.scEnd=-1;
			sc_t.scAv=-1;
			tf_t_scoreIni.setText("");
			tf_t_scoreEnd.setText("");
			tf_t_scoreAv.setText("");
		}

		tf_t_time.setText(String.valueOf(t_t));
		lst_t_t_events.removeAll();
		int ne=0;
		Vector t_e_put=new Vector();
		for (int k=0;k<prg.size();k++) {
			Vector v_t_events=(Vector)t_events.get((String)prg.elementAt(k));
			for (int n=0;n<v_t_events.size();n++) {
				String s=(String)v_t_events.elementAt(n);
				if (t_e_put.indexOf(s)<0) {
					t_e_put.addElement(s);
					s=justify(s,10,' ');
					s+=String.valueOf(n_t_events[ne]);
					lst_t_t_events.add(s);
				}
				ne++;
			}
		}
	}

	private LMS_Score getScore(LMS_Event[] ea) {
		int scIni=-1,scEnd=-1,scAv=-1;
		int nsc=0;
		for (int i=0;i<ea.length;i++) {
			if ("score".equals(ea[i].name)) {
				String auxs=ea[i].value.replace('	',' ');
				auxs=auxs.replace('\n',' ');
				auxs=auxs.replace('%',' ');
				auxs=auxs.trim();
				int sc=0;
				try {
					sc+=Double.parseDouble(auxs);
				} catch (NumberFormatException e) {
				}
				if (scIni==-1) {
					scIni=sc;
				}
				scEnd=sc;
				scAv+=sc;
				nsc++;
			}
		}
		if (nsc>0) {
			scAv/=nsc;
		}
		return new LMS_Score(scIni,scEnd,scAv);
	}

	private void refreshValues() {
		int ix=lst.getSelectedIndex();
		if (activeAct>=0&&ix>=0) {
			LMS_Event[] ea=(LMS_Event[])events.elementAt(activeAct);
			ta_value.setText(ea[ix].value.replace('	',' ').trim());
		} else {
			ta_value.setText("");
		}
	}

	public static String trim(String s,char ch) {
		if (s==null||s.length()==0) {
			return s;
		}
		int i1=0;
		while (s.charAt(i1)==ch) {
			i1++;
			if (i1>=s.length()) {
				return "";
			}
		}
		int i2=s.length()-1;
		while (s.charAt(i2)==ch) {
			i2--;
		}
		return s.substring(i1,i2+1);
	}

	public static String justify(String s,int j,char ch) {
		StringBuffer sb=new StringBuffer(s);
		if (j>0) {
			while (sb.length()<j) {
				sb.append(ch);
			}
		} else {
			while (sb.length()<-j) {
				sb.insert(0,ch);
			}
		}
		String auxs=new String(sb);
		if (j>0) {
			if (auxs.length()>j) {
				auxs=auxs.substring(0,j);
			}
		} else {
			if (auxs.length()>-j) {
				auxs=auxs.substring(auxs.length()+j);
			}
		}
		return auxs;
	}

	public void itemStateChanged(ItemEvent e) {
		if (e.getStateChange()==e.SELECTED) {
			if (e.getSource()==list) {
				refresh(list.getSelectedItem(),list.getSelectedIndex());
			} else if (e.getSource()==lst) {
				refreshValues();
			}
		}
	}

	public void actionPerformed(ActionEvent e){
		if (e.getSource()==list) {
			SqlValueArray va=values.valueAt(activeAct);
			String infos=va.getString("info");
			if (infos.length()>0) {
				util.showMessage(lb_title.getText(),infos,35,108);
			}
		} else if (e.getSource()==lst) {
			refreshValues();
		}
	}

/* ------------------- WindowListener ---------------- */

	public void windowClosing(WindowEvent e){
		setVisible(false);
	}
    public void windowOpened(WindowEvent e){}
    public void windowActivated(WindowEvent e){}
    public void windowDeactivated(WindowEvent e){}
    public void windowIconified(WindowEvent e){}
    public void windowDeiconified(WindowEvent e){}
    public void windowClosed(WindowEvent e){}

}

class LMS_Event {
	String stime,name,value;
	long time;
	LMS_Event(String stime,String name,String value) {
		this.stime=stime;
		try {
			time=Long.parseLong(stime);
		} catch (NumberFormatException e) {
			time=0;
		}
		this.name=name;
		this.value=value;
	}
}

class LMS_Score {
	long scIni,scEnd,scAv;
	LMS_Score(long scIni,long scEnd,long scAv) {
		this.scIni=scIni;
		this.scEnd=scEnd;
		this.scAv=scAv;
	}
}