/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package org.cnice.lms.client.admin;

import java.awt.*;
import java.awt.event.*;

import org.cnice.lms.common.*;
import org.cnice.lms.client.*;

public class ActivitiesPanel extends AdminPanel {
	
	private TextField tf_location,tf_desde,tf_hasta;
	private AdminChoice ch_course,ch_learner,ch_tutor;
	private Choice ch_program,ch_unit,ch_exercise;
	private Checkbox chbx_all,chbx_finished,chbx_unfinished;
	private Button b_detalles;
	private static final int lrn=0,tut=1,course=2,unit=3,exrc=4,loc=5,prg=6,frm=7,to=8,comp=9,incomp=10,all=11;
	private static final String[][] names={
		{"Learner","Tutor","Course","Unit","Exercise","Location","Program","From","To","Complete","Incomplete","All"},
		{"Alumno","Tutor","Curso","Unidad","Ejercicio","Localizacin","Programa","Desde","Hasta","Completas","Incompletas","Todas"}
	};
	private static ActivitiesInfoFrame frame_info;

	public ActivitiesPanel(AdminClient client,AdminTool tool) {
		super(client,tool);
		SEP.add(b_detalles=new Button("detalles"));
		b_detalles.addActionListener(this);
		int line=0;
		add(new Label(names[util.Lang][lrn]),line,0,1,2,12);
		add(ch_learner=new AdminChoice(),line,1,3,2,12);
		ch_learner.addItemListener(this);
		client.getUsers(AdminClient.learner,ch_learner);
		line++;
		add(new Label(names[util.Lang][course]),line,0,1,2,12);
		add(ch_course=new AdminChoice(),line,1,3,2,12);
		ch_course.addItemListener(this);
		client.getCourses(ch_course);
		line++;
		add(new Label(names[util.Lang][unit]),line,0,1,2,12);
		add(ch_unit=new Choice(),line,1,3,2,12);
		ch_unit.addItem("");
		ch_unit.addItemListener(this);
		line++;
		add(new Label(names[util.Lang][exrc]),line,0,1,2,12);
		add(ch_exercise=new Choice(),line,1,3,2,12);
		ch_exercise.addItem("");
		ch_exercise.addItemListener(this);
		line++;
		add(new Label(names[util.Lang][loc]),line,0,1,2,12);
		add(tf_location=new TextField(25),line,1,3,2,12);
		tf_location.setFont(util.SansSerif);
		line++;
		add(new Label(names[util.Lang][tut]),line,0,1,2,12);
		add(ch_tutor=new AdminChoice(),line,1,3,2,12);
		client.getUsers(AdminClient.tutor,ch_tutor);
		line++;
		add(new Label(names[util.Lang][prg]),line,1,1,2,12);
		add(ch_program=new Choice(),line,2,2,2,12);
		getLearningPrograms();
		line++;
		add(new Label(names[util.Lang][frm]),line,1,1,2,12); 
		add(tf_desde=new TextField(18),line,2,1,2,12);
		line++;
		add(new Label(names[util.Lang][to]),line,1,1,2,12); 
		add(tf_hasta=new TextField(18),line,2,1,2,12);
		line++;
		CheckboxGroup chbg=new CheckboxGroup();
		add(chbx_finished=new Checkbox(names[util.Lang][comp],true,chbg),line,0,1,2,12); 
		add(chbx_unfinished=new Checkbox(names[util.Lang][incomp],false,chbg),line,1,1,2,12); 
		add(chbx_all=new Checkbox(names[util.Lang][all],false,chbg),line,2,1,2,12); 
		
		frame_info=new ActivitiesInfoFrame(this);

		b_i.setEnabled(false);
		b_u.setEnabled(false);
		b_d.setEnabled(false);
		if (client.getUserType().equals(AdminClient.userTypeNames[0][AdminClient.tutor])) {
			ch_tutor.selectById(client.getUserID());
			ch_tutor.setEnabled(false);
		} else if (client.getUserType().equals(AdminClient.userTypeNames[0][AdminClient.learner])) {
			ch_learner.selectById(client.getUserID());
			ch_learner.setEnabled(false);
		}
		clear();
	}

	public void refreshUsers() {
		client.getUsers(AdminClient.learner,ch_learner);
		client.getUsers(AdminClient.tutor,ch_tutor);
	}
	
	public void setFromLearners(String userid,String courseid,String tutor_userid) {
		clear();
		selectLearnerById(userid);
		selectCourseById(courseid);
		selectTutorById(tutor_userid);
		// limpiar ventana y ensear el nuevo
		actionPerformed(new ActionEvent(b_cl,ActionEvent.ACTION_PERFORMED,""));
		actionPerformed(new ActionEvent(b_q,ActionEvent.ACTION_PERFORMED,""));
	}
	
	void refresh(SqlValueArray va0) {
		getValues(va0.getString("id"));
		showDetalles(false);
	}
	
	private void showDetalles(boolean doShow) {
		if (doShow||frame_info.isVisible()) {
			frame_info.setInfo(values,getSelectedItem(),getSelectedIndex());
			frame_info.show();
		}
	}
	
	void getValues(String ID) {
		SqlResult values=null;
		lb_ID.setText(ID);
		if (ID!=null&&ID.length()>0) {
			try {
				String query="select distinct";
				query+=" LearningProgram,courses.id as courseid,unit,exercise,location,users.id as userid from activities,courses,users";
				query+=" where activities.id='"+ID+"'";
				query+=" and courses.id=activities.courseid and users.id=activities.userid";
				values=client.executeQuery(query);
				if (values!=null && values.size()>0) {
					SqlValueArray va=values.valueAt(0);
					selectLearnerById(va.getString("userid"));
					selectCourseById(va.getString("courseid"));
					selectUnit(va.getString("unit"));
					ch_exercise.select(va.getString("exercise"));
					tf_location.setText(va.getString("location"));
					ch_program.select(va.getString("LearningProgram"));
				}
			} catch (Exception e) {
				System.out.println(e.getMessage());
			}
		}
	}
	
	String getInfo(String ID) {
		if (ID!=null&&ID.length()>0) {
			try {
				String query="select info from activities where id='"+ID+"'";
				SqlResult values=client.executeQuery(query);
				if (values!=null && values.size()>0) {
					SqlValueArray va=values.valueAt(0);
					return va.getString("info");
				}
			} catch (Exception e) {
				System.out.println(e.getMessage());
			}
		}
		return "";
	}

	private String learnerid,tutorid,courseid;
	
	void selectLearnerById(String id) {
		if (ch_learner.isEnabled()) {
			ch_learner.selectById(id);
			if (!id.equals(learnerid)) {
				selectTutorById(findTutorId());
				learnerid=id;
			}
		}
	}

	void selectTutorById(String id) {
		if (ch_tutor.isEnabled()) {
			ch_tutor.selectById(id);
			if (!id.equals(tutorid)) {
				tutorid=id;
			}
		}
	}

	void selectCourseById(String id) {
		ch_course.selectById(id);
		if (!id.equals(courseid)) {
			getUnits(id);
			getExercises(id,ch_unit.getSelectedItem());
			selectTutorById(findTutorId());
			courseid=id;
		}
	}
	
	void selectUnit(String unitName) {
		ch_unit.select(unitName);
		getExercises(ch_course.getSelectedId(),ch_unit.getSelectedItem());
	}
	
	void clear() {	
		lb_ID.setText("");
		tf_desde.setText("2002-11-01 00:00:00");
		String s=SqlMetadata.getDateTimeString();
		tf_hasta.setText(s.substring(0,s.indexOf(" "))+" 23:59:59");
		selectCourseById("");
		tf_location.setText("");		
		if (client.getUserType().equals(AdminClient.userTypeNames[util.Lang][AdminClient.learner])) {
			selectLearnerById(client.getUserID());
			ch_learner.setEnabled(false);
		} else {
//			if (client.getUserType().equals(AdminClient.userTypeNames[util.Lang][AdminClient.learner])) {
//				ch_tutor.selectById("");
//			} else if (client.getUserType().equals(AdminClient.userTypeNames[util.Lang][AdminClient.tutor])) {
//				ch_learner.selectById("");
//			} else if (client.getUserType().equals(AdminClient.userTypeNames[util.Lang][AdminClient.admin])) {
//				ch_tutor.selectById("");
//				ch_learner.selectById("");
//			}
			selectTutorById("");
			selectLearnerById("");
		}
		getLearningPrograms();
		chbx_finished.setState(true);
	}
	
	String outputStr(SqlValueArray va) {
		return va.getString("date")+" "+va.getString("exercise");
	}
	
	String QueryStr() {
		String query="select distinct activities.id,activities.date,activities.exercise,activities.LearningProgram,activities.info from activities,users,courses,learners where activities.userid=users.id";
		if (ch_learner.getSelectedId().length()>0) {
			query+=" and users.id="+ch_learner.getSelectedId();
		}
		if (ch_program.getSelectedItem().length()>0) {
			query+=" and activities.LearningProgram like '"+util.getInfo(ch_program)+"'";
		}
		if (ch_course.getSelectedId().length()>0) {
			query+=" and courses.id=activities.courseid and courses.id="+ch_course.getSelectedId();
		}
		if (ch_unit.getSelectedItem().length()>0) {
			query+=" and activities.unit like '"+util.getInfo(ch_unit)+"'";
		}
		if (ch_exercise.getSelectedItem().length()>0) {
			query+=" and activities.exercise like '"+util.getInfo(ch_exercise)+"'";
		}
		if (tf_location.getText().length()>0) {
			query+=" and location like '"+util.getInfo(tf_location)+"'";
		}
		if (ch_tutor.getSelectedId().length()>0) {
			query+=" and learners.tutor_userid="+ch_tutor.getSelectedId()+" and learners.userid=activities.userid and learners.courseid=activities.courseid";
		}
		if (tf_desde.getText().length()>0) {
			query+=" and date>='"+tf_desde.getText()+"'";
		}
		if (tf_hasta.getText().length()>0) {
			query+=" and date<='"+tf_hasta.getText()+"'";
		}
		if (chbx_finished.getState()) {
			query+=" and state='1'";
		} else if (chbx_unfinished.getState()) {
			query+=" and state='0'";
		}
		query+=" order by activities.id";
		return query;
	}
	
	String InsertStr() { return ""; }
	String UpdateStr() { return ""; }
	String DeleteStr() { return ""; }
	
	public void itemStateChanged(ItemEvent e) {
		super.itemStateChanged(e);
		if (e.getStateChange()==e.SELECTED) {
			if (e.getSource()==ch_learner) {
				selectLearnerById(ch_learner.getSelectedId());
			} else if (e.getSource()==ch_course) {
				selectCourseById(ch_course.getSelectedId());
			} else if (e.getSource()==ch_unit) {
				selectUnit(ch_unit.getSelectedItem());
			}
		}
	}
	
	public void actionPerformed(ActionEvent e){
		super.actionPerformed(e);
		if (e.getSource()==list) {
			String LearningProgram=ch_program.getSelectedItem();
			String location=tf_location.getText();
			if ("Malted".equals(LearningProgram)) {
				showScene(LearningProgram,location);
			}
		}
		if (e.getSource()==b_detalles) {
			showDetalles(true);
		} else if (e.getSource()==b_q) {
			showDetalles(false);
		}
	}
	
	public void showScene(String LearningProgram, String location) {
//		try {
//			RTS rts=new RTS(null,location,false,false);
//			MA.init();
//			MA.setSize(480,360);
//			MA.start();
//			LMSFrame F=new LMSFrame(LearningProgram+": "+location,MA);
//			Dimension scsz=Toolkit.getDefaultToolkit().getScreenSize();
//			Point p=getLocationOnScreen();
//			int xf=Math.max(0,p.x+(getSize().width-F.getSize().width)/2);
//			int yf=Math.max(0,p.y+(getSize().height-F.getSize().height)/2);
//			xf=Math.min(xf,scsz.width-F.getSize().width);
//			yf=Math.min(yf,scsz.height-F.getSize().height);
//			F.setLocation(-10000,yf);
//			Dimension d=MA.getSize();
//			F.show();
//			if (MA.getSize().height>d.height) { // El j2re 1.4 aqu aumenta el tamao en 2 pixels de ancho y seis de alto ????
//				F.setSize(F.getSize().width-2,F.getSize().height-6);
//				MA.setSize(d);
//			}
//			F.setLocation(xf,yf);
//			MA.start();
//			
//		} catch (Exception e) {
//			e.printStackTrace();
//		}
	}
	
/* ------------------------- get info from DB ---------------------- */	

	private String findTutorId() {
		String tutorid="";
		if (ch_learner.getSelectedId().length()>0&&ch_course.getSelectedId().length()>0) {
			String learnerid=ch_learner.getSelectedId();
			String courseid=ch_course.getSelectedId();
			String query="select distinct users.id as tutorid from users,learners where learners.userid='"+learnerid+"' and learners.courseid='"+courseid+"' and users.id=learners.tutor_userid";;
			try {
				SqlResult values = client.executeQuery(query);													
				if (values!=null&&values.size()>0) {
					SqlValueArray va=values.valueAt(0);
					tutorid=va.getString("tutorid");
				}
			} catch (Exception e) {
				System.out.println(e.getMessage());
			}
		}
		return tutorid;
	}

	private void getUnits(String courseid) {
		ch_unit.removeItemListener(this);
		ch_unit.removeAll();
		ch_unit.add("");
		if (courseid.length()>0) {
			String query="select distinct activities.unit from activities,courses where courses.id="+courseid+" and activities.courseid=courses.id order by name";
			try {
				SqlResult values = client.executeQuery(query);													
				if (values!=null) {
					for (int n=0;n<values.size();n++) {
						SqlValueArray va=values.valueAt(n);
						ch_unit.addItem(va.getString("unit"));
					}
				}
			} catch (Exception e) {
				System.out.println(e.getMessage());
			}
		}
		ch_unit.addItemListener(this);
	}

	private void getExercises(String courseid,String unit) {
		ch_exercise.removeItemListener(this);
		ch_exercise.removeAll();
		ch_exercise.add("");
		if (courseid.length()>0) {
			String s_unit="%";
			if (unit.length()>0) {
				s_unit=unit;
			}
			String query="select distinct activities.exercise from activities,courses where activities.unit like '"+s_unit+"'";
			query+=" and courses.id="+courseid+" and activities.courseid=courses.id";
			query+=" order by name";
			try {
				SqlResult values = client.executeQuery(query);													
				if (values!=null) {
					for (int n=0;n<values.size();n++) {
						SqlValueArray va=values.valueAt(n);
						ch_exercise.addItem(va.getString("exercise"));
					}
				}
			} catch (Exception e) {
				System.out.println(e.getMessage());
			}
		}
		ch_exercise.addItemListener(this);
	}

	private void getLearningPrograms() {
		ch_program.removeAll();
		ch_program.add("");
		String query="select distinct LearningProgram from activities order by LearningProgram";
		try {
			SqlResult values = client.executeQuery(query);													
			if (values!=null) {
				for (int n=0;n<values.size();n++) {
					SqlValueArray va=values.valueAt(n);
					ch_program.addItem(va.getString("LearningProgram"));
				}
			}
		} catch (Exception e) {
			System.out.println(e.getMessage());
		}
	}
	
}

class LMSFrame extends Frame implements WindowListener {
	
//	private Descartes D;
	
	LMSFrame(String name,Panel mainP) {
//		this.D=D;
		setTitle(name);
		setBackground(Color.lightGray);
		addWindowListener(this);
		setLayout(new GridLayout(1,1));
		add(mainP);
		pack();
		setResizable(false);
		Dimension ScrSz=Toolkit.getDefaultToolkit().getScreenSize();
		setLocation((ScrSz.width-getSize().width)/2,(ScrSz.height-getSize().height)/2);
	}

	public void windowClosing(WindowEvent e){
		setVisible(false);
//		if (D.father!=null) {
//			Applet father=D.father;
//			D.stop();
//			D.destroy();
//			dispose();
//			// prueba del 030917
//			Graphics g=father.getGraphics();
//			father.paintAll(g); 
//		}
	}
    public void windowOpened(WindowEvent e){}
    public void windowActivated(WindowEvent e){}
    public void windowDeactivated(WindowEvent e){}
    public void windowIconified(WindowEvent e){
	}
    public void windowDeiconified(WindowEvent e){
	}
    public void windowClosed(WindowEvent e){}

}