/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package org.cnice.lms.common;

import java.io.Serializable;
import java.sql.Types;

public class SqlValueArray implements Serializable {
	
	private SqlMetadata[] metadata;
	private SqlValue[] values;
	
	public SqlValueArray(SqlMetadata[] metadata,SqlValue[] values) {
		if (metadata!=null) {
			this.metadata=metadata;
		} else {
			this.metadata=new SqlMetadata[0];
		}
		if (values!=null) {
			this.values=values;
		} else {
			this.values=new SqlValue[0];
		}
		if (this.values.length!=this.metadata.length) {
			this.metadata=new SqlMetadata[0];
			this.values=new SqlValue[0];
		}
	}
	
	public int getValueCount() {
		return values.length;
	}
	
	public SqlMetadata getMetadata(int i) {
		if (i<metadata.length) {
			return metadata[i];
		}
		return null;
	}
	
	public SqlMetadata[] getMetadata() {
		return metadata;
	}
	
	public SqlValue getValue(int i) {
		if (i<values.length) {
			return values[i];
		}
		return null;
	}
	
	public SqlValue[] getValues() {
		return values;
	}
	
	public int getInt(int columnIndex) {
		return values[columnIndex].getInt();
	}
	
	public byte[] getBytes(int columnIndex) {
		return values[columnIndex].getBytes();
	}
	
	public String getString(int columnIndex) {
		return values[columnIndex].getString();
	}
	
	public int getValueIndex(String columnName) {
		for (int i=0;i<metadata.length;i++) {
			if (metadata[i].getName().equals(columnName)) {
				return i;
			}			
		}
		return metadata.length;
	}
	
	public int getInt(String columnName) {
		return getInt(getValueIndex(columnName));
	}
	
	public byte[] getBytes(String columnName) {
		return getBytes(getValueIndex(columnName));
	}
	
	public String getString(String columnName) {
		return getString(getValueIndex(columnName));
	}
}