/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package org.cnice.rad.client;
/*
 * @(#)ClientDialog.java
 */

/**
 * @version	1.0  Ene 2007
 * @administrator: Jose-Luis Abreu
 */

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

import org.cnice.rad.common.*;

public class ClientDialog {
	
	public String id_sesion_equipo;
	private String[] alumnos;

	private Client client;
	
	public String[] getAlumnos() {
		return alumnos;
	}

	public ClientDialog(Client client) {
		this.client=client;
	}

	public void setClient(Client cl) {
		this.client=cl;
	}

	/** Prompts the user for his/her user_login and password.
	  * Returns: the user_login if the user entered a valid combination, and returns null otherwise.
	  * Works only when isConnected() returns true.
	  */
	public synchronized String[] getUserLogin(int type) {
		String user_login=null;
		String user_password=null;
		if (client.isConnected()) {
			int times=0;
		    while (true&&times<3) {
				String login=util.getInfo(util.NormalText,"RAD usuario",util.names[util.usr],"");
			    if (login!=null&&login.length()>0) {
					String password=util.getInfo(util.PasswordText,"RAD contrasea",util.names[util.pwd],"");
					if (password!=null) {
						boolean ok=false;
						try{
							ok=client.userAllowed(login,password);
							if (ok&&type>=0&&!Client.userTypeNames[type].equals(client.getUserType())) {
								ok=false;
								System.out.println(client.getUserType()+" no es "+Client.userTypeNames[type]);
							}
						} catch(Exception ex){
							ok=false;
					    	System.out.println(ex);
						}
						if (ok) {
							user_login=login;
							user_password=password;
							break;
						} else {
							System.out.println("Error: identificacin invlida");
						}
					} else {
						break;
					}
				} else {
					break;
				}
				times++;
				if (times>=3) {
					System.out.println("No se permiten ms intentos");
				}
			}
			if (user_login!=null&&user_login.length()>0) {
				client.setUser(user_login,user_password);
			}
		}
		if (user_login!=null&&user_login.length()>0) {
			return new String[]{user_login,user_password};
		} else {
			return null;
		}
	}

	public synchronized String getGrupo(String login,String password) {
		String grupo=null;
		if (client.isConnected()) {
			int times=0;
		    while (true&&times<3) {
				grupo=util.getInfo(util.NormalText,"RAD grupo","grupo","");
				boolean ok=false;
				try{
					ok=client.grupoCorrecto(login,password,grupo);
				} catch(Exception ex){
					ok=false;
			    	System.out.println(ex);
				}
				if (ok) {
					break;
				} else {
					grupo=null;
					System.out.println("Error: grupo desconocido");
				}
				times++;
				if (times>=3) {
					System.out.println("No se permiten ms intentos");
				}
			}
		}
		return grupo;
	}

/*
 *
Cal que demani els usuaris....

Demana un usuari, cal que sigui alumne d'un grup amb sessi de grup oberta. 
Si s correcte l'ensenya a la llista, es crea sessi equip i sessio alumne 
i segueix demanant per ara calq ue siguin alumnes del mateix grup. 
Fins que es deixa usuari buit.

Retorna la sessi d'equip
 */	
	public synchronized boolean getSesionEquipo() {
		this.id_sesion_equipo=null;
		getSessionDialog gsd=new getSessionDialog(client);
		gsd.show();
		this.id_sesion_equipo=gsd.getIdSesionEquipo();
		this.alumnos=gsd.getUsers();
		gsd.dispose();
		return this.id_sesion_equipo!=null;
	}
}

class getSessionDialog extends Dialog implements ActionListener {

	private TextField tf_login,tf_password;
	private Button b_registrar, b_terminar;
	private List lst;
	private Label lb_grupo;
	
	private Client client;
	
	private String grupo,id_grupo,id_sesion_grupo;
	private Vector v_alumnos;
	private String[] info;
	
	String getIdSesionEquipo() {
		return info[0];
	}

	getSessionDialog(Client _client) {
		super(new Frame());
		this.client=_client;
		setBackground(Color.lightGray);
		setFont(util.SansSerif);
		setModal(true);
		setTitle("Sesin de equipo ");
		setLayout(new BorderLayout());
		lst=new List(8);
		lb_grupo=new Label(" Grupo:");
		Panel np=new Panel();
//		np.setLayout(new GridLayout(2,1,15,15));
		np.setLayout(new BorderLayout());
		np.add("North",lb_grupo);
		np.add("Center",lst);
		add("North",np);
		
		b_registrar=new Button("registrar");
		b_terminar=new Button("terminar");
		b_registrar.addActionListener(this);
		b_terminar.addActionListener(this);
		
		tf_login = new TextField(12);
		tf_login.setFont(util.Monospaced);
		tf_login.addActionListener(this);
		tf_password = new TextField(12);
		tf_password.setFont(util.Monospaced);
		tf_password.setEchoChar('*');
		tf_password.addActionListener(this);
		
		Panel sp=new Panel();
		sp.setLayout(new GridLayout(2,1));

		Panel p_login=new Panel();
		p_login.setLayout(new FlowLayout(FlowLayout.LEFT,4,4));
		p_login.add(new Label("usuario"));
		p_login.add(tf_login);
		p_login.add(new Label("contrasea"));
		p_login.add(tf_password);
		Panel p_buttons=new Panel();
		p_buttons.setLayout(new FlowLayout(FlowLayout.CENTER,20,4));
		p_buttons.add(b_registrar);
		p_buttons.add(b_terminar);
		sp.add(p_login);
		sp.add(p_buttons);
		
		add("South",sp);
		pack();
		Dimension d=getSize();
		Dimension sz=Toolkit.getDefaultToolkit().getScreenSize();
		setLocation((sz.width-d.width)/2,(sz.height-d.height)/2);
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==b_registrar||e.getSource()==tf_password) {
			registrarAlumno();			
			tf_password.setText("");
			tf_login.setText("");
			tf_login.requestFocus();
		} else if (e.getSource()==tf_login) {
			if (tf_login.getText().length()>0) {
				tf_password.requestFocus();
			} else {
				registrarSesionEquipo();
				setVisible(false);
			}
		} else if (e.getSource()==b_terminar) {
			registrarSesionEquipo();
			setVisible(false);
		}
	}
	/*
	 * El primer cal verificar que sigui alumne i que tingui sessi de grup oberta
	 * llavors ja es pot crear sessi d'equip o fer-ho al final???
	 * El altres han de ser alumnes del mateix grup
	 */
	private void registrarAlumno() {
		String title="Registrar alumno";
		boolean ok=false;
		try{
			ok=client.userAllowed(tf_login.getText(),tf_password.getText());
			if (ok&&!Client.userTypeNames[Client.learner].equals(client.getUserType())) {
				ok=false;
				util.showMessage(title,client.getUserType()+" no es "+Client.userTypeNames[Client.learner]);
			}
			if (ok) {
				client.setUser(tf_login.getText(),tf_password.getText());
				if (v_alumnos==null) {
					ok=false;
//System.out.println("abans executeSesionGrupo ");
					SqlResult values=client.executeSesionGrupo(
						client.getUserLogin(),
						client.getUserPassword(),
						client.getUserGroupID());
//System.out.println("executeSesionGrupo "+values);
					if (values!=null && values.size()>0) {
						for (int i=0;i<values.size();i++) {
							SqlValueArray va=values.valueAt(i);
//System.out.println(i+" "+va.getString("nombre_grupo")+" estado="+va.getInt("estado"));
							if (va.getInt("estado")==0) {
								ok=true;
								id_sesion_grupo=va.getString("id");
								id_grupo=va.getString("id_grupo");
								grupo=va.getString("nombre_grupo");
								lb_grupo.setText(" Grupo: "+grupo);
								v_alumnos=new Vector();
								v_alumnos.add(client.getUserID());
								break;
							}
						}
				 	}
					if (!ok) {
				    	util.showMessage(title,"No hay sesin de grupo abierta");
					}
				} else if (v_alumnos.indexOf(client.getUserID())>=0) {
					ok=false;
			    	util.showMessage(title,"El alumno ya est en la sesin");
				} else {
//System.out.println(client.getUserGroupID()+" == "+id_grupo);
					if (client.getUserGroupID().equals(id_grupo)) {
						v_alumnos.add(client.getUserID());
					} else {
						ok=false;
				    	util.showMessage(title,"El alumno est en otro grupo.");
					}
				}
			}
		} catch(Exception ex){
			ex.printStackTrace();
			ok=false;
	    	util.showMessage(title,"Alumno no registrado");
		}
//System.out.println("ok="+ok);
		if (ok) {
			lst.add(client.getUserName());
//System.out.println("added "+client.getUserName());
		}
	}
	
	public String[] getUsers() {
		if (lst!=null) {
			return lst.getItems();
		} else {
			return new String[0];
		}
	}

/*	
CREATE TABLE sesion_equipo ( 
id int(10) unsigned NOT NULL auto_increment, 
s_grupo int(8) unsigned NOT NULL DEFAULT '0', 
equipo int(8) unsigned NOT NULL DEFAULT '0', 
inicio datetime NOT NULL DEFAULT '2007-01-01', 
estado tinyint(2) NOT NULL DEFAULT '0', 
PRIMARY KEY (id), 
foreign key (s_grupo) references sesion_grupo(id), 
foreign key (equipo) references equipo(id) 
) type = InnoDB;

CREATE TABLE sesion_alumno ( 
id int(10) unsigned NOT NULL auto_increment, 
s_equipo int(10) unsigned NOT NULL DEFAULT '0', 
alumno int(6) unsigned NOT NULL DEFAULT '0', 
PRIMARY KEY (id), 
*/
	private void registrarSesionEquipo() {
		try {
			String[] id_alumno=new String[v_alumnos.size()];
			for (int i=0;i<v_alumnos.size();i++) {
				id_alumno[i]=(String)v_alumnos.elementAt(i);
			}
			info=client.executeCrearSesionEquipo(
				client.getUserLogin(),
				client.getUserPassword(),
	    		client.getNombreEquipo(),
	    		id_sesion_grupo,
	    		id_alumno);
	    } catch (Exception ex) {
	    	ex.printStackTrace();
	    }
	}

}